#include "phAdapt.h"

using namespace std;
// using std::cout;
// using std::endl;


void 
V_getHessians(double *hessiansFromPhasta, pMesh mesh, 
	      int nvar, int option, double *hessians) {

  int nshg=M_numVertices(mesh);
  
  switch (option) {
  case 0: { // for speed
    // from each component hessains get speed hessians
    // not a good way (can have trouble when speed is zero)
  }
  break;
  // For cases 1, 2 & 3 : 27 entries (for each node)
  // u_xx, v_xx, w_xx, u_yx, v_yx, w_yx, u_zx, v_zx, w_zx
  // u_yy, v_yy, w_yy, u_zy, v_zy, w_zy, u_zz, v_zz, w_zz
  // u_x, v_x, w_x, u_y, v_y, w_y, u_z, v_z, w_z
  case 1: { // for u
    for(int i=0; i<nshg; i++)
      for(int j=0; j<6; j++)
	hessians[i*6+j] = hessiansFromPhasta[i*27+3*j];
  }
  break;
  case 2: { // for v
    for(int i=0; i<nshg; i++)
      for(int j=0; j<6; j++)
	hessians[i*6+j] = hessiansFromPhasta[i*27+3*j+1];
  }
  break;
  case 3: { // for w
    for(int i=0; i<nshg; i++)
      for(int j=0; j<6; j++)
	hessians[i*6+j] = hessiansFromPhasta[i*27+3*j+2];
  }
  break;
  case 4: { // for speed OR average speed
    // 9 entries (for each node) : 
    // U_xx, U_yx, U_zx, U_yy, U_zy, U_zz, U_x, U_y, U_z
    for(int i=0; i<nshg; i++)
      for(int j=0; j<6; j++)
	hessians[i*6+j] = hessiansFromPhasta[i*9+j];
  }
  break;
  case 5: { // for temperature    
    // 9 entries (for each node) :
    // T_xx, T_yx, T_zx, T_yy, T_zy, T_zz, T_x, T_y, T_z
    for(int i=0; i<nshg; i++)
      for(int j=0; j<6; j++)
	hessians[i*6+j] = hessiansFromPhasta[i*9+j];    
  }
  break;
  default: {
    cout<<"Specify a correct option (V_getHessians.cc)"<<endl;
    exit(1);
  }
  break; 
  }
}

