#include <iostream>
#include "phAdapt.h"

using namespace std;


extern pMeshDataId errorIndicatorID;
extern pMeshDataId nodalgradientID;

// reconstruct the element gradient
void
elementGradient(pRegion region, double* elementGradient)
{
  pVertex v;
  double* nodalData;
  
  // build the linear system
  double matrix[16];
  buildSystem(region,matrix);
  double fieldVector[4];
  
  int four = 4;
  int indx[4];
  double fnumber;
  
  pPList regionVerts;
  regionVerts = R_vertices(region, 0);
  
  // get the field vals
  for (int i=0; i<PList_size(regionVerts); i++) {
    v = (pVertex)PList_item(regionVerts,i);
    if(EN_getDataPtr((pEntity)v, errorIndicatorID,
		     (void**)&nodalData)==NULL){
      cout<<"\nerror in elementGradient: no data attached to vertex\n";
      exit(0);
    }
    fieldVector[i]=nodalData[4];// speed component
//    fieldVector[i]=nodalData[5];// scalar 1 component
  }
  PList_delete(regionVerts);    
  
  ludcmp(matrix , &four, &four, indx, &fnumber);
  
  // fieldVector is going to be overridden and will
  // contain the solution
  lubksb(matrix , &four, &four, indx, fieldVector );
  
  for(int i=0; i<3; i++) {
    // the poly's structure is
    // a0 + a1*x + a2*y + a3*z
    elementGradient[i] = fieldVector[i+1];
    
#if  ( defined  DEBUG )
    //        cout<<"\ngradient["<<i<<"] "<<elementGradient[i]<<"\n";
#endif
  }
 
}
