#include <iostream>
#include <fstream>
#include <string>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#ifndef CYGWIN
#include <unistd.h>
#endif

#include "phAdapt.h"

using namespace std;



// fix4NodesOnSurface introduces new vertices for which 
// a solution is needed

extern pMeshDataId phasta_solution;
extern int ndof;

// just take the value from any adjacent vertex
void
fix4SolutionTransfer(pMesh mesh)
{

    VIter vit=M_vertexIter(mesh);
    pVertex vertex;
    double* nodalData;
    while(vertex=VIter_next(vit)) { 

        // if the node has NO solution, i.e. it is a NEW node
        if(EN_getDataPtr((pEntity)vertex, phasta_solution ,
		     (void**)&nodalData)==NULL){

            int foundVertex=0;
            // need to find a neighbor for this one
            int nedges = V_numEdges( vertex);
            for(int j=0; j<nedges;j++){
                
                pEdge edge = V_edge(vertex,j);
                
                pVertex vex = E_otherVertex(edge,vertex);

                if(EN_getDataPtr((pEntity)vex, phasta_solution ,
		     (void**)&nodalData) != NULL){

                    double* sol = new double[ndof];
                    
                    for(int k=0;k<ndof;k++){
                        sol[k] = nodalData[k];
                    }
                    EN_attachDataPtr( (pEntity)vertex, phasta_solution, (void *)
		      sol );
                    foundVertex=1;
                    break;
                }
            }
            if(!foundVertex){
                cout<<"\nerror in fix4SolutionTransfer:"
                    <<"all surrounding vertices have no solution\n";
                exit(0);
            }
        }
    }
    VIter_delete(vit);
}                
                


    
    
