#include "phAdapt.h"


extern pMeshDataId nodalgradientID;

// recover gradient at a vertex using patch of elements around it
void
gradientsFromPatch(pMesh mesh)
{
  VIter vIter;
  vIter = M_vertexIter(mesh);
  pVertex vertex;
  
  double elemGradient[3];
  
  double patchVolume;
  
  // loop over vertices and get patch of elements
  while(vertex = VIter_next(vIter)) {
    pPList elementPatch;
    elementPatch = V_regions(vertex);
    patchVolume = 0;

    double* patchGradient = new double[3];
    for(int i=0; i<3; i++){
      patchGradient[i]= 0.0  ;
    }

    // loop over elements and recover gradient at vertex   
    for (int i=0; i<PList_size(elementPatch); i++) {
      patchVolume+=R_volume((pRegion) PList_item(elementPatch,i));
      
      // compute element grad. for each element in the patch at vertex
      elementGradient( (pRegion)PList_item(elementPatch,i), elemGradient);
      
      // use element grad. (each component) to recover gradient at vertex
      for(int j=0; j<3; j++) {
	patchGradient[j]= patchGradient[j] + 
	  elemGradient[j]* R_volume((pRegion) PList_item(elementPatch,i));
      }
      
    }//loop over element patch ends
    
    for(int i=0; i<3; i++) {
      patchGradient[i]= patchGradient[i] / patchVolume ;
    }

    // attach the recovered gradient to the vertex
    EN_attachDataPtr( (pEntity)vertex, nodalgradientID, (void *)
		      patchGradient );
    
    PList_delete(elementPatch);
  }
  VIter_delete(vIter);

}

