#include "phAdapt.h"


extern pMeshDataId nodalgradientID;
extern pMeshDataId nodalhessianID;

// hessian  returned : 6-component (symmetric)
// u_xx, u_xy, u_xz, u_yy, u_yz, u_zz
// the nodal data later can be retrieved via
// nodalHessianID
void
hessiansFromSolution(pMesh mesh,int stepNumber)
{  
  // compute the hessain field from the solution

  nodalgradientID  =  MD_newMeshDataId( "gradient");
  nodalhessianID  =  MD_newMeshDataId( "hessian");
  
  // recover gradients using a patch
  // attaches gradient to vertices
  // gradient attached via nodalgradientID
  gradientsFromPatch(mesh);
  
  // recover hessians using a patch (from gradients)
  // attaches hessian to vertices
  // hessian attached via  nodalhessianID
  // hessian  attached : 6-component (symmetric)
  // u_xx, u_xy, u_xz, u_yy, u_yz, u_zz
  hessiansFromPatch(mesh);

  // no need to call ModifyHessiansAtBdry 
  // as it is embedded in SmoothHessians
  // ModifyHessiansAtBdry(mesh);
  SmoothHessians(mesh);
}

