#include <fstream>

#include "phAdapt.h"
#include "phReadWrite.h"

using namespace std;



extern pMeshDataId errorIndicatorID;

void writeSmoothEIs(pMesh mesh) {

  int nshg = M_numVertices(mesh);
  double *smoothEIs=new double[nshg];

  pVertex v;
  VIter vIter=M_vertexIter(mesh);
  int vCount=0;

  while(v = VIter_next(vIter)) {
    double *nodalEIs;
    if(!EN_getDataPtr((pEntity)v, errorIndicatorID,(void**)&nodalEIs)) {
      cout<<"\nerror in writeSmoothEIs: no data attached to  vertex\n";
      V_info(v);
      exit(0);
    }
    smoothEIs[vCount]=*nodalEIs;
    vCount++;
  }
  VIter_delete(vIter);

  writeArrayToFile("restart.99.1","SmoothEIs","binary","write",nshg,1,99,smoothEIs);

  delete [] smoothEIs;

}

