#include <stdio.h>
#include <fstream>
#include "MeshSimInternal.h"
#ifdef SIM
#include "SimPartitionedMesh.h"
#endif
#include "MeshSimAdapt.h"
#include <unistd.h>
#include <string>
#include <strings.h>
#include <fstream>
#include <time.h>
#include "phastaIO.h"
#include "mesh_interface.h"

extern int numVars;

////////////////////////////////////////////////////////////////////////////////
// write out the restart files
// which contain the transferred solution
////////////////////////////////////////////////////////////////////////////////
void
writeRestartFiles(double* q, int nshg_fine, int stepNumber)
{
    char fname[255];
    char* oformat ="binary";
    int magic_number = 362436;
    int* mptr = &magic_number;
    int  frest;
    int iarray[10];
    int size, nitems;
    char filename[255];
   

    sprintf(filename,"restart_fine.%d.%d", stepNumber, PMU_rank()+1 );
    openfile_( filename, "write", &frest );
    

    writestring_( &frest,"# PHASTA Input File Version 2.0\n");

    writestring_( &frest, "# Byte Order Magic Number : 362436 \n");

    sprintf(fname,"# Output generated by phParAdapt version: \n");

    writestring_( &frest, fname );


    time_t timenow = time ( &timenow);


    sprintf(fname,"# %s\n", ctime( &timenow ));

    writestring_( &frest, fname );

    int one=1;
    
    size = 1;
    nitems = 1;// length of iarray
    iarray[ 0 ] = 1;


    writeheader_( &frest, "byteorder magic number ",
                  (void*)iarray, &nitems, &size, "integer", oformat );

    writedatablock_( &frest, "byteorder magic number ",
                     (void*)mptr, &nitems, "integer", oformat );
          

    ///////////////////////////////////////////////////////////////////////////////      
    // writing the restart //
    ///////////////////////////////////////////////////////////////////////////////
    bzero( (void*)fname, 255 );
    sprintf(fname,"number of modes : < 0 > %d\n", nshg_fine);
    writestring_( &frest, fname );
    
    bzero( (void*)fname, 255 );
    sprintf(fname,"number of variables : < 0 > %d\n", numVars);
    writestring_( &frest, fname );
    
    size =  numVars*nshg_fine;
    nitems = 3;// length of iarray
    iarray[ 0 ] = nshg_fine;
    iarray[ 1 ] = numVars;
    iarray[ 2 ] = stepNumber;

    writeheader_( &frest, "solution ",
                  ( void* )iarray, &nitems, &size,"double", oformat );

    nitems = numVars*nshg_fine;
    writedatablock_( &frest, "solution ",
                     ( void* )(q), &nitems, "double", oformat );


    closefile_( &frest, "write" );
    // finished writing the restart //
}
