/*-------------------------------------------------------------------------
  Scientific Computation Research Center, RPI, Troy NY
  (C) Copyright 1995, RPI-SCOREC
 
  Project  : shapeFuntions
  Author(s): Saikat Dey
  Creation : May, 97
  Modifi.  : 
  Function :
             2nd derivative of edge mode for simplex. maple generated code
-------------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int EnDrv2(int ip, double r, double s, double drv[]) {
  double t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16,t17,t18,t19;
  double t20,t21,t22,t23,t24,t25,t26,t27,t28,t29,t30,t31,t32,t33;
   /* p=2 */
   if( ip==0 ) {
      drv[0] = 0.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 0.0;
   /* p=3 */
   } else if( ip==1 ) {
      drv[0] = 0.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 0.0;
   /* p=4 */
   } else if( ip==2 ) {
      drv[0] = 2.0;
      drv[1] = -3.0;
      drv[2] = -3.0;
      drv[3] = 2.0;
   /* p=5 */
   } else if( ip==3 ) {
      t2 = -12.0*s+12.0*r;
      drv[0] = 12.0*s-6.0*r;
      drv[1] = t2;
      drv[2] = t2;
      drv[3] = 6.0*s-12.0*r;
   /* p=6 */
   } else if( ip==4 ) {
      t1 = s*s;
      t2 = r*s;
      t3 = r*r;
      t5 = -30.0*t1+80.0*t2-30.0*t3;
      drv[0] = 40.0*t1-60.0*t2+12.0*t3;
      drv[1] = t5;
      drv[2] = t5;
      drv[3] = 12.0*t1-60.0*t2+40.0*t3;
   /* p=7 */
   } else if( ip==5 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = r*t1;
      t4 = r*r;
      t5 = t4*s;
      t6 = t4*r;
      t8 = -60.0*t2+300.0*t3-300.0*t5+60.0*t6;
      drv[0] = 100.0*t2-300.0*t3+180.0*t5-20.0*t6;
      drv[1] = t8;
      drv[2] = t8;
      drv[3] = 20.0*t2-180.0*t3+300.0*t5-100.0*t6;
   /* p=8 */
   } else if( ip==6 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r*t1*s;
      t5 = r*r;
      t6 = t5*t1;
      t8 = t5*r*s;
      t9 = t5*t5;
      t11 = -105.0*t2+840.0*t4-1575.0*t6+840.0*t8-105.0*t9;
      drv[0] = 210.0*t2-1050.0*t4+1260.0*t6-420.0*t8+30.0*t9;
      drv[1] = t11;
      drv[2] = t11;
      drv[3] = 30.0*t2-420.0*t4+1260.0*t6-1050.0*t8+210.0*t9;
   /* p=9 */
   } else if( ip==7 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*s;
      t4 = r*t2;
      t5 = r*r;
      t7 = t5*t1*s;
      t9 = t5*r*t1;
      t10 = t5*t5;
      t11 = t10*s;
      t12 = t10*r;
      t14 = -168.0*t3+1960.0*t4-5880.0*t7+5880.0*t9-1960.0*t11+168.0*t12;
      drv[0] = 392.0*t3-2940.0*t4+5880.0*t7-3920.0*t9+840.0*t11-42.0*t12;
      drv[1] = t14;
      drv[2] = t14;
      drv[3] = 42.0*t3-840.0*t4+3920.0*t7-5880.0*t9+2940.0*t11-392.0*t12;
   /* p=10 */
   } else if( ip==8 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t1;
      t5 = r*t2*s;
      t6 = r*r;
      t7 = t6*t2;
      t10 = t6*r*t1*s;
      t11 = t6*t6;
      t12 = t11*t1;
      t14 = t11*r*s;
      t15 = t11*t6;
      t17 = -252.0*t3+4032.0*t5-17640.0*t7+28224.0*t10-17640.0*t12+4032.0*t14
-252.0*t15;
      drv[0] = 672.0*t3-7056.0*t5+21168.0*t7-23520.0*t10+10080.0*t12-1512.0*t14
+56.0*t15;
      drv[1] = t17;
      drv[2] = t17;
      drv[3] = 56.0*t3-1512.0*t5+10080.0*t7-23520.0*t10+21168.0*t12-7056.0*t14+
672.0*t15;
   /* p=11 */
   } else if( ip==9 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t4 = t3*t2;
      t6 = r*t3*t1;
      t7 = r*r;
      t9 = t7*t3*s;
      t10 = t7*r;
      t11 = t10*t3;
      t12 = t7*t7;
      t13 = t12*t2;
      t15 = t12*r*t1;
      t17 = t12*t7*s;
      t18 = t12*t10;
      t20 = -360.0*t4+7560.0*t6-45360.0*t9+105840.0*t11-105840.0*t13+45360.0*
t15-7560.0*t17+360.0*t18;
      drv[0] = 1080.0*t4-15120.0*t6+63504.0*t9-105840.0*t11+75600.0*t13-22680.0
*t15+2520.0*t17-72.0*t18;
      drv[1] = t20;
      drv[2] = t20;
      drv[3] = 72.0*t4-2520.0*t6+22680.0*t9-75600.0*t11+105840.0*t13-63504.0*
t15+15120.0*t17-1080.0*t18;
   /* p=12 */
   } else if( ip==10 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*s;
      t6 = r*t2*t4;
      t7 = r*r;
      t9 = t7*t2*t1;
      t10 = t7*r;
      t12 = t10*t2*s;
      t13 = t7*t7;
      t14 = t13*t2;
      t16 = t13*r*t4;
      t18 = t13*t7*t1;
      t20 = t13*t10*s;
      t21 = t13*t13;
      t23 = -495.0*t3+13200.0*t6-103950.0*t9+332640.0*t12-485100.0*t14+332640.0
*t16-103950.0*t18+13200.0*t20-495.0*t21;
      drv[0] = 1650.0*t3-29700.0*t6+166320.0*t9-388080.0*t12+415800.0*t14
-207900.0*t16+46200.0*t18-3960.0*t20+90.0*t21;
      drv[1] = t23;
      drv[2] = t23;
      drv[3] = 90.0*t3-3960.0*t6+46200.0*t9-207900.0*t12+415800.0*t14-388080.0*
t16+166320.0*t18-29700.0*t20+1650.0*t21;
   /* p=13 */
   } else if( ip==11 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t3*s;
      t5 = r*t3;
      t6 = r*r;
      t7 = t1*s;
      t9 = t6*t2*t7;
      t10 = t6*r;
      t12 = t10*t2*t1;
      t13 = t6*t6;
      t15 = t13*t2*s;
      t17 = t13*r*t2;
      t19 = t13*t6*t7;
      t21 = t13*t10*t1;
      t22 = t13*t13;
      t23 = t22*s;
      t24 = t22*r;
      t26 = -660.0*t4+21780.0*t5-217800.0*t9+914760.0*t12-1829520.0*t15+
1829520.0*t17-914760.0*t19+217800.0*t21-21780.0*t23+660.0*t24;
      drv[0] = 2420.0*t4-54450.0*t5+392040.0*t9-1219680.0*t12+1829520.0*t15
-1372140.0*t17+508200.0*t19-87120.0*t21+5940.0*t23-110.0*t24;
      drv[1] = t26;
      drv[2] = t26;
      drv[3] = 110.0*t4-5940.0*t5+87120.0*t9-508200.0*t12+1372140.0*t15
-1829520.0*t17+1219680.0*t19-392040.0*t21+54450.0*t23-2420.0*t24;
   /* p=14 */
   } else if( ip==12 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t3*t1;
      t6 = r*t3*s;
      t7 = r*r;
      t8 = t7*t3;
      t9 = t7*r;
      t10 = t1*s;
      t12 = t9*t2*t10;
      t13 = t7*t7;
      t15 = t13*t2*t1;
      t18 = t13*r*t2*s;
      t20 = t13*t7*t2;
      t22 = t13*t9*t10;
      t23 = t13*t13;
      t24 = t23*t1;
      t26 = t23*r*s;
      t27 = t23*t7;
      t28 = 3432.0*t4-94380.0*t6+849420.0*t8-3397680.0*t12+6795360.0*t15
-7135128.0*t18+3963960.0*t20-1132560.0*t22+154440.0*t24-8580.0*t26+132.0*t27;
      t29 = -858.0*t4+34320.0*t6-424710.0*t8+2265120.0*t12-5945940.0*t15+
8154432.0*t18-5945940.0*t20+2265120.0*t22-424710.0*t24+34320.0*t26-858.0*t27;
      t30 = 132.0*t4-8580.0*t6+154440.0*t8-1132560.0*t12+3963960.0*t15
-7135128.0*t18+6795360.0*t20-3397680.0*t22+849420.0*t24-94380.0*t26+3432.0*t27;
      drv[0] = t28;
      drv[1] = t29;
      drv[2] = t29;
      drv[3] = t30;
   /* p=15 */
   } else if( ip==13 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t4 = t3*t3;
      t5 = t4*t2;
      t7 = r*t4*t1;
      t8 = r*r;
      t10 = t8*t4*s;
      t11 = t8*r;
      t12 = t11*t4;
      t13 = t8*t8;
      t15 = t13*t3*t2;
      t18 = t13*r*t3*t1;
      t21 = t13*t8*t3*s;
      t23 = t13*t11*t3;
      t24 = t13*t13;
      t25 = t24*t2;
      t27 = t24*r*t1;
      t29 = t24*t8*s;
      t30 = t24*t11;
      t31 = 4732.0*t5-156156.0*t7+1717716.0*t10-8588580.0*t12+22084920.0*t15
-30918888.0*t18+24048024.0*t21-10306296.0*t23+2342340.0*t25-260260.0*t27+
12012.0*t29-156.0*t30;
      t32 = -1092.0*t5+52052.0*t7-780780.0*t10+5153148.0*t12-17177160.0*t15+
30918888.0*t18-30918888.0*t21+17177160.0*t23-5153148.0*t25+780780.0*t27-52052.0
*t29+1092.0*t30;
      t33 = 156.0*t5-12012.0*t7+260260.0*t10-2342340.0*t12+10306296.0*t15
-24048024.0*t18+30918888.0*t21-22084920.0*t23+8588580.0*t25-1717716.0*t27+
156156.0*t29-4732.0*t30;
      drv[0] = t31;
      drv[1] = t32;
      drv[2] = t32;
      drv[3] = t33;
   }
   return 1;
}

#ifdef __cplusplus
}
#endif
