/*-------------------------------------------------------------------------
  Scientific Computation Research Center, RPI, Troy NY
  (C) Copyright 1995, RPI-SCOREC
 
  Project  : shapeFuntions
  Author(s): Saikat Dey
  Creation : Oct., 95
  Modifi.  : 
  Function :
             derivative of a tri. face mode shape. i,j are the highest poly.
             order of r,s in the polynomial. maple generated code.
-------------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int FnDrv(int i,int j, double r, double s, double drv[2]) {
   double t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16,t17,t18;
   double t19,t20,t21,t22,t23,t24,t25,t26,t27,t28,t29,t30,t31,t32,t33,t34;
   double t35,t36,t37,t38,t39,t40,t41,t42,t43,t44,t45,t46,t47,t48,t50,t52;
   double t53,t57;

   /* p=3 0 0 */
   if( i==0 && j==0 ) {
      drv[0] = 0.0;
      drv[1] = 0.0;
   /* p=4 0 1 */
   } else if( i==0 && j==1 ) {
      drv[0] = 0.0;
      drv[1] = 1.0;
   /* p=4 1 0 */
   } else if( i==1 && j==0 ) {
      drv[0] = 1.0;
      drv[1] = 0.0;
   /* p=5 0 2 */
   } else if( i==0 && j==2 ) {
      drv[0] = 0.0;
      drv[1] = 2.0*s-3.0/4.0;
   /* p=5 1 1 */
   } else if( i==1 && j==1 ) {
      drv[0] = s-1.0/4.0;
      drv[1] = r-1.0/4.0;
   /* p=5 2 0 */
   } else if( i==2 && j==0 ) {
      drv[0] = 2.0*r-3.0/4.0;
      drv[1] = 0.0;
   /* p=6 0 3 */
   } else if( i==0 && j==3 ) {
      t1 = s*s;
      drv[0] = 0.0;
      drv[1] = 3.0*t1-12.0/5.0*s+2.0/5.0;
   /* p=6 1 2 */
   } else if( i==1 && j==2 ) {
      t1 = s*s;
      drv[0] = t1-3.0/5.0*s+1.0/15.0;
      drv[1] = 2.0*r*s-3.0/5.0*r-2.0/5.0*s+2.0/15.0;
   /* p=6 2 1 */
   } else if( i==2 && j==1 ) {
      t3 = r*r;
      drv[0] = 2.0*r*s-2.0/5.0*r-3.0/5.0*s+2.0/15.0;
      drv[1] = t3-3.0/5.0*r+1.0/15.0;
   /* p=6 3 0 */
   } else if( i==3 && j==0 ) {
      t1 = r*r;
      drv[0] = 3.0*t1-12.0/5.0*r+2.0/5.0;
      drv[1] = 0.0;
   /* p=7 0 4 */
   } else if( i==0 && j==4 ) {
      t1 = s*s;
      drv[0] = 0.0;
      drv[1] = 4.0*t1*s-5.0*t1+20.0/11.0*s-2.0/11.0;
   /* p=7 1 3 */
   } else if( i==1 && j==3 ) {
      t1 = s*s;
      drv[0] = t1*s-t1+3.0/11.0*s-1.0/55.0;
      drv[1] = 3.0*r*t1-2.0*r*s+3.0/11.0*r-t1/2+4.0/11.0*s-3.0/55.0;
   /* p=7 2 2 */
   } else if( i==2 && j==2 ) {
      t1 = s*s;
      t3 = r*s;
      t5 = r*r;
      drv[0] = 2.0*r*t1-t3+r/11-t1/2+3.0/11.0*s-3.0/110.0;
      drv[1] = 2.0*t5*s-t5/2-t3+3.0/11.0*r+s/11-3.0/110.0;
   /* p=7 3 1 */
   } else if( i==3 && j==1 ) {
      t1 = r*r;
      drv[0] = 3.0*t1*s-t1/2-2.0*r*s+4.0/11.0*r+3.0/11.0*s-3.0/55.0;
      drv[1] = r*t1-t1+3.0/11.0*r-1.0/55.0;
   /* p=7 4 0 */
   } else if( i==4 && j==0 ) {
      t1 = r*r;
      drv[0] = 4.0*r*t1-5.0*t1+20.0/11.0*r-2.0/11.0;
      drv[1] = 0.0;
   /* p=8 0 5 */
   } else if( i==0 && j==5 ) {
      t1 = s*s;
      t2 = t1*t1;
      drv[0] = 0.0;
      drv[1] = 5.0*t2-60.0/7.0*t1*s+450.0/91.0*t1-100.0/91.0*s+75.0/1001.0;
   /* p=8 1 4 */
   } else if( i==1 && j==4 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t1*s;
      drv[0] = t2-10.0/7.0*t3+60.0/91.0*t1-10.0/91.0*s+5.0/1001.0;
      drv[1] = 4.0*r*t3-30.0/7.0*r*t1+120.0/91.0*r*s-10.0/91.0*r-4.0/7.0*t3+
60.0/91.0*t1-20.0/91.0*s+20.0/1001.0;
   /* p=8 2 3 */
   } else if( i==2 && j==3 ) {
      t1 = s*s;
      t2 = t1*s;
      t4 = r*t1;
      t5 = r*s;
      t7 = r*r;
      drv[0] = 2.0*r*t2-12.0/7.0*t4+36.0/91.0*t5-2.0/91.0*r-3.0/7.0*t2+36.0/
91.0*t1-9.0/91.0*s+6.0/1001.0;
      drv[1] = 3.0*t7*t1-12.0/7.0*t7*s+18.0/91.0*t7-9.0/7.0*t4+72.0/91.0*t5-9.0
/91.0*r+9.0/91.0*t1-6.0/91.0*s+9.0/1001.0;
   /* p=8 3 2 */
   } else if( i==3 && j==2 ) {
      t1 = r*r;
      t2 = s*s;
      t4 = t1*s;
      t6 = r*s;
      t8 = r*t1;
      drv[0] = 3.0*t1*t2-9.0/7.0*t4+9.0/91.0*t1-12.0/7.0*r*t2+72.0/91.0*t6-6.0/
91.0*r+18.0/91.0*t2-9.0/91.0*s+9.0/1001.0;
      drv[1] = 2.0*t8*s-3.0/7.0*t8-12.0/7.0*t4+36.0/91.0*t1+36.0/91.0*t6-9.0/
91.0*r-2.0/91.0*s+6.0/1001.0;
   /* p=8 4 1 */
   } else if( i==4 && j==1 ) {
      t1 = r*r;
      t2 = r*t1;
      t7 = t1*t1;
      drv[0] = 4.0*t2*s-4.0/7.0*t2-30.0/7.0*t1*s+60.0/91.0*t1+120.0/91.0*r*s
-20.0/91.0*r-10.0/91.0*s+20.0/1001.0;
      drv[1] = t7-10.0/7.0*t2+60.0/91.0*t1-10.0/91.0*r+5.0/1001.0;
   /* p=8 5 0 */
   } else if( i==5 && j==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      drv[0] = 5.0*t2-60.0/7.0*r*t1+450.0/91.0*t1-100.0/91.0*r+75.0/1001.0;
      drv[1] = 0.0;
   /* p=9 0 6 */
   } else if( i==0 && j==6 ) {
      t1 = s*s;
      t2 = t1*t1;
      drv[0] = 0.0;
      drv[1] = 6.0*t2*s-105.0/8.0*t2+21.0/2.0*t1*s-15.0/4.0*t1+15.0/26.0*s-3.0/
104.0;
   /* p=9 1 5 */
   } else if( i==1 && j==5 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = t1*s;
      drv[0] = t2*s-15.0/8.0*t2+5.0/4.0*t4-5.0/14.0*t1+15.0/364.0*s-1.0/728.0;
      drv[1] = 5.0*r*t2-15.0/2.0*r*t4+15.0/4.0*r*t1-5.0/7.0*r*s+15.0/364.0*r
-5.0/8.0*t2+t4-15.0/28.0*t1+10.0/91.0*s-5.0/728.0;
   /* p=9 2 4 */
   } else if( i==2 && j==4 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = t1*s;
      t5 = r*t4;
      t6 = r*t1;
      t7 = r*s;
      t9 = r*r;
      t13 = 4.0*t9*t4-15.0/4.0*t9*t1+t9*s-t9/14-3.0/2.0*t5+3.0/2.0*t6-3.0/7.0*
t7+3.0/91.0*r+t4/10-3.0/28.0*t1+3.0/91.0*s-1.0/364.0;
      drv[0] = 2.0*r*t2-5.0/2.0*t5+t6-t7/7+r/182-3.0/8.0*t2+t4/2-3.0/14.0*t1+
3.0/91.0*s-1.0/728.0;
      drv[1] = t13;
   /* p=9 3 3 */
   } else if( i==3 && j==3 ) {
      t1 = r*r;
      t2 = s*s;
      t3 = t2*s;
      t5 = t1*t2;
      t6 = t1*s;
      t8 = r*t2;
      t9 = r*s;
      t10 = 3.0*t1*t3-9.0/4.0*t5+9.0/20.0*t6-3.0/140.0*t1-3.0/2.0*r*t3+6.0/5.0*
t8-9.0/35.0*t9+6.0/455.0*r+3.0/20.0*t3-9.0/70.0*t2+27.0/910.0*s-3.0/1820.0;
      t11 = r*t1;
      t14 = 3.0*t11*t2-3.0/2.0*t11*s+3.0/20.0*t11-9.0/4.0*t5+6.0/5.0*t6-9.0/
70.0*t1+9.0/20.0*t8-9.0/35.0*t9+27.0/910.0*r-3.0/140.0*t2+6.0/455.0*s-3.0/
1820.0;
      drv[0] = t10;
      drv[1] = t14;
   /* p=9 4 2 */
   } else if( i==4 && j==2 ) {
      t1 = r*r;
      t2 = r*t1;
      t3 = s*s;
      t5 = t2*s;
      t7 = t1*s;
      t9 = r*s;
      t10 = 4.0*t2*t3-3.0/2.0*t5+t2/10-15.0/4.0*t1*t3+3.0/2.0*t7-3.0/28.0*t1+r*
t3-3.0/7.0*t9+3.0/91.0*r-t3/14+3.0/91.0*s-1.0/364.0;
      t11 = t1*t1;
      drv[0] = t10;
      drv[1] = 2.0*t11*s-3.0/8.0*t11-5.0/2.0*t5+t2/2+t7-3.0/14.0*t1-t9/7+3.0/
91.0*r+s/182-1.0/728.0;
   /* p=9 5 1 */
   } else if( i==5 && j==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t4 = r*t1;
      drv[0] = 5.0*t2*s-5.0/8.0*t2-15.0/2.0*t4*s+t4+15.0/4.0*t1*s-15.0/28.0*t1
-5.0/7.0*r*s+10.0/91.0*r+15.0/364.0*s-5.0/728.0;
      drv[1] = r*t2-15.0/8.0*t2+5.0/4.0*t4-5.0/14.0*t1+15.0/364.0*r-1.0/728.0;
   /* p=9 6 0 */
   } else if( i==6 && j==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      drv[0] = 6.0*r*t2-105.0/8.0*t2+21.0/2.0*r*t1-15.0/4.0*t1+15.0/26.0*r-3.0/
104.0;
      drv[1] = 0.0;
   /* p=10 0 7 */
   } else if( i==0 && j==7 ) {
      t1 = s*s;
      t2 = t1*t1;
      drv[0] = 0.0;
      drv[1] = 7.0*t1*t2-56.0/3.0*t2*s+980.0/51.0*t2-490.0/51.0*t1*s+245.0/
102.0*t1-14.0/51.0*s+7.0/663.0;
   /* p=10 1 6 */
   } else if( i==1 && j==6 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = t2*s;
      t5 = t1*s;
      t12 = 6.0*r*t4-35.0/3.0*r*t2+140.0/17.0*r*t5-175.0/68.0*r*t1+35.0/102.0*r
*s-r/68-2.0/3.0*t4+70.0/51.0*t2-35.0/34.0*t5+35.0/102.0*t1-5.0/102.0*s+1.0/
442.0;
      drv[0] = t1*t2-7.0/3.0*t4+35.0/17.0*t2-175.0/204.0*t5+35.0/204.0*t1-s/68+
1.0/2652.0;
      drv[1] = t12;
   /* p=10 2 5 */
   } else if( i==2 && j==5 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*s;
      t5 = r*t2;
      t6 = t1*s;
      t7 = r*t6;
      t8 = r*t1;
      t9 = r*s;
      t10 = 2.0*r*t3-10.0/3.0*t5+100.0/51.0*t7-25.0/51.0*t8+5.0/102.0*t9-r/714-
t3/3+10.0/17.0*t2-25.0/68.0*t6+5.0/51.0*t1-5.0/476.0*s+1.0/3094.0;
      t11 = r*r;
      t16 = 5.0*t11*t2-20.0/3.0*t11*t6+50.0/17.0*t11*t1-25.0/51.0*t11*s+5.0/
204.0*t11-5.0/3.0*t5+40.0/17.0*t7-75.0/68.0*t8+10.0/51.0*t9-5.0/476.0*r+5.0/
51.0*t2-5.0/34.0*t6+5.0/68.0*t1-5.0/357.0*s+5.0/6188.0;
      drv[0] = t10;
      drv[1] = t16;
   /* p=10 3 4 */
   } else if( i==3 && j==4 ) {
      t1 = r*r;
      t2 = s*s;
      t3 = t2*t2;
      t5 = t2*s;
      t6 = t1*t5;
      t7 = t1*t2;
      t8 = t1*s;
      t10 = r*t5;
      t11 = r*t2;
      t12 = r*s;
      t13 = 3.0*t1*t3-10.0/3.0*t6+20.0/17.0*t7-5.0/34.0*t8+t1/204-4.0/3.0*r*t3+
80.0/51.0*t10-10.0/17.0*t11+4.0/51.0*t12-r/357+2.0/17.0*t3-5.0/34.0*t5+t2/17-s
/119+1.0/3094.0;
      t14 = r*t1;
      t18 = 4.0*t14*t5-10.0/3.0*t14*t2+40.0/51.0*t14*s-5.0/102.0*t14-8.0/3.0*t6
+40.0/17.0*t7-10.0/17.0*t8+2.0/51.0*t1+8.0/17.0*t10-15.0/34.0*t11+2.0/17.0*t12-
r/119-t5/51+t2/51-2.0/357.0*s+2.0/4641.0;
      drv[0] = t13;
      drv[1] = t18;
   /* p=10 4 3 */
   } else if( i==4 && j==3 ) {
      t1 = r*r;
      t2 = r*t1;
      t3 = s*s;
      t4 = t3*s;
      t6 = t2*t3;
      t7 = t2*s;
      t9 = t1*t3;
      t10 = t1*s;
      t12 = r*t3;
      t13 = r*s;
      t14 = 4.0*t2*t4-8.0/3.0*t6+8.0/17.0*t7-t2/51-10.0/3.0*t1*t4+40.0/17.0*t9
-15.0/34.0*t10+t1/51+40.0/51.0*r*t4-10.0/17.0*t12+2.0/17.0*t13-2.0/357.0*r-5.0/
102.0*t4+2.0/51.0*t3-s/119+2.0/4641.0;
      t15 = t1*t1;
      t18 = 3.0*t15*t3-4.0/3.0*t15*s+2.0/17.0*t15-10.0/3.0*t6+80.0/51.0*t7-5.0/
34.0*t2+20.0/17.0*t9-10.0/17.0*t10+t1/17-5.0/34.0*t12+4.0/51.0*t13-r/119+t3/204
-s/357+1.0/3094.0;
      drv[0] = t14;
      drv[1] = t18;
   /* p=10 5 2 */
   } else if( i==5 && j==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = s*s;
      t5 = t2*s;
      t6 = t1*r;
      t8 = t6*s;
      t10 = t1*s;
      t12 = r*s;
      t13 = 5.0*t2*t3-5.0/3.0*t5+5.0/51.0*t2-20.0/3.0*t6*t3+40.0/17.0*t8-5.0/
34.0*t6+50.0/17.0*t1*t3-75.0/68.0*t10+5.0/68.0*t1-25.0/51.0*r*t3+10.0/51.0*t12
-5.0/357.0*r+5.0/204.0*t3-5.0/476.0*s+5.0/6188.0;
      t14 = t2*r;
      t16 = 2.0*t14*s-t14/3-10.0/3.0*t5+10.0/17.0*t2+100.0/51.0*t8-25.0/68.0*t6
-25.0/51.0*t10+5.0/51.0*t1+5.0/102.0*t12-5.0/476.0*r-s/714+1.0/3094.0;
      drv[0] = t13;
      drv[1] = t16;
   /* p=10 6 1 */
   } else if( i==6 && j==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t6 = t1*r;
      t10 = 6.0*t3*s-2.0/3.0*t3-35.0/3.0*t2*s+70.0/51.0*t2+140.0/17.0*t6*s-35.0
/34.0*t6-175.0/68.0*t1*s+35.0/102.0*t1+35.0/102.0*r*s-5.0/102.0*r-s/68+1.0/
442.0;
      drv[0] = t10;
      drv[1] = t2*t1-7.0/3.0*t3+35.0/17.0*t2-175.0/204.0*t6+35.0/204.0*t1-r/68+
1.0/2652.0;
   /* p=10 7 0 */
   } else if( i==7 && j==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      drv[0] = 7.0*t2*t1-56.0/3.0*t2*r+980.0/51.0*t2-490.0/51.0*t1*r+245.0/
102.0*t1-14.0/51.0*r+7.0/663.0;
      drv[1] = 0.0;
   /* p=11 0 8 */
   } else if( i==0 && j==8 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      drv[0] = 0.0;
      drv[1] = 8.0*t2*t3-126.0/5.0*t1*t3+3024.0/95.0*t3*s-392.0/19.0*t3+2352.0/
323.0*t2-441.0/323.0*t1+196.0/1615.0*s-6.0/1615.0;
   /* p=11 1 7 */
   } else if( i==1 && j==7 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t5 = t1*t3;
      t6 = t3*s;
      t14 = 7.0*r*t5-84.0/5.0*r*t6+294.0/19.0*r*t3-392.0/57.0*t2*r+490.0/323.0*
t1*r-49.0/323.0*r*s+49.0/9690.0*r-7.0/10.0*t5+168.0/95.0*t6-98.0/57.0*t3+784.0/
969.0*t2-245.0/1292.0*t1+98.0/4845.0*s-7.0/9690.0;
      drv[0] = t2*t3-14.0/5.0*t5+294.0/95.0*t6-98.0/57.0*t3+490.0/969.0*t2-49.0
/646.0*t1+49.0/9690.0*s-1.0/9690.0;
      drv[1] = t14;
   /* p=11 2 6 */
   } else if( i==2 && j==6 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t1;
      t5 = t2*s;
      t6 = r*t5;
      t7 = r*t2;
      t8 = t1*s;
      t9 = r*t8;
      t10 = r*t1;
      t11 = r*s;
      t12 = 2.0*r*t3-21.0/5.0*t6+63.0/19.0*t7-70.0/57.0*t9+70.0/323.0*t10-21.0/
1292.0*t11+7.0/19380.0*r-3.0/10.0*t3+63.0/95.0*t5-21.0/38.0*t2+70.0/323.0*t8
-105.0/2584.0*t1+21.0/6460.0*s-1.0/12920.0;
      t13 = r*r;
      t19 = 6.0*t13*t5-21.0/2.0*t13*t2+126.0/19.0*t13*t8-35.0/19.0*t13*t1+70.0/
323.0*t13*s-21.0/2584.0*t13-9.0/5.0*t6+63.0/19.0*t7-42.0/19.0*t9+210.0/323.0*
t10-105.0/1292.0*t11+21.0/6460.0*r+9.0/95.0*t5-7.0/38.0*t2+42.0/323.0*t8-105.0/
2584.0*t1+7.0/1292.0*s-3.0/12920.0;
      drv[0] = t12;
      drv[1] = t19;
   /* p=11 3 5 */
   } else if( i==3 && j==5 ) {
      t1 = r*r;
      t2 = s*s;
      t3 = t2*t2;
      t4 = t3*s;
      t6 = t1*t3;
      t7 = t2*s;
      t8 = t1*t7;
      t9 = t2*t1;
      t10 = t1*s;
      t12 = r*t3;
      t13 = r*t7;
      t14 = r*t2;
      t15 = r*s;
      t16 = 3.0*t1*t4-9.0/2.0*t6+45.0/19.0*t8-10.0/19.0*t9+15.0/323.0*t10-3.0/
2584.0*t1-6.0/5.0*r*t4+36.0/19.0*t12-20.0/19.0*t13+80.0/323.0*t14-15.0/646.0*
t15+r/1615+9.0/95.0*t4-3.0/19.0*t3+30.0/323.0*t7-15.0/646.0*t2+3.0/1292.0*s-3.0
/45220.0;
      t17 = r*t1;
      t22 = 5.0*t17*t3-6.0*t17*t7+45.0/19.0*t17*t2-20.0/57.0*t17*s+5.0/323.0*
t17-3.0*t6+72.0/19.0*t8-30.0/19.0*t9+80.0/323.0*t10-15.0/1292.0*t1+9.0/19.0*t12
-12.0/19.0*t13+90.0/323.0*t14-15.0/323.0*t15+3.0/1292.0*r-t3/57+8.0/323.0*t7
-15.0/1292.0*t2+2.0/969.0*s-1.0/9044.0;
      drv[0] = t16;
      drv[1] = t22;
   /* p=11 4 4 */
   } else if( i==4 && j==4 ) {
      t1 = r*r;
      t2 = t1*s;
      t3 = r*s;
      t4 = s*s;
      t5 = r*t4;
      t6 = t1*t4;
      t7 = r*t1;
      t8 = t7*s;
      t9 = t4*s;
      t10 = t1*t9;
      t11 = r*t9;
      t12 = t7*t4;
      t13 = t4*t4;
      t16 = t7*t9;
      t18 = 40.0/323.0*t2-1.0/13566.0-10.0/323.0*t3+80.0/323.0*t5+2.0/969.0*s
-20.0/19.0*t6+r/969-8.0/57.0*t8+40.0/969.0*t9+60.0/19.0*t10-5.0/323.0*t4-5.0/
1292.0*t1-40.0/57.0*t11+24.0/19.0*t12+4.0/969.0*t7+4.0*t7*t13-2.0/57.0*t13-3.0*
t13*t1-4.0*t16+12.0/19.0*r*t13;
      t19 = t1*t1;
      t23 = 40.0/969.0*t7-1.0/13566.0-5.0/323.0*t1+80.0/323.0*t2+s/969+2.0/
969.0*r-40.0/57.0*t8-2.0/57.0*t19-5.0/1292.0*t4+40.0/323.0*t5+4.0/969.0*t9+60.0
/19.0*t12-10.0/323.0*t3-20.0/19.0*t6+12.0/19.0*t19*s+4.0*t19*t9-8.0/57.0*t11
-4.0*t16-3.0*t19*t4+24.0/19.0*t10;
      drv[0] = t18;
      drv[1] = t23;
   /* p=11 5 3 */
   } else if( i==5 && j==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = s*s;
      t4 = t3*s;
      t6 = t2*t3;
      t7 = t2*s;
      t8 = r*t1;
      t10 = t8*t3;
      t11 = t8*s;
      t13 = t1*t3;
      t14 = t1*s;
      t16 = r*t3;
      t17 = r*s;
      t18 = 5.0*t2*t4-3.0*t6+9.0/19.0*t7-t2/57-6.0*t8*t4+72.0/19.0*t10-12.0/
19.0*t11+8.0/323.0*t8+45.0/19.0*t1*t4-30.0/19.0*t13+90.0/323.0*t14-15.0/1292.0*
t1-20.0/57.0*r*t4+80.0/323.0*t16-15.0/323.0*t17+2.0/969.0*r+5.0/323.0*t4-15.0/
1292.0*t3+3.0/1292.0*s-1.0/9044.0;
      t19 = t2*r;
      t22 = 3.0*t19*t3-6.0/5.0*t19*s+9.0/95.0*t19-9.0/2.0*t6+36.0/19.0*t7-3.0/
19.0*t2+45.0/19.0*t10-20.0/19.0*t11+30.0/323.0*t8-10.0/19.0*t13+80.0/323.0*t14
-15.0/646.0*t1+15.0/323.0*t16-15.0/646.0*t17+3.0/1292.0*r-3.0/2584.0*t3+s/1615
-3.0/45220.0;
      drv[0] = t18;
      drv[1] = t22;
   /* p=11 6 2 */
   } else if( i==6 && j==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = s*s;
      t6 = t3*s;
      t8 = t2*s;
      t9 = r*t1;
      t11 = t9*s;
      t13 = t1*s;
      t15 = r*s;
      t16 = 6.0*t3*t4-9.0/5.0*t6+9.0/95.0*t3-21.0/2.0*t2*t4+63.0/19.0*t8-7.0/
38.0*t2+126.0/19.0*t9*t4-42.0/19.0*t11+42.0/323.0*t9-35.0/19.0*t1*t4+210.0/
323.0*t13-105.0/2584.0*t1+70.0/323.0*r*t4-105.0/1292.0*t15+7.0/1292.0*r-21.0/
2584.0*t4+21.0/6460.0*s-3.0/12920.0;
      t17 = t2*t1;
      t19 = 2.0*t17*s-3.0/10.0*t17-21.0/5.0*t6+63.0/95.0*t3+63.0/19.0*t8-21.0/
38.0*t2-70.0/57.0*t11+70.0/323.0*t9+70.0/323.0*t13-105.0/2584.0*t1-21.0/1292.0*
t15+21.0/6460.0*r+7.0/19380.0*s-1.0/12920.0;
      drv[0] = t16;
      drv[1] = t19;
   /* p=11 7 1 */
   } else if( i==7 && j==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t5 = t2*r;
      t8 = r*t1;
      t12 = 7.0*t3*s-7.0/10.0*t3-84.0/5.0*t5*s+168.0/95.0*t5+294.0/19.0*t2*s
-98.0/57.0*t2-392.0/57.0*t8*s+784.0/969.0*t8+490.0/323.0*t1*s-245.0/1292.0*t1
-49.0/323.0*r*s+98.0/4845.0*r+49.0/9690.0*s-7.0/9690.0;
      drv[0] = t12;
      drv[1] = t2*t8-14.0/5.0*t3+294.0/95.0*t5-98.0/57.0*t2+490.0/969.0*t8-49.0
/646.0*t1+49.0/9690.0*r-1.0/9690.0;
   /* p=11 8 0 */
   } else if( i==8 && j==0 ) {
      t1 = r*r;
      t2 = r*t1;
      t3 = t1*t1;
      drv[0] = 8.0*t3*t2-126.0/5.0*t3*t1+3024.0/95.0*t3*r-392.0/19.0*t3+2352.0/
323.0*t2-441.0/323.0*t1+196.0/1615.0*r-6.0/1615.0;
      drv[1] = 0.0;
   /* p=12 0 9 */
   } else if( i==0 && j==9 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*s;
      drv[0] = 0.0;
      drv[1] = 9.0*t3-360.0/11.0*t2*t4+540.0/11.0*t2*t1-432.0/11.0*t2*s+3780.0/
209.0*t2-1008.0/209.0*t4+2520.0/3553.0*t1-180.0/3553.0*s+9.0/7106.0;
   /* p=12 1 8 */
   } else if( i==1 && j==8 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*s;
      t5 = t2*t4;
      t6 = t2*t1;
      t7 = t2*s;
      t16 = 8.0*r*t5-252.0/11.0*r*t6+288.0/11.0*r*t7-168.0/11.0*t2*r+1008.0/
209.0*r*t4-168.0/209.0*r*t1+224.0/3553.0*r*s-6.0/3553.0*r-8.0/11.0*t5+24.0/11.0
*t6-144.0/55.0*t7+336.0/209.0*t2-112.0/209.0*t4+336.0/3553.0*t1-28.0/3553.0*s+
4.0/17765.0;
      drv[0] = t3-36.0/11.0*t5+48.0/11.0*t6-168.0/55.0*t7+252.0/209.0*t2-56.0/
209.0*t4+112.0/3553.0*t1-6.0/3553.0*s+1.0/35530.0;
      drv[1] = t16;
   /* p=12 2 7 */
   } else if( i==2 && j==7 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t4 = t3*t2;
      t6 = t3*t1;
      t7 = r*t6;
      t8 = t3*s;
      t9 = r*t8;
      t10 = t3*r;
      t11 = t2*r;
      t12 = r*t1;
      t13 = r*s;
      t14 = 2.0*r*t4-56.0/11.0*t7+56.0/11.0*t9-28.0/11.0*t10+140.0/209.0*t11
-56.0/627.0*t12+56.0/10659.0*t13-r/10659-3.0/11.0*t4+8.0/11.0*t6-42.0/55.0*t8+
84.0/209.0*t3-70.0/627.0*t2+56.0/3553.0*t1-7.0/7106.0*s+1.0/53295.0;
      t15 = r*r;
      t23 = 336.0/209.0*t11-70.0/209.0*t12+112.0/3553.0*t13-7.0/7106.0*r+t6/11
-12.0/55.0*t8+42.0/209.0*t3-56.0/627.0*t2+70.0/3553.0*t1-7.0/3553.0*s+7.0/
106590.0;
      drv[0] = t14;
      drv[1] = 7.0*t15*t6-168.0/11.0*t15*t8+140.0/11.0*t15*t3-56.0/11.0*t15*t2+
210.0/209.0*t15*t1-56.0/627.0*t15*s+28.0/10659.0*t15-21.0/11.0*t7+48.0/11.0*t9
-42.0/11.0*t10+t23;
   /* p=12 3 6 */
   } else if( i==3 && j==6 ) {
      t1 = r*s;
      t2 = s*s;
      t3 = t2*r;
      t4 = t2*t2;
      t5 = r*t4;
      t6 = r*r;
      t7 = t4*s;
      t8 = r*t7;
      t9 = t2*s;
      t10 = t6*t9;
      t12 = t4*t2;
      t13 = t6*s;
      t14 = t6*t7;
      t15 = r*t9;
      t17 = t6*t2;
      t19 = t6*t4;
      t20 = 6.0/77.0*t12-3.0/209.0*t13-63.0/11.0*t14+120.0/209.0*t15+3.0*t6*t12
-10.0/209.0*t9+27.0/209.0*t4-9.0/55.0*t7+45.0/209.0*t17-12.0/11.0*r*t12+45.0/
11.0*t19;
      t22 = 1.0/35530.0+12.0/3553.0*t6-20.0/209.0*t13-5.0/7106.0*s-6.0/385.0*t7
-36.0/11.0*t10-9.0/14212.0*r+20.0/3553.0*t2-4.0/209.0*t9+6.0/209.0*t4+60.0/
3553.0*t1+60.0/11.0*t19;
      t23 = r*t6;
      t29 = -15.0/11.0*t23*t2+36.0/77.0*t8-t23/209-105.0/11.0*t23*t4+180.0/
209.0*t17+6.0*t23*t7-30.0/209.0*t3+108.0/209.0*t15-9.0/11.0*t5+30.0/209.0*t23*s
-36.0/11.0*t14+60.0/11.0*t23*t9;
      drv[0] = 1.0/71060.0+24.0/3553.0*t1-20.0/209.0*t3-18.0/11.0*t5-9.0/
14212.0*s-r/7106+30.0/3553.0*t2+t6/3553+24.0/11.0*t8-15.0/11.0*t10+t20;
      drv[1] = t22+t29;
   /* p=12 4 5 */
   } else if( i==4 && j==5 ) {
      t1 = r*s;
      t2 = s*s;
      t3 = t2*r;
      t4 = r*r;
      t5 = r*t4;
      t6 = t2*t2;
      t7 = t6*s;
      t9 = t5*t6;
      t10 = r*t6;
      t12 = t2*s;
      t13 = t4*t12;
      t14 = 1.0/74613.0+200.0/24871.0*t1-400.0/4389.0*t3+4.0*t5*t7-60.0/11.0*t9
-60.0/77.0*t10-25.0/49742.0*s-5.0/24871.0*r+400.0/74613.0*t2+20.0/24871.0*t4+
40.0/77.0*r*t7-150.0/77.0*t13;
      t15 = t5*s;
      t16 = t4*s;
      t18 = r*t12;
      t19 = t5*t12;
      t20 = t4*t2;
      t21 = t6*t4;
      t22 = t5*t2;
      t23 = 60.0/1463.0*t15-50.0/1463.0*t16-30.0/11.0*t4*t7+600.0/1463.0*t18
-4.0/4389.0*t5-100.0/4389.0*t12+60.0/1463.0*t6-2.0/77.0*t7+200.0/77.0*t19+600.0
/1463.0*t20+300.0/77.0*t21-40.0/77.0*t22;
      t25 = t4*t4;
      t27 = 5.0/298452.0+800.0/74613.0*t1-50.0/11.0*t9-10.0/77.0*t10+5.0/1463.0
*t6-25.0/74613.0*s+50.0/24871.0*t2-50.0/4389.0*t5-100.0/1463.0*t3+15.0/1463.0*
t25+5.0*t25*t6-20.0/4389.0*t12;
      t31 = -120.0/77.0*t13+400.0/1463.0*t15-400.0/4389.0*t16+240.0/1463.0*t18+
400.0/77.0*t19+900.0/1463.0*t20+100.0/77.0*t21-150.0/77.0*t22-20.0/77.0*t25*s
-60.0/11.0*t25*t12+150.0/77.0*t25*t2+100.0/24871.0*t4-25.0/49742.0*r;
      drv[0] = t14+t23;
      drv[1] = t27+t31;
   /* p=12 5 4 */
   } else if( i==5 && j==4 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t2*s;
      t4 = s*s;
      t5 = t4*s;
      t6 = t5*t2;
      t7 = t1*t1;
      t8 = t4*t4;
      t9 = t1*t4;
      t10 = t1*s;
      t11 = 240.0/1463.0*t3+400.0/77.0*t6-20.0/4389.0*t2-50.0/4389.0*t5+5.0/
1463.0*t7+15.0/1463.0*t8+100.0/24871.0*t4+900.0/1463.0*t9+50.0/24871.0*t1-100.0
/1463.0*t10-25.0/74613.0*r-25.0/49742.0*s;
      t14 = r*s;
      t15 = r*t4;
      t16 = t7*s;
      t17 = t1*t5;
      t18 = r*t5;
      t20 = t5*t7;
      t21 = t4*t2;
      t23 = t4*t7;
      t24 = 5.0*t7*t8+150.0/77.0*t1*t8+800.0/74613.0*t14-400.0/4389.0*t15-10.0/
77.0*t16-150.0/77.0*t17+400.0/1463.0*t18-20.0/77.0*r*t8+5.0/298452.0-50.0/11.0*
t20-120.0/77.0*t21-60.0/11.0*t2*t8+100.0/77.0*t23;
      t26 = r*t7;
      t29 = 1.0/74613.0+400.0/74613.0*t1-400.0/4389.0*t10-60.0/11.0*t20-5.0/
24871.0*s-40.0/77.0*t17-25.0/49742.0*r+20.0/24871.0*t4-4.0/4389.0*t5+40.0/77.0*
t26*s+200.0/24871.0*t14+4.0*t26*t5;
      t31 = -30.0/11.0*t26*t4-150.0/77.0*t21+60.0/1463.0*t7-100.0/4389.0*t2-2.0
/77.0*t26+600.0/1463.0*t9-50.0/1463.0*t15+60.0/1463.0*t18+300.0/77.0*t23+600.0/
1463.0*t3+200.0/77.0*t6-60.0/77.0*t16;
      drv[0] = t11+t24;
      drv[1] = t29+t31;
   /* p=12 6 3 */
   } else if( i==6 && j==3 ) {
      t1 = r*s;
      t2 = s*s;
      t3 = t2*r;
      t4 = r*r;
      t5 = t4*t4;
      t6 = r*t5;
      t7 = t5*t2;
      t8 = t6*t2;
      t9 = t2*s;
      t12 = 1.0/35530.0+60.0/3553.0*t1-20.0/209.0*t3-6.0/385.0*t6-9.0/14212.0*s
-5.0/7106.0*r+60.0/11.0*t7+12.0/3553.0*t2-36.0/11.0*t8-105.0/11.0*t5*t9+20.0/
3553.0*t4-15.0/11.0*t4*t9;
      t13 = r*t4;
      t14 = t13*s;
      t15 = t4*s;
      t16 = t5*s;
      t20 = t6*s;
      t21 = t4*t2;
      t22 = t13*t2;
      t23 = 108.0/209.0*t14-30.0/209.0*t15-9.0/11.0*t16+6.0*t6*t9+30.0/209.0*r*
t9-4.0/209.0*t13-t9/209+60.0/11.0*t13*t9+36.0/77.0*t20+180.0/209.0*t21-36.0/
11.0*t22+6.0/209.0*t5;
      t25 = t5*t4;
      t29 = -15.0/11.0*t22+27.0/209.0*t5-10.0/209.0*t13-9.0/55.0*t6+3.0*t25*t2+
45.0/209.0*t21-3.0/209.0*t3+45.0/11.0*t7+6.0/77.0*t25+120.0/209.0*t14-18.0/11.0
*t16;
      drv[0] = t12+t23;
      drv[1] = 1.0/71060.0+30.0/3553.0*t4-20.0/209.0*t15-s/7106-9.0/14212.0*r+
t2/3553+24.0/11.0*t20+24.0/3553.0*t1-12.0/11.0*t25*s-63.0/11.0*t8+t29;
   /* p=12 7 2 */
   } else if( i==7 && j==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = s*s;
      t6 = t3*s;
      t7 = t2*r;
      t9 = t7*s;
      t11 = t2*s;
      t12 = t1*r;
      t15 = t12*s;
      t17 = t1*s;
      t19 = r*s;
      t20 = 336.0/209.0*t15-56.0/627.0*t12+210.0/209.0*t1*t4-70.0/209.0*t17+
70.0/3553.0*t1-56.0/627.0*r*t4+112.0/3553.0*t19-7.0/3553.0*r+28.0/10659.0*t4
-7.0/7106.0*s+7.0/106590.0;
      t22 = t2*t12;
      t24 = 2.0*t22*s-3.0/11.0*t22-56.0/11.0*t6+8.0/11.0*t3+56.0/11.0*t9-42.0/
55.0*t7-28.0/11.0*t11+84.0/209.0*t2+140.0/209.0*t15-70.0/627.0*t12-56.0/627.0*
t17+56.0/3553.0*t1+56.0/10659.0*t19-7.0/7106.0*r-s/10659+1.0/53295.0;
      drv[0] = 7.0*t3*t4-21.0/11.0*t6+t3/11-168.0/11.0*t7*t4+48.0/11.0*t9-12.0/
55.0*t7+140.0/11.0*t4*t2-42.0/11.0*t11+42.0/209.0*t2-56.0/11.0*t12*t4+t20;
      drv[1] = t24;
   /* p=12 8 1 */
   } else if( i==8 && j==1 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t4 = t3*t2;
      t6 = t3*t1;
      t8 = t3*r;
      t14 = 8.0*t4*s-8.0/11.0*t4-252.0/11.0*t6*s+24.0/11.0*t6+288.0/11.0*t8*s
-144.0/55.0*t8-168.0/11.0*t3*s+336.0/209.0*t3+1008.0/209.0*t2*s-112.0/209.0*t2
-168.0/209.0*t1*s+336.0/3553.0*t1+224.0/3553.0*r*s-28.0/3553.0*r-6.0/3553.0*s+
4.0/17765.0;
      t15 = t3*t3;
      drv[0] = t14;
      drv[1] = t15-36.0/11.0*t4+48.0/11.0*t6-168.0/55.0*t8+252.0/209.0*t3-56.0/
209.0*t2+112.0/3553.0*t1-6.0/3553.0*r+1.0/35530.0;
   /* p=12 9 0 */
   } else if( i==9 && j==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*r;
      drv[0] = 9.0*t3-360.0/11.0*t4*t2+540.0/11.0*t2*t1-432.0/11.0*t2*r+3780.0/
209.0*t2-1008.0/209.0*t4+2520.0/3553.0*t1-180.0/3553.0*r+9.0/7106.0;
      drv[1] = 0.0;
   /* p=13 0 10 */
   } else if( i==0 && j==10 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*s;
      drv[0] = 0.0;
      drv[1] = 10.0*t3*s-165.0/4.0*t3+1650.0/23.0*t2*t5-1575.0/23.0*t2*t1+900.0
/23.0*t2*s-315.0/23.0*t2+1260.0/437.0*t5-150.0/437.0*t1+150.0/7429.0*s-25.0/
59432.0;
   /* p=13 1 9 */
   } else if( i==1 && j==9 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*s;
      t6 = t2*t5;
      t7 = t2*t1;
      t8 = t2*s;
      t18 = 9.0*r*t3-30.0*r*t6+945.0/23.0*r*t7-7560.0/253.0*r*t8+3150.0/253.0*r
*t2-756.0/253.0*r*t5+1890.0/4807.0*r*t1-120.0/4807.0*r*s+45.0/81719.0*r-3.0/4.0
*t3+60.0/23.0*t6-945.0/253.0*t7+720.0/253.0*t8-315.0/253.0*t2+1512.0/4807.0*t5
-210.0/4807.0*t1+240.0/81719.0*s-45.0/653752.0;
      drv[0] = t3*s-15.0/4.0*t3+135.0/23.0*t6-1260.0/253.0*t7+630.0/253.0*t8
-189.0/253.0*t2+630.0/4807.0*t5-60.0/4807.0*t1+45.0/81719.0*s-5.0/653752.0;
      drv[1] = t18;
   /* p=13 2 8 */
   } else if( i==2 && j==8 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*s;
      t4 = r*t2;
      t5 = r*t3;
      t6 = t2*t1;
      t7 = r*t6;
      t8 = t2*t2;
      t10 = t1*s;
      t11 = t2*t10;
      t12 = r*t11;
      t13 = r*s;
      t14 = r*t1;
      t15 = r*t10;
      t16 = -3.0/653752.0-28.0/4807.0*t1+24.0/81719.0*s+2.0/81719.0*r+168.0/
253.0*t3+420.0/253.0*t4-1176.0/253.0*t5+168.0/23.0*t7+2.0*r*t8-6.0*t12+252.0/
4807.0*t10-8.0/4807.0*t13-252.0/253.0*t6+168.0/4807.0*t14-84.0/253.0*t15-63.0/
253.0*t2+18.0/23.0*t11-t8/4;
      t17 = r*r;
      t23 = 56.0/81719.0*s-3.0/163438.0-56.0/4807.0*t13+24.0/81719.0*r+252.0/
4807.0*t10-42.0/4807.0*t1+840.0/253.0*t4+840.0/253.0*t17*t10-2940.0/253.0*t17*
t2+504.0/23.0*t17*t3+8.0*t17*t11-21.0*t17*t6;
      t26 = 756.0/4807.0*t14-4.0/4807.0*t17-1512.0/253.0*t5+168.0/4807.0*t17*s
-126.0/253.0*t17*t1-252.0/253.0*t15+126.0/23.0*t7+2.0/23.0*t11-63.0/253.0*t6
-2.0*t12+72.0/253.0*t3-42.0/253.0*t2;
      drv[0] = t16;
      drv[1] = t23+t26;
   /* p=13 3 7 */
   } else if( i==3 && j==7 ) {
      t1 = s*s;
      t2 = r*r;
      t3 = t1*t1;
      t4 = t3*t1;
      t5 = t2*t4;
      t6 = t3*s;
      t7 = r*t3;
      t8 = t2*t3;
      t9 = r*t6;
      t10 = r*t4;
      t11 = t1*s;
      t12 = t3*t11;
      t14 = -1.0/326876.0-14.0/4807.0*t1-7.0*t5+14.0/81719.0*s+8.0/245157.0*r+
42.0/253.0*t6-t2/14421+280.0/253.0*t7-735.0/253.0*t8-588.0/253.0*t9+56.0/23.0*
t10-r*t12;
      t15 = r*s;
      t16 = r*t1;
      t17 = r*t11;
      t18 = t2*t11;
      t19 = t2*t1;
      t20 = t2*s;
      t22 = t2*t6;
      t23 = 105.0/4807.0*t11-28.0/14421.0*t15-42.0/253.0*t4+168.0/4807.0*t16
-70.0/253.0*t17-21.0/253.0*t3+175.0/253.0*t18-21.0/253.0*t19+3.0/46.0*t12+21.0/
4807.0*t20+3.0*t2*t12+147.0/23.0*t22;
      t25 = t2*r;
      t30 = -7.0/506.0*t4-14.0/14421.0*t2+14.0/81719.0*r+56.0/245157.0*s-7.0/
2.0*t5-35.0/14421.0*t1+210.0/253.0*t7-1470.0/253.0*t8-252.0/253.0*t9+21.0/46.0*
t10-14.0*t25*t6-980.0/253.0*t25*t11+175.0/253.0*t25*t1-14.0/253.0*t25*s;
      t33 = 7.0/4807.0*t25+168.0/4807.0*t20+168.0/23.0*t22+7.0*t25*t4+245.0/
23.0*t25*t3+56.0/4807.0*t11-28.0/4807.0*t15+315.0/4807.0*t16-84.0/253.0*t17+
560.0/253.0*t18-105.0/253.0*t19-7.0/253.0*t3+8.0/253.0*t6-7.0/980628.0;
      drv[0] = t14+t23;
      drv[1] = t30+t33;
   /* p=13 4 6 */
   } else if( i==4 && j==6 ) {
      t1 = r*r;
      t2 = s*s;
      t3 = t2*r;
      t4 = r*t1;
      t5 = t2*t2;
      t6 = t5*t2;
      t8 = r*s;
      t9 = t1*t5;
      t10 = t4*t5;
      t11 = t5*s;
      t12 = t1*t11;
      t14 = t2*s;
      t15 = r*t14;
      t16 = t1*s;
      t18 = t2*t1;
      t19 = t1*t14;
      t20 = r*t5;
      t21 = -5.0/28842.0*t1+150.0/4807.0*t3+4.0*t4*t6-10.0/4807.0*t8-1575.0/
506.0*t9+105.0/23.0*t10+105.0/23.0*t12-5.0/2.0*t1*t6-50.0/253.0*t15+45.0/4807.0
*t16+10.0/23.0*r*t6-75.0/506.0*t18+250.0/253.0*t19+150.0/253.0*t20;
      t22 = t4*t14;
      t23 = t2*t4;
      t24 = t4*s;
      t25 = t4*t11;
      t26 = r*t11;
      t27 = -350.0/253.0*t22+50.0/253.0*t23-3.0/253.0*t24-7.0*t25+10.0/245157.0
*r+10.0/253.0*t11-210.0/253.0*t26-5.0/253.0*t6-15.0/506.0*t5+t4/4807-25.0/
14421.0*t2+10.0/81719.0*s+50.0/4807.0*t14-5.0/1961256.0;
      t29 = t1*t1;
      t31 = -5.0/4807.0*t1+25.0/253.0*t29*s+150.0/4807.0*t3-50.0/14421.0*t8
-525.0/253.0*t9+175.0/23.0*t10+30.0/23.0*t12-30.0/253.0*t15+150.0/4807.0*t16
-75.0/253.0*t18+300.0/253.0*t19+50.0/253.0*t20-1050.0/253.0*t22+250.0/253.0*t23
-25.0/253.0*t24;
      t36 = -5.0*t25-525.0/506.0*t29*t2+10.0/81719.0*r+105.0/23.0*t29*t14+6.0*
t29*t11-35.0/4.0*t29*t5-3.0/1012.0*t29+5.0/1771.0*t11-30.0/253.0*t26-5.0/1012.0
*t5+15.0/4807.0*t4-25.0/28842.0*t2+25.0/245157.0*s+15.0/4807.0*t14-5.0/
1307504.0;
      drv[0] = t21+t27;
      drv[1] = t31+t36;
   /* p=13 5 5 */
   } else if( i==5 && j==5 ) {
      t1 = r*r;
      t2 = r*t1;
      t3 = s*s;
      t4 = t2*t3;
      t5 = t1*t1;
      t6 = t3*t3;
      t7 = t6*s;
      t8 = t3*s;
      t9 = r*t3;
      t10 = r*s;
      t12 = t1*t6;
      t13 = t5*t3;
      t14 = t2*t6;
      t15 = t5*s;
      t16 = -25.0/9152528.0+1000.0/1771.0*t4-5.0/7084.0*t5+30.0/33649.0*t2+25.0
/3542.0*t7+375.0/67298.0*t8-25.0/67298.0*t1-75.0/7084.0*t6+1000.0/33649.0*t9
-250.0/100947.0*t10-50.0/253.0*r*t7-1125.0/506.0*t12-125.0/253.0*t13+150.0/23.0
*t14+125.0/3542.0*t15;
      t18 = r*t8;
      t19 = t5*t8;
      t20 = t1*s;
      t21 = t1*t3;
      t22 = t1*t8;
      t24 = t5*t6;
      t25 = r*t6;
      t26 = t2*t8;
      t27 = t2*s;
      t29 = 75.0/46.0*t1*t7-250.0/1771.0*t18+125.0/46.0*t19+1125.0/67298.0*t20
-375.0/1771.0*t21+1875.0/1771.0*t22+5.0*t5*t7-25.0/4.0*t24+500.0/1771.0*t25
-750.0/253.0*t26-75.0/1771.0*t27-5.0*t2*t7+100.0/1716099.0*r-125.0/100947.0*t3+
125.0/1144066.0*s;
      t31 = -25.0/9152528.0+1875.0/1771.0*t4-75.0/7084.0*t5+375.0/67298.0*t2+
30.0/33649.0*t8-125.0/100947.0*t1-5.0/7084.0*t6+1125.0/67298.0*t9-250.0/
100947.0*t10-125.0/253.0*t12-1125.0/506.0*t13+125.0/46.0*t14+500.0/1771.0*t15
-75.0/1771.0*t18+150.0/23.0*t19;
      t32 = r*t5;
      t37 = 1000.0/33649.0*t20-375.0/1771.0*t21+1000.0/1771.0*t22-25.0/4.0*t24+
125.0/3542.0*t25-750.0/253.0*t26-250.0/1771.0*t27+125.0/1144066.0*r-25.0/
67298.0*t3+100.0/1716099.0*s-50.0/253.0*t32*s+75.0/46.0*t32*t3-5.0*t32*t8+25.0/
3542.0*t32+5.0*t32*t6;
      drv[0] = t16+t29;
      drv[1] = t31+t37;
   /* p=13 6 4 */
   } else if( i==6 && j==4 ) {
      t1 = s*s;
      t2 = r*r;
      t3 = t2*t2;
      t4 = t3*r;
      t5 = t1*t1;
      t7 = r*t1;
      t8 = r*s;
      t9 = t2*r;
      t10 = t1*s;
      t11 = t3*t10;
      t12 = r*t10;
      t13 = t3*t1;
      t14 = 25.0/245157.0*r+10.0/81719.0*s-5.0/4807.0*t1+6.0*t4*t5+150.0/4807.0
*t7-25.0/28842.0*t2-50.0/14421.0*t8-3.0/1012.0*t5+5.0/1771.0*t4+15.0/4807.0*t9+
15.0/4807.0*t10+175.0/23.0*t11-25.0/253.0*t12-5.0/1012.0*t3-525.0/253.0*t13;
      t16 = t9*s;
      t17 = t9*t1;
      t18 = t9*t10;
      t20 = t3*s;
      t21 = t4*s;
      t22 = t2*s;
      t23 = t2*t1;
      t24 = t2*t10;
      t27 = t4*t1;
      t28 = t4*t10;
      t29 = -525.0/506.0*t2*t5-30.0/253.0*t16+300.0/253.0*t17-1050.0/253.0*t18+
105.0/23.0*t9*t5+50.0/253.0*t20-30.0/253.0*t21+150.0/4807.0*t22-75.0/253.0*t23+
250.0/253.0*t24-35.0/4.0*t3*t5+25.0/253.0*r*t5+30.0/23.0*t27-5.0*t28-5.0/
1307504.0;
      t31 = 10.0/81719.0*r+10.0/245157.0*s-5.0/28842.0*t1+45.0/4807.0*t7-25.0/
14421.0*t2-10.0/4807.0*t8+10.0/253.0*t4+50.0/4807.0*t9+t10/4807+105.0/23.0*t11
-3.0/253.0*t12-15.0/506.0*t3-1575.0/506.0*t13-50.0/253.0*t16;
      t32 = t3*t2;
      t36 = 250.0/253.0*t17-350.0/253.0*t18-5.0/253.0*t32+4.0*t32*t10-5.0/2.0*
t32*t1+150.0/253.0*t20-210.0/253.0*t21+150.0/4807.0*t22-75.0/506.0*t23+50.0/
253.0*t24+105.0/23.0*t27-7.0*t28+10.0/23.0*t32*s-5.0/1961256.0;
      drv[0] = t14+t29;
      drv[1] = t31+t36;
   /* p=13 7 3 */
   } else if( i==7 && j==3 ) {
      t1 = s*s;
      t2 = r*t1;
      t3 = r*s;
      t4 = r*r;
      t5 = t4*t4;
      t6 = t4*t5;
      t7 = t6*s;
      t8 = r*t5;
      t9 = t8*s;
      t10 = t1*s;
      t13 = t4*s;
      t14 = t8*t1;
      t17 = t4*r;
      t19 = t17*t1;
      t20 = t17*s;
      t21 = 168.0/4807.0*t2-28.0/4807.0*t3+21.0/46.0*t7-252.0/253.0*t9-14.0/
253.0*r*t10+245.0/23.0*t5*t10+315.0/4807.0*t13+168.0/23.0*t14-14.0*t8*t10+7.0*
t6*t10-980.0/253.0*t17*t10+560.0/253.0*t19-84.0/253.0*t20+14.0/81719.0*s;
      t23 = t4*t1;
      t24 = t5*t1;
      t25 = t5*s;
      t26 = t6*t1;
      t27 = 56.0/245157.0*r-14.0/14421.0*t1+175.0/253.0*t4*t10-105.0/253.0*t23
-1470.0/253.0*t24+8.0/253.0*t8+210.0/253.0*t25-7.0/253.0*t5+7.0/4807.0*t10+56.0
/4807.0*t17-7.0/506.0*t6-35.0/14421.0*t4-7.0/980628.0-7.0/2.0*t26;
      t29 = t5*t17;
      t31 = 8.0/245157.0*s-1.0/326876.0-28.0/14421.0*t3+14.0/81719.0*r-t1/14421
-42.0/253.0*t6-t29*s+280.0/253.0*t25-21.0/253.0*t5+42.0/253.0*t8+3.0/46.0*t29+
21.0/4807.0*t2;
      t33 = -735.0/253.0*t24-14.0/4807.0*t4+168.0/4807.0*t13+3.0*t29*t1-21.0/
253.0*t23-588.0/253.0*t9+147.0/23.0*t14-7.0*t26+175.0/253.0*t19-70.0/253.0*t20+
56.0/23.0*t7+105.0/4807.0*t17;
      drv[0] = t21+t27;
      drv[1] = t31+t33;
   /* p=13 8 2 */
   } else if( i==8 && j==2 ) {
      t1 = s*s;
      t2 = r*r;
      t3 = t2*t2;
      t4 = t3*r;
      t5 = t2*r;
      t6 = t3*t5;
      t8 = t6*s;
      t9 = t4*s;
      t10 = t3*t2;
      t13 = t5*s;
      t14 = -3.0/163438.0-4.0/4807.0*t1+72.0/253.0*t4+24.0/81719.0*s+8.0*t6*t1+
56.0/81719.0*r-2.0*t8-1512.0/253.0*t9-42.0/4807.0*t2-21.0*t10*t1+840.0/253.0*t5
*t1-252.0/253.0*t13;
      t15 = t3*s;
      t16 = t10*s;
      t17 = r*s;
      t22 = t2*s;
      t23 = 840.0/253.0*t15+252.0/4807.0*t5+126.0/23.0*t16-56.0/4807.0*t17+
168.0/4807.0*r*t1-2940.0/253.0*t3*t1-63.0/253.0*t10-42.0/253.0*t3-126.0/253.0*
t2*t1+2.0/23.0*t6+504.0/23.0*t4*t1+756.0/4807.0*t22;
      t25 = t3*t3;
      t27 = 2.0/81719.0*s-3.0/653752.0-8.0/4807.0*t17+24.0/81719.0*r+2.0*t25*s-
t25/4-252.0/253.0*t10-6.0*t8+420.0/253.0*t15-63.0/253.0*t3+168.0/253.0*t4+18.0/
23.0*t6-28.0/4807.0*t2+168.0/4807.0*t22-1176.0/253.0*t9-84.0/253.0*t13+168.0/
23.0*t16+252.0/4807.0*t5;
      drv[0] = t14+t23;
      drv[1] = t27;
   /* p=13 9 1 */
   } else if( i==9 && j==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = r*t1;
      t6 = t2*t5;
      t8 = t2*t1;
      t10 = t2*r;
      t16 = 9.0*t3*s-3.0/4.0*t3-30.0*t6*s+60.0/23.0*t6+945.0/23.0*t8*s-945.0/
253.0*t8-7560.0/253.0*t10*s+720.0/253.0*t10+3150.0/253.0*t2*s-315.0/253.0*t2
-756.0/253.0*t5*s+1512.0/4807.0*t5+1890.0/4807.0*t1*s-210.0/4807.0*t1-120.0/
4807.0*r*s+240.0/81719.0*r+45.0/81719.0*s-45.0/653752.0;
      drv[0] = t16;
      drv[1] = t3*r-15.0/4.0*t3+135.0/23.0*t6-1260.0/253.0*t8+630.0/253.0*t10
-189.0/253.0*t2+630.0/4807.0*t5-60.0/4807.0*t1+45.0/81719.0*r-5.0/653752.0;
   /* p=13 10 0 */
   } else if( i==10 && j==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*r;
      drv[0] = 10.0*t3*r-165.0/4.0*t3+1650.0/23.0*t2*t5-1575.0/23.0*t2*t1+900.0
/23.0*t2*r-315.0/23.0*t2+1260.0/437.0*t5-150.0/437.0*t1+150.0/7429.0*r-25.0/
59432.0;
      drv[1] = 0.0;
   /* p=14 0 11 */
   } else if( i==0 && j==11 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t6 = t1*s;
      t10 = 11.0*t3*t1-660.0/13.0*t3*s+6534.0/65.0*t3-1452.0/13.0*t2*t6+22869.0
/299.0*t2*t1-49896.0/1495.0*t2*s+2772.0/299.0*t2-2376.0/1495.0*t6+891.0/5681.0*
t1-44.0/5681.0*s+66.0/482885.0;
      drv[0] = 0.0;
      drv[1] = t10;
   /* p=14 1 10 */
   } else if( i==1 && j==10 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t3*s;
      t6 = t1*s;
      t7 = t2*t6;
      t8 = t2*t1;
      t9 = t2*s;
      t10 = t3*t1-55.0/13.0*t5+99.0/13.0*t3-99.0/13.0*t7+1386.0/299.0*t8-2646.0
/1495.0*t9+126.0/299.0*t2-18.0/299.0*t6+27.0/5681.0*t1-s/5681+1.0/482885.0;
      t20 = 10.0*r*t5-495.0/13.0*t3*r+792.0/13.0*r*t7-693.0/13.0*r*t8+8316.0/
299.0*r*t9-2646.0/299.0*t2*r+504.0/299.0*r*t6-54.0/299.0*t1*r+54.0/5681.0*r*s-r
/5681-10.0/13.0*t5+198.0/65.0*t3-66.0/13.0*t7+1386.0/299.0*t8-756.0/299.0*t9+
252.0/299.0*t2-252.0/1495.0*t6+108.0/5681.0*t1-6.0/5681.0*s+2.0/96577.0;
      drv[0] = t10;
      drv[1] = t20;
   /* p=14 2 9 */
   } else if( i==2 && j==9 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t2*s;
      t5 = t2*t1;
      t6 = t3*s;
      t7 = t1*s;
      t8 = r*t5;
      t9 = t2*t7;
      t10 = r*t9;
      t11 = r*s;
      t12 = t1*r;
      t13 = r*t7;
      t14 = t2*r;
      t15 = r*t4;
      t17 = t3*r;
      t18 = 6.0/5311735.0+54.0/65.0*t3-7938.0/16445.0*t4+1512.0/1495.0*t5-3.0/
13.0*t6-27.0/312455.0*s+648.0/312455.0*t1-378.0/16445.0*t7+2268.0/16445.0*t2
-2.0/312455.0*r-504.0/65.0*t8+648.0/65.0*t10+162.0/312455.0*t11-216.0/16445.0*
t12+504.0/3289.0*t13-15876.0/16445.0*t14+5292.0/1495.0*t15+2.0*r*t6-81.0/65.0*
t9-90.0/13.0*t17;
      t19 = r*r;
      t25 = 2646.0/299.0*t19*t2-27.0/13.0*t17+27.0/5311735.0+432.0/65.0*t10+
1296.0/312455.0*t11-1134.0/16445.0*t12+9072.0/16445.0*t13-7938.0/3289.0*t14+
9072.0/1495.0*t15-31752.0/16445.0*t19*t7-360.0/13.0*t19*t9-216.0/16445.0*t19*s+
756.0/3289.0*t19*t1;
      t29 = -1512.0/65.0*t19*t4+9.0*t19*t3+2268.0/65.0*t19*t5+81.0/312455.0*t19
-18.0/65.0*t9-567.0/65.0*t8+1134.0/312455.0*t1-2268.0/82225.0*t7+378.0/3289.0*
t2-27.0/312455.0*r+27.0/325.0*t3-72.0/312455.0*s-4536.0/16445.0*t4+567.0/1495.0
*t5;
      drv[0] = t18;
      drv[1] = t25+t29;
   /* p=14 3 8 */
   } else if( i==3 && j==8 ) {
      t1 = r*r;
      t2 = s*s;
      t3 = t2*t2;
      t4 = t3*t3;
      t6 = t1*t3;
      t7 = t1*s;
      t8 = t2*s;
      t9 = t3*t8;
      t10 = t3*t2;
      t11 = r*t10;
      t12 = t3*s;
      t13 = r*t12;
      t14 = 18.0/26558675.0+3.0*t1*t4+2646.0/1495.0*t6-108.0/82225.0*t7+756.0/
16445.0*t3-54.0/325.0*t9+27.0/1562275.0*t1-756.0/82225.0*t8+1512.0/1562275.0*t2
+1512.0/7475.0*t10-1008.0/325.0*t11-10584.0/82225.0*t12+14112.0/7475.0*t13;
      t16 = r*s;
      t17 = t2*r;
      t18 = r*t8;
      t19 = t3*r;
      t20 = t1*t10;
      t21 = t1*t9;
      t22 = t2*t1;
      t23 = t1*t8;
      t24 = r*t9;
      t25 = t1*t12;
      t26 = 18.0/325.0*t4-72.0/1562275.0*s-12.0/1562275.0*r-12.0/13.0*r*t4+
864.0/1562275.0*t16-1008.0/82225.0*t17+2016.0/16445.0*t18-10584.0/16445.0*t19+
3024.0/325.0*t20-108.0/13.0*t21+504.0/16445.0*t22-5292.0/16445.0*t23+864.0/
325.0*t24-1764.0/325.0*t25;
      t28 = t1*r;
      t31 = 48.0/26558675.0+6048.0/325.0*t28*t12-252.0/13.0*t28*t10+7056.0/
1495.0*t6-1008.0/82225.0*t7+336.0/16445.0*t3-4.0/325.0*t9+432.0/1562275.0*t1
-504.0/82225.0*t8+1512.0/1562275.0*t2+252.0/7475.0*t10-378.0/325.0*t11-3024.0/
82225.0*t12+9072.0/7475.0*t13-112.0/1562275.0*s-72.0/1562275.0*r;
      t37 = 3024.0/1562275.0*t16-2268.0/82225.0*t17+3024.0/16445.0*t18-10584.0/
16445.0*t19+3024.0/325.0*t20-48.0/13.0*t21+3024.0/16445.0*t22-21168.0/16445.0*
t23+144.0/325.0*t24-3024.0/325.0*t25+8.0*t28*t9+3528.0/1495.0*t28*t8+336.0/
16445.0*t28*s-5292.0/16445.0*t28*t2-36.0/82225.0*t28-588.0/65.0*t28*t3;
      drv[0] = t14+t26;
      drv[1] = t31+t37;
   /* p=14 4 7 */
   } else if( i==4 && j==7 ) {
      t1 = r*s;
      t2 = s*s;
      t3 = t2*t2;
      t4 = t3*t2;
      t5 = r*t4;
      t6 = r*r;
      t7 = t6*r;
      t8 = t2*s;
      t9 = t7*t8;
      t10 = t3*s;
      t11 = r*t10;
      t12 = t3*t8;
      t13 = t7*t3;
      t14 = t7*t10;
      t15 = t3*r;
      t16 = r*t8;
      t17 = 168.0/312455.0*t1-56.0/65.0*t5+196.0/299.0*t9+56.0/1495.0*t4+1176.0
/1495.0*t11-588.0/16445.0*t10-28.0/937365.0*s-8.0/937365.0*r-t12/65-196.0/65.0*
t13-4.0/82225.0*t7+2352.0/325.0*t14+12.0/312455.0*t6-1176.0/3289.0*t15+56.0/
3289.0*t3+280.0/3289.0*t16;
      t18 = t2*r;
      t19 = t6*t4;
      t21 = t7*t4;
      t22 = t6*t10;
      t23 = t6*s;
      t25 = t6*t2;
      t26 = t7*t2;
      t28 = t6*t3;
      t29 = t6*t8;
      t30 = t7*s;
      t31 = -14.0/3289.0*t8-168.0/16445.0*t18+336.0/65.0*t19+4.0*t7*t12-112.0/
13.0*t21+168.0/312455.0*t2-294.0/65.0*t22-42.0/16445.0*t23-30.0/13.0*t6*t12+
168.0/3289.0*t25-1176.0/16445.0*t26+24.0/65.0*r*t12+588.0/299.0*t28-1470.0/
3289.0*t29+56.0/16445.0*t30+8.0/15935205.0;
      t33 = 336.0/312455.0*t1-7.0/65.0*t5+784.0/299.0*t9+7.0/2990.0*t4+336.0/
1495.0*t11-84.0/16445.0*t10-28.0/937365.0*s-28.0/937365.0*r-98.0/13.0*t13-14.0/
16445.0*t7+672.0/65.0*t14+84.0/312455.0*t6-588.0/3289.0*t15+14.0/3289.0*t3+
224.0/3289.0*t16-28.0/16445.0*t8-42.0/3289.0*t18;
      t34 = t6*t6;
      t41 = 84.0/65.0*t19-70.0/13.0*t21+21.0/62491.0*t2-168.0/65.0*t22-168.0/
16445.0*t23+420.0/3289.0*t25-1470.0/3289.0*t26+588.0/299.0*t28+14.0/16445.0*t34
+7.0*t34*t4-196.0/65.0*t34*t8-588.0/16445.0*t34*s+147.0/299.0*t34*t2+588.0/65.0
*t34*t3-168.0/13.0*t34*t10-2352.0/3289.0*t29+112.0/3289.0*t30+14.0/15935205.0;
      drv[0] = t17+t31;
      drv[1] = t33+t41;
   /* p=14 5 6 */
   } else if( i==5 && j==6 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = s*s;
      t4 = t3*t3;
      t5 = t4*t3;
      t7 = t1*r;
      t9 = t3*s;
      t10 = t7*t9;
      t11 = t3*t2;
      t12 = t4*s;
      t13 = r*t12;
      t15 = r*s;
      t16 = t3*r;
      t17 = r*t9;
      t18 = r*t4;
      t19 = t7*t4;
      t20 = t2*t12;
      t21 = t7*t12;
      t23 = t7*s;
      t24 = t7*t3;
      t25 = 5.0*t2*t5-60.0/13.0*t7*t5+420.0/299.0*t10+105.0/598.0*t11+84.0/
299.0*t13+1.0/2124694.0-2.0/13.0*r*t5+36.0/62491.0*t15-30.0/3289.0*t16+200.0/
3289.0*t17-630.0/3289.0*t18-63.0/13.0*t19-105.0/13.0*t20+504.0/65.0*t21+18.0/
13.0*t1*t5+36.0/3289.0*t23-630.0/3289.0*t24;
      t26 = t1*s;
      t27 = t1*t3;
      t28 = t1*t9;
      t29 = t1*t4;
      t30 = t1*t12;
      t31 = t2*t9;
      t32 = t2*s;
      t33 = t2*t4;
      t34 = -27.0/6578.0*t26+225.0/3289.0*t27-1575.0/3289.0*t28+945.0/598.0*t29
-63.0/26.0*t30-35.0/26.0*t31-63.0/6578.0*t32+63.0/13.0*t33+t2/6578-3.0/16445.0*
t7-63.0/6578.0*t12+3.0/598.0*t5+45.0/124982.0*t3-15.0/6578.0*t9+45.0/6578.0*t4+
9.0/124982.0*t1-3.0/124982.0*s-2.0/187473.0*r;
      t36 = 630.0/299.0*t10+315.0/299.0*t11+9.0/299.0*t13+3.0/5311735.0+45.0/
62491.0*t15-45.0/6578.0*t16+90.0/3289.0*t17-315.0/6578.0*t18-105.0/26.0*t19
-90.0/13.0*t20+36.0/13.0*t21+150.0/3289.0*t23-1575.0/3289.0*t24-30.0/3289.0*t26
+300.0/3289.0*t27-1260.0/3289.0*t28+210.0/299.0*t29-6.0/13.0*t30;
      t37 = t2*r;
      t43 = -63.0/13.0*t31-315.0/3289.0*t32+126.0/13.0*t33+21.0/299.0*t37*s
-105.0/13.0*t37*t4-21.0/26.0*t37*t3+6.0*t37*t12-63.0/32890.0*t37+252.0/65.0*t37
*t9+9.0/3289.0*t2-9.0/6578.0*t7-9.0/16445.0*t12+9.0/62491.0*t3-9.0/16445.0*t9+
3.0/3289.0*t4+18.0/62491.0*t1-s/62491-3.0/124982.0*r;
      drv[0] = t25+t34;
      drv[1] = t36+t43;
   /* p=14 6 5 */
   } else if( i==6 && j==5 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = s*s;
      t4 = t3*t2;
      t5 = t2*r;
      t6 = t3*t3;
      t7 = t6*s;
      t9 = t1*r;
      t10 = t9*s;
      t11 = t5*t6;
      t12 = t5*t3;
      t13 = t3*s;
      t14 = t9*t13;
      t15 = t9*t3;
      t16 = t1*s;
      t17 = t1*t3;
      t18 = r*t13;
      t19 = 210.0/299.0*t4+6.0*t7*t5+3.0/5311735.0+90.0/3289.0*t10-90.0/13.0*
t11-6.0/13.0*t12+630.0/299.0*t14-1260.0/3289.0*t15-45.0/6578.0*t16+300.0/3289.0
*t17+3.0/3289.0*t2-9.0/16445.0*t9+9.0/62491.0*t1-9.0/16445.0*t5+9.0/3289.0*t6
-9.0/6578.0*t13+150.0/3289.0*t18+18.0/62491.0*t3;
      t21 = r*s;
      t22 = t3*r;
      t23 = r*t6;
      t24 = t5*t13;
      t25 = t9*t6;
      t27 = t5*s;
      t29 = t1*t13;
      t30 = t1*t6;
      t32 = t2*t13;
      t33 = t2*s;
      t34 = t2*t6;
      t35 = -63.0/32890.0*t7-3.0/124982.0*s-r/62491+21.0/299.0*r*t7+45.0/
62491.0*t21-30.0/3289.0*t22-315.0/3289.0*t23+36.0/13.0*t24-63.0/13.0*t25-105.0/
13.0*t2*t7+9.0/299.0*t27+252.0/65.0*t7*t9-1575.0/3289.0*t29+315.0/299.0*t30
-21.0/26.0*t1*t7-105.0/26.0*t32-315.0/6578.0*t33+126.0/13.0*t34;
      t37 = t2*t1;
      t39 = 5.0*t37*t6+945.0/598.0*t4+1.0/2124694.0+200.0/3289.0*t10-105.0/13.0
*t11-63.0/26.0*t12+420.0/299.0*t14-1575.0/3289.0*t15-30.0/3289.0*t16+225.0/
3289.0*t17+45.0/6578.0*t2-15.0/6578.0*t9+45.0/124982.0*t1-63.0/6578.0*t5+t6
/6578-3.0/16445.0*t13+36.0/3289.0*t18;
      t43 = 9.0/124982.0*t3-2.0/187473.0*s-3.0/124982.0*r+36.0/62491.0*t21-27.0
/6578.0*t22-63.0/6578.0*t23+504.0/65.0*t24-35.0/26.0*t25+84.0/299.0*t27+18.0/
13.0*t37*t3-60.0/13.0*t37*t13-2.0/13.0*t37*s+3.0/598.0*t37-630.0/3289.0*t29+
105.0/598.0*t30-63.0/13.0*t32-630.0/3289.0*t33+63.0/13.0*t34;
      drv[0] = t19+t35;
      drv[1] = t39+t43;
   /* p=14 7 4 */
   } else if( i==7 && j==4 ) {
      t1 = s*s;
      t2 = t1*r;
      t3 = r*s;
      t4 = t1*t1;
      t6 = r*r;
      t7 = t6*t6;
      t8 = r*t7;
      t9 = t1*s;
      t10 = t8*t9;
      t11 = t7*t6;
      t12 = t11*s;
      t13 = r*t6;
      t15 = t8*s;
      t17 = r*t9;
      t18 = 14.0/15935205.0+84.0/312455.0*t1-168.0/16445.0*t2+336.0/312455.0*t3
-588.0/16445.0*r*t4+672.0/65.0*t10-7.0/65.0*t12-196.0/65.0*t13*t4+336.0/1495.0*
t15+7.0*t11*t4-84.0/16445.0*t8+112.0/3289.0*t17-14.0/16445.0*t9-28.0/937365.0*r
-28.0/937365.0*s+7.0/2990.0*t11+14.0/3289.0*t7;
      t20 = t8*t1;
      t21 = t9*t13;
      t22 = t13*s;
      t23 = t1*t13;
      t24 = t6*s;
      t25 = t9*t6;
      t27 = t1*t7;
      t28 = t7*s;
      t29 = t11*t1;
      t30 = t11*t9;
      t32 = t7*t9;
      t33 = t1*t6;
      t34 = -168.0/13.0*t8*t4-168.0/65.0*t20+784.0/299.0*t21+224.0/3289.0*t22
-2352.0/3289.0*t23-42.0/3289.0*t24-1470.0/3289.0*t25+147.0/299.0*t6*t4+588.0/
299.0*t27-588.0/3289.0*t28+84.0/65.0*t29-28.0/16445.0*t13+14.0/16445.0*t4-70.0/
13.0*t30+21.0/62491.0*t6+588.0/65.0*t7*t4-98.0/13.0*t32+420.0/3289.0*t33;
      t36 = 8.0/15935205.0+12.0/312455.0*t1-42.0/16445.0*t2+168.0/312455.0*t3+
2352.0/325.0*t10-56.0/65.0*t12+1176.0/1495.0*t15-588.0/16445.0*t8+56.0/16445.0*
t17-4.0/82225.0*t9-28.0/937365.0*r-8.0/937365.0*s+56.0/1495.0*t11+56.0/3289.0*
t7-294.0/65.0*t20+196.0/299.0*t21;
      t37 = t7*t13;
      t41 = 280.0/3289.0*t22-1470.0/3289.0*t23-168.0/16445.0*t24-1176.0/16445.0
*t25+588.0/299.0*t27-1176.0/3289.0*t28+336.0/65.0*t29-14.0/3289.0*t13-112.0/
13.0*t30+168.0/312455.0*t6+24.0/65.0*t37*s-196.0/65.0*t32+168.0/3289.0*t33-30.0
/13.0*t37*t1+4.0*t37*t9-t37/65;
      drv[0] = t18+t34;
      drv[1] = t36+t41;
   /* p=14 8 3 */
   } else if( i==8 && j==3 ) {
      t1 = r*s;
      t2 = s*s;
      t3 = t2*r;
      t4 = r*r;
      t5 = t4*t4;
      t6 = t5*r;
      t7 = t2*s;
      t9 = t5*t4;
      t11 = t9*t2;
      t12 = t4*r;
      t13 = t5*t12;
      t15 = t12*t2;
      t16 = t12*s;
      t17 = t4*s;
      t18 = t4*t2;
      t20 = t13*t2;
      t22 = t2*t5;
      t23 = t5*s;
      t24 = 3024.0/1562275.0*t1-1008.0/82225.0*t3+6048.0/325.0*t6*t7-252.0/13.0
*t9*t7+3024.0/325.0*t11+8.0*t13*t7-21168.0/16445.0*t15+3024.0/16445.0*t16
-2268.0/82225.0*t17+3024.0/16445.0*t18-5292.0/16445.0*t4*t7-48.0/13.0*t20-588.0
/65.0*t5*t7+7056.0/1495.0*t22-10584.0/16445.0*t23-4.0/325.0*t13;
      t25 = t6*s;
      t26 = t6*t2;
      t28 = t13*s;
      t29 = t9*s;
      t31 = 9072.0/7475.0*t25-3024.0/325.0*t26+3528.0/1495.0*t12*t7+144.0/325.0
*t28-504.0/82225.0*t12+336.0/16445.0*t5-378.0/325.0*t29+1512.0/1562275.0*t4
-3024.0/82225.0*t6-36.0/82225.0*t7+336.0/16445.0*r*t7+432.0/1562275.0*t2+252.0/
7475.0*t9-112.0/1562275.0*r-72.0/1562275.0*s+48.0/26558675.0;
      t33 = t5*t5;
      t36 = 864.0/1562275.0*t1-108.0/82225.0*t3+3.0*t33*t2+18.0/325.0*t33+
3024.0/325.0*t11-5292.0/16445.0*t15+2016.0/16445.0*t16-1008.0/82225.0*t17+504.0
/16445.0*t18-108.0/13.0*t20+2646.0/1495.0*t22-10584.0/16445.0*t23-12.0/13.0*t33
*s;
      t37 = -54.0/325.0*t13+14112.0/7475.0*t25-1764.0/325.0*t26+864.0/325.0*t28
-756.0/82225.0*t12+756.0/16445.0*t5-1008.0/325.0*t29+1512.0/1562275.0*t4
-10584.0/82225.0*t6+27.0/1562275.0*t2+1512.0/7475.0*t9-72.0/1562275.0*r-12.0/
1562275.0*s+18.0/26558675.0;
      drv[0] = t24+t31;
      drv[1] = t36+t37;
   /* p=14 9 2 */
   } else if( i==9 && j==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = s*s;
      t5 = t1*r;
      t6 = t5*s;
      t7 = r*s;
      t9 = t2*t2;
      t10 = t9*s;
      t11 = t2*r;
      t14 = t1*s;
      t16 = t2*t5;
      t18 = t2*s;
      t19 = 1134.0/312455.0*t1+2646.0/299.0*t2*t3+9072.0/16445.0*t6+1296.0/
312455.0*t7-216.0/16445.0*t3*r-27.0/13.0*t10-1512.0/65.0*t11*t3+27.0/5311735.0
-31752.0/16445.0*t5*t3-1134.0/16445.0*t14+756.0/3289.0*t1*t3-360.0/13.0*t16*t3
-7938.0/3289.0*t18;
      t20 = t2*t1;
      t23 = t16*s;
      t24 = t20*s;
      t25 = t11*s;
      t26 = 2268.0/65.0*t20*t3+9.0*t9*t3+432.0/65.0*t23+378.0/3289.0*t2+27.0/
325.0*t9-18.0/65.0*t16-2268.0/82225.0*t5-4536.0/16445.0*t11-567.0/65.0*t24+
9072.0/1495.0*t25-27.0/312455.0*s+567.0/1495.0*t20+81.0/312455.0*t3-72.0/
312455.0*r;
      t28 = t9*r;
      t30 = 6.0/5311735.0-27.0/312455.0*r+162.0/312455.0*t7+1512.0/1495.0*t20
-7938.0/16445.0*t11-2.0/312455.0*s+54.0/65.0*t9+5292.0/1495.0*t25-81.0/65.0*t16
-378.0/16445.0*t5-3.0/13.0*t28+504.0/3289.0*t6+648.0/312455.0*t1-216.0/16445.0*
t14+648.0/65.0*t23+2.0*t28*s-15876.0/16445.0*t18+2268.0/16445.0*t2-504.0/65.0*
t24-90.0/13.0*t10;
      drv[0] = t19+t26;
      drv[1] = t30;
   /* p=14 10 1 */
   } else if( i==10 && j==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t3*r;
      t7 = t1*r;
      t8 = t2*t7;
      t10 = t2*t1;
      t12 = t2*r;
      t18 = 10.0*t4*s-10.0/13.0*t4-495.0/13.0*t3*s+198.0/65.0*t3+792.0/13.0*t8*
s-66.0/13.0*t8-693.0/13.0*t10*s+1386.0/299.0*t10+8316.0/299.0*t12*s-756.0/299.0
*t12-2646.0/299.0*t2*s+252.0/299.0*t2+504.0/299.0*t7*s-252.0/1495.0*t7-54.0/
299.0*t1*s+108.0/5681.0*t1+54.0/5681.0*r*s-6.0/5681.0*r-s/5681+2.0/96577.0;
      t20 = t1*t3-55.0/13.0*t4+99.0/13.0*t3-99.0/13.0*t8+1386.0/299.0*t10
-2646.0/1495.0*t12+126.0/299.0*t2-18.0/299.0*t7+27.0/5681.0*t1-r/5681+1.0/
482885.0;
      drv[0] = t18;
      drv[1] = t20;
   /* p=14 11 0 */
   } else if( i==11 && j==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t6 = t1*r;
      t10 = 11.0*t1*t3-660.0/13.0*t3*r+6534.0/65.0*t3-1452.0/13.0*t2*t6+22869.0
/299.0*t2*t1-49896.0/1495.0*t2*r+2772.0/299.0*t2-2376.0/1495.0*t6+891.0/5681.0*
t1-44.0/5681.0*r+66.0/482885.0;
      drv[0] = t10;
      drv[1] = 0.0;
   /* p=15 0 12 */
   } else if( i==0 && j==12 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t4 = t3*t3;
      t11 = 12.0*t4*t2-429.0/7.0*t4*t1+2860.0/21.0*t4*s-1210.0/7.0*t4+968.0/7.0
*t2*t3-363.0/5.0*t1*t3+2904.0/115.0*t3*s-132.0/23.0*t3+132.0/161.0*t2-11.0/
161.0*t1+44.0/15295.0*s-2.0/45885.0;
      drv[0] = 0.0;
      drv[1] = t11;
   /* p=15 1 11 */
   } else if( i==1 && j==11 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t4 = t3*t3;
      t6 = t4*t1;
      t7 = t4*s;
      t8 = t3*t2;
      t9 = t3*t1;
      t10 = t3*s;
      t11 = t4*t2-33.0/7.0*t6+605.0/63.0*t7-3025.0/273.0*t4+726.0/91.0*t8-242.0
/65.0*t9+1694.0/1495.0*t10-66.0/299.0*t3+55.0/2093.0*t2-11.0/6279.0*t1+11.0/
198835.0*s-1.0/1789515.0;
      t22 = 11.0*r*t6-330.0/7.0*r*t7+605.0/7.0*r*t4-24200.0/273.0*r*t8+726.0/
13.0*r*t9-1452.0/65.0*r*t10+1694.0/299.0*r*t3-264.0/299.0*r*t2+165.0/2093.0*r*
t1-22.0/6279.0*r*s+11.0/198835.0*r;
      t23 = -11.0/14.0*t6+220.0/63.0*t7-605.0/91.0*t4+1936.0/273.0*t8-121.0/
26.0*t9+2904.0/1495.0*t10-154.0/299.0*t3+176.0/2093.0*t2-33.0/4186.0*t1+44.0/
119301.0*s-11.0/1789515.0;
      drv[0] = t11;
      drv[1] = t22+t23;
   /* p=15 2 10 */
   } else if( i==2 && j==10 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t3*s;
      t5 = r*t4;
      t6 = r*t3;
      t7 = t1*s;
      t8 = t2*t1;
      t9 = r*t8;
      t10 = t2*t7;
      t11 = r*t10;
      t12 = t3*t1;
      t14 = -1.0/3579030.0-55.0/7.0*t5+275.0/21.0*t6+s/39767-3.0/4186.0*t1+20.0
/2093.0*t7+88.0/13.0*t9-1100.0/91.0*t11+2.0*r*t12+r/596505+55.0/63.0*t4;
      t15 = r*t2;
      t16 = r*s;
      t17 = r*t1;
      t18 = r*t7;
      t19 = t2*s;
      t20 = r*t19;
      t21 = 154.0/299.0*t15-t16/6279-3.0/14.0*t12-275.0/182.0*t3+10.0/2093.0*
t17-20.0/299.0*t18-154.0/65.0*t20-21.0/299.0*t2+462.0/1495.0*t19+132.0/91.0*t10
-11.0/13.0*t8;
      t23 = r*r;
      t31 = -77.0/13.0*t23*t2-1.0/715806.0+3.0/39767.0*s+55.0/7.0*t6-t23/12558
-66.0/13.0*t20+10.0*t23*t4-495.0/14.0*t23*t3-550.0/13.0*t23*t8+1100.0/21.0*t23*
t10+10.0/2093.0*t23*s-30.0/299.0*t23*t1+66.0/299.0*t19-21.0/299.0*t2+462.0/
299.0*t15;
      t34 = -1100.0/91.0*t11+44.0/91.0*t10-11.0/26.0*t8+132.0/13.0*t9+4.0/299.0
*t7-3.0/2093.0*t1-3.0/2093.0*t16+60.0/2093.0*t17-84.0/299.0*t18-55.0/182.0*t3
-15.0/7.0*t5+r/39767+5.0/63.0*t4+308.0/299.0*t23*t7+264.0/13.0*t23*t19;
      drv[0] = t14+t21;
      drv[1] = t31+t34;
   /* p=15 3 9 */
   } else if( i==3 && j==9 ) {
      t1 = r*r;
      t2 = t1*s;
      t3 = s*s;
      t4 = t3*t3;
      t5 = r*t4;
      t6 = t3*s;
      t7 = t4*t6;
      t8 = r*t7;
      t9 = t4*t3;
      t10 = r*t9;
      t11 = t4*s;
      t12 = t1*t7;
      t13 = r*t11;
      t14 = t4*t4;
      t15 = t14*s;
      t17 = r*t14;
      t18 = t1*t3;
      t19 = t1*t6;
      t20 = t1*t11;
      t21 = t1*t4;
      t22 = 9.0/23023.0*t2-378.0/16445.0*t4+504.0/1495.0*t5-360.0/91.0*t8+192.0
/65.0*t10+126.0/1495.0*t11+108.0/455.0*t7+90.0/7.0*t12-84.0/65.0*t13-6.0/7.0*r*
t15+20.0/7.0*t17-36.0/3289.0*t18+42.0/299.0*t19+252.0/65.0*t20-63.0/65.0*t21;
      t23 = r*t3;
      t24 = r*s;
      t26 = t1*t14;
      t27 = r*t6;
      t28 = t1*t9;
      t29 = 96.0/23023.0*t23-18.0/115115.0*t24+4.0/2187185.0*r-15.0/91.0*t14+
t15/21+3.0*t1*t15-135.0/14.0*t26-t1/230230+27.0/2187185.0*s-36.0/115115.0*t3
-168.0/3289.0*t27-120.0/13.0*t28+12.0/3289.0*t6-1.0/6561555.0-12.0/65.0*t9;
      t31 = t1*r;
      t34 = 96.0/23023.0*t2-42.0/3289.0*t4+126.0/299.0*t5-120.0/91.0*t8+108.0/
65.0*t10+48.0/1495.0*t11+30.0*t31*t9-180.0/7.0*t31*t7-1.0/2187185.0+3.0/23023.0
*t31+16.0/455.0*t7+80.0/7.0*t12-72.0/65.0*t13+3.0/7.0*t17-252.0/3289.0*t18+
1008.0/1495.0*t19+576.0/65.0*t20-42.0/13.0*t21;
      t41 = -84.0/65.0*t31*t6+84.0/13.0*t31*t4+9.0*t31*t14+42.0/299.0*t31*t3
-24.0/3289.0*t31*s-240.0/13.0*t31*t11+36.0/3289.0*t23-72.0/115115.0*t24+27.0/
2187185.0*r-t14/91-27.0/7.0*t26-9.0/115115.0*t1+48.0/2187185.0*s-6.0/16445.0*t3
-1512.0/16445.0*t27-180.0/13.0*t28+48.0/16445.0*t6-3.0/65.0*t9;
      drv[0] = t22+t29;
      drv[1] = t34+t41;
   /* p=15 4 8 */
   } else if( i==4 && j==8 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = r*r;
      t5 = t4*t3;
      t6 = t1*s;
      t7 = r*t6;
      t8 = r*t1;
      t9 = r*s;
      t10 = t2*t2;
      t13 = t4*s;
      t14 = t4*t2;
      t15 = t4*t1;
      t16 = t4*r;
      t17 = -8.0/195.0*t3-80.0/13.0*t5+16.0/9867.0*t6-112.0/3289.0*t7-8.0/
49335.0*t1+32.0/9867.0*t8-16.0/115115.0*t9-15.0/7.0*t4*t10-10.0/819.0*t10-t4
/115115+16.0/2187185.0*s+4.0/2187185.0*r+20.0/63.0*r*t10+16.0/23023.0*t13-14.0/
13.0*t14-28.0/3289.0*t2-56.0/3289.0*t15+4.0/345345.0*t16;
      t18 = t2*t6;
      t19 = t4*t18;
      t20 = r*t18;
      t21 = t16*t18;
      t22 = t2*s;
      t23 = t4*t22;
      t24 = t16*s;
      t25 = t4*t6;
      t26 = t16*t3;
      t27 = t16*t2;
      t28 = t16*t22;
      t29 = r*t3;
      t30 = t16*t1;
      t32 = r*t2;
      t33 = r*t22;
      t34 = t16*t6;
      t35 = 40.0/7.0*t19+16.0/455.0*t18-80.0/91.0*t20-72.0/7.0*t21+224.0/65.0*
t23+112.0/4485.0*t22-16.0/16445.0*t24+56.0/299.0*t25+32.0/3.0*t26+112.0/65.0*
t27-224.0/39.0*t28+64.0/65.0*t29+112.0/4485.0*t30+4.0*t16*t10+56.0/299.0*t32
-112.0/195.0*t33-56.0/195.0*t34-2.0/19684665.0;
      t37 = -t3/195-40.0/13.0*t5+8.0/9867.0*t6-112.0/3289.0*t7-2.0/16445.0*t1+
16.0/3289.0*t8-16.0/49335.0*t9-8.0/115115.0*t4+8.0/937365.0*s+16.0/2187185.0*r+
32.0/9867.0*t13-56.0/39.0*t14-28.0/9867.0*t2-168.0/3289.0*t15+16.0/69069.0*t16+
80.0/63.0*t19+8.0/4095.0*t18-80.0/819.0*t20-40.0/7.0*t21+192.0/65.0*t23;
      t38 = t4*t4;
      t46 = 8.0/1495.0*t22-112.0/9867.0*t24+112.0/299.0*t25+40.0/3.0*t26+224.0/
39.0*t27-160.0/13.0*t28+16.0/65.0*t29+56.0/299.0*t30+112.0/897.0*t32-16.0/65.0*
t33-4.0/16445.0*t38+8.0*t38*t18-56.0/39.0*t34-280.0/39.0*t38*t2+112.0/65.0*t38*
t6-14.0/65.0*t38*t1+56.0/4485.0*t38*s+16.0*t38*t22-18.0*t38*t3-4.0/19684665.0;
      drv[0] = t17+t35;
      drv[1] = t37+t46;
   /* p=15 5 7 */
   } else if( i==5 && j==7 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t4 = t3*t2;
      t6 = t3*t1;
      t7 = r*t6;
      t8 = r*r;
      t9 = t8*t8;
      t10 = t9*t1;
      t11 = r*t1;
      t12 = r*s;
      t13 = t8*t2;
      t14 = t3*s;
      t15 = t8*t14;
      t16 = t9*t6;
      t17 = t9*t14;
      t18 = t8*r;
      t20 = t9*s;
      t21 = r*t3;
      t22 = r*t14;
      t23 = t18*t1;
      t24 = t18*s;
      t25 = t18*t14;
      t26 = t18*t3;
      t27 = t18*t2;
      t28 = t8*s;
      t29 = -100.0/819.0*r*t4+32.0/117.0*t7-7.0/117.0*t10+80.0/29601.0*t11-4.0/
29601.0*t12-1.0/11810799.0+175.0/897.0*t13+28.0/13.0*t15-10.0*t16+70.0/9.0*t17
-30.0/7.0*t4*t18+7.0/2691.0*t20+280.0/2691.0*t21-28.0/117.0*t22+56.0/897.0*t23
-28.0/9867.0*t24-280.0/39.0*t25+112.0/39.0*t26-70.0/117.0*t27+10.0/9867.0*t28;
      t30 = t9*t3;
      t31 = r*t2;
      t32 = t8*t6;
      t35 = t8*t3;
      t36 = t9*t2;
      t37 = t8*t1;
      t38 = t18*t6;
      t39 = -t1/9867+25.0/29601.0*t2+8.0/3936933.0*r+s/187473-t8/69069-t6/117+
t4/273-t9/29601+8.0/207207.0*t18-35.0/9867.0*t3+7.0/897.0*t14-350.0/117.0*t30
-700.0/29601.0*t31-100.0/39.0*t32+25.0/21.0*t8*t4+5.0*t9*t4-35.0/39.0*t35+70.0/
117.0*t36-70.0/3289.0*t37+80.0/9.0*t38;
      t41 = t9*r;
      t46 = 28.0/897.0*t20+35.0/897.0*t21-2.0/39.0*t22+175.0/897.0*t23-140.0/
9867.0*t24-200.0/39.0*t25+140.0/39.0*t26-140.0/117.0*t27-14.0/585.0*t41*s+14.0/
39.0*t41*t1-12.0*t41*t14;
      t52 = -7.0/9867.0*t9+10.0/29601.0*t18-7.0/9867.0*t3+4.0/4485.0*t14-350.0/
39.0*t30-140.0/9867.0*t31-50.0/117.0*t32-70.0/117.0*t35+112.0/39.0*t36-350.0/
9867.0*t37+25.0/9.0*t38;
      drv[0] = t29+t39;
      drv[1] = t7/39-35.0/78.0*t10+25.0/9867.0*t11-2.0/9867.0*t12-1.0/8436285.0
+7.0/13455.0*t41+560.0/2691.0*t13+32.0/39.0*t15-15.0/2.0*t16+40.0/3.0*t17+t46+
7.0*t41*t6-280.0/117.0*t41*t2+70.0/9.0*t41*t3+80.0/29601.0*t28-t1/19734+8.0/
29601.0*t2+r/187473+4.0/937365.0*s-2.0/29601.0*t8-t6/2340+t52;
   /* p=15 6 6 */
   } else if( i==6 && j==6 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = s*s;
      t5 = t4*t4;
      t6 = t3*t5;
      t7 = t4*s;
      t8 = t1*t7;
      t9 = r*t5;
      t10 = t3*s;
      t11 = r*s;
      t12 = r*t7;
      t13 = t5*t4;
      t15 = t1*t5;
      t16 = t3*t4;
      t17 = t1*s;
      t19 = t2*t4;
      t20 = t2*t7;
      t21 = t1*t4;
      t22 = t1*r;
      t24 = t5*s;
      t25 = t3*t24;
      t27 = t2*t5;
      t28 = t3*t7;
      t29 = t1*t24;
      t32 = -35.0/156.0*t19+70.0/39.0*t20-175.0/6578.0*t21+10.0/3.0*t22*t13-9.0
*t25+6.0*t3*t13-175.0/26.0*t27-50.0/39.0*t28+14.0/13.0*t29-15.0/2.0*t2*t13+2.0/
39.0*r*t13;
      t34 = t22*t4;
      t35 = t22*s;
      t36 = t22*t24;
      t37 = t22*t5;
      t38 = t22*t7;
      t39 = r*t4;
      t41 = r*t24;
      t42 = t2*s;
      t43 = t2*t24;
      t44 = 3.0/624910.0*s+t3/8970-t4/13156+r/374946+7.0/2990.0*t24-7.0/39468.0
*t2+t22/9867-21.0/13156.0*t5-7.0/78.0*t41+7.0/598.0*t42+35.0/3.0*t43;
      t48 = 42.0/13.0*t20-175.0/6578.0*t21-9.0*t25-175.0/26.0*t27-70.0/13.0*t28
+2.0/13.0*t29+175.0/897.0*t34-175.0/9867.0*t35-50.0/39.0*t36+70.0/39.0*t37-35.0
/39.0*t38;
      t50 = t2*t1;
      t57 = t24/8970-21.0/13156.0*t2+5.0/9867.0*t22-7.0/39468.0*t5-t50/780-t41
/130+35.0/598.0*t42+5.0*t43-15.0/2.0*t50*t5+10.0/3.0*t50*t7+6.0*t50*t24;
      drv[0] = 5.0*t6+175.0/897.0*t8+35.0/598.0*t9-t10/130-t11/6578-175.0/
9867.0*t12-25.0/39.0*t1*t13-35.0/52.0*t15+2.0/13.0*t16+5.0/3289.0*t17+t32+35.0/
299.0*t34-21.0/3289.0*t35-70.0/13.0*t36+42.0/13.0*t37-35.0/39.0*t38-1.0/
11248380.0+5.0/9867.0*t7-t1/39468-t13/780+25.0/9867.0*t39+t44;
      drv[1] = 35.0/3.0*t6+35.0/299.0*t8+7.0/598.0*t9-7.0/78.0*t10-t11/6578
-21.0/3289.0*t12-35.0/156.0*t15+14.0/13.0*t16+25.0/9867.0*t17-35.0/52.0*t19+t48
+2.0/39.0*t50*s-25.0/39.0*t50*t4-1.0/11248380.0+t7/9867-t1/13156+5.0/3289.0*t39
+s/374946+7.0/2990.0*t3-t4/39468+3.0/624910.0*r+t57;
   /* p=15 7 5 */
   } else if( i==7 && j==5 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = s*s;
      t4 = t3*t3;
      t5 = t4*s;
      t8 = t3*s;
      t9 = t2*t8;
      t10 = t2*r;
      t11 = t10*s;
      t12 = r*s;
      t13 = r*t3;
      t14 = t2*t1;
      t15 = t14*s;
      t16 = t14*t3;
      t17 = t1*t4;
      t18 = t10*t3;
      t20 = t14*t4;
      t21 = t14*t8;
      t22 = t2*t3;
      t23 = t1*t3;
      t26 = t2*t4;
      t27 = t10*t8;
      t28 = t10*t4;
      t29 = t1*t8;
      t30 = t2*s;
      t31 = -15.0/2.0*t20+25.0/9.0*t21-70.0/117.0*t22-350.0/9867.0*t23+7.0*t14*
t5-12.0*t10*t5-350.0/39.0*t26-200.0/39.0*t27+40.0/3.0*t28+175.0/897.0*t29+35.0/
897.0*t30;
      t33 = r*t4;
      t35 = t1*r;
      t36 = t35*t3;
      t37 = t35*s;
      t39 = t35*t4;
      t40 = t35*t8;
      t42 = r*t8;
      t43 = t1*s;
      t44 = -t1/19734+8.0/29601.0*t35-140.0/9867.0*t42-t14/2340+4.0/4485.0*t10
-2.0/29601.0*t3+7.0/13455.0*t5-7.0/9867.0*t2+25.0/9867.0*t43-7.0/9867.0*t4-1.0/
8436285.0;
      t47 = t2*t35;
      t50 = 5.0*t47*t4+25.0/21.0*t47*t3+112.0/39.0*t9-1.0/11810799.0-28.0/117.0
*t11-4.0/29601.0*t12+10.0/9867.0*t13+32.0/117.0*t15-100.0/39.0*t16-7.0/117.0*
t17+28.0/13.0*t18-10.0*t20+80.0/9.0*t21-35.0/39.0*t22-70.0/3289.0*t23-350.0/
117.0*t26-280.0/39.0*t27+70.0/9.0*t28+56.0/897.0*t29+280.0/2691.0*t30;
      t53 = 7.0/2691.0*t33+175.0/897.0*t36-700.0/29601.0*t37+70.0/117.0*t39
-70.0/117.0*t40-100.0/819.0*t47*s-30.0/7.0*t47*t8+8.0/3936933.0*s+r/187473+8.0/
207207.0*t8-t1/9867+25.0/29601.0*t35-28.0/9867.0*t42-t14/117+7.0/897.0*t10-t3
/69069-35.0/9867.0*t2+80.0/29601.0*t43-t4/29601+t47/273;
      drv[0] = 70.0/9.0*t2*t5+14.0/39.0*t1*t5+140.0/39.0*t9-2.0/39.0*t11-2.0/
9867.0*t12+80.0/29601.0*t13+t15/39-50.0/117.0*t16-35.0/78.0*t17+32.0/39.0*t18+
t31+28.0/897.0*t33-14.0/585.0*r*t5+560.0/2691.0*t36-140.0/9867.0*t37-280.0/
117.0*t35*t5+112.0/39.0*t39-140.0/117.0*t40+s/187473+4.0/937365.0*r+10.0/
29601.0*t8+t44;
      drv[1] = t50+t53;
   /* p=15 8 4 */
   } else if( i==8 && j==4 ) {
      t1 = r*s;
      t2 = s*s;
      t3 = t2*r;
      t4 = r*r;
      t5 = r*t4;
      t6 = t4*t4;
      t7 = t6*t5;
      t8 = t7*s;
      t9 = t2*s;
      t10 = r*t9;
      t11 = t6*t4;
      t12 = t11*s;
      t13 = t7*t9;
      t14 = t11*t2;
      t15 = t6*r;
      t16 = t15*t2;
      t17 = t2*t2;
      t19 = t2*t4;
      t20 = t6*t9;
      t21 = t11*t9;
      t22 = t6*t2;
      t23 = t4*s;
      t26 = t15*t9;
      t27 = -16.0/49335.0*t1-4.0/19684665.0+8.0/937365.0*r+16.0/2187185.0*s+
32.0/9867.0*t3-80.0/819.0*t8-112.0/9867.0*t10+16.0/65.0*t12-40.0/7.0*t13-40.0/
13.0*t14+192.0/65.0*t16+8.0*t7*t17-168.0/3289.0*t19+224.0/39.0*t20+40.0/3.0*t21
-56.0/39.0*t22+16.0/3289.0*t23-18.0*t11*t17-280.0/39.0*t6*t17-160.0/13.0*t26;
      t29 = t7*t2;
      t31 = t15*s;
      t32 = t5*t9;
      t33 = t5*s;
      t34 = t2*t5;
      t36 = t4*t9;
      t37 = t6*s;
      t39 = 16.0*t15*t17-28.0/9867.0*t6+80.0/63.0*t29-14.0/65.0*t4*t17-4.0/
16445.0*t17+8.0/9867.0*t5-2.0/16445.0*t4+8.0/4095.0*t7+16.0/69069.0*t9-8.0/
115115.0*t2+8.0/1495.0*t15-16.0/65.0*t31-t11/195-56.0/39.0*t32-112.0/3289.0*t33
+112.0/299.0*t34+56.0/4485.0*r*t17+56.0/299.0*t36+112.0/897.0*t37+112.0/65.0*t5
*t17;
      t41 = t6*t6;
      t43 = -16.0/115115.0*t1+4.0*t41*t9-2.0/19684665.0+16.0/2187185.0*r+4.0/
2187185.0*s+16.0/23023.0*t3-80.0/91.0*t8-16.0/16445.0*t10+64.0/65.0*t12-72.0/
7.0*t13-80.0/13.0*t14+224.0/65.0*t16-56.0/3289.0*t19+112.0/65.0*t20+32.0/3.0*
t21-14.0/13.0*t22+32.0/9867.0*t23-224.0/39.0*t26;
      t46 = -28.0/3289.0*t6+40.0/7.0*t29+16.0/9867.0*t5-8.0/49335.0*t4+16.0/
455.0*t7+4.0/345345.0*t9-t2/115115+112.0/4485.0*t15-112.0/195.0*t31-8.0/195.0*
t11+20.0/63.0*t41*s-10.0/819.0*t41-15.0/7.0*t41*t2-56.0/195.0*t32-112.0/3289.0*
t33+56.0/299.0*t34+112.0/4485.0*t36+56.0/299.0*t37;
      drv[0] = t27+t39;
      drv[1] = t43+t46;
   /* p=15 9 3 */
   } else if( i==9 && j==3 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t4 = t3*t2;
      t5 = s*s;
      t6 = r*t5;
      t7 = t4*s;
      t8 = t3*t3;
      t9 = t8*t5;
      t10 = t3*r;
      t11 = t3*t1;
      t12 = t10*s;
      t13 = r*s;
      t14 = t3*s;
      t15 = t2*t5;
      t16 = t2*s;
      t17 = t5*s;
      t19 = t8*s;
      t20 = -1.0/2187185.0+16.0/455.0*t4+96.0/23023.0*t6-120.0/91.0*t7-t8/91
-9.0/115115.0*t5-27.0/7.0*t9+48.0/1495.0*t10-3.0/65.0*t11+27.0/2187185.0*s+48.0
/2187185.0*r-72.0/65.0*t12-72.0/115115.0*t13+126.0/299.0*t14+1008.0/1495.0*t15
-1512.0/16445.0*t16-84.0/65.0*t2*t17+3.0/7.0*t19;
      t25 = t11*t5;
      t26 = t10*t5;
      t27 = t4*t5;
      t28 = t1*s;
      t30 = t3*t5;
      t32 = t1*t5;
      t34 = t11*s;
      t35 = -240.0/13.0*t10*t17-42.0/3289.0*t3+48.0/16445.0*t2-180.0/7.0*t4*t17
-6.0/16445.0*t1-24.0/3289.0*r*t17+9.0*t8*t17-180.0/13.0*t25+576.0/65.0*t26+80.0
/7.0*t27+36.0/3289.0*t28+30.0*t11*t17-42.0/13.0*t30+84.0/13.0*t3*t17-252.0/
3289.0*t32+42.0/299.0*t1*t17+108.0/65.0*t34+3.0/23023.0*t17;
      t37 = t8*r;
      t39 = -1.0/6561555.0+108.0/455.0*t4+9.0/23023.0*t6-360.0/91.0*t7-15.0/
91.0*t8-t5/230230-135.0/14.0*t9+126.0/1495.0*t10-12.0/65.0*t11+4.0/2187185.0*s+
27.0/2187185.0*r-84.0/65.0*t12-18.0/115115.0*t13-6.0/7.0*t37*s+504.0/1495.0*t14
;
      t41 = 42.0/299.0*t15-168.0/3289.0*t16+20.0/7.0*t19-378.0/16445.0*t3+12.0/
3289.0*t2-36.0/115115.0*t1-120.0/13.0*t25+252.0/65.0*t26+90.0/7.0*t27+96.0/
23023.0*t28-63.0/65.0*t30-36.0/3289.0*t32+192.0/65.0*t34+t37/21+3.0*t37*t5;
      drv[0] = t20+t35;
      drv[1] = t39+t41;
   /* p=15 10 2 */
   } else if( i==10 && j==2 ) {
      t1 = r*r;
      t2 = s*s;
      t4 = t1*t1;
      t5 = t4*t4;
      t6 = t5*r;
      t7 = t6*s;
      t8 = t4*r;
      t9 = r*s;
      t10 = t4*t1;
      t12 = t1*r;
      t13 = t4*t12;
      t14 = t13*s;
      t17 = -1.0/715806.0-30.0/299.0*t1*t2-15.0/7.0*t7+66.0/299.0*t8-3.0/2093.0
*t9-11.0/26.0*t10+s/39767+3.0/39767.0*r-550.0/13.0*t10*t2+44.0/91.0*t13-1100.0/
91.0*t14+10.0/2093.0*r*t2-t2/12558-495.0/14.0*t5*t2-55.0/182.0*t5;
      t18 = t8*s;
      t21 = t10*s;
      t22 = t1*s;
      t25 = t5*s;
      t26 = t4*s;
      t28 = t12*s;
      t29 = -66.0/13.0*t18+264.0/13.0*t8*t2+1100.0/21.0*t13*t2+4.0/299.0*t12
-3.0/2093.0*t1+132.0/13.0*t21+60.0/2093.0*t22+10.0*t6*t2+5.0/63.0*t6-77.0/13.0*
t4*t2-21.0/299.0*t4+55.0/7.0*t25+462.0/299.0*t26+308.0/299.0*t12*t2-84.0/299.0*
t28;
      t31 = -1.0/3579030.0+462.0/1495.0*t8+r/39767+275.0/21.0*t25-t9/6279+132.0
/91.0*t13-11.0/13.0*t10+88.0/13.0*t21-154.0/65.0*t18-1100.0/91.0*t14-55.0/7.0*
t7;
      t32 = t5*t1;
      t34 = -3.0/4186.0*t1+154.0/299.0*t26+s/596505+55.0/63.0*t6+10.0/2093.0*
t22-3.0/14.0*t32-21.0/299.0*t4-20.0/299.0*t28+20.0/2093.0*t12-275.0/182.0*t5+
2.0*t32*s;
      drv[0] = t17+t29;
      drv[1] = t31+t34;
   /* p=15 11 1 */
   } else if( i==11 && j==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t3*t1;
      t6 = t3*r;
      t9 = t1*r;
      t10 = t2*t9;
      t12 = t1*t2;
      t14 = r*t2;
      t16 = 11.0*t4*s-11.0/14.0*t4-330.0/7.0*t6*s+220.0/63.0*t6+605.0/7.0*t3*s
-605.0/91.0*t3-24200.0/273.0*t10*s+1936.0/273.0*t10+726.0/13.0*t12*s-121.0/26.0
*t12-1452.0/65.0*t14*s;
      t21 = 2904.0/1495.0*t14+1694.0/299.0*t2*s-154.0/299.0*t2-264.0/299.0*t9*s
+176.0/2093.0*t9+165.0/2093.0*t1*s-33.0/4186.0*t1-22.0/6279.0*r*s+44.0/119301.0
*r+11.0/198835.0*s-11.0/1789515.0;
      t24 = t3*t9-33.0/7.0*t4+605.0/63.0*t6-3025.0/273.0*t3+726.0/91.0*t10
-242.0/65.0*t12+1694.0/1495.0*t14-66.0/299.0*t2+55.0/2093.0*t9-11.0/6279.0*t1+
11.0/198835.0*r-1.0/1789515.0;
      drv[0] = t16+t21;
      drv[1] = t24;
   /* p=15 12 0 */
   } else if( i==12 && j==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t4 = t3*t3;
      t11 = 12.0*t4*t2-429.0/7.0*t4*t1+2860.0/21.0*t4*r-1210.0/7.0*t4+968.0/7.0
*t3*t2-363.0/5.0*t3*t1+2904.0/115.0*t3*r-132.0/23.0*t3+132.0/161.0*t2-11.0/
161.0*t1+44.0/15295.0*r-2.0/45885.0;
      drv[0] = t11;
      drv[1] = 0.0;
    } else
      return 0;
    return 1;
}
#ifdef __cplusplus
}
#endif
