/*-------------------------------------------------------------------------
  Scientific Computation Research Center, RPI, Troy NY
  (C) Copyright 1995, RPI-SCOREC
 
  Project  : shapeFuntions
  Author(s): Saikat Dey
  Creation : Oct., 95
  Modifi.  : 
  Function :
           2nd derivative of a tri. face mode shape. i,j are the highest poly.
           order of r,s in the polynomial. maple generated code.
-------------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int FnDrv2(int i,int j, double r, double s, double drv[]) {
   double t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16,t17,t18;
   double t19,t20,t21,t22,t23,t24,t25,t26,t27,t28,t29,t30,t31,t32,t33,t34;
   double t35,t36,t37,t38,t39,t40,t41,t42,t43,t44,t45;
   double t46,t47,t48,t49,t50,t51;
   /* p=3 0 0 */
   if( i==0 && j==0 ) {
      drv[0] = 0.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 0.0;
   /* p=4 0 1 */
   } else if( i==0 && j==1 ) {
      drv[0] = 0.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 0.0;
   /* p=4 1 0 */
   } else if( i==1 && j==0 ) {
      drv[0] = 0.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 0.0;
   /* p=5 0 2 */
   } else if( i==0 && j==2 ) {
      drv[0] = 0.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 2.0;
   /* p=5 1 1 */
   } else if( i==1 && j==1 ) {
      drv[0] = 0.0;
      drv[1] = 1.0;
      drv[2] = 1.0;
      drv[3] = 0.0;
   /* p=5 2 0 */
   } else if( i==2 && j==0 ) {
      drv[0] = 2.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 0.0;
   /* p=6 0 3 */
   } else if( i==0 && j==3 ) {
      drv[0] = 0.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 6.0*s-12.0/5.0;
   /* p=6 1 2 */
   } else if( i==1 && j==2 ) {
      t1 = 2.0*s-3.0/5.0;
      drv[0] = 0.0;
      drv[1] = t1;
      drv[2] = t1;
      drv[3] = 2.0*r-2.0/5.0;
   /* p=6 2 1 */
   } else if( i==2 && j==1 ) {
      t2 = 2.0*r-3.0/5.0;
      drv[0] = 2.0*s-2.0/5.0;
      drv[1] = t2;
      drv[2] = t2;
      drv[3] = 0.0;
   /* p=6 3 0 */
   } else if( i==3 && j==0 ) {
      drv[0] = 6.0*r-12.0/5.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 0.0;
   /* p=7 0 4 */
   } else if( i==0 && j==4 ) {
      t1 = s*s;
      drv[0] = 0.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 12.0*t1-10.0*s+20.0/11.0;
   /* p=7 1 3 */
   } else if( i==1 && j==3 ) {
      t1 = s*s;
      t2 = 3.0*t1-2.0*s+3.0/11.0;
      drv[0] = 0.0;
      drv[1] = t2;
      drv[2] = t2;
      drv[3] = 6.0*r*s-2.0*r-s+4.0/11.0;
   /* p=7 2 2 */
   } else if( i==2 && j==2 ) {
      t1 = s*s;
      t4 = 4.0*r*s-r-s+3.0/11.0;
      t5 = r*r;
      drv[0] = 2.0*t1-s+1.0/11.0;
      drv[1] = t4;
      drv[2] = t4;
      drv[3] = 2.0*t5-r+1.0/11.0;
   /* p=7 3 1 */
   } else if( i==3 && j==1 ) {
      t3 = r*r;
      t4 = 3.0*t3-2.0*r+3.0/11.0;
      drv[0] = 6.0*r*s-r-2.0*s+4.0/11.0;
      drv[1] = t4;
      drv[2] = t4;
      drv[3] = 0.0;
   /* p=7 4 0 */
   } else if( i==4 && j==0 ) {
      t1 = r*r;
      drv[0] = 12.0*t1-10.0*r+20.0/11.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 0.0;
   /* p=8 0 5 */
   } else if( i==0 && j==5 ) {
      t1 = s*s;
      drv[0] = 0.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 20.0*t1*s-180.0/7.0*t1+900.0/91.0*s-100.0/91.0;
   /* p=8 1 4 */
   } else if( i==1 && j==4 ) {
      t1 = s*s;
      t3 = 4.0*t1*s-30.0/7.0*t1+120.0/91.0*s-10.0/91.0;
      drv[0] = 0.0;
      drv[1] = t3;
      drv[2] = t3;
      drv[3] = 12.0*r*t1-60.0/7.0*r*s+120.0/91.0*r-12.0/7.0*t1+120.0/91.0*s
-20.0/91.0;
   /* p=8 2 3 */
   } else if( i==2 && j==3 ) {
      t1 = s*s;
      t5 = r*s;
      t6 = 6.0*r*t1-24.0/7.0*t5+36.0/91.0*r-9.0/7.0*t1+72.0/91.0*s-9.0/91.0;
      t7 = r*r;
      drv[0] = 2.0*t1*s-12.0/7.0*t1+36.0/91.0*s-2.0/91.0;
      drv[1] = t6;
      drv[2] = t6;
      drv[3] = 6.0*t7*s-12.0/7.0*t7-18.0/7.0*t5+72.0/91.0*r+18.0/91.0*s-6.0/
91.0;
   /* p=8 3 2 */
   } else if( i==3 && j==2 ) {
      t1 = s*s;
      t3 = r*s;
      t5 = r*r;
      t7 = 6.0*t5*s-9.0/7.0*t5-24.0/7.0*t3+72.0/91.0*r+36.0/91.0*s-9.0/91.0;
      drv[0] = 6.0*r*t1-18.0/7.0*t3+18.0/91.0*r-12.0/7.0*t1+72.0/91.0*s-6.0/
91.0;
      drv[1] = t7;
      drv[2] = t7;
      drv[3] = 2.0*t5*r-12.0/7.0*t5+36.0/91.0*r-2.0/91.0;
   /* p=8 4 1 */
   } else if( i==4 && j==1 ) {
      t1 = r*r;
      t6 = 4.0*r*t1-30.0/7.0*t1+120.0/91.0*r-10.0/91.0;
      drv[0] = 12.0*t1*s-12.0/7.0*t1-60.0/7.0*r*s+120.0/91.0*r+120.0/91.0*s
-20.0/91.0;
      drv[1] = t6;
      drv[2] = t6;
      drv[3] = 0.0;
   /* p=8 5 0 */
   } else if( i==5 && j==0 ) {
      t1 = r*r;
      drv[0] = 20.0*r*t1-180.0/7.0*t1+900.0/91.0*r-100.0/91.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 0.0;
   /* p=9 0 6 */
   } else if( i==0 && j==6 ) {
      t1 = s*s;
      t2 = t1*t1;
      drv[0] = 0.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 30.0*t2-105.0/2.0*t1*s+63.0/2.0*t1-15.0/2.0*s+15.0/26.0;
   /* p=9 1 5 */
   } else if( i==1 && j==5 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t1*s;
      t4 = 5.0*t2-15.0/2.0*t3+15.0/4.0*t1-5.0/7.0*s+15.0/364.0;
      drv[0] = 0.0;
      drv[1] = t4;
      drv[2] = t4;
      drv[3] = 20.0*r*t3-45.0/2.0*r*t1+15.0/2.0*r*s-5.0/7.0*r-5.0/2.0*t3+3.0*t1
-15.0/14.0*s+10.0/91.0;
   /* p=9 2 4 */
   } else if( i==2 && j==4 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t1*s;
      t6 = r*t1;
      t7 = r*s;
      t8 = 8.0*r*t3-15.0/2.0*t6+2.0*t7-r/7-3.0/2.0*t3+3.0/2.0*t1-3.0/7.0*s+3.0/
91.0;
      t9 = r*r;
      drv[0] = 2.0*t2-5.0/2.0*t3+t1-s/7+1.0/182.0;
      drv[1] = t8;
      drv[2] = t8;
      drv[3] = 12.0*t9*t1-15.0/2.0*t9*s+t9-9.0/2.0*t6+3.0*t7-3.0/7.0*r+3.0/10.0
*t1-3.0/14.0*s+3.0/91.0;
   /* p=9 3 3 */
   } else if( i==3 && j==3 ) {
      t1 = s*s;
      t2 = t1*s;
      t4 = r*t1;
      t5 = r*s;
      t7 = r*r;
      t9 = t7*s;
      t10 = 9.0*t7*t1-9.0/2.0*t9+9.0/20.0*t7-9.0/2.0*t4+12.0/5.0*t5-9.0/35.0*r+
9.0/20.0*t1-9.0/35.0*s+27.0/910.0;
      t11 = t7*r;
      drv[0] = 6.0*r*t2-9.0/2.0*t4+9.0/10.0*t5-3.0/70.0*r-3.0/2.0*t2+6.0/5.0*t1
-9.0/35.0*s+6.0/455.0;
      drv[1] = t10;
      drv[2] = t10;
      drv[3] = 6.0*t11*s-3.0/2.0*t11-9.0/2.0*t9+6.0/5.0*t7+9.0/10.0*t5-9.0/35.0
*r-3.0/70.0*s+6.0/455.0;
   /* p=9 4 2 */
   } else if( i==4 && j==2 ) {
      t1 = r*r;
      t2 = s*s;
      t4 = t1*s;
      t6 = r*s;
      t8 = r*t1;
      t10 = 8.0*t8*s-3.0/2.0*t8-15.0/2.0*t4+3.0/2.0*t1+2.0*t6-3.0/7.0*r-s/7+3.0
/91.0;
      t11 = t1*t1;
      drv[0] = 12.0*t1*t2-9.0/2.0*t4+3.0/10.0*t1-15.0/2.0*r*t2+3.0*t6-3.0/14.0*
r+t2-3.0/7.0*s+3.0/91.0;
      drv[1] = t10;
      drv[2] = t10;
      drv[3] = 2.0*t11-5.0/2.0*t8+t1-r/7+1.0/182.0;
   /* p=9 5 1 */
   } else if( i==5 && j==1 ) {
      t1 = r*r;
      t2 = r*t1;
      t7 = t1*t1;
      t8 = 5.0*t7-15.0/2.0*t2+15.0/4.0*t1-5.0/7.0*r+15.0/364.0;
      drv[0] = 20.0*t2*s-5.0/2.0*t2-45.0/2.0*t1*s+3.0*t1+15.0/2.0*r*s-15.0/14.0
*r-5.0/7.0*s+10.0/91.0;
      drv[1] = t8;
      drv[2] = t8;
      drv[3] = 0.0;
   /* p=9 6 0 */
   } else if( i==6 && j==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      drv[0] = 30.0*t2-105.0/2.0*r*t1+63.0/2.0*t1-15.0/2.0*r+15.0/26.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 0.0;
   /* p=10 0 7 */
   } else if( i==0 && j==7 ) {
      t1 = s*s;
      t2 = t1*t1;
      drv[0] = 0.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 42.0*t2*s-280.0/3.0*t2+3920.0/51.0*t1*s-490.0/17.0*t1+245.0/51.0
*s-14.0/51.0;
   /* p=10 1 6 */
   } else if( i==1 && j==6 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = t1*s;
      t5 = 6.0*t2*s-35.0/3.0*t2+140.0/17.0*t4-175.0/68.0*t1+35.0/102.0*s-1.0/
68.0;
      drv[0] = 0.0;
      drv[1] = t5;
      drv[2] = t5;
      drv[3] = 30.0*r*t2-140.0/3.0*r*t4+420.0/17.0*r*t1-175.0/34.0*r*s+35.0/
102.0*r-10.0/3.0*t2+280.0/51.0*t4-105.0/34.0*t1+35.0/51.0*s-5.0/102.0;
   /* p=10 2 5 */
   } else if( i==2 && j==5 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = t1*s;
      t7 = r*t4;
      t8 = r*t1;
      t9 = r*s;
      t10 = 10.0*r*t2-40.0/3.0*t7+100.0/17.0*t8-50.0/51.0*t9+5.0/102.0*r-5.0/
3.0*t2+40.0/17.0*t4-75.0/68.0*t1+10.0/51.0*s-5.0/476.0;
      t11 = r*r;
      t15 = 20.0*t11*t4-20.0*t11*t1+100.0/17.0*t11*s-25.0/51.0*t11-20.0/3.0*t7+
120.0/17.0*t8-75.0/34.0*t9+10.0/51.0*r+20.0/51.0*t4-15.0/34.0*t1+5.0/34.0*s-5.0
/357.0;
      drv[0] = 2.0*t2*s-10.0/3.0*t2+100.0/51.0*t4-25.0/51.0*t1+5.0/102.0*s-1.0/
714.0;
      drv[1] = t10;
      drv[2] = t10;
      drv[3] = t15;
   /* p=10 3 4 */
   } else if( i==3 && j==4 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = t1*s;
      t5 = r*t4;
      t6 = r*t1;
      t7 = r*s;
      t9 = r*r;
      t11 = t9*t1;
      t12 = t9*s;
      t13 = 12.0*t9*t4-10.0*t11+40.0/17.0*t12-5.0/34.0*t9-16.0/3.0*t5+80.0/17.0
*t6-20.0/17.0*t7+4.0/51.0*r+8.0/17.0*t4-15.0/34.0*t1+2.0/17.0*s-1.0/119.0;
      t14 = t9*r;
      t17 = 12.0*t14*t1-20.0/3.0*t14*s+40.0/51.0*t14-8.0*t11+80.0/17.0*t12-10.0
/17.0*t9+24.0/17.0*t6-15.0/17.0*t7+2.0/17.0*r-t1/17+2.0/51.0*s-2.0/357.0;
      drv[0] = 6.0*r*t2-20.0/3.0*t5+40.0/17.0*t6-5.0/17.0*t7+r/102-4.0/3.0*t2+
80.0/51.0*t4-10.0/17.0*t1+4.0/51.0*s-1.0/357.0;
      drv[1] = t13;
      drv[2] = t13;
      drv[3] = t17;
   /* p=10 4 3 */
   } else if( i==4 && j==3 ) {
      t1 = r*r;
      t2 = s*s;
      t3 = t2*s;
      t5 = t1*t2;
      t6 = t1*s;
      t8 = r*t2;
      t9 = r*s;
      t10 = 12.0*t1*t3-8.0*t5+24.0/17.0*t6-t1/17-20.0/3.0*r*t3+80.0/17.0*t8
-15.0/17.0*t9+2.0/51.0*r+40.0/51.0*t3-10.0/17.0*t2+2.0/17.0*s-2.0/357.0;
      t11 = t1*r;
      t13 = t11*s;
      t14 = 12.0*t11*t2-16.0/3.0*t13+8.0/17.0*t11-10.0*t5+80.0/17.0*t6-15.0/
34.0*t1+40.0/17.0*t8-20.0/17.0*t9+2.0/17.0*r-5.0/34.0*t2+4.0/51.0*s-1.0/119.0;
      t15 = t1*t1;
      drv[0] = t10;
      drv[1] = t14;
      drv[2] = t14;
      drv[3] = 6.0*t15*s-4.0/3.0*t15-20.0/3.0*t13+80.0/51.0*t11+40.0/17.0*t6
-10.0/17.0*t1-5.0/17.0*t9+4.0/51.0*r+s/102-1.0/357.0;
   /* p=10 5 2 */
   } else if( i==5 && j==2 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = s*s;
      t5 = t2*s;
      t7 = t1*s;
      t9 = r*s;
      t10 = 20.0*t2*t3-20.0/3.0*t5+20.0/51.0*t2-20.0*t1*t3+120.0/17.0*t7-15.0/
34.0*t1+100.0/17.0*r*t3-75.0/34.0*t9+5.0/34.0*r-25.0/51.0*t3+10.0/51.0*s-5.0/
357.0;
      t11 = t1*t1;
      t13 = 10.0*t11*s-5.0/3.0*t11-40.0/3.0*t5+40.0/17.0*t2+100.0/17.0*t7-75.0/
68.0*t1-50.0/51.0*t9+10.0/51.0*r+5.0/102.0*s-5.0/476.0;
      drv[0] = t10;
      drv[1] = t13;
      drv[2] = t13;
      drv[3] = 2.0*t11*r-10.0/3.0*t11+100.0/51.0*t2-25.0/51.0*t1+5.0/102.0*r
-1.0/714.0;
   /* p=10 6 1 */
   } else if( i==6 && j==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t4 = t1*r;
      t10 = 6.0*r*t2-35.0/3.0*t2+140.0/17.0*t4-175.0/68.0*t1+35.0/102.0*r-1.0/
68.0;
      drv[0] = 30.0*t2*s-10.0/3.0*t2-140.0/3.0*t4*s+280.0/51.0*t4+420.0/17.0*t1
*s-105.0/34.0*t1-175.0/34.0*r*s+35.0/51.0*r+35.0/102.0*s-5.0/102.0;
      drv[1] = t10;
      drv[2] = t10;
      drv[3] = 0.0;
   /* p=10 7 0 */
   } else if( i==7 && j==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      drv[0] = 42.0*r*t2-280.0/3.0*t2+3920.0/51.0*t1*r-490.0/17.0*t1+245.0/51.0
*r-14.0/51.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 0.0;
   /* p=11 0 8 */
   } else if( i==0 && j==8 ) {
      t1 = s*s;
      t2 = t1*t1;
      drv[0] = 0.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 56.0*t2*t1-756.0/5.0*t2*s+3024.0/19.0*t2-1568.0/19.0*t1*s+7056.0
/323.0*t1-882.0/323.0*s+196.0/1615.0;
   /* p=11 1 7 */
   } else if( i==1 && j==7 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = t2*s;
      t5 = t1*s;
      t6 = 7.0*t2*t1-84.0/5.0*t4+294.0/19.0*t2-392.0/57.0*t5+490.0/323.0*t1
-49.0/323.0*s+49.0/9690.0;
      t12 = 42.0*r*t4-84.0*r*t2+1176.0/19.0*r*t5-392.0/19.0*t1*r+980.0/323.0*r*
s-49.0/323.0*r-21.0/5.0*t4+168.0/19.0*t2-392.0/57.0*t5+784.0/323.0*t1-245.0/
646.0*s+98.0/4845.0;
      drv[0] = 0.0;
      drv[1] = t6;
      drv[2] = t6;
      drv[3] = t12;
   /* p=11 2 6 */
   } else if( i==2 && j==6 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = t2*s;
      t5 = t1*s;
      t8 = r*t2;
      t9 = r*t5;
      t10 = t1*r;
      t11 = r*s;
      t12 = 12.0*r*t4-21.0*t8+252.0/19.0*t9-70.0/19.0*t10+140.0/323.0*t11-21.0/
1292.0*r-9.0/5.0*t4+63.0/19.0*t2-42.0/19.0*t5+210.0/323.0*t1-105.0/1292.0*s+
21.0/6460.0;
      t13 = r*r;
      t18 = 30.0*t13*t2-42.0*t13*t5+378.0/19.0*t13*t1-70.0/19.0*t13*s+70.0/
323.0*t13-9.0*t8+252.0/19.0*t9-126.0/19.0*t10+420.0/323.0*t11-105.0/1292.0*r+
9.0/19.0*t2-14.0/19.0*t5+126.0/323.0*t1-105.0/1292.0*s+7.0/1292.0;
      drv[0] = 2.0*t2*t1-21.0/5.0*t4+63.0/19.0*t2-70.0/57.0*t5+70.0/323.0*t1
-21.0/1292.0*s+7.0/19380.0;
      drv[1] = t12;
      drv[2] = t12;
      drv[3] = t18;
   /* p=11 3 5 */
   } else if( i==3 && j==5 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*s;
      t5 = r*t2;
      t6 = t1*s;
      t7 = r*t6;
      t8 = t1*r;
      t9 = r*s;
      t10 = 6.0*r*t3-9.0*t5+90.0/19.0*t7-20.0/19.0*t8+30.0/323.0*t9-3.0/1292.0*
r-6.0/5.0*t3+36.0/19.0*t2-20.0/19.0*t6+80.0/323.0*t1-15.0/646.0*s+1.0/1615.0;
      t11 = r*r;
      t13 = t11*t6;
      t14 = t11*t1;
      t15 = t11*s;
      t16 = 15.0*t11*t2-18.0*t13+135.0/19.0*t14-20.0/19.0*t15+15.0/323.0*t11
-6.0*t5+144.0/19.0*t7-60.0/19.0*t8+160.0/323.0*t9-15.0/646.0*r+9.0/19.0*t2-12.0
/19.0*t6+90.0/323.0*t1-15.0/323.0*s+3.0/1292.0;
      t17 = t11*r;
      t21 = 20.0*t17*t6-18.0*t17*t1+90.0/19.0*t17*s-20.0/57.0*t17-12.0*t13+
216.0/19.0*t14-60.0/19.0*t15+80.0/323.0*t11+36.0/19.0*t7-36.0/19.0*t8+180.0/
323.0*t9-15.0/323.0*r-4.0/57.0*t6+24.0/323.0*t1-15.0/646.0*s+2.0/969.0;
      drv[0] = t10;
      drv[1] = t16;
      drv[2] = t16;
      drv[3] = t21;
   /* p=11 4 4 */
   } else if( i==4 && j==4 ) {
      t1 = r*s;
      t2 = r*r;
      t3 = t2*s;
      t4 = s*s;
      t5 = t4*t4;
      t6 = t4*s;
      t7 = t2*t4;
      t8 = t2*t6;
      t10 = r*t6;
      t11 = r*t4;
      t13 = 80.0/323.0*t1-8.0/19.0*t3-5.0/646.0*r+12.0/19.0*t5-40.0/57.0*t6+1.0
/969.0+80.0/323.0*t4+72.0/19.0*t7-10.0/323.0*s-12.0*t8+12.0*t2*t5+120.0/19.0*
t10+4.0/323.0*t2-40.0/19.0*t11-6.0*r*t5;
      t14 = r*t2;
      t15 = t14*s;
      t16 = t14*t4;
      t18 = 40.0/323.0*t2+2.0/969.0-8.0/57.0*t14+48.0/19.0*t10-40.0/19.0*t11
-8.0/57.0*t6+40.0/323.0*t4+160.0/323.0*t1+48.0/19.0*t15-10.0/323.0*r-10.0/323.0
*s-12.0*t16+16.0*t14*t6+180.0/19.0*t7-40.0/19.0*t3-12.0*t8;
      t19 = t2*t2;
      t22 = -5.0/646.0*s+4.0/323.0*t4+1.0/969.0+72.0/19.0*t7-40.0/19.0*t3-8.0/
19.0*t11+80.0/323.0*t1+80.0/323.0*t2+12.0/19.0*t19-10.0/323.0*r-6.0*t19*s+12.0*
t19*t4+120.0/19.0*t15-40.0/57.0*t14-12.0*t16;
      drv[0] = t13;
      drv[1] = t18;
      drv[2] = t18;
      drv[3] = t22;
   /* p=11 5 3 */
   } else if( i==5 && j==3 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = s*s;
      t4 = t3*s;
      t6 = t2*t3;
      t7 = t2*s;
      t9 = t1*t3;
      t10 = t1*s;
      t12 = r*t3;
      t13 = r*s;
      t14 = 20.0*t2*t4-12.0*t6+36.0/19.0*t7-4.0/57.0*t2-18.0*t1*t4+216.0/19.0*
t9-36.0/19.0*t10+24.0/323.0*t1+90.0/19.0*r*t4-60.0/19.0*t12+180.0/323.0*t13
-15.0/646.0*r-20.0/57.0*t4+80.0/323.0*t3-15.0/323.0*s+2.0/969.0;
      t15 = t1*t1;
      t17 = t15*s;
      t18 = 15.0*t15*t3-6.0*t17+9.0/19.0*t15-18.0*t6+144.0/19.0*t7-12.0/19.0*t2
+135.0/19.0*t9-60.0/19.0*t10+90.0/323.0*t1-20.0/19.0*t12+160.0/323.0*t13-15.0/
323.0*r+15.0/323.0*t3-15.0/646.0*s+3.0/1292.0;
      t19 = t15*r;
      t21 = 6.0*t19*s-6.0/5.0*t19-9.0*t17+36.0/19.0*t15+90.0/19.0*t7-20.0/19.0*
t2-20.0/19.0*t10+80.0/323.0*t1+30.0/323.0*t13-15.0/646.0*r-3.0/1292.0*s+1.0/
1615.0;
      drv[0] = t14;
      drv[1] = t18;
      drv[2] = t18;
      drv[3] = t21;
   /* p=11 6 2 */
   } else if( i==6 && j==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = s*s;
      t5 = t2*s;
      t6 = t1*r;
      t8 = t6*s;
      t10 = t1*s;
      t12 = r*s;
      t13 = 30.0*t2*t3-9.0*t5+9.0/19.0*t2-42.0*t6*t3+252.0/19.0*t8-14.0/19.0*t6
+378.0/19.0*t1*t3-126.0/19.0*t10+126.0/323.0*t1-70.0/19.0*r*t3+420.0/323.0*t12
-105.0/1292.0*r+70.0/323.0*t3-105.0/1292.0*s+7.0/1292.0;
      t14 = r*t2;
      t16 = 12.0*t14*s-9.0/5.0*t14-21.0*t5+63.0/19.0*t2+252.0/19.0*t8-42.0/19.0
*t6-70.0/19.0*t10+210.0/323.0*t1+140.0/323.0*t12-105.0/1292.0*r-21.0/1292.0*s+
21.0/6460.0;
      drv[0] = t13;
      drv[1] = t16;
      drv[2] = t16;
      drv[3] = 2.0*t2*t1-21.0/5.0*t14+63.0/19.0*t2-70.0/57.0*t6+70.0/323.0*t1
-21.0/1292.0*r+7.0/19380.0;
   /* p=11 7 1 */
   } else if( i==7 && j==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = r*t2;
      t6 = t1*r;
      t10 = 42.0*t3*s-21.0/5.0*t3-84.0*t2*s+168.0/19.0*t2+1176.0/19.0*t6*s
-392.0/57.0*t6-392.0/19.0*t1*s+784.0/323.0*t1+980.0/323.0*r*s-245.0/646.0*r
-49.0/323.0*s+98.0/4845.0;
      t12 = 7.0*t2*t1-84.0/5.0*t3+294.0/19.0*t2-392.0/57.0*t6+490.0/323.0*t1
-49.0/323.0*r+49.0/9690.0;
      drv[0] = t10;
      drv[1] = t12;
      drv[2] = t12;
      drv[3] = 0.0;
   /* p=11 8 0 */
   } else if( i==8 && j==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      drv[0] = 56.0*t2*t1-756.0/5.0*r*t2+3024.0/19.0*t2-1568.0/19.0*t1*r+7056.0
/323.0*t1-882.0/323.0*r+196.0/1615.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 0.0;
   /* p=12 0 9 */
   } else if( i==0 && j==9 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      drv[0] = 0.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 72.0*t2*t3-2520.0/11.0*t1*t3+3240.0/11.0*t3*s-2160.0/11.0*t3+
15120.0/209.0*t2-3024.0/209.0*t1+5040.0/3553.0*s-180.0/3553.0;
   /* p=12 1 8 */
   } else if( i==1 && j==8 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t5 = t3*t1;
      t6 = t3*s;
      t7 = 8.0*t3*t2-252.0/11.0*t5+288.0/11.0*t6-168.0/11.0*t3+1008.0/209.0*t2
-168.0/209.0*t1+224.0/3553.0*s-6.0/3553.0;
      t14 = 56.0*r*t5-1512.0/11.0*r*t6+1440.0/11.0*r*t3-672.0/11.0*r*t2+3024.0/
209.0*r*t1-336.0/209.0*r*s+224.0/3553.0*r-56.0/11.0*t5+144.0/11.0*t6-144.0/11.0
*t3+1344.0/209.0*t2-336.0/209.0*t1+672.0/3553.0*s-28.0/3553.0;
      drv[0] = 0.0;
      drv[1] = t7;
      drv[2] = t7;
      drv[3] = t14;
   /* p=12 2 7 */
   } else if( i==2 && j==7 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t5 = t3*t1;
      t6 = t3*s;
      t9 = r*t6;
      t10 = r*t3;
      t11 = r*t2;
      t12 = r*t1;
      t13 = r*s;
      t14 = 14.0*r*t5-336.0/11.0*t9+280.0/11.0*t10-112.0/11.0*t11+420.0/209.0*
t12-112.0/627.0*t13+56.0/10659.0*r-21.0/11.0*t5+48.0/11.0*t6-42.0/11.0*t3+336.0
/209.0*t2-70.0/209.0*t1+112.0/3553.0*s-7.0/7106.0;
      t15 = r*r;
      t21 = 42.0*t15*t6-840.0/11.0*t15*t3+560.0/11.0*t15*t2-168.0/11.0*t15*t1+
420.0/209.0*t15*s-56.0/627.0*t15-126.0/11.0*t9+240.0/11.0*t10-168.0/11.0*t11+
1008.0/209.0*t12-140.0/209.0*t13+112.0/3553.0*r+6.0/11.0*t6-12.0/11.0*t3+168.0/
209.0*t2-56.0/209.0*t1+140.0/3553.0*s-7.0/3553.0;
      drv[0] = 2.0*t3*t2-56.0/11.0*t5+56.0/11.0*t6-28.0/11.0*t3+140.0/209.0*t2
-56.0/627.0*t1+56.0/10659.0*s-1.0/10659.0;
      drv[1] = t14;
      drv[2] = t14;
      drv[3] = t21;
   /* p=12 3 6 */
   } else if( i==3 && j==6 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*s;
      t4 = t2*t1;
      t5 = t1*s;
      t6 = r*t2;
      t7 = r*t1;
      t8 = r*t5;
      t9 = r*t3;
      t10 = r*s;
      t12 = 24.0/11.0*t3-18.0/11.0*t2-1.0/7106.0-12.0/11.0*t4+24.0/3553.0*s
-20.0/209.0*t1+120.0/209.0*t5+90.0/11.0*t6+90.0/209.0*t7-30.0/11.0*t8-126.0/
11.0*t9-6.0/209.0*t10+2.0/3553.0*r+6.0*r*t4;
      t13 = r*r;
      t14 = t13*t5;
      t15 = t13*s;
      t16 = t13*t1;
      t17 = t13*t2;
      t19 = -9.0/14212.0+120.0/11.0*t6+60.0/3553.0*s-72.0/11.0*t8-72.0/11.0*t9+
24.0/3553.0*r-40.0/209.0*t10+360.0/209.0*t7+180.0/11.0*t14+90.0/209.0*t15-45.0/
11.0*t16-315.0/11.0*t17+36.0/77.0*t3-3.0/209.0*t13+18.0*t13*t3-9.0/11.0*t2+
108.0/209.0*t5-30.0/209.0*t1;
      t20 = t13*r;
      t25 = -5.0/7106.0+240.0/11.0*t14+60.0/3553.0*r-108.0/11.0*t16-180.0/11.0*
t17-20.0/209.0*t13+360.0/209.0*t15+40.0/3553.0*s+180.0/11.0*t20*t1+30.0/209.0*
t20-12.0/209.0*t1-30.0/11.0*t20*s-420.0/11.0*t20*t5+180.0/77.0*t6-6.0/77.0*t2+
24.0/209.0*t5+30.0*t20*t2-36.0/11.0*t8+324.0/209.0*t7-60.0/209.0*t10;
      drv[0] = t12;
      drv[1] = t19;
      drv[2] = t19;
      drv[3] = t25;
   /* p=12 4 5 */
   } else if( i==4 && j==5 ) {
      t1 = r*r;
      t2 = s*s;
      t3 = t2*s;
      t4 = t1*t3;
      t5 = t2*t2;
      t6 = t1*t5;
      t7 = t5*s;
      t8 = t1*s;
      t10 = r*t5;
      t11 = r*t2;
      t12 = r*t3;
      t14 = r*s;
      t15 = t2*t1;
      t16 = 600.0/77.0*t4-180.0/11.0*t6+40.0/77.0*t7-60.0/77.0*t5+180.0/1463.0*
t8-5.0/24871.0+12.0*t1*t7-4.0/1463.0*t1+200.0/24871.0*s-400.0/4389.0*t2+600.0/
1463.0*t3+600.0/77.0*t10+1200.0/1463.0*t11-300.0/77.0*t12-60.0/11.0*r*t7-100.0/
1463.0*t14-120.0/77.0*t15+40.0/24871.0*r;
      t17 = t1*r;
      t18 = t17*t2;
      t19 = t17*t3;
      t21 = t17*s;
      t22 = -25.0/49742.0+600.0/77.0*t18-240.0/11.0*t19+200.0/77.0*t10+800.0/
74613.0*s-240.0/77.0*t12+60.0/1463.0*t17+20.0*t17*t5+200.0/24871.0*r-800.0/
4389.0*t14+1800.0/1463.0*t11+1200.0/77.0*t4+1200.0/1463.0*t8-450.0/77.0*t15
-150.0/11.0*t6-50.0/1463.0*t1-80.0/77.0*t21-10.0/77.0*t5+240.0/1463.0*t3-100.0/
1463.0*t2;
      t23 = t1*t1;
      t27 = -25.0/74613.0+800.0/74613.0*r+100.0/24871.0*s-180.0/11.0*t23*t2+
20.0*t23*t3-200.0/1463.0*t14+400.0/77.0*t4-20.0/77.0*t23-400.0/4389.0*t1+1800.0
/1463.0*t8-360.0/77.0*t15-20.0/1463.0*t2-200.0/11.0*t19-300.0/77.0*t21+20.0/
1463.0*t3+1200.0/77.0*t18+400.0/1463.0*t17+300.0/77.0*t23*s-40.0/77.0*t12+720.0
/1463.0*t11;
      drv[0] = t16;
      drv[1] = t22;
      drv[2] = t22;
      drv[3] = t27;
   /* p=12 5 4 */
   } else if( i==5 && j==4 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = s*s;
      t4 = t3*s;
      t5 = t2*t4;
      t6 = t3*t3;
      t9 = t2*s;
      t10 = r*s;
      t11 = r*t3;
      t12 = r*t4;
      t14 = t1*t3;
      t15 = t1*t4;
      t16 = t1*s;
      t17 = t2*t3;
      t18 = -25.0/74613.0+800.0/74613.0*s-200.0/11.0*t5+20.0*t2*t6-400.0/4389.0
*t3+300.0/77.0*r*t6-40.0/77.0*t9+100.0/24871.0*r+20.0/1463.0*t2-200.0/1463.0*
t10+1800.0/1463.0*t11-300.0/77.0*t12-180.0/11.0*t1*t6-360.0/77.0*t14+1200.0/
77.0*t15+720.0/1463.0*t16+400.0/77.0*t17-20.0/1463.0*t1-20.0/77.0*t6+400.0/
1463.0*t4;
      t19 = t1*t1;
      t20 = t19*t3;
      t22 = t19*s;
      t23 = -25.0/49742.0+800.0/74613.0*r+200.0/24871.0*s-150.0/11.0*t20+20.0*
t19*t4-800.0/4389.0*t10+600.0/77.0*t15-10.0/77.0*t19-100.0/1463.0*t1+1800.0/
1463.0*t16-450.0/77.0*t14-50.0/1463.0*t3-240.0/11.0*t5-240.0/77.0*t9+60.0/
1463.0*t4+1200.0/77.0*t17+240.0/1463.0*t2+200.0/77.0*t22-80.0/77.0*t12+1200.0/
1463.0*t11;
      t24 = t19*r;
      t27 = -60.0/11.0*t24*s-5.0/24871.0+600.0/77.0*t22-180.0/11.0*t20+200.0/
24871.0*r-120.0/77.0*t14+40.0/77.0*t24-400.0/4389.0*t1+1200.0/1463.0*t16+12.0*
t24*t3+40.0/24871.0*s+600.0/77.0*t17+600.0/1463.0*t2-4.0/1463.0*t3-300.0/77.0*
t9-60.0/77.0*t19+180.0/1463.0*t11-100.0/1463.0*t10;
      drv[0] = t18;
      drv[1] = t23;
      drv[2] = t23;
      drv[3] = t27;
   /* p=12 6 3 */
   } else if( i==6 && j==3 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = s*s;
      t4 = t3*s;
      t7 = t2*s;
      t8 = t1*s;
      t9 = t2*t3;
      t10 = r*t3;
      t11 = t1*t1;
      t12 = t11*s;
      t14 = t11*t3;
      t16 = r*s;
      t17 = t1*t3;
      t18 = -420.0/11.0*t2*t4+180.0/11.0*t1*t4-36.0/11.0*t7+324.0/209.0*t8-5.0/
7106.0+240.0/11.0*t9-12.0/209.0*t1+60.0/3553.0*s-20.0/209.0*t3+30.0/209.0*t4+
24.0/209.0*t2+360.0/209.0*t10+180.0/77.0*t12-6.0/77.0*t11-30.0/11.0*r*t4-180.0/
11.0*t14+30.0*t11*t4-60.0/209.0*t16-108.0/11.0*t17+40.0/3553.0*r;
      t19 = t11*r;
      t20 = t19*s;
      t22 = -315.0/11.0*t14-9.0/14212.0+180.0/11.0*t9+24.0/3553.0*s-9.0/11.0*
t11+108.0/209.0*t2+120.0/11.0*t12+60.0/3553.0*r-40.0/209.0*t16+90.0/209.0*t10+
360.0/209.0*t8+36.0/77.0*t19-45.0/11.0*t17-72.0/11.0*t20+18.0*t19*t3-30.0/209.0
*t1-72.0/11.0*t7-3.0/209.0*t3;
      t23 = t11*t1;
      t25 = -126.0/11.0*t20-1.0/7106.0+90.0/11.0*t12+24.0/3553.0*r+24.0/11.0*
t19-20.0/209.0*t1+90.0/209.0*t8+2.0/3553.0*s+120.0/209.0*t2-30.0/11.0*t7-12.0/
11.0*t23+6.0*t23*s-18.0/11.0*t11-6.0/209.0*t16;
      drv[0] = t18;
      drv[1] = t22;
      drv[2] = t22;
      drv[3] = t25;
   /* p=12 7 2 */
   } else if( i==7 && j==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = s*s;
      t6 = t3*s;
      t8 = t2*s;
      t9 = t1*r;
      t11 = t9*s;
      t13 = t1*s;
      t15 = r*s;
      t16 = 42.0*t3*t4-126.0/11.0*t6+6.0/11.0*t3-840.0/11.0*t2*t4+240.0/11.0*t8
-12.0/11.0*t2+560.0/11.0*t9*t4-168.0/11.0*t11+168.0/209.0*t9-168.0/11.0*t1*t4+
1008.0/209.0*t13-56.0/209.0*t1+420.0/209.0*r*t4-140.0/209.0*t15+140.0/3553.0*r
-56.0/627.0*t4+112.0/3553.0*s-7.0/3553.0;
      t17 = t2*t1;
      t19 = 14.0*t17*s-21.0/11.0*t17-336.0/11.0*t6+48.0/11.0*t3+280.0/11.0*t8
-42.0/11.0*t2-112.0/11.0*t11+336.0/209.0*t9+420.0/209.0*t13-70.0/209.0*t1-112.0
/627.0*t15+112.0/3553.0*r+56.0/10659.0*s-7.0/7106.0;
      drv[0] = t16;
      drv[1] = t19;
      drv[2] = t19;
      drv[3] = 2.0*t2*t9-56.0/11.0*t17+56.0/11.0*t3-28.0/11.0*t2+140.0/209.0*t9
-56.0/627.0*t1+56.0/10659.0*r-1.0/10659.0;
   /* p=12 8 1 */
   } else if( i==8 && j==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t5 = t2*r;
      t8 = t1*r;
      t12 = 56.0*t3*s-56.0/11.0*t3-1512.0/11.0*t5*s+144.0/11.0*t5+1440.0/11.0*
t2*s-144.0/11.0*t2-672.0/11.0*t8*s+1344.0/209.0*t8+3024.0/209.0*t1*s-336.0/
209.0*t1-336.0/209.0*r*s+672.0/3553.0*r+224.0/3553.0*s-28.0/3553.0;
      t14 = 8.0*t2*t8-252.0/11.0*t3+288.0/11.0*t5-168.0/11.0*t2+1008.0/209.0*t8
-168.0/209.0*t1+224.0/3553.0*r-6.0/3553.0;
      drv[0] = t12;
      drv[1] = t14;
      drv[2] = t14;
      drv[3] = 0.0;
   /* p=12 9 0 */
   } else if( i==9 && j==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      drv[0] = 72.0*t3*t2-2520.0/11.0*t3*t1+3240.0/11.0*t3*r-2160.0/11.0*t3+
15120.0/209.0*t2-3024.0/209.0*t1+5040.0/3553.0*r-180.0/3553.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 0.0;
   /* p=13 0 10 */
   } else if( i==0 && j==10 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*s;
      drv[0] = 0.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 90.0*t3-330.0*t2*t4+11550.0/23.0*t2*t1-9450.0/23.0*t2*s+4500.0/
23.0*t2-1260.0/23.0*t4+3780.0/437.0*t1-300.0/437.0*s+150.0/7429.0;
   /* p=13 1 9 */
   } else if( i==1 && j==9 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*s;
      t5 = t2*t4;
      t6 = t2*t1;
      t7 = t2*s;
      t8 = 9.0*t3-30.0*t5+945.0/23.0*t6-7560.0/253.0*t7+3150.0/253.0*t2-756.0/
253.0*t4+1890.0/4807.0*t1-120.0/4807.0*s+45.0/81719.0;
      t16 = 72.0*r*t5-210.0*r*t6+5670.0/23.0*r*t7-37800.0/253.0*r*t2+12600.0/
253.0*r*t4-2268.0/253.0*r*t1+3780.0/4807.0*r*s-120.0/4807.0*r-6.0*t5+420.0/23.0
*t6-5670.0/253.0*t7+3600.0/253.0*t2-1260.0/253.0*t4+4536.0/4807.0*t1-420.0/
4807.0*s+240.0/81719.0;
      drv[0] = 0.0;
      drv[1] = t8;
      drv[2] = t8;
      drv[3] = t16;
   /* p=13 2 8 */
   } else if( i==2 && j==8 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*s;
      t4 = t2*t1;
      t5 = t1*s;
      t6 = t2*t5;
      t7 = t2*t2;
      t9 = r*t2;
      t10 = r*t3;
      t11 = r*t4;
      t13 = r*s;
      t14 = r*t1;
      t15 = r*t5;
      t16 = 840.0/253.0*t2+126.0/23.0*t4+24.0/81719.0-1512.0/253.0*t3-2.0*t6
-56.0/4807.0*s+756.0/4807.0*t1-5880.0/253.0*t9-252.0/253.0*t5+1008.0/23.0*t10
-42.0*t11+16.0*r*t6-8.0/4807.0*r+336.0/4807.0*t13-252.0/253.0*t14+1680.0/253.0*
t15;
      t17 = r*r;
      t25 = -126.0*t17*t3+56.0*t17*t4+360.0/253.0*t2+168.0/4807.0*t17+14.0/23.0
*t4-378.0/253.0*t3-252.0/253.0*t17*s+2520.0/253.0*t17*t1-168.0/253.0*t5+756.0/
4807.0*t1-84.0/4807.0*s;
      drv[0] = 2.0/81719.0-1176.0/253.0*t3+168.0/23.0*t4-6.0*t6+2.0*t7-8.0/
4807.0*s+168.0/4807.0*t1-84.0/253.0*t5+420.0/253.0*t2;
      drv[1] = t16;
      drv[2] = t16;
      drv[3] = 56.0/81719.0+3360.0/253.0*t15+756.0/23.0*t10-7560.0/253.0*t9
-14.0*t11-56.0/4807.0*r+1512.0/4807.0*t13-11760.0/253.0*t17*t5-756.0/253.0*t14+
2520.0/23.0*t17*t2+t25;
   /* p=13 3 7 */
   } else if( i==3 && j==7 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t4 = t3*t2;
      t6 = t3*s;
      t7 = r*t6;
      t8 = t3*t1;
      t9 = r*t8;
      t10 = r*t2;
      t11 = r*s;
      t12 = r*t3;
      t13 = r*t1;
      t14 = 6.0*r*t4+294.0/23.0*t7-14.0*t9+350.0/253.0*t10+8.0/245157.0+42.0/
4807.0*t11-1470.0/253.0*t12-42.0/253.0*t13-588.0/253.0*t6+56.0/23.0*t8-2.0/
14421.0*r-t4-28.0/14421.0*s+168.0/4807.0*t1-70.0/253.0*t2+280.0/253.0*t3;
      t15 = r*r;
      t17 = t15*t3;
      t18 = t15*t6;
      t19 = t15*t1;
      t21 = t15*t2;
      t22 = t15*s;
      t23 = -2940.0/253.0*t21-42.0/253.0*t22+315.0/4807.0*t1-2940.0/253.0*t12
-84.0/253.0*t2+336.0/23.0*t7-7.0*t9-28.0/14421.0*r+336.0/4807.0*t11-210.0/253.0
*t13+1120.0/253.0*t10;
      t24 = 21.0*t15*t8+735.0/23.0*t17-42.0*t18+210.0/253.0*t3+525.0/253.0*t19+
21.0/46.0*t8+14.0/81719.0-252.0/253.0*t6+21.0/4807.0*t15-28.0/4807.0*s+t23;
      t25 = t15*r;
      t31 = 56.0/245157.0-70.0/14421.0*s-70.0*t25*t3+42.0*t25*t6-1260.0/253.0*
t12-2940.0/253.0*t25*t1-28.0/4807.0*r+63.0/23.0*t7-14.0/253.0*t25+630.0/4807.0*
t11+980.0/23.0*t25*t2+350.0/253.0*t25*s;
      t32 = -252.0/253.0*t13+840.0/23.0*t17+840.0/253.0*t10-21.0*t18-21.0/253.0
*t6+168.0/4807.0*t15-210.0/253.0*t22+1680.0/253.0*t19-5880.0/253.0*t21+40.0/
253.0*t3-28.0/253.0*t2+168.0/4807.0*t1;
      drv[0] = t14;
      drv[1] = t24;
      drv[2] = t24;
      drv[3] = t31+t32;
   /* p=13 4 6 */
   } else if( i==4 && j==6 ) {
      t1 = r*r;
      t2 = s*s;
      t3 = t2*t2;
      t4 = t3*s;
      t5 = t1*t4;
      t6 = t3*t2;
      t8 = t2*s;
      t9 = t1*t8;
      t10 = t1*s;
      t12 = t3*t1;
      t13 = t1*t2;
      t14 = r*t4;
      t16 = r*s;
      t17 = r*t2;
      t18 = r*t8;
      t19 = r*t3;
      t20 = 315.0/23.0*t12+150.0/253.0*t13-50.0/253.0*t8+210.0/23.0*t14+150.0/
253.0*t3-5.0*r*t6+3.0/4807.0*t1+90.0/4807.0*t16-75.0/253.0*t17+500.0/253.0*t18
-1575.0/253.0*t19;
      t22 = r*t1;
      t23 = t22*t3;
      t25 = t22*t2;
      t26 = t22*t8;
      t27 = t22*s;
      t28 = 10.0/81719.0-50.0/14421.0*s-35.0*t23+24.0*t22*t4-1050.0/253.0*t19
-1050.0/253.0*t25-10.0/4807.0*r+60.0/23.0*t14-3.0/253.0*t22+300.0/4807.0*t16+
420.0/23.0*t26+100.0/253.0*t27;
      t29 = -150.0/253.0*t17+525.0/23.0*t12+600.0/253.0*t18-15.0*t5-30.0/253.0*
t4+45.0/4807.0*t1-75.0/253.0*t10+750.0/253.0*t13-3150.0/253.0*t9+50.0/253.0*t3
-30.0/253.0*t8+150.0/4807.0*t2;
      t30 = t28+t29;
      t31 = 25.0/245157.0+700.0/23.0*t26+500.0/253.0*t27-25.0/253.0*t22-25.0*
t23+25.0/1771.0*t3+45.0/4807.0*t2+150.0/23.0*t12-150.0/253.0*t10+900.0/253.0*
t13+300.0/4807.0*t16-90.0/253.0*t17;
      t32 = t1*t1;
      t37 = 200.0/253.0*t18-150.0/253.0*t19-3150.0/253.0*t25+150.0/4807.0*t1
-5.0/253.0*t8-25.0/14421.0*s-50.0/14421.0*r+25.0/253.0*t32+30.0*t32*t3-35.0*t32
*t8-525.0/253.0*t32*s+315.0/23.0*t32*t2-2100.0/253.0*t9;
      drv[0] = 10.0/245157.0-21.0*t5+12.0*t1*t6-210.0/253.0*t4-1050.0/253.0*t9
-10.0/4807.0*s+10.0/23.0*t6-5.0/14421.0*r-9.0/253.0*t10+150.0/4807.0*t2+t20;
      drv[1] = t30;
      drv[2] = t30;
      drv[3] = t31+t37;
   /* p=13 5 5 */
   } else if( i==5 && j==5 ) {
      t1 = r*r;
      t2 = s*s;
      t3 = t2*t2;
      t4 = t3*s;
      t6 = t2*s;
      t7 = t1*t6;
      t8 = r*t1;
      t9 = t1*s;
      t10 = t8*t3;
      t11 = t3*t1;
      t13 = 100.0/1716099.0-15.0*t1*t4-50.0/253.0*t4-2250.0/253.0*t7-250.0/
100947.0*s-25.0/33649.0*r-5.0/1771.0*t8-225.0/1771.0*t9-25.0*t10+1000.0/33649.0
*t2+450.0/23.0*t11+20.0*t8*t4;
      t14 = t8*t6;
      t15 = t8*s;
      t16 = t8*t2;
      t17 = t1*t2;
      t19 = r*s;
      t20 = r*t2;
      t21 = r*t6;
      t22 = r*t3;
      t23 = 250.0/23.0*t14+250.0/1771.0*t15-500.0/253.0*t16+3000.0/1771.0*t17
-250.0/1771.0*t6+75.0/23.0*r*t4+500.0/1771.0*t3+90.0/33649.0*t1+1125.0/33649.0*
t19-750.0/1771.0*t20+3750.0/1771.0*t21-1125.0/253.0*t22;
      t25 = t1*t1;
      t27 = t25*t6;
      t28 = t25*s;
      t29 = t25*t2;
      t30 = 1125.0/67298.0*t1+25.0*t25*t3+125.0/3542.0*t25-25.0*t27-250.0/253.0
*t28+375.0/46.0*t29-250.0/253.0*t22+2000.0/33649.0*t19-750.0/1771.0*t20+2000.0/
1771.0*t21+1125.0/67298.0*t2+125.0/3542.0*t3;
      t31 = -75.0/1771.0*t8-750.0/1771.0*t9-25.0*t10+375.0/46.0*t11+600.0/23.0*
t14+2000.0/1771.0*t15-2250.0/253.0*t16+5625.0/1771.0*t17-75.0/1771.0*t6-250.0/
100947.0*s-250.0/100947.0*r-2250.0/253.0*t7+125.0/1144066.0;
      t32 = t30+t31;
      t33 = t25*r;
      t37 = 20.0*t33*t6+75.0/23.0*t33*s+100.0/1716099.0-15.0*t33*t2-50.0/253.0*
t33-25.0/33649.0*s-2250.0/253.0*t16-250.0/100947.0*r-250.0/1771.0*t8-25.0*t27+
1125.0/33649.0*t19+250.0/23.0*t14;
      t38 = 450.0/23.0*t29+500.0/1771.0*t25-1125.0/253.0*t28+3750.0/1771.0*t15
-225.0/1771.0*t20+250.0/1771.0*t21+1000.0/33649.0*t1-750.0/1771.0*t9+3000.0/
1771.0*t17-500.0/253.0*t7-5.0/1771.0*t6+90.0/33649.0*t2;
      drv[0] = t13+t23;
      drv[1] = t32;
      drv[2] = t32;
      drv[3] = t37+t38;
   /* p=13 6 4 */
   } else if( i==6 && j==4 ) {
      t1 = r*r;
      t2 = s*s;
      t3 = t1*t2;
      t4 = t2*t2;
      t6 = t1*t1;
      t8 = t1*r;
      t9 = t2*s;
      t10 = 25.0/245157.0+900.0/253.0*t3-525.0/253.0*r*t4+25.0/253.0*t4+30.0*t6
*t4+25.0/1771.0*t6+45.0/4807.0*t1-5.0/253.0*t8-25.0/253.0*t9-50.0/14421.0*s+
150.0/4807.0*t2-25.0/14421.0*r;
      t11 = t8*t9;
      t12 = r*s;
      t13 = t8*s;
      t14 = r*t2;
      t16 = t6*t9;
      t17 = t6*s;
      t18 = t6*t2;
      t19 = t8*t2;
      t20 = r*t9;
      t21 = t1*s;
      t22 = t1*t9;
      t24 = 700.0/23.0*t11+300.0/4807.0*t12+200.0/253.0*t13-150.0/253.0*t14
-35.0*t8*t4-25.0*t16-150.0/253.0*t17+150.0/23.0*t18-2100.0/253.0*t19+500.0/
253.0*t20-90.0/253.0*t21-3150.0/253.0*t22+315.0/23.0*t1*t4;
      t26 = t6*r;
      t28 = t26*s;
      t29 = t26*t2;
      t30 = 24.0*t26*t9+60.0/23.0*t28+10.0/81719.0-15.0*t29-30.0/253.0*t26-10.0
/4807.0*s-3150.0/253.0*t19-50.0/14421.0*r-30.0/253.0*t8-35.0*t16+300.0/4807.0*
t12+420.0/23.0*t11;
      t31 = 525.0/23.0*t18+50.0/253.0*t6-1050.0/253.0*t17+600.0/253.0*t13-75.0/
253.0*t14+100.0/253.0*t20+150.0/4807.0*t1-150.0/253.0*t21+750.0/253.0*t3-1050.0
/253.0*t22-3.0/253.0*t9+45.0/4807.0*t2;
      t32 = t30+t31;
      t33 = t6*t1;
      t37 = 90.0/4807.0*t12+315.0/23.0*t18+150.0/253.0*t6-1575.0/253.0*t17+
500.0/253.0*t13-9.0/253.0*t14+150.0/4807.0*t1-75.0/253.0*t21+150.0/253.0*t3-5.0
*t33*s+3.0/4807.0*t2;
      drv[0] = t10+t24;
      drv[1] = t32;
      drv[2] = t32;
      drv[3] = 210.0/23.0*t28+10.0/245157.0-21.0*t29-210.0/253.0*t26-5.0/
14421.0*s-1050.0/253.0*t19+12.0*t33*t2-10.0/4807.0*r-50.0/253.0*t8+10.0/23.0*
t33+t37;
   /* p=13 7 3 */
   } else if( i==7 && j==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = s*s;
      t4 = t2*t3;
      t5 = t3*s;
      t7 = t2*s;
      t9 = t2*r;
      t11 = t1*r;
      t12 = t1*s;
      t13 = t9*s;
      t14 = 840.0/23.0*t4+56.0/245157.0-70.0*t2*t5-1260.0/253.0*t7-2940.0/253.0
*t1*t5+42.0*t9*t5-28.0/4807.0*s-70.0/14421.0*r-28.0/253.0*t11-252.0/253.0*t12+
63.0/23.0*t13+40.0/253.0*t2;
      t16 = t11*s;
      t17 = t11*t3;
      t18 = t1*t3;
      t19 = r*s;
      t20 = r*t3;
      t22 = t9*t3;
      t23 = 168.0/4807.0*t3+980.0/23.0*t11*t5+840.0/253.0*t16-5880.0/253.0*t17+
1680.0/253.0*t18-14.0/253.0*t5-21.0/253.0*t9+168.0/4807.0*t1+630.0/4807.0*t19
-210.0/253.0*t20+350.0/253.0*r*t5-21.0*t22;
      t25 = t2*t1;
      t28 = t25*s;
      t29 = 336.0/4807.0*t19+735.0/23.0*t4+210.0/253.0*t2-2940.0/253.0*t7+
1120.0/253.0*t16-42.0/253.0*t20+315.0/4807.0*t1-210.0/253.0*t12+525.0/253.0*t18
-7.0*t28+21.0/4807.0*t3;
      t30 = 336.0/23.0*t13+14.0/81719.0-42.0*t22-252.0/253.0*t9-28.0/14421.0*s
-2940.0/253.0*t17+21.0*t25*t3-28.0/4807.0*r-84.0/253.0*t11+21.0/46.0*t25+t29;
      t31 = t2*t11;
      t33 = -588.0/253.0*t9+294.0/23.0*t13+8.0/245157.0+350.0/253.0*t16-14.0*
t28-28.0/14421.0*r-1470.0/253.0*t7-t31+280.0/253.0*t2-70.0/253.0*t11+42.0/
4807.0*t19+168.0/4807.0*t1-42.0/253.0*t12+56.0/23.0*t25-2.0/14421.0*s+6.0*t31*s
;
      drv[0] = t14+t23;
      drv[1] = t30;
      drv[2] = t30;
      drv[3] = t33;
   /* p=13 8 2 */
   } else if( i==8 && j==2 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = s*s;
      t5 = t2*s;
      t6 = r*s;
      t7 = t1*t1;
      t8 = t7*s;
      t9 = t7*t1;
      t11 = t7*r;
      t13 = t1*s;
      t17 = t11*s;
      t19 = t9*s;
      t20 = 2520.0/253.0*t1*t3-252.0/253.0*r*t3+360.0/253.0*t7-84.0/4807.0*r
-378.0/253.0*t11-56.0/4807.0*s+168.0/4807.0*t3+756.0/23.0*t17+2520.0/23.0*t7*t3
-14.0*t19+14.0/23.0*t9;
      t22 = t7*t2;
      t24 = -5880.0/253.0*t8+840.0/253.0*t7+24.0/81719.0+756.0/4807.0*t1-1512.0
/253.0*t11+16.0*t22*s-8.0/4807.0*s-42.0*t19-252.0/253.0*t2+1680.0/253.0*t5
-252.0/253.0*t13-56.0/4807.0*r+336.0/4807.0*t6+126.0/23.0*t9+1008.0/23.0*t17
-2.0*t22;
      t25 = t7*t7;
      drv[0] = -11760.0/253.0*t2*t3+3360.0/253.0*t5+56.0/81719.0+756.0/4807.0*
t1+1512.0/4807.0*t6-7560.0/253.0*t8+56.0*t9*t3-168.0/253.0*t2-126.0*t11*t3
-756.0/253.0*t13+t20;
      drv[1] = t24;
      drv[2] = t24;
      drv[3] = -1176.0/253.0*t11+2.0/81719.0+2.0*t25-8.0/4807.0*r-6.0*t22+420.0
/253.0*t7-84.0/253.0*t2+168.0/4807.0*t1+168.0/23.0*t9;
   /* p=13 9 1 */
   } else if( i==9 && j==1 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t4 = t2*t3;
      t6 = t1*t3;
      t8 = r*t3;
      t14 = 72.0*t4*s-6.0*t4-210.0*t6*s+420.0/23.0*t6+5670.0/23.0*t8*s-5670.0/
253.0*t8-37800.0/253.0*t3*s+3600.0/253.0*t3+12600.0/253.0*t2*s-1260.0/253.0*t2
-2268.0/253.0*t1*s+4536.0/4807.0*t1+3780.0/4807.0*r*s-420.0/4807.0*r-120.0/
4807.0*s+240.0/81719.0;
      t15 = t3*t3;
      t16 = 9.0*t15-30.0*t4+945.0/23.0*t6-7560.0/253.0*t8+3150.0/253.0*t3-756.0
/253.0*t2+1890.0/4807.0*t1-120.0/4807.0*r+45.0/81719.0;
      drv[0] = t14;
      drv[1] = t16;
      drv[2] = t16;
      drv[3] = 0.0;
   /* p=13 10 0 */
   } else if( i==10 && j==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*r;
      drv[0] = 90.0*t3-330.0*t2*t4+11550.0/23.0*t2*t1-9450.0/23.0*t2*r+4500.0/
23.0*t2-1260.0/23.0*t4+3780.0/437.0*t1-300.0/437.0*r+150.0/7429.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 0.0;
   /* p=14 0 11 */
   } else if( i==0 && j==11 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*s;
      drv[0] = 0.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 110.0*t3*s-5940.0/13.0*t3+52272.0/65.0*t2*t5-10164.0/13.0*t2*t1+
137214.0/299.0*t2*s-49896.0/299.0*t2+11088.0/299.0*t5-7128.0/1495.0*t1+1782.0/
5681.0*s-44.0/5681.0;
   /* p=14 1 10 */
   } else if( i==1 && j==10 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*s;
      t6 = t2*t5;
      t7 = t2*t1;
      t8 = t2*s;
      t9 = 10.0*t3*s-495.0/13.0*t3+792.0/13.0*t6-693.0/13.0*t7+8316.0/299.0*t8
-2646.0/299.0*t2+504.0/299.0*t5-54.0/299.0*t1+54.0/5681.0*s-1.0/5681.0;
      t18 = 90.0*r*t3-3960.0/13.0*r*t6+5544.0/13.0*r*t7-4158.0/13.0*r*t8+
41580.0/299.0*t2*r-10584.0/299.0*r*t5+1512.0/299.0*t1*r-108.0/299.0*r*s+54.0/
5681.0*r-90.0/13.0*t3+1584.0/65.0*t6-462.0/13.0*t7+8316.0/299.0*t8-3780.0/299.0
*t2+1008.0/299.0*t5-756.0/1495.0*t1+216.0/5681.0*s-6.0/5681.0;
      drv[0] = 0.0;
      drv[1] = t9;
      drv[2] = t9;
      drv[3] = t18;
   /* p=14 2 9 */
   } else if( i==2 && j==9 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*s;
      t6 = t2*t5;
      t7 = t2*t1;
      t8 = t2*s;
      t11 = r*t7;
      t12 = r*t5;
      t13 = r*t1;
      t14 = r*t8;
      t15 = r*s;
      t16 = r*t2;
      t17 = r*t6;
      t18 = 18.0*r*t3+9072.0/1495.0*t8-567.0/65.0*t7-27.0/13.0*t3+432.0/65.0*t6
+1296.0/312455.0*s-1134.0/16445.0*t1+9072.0/16445.0*t5-7938.0/3289.0*t2-27.0/
312455.0+4536.0/65.0*t11-63504.0/16445.0*t12+1512.0/3289.0*t13-3024.0/65.0*t14
-432.0/16445.0*t15+5292.0/299.0*t16+162.0/312455.0*r-720.0/13.0*t17;
      t19 = r*r;
      t21 = -72.0/312455.0-3402.0/65.0*t14+3024.0/65.0*t11-216.0/13.0*t17
-2268.0/16445.0*t15+27216.0/16445.0*t13-31752.0/3289.0*t12+9072.0/299.0*t16
-126.0/65.0*t7+1296.0/312455.0*r+216.0/325.0*t6-2520.0/13.0*t19*t7;
      t28 = -4536.0/3289.0*t2+3402.0/1495.0*t8-6804.0/82225.0*t1+1512.0/3289.0*
t5+2268.0/312455.0*s+10584.0/299.0*t19*t5-95256.0/16445.0*t19*t1+13608.0/65.0*
t19*t8+1512.0/3289.0*t19*s-1512.0/13.0*t19*t2-216.0/16445.0*t19+72.0*t19*t6;
      drv[0] = 2.0*t3*s+648.0/65.0*t6-2.0/312455.0-15876.0/16445.0*t2+504.0/
3289.0*t5-504.0/65.0*t7-216.0/16445.0*t1+5292.0/1495.0*t8+162.0/312455.0*s-90.0
/13.0*t3;
      drv[1] = t18;
      drv[2] = t18;
      drv[3] = t21+t28;
   /* p=14 3 8 */
   } else if( i==3 && j==8 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t1*s;
      t5 = t2*t4;
      t6 = t2*t2;
      t7 = t2*s;
      t8 = r*t5;
      t9 = r*t2;
      t10 = r*t4;
      t11 = r*t3;
      t12 = r*t1;
      t13 = r*t7;
      t14 = r*s;
      t16 = -12.0/1562275.0-1008.0/325.0*t3+864.0/325.0*t5-12.0/13.0*t6-1008.0/
82225.0*t1+2016.0/16445.0*t4-10584.0/16445.0*t2+14112.0/7475.0*t7+864.0/
1562275.0*s-216.0/13.0*t8+54.0/1562275.0*r+5292.0/1495.0*t9-10584.0/16445.0*t10
+6048.0/325.0*t11+1008.0/16445.0*t12-3528.0/325.0*t13-216.0/82225.0*t14+6.0*r*
t6;
      t17 = r*r;
      t18 = t17*t3;
      t19 = -72.0/1562275.0-6048.0/325.0*t13+6048.0/325.0*t11-96.0/13.0*t8
-2016.0/82225.0*t14+6048.0/16445.0*t12-42336.0/16445.0*t10+14112.0/1495.0*t9
-378.0/325.0*t3+864.0/1562275.0*r+144.0/325.0*t5-756.0/13.0*t18;
      t20 = t17*t4;
      t21 = t17*t1;
      t22 = t17*t7;
      t23 = t17*s;
      t24 = t17*t2;
      t26 = -10584.0/16445.0*t2+9072.0/7475.0*t7-2268.0/82225.0*t1+3024.0/
16445.0*t4+3024.0/1562275.0*s+10584.0/1495.0*t20-15876.0/16445.0*t21+18144.0/
325.0*t22+1008.0/16445.0*t23-1764.0/65.0*t24-108.0/82225.0*t17+24.0*t17*t5;
      t27 = t19+t26;
      t28 = 1008.0/325.0*t11+1512.0/7475.0*t7-3024.0/16445.0*t2+1344.0/16445.0*
t4-1512.0/82225.0*t1+3024.0/1562275.0*s-28.0/325.0*t3-4536.0/82225.0*t14-2268.0
/325.0*t13+9072.0/16445.0*t12+9072.0/1495.0*t9-42336.0/16445.0*t10+3024.0/
1562275.0*r-336.0/13.0*t18;
      t29 = t17*r;
      t36 = -1008.0/82225.0*t17-3024.0/65.0*t24+6048.0/16445.0*t23+18144.0/
325.0*t22-63504.0/16445.0*t21+28224.0/1495.0*t20+336.0/16445.0*t29-2352.0/65.0*
t29*t4+6048.0/65.0*t29*t2+10584.0/1495.0*t29*t1-10584.0/16445.0*t29*s-1512.0/
13.0*t29*t7+56.0*t29*t3-112.0/1562275.0;
      drv[0] = t16;
      drv[1] = t27;
      drv[2] = t27;
      drv[3] = t28+t36;
   /* p=14 4 7 */
   } else if( i==4 && j==7 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t1*s;
      t5 = t2*t4;
      t6 = t2*s;
      t8 = r*r;
      t9 = t8*t4;
      t10 = r*t2;
      t11 = -8.0/937365.0-56.0/65.0*t3+24.0/65.0*t5-168.0/16445.0*t1+280.0/
3289.0*t4-1176.0/3289.0*t2+1176.0/1495.0*t6+168.0/312455.0*s-60.0/13.0*r*t5+
24.0/312455.0*r+588.0/299.0*t9+1176.0/299.0*t10;
      t12 = r*t4;
      t13 = r*t3;
      t14 = t8*t2;
      t15 = r*t1;
      t16 = t8*t3;
      t17 = t8*t6;
      t19 = t8*s;
      t20 = t8*t1;
      t21 = r*t6;
      t22 = r*s;
      t23 = -2940.0/3289.0*t12+672.0/65.0*t13-588.0/65.0*t14+336.0/3289.0*t15
-336.0/13.0*t16+7056.0/325.0*t17+12.0*t8*t5+168.0/16445.0*t19-3528.0/16445.0*
t20-12.0/82225.0*t8-588.0/65.0*t21-84.0/16445.0*t22;
      t25 = t8*r;
      t26 = t25*t2;
      t27 = t25*s;
      t28 = t25*t6;
      t30 = t25*t1;
      t31 = 2352.0/65.0*t26-2352.0/16445.0*t27-672.0/13.0*t28-588.0/3289.0*t2+
224.0/3289.0*t4-42.0/3289.0*t1+336.0/312455.0*s-7.0/65.0*t3-4704.0/3289.0*t12+
1176.0/299.0*t10-42.0/16445.0*t8+2352.0/299.0*t9+28.0*t25*t3+588.0/299.0*t30;
      t32 = t25*t4;
      t33 = 168.0/312455.0*r+336.0/1495.0*t6+2016.0/65.0*t17+336.0/3289.0*t19
-784.0/65.0*t32-210.0/13.0*t16-294.0/13.0*t14+168.0/65.0*t13+840.0/3289.0*t15
-336.0/65.0*t21-4410.0/3289.0*t20-28.0/937365.0-336.0/16445.0*t22+56.0/16445.0*
t25;
      t34 = t31+t33;
      t35 = t8*t8;
      t41 = 672.0/13.0*t26-2940.0/3289.0*t27-420.0/13.0*t28-840.0/13.0*t35*t2
-588.0/16445.0*t35+294.0/299.0*t35*s+2352.0/65.0*t35*t4+42.0*t35*t6-588.0/65.0*
t35*t1-84.0/3289.0*t2+56.0/3289.0*t4-84.0/16445.0*t1+42.0/62491.0*s-2352.0/
3289.0*t12+336.0/299.0*t10;
      t42 = -168.0/16445.0*t8+2352.0/299.0*t9+2352.0/299.0*t30+336.0/312455.0*r
+21.0/1495.0*t6+504.0/65.0*t17+840.0/3289.0*t19-392.0/13.0*t32-168.0/13.0*t14+
672.0/3289.0*t15-42.0/65.0*t21-7056.0/3289.0*t20-28.0/937365.0-84.0/3289.0*t22+
112.0/3289.0*t25;
      drv[0] = t11+t23;
      drv[1] = t34;
      drv[2] = t34;
      drv[3] = t41+t42;
   /* p=14 5 6 */
   } else if( i==5 && j==6 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = r*t2;
      t4 = r*t1;
      t5 = t1*s;
      t6 = r*t5;
      t7 = t2*t1;
      t9 = r*r;
      t10 = t9*t2;
      t11 = t9*r;
      t12 = t11*t5;
      t13 = t2*s;
      t14 = r*t13;
      t15 = 945.0/299.0*t3+450.0/3289.0*t4-3150.0/3289.0*t6+200.0/3289.0*t5
-30.0/3289.0*t1-2.0/13.0*t7+36.0/13.0*r*t7+36.0/62491.0*s+9.0/62491.0*r-189.0/
13.0*t10+2.0/3289.0*t11-70.0/13.0*t12-9.0/16445.0*t9-63.0/13.0*t14;
      t16 = t9*t5;
      t18 = t11*t2;
      t19 = t9*t1;
      t21 = t11*t13;
      t22 = t11*s;
      t23 = t11*t1;
      t24 = t9*t13;
      t25 = t9*s;
      t26 = r*s;
      t27 = 1260.0/299.0*t16-180.0/13.0*t9*t7+252.0/13.0*t18-1890.0/3289.0*t19+
20.0*t11*t7-420.0/13.0*t21-126.0/3289.0*t22+210.0/299.0*t23+1512.0/65.0*t24+
108.0/3289.0*t25-27.0/3289.0*t26+84.0/299.0*t13-630.0/3289.0*t2-2.0/187473.0;
      t29 = t9*t9;
      t30 = t29*t1;
      t31 = t29*s;
      t32 = t29*t2;
      t34 = t29*t5;
      t35 = 420.0/299.0*t3+600.0/3289.0*t4-2520.0/3289.0*t6+90.0/3289.0*t5-45.0
/6578.0*t1+45.0/62491.0*s+36.0/62491.0*r-105.0/26.0*t30-63.0/6578.0*t29+105.0/
299.0*t31-525.0/13.0*t32+30.0*t29*t13+252.0/13.0*t34-315.0/26.0*t10+36.0/3289.0
*t11;
      t36 = -252.0/13.0*t12-27.0/6578.0*t9-12.0/13.0*t14+1890.0/299.0*t16+504.0
/13.0*t18-4725.0/3289.0*t19-360.0/13.0*t21-1260.0/3289.0*t22+1260.0/299.0*t23+
108.0/13.0*t24+450.0/3289.0*t25-60.0/3289.0*t26+9.0/299.0*t13-315.0/6578.0*t2
-3.0/124982.0;
      t37 = t35+t36;
      t38 = 45.0/299.0*t3+270.0/3289.0*t4-630.0/3289.0*t6+12.0/3289.0*t5-27.0/
16445.0*t1+18.0/62491.0*s+45.0/62491.0*r-189.0/13.0*t30-315.0/3289.0*t29+630.0/
299.0*t31-450.0/13.0*t32+504.0/13.0*t34-30.0/13.0*t10+150.0/3289.0*t11-210.0/
13.0*t12;
      t39 = t29*r;
      t44 = -30.0/3289.0*t9+840.0/299.0*t16+180.0/13.0*t18-3780.0/3289.0*t19
-3150.0/3289.0*t22+1890.0/299.0*t23+600.0/3289.0*t25-45.0/3289.0*t26-9.0/3289.0
*t2+756.0/65.0*t39*t1-21.0/13.0*t39*s+21.0/299.0*t39-420.0/13.0*t39*t5+30.0*t39
*t2-1.0/62491.0;
      drv[0] = t15+t27;
      drv[1] = t37;
      drv[2] = t37;
      drv[3] = t38+t44;
   /* p=14 6 5 */
   } else if( i==6 && j==5 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = s*s;
      t4 = t2*t3;
      t5 = t3*t3;
      t6 = t1*t5;
      t7 = t3*s;
      t8 = t1*t7;
      t9 = t2*t5;
      t10 = t1*r;
      t11 = t10*t5;
      t12 = t1*t3;
      t13 = t5*s;
      t17 = -1.0/62491.0-30.0/13.0*t4-189.0/13.0*t6+1890.0/299.0*t8-450.0/13.0*
t9+504.0/13.0*t11-3780.0/3289.0*t12+30.0*t2*t13-420.0/13.0*t10*t13+12.0/3289.0*
t10-27.0/16445.0*t1-9.0/3289.0*t2+21.0/299.0*t13-21.0/13.0*r*t13-315.0/3289.0*
t5;
      t18 = r*t3;
      t19 = r*t7;
      t20 = r*t5;
      t21 = r*s;
      t22 = t2*s;
      t23 = t10*t7;
      t24 = t2*t7;
      t25 = t10*t3;
      t27 = t1*s;
      t28 = t10*s;
      t29 = 150.0/3289.0*t7-30.0/3289.0*t3+45.0/62491.0*s+600.0/3289.0*t18+18.0
/62491.0*r-3150.0/3289.0*t19+630.0/299.0*t20-45.0/3289.0*t21+45.0/299.0*t22
-210.0/13.0*t23+180.0/13.0*t24+840.0/299.0*t25+756.0/65.0*t1*t13+270.0/3289.0*
t27-630.0/3289.0*t28;
      t31 = -3.0/124982.0-315.0/26.0*t4-105.0/26.0*t6+1260.0/299.0*t8-525.0/
13.0*t9+252.0/13.0*t11-4725.0/3289.0*t12+90.0/3289.0*t10-45.0/6578.0*t1-315.0/
6578.0*t2-63.0/6578.0*t5+36.0/3289.0*t7-27.0/6578.0*t3+36.0/62491.0*s+450.0/
3289.0*t18;
      t32 = t2*r;
      t33 = t32*t3;
      t34 = t32*s;
      t35 = t32*t7;
      t37 = 45.0/62491.0*r-1260.0/3289.0*t19+105.0/299.0*t20-60.0/3289.0*t21+
420.0/299.0*t22-252.0/13.0*t23+108.0/13.0*t33-12.0/13.0*t34+9.0/299.0*t32-360.0
/13.0*t35+30.0*t32*t5+504.0/13.0*t24+1890.0/299.0*t25+600.0/3289.0*t27-2520.0/
3289.0*t28;
      t38 = t31+t37;
      t39 = -189.0/13.0*t4+210.0/299.0*t8-1890.0/3289.0*t12+200.0/3289.0*t10
-30.0/3289.0*t1-630.0/3289.0*t2+2.0/3289.0*t7-9.0/16445.0*t3+9.0/62491.0*s+
108.0/3289.0*t18+36.0/62491.0*r-126.0/3289.0*t19-27.0/3289.0*t21+945.0/299.0*
t22;
      t40 = t2*t1;
      t44 = -70.0/13.0*t23+20.0*t40*t7-2.0/13.0*t40+1512.0/65.0*t33-63.0/13.0*
t34+36.0/13.0*t40*s+84.0/299.0*t32-420.0/13.0*t35+252.0/13.0*t24+1260.0/299.0*
t25+450.0/3289.0*t27-3150.0/3289.0*t28-180.0/13.0*t40*t3-2.0/187473.0;
      drv[0] = t17+t29;
      drv[1] = t38;
      drv[2] = t38;
      drv[3] = t39+t44;
   /* p=14 7 4 */
   } else if( i==7 && j==4 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t4 = r*t3;
      t5 = s*s;
      t6 = t5*s;
      t7 = t5*t5;
      t8 = r*t6;
      t9 = r*t5;
      t11 = t4*t6;
      t12 = r*s;
      t13 = -28.0/937365.0+56.0/3289.0*t2-84.0/16445.0*t1-84.0/3289.0*t3+21.0/
1495.0*t4+112.0/3289.0*t6-588.0/16445.0*t7-2940.0/3289.0*t8-168.0/16445.0*t5+
840.0/3289.0*t9+336.0/312455.0*s+42.0/62491.0*r+294.0/299.0*r*t7-420.0/13.0*t11
-84.0/3289.0*t12;
      t14 = t3*s;
      t16 = t2*t6;
      t17 = t3*t5;
      t19 = t1*t6;
      t22 = t1*t5;
      t23 = t4*s;
      t24 = t1*s;
      t25 = t3*t6;
      t26 = t2*t5;
      t27 = t4*t5;
      t28 = t2*s;
      t29 = 336.0/299.0*t14+42.0*t4*t7-392.0/13.0*t16-168.0/13.0*t17-588.0/65.0
*t1*t7+2352.0/299.0*t19-840.0/13.0*t3*t7+2352.0/65.0*t2*t7-7056.0/3289.0*t22
-42.0/65.0*t23+672.0/3289.0*t24+672.0/13.0*t25+2352.0/299.0*t26+504.0/65.0*t27
-2352.0/3289.0*t28;
      t31 = -28.0/937365.0+224.0/3289.0*t2-42.0/3289.0*t1-588.0/3289.0*t3+336.0
/1495.0*t4+56.0/16445.0*t6-2352.0/16445.0*t8-42.0/16445.0*t5+336.0/3289.0*t9+
168.0/312455.0*s+336.0/312455.0*r-672.0/13.0*t11-336.0/16445.0*t12+1176.0/299.0
*t14;
      t32 = t1*t3;
      t33 = t32*t5;
      t34 = t32*s;
      t36 = -784.0/65.0*t16-294.0/13.0*t17+588.0/299.0*t19-4410.0/3289.0*t22
-210.0/13.0*t33-7.0/65.0*t32+168.0/65.0*t34+28.0*t32*t6-336.0/65.0*t23+840.0/
3289.0*t24+2352.0/65.0*t25+2352.0/299.0*t26+2016.0/65.0*t27-4704.0/3289.0*t28;
      t37 = t31+t36;
      t38 = t2*t3;
      t41 = -8.0/937365.0-60.0/13.0*t38*s+12.0*t38*t5+24.0/65.0*t38-84.0/
16445.0*t12+168.0/16445.0*t9+7056.0/325.0*t27+168.0/312455.0*r-56.0/65.0*t32
-1176.0/3289.0*t3+588.0/299.0*t26-12.0/82225.0*t5;
      t42 = 1176.0/299.0*t14+24.0/312455.0*s-3528.0/16445.0*t22-336.0/13.0*t33+
336.0/3289.0*t24-588.0/65.0*t17+280.0/3289.0*t2-2940.0/3289.0*t28-588.0/65.0*
t23+672.0/65.0*t34-168.0/16445.0*t1+1176.0/1495.0*t4;
      drv[0] = t13+t29;
      drv[1] = t37;
      drv[2] = t37;
      drv[3] = t41+t42;
   /* p=14 8 3 */
   } else if( i==8 && j==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = s*s;
      t5 = t3*t4;
      t6 = t1*r;
      t7 = t2*r;
      t8 = t4*s;
      t9 = r*t4;
      t12 = r*s;
      t13 = -336.0/13.0*t5+1344.0/16445.0*t6-3024.0/16445.0*t2-1512.0/82225.0*
t1-28.0/325.0*t3+1512.0/7475.0*t7+336.0/16445.0*t8-1008.0/82225.0*t4+3024.0/
1562275.0*r+3024.0/1562275.0*s+6048.0/16445.0*t9-10584.0/16445.0*r*t8-1512.0/
13.0*t7*t8-4536.0/82225.0*t12;
      t14 = t3*s;
      t15 = t2*s;
      t17 = t2*t4;
      t20 = t1*t4;
      t22 = t6*s;
      t23 = t4*t6;
      t24 = t4*t7;
      t25 = t7*s;
      t26 = t1*s;
      t27 = 1008.0/325.0*t14+9072.0/1495.0*t15-2352.0/65.0*t6*t8-3024.0/65.0*
t17+10584.0/1495.0*t1*t8+56.0*t3*t8-63504.0/16445.0*t20+6048.0/65.0*t2*t8
-42336.0/16445.0*t22+28224.0/1495.0*t23+18144.0/325.0*t24-2268.0/325.0*t25+
9072.0/16445.0*t26-112.0/1562275.0;
      t29 = t2*t6;
      t30 = t29*s;
      t32 = -72.0/1562275.0-96.0/13.0*t30+24.0*t29*t4+144.0/325.0*t29-2016.0/
82225.0*t12+1008.0/16445.0*t9+18144.0/325.0*t24+3024.0/1562275.0*r-378.0/325.0*
t3-10584.0/16445.0*t2+10584.0/1495.0*t23-108.0/82225.0*t4;
      t33 = 14112.0/1495.0*t15+864.0/1562275.0*s-15876.0/16445.0*t20-756.0/13.0
*t5+6048.0/16445.0*t26-1764.0/65.0*t17+3024.0/16445.0*t6-42336.0/16445.0*t22
-6048.0/325.0*t25+6048.0/325.0*t14-2268.0/82225.0*t1+9072.0/7475.0*t7;
      t34 = t32+t33;
      t35 = t2*t2;
      t37 = -12.0/1562275.0-216.0/13.0*t30+864.0/325.0*t29-216.0/82225.0*t12+
864.0/1562275.0*r-1008.0/325.0*t3-10584.0/16445.0*t2-12.0/13.0*t35+5292.0/
1495.0*t15+54.0/1562275.0*s+1008.0/16445.0*t26+6.0*t35*s+2016.0/16445.0*t6
-10584.0/16445.0*t22-3528.0/325.0*t25+6048.0/325.0*t14-1008.0/82225.0*t1+
14112.0/7475.0*t7;
      drv[0] = t13+t27;
      drv[1] = t34;
      drv[2] = t34;
      drv[3] = t37;
   /* p=14 9 2 */
   } else if( i==9 && j==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = s*s;
      t6 = t3*s;
      t7 = t2*r;
      t8 = t7*s;
      t9 = t1*r;
      t10 = t9*s;
      t11 = t2*t9;
      t12 = t11*s;
      t14 = -72.0/312455.0-2520.0/13.0*t3*t4+3024.0/65.0*t6-216.0/16445.0*t4+
1296.0/312455.0*s-3402.0/65.0*t8-31752.0/3289.0*t10+2268.0/312455.0*r+1512.0/
3289.0*t9-216.0/13.0*t12+10584.0/299.0*t9*t4-4536.0/3289.0*t2;
      t17 = t1*s;
      t21 = r*s;
      t22 = t2*s;
      t23 = 1512.0/3289.0*r*t4+72.0*t11*t4+3402.0/1495.0*t7+27216.0/16445.0*t17
-95256.0/16445.0*t1*t4-1512.0/13.0*t2*t4-6804.0/82225.0*t1-126.0/65.0*t3+
13608.0/65.0*t4*t7-2268.0/16445.0*t21+9072.0/299.0*t22+216.0/325.0*t11;
      t25 = t2*t2;
      t27 = -27.0/312455.0-720.0/13.0*t12+432.0/65.0*t11-432.0/16445.0*t21+
1296.0/312455.0*r-567.0/65.0*t3-7938.0/3289.0*t2-27.0/13.0*t25+5292.0/299.0*t22
+162.0/312455.0*s+1512.0/3289.0*t17+18.0*t25*s+9072.0/16445.0*t9-63504.0/
16445.0*t10-3024.0/65.0*t8+4536.0/65.0*t6-1134.0/16445.0*t1+9072.0/1495.0*t7;
      drv[0] = t14+t23;
      drv[1] = t27;
      drv[2] = t27;
      drv[3] = 648.0/65.0*t11+162.0/312455.0*r+2.0*t25*r-15876.0/16445.0*t2-2.0
/312455.0-216.0/16445.0*t1-90.0/13.0*t25+504.0/3289.0*t9+5292.0/1495.0*t7-504.0
/65.0*t3;
   /* p=14 10 1 */
   } else if( i==10 && j==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*r;
      t6 = t2*t5;
      t8 = t2*t1;
      t10 = t2*r;
      t16 = 90.0*t3*s-90.0/13.0*t3-3960.0/13.0*t6*s+1584.0/65.0*t6+5544.0/13.0*
t8*s-462.0/13.0*t8-4158.0/13.0*t10*s+8316.0/299.0*t10+41580.0/299.0*t2*s-3780.0
/299.0*t2-10584.0/299.0*t5*s+1008.0/299.0*t5+1512.0/299.0*t1*s-756.0/1495.0*t1
-108.0/299.0*r*s+216.0/5681.0*r+54.0/5681.0*s-6.0/5681.0;
      t18 = 10.0*t3*r-495.0/13.0*t3+792.0/13.0*t6-693.0/13.0*t8+8316.0/299.0*
t10-2646.0/299.0*t2+504.0/299.0*t5-54.0/299.0*t1+54.0/5681.0*r-1.0/5681.0;
      drv[0] = t16;
      drv[1] = t18;
      drv[2] = t18;
      drv[3] = 0.0;
   /* p=14 11 0 */
   } else if( i==11 && j==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*r;
      drv[0] = 110.0*t3*r-5940.0/13.0*t3+52272.0/65.0*t2*t5-10164.0/13.0*t2*t1+
137214.0/299.0*t2*r-49896.0/299.0*t2+11088.0/299.0*t5-7128.0/1495.0*t1+1782.0/
5681.0*r-44.0/5681.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 0.0;
   /* p=15 0 12 */
   } else if( i==0 && j==12 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t6 = t1*s;
      t10 = 132.0*t3*t1-4290.0/7.0*t3*s+8580.0/7.0*t3-9680.0/7.0*t2*t6+968.0*t2
*t1-2178.0/5.0*t2*s+2904.0/23.0*t2-528.0/23.0*t6+396.0/161.0*t1-22.0/161.0*s+
44.0/15295.0;
      drv[0] = 0.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = t10;
   /* p=15 1 11 */
   } else if( i==1 && j==11 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t3*s;
      t6 = t1*s;
      t7 = t2*t6;
      t8 = t2*t1;
      t9 = t2*s;
      t10 = 11.0*t3*t1-330.0/7.0*t5+605.0/7.0*t3-24200.0/273.0*t7+726.0/13.0*t8
-1452.0/65.0*t9+1694.0/299.0*t2-264.0/299.0*t6+165.0/2093.0*t1-22.0/6279.0*s+
11.0/198835.0;
      t20 = 110.0*r*t5-2970.0/7.0*r*t3+4840.0/7.0*r*t7-24200.0/39.0*r*t8+4356.0
/13.0*r*t9-1452.0/13.0*r*t2+6776.0/299.0*r*t6-792.0/299.0*r*t1+330.0/2093.0*r*s
-22.0/6279.0*r-55.0/7.0*t5+220.0/7.0*t3-4840.0/91.0*t7+1936.0/39.0*t8-363.0/
13.0*t9+2904.0/299.0*t2-616.0/299.0*t6+528.0/2093.0*t1-33.0/2093.0*s+44.0/
119301.0;
      drv[0] = 0.0;
      drv[1] = t10;
      drv[2] = t10;
      drv[3] = t20;
   /* p=15 2 10 */
   } else if( i==2 && j==10 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t2*t1;
      t5 = t1*s;
      t6 = t2*t5;
      t7 = t3*s;
      t8 = t2*s;
      t10 = 275.0/21.0*t3+1.0/596505.0+88.0/13.0*t4-1100.0/91.0*t6-55.0/7.0*t7
-20.0/299.0*t5+154.0/299.0*t2-154.0/65.0*t8+2.0*t3*t1-s/6279+10.0/2093.0*t1;
      t11 = r*t6;
      t12 = r*t8;
      t13 = r*t4;
      t14 = r*t3;
      t15 = r*t1;
      t16 = r*t5;
      t17 = r*t2;
      t19 = r*s;
      t20 = 2200.0/21.0*t11+1.0/39767.0+528.0/13.0*t12-1100.0/13.0*t13-495.0/
7.0*t14+55.0/7.0*t3-1100.0/91.0*t6-60.0/299.0*t15+616.0/299.0*t16-154.0/13.0*
t17+20.0*r*t7-r/6279+20.0/2093.0*t19-15.0/7.0*t7+132.0/13.0*t4+60.0/2093.0*t1
-3.0/2093.0*s-84.0/299.0*t5+462.0/299.0*t2-66.0/13.0*t8;
      t21 = r*r;
      t26 = 3.0/39767.0+440.0/7.0*t11+792.0/13.0*t12-1100.0/13.0*t13-135.0/7.0*
t14-252.0/299.0*t15+1848.0/299.0*t16-330.0/13.0*t17+120.0/2093.0*t19+90.0*t21*
t3+1100.0/3.0*t21*t4-1980.0/7.0*t21*t6-308.0/13.0*t21*t5;
      t31 = 1320.0/13.0*t21*t2-3300.0/13.0*t21*t8-60.0/299.0*t21*s+924.0/299.0*
t21*t1+10.0/2093.0*t21-33.0/13.0*t8+12.0/299.0*t1-3.0/2093.0*r+5.0/7.0*t3-6.0/
2093.0*s+44.0/13.0*t4-220.0/91.0*t6-84.0/299.0*t5+330.0/299.0*t2;
      drv[0] = t10;
      drv[1] = t20;
      drv[2] = t20;
      drv[3] = t26+t31;
   /* p=15 3 9 */
   } else if( i==3 && j==9 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = r*t3;
      t5 = t2*t1;
      t6 = r*t5;
      t7 = t1*s;
      t8 = t2*t7;
      t9 = r*t8;
      t10 = t3*s;
      t12 = r*t7;
      t13 = r*t2;
      t14 = t2*s;
      t15 = r*t14;
      t16 = r*s;
      t17 = r*t1;
      t18 = -135.0/7.0*t4+4.0/2187185.0-18.0/115115.0*s-r/115115-240.0/13.0*t6+
180.0/7.0*t9+6.0*r*t10-6.0/7.0*t10+20.0/7.0*t3+84.0/299.0*t12-126.0/65.0*t13+
504.0/65.0*t15+18.0/23023.0*t16-72.0/3289.0*t17-360.0/91.0*t8-168.0/3289.0*t7+
96.0/23023.0*t1+504.0/1495.0*t2-84.0/65.0*t14+192.0/65.0*t5;
      t19 = r*r;
      t20 = t19*t7;
      t21 = t19*t5;
      t22 = 192.0/23023.0*t16-252.0/65.0*t20+27.0/2187185.0-84.0/13.0*t13-72.0/
115115.0*s+108.0/65.0*t5-18.0/115115.0*r+3.0/7.0*t3-54.0/7.0*t4-360.0/13.0*t6+
160.0/7.0*t9-504.0/3289.0*t17+90.0*t21;
      t23 = t19*t8;
      t24 = t19*t2;
      t25 = t19*t14;
      t26 = t19*s;
      t27 = t19*t1;
      t29 = -540.0/7.0*t23+252.0/13.0*t24-720.0/13.0*t25-72.0/3289.0*t26+126.0/
299.0*t27+9.0/23023.0*t19+27.0*t19*t3-72.0/65.0*t14+36.0/3289.0*t1+1152.0/65.0*
t15+2016.0/1495.0*t12-1512.0/16445.0*t7+126.0/299.0*t2-120.0/91.0*t8;
      t30 = t22+t29;
      t31 = 72.0/3289.0*t16-168.0/13.0*t20-72.0/13.0*t13+48.0/2187185.0-12.0/
16445.0*s+16.0/65.0*t5-72.0/115115.0*r-120.0/13.0*t6+24.0/7.0*t9-4536.0/16445.0
*t17+80.0*t21-216.0/7.0*t23+576.0/13.0*t24-1080.0/13.0*t25-504.0/3289.0*t26+
3024.0/1495.0*t27;
      t32 = t19*r;
      t40 = 96.0/23023.0*t19-18.0/65.0*t14+144.0/16445.0*t1+648.0/65.0*t15+
504.0/299.0*t12-168.0/3289.0*t7+48.0/299.0*t2-8.0/91.0*t8+84.0/299.0*t32*s-24.0
/3289.0*t32+72.0*t32*t8+336.0/13.0*t32*t7-252.0/65.0*t32*t1-1200.0/13.0*t32*t2+
180.0*t32*t14-180.0*t32*t5;
      drv[0] = t18;
      drv[1] = t30;
      drv[2] = t30;
      drv[3] = t31+t40;
   /* p=15 4 8 */
   } else if( i==4 && j==8 ) {
      t1 = r*r;
      t2 = s*s;
      t3 = t2*t2;
      t4 = t3*t3;
      t6 = t3*s;
      t7 = t1*t6;
      t8 = t1*t3;
      t9 = t2*s;
      t10 = t1*t9;
      t12 = 4.0/2187185.0+12.0*t1*t4-16.0/115115.0*s+20.0/63.0*t4-2.0/115115.0*
r+4.0/115115.0*t1-112.0/195.0*t6-224.0/13.0*t7+336.0/65.0*t8+56.0/299.0*t3-56.0
/65.0*t10-112.0/3289.0*t9-30.0/7.0*r*t4;
      t13 = t3*t2;
      t14 = t3*t9;
      t15 = t1*t14;
      t16 = t1*t13;
      t17 = r*s;
      t18 = r*t13;
      t19 = r*t3;
      t20 = r*t2;
      t21 = r*t9;
      t22 = r*t14;
      t23 = r*t6;
      t24 = t1*t2;
      t25 = t1*s;
      t26 = 64.0/65.0*t13-216.0/7.0*t15-80.0/91.0*t14+32.0*t16+32.0/23023.0*t17
-160.0/13.0*t18-28.0/13.0*t19-112.0/3289.0*t20+112.0/299.0*t21+80.0/7.0*t22+
448.0/65.0*t23+32.0/9867.0*t2+112.0/1495.0*t24-48.0/16445.0*t25;
      t28 = -16.0/49335.0*s-16.0/115115.0*r+16.0/23023.0*t1-16.0/65.0*t6-480.0/
13.0*t7+224.0/13.0*t8+112.0/897.0*t3-56.0/13.0*t10-112.0/3289.0*t9+16.0/65.0*
t13-120.0/7.0*t15-80.0/819.0*t14+40.0*t16+64.0/9867.0*t17-80.0/13.0*t18-112.0/
39.0*t19;
      t29 = t1*r;
      t31 = t29*t9;
      t32 = t29*t2;
      t33 = t29*s;
      t34 = t29*t6;
      t35 = t29*t3;
      t36 = t29*t13;
      t37 = -336.0/3289.0*t20+224.0/299.0*t21+160.0/63.0*t22+384.0/65.0*t23+
16.0/3289.0*t2+168.0/299.0*t24-112.0/3289.0*t25+16.0/2187185.0-16.0/16445.0*t29
+32.0*t29*t14+448.0/65.0*t31-56.0/65.0*t32+224.0/4485.0*t33+64.0*t34-1120.0/
39.0*t35-72.0*t36;
      t38 = t28+t37;
      t39 = t1*t1;
      t41 = -28.0/65.0*t39*s-4.0/16445.0*s-16.0/49335.0*r+32.0/9867.0*t1-2.0/
65.0*t6-240.0/13.0*t7+192.0/13.0*t8+8.0/299.0*t3-224.0/39.0*t10-112.0/9867.0*t9
+8.0/585.0*t13+80.0/9.0*t16+32.0/3289.0*t17-80.0/117.0*t18-16.0/13.0*t19-336.0/
3289.0*t20+448.0/897.0*t21;
      t47 = 96.0/65.0*t23+8.0/3289.0*t2+336.0/299.0*t24-336.0/3289.0*t25-112.0/
9867.0*t29+896.0/39.0*t31-56.0/13.0*t32+112.0/299.0*t33+80.0*t34-800.0/13.0*t35
+56.0/4485.0*t39+336.0/65.0*t39*t2+8.0/937365.0-40.0*t36-1120.0/39.0*t39*t9+
56.0*t39*t13+80.0*t39*t3-108.0*t39*t6;
      drv[0] = t12+t26;
      drv[1] = t38;
      drv[2] = t38;
      drv[3] = t41+t47;
   /* p=15 5 7 */
   } else if( i==5 && j==7 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = r*r;
      t5 = t4*t3;
      t6 = t1*s;
      t7 = t4*r;
      t8 = t2*t6;
      t10 = t7*t6;
      t11 = r*s;
      t12 = t7*t3;
      t13 = r*t2;
      t14 = t2*s;
      t15 = r*t14;
      t16 = r*t3;
      t17 = r*t1;
      t18 = 32.0/117.0*t3+80.0/3.0*t5-700.0/29601.0*t6+20.0*t7*t8-4.0/29601.0*
t7-100.0/819.0*t8-4.0/29601.0*s-2.0/69069.0*r+280.0/117.0*t10+20.0/9867.0*t11
-40.0*t12-70.0/39.0*t13+56.0/13.0*t15-200.0/39.0*t16-140.0/3289.0*t17+80.0/
29601.0*t1;
      t20 = t4*t6;
      t21 = t4*t2;
      t22 = t4*t14;
      t23 = t7*t1;
      t24 = t4*s;
      t25 = t4*t1;
      t26 = t7*t2;
      t27 = t7*t14;
      t29 = r*t6;
      t30 = t7*s;
      t31 = -28.0/117.0*t14+280.0/2691.0*t2-90.0/7.0*t4*t8-70.0/39.0*t20+112.0/
13.0*t21-280.0/13.0*t22-28.0/117.0*t23-28.0/3289.0*t24+56.0/299.0*t25-1400.0/
117.0*t26+280.0/9.0*t27+50.0/21.0*r*t8+350.0/897.0*t29+28.0/2691.0*t30+8.0/
69069.0*t4+8.0/3936933.0;
      t33 = t4*t4;
      t34 = t33*t1;
      t35 = t33*t6;
      t37 = t33*t14;
      t38 = t3/39+25.0/3.0*t5-140.0/9867.0*t6-28.0/9867.0*t7-2.0/9867.0*s-4.0/
29601.0*r+448.0/39.0*t10+160.0/29601.0*t11+70.0/39.0*t34+7.0/2691.0*t33-30.0*
t12-140.0/117.0*t13+64.0/39.0*t15-100.0/117.0*t16-1400.0/117.0*t35+35.0*t33*t3
-60.0*t37;
      t39 = t33*t2;
      t40 = t33*s;
      t41 = 350.0/9.0*t39-700.0/9867.0*t17+25.0/9867.0*t1-2.0/39.0*t14+35.0/
897.0*t2-140.0/39.0*t20+140.0/13.0*t21-200.0/13.0*t22-70.0/39.0*t23-140.0/
3289.0*t24+175.0/299.0*t25-1400.0/39.0*t26+160.0/3.0*t27+1120.0/2691.0*t29+
112.0/897.0*t30+10.0/9867.0*t4-14.0/117.0*t40+1.0/187473.0;
      t42 = t38+t41;
      t43 = 4.0/937365.0-28.0/9867.0*t6-140.0/9867.0*t7-s/9867-2.0/9867.0*r+
560.0/39.0*t10+50.0/9867.0*t11+112.0/13.0*t34+28.0/897.0*t33-10.0/39.0*t13+2.0/
13.0*t15-1400.0/39.0*t35-45.0*t37+200.0/3.0*t39-140.0/3289.0*t17+8.0/9867.0*t1-
t14/390+4.0/897.0*t2;
      t44 = t33*r;
      t50 = -280.0/117.0*t20+160.0/39.0*t21-100.0/39.0*t22-140.0/39.0*t23-700.0
/9867.0*t24+560.0/897.0*t25-1000.0/39.0*t26+50.0/3.0*t27+140.0/897.0*t29+350.0/
897.0*t30+80.0/29601.0*t4+42.0*t44*t14-280.0/39.0*t44*t1-14.0/585.0*t44+28.0/
39.0*t44*s-35.0/39.0*t40+280.0/9.0*t44*t6-60.0*t44*t2;
      drv[0] = t18+t31;
      drv[1] = t42;
      drv[2] = t42;
      drv[3] = t43+t50;
   /* p=15 6 6 */
   } else if( i==6 && j==6 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = s*s;
      t4 = t3*t3;
      t5 = t4*s;
      t6 = t2*t5;
      t7 = t4*t3;
      t9 = t1*r;
      t10 = t9*t3;
      t11 = t3*s;
      t12 = t2*t11;
      t13 = t2*t3;
      t14 = t9*t11;
      t15 = -45.0*t6+1.0/374946.0-7.0/78.0*t5+35.0/598.0*t4+30.0*t7*t2-35.0/
39.0*t10-250.0/39.0*t12-175.0/9867.0*t11-7.0/9867.0*t9+t1/3289+2.0/39.0*t7+t2
/1794-r/19734+25.0/9867.0*t3-s/6578+10.0/13.0*t13+280.0/39.0*t14;
      t16 = r*s;
      t18 = t9*s;
      t19 = t1*t11;
      t20 = t4*t1;
      t21 = t1*t5;
      t22 = t4*t2;
      t23 = t1*s;
      t24 = t1*t3;
      t25 = t9*t4;
      t26 = t9*t5;
      t27 = t2*s;
      t28 = r*t11;
      t29 = r*t3;
      t30 = r*t4;
      t31 = r*t5;
      t34 = 10.0/3289.0*t16+10.0*t7*t1+14.0/299.0*t18-35.0/13.0*t19+126.0/13.0*
t20-210.0/13.0*t21+25.0*t22-63.0/3289.0*t23+105.0/299.0*t24-350.0/13.0*t25+
140.0/3.0*t26-t27/26+350.0/897.0*t28-175.0/3289.0*t29-35.0/26.0*t30+28.0/13.0*
t31-50.0/39.0*r*t7-30.0*t9*t7;
      t36 = -45.0*t6+3.0/624910.0-t5/130+7.0/598.0*t4-35.0/13.0*t10-350.0/13.0*
t12-21.0/3289.0*t11-21.0/3289.0*t9+5.0/3289.0*t1+7.0/598.0*t2-r/6578+5.0/3289.0
*t3-s/6578+70.0/13.0*t13+168.0/13.0*t14+50.0/9867.0*t16+70.0/299.0*t18-35.0/
13.0*t19;
      t37 = t2*r;
      t38 = t37*t11;
      t39 = t37*s;
      t41 = t37*t3;
      t42 = t37*t4;
      t43 = 70.0/13.0*t20-50.0/13.0*t21+175.0/3.0*t22-175.0/3289.0*t23+175.0/
299.0*t24+20.0*t38-t37/130-350.0/13.0*t25+20.0*t26-35.0/78.0*t27+70.0/299.0*t28
-175.0/3289.0*t29-35.0/78.0*t30+4.0/13.0*t31+4.0/13.0*t39+36.0*t37*t5-50.0/13.0
*t41-45.0*t42;
      t44 = t36+t43;
      t45 = 1.0/374946.0+t4/1794-35.0/13.0*t10-350.0/13.0*t12-7.0/9867.0*t11
-175.0/9867.0*t9+25.0/9867.0*t1+35.0/598.0*t2-r/6578+t3/3289-s/19734+126.0/13.0
*t13+280.0/39.0*t14+10.0/3289.0*t16+350.0/897.0*t18-35.0/39.0*t19+10.0/13.0*t20
;
      t46 = t2*t1;
      t51 = 25.0*t22-175.0/3289.0*t23+105.0/299.0*t24+2.0/39.0*t46+140.0/3.0*
t38-7.0/78.0*t37-250.0/39.0*t25-35.0/26.0*t27+14.0/299.0*t28-63.0/3289.0*t29-
t30/26+28.0/13.0*t39-210.0/13.0*t41-45.0*t42+30.0*t46*t4-50.0/39.0*t46*s+10.0*
t46*t3-30.0*t46*t11;
      drv[0] = t15+t34;
      drv[1] = t44;
      drv[2] = t44;
      drv[3] = t45+t51;
   /* p=15 7 5 */
   } else if( i==7 && j==5 ) {
      t1 = r*s;
      t2 = r*r;
      t3 = t2*t2;
      t4 = s*s;
      t5 = t4*s;
      t6 = t3*t5;
      t7 = t3*t4;
      t8 = t2*r;
      t9 = t8*t5;
      t10 = t4*t4;
      t11 = t10*s;
      t13 = t8*s;
      t14 = t3*r;
      t15 = t14*s;
      t16 = t2*t4;
      t17 = 4.0/937365.0+50.0/9867.0*t1-1000.0/39.0*t6+4.0/897.0*t3-2.0/9867.0*
s+160.0/39.0*t7+80.0/29601.0*t4-r/9867+560.0/39.0*t9-14.0/585.0*t11-60.0*t3*t11
+140.0/897.0*t13+8.0/9867.0*t2-t14/390+2.0/13.0*t15-28.0/9867.0*t8-140.0/9867.0
*t5+560.0/897.0*t16;
      t18 = t3*t10;
      t19 = t2*s;
      t20 = t8*t4;
      t21 = t2*t10;
      t23 = r*t10;
      t24 = t14*t10;
      t25 = t3*s;
      t27 = t14*t4;
      t28 = t14*t5;
      t29 = r*t5;
      t30 = r*t4;
      t32 = t8*t10;
      t34 = t2*t5;
      t35 = 200.0/3.0*t18-140.0/3289.0*t19-280.0/117.0*t20+28.0/897.0*t10+112.0
/13.0*t21-280.0/39.0*t2*t11-35.0/39.0*t23-45.0*t24-10.0/39.0*t25+280.0/9.0*t8*
t11-100.0/39.0*t27+50.0/3.0*t28+350.0/897.0*t29-700.0/9867.0*t30+28.0/39.0*r*
t11-1400.0/39.0*t32+42.0*t14*t11-140.0/39.0*t34;
      t37 = 160.0/29601.0*t1-1400.0/39.0*t6+35.0/897.0*t3-4.0/29601.0*s+140.0/
13.0*t7+10.0/9867.0*t4-2.0/9867.0*r+448.0/39.0*t9+1120.0/2691.0*t13+25.0/9867.0
*t2-2.0/39.0*t14+64.0/39.0*t15-140.0/9867.0*t8-28.0/9867.0*t5+175.0/299.0*t16+
350.0/9.0*t18-700.0/9867.0*t19;
      t38 = t3*t2;
      t40 = t38*s;
      t41 = t38*t5;
      t42 = t38*t4;
      t43 = -140.0/39.0*t20+7.0/2691.0*t10+70.0/39.0*t21-14.0/117.0*t23-60.0*
t24-140.0/117.0*t25-200.0/13.0*t27+160.0/3.0*t28+35.0*t38*t10+t38/39-100.0/
117.0*t40-30.0*t41+25.0/3.0*t42+112.0/897.0*t29-140.0/3289.0*t30-1400.0/117.0*
t32-70.0/39.0*t34+1.0/187473.0;
      t44 = t37+t43;
      t45 = t3*t8;
      t47 = 20.0/9867.0*t1-1400.0/117.0*t6+280.0/2691.0*t3-2.0/69069.0*s+112.0/
13.0*t7+8.0/69069.0*t4-4.0/29601.0*r+280.0/117.0*t9+350.0/897.0*t13+80.0/
29601.0*t2-28.0/117.0*t14+56.0/13.0*t15-700.0/29601.0*t8-4.0/29601.0*t5+50.0/
21.0*t45*s+56.0/299.0*t16;
      t50 = -90.0/7.0*t45*t4-140.0/3289.0*t19-70.0/39.0*t20+20.0*t45*t5-70.0/
39.0*t25-280.0/13.0*t27+280.0/9.0*t28+32.0/117.0*t38-200.0/39.0*t40-40.0*t41+
80.0/3.0*t42+28.0/2691.0*t29-28.0/3289.0*t30-100.0/819.0*t45-28.0/117.0*t34+8.0
/3936933.0;
      drv[0] = t17+t35;
      drv[1] = t44;
      drv[2] = t44;
      drv[3] = t47+t50;
   /* p=15 8 4 */
   } else if( i==8 && j==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = s*s;
      t4 = t3*s;
      t5 = t2*t4;
      t6 = t1*r;
      t7 = t6*t4;
      t8 = t2*r;
      t9 = t8*s;
      t10 = r*s;
      t11 = t6*s;
      t12 = t1*t4;
      t13 = t3*t3;
      t15 = t2*t1;
      t17 = t6*t3;
      t19 = t15*s;
      t20 = t15*t3;
      t21 = t1*s;
      t22 = t1*t3;
      t24 = t2*s;
      t25 = 8.0/937365.0-800.0/13.0*t5+896.0/39.0*t7+96.0/65.0*t9+32.0/3289.0*
t10+448.0/897.0*t11-56.0/13.0*t12+336.0/65.0*t1*t13+56.0*t15*t13-224.0/39.0*t17
+80.0*t2*t13-80.0/117.0*t19+80.0/9.0*t20-336.0/3289.0*t21+336.0/299.0*t22
-1120.0/39.0*t6*t13-16.0/13.0*t24;
      t26 = t8*t3;
      t27 = t15*t4;
      t28 = t8*t4;
      t29 = r*t4;
      t30 = r*t3;
      t33 = t2*t3;
      t34 = -240.0/13.0*t26-40.0*t27+8.0/585.0*t15+56.0/4485.0*t13+8.0/3289.0*
t1-2.0/65.0*t8-112.0/9867.0*t4-112.0/9867.0*t6-16.0/49335.0*s+32.0/9867.0*t3+
8.0/299.0*t2+80.0*t28+112.0/299.0*t29-336.0/3289.0*t30-108.0*t8*t13-28.0/65.0*r
*t13-4.0/16445.0*r+192.0/13.0*t33;
      t36 = -1120.0/39.0*t5+448.0/65.0*t7+384.0/65.0*t9+64.0/9867.0*t10+224.0/
299.0*t11-56.0/65.0*t12-56.0/13.0*t17-80.0/13.0*t19+40.0*t20-336.0/3289.0*t21+
168.0/299.0*t22-112.0/39.0*t24-480.0/13.0*t26-72.0*t27+16.0/65.0*t15+16.0/
3289.0*t1;
      t37 = t2*t6;
      t39 = t37*s;
      t40 = t37*t3;
      t41 = -16.0/65.0*t8-16.0/16445.0*t4-112.0/3289.0*t6-16.0/115115.0*s+16.0/
23023.0*t3+112.0/897.0*t2+32.0*t37*t4-80.0/819.0*t37+160.0/63.0*t39+64.0*t28+
224.0/4485.0*t29-112.0/3289.0*t30-120.0/7.0*t40-16.0/49335.0*r+224.0/13.0*t33+
16.0/2187185.0;
      t42 = t36+t41;
      t43 = 4.0/2187185.0+448.0/65.0*t9+32.0/23023.0*t10+112.0/299.0*t11-56.0/
65.0*t17-160.0/13.0*t19+32.0*t20-112.0/3289.0*t21+112.0/1495.0*t22-28.0/13.0*
t24-224.0/13.0*t26+64.0/65.0*t15+32.0/9867.0*t1;
      t44 = t2*t2;
      t47 = -112.0/195.0*t8-112.0/3289.0*t6-2.0/115115.0*s+4.0/115115.0*t3+56.0
/299.0*t2-80.0/91.0*t37+80.0/7.0*t39-48.0/16445.0*t30-216.0/7.0*t40+20.0/63.0*
t44-30.0/7.0*t44*s+12.0*t44*t3-16.0/115115.0*r+336.0/65.0*t33;
      drv[0] = t25+t34;
      drv[1] = t42;
      drv[2] = t42;
      drv[3] = t43+t47;
   /* p=15 9 3 */
   } else if( i==9 && j==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = s*s;
      t4 = t3*s;
      t6 = t1*r;
      t8 = t2*r;
      t9 = t8*s;
      t10 = r*s;
      t11 = t6*s;
      t13 = t2*t6;
      t14 = t13*s;
      t15 = t6*t3;
      t16 = t2*t1;
      t17 = t16*s;
      t18 = t16*t3;
      t19 = t1*s;
      t20 = t1*t3;
      t22 = t8*t3;
      t23 = -1200.0/13.0*t2*t4+336.0/13.0*t6*t4+648.0/65.0*t9+72.0/3289.0*t10+
504.0/299.0*t11-252.0/65.0*t1*t4+24.0/7.0*t14-168.0/13.0*t15-120.0/13.0*t17+
80.0*t18-4536.0/16445.0*t19+3024.0/1495.0*t20-180.0*t16*t4+48.0/299.0*t2-12.0/
16445.0*r-1080.0/13.0*t22;
      t24 = t13*t3;
      t26 = t2*s;
      t29 = r*t3;
      t30 = t2*t3;
      t31 = -216.0/7.0*t24+72.0*t13*t4-72.0/13.0*t26+180.0*t8*t4+84.0/299.0*r*
t4-504.0/3289.0*t29+16.0/65.0*t16-8.0/91.0*t13-18.0/65.0*t8+144.0/16445.0*t1+
96.0/23023.0*t3-72.0/115115.0*s-24.0/3289.0*t4-168.0/3289.0*t6+576.0/13.0*t30+
48.0/2187185.0;
      t33 = 1152.0/65.0*t9+192.0/23023.0*t10+2016.0/1495.0*t11+160.0/7.0*t14
-252.0/65.0*t15-360.0/13.0*t17+90.0*t18-504.0/3289.0*t19+126.0/299.0*t20+27.0/
2187185.0+126.0/299.0*t2-72.0/115115.0*r-720.0/13.0*t22;
      t34 = t2*t2;
      t35 = t34*s;
      t37 = -540.0/7.0*t24-84.0/13.0*t26-72.0/3289.0*t29-54.0/7.0*t35+27.0*t34*
t3+108.0/65.0*t16-120.0/91.0*t13-72.0/65.0*t8+36.0/3289.0*t1+9.0/23023.0*t3
-18.0/115115.0*s-1512.0/16445.0*t6+252.0/13.0*t30+3.0/7.0*t34;
      t38 = t33+t37;
      t39 = t34*r;
      t41 = -126.0/65.0*t26+4.0/2187185.0-84.0/65.0*t8-18.0/115115.0*r-168.0/
3289.0*t6-360.0/91.0*t13+84.0/299.0*t11+192.0/65.0*t16-240.0/13.0*t17+96.0/
23023.0*t1-72.0/3289.0*t19+180.0/7.0*t14-6.0/7.0*t39+20.0/7.0*t34-s/115115+
504.0/65.0*t9+504.0/1495.0*t2-135.0/7.0*t35+18.0/23023.0*t10+6.0*t39*s;
      drv[0] = t23+t31;
      drv[1] = t38;
      drv[2] = t38;
      drv[3] = t41;
   /* p=15 10 2 */
   } else if( i==10 && j==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = s*s;
      t5 = t2*t2;
      t6 = t5*s;
      t7 = t2*t1;
      t9 = t2*r;
      t10 = t1*r;
      t11 = t2*t10;
      t12 = 1320.0/13.0*t2*t3-135.0/7.0*t6+1100.0/3.0*t7*t3+3.0/39767.0+10.0/
2093.0*t3-3.0/2093.0*s+330.0/299.0*t2-6.0/2093.0*r-33.0/13.0*t9+12.0/299.0*t1
-84.0/299.0*t10-220.0/91.0*t11+44.0/13.0*t7;
      t14 = t2*s;
      t17 = t9*s;
      t18 = r*s;
      t19 = t10*s;
      t20 = t11*s;
      t22 = t7*s;
      t23 = t1*s;
      t26 = 5.0/7.0*t5-3300.0/13.0*t9*t3-330.0/13.0*t14+90.0*t5*t3-60.0/299.0*r
*t3+792.0/13.0*t17+120.0/2093.0*t18+1848.0/299.0*t19+440.0/7.0*t20-308.0/13.0*
t10*t3-1100.0/13.0*t22-252.0/299.0*t23+924.0/299.0*t1*t3-1980.0/7.0*t11*t3;
      t28 = t5*r;
      t30 = -154.0/13.0*t14+1.0/39767.0-66.0/13.0*t9-3.0/2093.0*r-84.0/299.0*
t10-1100.0/91.0*t11+616.0/299.0*t19+132.0/13.0*t7-1100.0/13.0*t22+60.0/2093.0*
t1-60.0/299.0*t23+2200.0/21.0*t20-15.0/7.0*t28+55.0/7.0*t5-s/6279+528.0/13.0*
t17+462.0/299.0*t2-495.0/7.0*t6+20.0/2093.0*t18+20.0*t28*s;
      t32 = 154.0/299.0*t2+2.0*t5*t1-20.0/299.0*t10+88.0/13.0*t7+10.0/2093.0*t1
-1100.0/91.0*t11+1.0/596505.0-154.0/65.0*t9+275.0/21.0*t5-r/6279-55.0/7.0*t28;
      drv[0] = t12+t26;
      drv[1] = t30;
      drv[2] = t30;
      drv[3] = t32;
   /* p=15 11 1 */
   } else if( i==11 && j==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = r*t3;
      t7 = t1*r;
      t8 = t2*t7;
      t10 = t2*t1;
      t12 = t2*r;
      t18 = 110.0*t4*s-55.0/7.0*t4-2970.0/7.0*t3*s+220.0/7.0*t3+4840.0/7.0*t8*s
-4840.0/91.0*t8-24200.0/39.0*t10*s+1936.0/39.0*t10+4356.0/13.0*t12*s-363.0/13.0
*t12-1452.0/13.0*t2*s+2904.0/299.0*t2+6776.0/299.0*t7*s-616.0/299.0*t7-792.0/
299.0*t1*s+528.0/2093.0*t1+330.0/2093.0*r*s-33.0/2093.0*r-22.0/6279.0*s+44.0/
119301.0;
      t20 = 11.0*t1*t3-330.0/7.0*t4+605.0/7.0*t3-24200.0/273.0*t8+726.0/13.0*
t10-1452.0/65.0*t12+1694.0/299.0*t2-264.0/299.0*t7+165.0/2093.0*t1-22.0/6279.0*
r+11.0/198835.0;
      drv[0] = t18;
      drv[1] = t20;
      drv[2] = t20;
      drv[3] = 0.0;
   /* p=15 12 0 */
   } else if( i==12 && j==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t6 = t1*r;
      t10 = 132.0*t1*t3-4290.0/7.0*r*t3+8580.0/7.0*t3-9680.0/7.0*t2*t6+968.0*t2
*t1-2178.0/5.0*t2*r+2904.0/23.0*t2-528.0/23.0*t6+396.0/161.0*t1-22.0/161.0*r+
44.0/15295.0;
      drv[0] = t10;
      drv[1] = 0.0;
      drv[2] = 0.0;
      drv[3] = 0.0;
   }
   return 1;
}
#ifdef __cplusplus
}
#endif
