#include <iostream>
#include "phastaIO.h"

using std::cerr;
using std::endl;

const char* iformat="binary";

int
restart( int irestart,
        double* q,
        int nshg, 
        int nvr,
        char fieldname[]) { 

    int iarray[4];
    int isize = 3;

    readheader_( &irestart, fieldname, iarray, &isize, "double", iformat );

    isize = iarray[0]*iarray[1];
    int lstep = iarray[2];
    double* qlocal = new double [ isize ];

    readdatablock_( &irestart, fieldname, qlocal, &isize, "double" , iformat );

    // copy the needed part into the array passed in 

    if ( nshg > iarray[0] ) {
        cerr << "reading only " << iarray[0] << "modes from irestart" << endl;
        cerr << nshg << " modes were requested " << endl;
        nshg = iarray[0];
    }
    if ( nvr  > iarray[1] ) {
        cerr << "reading only " << iarray[1] << "vars from restart" << endl;
        cerr << nvr << " vars were requested " << endl;
        nvr  = iarray[1];
    }
    // we are not transposing here, just copying the needed chunk
    for(int i=0; i < nvr; i++)
        for(int j=0; j < nshg; j++)
            q[i*nshg+j] = qlocal[i*iarray[0]+j];

    delete [] qlocal;
    return lstep;
}
