#include<stdio.h>
#include<string.h>
#define swap_char(A,B) { ucTmp = A; A = B ; B = ucTmp; }
static int swapbyteorder=0;

static int cscompare(const char* s1, const char* s2)
{
  while( *s1 == ' ') s1++;
  while( *s2 == ' ') s2++;
  while((*s1) && (*s2) &&(tolower(*(s1++))==tolower(*(s2++))))
    {
      while( *s1 == ' ') s1++;
      while( *s2 == ' ') s2++;
    }
  if (!(*s1) && !(*s2)) return 1;
  else return 0;
}

static void SwapArrayByteOrder(void* array, int nbytes, int nItems)
{
  int i,j;
  unsigned char  ucTmp;
  unsigned char* ucDst = (unsigned char*)array;

  for(i=0; i < nItems; i++) {
    for(j=0; j < (nbytes/2); j++)
      swap_char( ucDst[j] , ucDst[(nbytes - 1) - j] );
    ucDst += nbytes;
  }
}

void restart(char* solfile, double *q, int nshg, int nvr)
{
  FILE* orest = fopen(solfile,"r");
  int swapbyteorder, nshgl, nvl,i,j;  
  double* qlocal;
  char *pch, *header, inpLine[125];
  int lstep;
   
  int notdoneyet=1, rlen, skipsize, tmpint;
   
  fgets(inpLine, 125, orest);
  while(!feof(orest) && notdoneyet) { 
    if ( inpLine[0] != '\n') {
      rlen = strcspn(inpLine,"#"); 
      if ( rlen > 0) { /* ignore comment lines */
        header = (char *) malloc( rlen+1);
        strncpy(header,inpLine,rlen);
        header[rlen] = NULL;  /* add terminate character */
        
        /* tokenize and look for what we want */
        pch = strtok(header,":");
        if(cscompare(pch,"solution")){
          
          pch = strtok(NULL," ,;<>");
          skipsize = atoi(pch);
          
          pch = strtok(NULL," ,;<>");
          nshgl = atoi(pch);
          
          pch = strtok(NULL," ,;<>");
          nvl = atoi(pch);
          
          if ( nvl < nvr ) {
            fprintf( stderr, 
                     " Your restartfile has lesser number of solution variables\n");
            fprintf( stderr, " than you are trying to read. \n" );
            exit( 0 );
          }
          
          pch = strtok(NULL," ,;<>");
          lstep = atoi(pch);
          
          qlocal = (double *)malloc(sizeof(double)* nshgl * nvl);
          fread((void *)qlocal,sizeof(double),nshgl*nvl, orest);
          fscanf(orest,"\n");
          
          notdoneyet=0;
          break;
        } else if(cscompare(pch,"byteorder magic number")){
          
          fread((void *)&tmpint,sizeof(int),1,orest);
          if( 362436 != tmpint ) swapbyteorder=1;
          else swapbyteorder = 0;
          fscanf(orest,"\n");
          
        } else {
          
          pch = strtok(NULL," ,;<>");
          skipsize = atoi(pch);
          fseek(orest,skipsize,SEEK_CUR);
        }
      }
    }
    fgets(inpLine, 125, orest);  
  }	 
  
  
  fclose(orest);
  
  if(notdoneyet){
    fprintf(stderr,"could not find solution in restart file \n");
    exit(1);
  }
  if( swapbyteorder)
    SwapArrayByteOrder((void *)qlocal, sizeof(double), nshgl*nvl);
  
  /* copy the needed part into the array passed in */
  
  for(i=0; i < nvr; i++)
    for(j=0; j < nshg; j++)
      q[i*nshg+j] = qlocal[i*nshgl+j];
  
  /* destroying the local array */
  
  free(qlocal);
}
