#include "phRead.h"
#include "phastaIO.h"

#include <stdio.h>

#include <iostream>
#include <string>
#include <cstring>

using namespace std;

// to read parameters from a phasta file (filename)
// parameters correspond to header info for given field
// these parameters are used as reference values
// (sometimes needed before reading the field-array)
void readParametersFromFile( char *filename,
                             char *fieldName,
                             const char *data_type,
                             int &isize,
                             int *iarray) {

  // read file (i.e., geombc, restart, error etc.)
  // fileDescriptor
  int file_handle;
  // format of the file
  string iformat_str = "binary";
  char iformat[16];
  strcpy(iformat,iformat_str.c_str());

  openfile_( filename, "read",  &file_handle );

  readheader_( &file_handle, fieldName, iarray,
               &isize, data_type, iformat );

  closefile_(&file_handle, "read");
}

// to read array from a phasta file (filename)
// memory is allocated HERE for 'valueArray'
// `fieldName' tells which block to read like solution, error etc.
void readArrayFromFile( char *filename,
                        char *fieldName,
                        const char *data_type,
                        int isize,
                        int *iarray,
                        int asize,
                        void *valueArray) {
  // read file (i.e., geombc, restart, error etc.)
  // fileDescriptor
  int file_handle;
  // format of the file
  string iformat_str = "binary";
  char iformat[16];
  strcpy(iformat,iformat_str.c_str());

  openfile_( filename, "read",  &file_handle );

  readheader_( &file_handle, fieldName, iarray,
               &isize, data_type, iformat );

  readdatablock_( &file_handle, fieldName, valueArray, &asize,
                  data_type , iformat );

  closefile_(&file_handle, "read");
}

