#ifndef __phRead_H_
#define __phRead_H_

#include <strings.h>

#ifdef __cplusplus
extern "C" {
#endif

  // to read parameters from a phasta file (filename)
  // parameters correspond to header info for given field
  // these parameters are used as reference values
  // (sometimes needed before reading the field-array)
  void readParametersFromFile(char *filename,
                              char *fieldName,
                              const char *data_type,
                              int &isize,
                              int *iarray);

  // to read array from a phasta file (filename)
  // memory is allocated HERE for 'valueArray'
  // `fieldName' tells which block to read like solution, error etc.
  void readArrayFromFile( char *filename,
                          char *fieldName,
                          const char *data_type,
                          int isize,
                          int *iarray,
                          int asize,
                          void *valueArray);

#ifdef __cplusplus
}
#endif

#endif
