#include "subsample.h"

#include <iostream>

using std::cout;
using std::endl;

// set value of 1 in 'flag_for_points' to include point in subsample
void subsample_idx(int sub_option, int num_points, int nsd, double *coords, int *flag_for_points) {

  switch(sub_option) {
  case 0:
    subsample_idx_0(sub_option,num_points,nsd,coords,flag_for_points);
  break;
  case 1:
    subsample_idx_1(sub_option,num_points,nsd,coords,flag_for_points);
  break;
  default:
    cout<<"  Error in subsample_idx() : option ["<<sub_option<<"] NOT supported"<<endl;
  break;
  }

}

// set value of 1 in 'flag_for_points' to include point in subsample
void subsample_idx_0(int sub_option, int num_points, int nsd, double *coords, int *flag_for_points) {
  for(int i=0; i<num_points; i++)
    flag_for_points[i] = 1;
}

// set value of 1 in 'flag_for_points' to include point in subsample
void subsample_idx_1(int sub_option, int num_points, int nsd, double *coords, int *flag_for_points) {

  for(int i=0; i<num_points; i++) {
    double xyz[3]; // assuming nsd (number of space dimensions) to be 3
    for(int j=0; j<nsd; j++)
      xyz[j] = coords[i*nsd+j];

    // now one can check if point 'i' with 'xyz' is in some box(es)/zone(s)...
  }

}
