/*-------------------------------------------------------------------------
  Scientific Computation Research Center, RPI, Troy NY
  (C) Copyright 1995, RPI-SCOREC
 
  Project  : shapeFuntions
  Author(s): Saikat Dey
  Creation : Oct., 95
  Modifi.  : 
  Function :
             mode shape for a triangular face. i,j are highest order of
             r,s in the polynomial, maple generated code.
-------------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

double Fn(int i, int j, double r, double s) {
   double f = 0.0;
   double t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16,t17,t18;
   double t19,t20,t21,t22,t23,t24,t25,t26,t27,t28,t29,t30,t31,t32,t33,t34;
   double t35,t36,t37,t38,t39,t40,t41,t42,t43,t44,t45,t47,t50,t51;

   /* p=3 0 0 */
   if( i==0 && j==0 ) {
      f = 1.0;
   /* p=4 0 1 */
   } else if( i==0 && j==1 ) {
      f = s-1.0/3.0;
   /* p=4 1 0 */
   } else if( i==1 && j==0 ) {
      f = r-1.0/3.0;
   /* p=5 0 2 */
   } else if( i==0 && j==2 ) {
      t1 = s*s;
      f = t1-3.0/4.0*s+3.0/28.0;
   /* p=5 1 1 */
   } else if( i==1 && j==1 ) {
      f = r*s-r/4-s/4+1.0/14.0;
   /* p=5 2 0 */
   } else if( i==2 && j==0 ) {
      t1 = r*r;
      f = t1-3.0/4.0*r+3.0/28.0;
   /* p=6 0 3 */
   } else if( i==0 && j==3 ) {
      t1 = s*s;
      f = t1*s-6.0/5.0*t1+2.0/5.0*s-1.0/30.0;
   /* p=6 1 2 */
   } else if( i==1 && j==2 ) {
      t1 = s*s;
      f = r*t1-3.0/5.0*r*s+r/15-t1/5+2.0/15.0*s-1.0/60.0;
   /* p=6 2 1 */
   } else if( i==2 && j==1 ) {
      t1 = r*r;
      f = t1*s-t1/5-3.0/5.0*r*s+2.0/15.0*r+s/15-1.0/60.0;
   /* p=6 3 0 */
   } else if( i==3 && j==0 ) {
      t1 = r*r;
      f = r*t1-6.0/5.0*t1+2.0/5.0*r-1.0/30.0;
   /* p=7 0 4 */
   } else if( i==0 && j==4 ) {
      t1 = s*s;
      t2 = t1*t1;
      f = t2-5.0/3.0*t1*s+10.0/11.0*t1-2.0/11.0*s+1.0/99.0;
   /* p=7 1 3 */
   } else if( i==1 && j==3 ) {
      t1 = s*s;
      t2 = t1*s;
      f = r*t2-r*t1+3.0/11.0*r*s-r/55-t2/6+2.0/11.0*t1-3.0/55.0*s+2.0/495.0;
   /* p=7 2 2 */
   } else if( i==2 && j==2 ) {
      t1 = r*r;
      t2 = s*s;
      f = t1*t2-t1*s/2+t1/22-r*t2/2+3.0/11.0*r*s-3.0/110.0*r+t2/22-3.0/110.0*s
+1.0/330.0;
   /* p=7 3 1 */
   } else if( i==3 && j==1 ) {
      t1 = r*r;
      t2 = r*t1;
      f = t2*s-t2/6-t1*s+2.0/11.0*t1+3.0/11.0*r*s-3.0/55.0*r-s/55+2.0/495.0;
   /* p=7 4 0 */
   } else if( i==4 && j==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      f = t2-5.0/3.0*r*t1+10.0/11.0*t1-2.0/11.0*r+1.0/99.0;
   /* p=8 0 5 */
   } else if( i==0 && j==5 ) {
      t1 = s*s;
      t2 = t1*t1;
      f = t2*s-15.0/7.0*t2+150.0/91.0*t1*s-50.0/91.0*t1+75.0/1001.0*s-3.0/
1001.0;
   /* p=8 1 4 */
   } else if( i==1 && j==4 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = t1*s;
      f = r*t2-10.0/7.0*r*t4+60.0/91.0*r*t1-10.0/91.0*r*s+5.0/1001.0*r-t2/7+
20.0/91.0*t4-10.0/91.0*t1+20.0/1001.0*s-1.0/1001.0;
   /* p=8 2 3 */
   } else if( i==2 && j==3 ) {
      t1 = r*r;
      t2 = s*s;
      t3 = t2*s;
      f = t1*t3-6.0/7.0*t1*t2+18.0/91.0*t1*s-t1/91-3.0/7.0*r*t3+36.0/91.0*r*
t2-9.0/91.0*r*s+6.0/1001.0*r+3.0/91.0*t3-3.0/91.0*t2+9.0/1001.0*s-3.0/5005.0;
   /* p=8 3 2 */
   } else if( i==3 && j==2 ) {
      t1 = r*r;
      t2 = r*t1;
      t3 = s*s;
      f = t2*t3-3.0/7.0*t2*s+3.0/91.0*t2-6.0/7.0*t1*t3+36.0/91.0*t1*s-3.0/
91.0*t1+18.0/91.0*r*t3-9.0/91.0*r*s+9.0/1001.0*r-t3/91+6.0/1001.0*s-3.0/5005.0;
   /* p=8 4 1 */
   } else if( i==4 && j==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t4 = r*t1;
      f = t2*s-t2/7-10.0/7.0*t4*s+20.0/91.0*t4+60.0/91.0*t1*s-10.0/91.0*t1
-10.0/91.0*r*s+20.0/1001.0*r+5.0/1001.0*s-1.0/1001.0;
   /* p=8 5 0 */
   } else if( i==5 && j==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      f = r*t2-15.0/7.0*t2+150.0/91.0*r*t1-50.0/91.0*t1+75.0/1001.0*r-3.0/
1001.0;
   /* p=9 0 6 */
   } else if( i==0 && j==6 ) {
      t1 = s*s;
      t2 = t1*t1;
      f = t1*t2-21.0/8.0*t2*s+21.0/8.0*t2-5.0/4.0*t1*s+15.0/52.0*t1-3.0/104.0*
s+1.0/1144.0;
   /* p=9 1 5 */
   } else if( i==1 && j==5 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*s;
      t6 = t1*s;
      f = r*t3-15.0/8.0*r*t2+5.0/4.0*r*t6-5.0/14.0*r*t1+15.0/364.0*r*s-r/728-
t3/8+t2/4-5.0/28.0*t6+5.0/91.0*t1-5.0/728.0*s+1.0/4004.0;
   /* p=9 2 4 */
   } else if( i==2 && j==4 ) {
      t1 = r*r;
      t2 = s*s;
      t3 = t2*t2;
      t5 = t2*s;
      f = t1*t3-5.0/4.0*t1*t5+t1*t2/2-t1*s/14+t1/364-3.0/8.0*r*t3+r*t5/2-3.0/
14.0*r*t2+3.0/91.0*r*s-r/728+t3/40-t5/28+3.0/182.0*t2-s/364+1.0/8008.0;
   /* p=9 3 3 */
   } else if( i==3 && j==3 ) {
      t1 = r*r;
      t2 = r*t1;
      t3 = s*s;
      t4 = t3*s;
      f = t2*t4-3.0/4.0*t2*t3+3.0/20.0*t2*s-t2/140-3.0/4.0*t1*t4+3.0/5.0*t1*
t3-9.0/70.0*t1*s+3.0/455.0*t1+3.0/20.0*r*t4-9.0/70.0*r*t3+27.0/910.0*r*s-3.0/
1820.0*r-t4/140+3.0/455.0*t3-3.0/1820.0*s+1.0/10010.0;
   /* p=9 4 2 */
   } else if( i==4 && j==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = s*s;
      t6 = r*t1;
      f = t2*t3-3.0/8.0*t2*s+t2/40-5.0/4.0*t6*t3+t6*s/2-t6/28+t1*t3/2-3.0/
14.0*t1*s+3.0/182.0*t1-r*t3/14+3.0/91.0*r*s-r/364+t3/364-s/728+1.0/8008.0;
   /* p=9 5 1 */
   } else if( i==5 && j==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = r*t2;
      t6 = r*t1;
      f = t3*s-t3/8-15.0/8.0*t2*s+t2/4+5.0/4.0*t6*s-5.0/28.0*t6-5.0/14.0*t1*s
+5.0/91.0*t1+15.0/364.0*r*s-5.0/728.0*r-s/728+1.0/4004.0;
   /* p=9 6 0 */
   } else if( i==6 && j==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      f = t1*t2-21.0/8.0*r*t2+21.0/8.0*t2-5.0/4.0*r*t1+15.0/52.0*t1-3.0/104.0*
r+1.0/1144.0;
   /* p=10 0 7 */
   } else if( i==0 && j==7 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      f = t2*t3-28.0/9.0*t1*t3+196.0/51.0*t3*s-245.0/102.0*t3+245.0/306.0*t2
-7.0/51.0*t1+7.0/663.0*s-1.0/3978.0;
   /* p=10 1 6 */
   } else if( i==1 && j==6 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t1*t2;
      t5 = t2*s;
      t8 = t1*s;
      f = r*t3-7.0/3.0*r*t5+35.0/17.0*r*t2-175.0/204.0*r*t8+35.0/204.0*r*t1-r
*s/68+r/2652-t3/9+14.0/51.0*t5-35.0/136.0*t2+35.0/306.0*t8-5.0/204.0*t1+s/442
-1.0/15912.0;
   /* p=10 2 5 */
   } else if( i==2 && j==5 ) {
      t1 = r*r;
      t2 = s*s;
      t3 = t2*t2;
      t4 = t3*s;
      t7 = t2*s;
      f = t1*t4-5.0/3.0*t1*t3+50.0/51.0*t1*t7-25.0/102.0*t1*t2+5.0/204.0*t1*s
-t1/1428-r*t4/3+10.0/17.0*r*t3-25.0/68.0*r*t7+5.0/51.0*r*t2-5.0/476.0*r*s+r
/3094+t4/51-5.0/136.0*t3+5.0/204.0*t7-5.0/714.0*t2+5.0/6188.0*s-1.0/37128.0;
   /* p=10 3 4 */
   } else if( i==3 && j==4 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = s*s;
      t4 = t3*t3;
      t6 = t3*s;
      f = t2*t4-10.0/9.0*t2*t6+20.0/51.0*t2*t3-5.0/102.0*t2*s+t2/612-2.0/3.0*
t1*t4+40.0/51.0*t1*t6-5.0/17.0*t1*t3+2.0/51.0*t1*s-t1/714+2.0/17.0*r*t4-5.0/
34.0*r*t6+r*t3/17-r*s/119+r/3094-t4/204+t6/153-t3/357+2.0/4641.0*s-1.0/55692.0;
   /* p=10 4 3 */
   } else if( i==4 && j==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = s*s;
      t4 = t3*s;
      t8 = t1*r;
      f = t2*t4-2.0/3.0*t2*t3+2.0/17.0*t2*s-t2/204-10.0/9.0*t8*t4+40.0/51.0*
t8*t3-5.0/34.0*t8*s+t8/153+20.0/51.0*t1*t4-5.0/17.0*t1*t3+t1*s/17-t1/357-5.0/
102.0*r*t4+2.0/51.0*r*t3-r*s/119+2.0/4641.0*r+t4/612-t3/714+s/3094-1.0/55692.0;
   /* p=10 5 2 */
   } else if( i==5 && j==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = r*t2;
      t4 = s*s;
      t9 = t1*r;
      f = t3*t4-t3*s/3+t3/51-5.0/3.0*t2*t4+10.0/17.0*t2*s-5.0/136.0*t2+50.0/
51.0*t9*t4-25.0/68.0*t9*s+5.0/204.0*t9-25.0/102.0*t1*t4+5.0/51.0*t1*s-5.0/714.0
*t1+5.0/204.0*r*t4-5.0/476.0*r*s+5.0/6188.0*r-t4/1428+s/3094-1.0/37128.0;
   /* p=10 6 1 */
   } else if( i==6 && j==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*t2;
      t5 = r*t2;
      t8 = t1*r;
      f = t3*s-t3/9-7.0/3.0*t5*s+14.0/51.0*t5+35.0/17.0*t2*s-35.0/136.0*t2
-175.0/204.0*t8*s+35.0/306.0*t8+35.0/204.0*t1*s-5.0/204.0*t1-r*s/68+r/442+s
/2652-1.0/15912.0;
   /* p=10 7 0 */
   } else if( i==7 && j==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      f = t2*t3-28.0/9.0*t1*t3+196.0/51.0*r*t3-245.0/102.0*t3+245.0/306.0*t2
-7.0/51.0*t1+7.0/663.0*r-1.0/3978.0;
   /* p=11 0 8 */
   } else if( i==0 && j==8 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*s;
      f = t3-18.0/5.0*t2*t4+504.0/95.0*t1*t2-392.0/95.0*t2*s+588.0/323.0*t2
-147.0/323.0*t4+98.0/1615.0*t1-6.0/1615.0*s+3.0/41990.0;
   /* p=11 1 7 */
   } else if( i==1 && j==7 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t4 = t2*t3;
      t6 = t1*t3;
      t8 = t3*s;
      f = r*t4-14.0/5.0*r*t6+294.0/95.0*r*t8-98.0/57.0*r*t3+490.0/969.0*r*t2
-49.0/646.0*t1*r+49.0/9690.0*r*s-r/9690-t4/10+28.0/95.0*t6-98.0/285.0*t8+196.0/
969.0*t3-245.0/3876.0*t2+49.0/4845.0*t1-7.0/9690.0*s+1.0/62985.0;
   /* p=11 2 6 */
   } else if( i==2 && j==6 ) {
      t1 = r*r;
      t2 = s*s;
      t3 = t2*t2;
      t4 = t2*t3;
      t6 = t3*s;
      t9 = t2*s;
      t20 = 70.0/323.0*r*t9-105.0/2584.0*r*t2+21.0/6460.0*r*s-r/12920+3.0/190.0
*t4-7.0/190.0*t6+21.0/646.0*t3-35.0/2584.0*t9+7.0/2584.0*t2-3.0/12920.0*s+1.0/
167960.0;
      f = t1*t4-21.0/10.0*t1*t6+63.0/38.0*t1*t3-35.0/57.0*t1*t9+35.0/323.0*t1
*t2-21.0/2584.0*t1*s+7.0/38760.0*t1-3.0/10.0*r*t4+63.0/95.0*r*t6-21.0/38.0*r*t3
+t20;
   /* p=11 3 5 */
   } else if( i==3 && j==5 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = s*s;
      t4 = t3*t3;
      t5 = t4*s;
      t8 = t3*s;
      t17 = t2*t5-3.0/2.0*t2*t4+15.0/19.0*t2*t8-10.0/57.0*t2*t3+5.0/323.0*t2*s-
t2/2584-3.0/5.0*t1*t5+18.0/19.0*t1*t4-10.0/19.0*t1*t8+40.0/323.0*t1*t3-15.0/
1292.0*t1*s+t1/3230;
      t23 = 9.0/95.0*r*t5-3.0/19.0*r*t4+30.0/323.0*r*t8-15.0/646.0*r*t3+3.0/
1292.0*r*s-3.0/45220.0*r-t5/285+2.0/323.0*t4-5.0/1292.0*t8+t3/969-s/9044+1.0/
293930.0;
      f = t17+t23;
   /* p=11 4 4 */
   } else if( i==4 && j==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = s*s;
      t4 = t3*s;
      t6 = t1*r;
      t7 = t3*t3;
      t12 = 1.0/352716.0-t2*t4+t1/1938-5.0/3876.0*t6+t3/1938-5.0/3876.0*t4+t7
/969-s/13566-2.0/57.0*r*t7-20.0/57.0*t6*t3+2.0/969.0*r*s+20.0/19.0*t6*t4;
      t24 = -5.0/323.0*r*t3+40.0/323.0*t1*t3-t6*t7+40.0/969.0*t6*s+6.0/19.0*t1*
t7-20.0/57.0*t1*t4+t2*t7-5.0/323.0*t1*s+6.0/19.0*t2*t3-2.0/57.0*t2*s+40.0/969.0
*r*t4+t2/969-r/13566;
      f = t12+t24;
   /* p=11 5 3 */
   } else if( i==5 && j==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = r*t2;
      t4 = s*s;
      t5 = t4*s;
      t12 = t1*r;
      t16 = t3*t5-3.0/5.0*t3*t4+9.0/95.0*t3*s-t3/285-3.0/2.0*t2*t5+18.0/19.0*t2
*t4-3.0/19.0*t2*s+2.0/323.0*t2+15.0/19.0*t12*t5-10.0/19.0*t12*t4+30.0/323.0*t12
*s-5.0/1292.0*t12;
      t23 = -10.0/57.0*t1*t5+40.0/323.0*t1*t4-15.0/646.0*t1*s+t1/969+5.0/323.0*
r*t5-15.0/1292.0*r*t4+3.0/1292.0*r*s-r/9044-t5/2584+t4/3230-3.0/45220.0*s+1.0/
293930.0;
      f = t16+t23;
   /* p=11 6 2 */
   } else if( i==6 && j==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = s*s;
      t7 = r*t2;
      t12 = t1*r;
      t20 = 70.0/323.0*t12*s-35.0/2584.0*t12+35.0/323.0*t1*t4-105.0/2584.0*t1*s
+7.0/2584.0*t1-21.0/2584.0*r*t4+21.0/6460.0*r*s-3.0/12920.0*r+7.0/38760.0*t4-s
/12920+1.0/167960.0;
      f = t3*t4-3.0/10.0*t3*s+3.0/190.0*t3-21.0/10.0*t7*t4+63.0/95.0*t7*s-7.0
/190.0*t7+63.0/38.0*t2*t4-21.0/38.0*t2*s+21.0/646.0*t2-35.0/57.0*t12*t4+t20;
   /* p=11 7 1 */
   } else if( i==7 && j==1 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t4 = t2*t3;
      t6 = t1*t3;
      t8 = r*t3;
      f = t4*s-t4/10-14.0/5.0*t6*s+28.0/95.0*t6+294.0/95.0*t8*s-98.0/285.0*t8
-98.0/57.0*t3*s+196.0/969.0*t3+490.0/969.0*t2*s-245.0/3876.0*t2-49.0/646.0*t1*s
+49.0/4845.0*t1+49.0/9690.0*r*s-7.0/9690.0*r-s/9690+1.0/62985.0;
   /* p=11 8 0 */
   } else if( i==8 && j==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*r;
      f = t3-18.0/5.0*t2*t4+504.0/95.0*t2*t1-392.0/95.0*r*t2+588.0/323.0*t2
-147.0/323.0*t4+98.0/1615.0*t1-6.0/1615.0*r+3.0/41990.0;
   /* p=12 0 9 */
   } else if( i==0 && j==9 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*s;
      f = t3*s-45.0/11.0*t3+540.0/77.0*t2*t5-72.0/11.0*t2*t1+756.0/209.0*t2*s
-252.0/209.0*t2+840.0/3553.0*t5-90.0/3553.0*t1+9.0/7106.0*s-1.0/49742.0;
   /* p=12 1 8 */
   } else if( i==1 && j==8 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*s;
      t6 = t2*t5;
      t8 = t2*t1;
      t10 = t2*s;
      f = r*t3-36.0/11.0*r*t6+48.0/11.0*r*t8-168.0/55.0*r*t10+252.0/209.0*r*
t2-56.0/209.0*r*t5+112.0/3553.0*t1*r-6.0/3553.0*r*s+r/35530-t3/11+24.0/77.0*t6
-24.0/55.0*t8+336.0/1045.0*t10-28.0/209.0*t2+112.0/3553.0*t5-14.0/3553.0*t1+4.0
/17765.0*s-1.0/248710.0;
   /* p=12 2 7 */
   } else if( i==2 && j==7 ) {
      t1 = r*r;
      t2 = s*s;
      t3 = t2*s;
      t4 = t2*t2;
      t5 = t3*t4;
      t7 = t2*t4;
      t9 = t4*s;
      t19 = t1*t5-28.0/11.0*t1*t7+28.0/11.0*t1*t9-14.0/11.0*t1*t4+70.0/209.0*t1
*t3-28.0/627.0*t2*t1+28.0/10659.0*t1*s-t1/21318-3.0/11.0*r*t5+8.0/11.0*r*t7
-42.0/55.0*r*t9+84.0/209.0*r*t4;
      t23 = -70.0/627.0*r*t3+56.0/3553.0*r*t2-7.0/7106.0*r*s+r/53295+t5/77-2.0/
55.0*t7+42.0/1045.0*t9-14.0/627.0*t4+70.0/10659.0*t3-7.0/7106.0*t2+7.0/106590.0
*s-1.0/746130.0;
      f = t19+t23;
   /* p=12 3 6 */
   } else if( i==3 && j==6 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t1;
      t5 = r*r;
      t6 = r*t5;
      t7 = t1*s;
      t10 = t2*s;
      t21 = 6.0/77.0*r*t3-5.0/11.0*t6*t7+27.0/209.0*r*t2-9.0/55.0*r*t10+15.0/
11.0*t6*t2-21.0/11.0*t6*t10+t6*t3-1.0/1492260.0-10.0/209.0*r*t7+15.0/209.0*t6*
t1+12.0/3553.0*t5*s-6.0/11.0*t5*t3+12.0/11.0*t5*t10-9.0/11.0*t5*t2;
      t27 = 60.0/209.0*t5*t7-t6*s/209-t5/14212-10.0/209.0*t1*t5-5.0/14212.0*t1+
30.0/3553.0*t1*r-9.0/14212.0*r*s+6.0/1045.0*t10+20.0/10659.0*t7-t2/209+s/35530+
t6/10659+r/71060-t3/385;
      f = t21+t27;
   /* p=12 4 5 */
   } else if( i==4 && j==5 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = t2*s;
      t6 = r*r;
      t7 = r*t6;
      t13 = t1*s;
      t15 = t6*t6;
      t22 = 60.0/1463.0*r*t2-2.0/77.0*r*t4+100.0/77.0*t7*t2-25.0/49742.0*r*s+
400.0/74613.0*t1*r-10.0/11.0*t7*t4-200.0/4389.0*t6*t1-1.0/2089164.0-100.0/
4389.0*r*t13+15.0/1463.0*t15*s-30.0/77.0*t6*t2-10.0/77.0*t15*t1+50.0/77.0*t15*
t13+20.0/77.0*t6*t4+300.0/1463.0*t6*t13;
      t29 = t15*t4-15.0/11.0*t15*t2+100.0/24871.0*t6*s-50.0/4389.0*t7*s+200.0/
1463.0*t1*t7-t15/4389-5.0/49742.0*t6-25.0/149226.0*t1-5.0/4389.0*t2+t4/1463+5.0
/298452.0*s-50.0/77.0*t7*t13+50.0/74613.0*t13+r/74613+20.0/74613.0*t7;
      f = t22+t29;
   /* p=12 5 4 */
   } else if( i==5 && j==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = r*t2;
      t4 = s*s;
      t5 = t4*s;
      t10 = t4*t4;
      t12 = t1*r;
      t21 = -10.0/11.0*t5*t3+20.0/77.0*t3*t4+200.0/1463.0*t1*t5-5.0/4389.0*t2
-25.0/149226.0*t1-2.0/77.0*t3*s+15.0/1463.0*r*t10+50.0/77.0*t12*t10-25.0/
49742.0*r*s+100.0/24871.0*r*t4-200.0/4389.0*t1*t4-30.0/77.0*t2*t4+100.0/77.0*t5
*t2-10.0/77.0*t1*t10-15.0/11.0*t2*t10;
      t29 = 400.0/74613.0*t1*s+60.0/1463.0*t2*s-100.0/4389.0*t12*s+t3*t10+300.0
/1463.0*t12*t4-50.0/4389.0*r*t5-50.0/77.0*t12*t5+50.0/74613.0*t12+20.0/74613.0*
t5-t10/4389+t3/1463-5.0/49742.0*t4+s/74613+5.0/298452.0*r-1.0/2089164.0;
      f = t21+t29;
   /* p=12 6 3 */
   } else if( i==6 && j==3 ) {
      t1 = s*s;
      t2 = r*r;
      t3 = t2*t2;
      t4 = t3*t2;
      t6 = t1*s;
      t9 = r*t2;
      t12 = t3*r;
      t15 = -t1/14212-1.0/1492260.0-6.0/11.0*t1*t4+t4*t6+6.0/77.0*t4*s+20.0/
10659.0*t9-5.0/11.0*t9*t6-9.0/14212.0*r*s+6.0/1045.0*t12+12.0/11.0*t12*t1+t6
/10659-9.0/55.0*t12*s+s/71060+r/35530;
      t27 = -t4/385+27.0/209.0*t3*s-10.0/209.0*t9*s+30.0/3553.0*t2*s+15.0/209.0
*t2*t6+60.0/209.0*t9*t1-r*t6/209+15.0/11.0*t3*t6-t3/209-5.0/14212.0*t2-10.0/
209.0*t2*t1-21.0/11.0*t12*t6+12.0/3553.0*t1*r-9.0/11.0*t3*t1;
      f = t15+t27;
   /* p=12 7 2 */
   } else if( i==7 && j==2 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t4 = t3*t2;
      t5 = s*s;
      t8 = t3*t1;
      t11 = t3*r;
      t16 = t4*t5-3.0/11.0*t4*s+t4/77-28.0/11.0*t8*t5+8.0/11.0*t8*s-2.0/55.0*t8
+28.0/11.0*t11*t5-42.0/55.0*t11*s+42.0/1045.0*t11-14.0/11.0*t5*t3+84.0/209.0*t3
*s-14.0/627.0*t3;
      t23 = 70.0/209.0*t5*t2-70.0/627.0*t2*s+70.0/10659.0*t2-28.0/627.0*t1*t5+
56.0/3553.0*t1*s-7.0/7106.0*t1+28.0/10659.0*r*t5-7.0/7106.0*r*s+7.0/106590.0*r-
t5/21318+s/53295-1.0/746130.0;
      f = t16+t23;
   /* p=12 8 1 */
   } else if( i==8 && j==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*r;
      t6 = t5*t2;
      t8 = t2*t1;
      t10 = r*t2;
      f = t3*s-t3/11-36.0/11.0*t6*s+24.0/77.0*t6+48.0/11.0*t8*s-24.0/55.0*t8
-168.0/55.0*t10*s+336.0/1045.0*t10+252.0/209.0*t2*s-28.0/209.0*t2-56.0/209.0*t5
*s+112.0/3553.0*t5+112.0/3553.0*t1*s-14.0/3553.0*t1-6.0/3553.0*r*s+4.0/17765.0*
r+s/35530-1.0/248710.0;
   /* p=12 9 0 */
   } else if( i==9 && j==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*r;
      t9 = t3*r-45.0/11.0*t3+540.0/77.0*t5*t2-72.0/11.0*t2*t1+756.0/209.0*r*t2
-252.0/209.0*t2+840.0/3553.0*t5-90.0/3553.0*t1+9.0/7106.0*r-1.0/49742.0;
   /* p=13 0 10 */
   } else if( i==0 && j==10 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t6 = t1*s;
      f = t3*t1-55.0/12.0*t3*s+825.0/92.0*t3-225.0/23.0*t2*t6+150.0/23.0*t2*
t1-63.0/23.0*t2*s+315.0/437.0*t2-50.0/437.0*t6+75.0/7429.0*t1-25.0/59432.0*s+
1.0/178296.0;
   /* p=13 1 9 */
   } else if( i==1 && j==9 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t3*s;
      t7 = t1*s;
      t8 = t2*t7;
      t10 = t2*t1;
      t12 = t2*s;
      f = r*t4-15.0/4.0*r*t3+135.0/23.0*r*t8-1260.0/253.0*r*t10+630.0/253.0*r
*t12-189.0/253.0*r*t2+630.0/4807.0*r*t7-60.0/4807.0*r*t1+45.0/81719.0*r*s-5.0/
653752.0*r-t4/12+15.0/46.0*t3-135.0/253.0*t8+120.0/253.0*t10-63.0/253.0*t12+
378.0/4807.0*t2-70.0/4807.0*t7+120.0/81719.0*t1-45.0/653752.0*s+1.0/980628.0;
   /* p=13 2 8 */
   } else if( i==2 && j==8 ) {
      t1 = r*r;
      t2 = s*s;
      t3 = t2*t2;
      t4 = t3*s;
      t8 = t3*t3;
      t10 = t2*s;
      t11 = t3*t10;
      t17 = t3*t2;
      t19 = -588.0/253.0*t1*t4-28.0/4807.0*r*t2+24.0/81719.0*r*s+t1*t8-3.0*t1*
t11-4.0/4807.0*t1*s-63.0/253.0*r*t3-42.0/253.0*t1*t10+210.0/253.0*t1*t3+84.0/
23.0*t1*t17-42.0/1265.0*t4+28.0/81719.0*t2+t1/81719;
      t26 = -3.0/653752.0*r-14.0/4807.0*t10-3.0/163438.0*s+1.0/3268760.0+18.0/
23.0*r*t11-r*t8/4+252.0/4807.0*r*t10-252.0/253.0*r*t17+168.0/253.0*r*t4+84.0/
4807.0*t2*t1+63.0/4807.0*t3-9.0/253.0*t11+t8/92+12.0/253.0*t17;
      f = t19+t26;
   /* p=13 3 7 */
   } else if( i==3 && j==7 ) {
      t1 = r*r;
      t2 = r*t1;
      t3 = s*s;
      t4 = t3*t3;
      t5 = t3*s;
      t6 = t4*t5;
      t7 = t4*s;
      t9 = t4*t3;
      t14 = 1.0/7354710.0-t2/43263+14.0/4807.0*t4-t6/506-35.0/43263.0*t5-7.0/
980628.0*s+28.0/245157.0*t3-294.0/253.0*t1*t7+4.0/245157.0*t1-r/326876-7.0/
1265.0*t7+4.0/759.0*t9+28.0/23.0*t1*t9-14.0/4807.0*r*t3+14.0/81719.0*r*s-t1*t6
/2;
      t31 = -14.0/14421.0*t1*s-21.0/253.0*r*t4+84.0/4807.0*t1*t3-35.0/253.0*t1*
t5+140.0/253.0*t1*t4+105.0/4807.0*r*t5+49.0/23.0*t2*t7-7.0/3.0*t2*t9+7.0/4807.0
*t2*s-7.0/253.0*t3*t2+175.0/759.0*t2*t5-245.0/253.0*t2*t4+3.0/46.0*r*t6+t2*t6
-42.0/253.0*r*t9+42.0/253.0*r*t7;
      f = t14+t31;
   /* p=13 4 6 */
   } else if( i==4 && j==6 ) {
      t1 = s*s;
      t2 = t1*s;
      t4 = r*r;
      t5 = t4*t4;
      t7 = t1*t1;
      t8 = t7*s;
      t9 = t7*t1;
      t15 = 1.0/11767536.0+50.0/4807.0*r*t2+t5/19228+75.0/4807.0*t4*t1+15.0/
19228.0*t7-5.0/1961256.0*r-t8/1012+5.0/10626.0*t9-25.0/86526.0*t2-5.0/1307504.0
*s+25.0/490314.0*t1+5.0/245157.0*t4-105.0/253.0*t4*t8+5.0/23.0*t4*t9-25.0/
14421.0*r*t1+10.0/81719.0*r*s-5.0/4807.0*t4*s;
      t21 = t4*r;
      t34 = -15.0/506.0*r*t7-25.0/253.0*t4*t2+75.0/253.0*t4*t7+105.0/92.0*t5*t7
-175.0/506.0*t5*t2+15.0/4807.0*t21*s-5.0/86526.0*t21+t5*t9-7.0/4.0*t5*t8+25.0/
506.0*t5*t1-3.0/1012.0*t5*s+35.0/23.0*t21*t8-5.0/6.0*t21*t9-25.0/506.0*t21*t1+
250.0/759.0*t21*t2-525.0/506.0*t21*t7-5.0/253.0*r*t9+10.0/253.0*r*t8;
      f = t15+t34;
   /* p=13 5 5 */
   } else if( i==5 && j==5 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r*r;
      t7 = t1*s;
      t10 = t4*t4;
      t11 = t10*r;
      t14 = t2*s;
      t19 = t4*r;
      t26 = 1.0/13728792.0-75.0/7084.0*r*t2-125.0/100947.0*t4*s+500.0/33649.0*
t4*t1-125.0/1771.0*t4*t7+250.0/1771.0*t4*t2-5.0/4.0*t11*t2-375.0/506.0*t10*t7
-5.0/4.0*t10*t14+375.0/67298.0*r*t7+250.0/1771.0*t10*t1-75.0/7084.0*t10*s+375.0
/67298.0*t19*s+625.0/1771.0*t19*t7-375.0/506.0*t19*t2+25.0/3542.0*r*t14+t11*t14
+25.0/3542.0*t11*s;
      t35 = -t14/7084-25.0/253.0*t4*t14-25.0/201894.0*t7+50.0/1716099.0*t4-25.0
/253.0*t11*t1+50.0/1716099.0*t1-25.0/9152528.0*r-t11/7084-125.0/100947.0*r*t1+
125.0/1144066.0*r*s+25.0/46.0*t11*t7-25.0/9152528.0*s-125.0/1771.0*t19*t1-25.0/
201894.0*t19+25.0/46.0*t19*t14+15.0/67298.0*t10+75.0/46.0*t10*t2+15.0/67298.0*
t2;
      f = t26+t35;
   /* p=13 6 4 */
   } else if( i==6 && j==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = s*s;
      t5 = t4*t4;
      t7 = r*t2;
      t9 = t4*s;
      t25 = t3*t5-105.0/253.0*t4*t7-5.0/6.0*t3*t9-5.0/4807.0*t4*r+10.0/253.0*t7
*s+10.0/81719.0*r*s+35.0/23.0*t7*t9-25.0/14421.0*t1*s-3.0/1012.0*r*t5+75.0/
4807.0*t4*t1-25.0/506.0*t1*t9+25.0/506.0*t5*t1-7.0/4.0*t5*t7+105.0/92.0*t5*t2
-525.0/506.0*t2*t9+15.0/4807.0*r*t9+75.0/253.0*t4*t2;
      t28 = r*t1;
      t34 = -15.0/506.0*t2*s-5.0/253.0*t3*s+50.0/4807.0*t28*s-25.0/253.0*t28*t4
+5.0/23.0*t3*t4+250.0/759.0*t28*t9-175.0/506.0*t28*t5+15.0/19228.0*t2+25.0/
490314.0*t1-5.0/86526.0*t9+5.0/10626.0*t3-5.0/1307504.0*r+t5/19228-5.0/
1961256.0*s-t7/1012+5.0/245157.0*t4-25.0/86526.0*t28+1.0/11767536.0;
      f = t25+t34;
   /* p=13 7 3 */
   } else if( i==7 && j==3 ) {
      t1 = s*s;
      t3 = r*r;
      t4 = t3*t3;
      t5 = t4*t3;
      t6 = t1*s;
      t10 = t3*r;
      t11 = t4*t10;
      t14 = t4*r;
      t16 = 1.0/7354710.0-s/326876-14.0/14421.0*r*t1+4.0/245157.0*t1-7.0/3.0*t5
*t6+4.0/759.0*t5-7.0/980628.0*r+14.0/81719.0*r*s+140.0/253.0*t4*t1+t11*t6+14.0/
4807.0*t4-t11/506-t11*t1/2-t6/43263-7.0/1265.0*t14-294.0/253.0*t14*t1;
      t31 = 3.0/46.0*t11*s-35.0/43263.0*t10+175.0/759.0*t10*t6-21.0/253.0*t4*s
-245.0/253.0*t4*t6+49.0/23.0*t14*t6-35.0/253.0*t10*t1+7.0/4807.0*r*t6+28.0/
245157.0*t3-7.0/253.0*t3*t6+42.0/253.0*t14*s+84.0/4807.0*t3*t1-14.0/4807.0*t3*s
-42.0/253.0*t5*s+105.0/4807.0*t10*s+28.0/23.0*t5*t1;
      f = t16+t31;
   /* p=13 8 2 */
   } else if( i==8 && j==2 ) {
      t1 = r*r;
      t2 = r*t1;
      t4 = s*s;
      t7 = t1*t1;
      t8 = t7*t1;
      t11 = t7*r;
      t14 = t7*t7;
      t17 = 1.0/3268760.0+28.0/81719.0*t1+252.0/4807.0*t2*s+84.0/4807.0*t4*t1
-28.0/4807.0*t1*s-252.0/253.0*t8*s+84.0/23.0*t8*t4+168.0/253.0*t11*s-42.0/253.0
*t2*t4+t14/92-t14*s/4-14.0/4807.0*t2+t14*t4;
      t18 = t7*t2;
      t26 = -9.0/253.0*t18+63.0/4807.0*t7+24.0/81719.0*r*s+210.0/253.0*t7*t4
-63.0/253.0*t7*s+18.0/23.0*t18*s-3.0*t18*t4-42.0/1265.0*t11-3.0/653752.0*s-4.0/
4807.0*t4*r+t4/81719+12.0/253.0*t8-3.0/163438.0*r-588.0/253.0*t11*t4;
      f = t17+t26;
   /* p=13 9 1 */
   } else if( i==9 && j==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t3*r;
      t7 = r*t1;
      t8 = t7*t2;
      t10 = t2*t1;
      t12 = t2*r;
      f = t4*s-t4/12-15.0/4.0*t3*s+15.0/46.0*t3+135.0/23.0*t8*s-135.0/253.0*
t8-1260.0/253.0*t10*s+120.0/253.0*t10+630.0/253.0*t12*s-63.0/253.0*t12-189.0/
253.0*t2*s+378.0/4807.0*t2+630.0/4807.0*t7*s-70.0/4807.0*t7-60.0/4807.0*t1*s+
120.0/81719.0*t1+45.0/81719.0*r*s-45.0/653752.0*r-5.0/653752.0*s+1.0/980628.0;
   /* p=13 10 0 */
   } else if( i==10 && j==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t6 = r*t1;
      f = t3*t1-55.0/12.0*t3*r+825.0/92.0*t3-225.0/23.0*t2*t6+150.0/23.0*t2*
t1-63.0/23.0*t2*r+315.0/437.0*t2-50.0/437.0*t6+75.0/7429.0*t1-25.0/59432.0*r+
1.0/178296.0;
   /* p=14 0 11 */
   } else if( i==0 && j==11 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t4 = t3*t3;
      f = t4*t2-66.0/13.0*t4*t1+726.0/65.0*t4*s-363.0/26.0*t4+3267.0/299.0*t3
*t2-8316.0/1495.0*t3*t1+2772.0/1495.0*t3*s-594.0/1495.0*t3+297.0/5681.0*t2-22.0
/5681.0*t1+66.0/482885.0*s-3.0/1931540.0;
   /* p=14 1 10 */
   } else if( i==1 && j==10 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t3*t1;
      t6 = t3*s;
      t9 = t1*s;
      t10 = t2*t9;
      t12 = t2*t1;
      t14 = t2*s;
      t20 = r*t4-55.0/13.0*r*t6+99.0/13.0*r*t3-99.0/13.0*r*t10+1386.0/299.0*r*
t12-2646.0/1495.0*r*t14+126.0/299.0*r*t2-18.0/299.0*r*t9+27.0/5681.0*r*t1-r*s
/5681+r/482885;
      t21 = -t4/13+22.0/65.0*t6-33.0/52.0*t3+198.0/299.0*t10-126.0/299.0*t12+
252.0/1495.0*t14-63.0/1495.0*t2+36.0/5681.0*t9-3.0/5681.0*t1+2.0/96577.0*s-1.0/
3863080.0;
      f = t20+t21;
   /* p=14 2 9 */
   } else if( i==2 && j==9 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t6 = r*r;
      t7 = t2*t1;
      t9 = t1*s;
      t10 = t2*t9;
      t12 = t3*s;
      t14 = t2*s;
      t22 = 54.0/65.0*r*t3+648.0/312455.0*r*t1-252.0/65.0*t6*t7+324.0/65.0*t6*
t10+t6*t12-3.0/42493880.0+378.0/16445.0*t14+2646.0/1495.0*t6*t14-567.0/82225.0*
t2-7938.0/16445.0*t6*t2+81.0/312455.0*t6*s-45.0/13.0*t6*t3-378.0/16445.0*r*t9
-108.0/16445.0*t6*t1+252.0/3289.0*t6*t9;
      t29 = -7938.0/16445.0*r*t14+1512.0/1495.0*r*t7+2268.0/16445.0*r*t2-756.0/
16445.0*t7-9.0/260.0*t3-t6/312455+81.0/1495.0*t10-81.0/65.0*r*t10-27.0/312455.0
*r*s-36.0/312455.0*t1+6.0/5311735.0*r+3.0/325.0*t12+378.0/312455.0*t9+27.0/
5311735.0*s-3.0/13.0*r*t12;
      f = t22+t29;
   /* p=14 3 8 */
   } else if( i==3 && j==8 ) {
      t1 = r*r;
      t2 = r*t1;
      t3 = s*s;
      t4 = t3*s;
      t7 = t3*t3;
      t8 = t7*t3;
      t10 = t7*s;
      t13 = t7*t7;
      t15 = t7*t4;
      t25 = -1764.0/16445.0*t4*t2+168.0/16445.0*t3*t2+1008.0/325.0*t2*t8-588.0/
325.0*t2*t10+882.0/1495.0*t2*t7+t2*t13-3.0/106234700.0+36.0/7475.0*t15-6.0/
1562275.0*t1-72.0/1562275.0*r*s-54.0/325.0*r*t15+18.0/325.0*r*t13+1512.0/
1562275.0*r*t3-504.0/325.0*t1*t8+432.0/325.0*t1*t15-6.0/13.0*t1*t13-756.0/
82225.0*r*t4+432.0/1562275.0*t1*s;
      t35 = -504.0/82225.0*t3*t1+1008.0/16445.0*t4*t1-5292.0/16445.0*t1*t7+
7056.0/7475.0*t1*t10-10584.0/82225.0*r*t10+1512.0/7475.0*r*t8-36.0/13.0*t2*t15+
756.0/16445.0*r*t7-126.0/82225.0*t7-t13/650-504.0/82225.0*t8+336.0/82225.0*t10
-36.0/82225.0*t2*s+504.0/1562275.0*t4+48.0/26558675.0*s-56.0/1562275.0*t3+9.0/
1562275.0*t2+18.0/26558675.0*r;
      f = t25+t35;
   /* p=14 4 7 */
   } else if( i==4 && j==7 ) {
      t1 = r*r;
      t2 = r*t1;
      t3 = s*s;
      t4 = t3*s;
      t7 = t3*t3;
      t8 = t7*t3;
      t12 = t7*t4;
      t14 = t1*t1;
      t22 = t7*s;
      t24 = 4.0/312455.0*t2+8.0/15935205.0*r-14.0/937365.0*t3+14.0/15935205.0*s
+7.0/62491.0*t4-490.0/3289.0*t4*t2+56.0/3289.0*t3*t2+112.0/65.0*t2*t8+196.0/
299.0*t2*t7-28.0/937365.0*r*s-r*t12/65-1.0/63740820.0-294.0/16445.0*t14*t3+56.0
/3289.0*r*t7+14.0/16445.0*t14*s-10.0/13.0*t2*t12+49.0/299.0*t14*t4-49.0/65.0*
t14*t7+56.0/1495.0*r*t8+588.0/1495.0*t1*t22;
      t39 = -14.0/3289.0*r*t4+84.0/312455.0*t1*s-84.0/16445.0*t3*t1+140.0/
3289.0*t4*t1-588.0/3289.0*t1*t7-588.0/16445.0*r*t22-4.0/937365.0*t1-t14/82225+
588.0/325.0*t14*t22+t14*t12-28.0/13.0*t14*t8+168.0/312455.0*r*t3-28.0/65.0*t1*
t8+12.0/65.0*t1*t12+t12/2990-7.0/16445.0*t7+14.0/16445.0*t22-98.0/65.0*t2*t22
-14.0/16445.0*t8-14.0/16445.0*t2*s;
      f = t24+t39;
   /* p=14 5 6 */
   } else if( i==5 && j==6 ) {
      t1 = r*r;
      t2 = r*t1;
      t3 = s*s;
      t4 = t3*t3;
      t5 = t4*t3;
      t6 = t4*s;
      t8 = t3*s;
      t16 = t1*t1;
      t21 = t16*r;
      t24 = 75.0/3289.0*t3*t2+6.0/13.0*t2*t5-21.0/26.0*t2*t6+315.0/598.0*t4*t2
-3.0/124982.0*r*s+126.0/65.0*t16*t6-15.0/13.0*t16*t5+45.0/124982.0*r*t3-t1*t5
/13+21.0/598.0*t21*t3-15.0/6578.0*r*t8;
      t44 = t21*t5-21.0/13.0*t21*t6+105.0/299.0*t16*t8-63.0/32890.0*t21*s-63.0/
52.0*t16*t4+9.0/3289.0*t16*s+42.0/299.0*t1*t6-t1/187473+t21/32890-3.0/65780.0*
t16-1.0/84987760.0;
      f = 3.0/124982.0*t2-3.0/32890.0*t5+3.0/16445.0*t6-9.0/65780.0*t4-9.0/
6578.0*t2*s+r/2124694+3.0/62491.0*t8+3.0/5311735.0*s-t3/124982-525.0/3289.0*t2*
t8+t24+18.0/62491.0*t1*s-15.0/3289.0*t3*t1+100.0/3289.0*t1*t8-315.0/3289.0*t4*
t1-7.0/26.0*t21*t8-63.0/6578.0*r*t6+3.0/598.0*r*t5+63.0/65.0*t21*t4+45.0/6578.0
*r*t4-315.0/6578.0*t16*t3+t44;
   /* p=14 6 5 */
   } else if( i==6 && j==5 ) {
      t1 = r*r;
      t2 = s*s;
      t3 = t2*t2;
      t6 = t1*t1;
      t7 = r*t6;
      t9 = t3*s;
      t12 = t6*t1;
      t13 = t2*s;
      t24 = t1*r;
      t27 = 3.0/124982.0*t13+t12*t9-315.0/3289.0*t6*t2-1.0/84987760.0-3.0/
124982.0*r*s+3.0/5311735.0*r+s/2124694-9.0/6578.0*r*t13+105.0/299.0*t24*t3+3.0/
62491.0*t24-7.0/26.0*t24*t9;
      t44 = 75.0/3289.0*t1*t13-3.0/65780.0*t3-63.0/52.0*t6*t3-21.0/26.0*t7*t13
-3.0/32890.0*t12-t12*t2/13+3.0/16445.0*t7+42.0/299.0*t7*t2-15.0/6578.0*t24*s-t1
/124982+21.0/598.0*t1*t9;
      f = -315.0/6578.0*t3*t1-15.0/3289.0*t1*t2-63.0/6578.0*t7*s-63.0/32890.0
*r*t9+9.0/3289.0*r*t3+6.0/13.0*t12*t13+3.0/598.0*t12*s-21.0/13.0*t7*t9+45.0/
124982.0*t1*s+126.0/65.0*t7*t3+t27+t9/32890+45.0/6578.0*t6*s-9.0/65780.0*t6+
18.0/62491.0*r*t2-t2/187473+315.0/598.0*t6*t13-525.0/3289.0*t24*t13+100.0/
3289.0*t24*t2+63.0/65.0*t6*t9-15.0/13.0*t12*t3+t44;
   /* p=14 7 4 */
   } else if( i==7 && j==4 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t4 = t3*t2;
      t5 = s*s;
      t6 = t5*s;
      t9 = r*t3;
      t12 = t5*t5;
      t20 = t3*t1;
      t24 = -1.0/63740820.0-14.0/937365.0*t1-10.0/13.0*t4*t6+12.0/65.0*t4*t5
-98.0/65.0*t6*t9+56.0/3289.0*t6*t1+t4*t12-588.0/3289.0*t3*t5-294.0/16445.0*t1*
t12-84.0/16445.0*t1*t5+588.0/325.0*t12*t9-588.0/16445.0*t9*s+14.0/16445.0*r*t12
+56.0/1495.0*t20*s+t4/2990-14.0/16445.0*t20-t4*s/65+14.0/16445.0*t9+140.0/
3289.0*t2*t5-t12/82225;
      t39 = -49.0/65.0*t12*t3-7.0/16445.0*t3+7.0/62491.0*t2-28.0/937365.0*r*s
-4.0/937365.0*t5+84.0/312455.0*r*t5+14.0/15935205.0*r+4.0/312455.0*t6+8.0/
15935205.0*s-14.0/16445.0*r*t6+56.0/3289.0*t3*s+49.0/299.0*t12*t2-490.0/3289.0*
t6*t2+196.0/299.0*t6*t3+588.0/1495.0*t9*t5-14.0/3289.0*t2*s-28.0/65.0*t20*t5
-28.0/13.0*t20*t12+112.0/65.0*t20*t6+168.0/312455.0*t1*s;
      f = t24+t39;
   /* p=14 8 3 */
   } else if( i==8 && j==3 ) {
      t2 = s*s;
      t4 = t2*s;
      t6 = r*r;
      t7 = t6*r;
      t8 = t6*t6;
      t10 = t8*t8;
      t16 = t8*t6;
      t18 = t8*t7;
      t22 = 48.0/26558675.0*r-72.0/1562275.0*r*s+432.0/1562275.0*r*t2-36.0/
82225.0*r*t4+504.0/1562275.0*t7+756.0/16445.0*t8*s-126.0/82225.0*t8-6.0/13.0*
t10*t2+1008.0/16445.0*t7*t2+882.0/1495.0*t8*t4+18.0/325.0*t10*s-1764.0/16445.0*
t7*t4-504.0/325.0*t16*t2-504.0/82225.0*t16-36.0/13.0*t18*t4+36.0/7475.0*t18
-54.0/325.0*t18*s-756.0/82225.0*t7*s;
      t23 = t8*r;
      t35 = 336.0/82225.0*t23+7056.0/7475.0*t23*t2-504.0/82225.0*t6*t2-5292.0/
16445.0*t8*t2+168.0/16445.0*t6*t4-56.0/1562275.0*t6-588.0/325.0*t23*t4+t10*t4+
432.0/325.0*t18*t2+1512.0/7475.0*t16*s+1008.0/325.0*t16*t4-10584.0/82225.0*t23*
s+1512.0/1562275.0*t6*s+9.0/1562275.0*t4+18.0/26558675.0*s-3.0/106234700.0-6.0/
1562275.0*t2-t10/650;
      f = t22+t35;
   /* p=14 9 2 */
   } else if( i==9 && j==2 ) {
      t1 = s*s;
      t4 = r*r;
      t5 = t4*t4;
      t6 = t5*t5;
      t9 = t6*r;
      t12 = r*t4;
      t15 = t5*r;
      t18 = t5*t12;
      t20 = t5*t4;
      t24 = 81.0/312455.0*r*t1-27.0/312455.0*r*s+54.0/65.0*t6*s+2268.0/16445.0*
t5*s+t9*t1-3.0/13.0*t9*s+252.0/3289.0*t12*t1-45.0/13.0*t6*t1+2646.0/1495.0*t15*
t1-378.0/16445.0*t12*s-81.0/65.0*t18*s-3.0/42493880.0+1512.0/1495.0*t20*s+648.0
/312455.0*t4*s-7938.0/16445.0*t15*s;
      t29 = -36.0/312455.0*t4+324.0/65.0*t18*t1-7938.0/16445.0*t5*t1-108.0/
16445.0*t4*t1-252.0/65.0*t20*t1+81.0/1495.0*t18-756.0/16445.0*t20+378.0/16445.0
*t15+3.0/325.0*t9+378.0/312455.0*t12-567.0/82225.0*t5-9.0/260.0*t6+6.0/
5311735.0*s+27.0/5311735.0*r-t1/312455;
      f = t24+t29;
   /* p=14 10 1 */
   } else if( i==10 && j==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t3*t1;
      t6 = t3*r;
      t9 = r*t1;
      t10 = t2*t9;
      t12 = t2*t1;
      t14 = r*t2;
      t16 = t4*s-t4/13-55.0/13.0*t6*s+22.0/65.0*t6+99.0/13.0*t3*s-33.0/52.0*t3
-99.0/13.0*t10*s+198.0/299.0*t10+1386.0/299.0*t12*s-126.0/299.0*t12-2646.0/
1495.0*t14*s;
      t21 = 252.0/1495.0*t14+126.0/299.0*t2*s-63.0/1495.0*t2-18.0/299.0*t9*s+
36.0/5681.0*t9+27.0/5681.0*t1*s-3.0/5681.0*t1-r*s/5681+2.0/96577.0*r+s/482885
-1.0/3863080.0;
      f = t16+t21;
   /* p=14 11 0 */
   } else if( i==11 && j==0 ) {
      t1 = r*r;
      t2 = r*t1;
      t3 = t1*t1;
      t4 = t3*t3;
      f = t4*t2-66.0/13.0*t4*t1+726.0/65.0*r*t4-363.0/26.0*t4+3267.0/299.0*t3
*t2-8316.0/1495.0*t3*t1+2772.0/1495.0*t3*r-594.0/1495.0*t3+297.0/5681.0*t2-22.0
/5681.0*t1+66.0/482885.0*r-3.0/1931540.0;
   /* p=15 0 12 */
   } else if( i==0 && j==12 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*s;
      f = t3*t2-39.0/7.0*t3*t5+286.0/21.0*t3*t1-1210.0/63.0*t3*s+121.0/7.0*t3
-363.0/35.0*t2*t5+484.0/115.0*t2*t1-132.0/115.0*t2*s+33.0/161.0*t2-11.0/483.0*
t5+22.0/15295.0*t1-2.0/45885.0*s+1.0/2340135.0;
   /* p=15 1 11 */
   } else if( i==1 && j==11 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t4 = t3*t3;
      t5 = t4*t2;
      t7 = t4*t1;
      t9 = t4*s;
      t12 = t3*t2;
      t14 = t3*t1;
      t16 = t3*s;
      t22 = r*t5-33.0/7.0*r*t7+605.0/63.0*r*t9-3025.0/273.0*r*t4+726.0/91.0*r*
t12-242.0/65.0*r*t14+1694.0/1495.0*r*t16-66.0/299.0*t3*r+55.0/2093.0*r*t2-11.0/
6279.0*r*t1+11.0/198835.0*r*s-r/1789515;
      t23 = -t5/14+22.0/63.0*t7-605.0/819.0*t9+242.0/273.0*t4-121.0/182.0*t12+
484.0/1495.0*t14-154.0/1495.0*t16+44.0/2093.0*t3-11.0/4186.0*t2+22.0/119301.0*
t1-11.0/1789515.0*s+2.0/30421755.0;
      f = t22+t23;
   /* p=15 2 10 */
   } else if( i==2 && j==10 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = r*r;
      t5 = t1*s;
      t6 = t2*t5;
      t9 = t2*t2;
      t13 = t2*s;
      t15 = t2*t1;
      t17 = t9*t1;
      t19 = t9*s;
      t25 = t2/299-t3*s/12558-550.0/91.0*t3*t6+20.0/2093.0*r*t5+275.0/42.0*t3*
t9+5.0/2093.0*t3*t1-10.0/299.0*t3*t5-77.0/65.0*t3*t13+44.0/13.0*t3*t15+t3*t17
-55.0/14.0*t3*t19-275.0/182.0*r*t9-21.0/299.0*r*t2+55.0/63.0*r*t19+462.0/1495.0
*r*t13+t3/1193010;
      t32 = -11.0/182.0*t6+3.0/79534.0*t1-3.0/4186.0*r*t1-s/715806-t5/2093-r
/3579030+11.0/299.0*t15-11.0/13.0*r*t15+r*s/39767+132.0/91.0*r*t6+1.0/
60843510.0-3.0/14.0*r*t17+11.0/182.0*t9-55.0/1638.0*t19+t17/126-21.0/1495.0*t13
+77.0/299.0*t3*t2;
      f = t25+t32;
   /* p=15 3 9 */
   } else if( i==3 && j==9 ) {
      t1 = r*r;
      t2 = s*s;
      t4 = t2*s;
      t6 = t2*t2;
      t8 = t6*s;
      t11 = t1*r;
      t12 = t6*t2;
      t15 = t6*t6;
      t16 = t15*s;
      t21 = t6*t4;
      t28 = 48.0/23023.0*t2*t1-84.0/3289.0*t4*t1+252.0/1495.0*t1*t6-42.0/65.0*
t1*t8+27.0/2187185.0*r*s+2.0/334639305.0-40.0/13.0*t11*t12-21.0/65.0*t11*t6+t11
*t16-45.0/14.0*t11*t15+3.0/23023.0*t11*s-36.0/115115.0*r*t2-180.0/91.0*t1*t21+
12.0/3289.0*r*t4+10.0/7.0*t1*t15-9.0/115115.0*t1*s-r/6561555+8.0/1495.0*t12+
14.0/299.0*t11*t4+96.0/65.0*t1*t12;
      t39 = -3.0/7.0*t1*t16-15.0/91.0*r*t15-378.0/16445.0*r*t6+r*t16/21+126.0/
1495.0*r*t8+2.0/2187185.0*t1+108.0/455.0*r*t21+24.0/2187185.0*t2-12.0/3289.0*
t11*t2-42.0/16445.0*t8+12.0/16445.0*t6-t16/819+2.0/455.0*t15+84.0/65.0*t11*t8-s
/2187185-2.0/16445.0*t4-t11/690690-12.0/65.0*r*t12-3.0/455.0*t21+30.0/7.0*t11*
t21;
      f = t28+t39;
   /* p=15 4 8 */
   } else if( i==4 && j==8 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*s;
      t4 = r*r;
      t5 = r*t4;
      t6 = t2*t1;
      t10 = t2*t2;
      t14 = t1*s;
      t17 = 4.0/937365.0*t1+2.0/9867.0*t2-28.0/49335.0*t3-80.0/39.0*t5*t6+224.0
/195.0*t5*t3-14.0/39.0*t5*t2-5.0/7.0*t5*t10+16.0/69069.0*t5*s-56.0/9867.0*t5*t1
+56.0/897.0*t5*t14-8.0/49335.0*t1*r;
      t18 = t2*t14;
      t20 = t4*t4;
      t31 = 40.0/21.0*t5*t18-14.0/195.0*t20*t14+16.0/455.0*r*t18-40.0/91.0*t4*
t18-8.0/115115.0*t4*s+16.0/9867.0*t4*t1-56.0/195.0*t4*t3+32.0/65.0*t6*t4-10.0/
819.0*r*t10+28.0/65.0*t20*t2-4.0/16445.0*t20*s;
      t37 = 112.0/4485.0*t3*r-56.0/39.0*t20*t3-t5/345345-t18/1365-18.0/7.0*t20*
t18+t20/345345+t10/4095+16.0/2187185.0*r*s-2.0/49335.0*t14+4.0/4485.0*t6-4.0/
19684665.0*s;
      t47 = -8.0/195.0*r*t6-2.0/19684665.0*r+t20*t10+1.0/334639305.0+28.0/
4485.0*t20*t1+8.0/3.0*t20*t6-28.0/3289.0*r*t2+28.0/299.0*t4*t2-56.0/3289.0*t4*
t14+10.0/63.0*t4*t10+16.0/9867.0*r*t14+2.0/2187185.0*t4;
      f = t17+t31+t37+t47;
   /* p=15 5 7 */
   } else if( i==5 && j==7 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t1;
      t6 = r*r;
      t7 = t6*t6;
      t8 = t7*r;
      t9 = t2*s;
      t11 = t1*s;
      t12 = t11*t2;
      t14 = t6*r;
      t22 = 2.0/1003917915.0-t3*r/117+r*s/187473+14.0/9.0*t8*t9-15.0/14.0*t7*
t12-100.0/117.0*t14*t3+28.0/39.0*t14*t9+10.0/29601.0*t14*s-70.0/9867.0*t14*t1+
175.0/2691.0*t14*t11-r*t1/9867+25.0/63.0*t14*t12;
      t33 = -35.0/234.0*t7*t11+r*t12/273-50.0/819.0*t6*t12-2.0/29601.0*t6*s+
40.0/29601.0*t1*t6-2.0*t8*t3-350.0/29601.0*t11*t6+16.0/117.0*t6*t3+28.0/39.0*t7
*t2-35.0/9867.0*r*t2-t8/148005-7.0/49335.0*t9;
      t38 = -t11/59202-s/8436285-r/11810799+2.0/13455.0*t3+140.0/2691.0*t6*t2+
25.0/29601.0*r*t11+4.0/3936933.0*t6+2.0/937365.0*t1+2.0/29601.0*t2-35.0/117.0*
t2*t14+2.0/207207.0*t7-t12/16380;
      t50 = -t14/207207+7.0/13455.0*t8*s+t8*t12+14.0/897.0*t7*t1-7.0/585.0*t1*
t8+20.0/9.0*t7*t3-70.0/117.0*t8*t2+14.0/117.0*t11*t8-7.0/9867.0*t7*s+7.0/897.0*
r*t9-14.0/117.0*t6*t9-70.0/39.0*t7*t9;
      f = t22+t33+t38+t50;
   /* p=15 6 6 */
   } else if( i==6 && j==6 ) {
      t1 = r*r;
      t2 = r*t1;
      t3 = s*s;
      t4 = t3*t3;
      t5 = t4*t3;
      t7 = t4*s;
      t10 = t3*s;
      t12 = t1*t1;
      t14 = t12*t1;
      t19 = r*t12;
      t21 = -25.0/117.0*t2*t5+14.0/39.0*t7*t2-35.0/156.0*t4*t2+1.0/573667380.0
-175.0/19734.0*t1*t10+t1/749892-35.0/156.0*t12*t10-t14*s/780+5.0/9867.0*r*t10-
t1*s/13156+25.0/19734.0*t3*t1-3.0/2.0*t19*t5;
      t34 = 35.0/1196.0*t4*t1-7.0/156.0*t7*t1+t1*t5/39+21.0/26.0*t12*t4-21.0/
13156.0*r*t4-21.0/13156.0*t12*s+7.0/2990.0*t7*r-35.0/26.0*t7*t12-7.0/156.0*t19*
t3+14.0/39.0*t19*t10+t14*t5+t14*t3/39;
      t42 = 5.0/9867.0*t2*s-175.0/19734.0*t3*t2+175.0/2691.0*t2*t10-t3*r/13156+
t3/749892-t2/118404+t12/39468-3.0/2.0*t14*t7-7.0/197340.0*t19-7.0/197340.0*t7+
3.0/624910.0*r*s-t10/118404;
      t51 = 7.0/3.0*t19*t7+t4/39468+t14/53820-r*t5/780-s/11248380+t5/53820-r
/11248380+5.0/6.0*t14*t4+35.0/1196.0*t12*t3-25.0/117.0*t14*t10+5.0/6.0*t12*t5
-35.0/26.0*t19*t4+7.0/2990.0*t19*s;
      f = t21+t34+t42+t51;
   /* p=15 7 5 */
   } else if( i==7 && j==5 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = s*s;
      t5 = t4*t4;
      t7 = t1*r;
      t8 = t7*t2;
      t11 = t5*s;
      t13 = t4*s;
      t14 = t2*r;
      t20 = 20.0/9.0*t3*t5+2.0/1003917915.0-50.0/819.0*t8*t4+t8*s/273+t11*t8-
t13/207207-7.0/49335.0*t14+r*s/187473+14.0/9.0*t14*t11-2.0*t3*t11+14.0/117.0*t7
*t11-35.0/234.0*t7*t5;
      t33 = 16.0/117.0*t4*t3+25.0/29601.0*t7*s-350.0/29601.0*t7*t4+175.0/2691.0
*t7*t13-2.0/29601.0*r*t4-35.0/117.0*t2*t13+25.0/63.0*t8*t13+10.0/29601.0*r*t13-
t1*s/9867+40.0/29601.0*t4*t1-70.0/9867.0*t1*t13+14.0/897.0*t1*t5;
      t47 = -7.0/585.0*t1*t11+28.0/39.0*t2*t5-7.0/9867.0*r*t5-35.0/9867.0*t2*s+
7.0/13455.0*r*t11-70.0/117.0*t2*t11-14.0/117.0*t14*t4+28.0/39.0*t14*t13-100.0/
117.0*t3*t13-15.0/14.0*t8*t5-70.0/39.0*t14*t5+140.0/2691.0*t4*t2;
      t50 = 7.0/897.0*t14*s+2.0/13455.0*t3+2.0/207207.0*t5+4.0/3936933.0*t4-s
/11810799-t11/148005-t8/16380-r/8436285+2.0/29601.0*t2-t7/59202+2.0/937365.0*t1
-t3*s/117;
      f = t20+t33+t47+t50;
   /* p=15 8 4 */
   } else if( i==8 && j==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = s*s;
      t5 = t4*s;
      t7 = t1*r;
      t9 = t4*t4;
      t10 = t2*t1;
      t12 = t7*t2;
      t13 = 1.0/334639305.0-5.0/7.0*t3*t5-2.0/49335.0*t7+2.0/9867.0*t2+16.0/
2187185.0*r*s+t3/4095-t5/345345+t9/345345+8.0/3.0*t10*t9-t12/1365+4.0/4485.0*
t10;
      t22 = -10.0/819.0*t3*s-2.0/19684665.0*s-4.0/19684665.0*r+2.0/2187185.0*t4
-40.0/91.0*t12*t4+16.0/455.0*t12*s+10.0/63.0*t4*t3-14.0/195.0*t7*t9+32.0/65.0*
t10*t4+16.0/9867.0*t7*s-56.0/3289.0*t7*t4;
      t27 = t2*r;
      t34 = -8.0/115115.0*r*t4-14.0/39.0*t2*t5+28.0/299.0*t4*t2-56.0/195.0*t27*
t4-28.0/49335.0*t27+224.0/195.0*t27*t5-28.0/3289.0*t2*s+28.0/4485.0*t1*t9+4.0/
937365.0*t1-8.0/195.0*t10*s+40.0/21.0*t12*t5;
      t47 = 16.0/69069.0*r*t5-8.0/49335.0*t1*s+16.0/9867.0*t4*t1-56.0/9867.0*t1
*t5+28.0/65.0*t2*t9-4.0/16445.0*r*t9-80.0/39.0*t10*t5-18.0/7.0*t12*t9-56.0/39.0
*t27*t9+112.0/4485.0*t27*s+t3*t9+56.0/897.0*t7*t5;
      f = t13+t22+t34+t47;
   /* p=15 9 3 */
   } else if( i==9 && j==3 ) {
      t1 = s*s;
      t3 = r*r;
      t4 = t3*t3;
      t6 = t4*t3;
      t9 = t3*r;
      t10 = t4*t9;
      t12 = t4*t4;
      t16 = t12*r;
      t17 = t1*s;
      t27 = r*t4;
      t30 = -9.0/115115.0*r*t1+252.0/1495.0*t4*t1+96.0/65.0*t6*t1-12.0/65.0*t6*
s+2.0/334639305.0+108.0/455.0*t10*s-15.0/91.0*t12*s+27.0/2187185.0*r*s+10.0/7.0
*t12*t1+t16*t17+12.0/3289.0*t9*s-84.0/3289.0*t1*t9+14.0/299.0*t9*t17-21.0/65.0*
t4*t17+30.0/7.0*t10*t17+3.0/23023.0*r*t17-12.0/3289.0*t3*t17-378.0/16445.0*t4*s
-42.0/65.0*t27*t1+84.0/65.0*t27*t17;
      t39 = -40.0/13.0*t6*t17+t16*s/21-3.0/7.0*t16*t1+126.0/1495.0*t27*s+8.0/
1495.0*t6+12.0/16445.0*t4-2.0/16445.0*t9-t16/819-s/6561555+2.0/455.0*t12-t17
/690690-180.0/91.0*t10*t1+2.0/2187185.0*t1-3.0/455.0*t10-r/2187185-42.0/16445.0
*t27+48.0/23023.0*t3*t1+24.0/2187185.0*t3-36.0/115115.0*t3*s-45.0/14.0*t12*t17;
      f = t30+t39;
   /* p=15 10 2 */
   } else if( i==10 && j==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t3*r;
      t5 = t3*t1;
      t6 = s*s;
      t8 = t2*t1;
      t10 = r*t1;
      t11 = t2*t10;
      t15 = 1.0/60843510.0-55.0/1638.0*t4+t5*t6+44.0/13.0*t8*t6-t10/2093+11.0/
299.0*t8+t2/299+t5/126+11.0/182.0*t3-s/3579030-550.0/91.0*t11*t6-11.0/182.0*t11
-r/715806+t6/1193010+132.0/91.0*t11*s+r*s/39767;
      t18 = t2*r;
      t32 = 275.0/42.0*t3*t6-3.0/14.0*t5*s-77.0/65.0*t18*t6-55.0/14.0*t4*t6+
77.0/299.0*t2*t6+462.0/1495.0*t18*s+55.0/63.0*t4*s-21.0/1495.0*t18+3.0/79534.0*
t1-3.0/4186.0*t1*s+20.0/2093.0*t10*s-10.0/299.0*t10*t6-r*t6/12558-11.0/13.0*t8*
s+5.0/2093.0*t6*t1-21.0/299.0*t2*s-275.0/182.0*t3*s;
      f = t15+t32;
   /* p=15 11 1 */
   } else if( i==11 && j==1 ) {
      t1 = r*r;
      t2 = r*t1;
      t3 = t1*t1;
      t4 = t3*t3;
      t5 = t4*t2;
      t7 = t4*t1;
      t9 = r*t4;
      t12 = t3*t2;
      t14 = t3*t1;
      t16 = t5*s-t5/14-33.0/7.0*t7*s+22.0/63.0*t7+605.0/63.0*t9*s-605.0/819.0*
t9-3025.0/273.0*t4*s+242.0/273.0*t4+726.0/91.0*t12*s-121.0/182.0*t12-242.0/65.0
*t14*s+484.0/1495.0*t14;
      t17 = t3*r;
      t23 = 1694.0/1495.0*t17*s-154.0/1495.0*t17-66.0/299.0*t3*s+44.0/2093.0*t3
+55.0/2093.0*t2*s-11.0/4186.0*t2-11.0/6279.0*t1*s+22.0/119301.0*t1+11.0/
198835.0*r*s-11.0/1789515.0*r-s/1789515+2.0/30421755.0;
      f = t16+t23;
   /* p=15 12 0 */
   } else if( i==12 && j==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = r*t1;
      f = t3*t2-39.0/7.0*t3*t5+286.0/21.0*t3*t1-1210.0/63.0*t3*r+121.0/7.0*t3
-363.0/35.0*t2*t5+484.0/115.0*t2*t1-132.0/115.0*t2*r+33.0/161.0*t2-11.0/483.0*
t5+22.0/15295.0*t1-2.0/45885.0*r+1.0/2340135.0;
    }
    return f;
}
#ifdef __cplusplus
}
#endif
