/*-------------------------------------------------------------------------
  Scientific Computation Research Center, RPI, Troy NY
  (C) Copyright 1995, RPI-SCOREC
 
  Project  : shapeFuntions
  Author(s): Saikat Dey
  Creation : Oct., 95
  Modifi.  : 
  Function :
             derivatives of the "body" mode of a tet., Maple generated code.
             i,j,k represent the highest monomila order of r,s,t in the
             polynomial.
-------------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int BnDrv(int i,int j, int k, double r, double s, double t, double drv[3]) {
   double t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16,t17,t18;
   double t19,t20,t21,t22,t23,t24,t25,t26,t27,t28,t29,t30,t31,t32,t33,t34;
   double t35,t36,t37,t38,t39,t40,t41,t42,t43,t44,t45,t46;

   /* p=4 0 0 0 */
   if( i==0 && j==0 && k==0 ) {
      drv[0] = 0.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
   /* p=5 0 0 1 */
   } else if( i==0 && j==0 && k==1 ) {
      drv[0] = 2.0/3.0;
      drv[1] = 2.0/3.0;
      drv[2] = 1.0;
   /* p=5 0 1 0 */
   } else if( i==0 && j==1 && k==0 ) {
      drv[0] = 2.0/5.0;
      drv[1] = 1.0;
      drv[2] = 0.0;
   /* p=5 1 0 0 */
   } else if( i==1 && j==0 && k==0 ) {
      drv[0] = 1.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
   /* p=6 0 0 2 */
   } else if( i==0 && j==0 && k==2 ) {
      t1 = 6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0;
      drv[0] = t1;
      drv[1] = t1;
      drv[2] = 2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0;
   /* p=6 0 1 1 */
   } else if( i==0 && j==1 && k==1 ) {
      drv[0] = 2.0/7.0*t+6.0/7.0*s+8.0/21.0*r-8.0/21.0;
      drv[1] = t+4.0/3.0*s+6.0/7.0*r-6.0/7.0;
      drv[2] = s+2.0/7.0*r-2.0/7.0;
   /* p=6 0 2 0 */
   } else if( i==0 && j==2 && k==0 ) {
      drv[0] = 6.0/7.0*s+2.0/7.0*r-2.0/7.0;
      drv[1] = 2.0*s+6.0/7.0*r-6.0/7.0;
      drv[2] = 0.0;
   /* p=6 1 0 1 */
   } else if( i==1 && j==0 && k==1 ) {
      drv[0] = t+2.0/3.0*s+4.0/3.0*r-22.0/27.0;
      drv[1] = 2.0/3.0*r-4.0/27.0;
      drv[2] = r-2.0/9.0;
   /* p=6 1 1 0 */
   } else if( i==1 && j==1 && k==0 ) {
      drv[0] = s+4.0/5.0*r-22.0/45.0;
      drv[1] = r-2.0/9.0;
      drv[2] = 0.0;
   /* p=6 2 0 0 */
   } else if( i==2 && j==0 && k==0 ) {
      drv[0] = 2.0*r-2.0/3.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
   /* p=7 0 0 3 */
   } else if( i==0 && j==0 && k==3 ) {
      t1 = t*t;
      t2 = s+r-1.0;
      t3 = t*t2;
      t4 = t2*t2;
      t5 = 12.0/7.0*t1+12.0/7.0*t3+12.0/35.0*t4;
      drv[0] = t5;
      drv[1] = t5;
      drv[2] = 3.0*t1+24.0/7.0*t3+6.0/7.0*t4;
   /* p=7 0 1 2 */
   } else if( i==0 && j==1 && k==2 ) {
      t1 = t*t;
      t2 = s+r-1.0;
      t3 = t*t2;
      t4 = t2*t2;
      t5 = s+2.0/9.0*r-2.0/9.0;
      t7 = t5*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = 2.0/9.0*t1+4.0/15.0*t3+t4/15+t7;
      drv[1] = t1+6.0/5.0*t3+3.0/10.0*t4+t7;
      drv[2] = t5*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=7 0 2 1 */
   } else if( i==0 && j==2 && k==1 ) {
      t2 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t4 = s*s;
      t5 = r-1.0;
      t6 = s*t5;
      t7 = t5*t5;
      drv[0] = (2.0/3.0*s+r/6-1.0/6.0)*t2+2.0/3.0*t4+4.0/9.0*t6+t7/18;
      drv[1] = (2.0*s+2.0/3.0*r-2.0/3.0)*t2+2.0/3.0*t4+4.0/9.0*t6+t7/18;
      drv[2] = t4+2.0/3.0*t6+t7/12;
   /* p=7 0 3 0 */
   } else if( i==0 && j==3 && k==0 ) {
      t1 = s*s;
      t2 = r-1.0;
      t3 = s*t2;
      t4 = t2*t2;
      drv[0] = 4.0/3.0*t1+t3+t4/7;
      drv[1] = 3.0*t1+8.0/3.0*t3+t4/2;
      drv[2] = 0.0;
   /* p=7 1 0 2 */
   } else if( i==1 && j==0 && k==2 ) {
      t1 = t*t;
      t2 = s+r-1.0;
      t4 = t2*t2;
      t5 = r-2.0/11.0;
      t7 = t5*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = t1+6.0/5.0*t*t2+3.0/10.0*t4+t7;
      drv[1] = t7;
      drv[2] = t5*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=7 1 1 1 */
   } else if( i==1 && j==1 && k==1 ) {
      t1 = s+2.0/7.0*r-2.0/7.0;
      t2 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t4 = r-2.0/11.0;
      t5 = t4*t2;
      t6 = t4*t1;
      drv[0] = t1*t2+2.0/7.0*t5+2.0/3.0*t6;
      drv[1] = t5+2.0/3.0*t6;
      drv[2] = t6;
   /* p=7 1 2 0 */
   } else if( i==1 && j==2 && k==0 ) {
      t1 = s*s;
      t2 = r-1.0;
      t4 = t2*t2;
      t5 = r-2.0/11.0;
      drv[0] = t1+6.0/7.0*s*t2+t4/7+t5*(6.0/7.0*s+2.0/7.0*r-2.0/7.0);
      drv[1] = t5*(2.0*s+6.0/7.0*r-6.0/7.0);
      drv[2] = 0.0;
   /* p=7 2 0 1 */
   } else if( i==2 && j==0 && k==1 ) {
      t4 = r*r;
      drv[0] = (2.0*r-6.0/11.0)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0)+2.0/3.0*t4-4.0/
11.0*r+2.0/55.0;
      drv[1] = 2.0/3.0*t4-4.0/11.0*r+2.0/55.0;
      drv[2] = t4-6.0/11.0*r+3.0/55.0;
   /* p=7 2 1 0 */
   } else if( i==2 && j==1 && k==0 ) {
      t4 = r*r;
      drv[0] = (2.0*r-6.0/11.0)*(s+2.0/5.0*r-2.0/5.0)+2.0/5.0*t4-12.0/55.0*r+
6.0/275.0;
      drv[1] = t4-6.0/11.0*r+3.0/55.0;
      drv[2] = 0.0;
   /* p=7 3 0 0 */
   } else if( i==3 && j==0 && k==0 ) {
      t1 = r*r;
      drv[0] = 3.0*t1-24.0/11.0*r+18.0/55.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
   /* p=8 0 0 4 */
   } else if( i==0 && j==0 && k==4 ) {
      t1 = t*t;
      t2 = t1*t;
      t3 = s+r-1.0;
      t4 = t3*t1;
      t5 = t3*t3;
      t6 = t*t5;
      t7 = t5*t3;
      t8 = 20.0/9.0*t2+10.0/3.0*t4+10.0/7.0*t6+10.0/63.0*t7;
      drv[0] = t8;
      drv[1] = t8;
      drv[2] = 4.0*t2+20.0/3.0*t4+10.0/3.0*t6+10.0/21.0*t7;
   /* p=8 0 1 3 */
   } else if( i==0 && j==1 && k==3 ) {
      t1 = t*t;
      t2 = t1*t;
      t3 = s+r-1.0;
      t4 = t3*t1;
      t5 = t3*t3;
      t6 = t*t5;
      t7 = t5*t3;
      t8 = s+2.0/11.0*r-2.0/11.0;
      t9 = t*t3;
      t11 = t8*(12.0/7.0*t1+12.0/7.0*t9+12.0/35.0*t5);
      drv[0] = 2.0/11.0*t2+24.0/77.0*t4+12.0/77.0*t6+8.0/385.0*t7+t11;
      drv[1] = t2+12.0/7.0*t4+6.0/7.0*t6+4.0/35.0*t7+t11;
      drv[2] = t8*(3.0*t1+24.0/7.0*t9+6.0/7.0*t5);
   /* p=8 0 2 2 */
   } else if( i==0 && j==2 && k==2 ) {
      t2 = t*t;
      t3 = s+r-1.0;
      t5 = t3*t3;
      t6 = t2+6.0/5.0*t*t3+3.0/10.0*t5;
      t8 = s*s;
      t9 = r-1.0;
      t11 = t9*t9;
      t12 = t8+6.0/11.0*s*t9+3.0/55.0*t11;
      t14 = t12*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (6.0/11.0*s+6.0/55.0*r-6.0/55.0)*t6+t14;
      drv[1] = (2.0*s+6.0/11.0*r-6.0/11.0)*t6+t14;
      drv[2] = t12*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=8 0 3 1 */
   } else if( i==0 && j==3 && k==1 ) {
      t1 = s*s;
      t2 = r-1.0;
      t3 = s*t2;
      t4 = t2*t2;
      t6 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t8 = t1*s;
      t9 = t1*t2;
      t10 = s*t4;
      t11 = t4*t2;
      drv[0] = (12.0/11.0*t1+36.0/55.0*t3+4.0/55.0*t4)*t6+2.0/3.0*t8+8.0/11.0*
t9+12.0/55.0*t10+8.0/495.0*t11;
      drv[1] = (3.0*t1+24.0/11.0*t3+18.0/55.0*t4)*t6+2.0/3.0*t8+8.0/11.0*t9+
12.0/55.0*t10+8.0/495.0*t11;
      drv[2] = t8+12.0/11.0*t9+18.0/55.0*t10+4.0/165.0*t11;
   /* p=8 0 4 0 */
   } else if( i==0 && j==4 && k==0 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = r-1.0;
      t4 = t3*t1;
      t5 = t3*t3;
      t6 = s*t5;
      t7 = t5*t3;
      drv[0] = 20.0/11.0*t2+24.0/11.0*t4+8.0/11.0*t6+2.0/33.0*t7;
      drv[1] = 4.0*t2+60.0/11.0*t4+24.0/11.0*t6+8.0/33.0*t7;
      drv[2] = 0.0;
   /* p=8 1 0 3 */
   } else if( i==1 && j==0 && k==3 ) {
      t1 = t*t;
      t3 = s+r-1.0;
      t5 = t3*t3;
      t8 = r-2.0/13.0;
      t9 = t*t3;
      t11 = t8*(12.0/7.0*t1+12.0/7.0*t9+12.0/35.0*t5);
      drv[0] = t1*t+12.0/7.0*t3*t1+6.0/7.0*t*t5+4.0/35.0*t5*t3+t11;
      drv[1] = t11;
      drv[2] = t8*(3.0*t1+24.0/7.0*t9+6.0/7.0*t5);
   /* p=8 1 1 2 */
   } else if( i==1 && j==1 && k==2 ) {
      t1 = s+2.0/9.0*r-2.0/9.0;
      t2 = t*t;
      t3 = s+r-1.0;
      t5 = t3*t3;
      t6 = t2+6.0/5.0*t*t3+3.0/10.0*t5;
      t8 = r-2.0/13.0;
      t9 = t8*t6;
      t10 = t8*t1;
      t12 = t10*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = t1*t6+2.0/9.0*t9+t12;
      drv[1] = t9+t12;
      drv[2] = t10*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=8 1 2 1 */
   } else if( i==1 && j==2 && k==1 ) {
      t1 = s*s;
      t2 = r-1.0;
      t4 = t2*t2;
      t5 = t1+2.0/3.0*s*t2+t4/12;
      t6 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t8 = r-2.0/13.0;
      t12 = t8*t5;
      drv[0] = t5*t6+t8*(2.0/3.0*s+r/6-1.0/6.0)*t6+2.0/3.0*t12;
      drv[1] = t8*(2.0*s+2.0/3.0*r-2.0/3.0)*t6+2.0/3.0*t12;
      drv[2] = t12;
   /* p=8 1 3 0 */
   } else if( i==1 && j==3 && k==0 ) {
      t1 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t8 = r-2.0/13.0;
      t9 = s*t3;
      drv[0] = t1*s+4.0/3.0*t3*t1+s*t5/2+t5*t3/21+t8*(4.0/3.0*t1+t9+t5/7);
      drv[1] = t8*(3.0*t1+8.0/3.0*t9+t5/2);
      drv[2] = 0.0;
   /* p=8 2 0 2 */
   } else if( i==2 && j==0 && k==2 ) {
      t2 = t*t;
      t3 = s+r-1.0;
      t5 = t3*t3;
      t8 = r*r;
      t9 = t8-6.0/13.0*r+1.0/26.0;
      t11 = t9*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (2.0*r-6.0/13.0)*(t2+6.0/5.0*t*t3+3.0/10.0*t5)+t11;
      drv[1] = t11;
      drv[2] = t9*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=8 2 1 1 */
   } else if( i==2 && j==1 && k==1 ) {
      t2 = s+2.0/7.0*r-2.0/7.0;
      t4 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t6 = r*r;
      t7 = t6-6.0/13.0*r+1.0/26.0;
      t8 = t7*t4;
      t9 = t7*t2;
      drv[0] = (2.0*r-6.0/13.0)*t2*t4+2.0/7.0*t8+2.0/3.0*t9;
      drv[1] = t8+2.0/3.0*t9;
      drv[2] = t9;
   /* p=8 2 2 0 */
   } else if( i==2 && j==2 && k==0 ) {
      t2 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t8 = r*r;
      t9 = t8-6.0/13.0*r+1.0/26.0;
      drv[0] = (2.0*r-6.0/13.0)*(t2+6.0/7.0*s*t3+t5/7)+t9*(6.0/7.0*s+2.0/7.0*r
-2.0/7.0);
      drv[1] = t9*(2.0*s+6.0/7.0*r-6.0/7.0);
      drv[2] = 0.0;
   /* p=8 3 0 1 */
   } else if( i==3 && j==0 && k==1 ) {
      t1 = r*r;
      t5 = t1*r;
      drv[0] = (t+2.0/3.0*s+2.0/3.0*r-2.0/3.0)*(3.0*t1-24.0/13.0*r+3.0/13.0)+
2.0/3.0*t5-8.0/13.0*t1+2.0/13.0*r-4.0/429.0;
      drv[1] = 2.0/3.0*t5-8.0/13.0*t1+2.0/13.0*r-4.0/429.0;
      drv[2] = t5-12.0/13.0*t1+3.0/13.0*r-2.0/143.0;
   /* p=8 3 1 0 */
   } else if( i==3 && j==1 && k==0 ) {
      t1 = r*r;
      t5 = t1*r;
      drv[0] = (s+2.0/5.0*r-2.0/5.0)*(3.0*t1-24.0/13.0*r+3.0/13.0)+2.0/5.0*t5
-24.0/65.0*t1+6.0/65.0*r-4.0/715.0;
      drv[1] = t5-12.0/13.0*t1+3.0/13.0*r-2.0/143.0;
      drv[2] = 0.0;
   /* p=8 4 0 0 */
   } else if( i==4 && j==0 && k==0 ) {
      t1 = r*r;
      drv[0] = 4.0*t1*r-60.0/13.0*t1+20.0/13.0*r-20.0/143.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
   /* p=9 0 0 5 */
   } else if( i==0 && j==0 && k==5 ) {
      t1 = t*t;
      t2 = t1*t1;
      t4 = s+r-1.0;
      t5 = t1*t*t4;
      t6 = t4*t4;
      t7 = t1*t6;
      t9 = t*t6*t4;
      t10 = t6*t6;
      t11 = 30.0/11.0*t2+60.0/11.0*t5+40.0/11.0*t7+10.0/11.0*t9+5.0/77.0*t10;
      drv[0] = t11;
      drv[1] = t11;
      drv[2] = 5.0*t2+120.0/11.0*t5+90.0/11.0*t7+80.0/33.0*t9+5.0/22.0*t10;
   /* p=9 0 1 4 */
   } else if( i==0 && j==1 && k==4 ) {
      t1 = t*t;
      t2 = t1*t1;
      t3 = t1*t;
      t4 = s+r-1.0;
      t5 = t3*t4;
      t6 = t4*t4;
      t7 = t1*t6;
      t8 = t6*t4;
      t9 = t*t8;
      t10 = t6*t6;
      t11 = s+2.0/13.0*r-2.0/13.0;
      t12 = t4*t1;
      t13 = t*t6;
      t15 = t11*(20.0/9.0*t3+10.0/3.0*t12+10.0/7.0*t13+10.0/63.0*t8);
      drv[0] = 2.0/13.0*t2+40.0/117.0*t5+10.0/39.0*t7+20.0/273.0*t9+5.0/819.0*
t10+t15;
      drv[1] = t2+20.0/9.0*t5+5.0/3.0*t7+10.0/21.0*t9+5.0/126.0*t10+t15;
      drv[2] = t11*(4.0*t3+20.0/3.0*t12+10.0/3.0*t13+10.0/21.0*t8);
   /* p=9 0 2 3 */
   } else if( i==0 && j==2 && k==3 ) {
      t2 = t*t;
      t4 = s+r-1.0;
      t6 = t4*t4;
      t9 = t2*t+12.0/7.0*t4*t2+6.0/7.0*t*t6+4.0/35.0*t6*t4;
      t11 = s*s;
      t12 = r-1.0;
      t14 = t12*t12;
      t15 = t11+6.0/13.0*s*t12+t14/26;
      t16 = t*t4;
      t18 = t15*(12.0/7.0*t2+12.0/7.0*t16+12.0/35.0*t6);
      drv[0] = (6.0/13.0*s+r/13-1.0/13.0)*t9+t18;
      drv[1] = (2.0*s+6.0/13.0*r-6.0/13.0)*t9+t18;
      drv[2] = t15*(3.0*t2+24.0/7.0*t16+6.0/7.0*t6);
   /* p=9 0 3 2 */
   } else if( i==0 && j==3 && k==2 ) {
      t1 = s*s;
      t2 = r-1.0;
      t3 = s*t2;
      t4 = t2*t2;
      t6 = t*t;
      t7 = s+r-1.0;
      t9 = t7*t7;
      t10 = t6+6.0/5.0*t*t7+3.0/10.0*t9;
      t16 = t1*s+12.0/13.0*t1*t2+3.0/13.0*s*t4+2.0/143.0*t4*t2;
      t18 = t16*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (12.0/13.0*t1+6.0/13.0*t3+6.0/143.0*t4)*t10+t18;
      drv[1] = (3.0*t1+24.0/13.0*t3+3.0/13.0*t4)*t10+t18;
      drv[2] = t16*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=9 0 4 1 */
   } else if( i==0 && j==4 && k==1 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = r-1.0;
      t4 = t3*t1;
      t5 = t3*t3;
      t6 = s*t5;
      t7 = t5*t3;
      t9 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t11 = t1*t1;
      t12 = t3*t2;
      t13 = t1*t5;
      t14 = s*t7;
      t15 = t5*t5;
      drv[0] = (20.0/13.0*t2+20.0/13.0*t4+60.0/143.0*t6+4.0/143.0*t7)*t9+2.0/
3.0*t11+40.0/39.0*t12+20.0/39.0*t13+40.0/429.0*t14+2.0/429.0*t15;
      drv[1] = (4.0*t2+60.0/13.0*t4+20.0/13.0*t6+20.0/143.0*t7)*t9+2.0/3.0*t11+
40.0/39.0*t12+20.0/39.0*t13+40.0/429.0*t14+2.0/429.0*t15;
      drv[2] = t11+20.0/13.0*t12+10.0/13.0*t13+20.0/143.0*t14+t15/143;
   /* p=9 0 5 0 */
   } else if( i==0 && j==5 && k==0 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t5 = t1*s*t4;
      t6 = t4*t4;
      t7 = t1*t6;
      t9 = s*t6*t4;
      t10 = t6*t6;
      drv[0] = 30.0/13.0*t2+50.0/13.0*t5+300.0/143.0*t7+60.0/143.0*t9+10.0/
429.0*t10;
      drv[1] = 5.0*t2+120.0/13.0*t5+75.0/13.0*t7+200.0/143.0*t9+15.0/143.0*t10;
      drv[2] = 0.0;
   /* p=9 1 0 4 */
   } else if( i==1 && j==0 && k==4 ) {
      t1 = t*t;
      t2 = t1*t1;
      t3 = t1*t;
      t4 = s+r-1.0;
      t6 = t4*t4;
      t8 = t6*t4;
      t10 = t6*t6;
      t11 = r-2.0/15.0;
      t12 = t4*t1;
      t13 = t*t6;
      t15 = t11*(20.0/9.0*t3+10.0/3.0*t12+10.0/7.0*t13+10.0/63.0*t8);
      drv[0] = t2+20.0/9.0*t3*t4+5.0/3.0*t1*t6+10.0/21.0*t*t8+5.0/126.0*t10+t15
;
      drv[1] = t15;
      drv[2] = t11*(4.0*t3+20.0/3.0*t12+10.0/3.0*t13+10.0/21.0*t8);
   /* p=9 1 1 3 */
   } else if( i==1 && j==1 && k==3 ) {
      t1 = s+2.0/11.0*r-2.0/11.0;
      t2 = t*t;
      t4 = s+r-1.0;
      t6 = t4*t4;
      t9 = t2*t+12.0/7.0*t4*t2+6.0/7.0*t*t6+4.0/35.0*t6*t4;
      t11 = r-2.0/15.0;
      t12 = t11*t9;
      t13 = t11*t1;
      t14 = t*t4;
      t16 = t13*(12.0/7.0*t2+12.0/7.0*t14+12.0/35.0*t6);
      drv[0] = t1*t9+2.0/11.0*t12+t16;
      drv[1] = t12+t16;
      drv[2] = t13*(3.0*t2+24.0/7.0*t14+6.0/7.0*t6);
   /* p=9 1 2 2 */
   } else if( i==1 && j==2 && k==2 ) {
      t1 = s*s;
      t2 = r-1.0;
      t4 = t2*t2;
      t5 = t1+6.0/11.0*s*t2+3.0/55.0*t4;
      t6 = t*t;
      t7 = s+r-1.0;
      t9 = t7*t7;
      t10 = t6+6.0/5.0*t*t7+3.0/10.0*t9;
      t12 = r-2.0/15.0;
      t16 = t12*t5;
      t18 = t16*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = t5*t10+t12*(6.0/11.0*s+6.0/55.0*r-6.0/55.0)*t10+t18;
      drv[1] = t12*(2.0*s+6.0/11.0*r-6.0/11.0)*t10+t18;
      drv[2] = t16*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=9 1 3 1 */
   } else if( i==1 && j==3 && k==1 ) {
      t1 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t8 = t1*s+12.0/11.0*t3*t1+18.0/55.0*s*t5+4.0/165.0*t5*t3;
      t9 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t11 = r-2.0/15.0;
      t12 = s*t3;
      t16 = t11*t8;
      drv[0] = t8*t9+t11*(12.0/11.0*t1+36.0/55.0*t12+4.0/55.0*t5)*t9+2.0/3.0*
t16;
      drv[1] = t11*(3.0*t1+24.0/11.0*t12+18.0/55.0*t5)*t9+2.0/3.0*t16;
      drv[2] = t16;
   /* p=9 1 4 0 */
   } else if( i==1 && j==4 && k==0 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t1*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t8 = t6*t4;
      t10 = t6*t6;
      t11 = r-2.0/15.0;
      t12 = t4*t1;
      t13 = s*t6;
      drv[0] = t2+20.0/11.0*t3*t4+12.0/11.0*t1*t6+8.0/33.0*s*t8+t10/66+t11*(
20.0/11.0*t3+24.0/11.0*t12+8.0/11.0*t13+2.0/33.0*t8);
      drv[1] = t11*(4.0*t3+60.0/11.0*t12+24.0/11.0*t13+8.0/33.0*t8);
      drv[2] = 0.0;
   /* p=9 2 0 3 */
   } else if( i==2 && j==0 && k==3 ) {
      t2 = t*t;
      t4 = s+r-1.0;
      t6 = t4*t4;
      t11 = r*r;
      t12 = t11-2.0/5.0*r+1.0/35.0;
      t13 = t*t4;
      t15 = t12*(12.0/7.0*t2+12.0/7.0*t13+12.0/35.0*t6);
      drv[0] = (2.0*r-2.0/5.0)*(t2*t+12.0/7.0*t4*t2+6.0/7.0*t*t6+4.0/35.0*t6*t4
)+t15;
      drv[1] = t15;
      drv[2] = t12*(3.0*t2+24.0/7.0*t13+6.0/7.0*t6);
   /* p=9 2 1 2 */
   } else if( i==2 && j==1 && k==2 ) {
      t2 = s+2.0/9.0*r-2.0/9.0;
      t4 = t*t;
      t5 = s+r-1.0;
      t7 = t5*t5;
      t8 = t4+6.0/5.0*t*t5+3.0/10.0*t7;
      t10 = r*r;
      t11 = t10-2.0/5.0*r+1.0/35.0;
      t12 = t11*t8;
      t13 = t11*t2;
      t15 = t13*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (2.0*r-2.0/5.0)*t2*t8+2.0/9.0*t12+t15;
      drv[1] = t12+t15;
      drv[2] = t13*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=9 2 2 1 */
   } else if( i==2 && j==2 && k==1 ) {
      t2 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t6 = t2+2.0/3.0*s*t3+t5/12;
      t8 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t10 = r*r;
      t11 = t10-2.0/5.0*r+1.0/35.0;
      t15 = t11*t6;
      drv[0] = (2.0*r-2.0/5.0)*t6*t8+t11*(2.0/3.0*s+r/6-1.0/6.0)*t8+2.0/3.0*t15
;
      drv[1] = t11*(2.0*s+2.0/3.0*r-2.0/3.0)*t8+2.0/3.0*t15;
      drv[2] = t15;
   /* p=9 2 3 0 */
   } else if( i==2 && j==3 && k==0 ) {
      t2 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t11 = r*r;
      t12 = t11-2.0/5.0*r+1.0/35.0;
      t13 = s*t4;
      drv[0] = (2.0*r-2.0/5.0)*(t2*s+4.0/3.0*t4*t2+s*t6/2+t6*t4/21)+t12*(4.0/
3.0*t2+t13+t6/7);
      drv[1] = t12*(3.0*t2+8.0/3.0*t13+t6/2);
      drv[2] = 0.0;
   /* p=9 3 0 2 */
   } else if( i==3 && j==0 && k==2 ) {
      t1 = r*r;
      t3 = t*t;
      t4 = s+r-1.0;
      t6 = t4*t4;
      t10 = t1*r-4.0/5.0*t1+6.0/35.0*r-4.0/455.0;
      t12 = t10*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (3.0*t1-8.0/5.0*r+6.0/35.0)*(t3+6.0/5.0*t*t4+3.0/10.0*t6)+t12;
      drv[1] = t12;
      drv[2] = t10*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=9 3 1 1 */
   } else if( i==3 && j==1 && k==1 ) {
      t1 = r*r;
      t3 = s+2.0/7.0*r-2.0/7.0;
      t5 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t8 = t1*r-4.0/5.0*t1+6.0/35.0*r-4.0/455.0;
      t9 = t8*t5;
      t10 = t3*t8;
      drv[0] = t3*(3.0*t1-8.0/5.0*r+6.0/35.0)*t5+2.0/7.0*t9+2.0/3.0*t10;
      drv[1] = t9+2.0/3.0*t10;
      drv[2] = t10;
   /* p=9 3 2 0 */
   } else if( i==3 && j==2 && k==0 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t10 = t1*r-4.0/5.0*t1+6.0/35.0*r-4.0/455.0;
      drv[0] = (3.0*t1-8.0/5.0*r+6.0/35.0)*(t3+6.0/7.0*s*t4+t6/7)+t10*(6.0/7.0*
s+2.0/7.0*r-2.0/7.0);
      drv[1] = t10*(2.0*s+6.0/7.0*r-6.0/7.0);
      drv[2] = 0.0;
   /* p=9 4 0 1 */
   } else if( i==4 && j==0 && k==1 ) {
      t1 = r*r;
      t2 = t1*r;
      t6 = t1*t1;
      drv[0] = (4.0*t2-4.0*t1+8.0/7.0*r-8.0/91.0)*(t+2.0/3.0*s+2.0/3.0*r-2.0/
3.0)+2.0/3.0*t6-8.0/9.0*t2+8.0/21.0*t1-16.0/273.0*r+2.0/819.0;
      drv[1] = 2.0/3.0*t6-8.0/9.0*t2+8.0/21.0*t1-16.0/273.0*r+2.0/819.0;
      drv[2] = t6-4.0/3.0*t2+4.0/7.0*t1-8.0/91.0*r+1.0/273.0;
   /* p=9 4 1 0 */
   } else if( i==4 && j==1 && k==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t6 = t1*t1;
      drv[0] = (4.0*t2-4.0*t1+8.0/7.0*r-8.0/91.0)*(s+2.0/5.0*r-2.0/5.0)+2.0/5.0
*t6-8.0/15.0*t2+8.0/35.0*t1-16.0/455.0*r+2.0/1365.0;
      drv[1] = t6-4.0/3.0*t2+4.0/7.0*t1-8.0/91.0*r+1.0/273.0;
      drv[2] = 0.0;
   /* p=9 5 0 0 */
   } else if( i==5 && j==0 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      drv[0] = 5.0*t2-8.0*t1*r+30.0/7.0*t1-80.0/91.0*r+5.0/91.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
   /* p=10 0 0 6 */
   } else if( i==0 && j==0 && k==6 ) {
      t1 = t*t;
      t2 = t1*t1;
      t3 = t2*t;
      t4 = s+r-1.0;
      t5 = t4*t2;
      t7 = t4*t4;
      t8 = t1*t*t7;
      t10 = t1*t7*t4;
      t11 = t7*t7;
      t12 = t*t11;
      t13 = t11*t4;
      t14 = 42.0/13.0*t3+105.0/13.0*t5+1050.0/143.0*t8+420.0/143.0*t10+70.0/
143.0*t12+7.0/286.0*t13;
      drv[0] = t14;
      drv[1] = t14;
      drv[2] = 6.0*t3+210.0/13.0*t5+210.0/13.0*t8+1050.0/143.0*t10+210.0/143.0*
t12+14.0/143.0*t13;
   /* p=10 0 1 5 */
   } else if( i==0 && j==1 && k==5 ) {
      t1 = t*t;
      t2 = t1*t1;
      t3 = t2*t;
      t4 = s+r-1.0;
      t5 = t4*t2;
      t6 = t1*t;
      t7 = t4*t4;
      t8 = t6*t7;
      t9 = t7*t4;
      t10 = t1*t9;
      t11 = t7*t7;
      t12 = t*t11;
      t13 = t11*t4;
      t14 = s+2.0/15.0*r-2.0/15.0;
      t15 = t6*t4;
      t16 = t1*t7;
      t17 = t*t9;
      t19 = t14*(30.0/11.0*t2+60.0/11.0*t15+40.0/11.0*t16+10.0/11.0*t17+5.0/
77.0*t11);
      drv[0] = 2.0/15.0*t3+4.0/11.0*t5+4.0/11.0*t8+16.0/99.0*t10+t12/33+2.0/
1155.0*t13+t19;
      drv[1] = t3+30.0/11.0*t5+30.0/11.0*t8+40.0/33.0*t10+5.0/22.0*t12+t13/77+
t19;
      drv[2] = t14*(5.0*t2+120.0/11.0*t15+90.0/11.0*t16+80.0/33.0*t17+5.0/22.0*
t11);
   /* p=10 0 2 4 */
   } else if( i==0 && j==2 && k==4 ) {
      t2 = t*t;
      t3 = t2*t2;
      t4 = t2*t;
      t5 = s+r-1.0;
      t7 = t5*t5;
      t9 = t7*t5;
      t11 = t7*t7;
      t12 = t3+20.0/9.0*t4*t5+5.0/3.0*t2*t7+10.0/21.0*t*t9+5.0/126.0*t11;
      t14 = s*s;
      t15 = r-1.0;
      t17 = t15*t15;
      t18 = t14+2.0/5.0*s*t15+t17/35;
      t19 = t2*t5;
      t20 = t*t7;
      t22 = t18*(20.0/9.0*t4+10.0/3.0*t19+10.0/7.0*t20+10.0/63.0*t9);
      drv[0] = (2.0/5.0*s+2.0/35.0*r-2.0/35.0)*t12+t22;
      drv[1] = (2.0*s+2.0/5.0*r-2.0/5.0)*t12+t22;
      drv[2] = t18*(4.0*t4+20.0/3.0*t19+10.0/3.0*t20+10.0/21.0*t9);
   /* p=10 0 3 3 */
   } else if( i==0 && j==3 && k==3 ) {
      t1 = s*s;
      t2 = r-1.0;
      t3 = s*t2;
      t4 = t2*t2;
      t6 = t*t;
      t8 = s+r-1.0;
      t10 = t8*t8;
      t13 = t6*t+12.0/7.0*t6*t8+6.0/7.0*t*t10+4.0/35.0*t10*t8;
      t19 = t1*s+4.0/5.0*t1*t2+6.0/35.0*s*t4+4.0/455.0*t4*t2;
      t20 = t*t8;
      t22 = t19*(12.0/7.0*t6+12.0/7.0*t20+12.0/35.0*t10);
      drv[0] = (4.0/5.0*t1+12.0/35.0*t3+12.0/455.0*t4)*t13+t22;
      drv[1] = (3.0*t1+8.0/5.0*t3+6.0/35.0*t4)*t13+t22;
      drv[2] = t19*(3.0*t6+24.0/7.0*t20+6.0/7.0*t10);
   /* p=10 0 4 2 */
   } else if( i==0 && j==4 && k==2 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = r-1.0;
      t4 = t3*t1;
      t5 = t3*t3;
      t6 = s*t5;
      t7 = t5*t3;
      t9 = t*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      t13 = t9+6.0/5.0*t*t10+3.0/10.0*t12;
      t15 = t1*t1;
      t19 = t5*t5;
      t20 = t15+4.0/3.0*t3*t2+4.0/7.0*t1*t5+8.0/91.0*s*t7+t19/273;
      t22 = t20*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (4.0/3.0*t2+8.0/7.0*t4+24.0/91.0*t6+4.0/273.0*t7)*t13+t22;
      drv[1] = (4.0*t2+4.0*t4+8.0/7.0*t6+8.0/91.0*t7)*t13+t22;
      drv[2] = t20*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=10 0 5 1 */
   } else if( i==0 && j==5 && k==1 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t1*s;
      t4 = r-1.0;
      t5 = t3*t4;
      t6 = t4*t4;
      t7 = t1*t6;
      t8 = t6*t4;
      t9 = s*t8;
      t10 = t6*t6;
      t12 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t14 = s*t2;
      t15 = t4*t2;
      t16 = t3*t6;
      t17 = t1*t8;
      t18 = s*t10;
      t19 = t10*t4;
      drv[0] = (2.0*t2+20.0/7.0*t5+120.0/91.0*t7+20.0/91.0*t9+10.0/1001.0*t10)*
t12+2.0/3.0*t14+4.0/3.0*t15+20.0/21.0*t16+80.0/273.0*t17+10.0/273.0*t18+4.0/
3003.0*t19;
      drv[1] = (5.0*t2+8.0*t5+30.0/7.0*t7+80.0/91.0*t9+5.0/91.0*t10)*t12+2.0/
3.0*t14+4.0/3.0*t15+20.0/21.0*t16+80.0/273.0*t17+10.0/273.0*t18+4.0/3003.0*t19;
      drv[2] = t14+2.0*t15+10.0/7.0*t16+40.0/91.0*t17+5.0/91.0*t18+2.0/1001.0*
t19;
   /* p=10 0 6 0 */
   } else if( i==0 && j==6 && k==0 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*s;
      t4 = r-1.0;
      t5 = t4*t2;
      t7 = t4*t4;
      t8 = t1*s*t7;
      t10 = t1*t7*t4;
      t11 = t7*t7;
      t12 = s*t11;
      t13 = t11*t4;
      drv[0] = 14.0/5.0*t3+6.0*t5+60.0/13.0*t8+20.0/13.0*t10+30.0/143.0*t12+6.0
/715.0*t13;
      drv[1] = 6.0*t3+14.0*t5+12.0*t8+60.0/13.0*t10+10.0/13.0*t12+6.0/143.0*t13
;
      drv[2] = 0.0;
   /* p=10 1 0 5 */
   } else if( i==1 && j==0 && k==5 ) {
      t1 = t*t;
      t2 = t1*t1;
      t4 = s+r-1.0;
      t6 = t1*t;
      t7 = t4*t4;
      t9 = t7*t4;
      t11 = t7*t7;
      t14 = r-2.0/17.0;
      t15 = t6*t4;
      t16 = t1*t7;
      t17 = t*t9;
      t19 = t14*(30.0/11.0*t2+60.0/11.0*t15+40.0/11.0*t16+10.0/11.0*t17+5.0/
77.0*t11);
      drv[0] = t2*t+30.0/11.0*t4*t2+30.0/11.0*t6*t7+40.0/33.0*t1*t9+5.0/22.0*t*
t11+t11*t4/77+t19;
      drv[1] = t19;
      drv[2] = t14*(5.0*t2+120.0/11.0*t15+90.0/11.0*t16+80.0/33.0*t17+5.0/22.0*
t11);
   /* p=10 1 1 4 */
   } else if( i==1 && j==1 && k==4 ) {
      t1 = s+2.0/13.0*r-2.0/13.0;
      t2 = t*t;
      t3 = t2*t2;
      t4 = t2*t;
      t5 = s+r-1.0;
      t7 = t5*t5;
      t9 = t7*t5;
      t11 = t7*t7;
      t12 = t3+20.0/9.0*t4*t5+5.0/3.0*t2*t7+10.0/21.0*t*t9+5.0/126.0*t11;
      t14 = r-2.0/17.0;
      t15 = t14*t12;
      t16 = t14*t1;
      t17 = t2*t5;
      t18 = t*t7;
      t20 = t16*(20.0/9.0*t4+10.0/3.0*t17+10.0/7.0*t18+10.0/63.0*t9);
      drv[0] = t1*t12+2.0/13.0*t15+t20;
      drv[1] = t15+t20;
      drv[2] = t16*(4.0*t4+20.0/3.0*t17+10.0/3.0*t18+10.0/21.0*t9);
   /* p=10 1 2 3 */
   } else if( i==1 && j==2 && k==3 ) {
      t1 = s*s;
      t2 = r-1.0;
      t4 = t2*t2;
      t5 = t1+6.0/13.0*t2*s+t4/26;
      t6 = t*t;
      t8 = s+r-1.0;
      t10 = t8*t8;
      t13 = t6*t+12.0/7.0*t6*t8+6.0/7.0*t*t10+4.0/35.0*t10*t8;
      t15 = r-2.0/17.0;
      t19 = t15*t5;
      t20 = t*t8;
      t22 = t19*(12.0/7.0*t6+12.0/7.0*t20+12.0/35.0*t10);
      drv[0] = t5*t13+t15*(6.0/13.0*s+r/13-1.0/13.0)*t13+t22;
      drv[1] = t15*(2.0*s+6.0/13.0*r-6.0/13.0)*t13+t22;
      drv[2] = t19*(3.0*t6+24.0/7.0*t20+6.0/7.0*t10);
   /* p=10 1 3 2 */
   } else if( i==1 && j==3 && k==2 ) {
      t1 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t8 = t1*s+12.0/13.0*t3*t1+3.0/13.0*s*t5+2.0/143.0*t5*t3;
      t9 = t*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      t13 = t9+6.0/5.0*t*t10+3.0/10.0*t12;
      t15 = r-2.0/17.0;
      t16 = s*t3;
      t20 = t15*t8;
      t22 = t20*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = t8*t13+t15*(12.0/13.0*t1+6.0/13.0*t16+6.0/143.0*t5)*t13+t22;
      drv[1] = t15*(3.0*t1+24.0/13.0*t16+3.0/13.0*t5)*t13+t22;
      drv[2] = t20*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=10 1 4 1 */
   } else if( i==1 && j==4 && k==1 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t1*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t8 = t6*t4;
      t10 = t6*t6;
      t11 = t2+20.0/13.0*t3*t4+10.0/13.0*t1*t6+20.0/143.0*s*t8+t10/143;
      t12 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t14 = r-2.0/17.0;
      t15 = t4*t1;
      t16 = s*t6;
      t20 = t14*t11;
      drv[0] = t11*t12+t14*(20.0/13.0*t3+20.0/13.0*t15+60.0/143.0*t16+4.0/143.0
*t8)*t12+2.0/3.0*t20;
      drv[1] = t14*(4.0*t3+60.0/13.0*t15+20.0/13.0*t16+20.0/143.0*t8)*t12+2.0/
3.0*t20;
      drv[2] = t20;
   /* p=10 1 5 0 */
   } else if( i==1 && j==5 && k==0 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t6 = t1*s;
      t7 = t4*t4;
      t9 = t7*t4;
      t11 = t7*t7;
      t14 = r-2.0/17.0;
      t15 = t6*t4;
      t16 = t1*t7;
      t17 = s*t9;
      drv[0] = t2*s+30.0/13.0*t4*t2+25.0/13.0*t6*t7+100.0/143.0*t1*t9+15.0/
143.0*s*t11+2.0/429.0*t11*t4+t14*(30.0/13.0*t2+50.0/13.0*t15+300.0/143.0*t16+
60.0/143.0*t17+10.0/429.0*t11);
      drv[1] = t14*(5.0*t2+120.0/13.0*t15+75.0/13.0*t16+200.0/143.0*t17+15.0/
143.0*t11);
      drv[2] = 0.0;
   /* p=10 2 0 4 */
   } else if( i==2 && j==0 && k==4 ) {
      t2 = t*t;
      t3 = t2*t2;
      t4 = t2*t;
      t5 = s+r-1.0;
      t7 = t5*t5;
      t9 = t7*t5;
      t11 = t7*t7;
      t14 = r*r;
      t15 = t14-6.0/17.0*r+3.0/136.0;
      t16 = t2*t5;
      t17 = t*t7;
      t19 = t15*(20.0/9.0*t4+10.0/3.0*t16+10.0/7.0*t17+10.0/63.0*t9);
      drv[0] = (2.0*r-6.0/17.0)*(t3+20.0/9.0*t4*t5+5.0/3.0*t2*t7+10.0/21.0*t*t9
+5.0/126.0*t11)+t19;
      drv[1] = t19;
      drv[2] = t15*(4.0*t4+20.0/3.0*t16+10.0/3.0*t17+10.0/21.0*t9);
   /* p=10 2 1 3 */
   } else if( i==2 && j==1 && k==3 ) {
      t2 = s+2.0/11.0*r-2.0/11.0;
      t4 = t*t;
      t6 = s+r-1.0;
      t8 = t6*t6;
      t11 = t4*t+12.0/7.0*t6*t4+6.0/7.0*t*t8+4.0/35.0*t8*t6;
      t13 = r*r;
      t14 = t13-6.0/17.0*r+3.0/136.0;
      t15 = t14*t11;
      t16 = t14*t2;
      t17 = t*t6;
      t19 = t16*(12.0/7.0*t4+12.0/7.0*t17+12.0/35.0*t8);
      drv[0] = (2.0*r-6.0/17.0)*t2*t11+2.0/11.0*t15+t19;
      drv[1] = t15+t19;
      drv[2] = t16*(3.0*t4+24.0/7.0*t17+6.0/7.0*t8);
   /* p=10 2 2 2 */
   } else if( i==2 && j==2 && k==2 ) {
      t2 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t6 = t2+6.0/11.0*s*t3+3.0/55.0*t5;
      t8 = t*t;
      t9 = s+r-1.0;
      t11 = t9*t9;
      t12 = t8+6.0/5.0*t*t9+3.0/10.0*t11;
      t14 = r*r;
      t15 = t14-6.0/17.0*r+3.0/136.0;
      t19 = t15*t6;
      t21 = t19*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (2.0*r-6.0/17.0)*t6*t12+t15*(6.0/11.0*s+6.0/55.0*r-6.0/55.0)*t12
+t21;
      drv[1] = t15*(2.0*s+6.0/11.0*r-6.0/11.0)*t12+t21;
      drv[2] = t19*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=10 2 3 1 */
   } else if( i==2 && j==3 && k==1 ) {
      t2 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t9 = t2*s+12.0/11.0*t4*t2+18.0/55.0*s*t6+4.0/165.0*t6*t4;
      t11 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t13 = r*r;
      t14 = t13-6.0/17.0*r+3.0/136.0;
      t15 = s*t4;
      t19 = t14*t9;
      drv[0] = (2.0*r-6.0/17.0)*t9*t11+t14*(12.0/11.0*t2+36.0/55.0*t15+4.0/55.0
*t6)*t11+2.0/3.0*t19;
      drv[1] = t14*(3.0*t2+24.0/11.0*t15+18.0/55.0*t6)*t11+2.0/3.0*t19;
      drv[2] = t19;
   /* p=10 2 4 0 */
   } else if( i==2 && j==4 && k==0 ) {
      t2 = s*s;
      t3 = t2*t2;
      t4 = t2*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t9 = t7*t5;
      t11 = t7*t7;
      t14 = r*r;
      t15 = t14-6.0/17.0*r+3.0/136.0;
      t16 = t2*t5;
      t17 = s*t7;
      drv[0] = (2.0*r-6.0/17.0)*(t3+20.0/11.0*t4*t5+12.0/11.0*t2*t7+8.0/33.0*s*
t9+t11/66)+t15*(20.0/11.0*t4+24.0/11.0*t16+8.0/11.0*t17+2.0/33.0*t9);
      drv[1] = t15*(4.0*t4+60.0/11.0*t16+24.0/11.0*t17+8.0/33.0*t9);
      drv[2] = 0.0;
   /* p=10 3 0 3 */
   } else if( i==3 && j==0 && k==3 ) {
      t1 = r*r;
      t3 = t*t;
      t5 = s+r-1.0;
      t7 = t5*t5;
      t13 = t1*r-12.0/17.0*t1+9.0/68.0*r-1.0/170.0;
      t14 = t*t5;
      t16 = t13*(12.0/7.0*t3+12.0/7.0*t14+12.0/35.0*t7);
      drv[0] = (3.0*t1-24.0/17.0*r+9.0/68.0)*(t3*t+12.0/7.0*t3*t5+6.0/7.0*t*t7+
4.0/35.0*t7*t5)+t16;
      drv[1] = t16;
      drv[2] = t13*(3.0*t3+24.0/7.0*t14+6.0/7.0*t7);
   /* p=10 3 1 2 */
   } else if( i==3 && j==1 && k==2 ) {
      t1 = r*r;
      t3 = s+2.0/9.0*r-2.0/9.0;
      t5 = t*t;
      t6 = s+r-1.0;
      t8 = t6*t6;
      t9 = t5+6.0/5.0*t*t6+3.0/10.0*t8;
      t12 = t1*r-12.0/17.0*t1+9.0/68.0*r-1.0/170.0;
      t13 = t12*t9;
      t14 = t12*t3;
      t16 = t14*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = t3*(3.0*t1-24.0/17.0*r+9.0/68.0)*t9+2.0/9.0*t13+t16;
      drv[1] = t13+t16;
      drv[2] = t14*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=10 3 2 1 */
   } else if( i==3 && j==2 && k==1 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t7 = t3+2.0/3.0*s*t4+t6/12;
      t9 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t12 = t1*r-12.0/17.0*t1+9.0/68.0*r-1.0/170.0;
      t16 = t12*t7;
      drv[0] = (3.0*t1-24.0/17.0*r+9.0/68.0)*t7*t9+t12*(2.0/3.0*s+r/6-1.0/6.0)*
t9+2.0/3.0*t16;
      drv[1] = t12*(2.0*s+2.0/3.0*r-2.0/3.0)*t9+2.0/3.0*t16;
      drv[2] = t16;
   /* p=10 3 3 0 */
   } else if( i==3 && j==3 && k==0 ) {
      t1 = r*r;
      t3 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t13 = t1*r-12.0/17.0*t1+9.0/68.0*r-1.0/170.0;
      t14 = s*t5;
      drv[0] = (3.0*t1-24.0/17.0*r+9.0/68.0)*(t3*s+4.0/3.0*t3*t5+s*t7/2+t7*t5
/21)+t13*(4.0/3.0*t3+t14+t7/7);
      drv[1] = t13*(3.0*t3+8.0/3.0*t14+t7/2);
      drv[2] = 0.0;
   /* p=10 4 0 2 */
   } else if( i==4 && j==0 && k==2 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = t*t;
      t5 = s+r-1.0;
      t7 = t5*t5;
      t10 = t1*t1;
      t11 = t10-20.0/17.0*t2+15.0/34.0*t1-r/17+1.0/476.0;
      t13 = t11*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (4.0*t2-60.0/17.0*t1+15.0/17.0*r-1.0/17.0)*(t4+6.0/5.0*t*t5+3.0/
10.0*t7)+t13;
      drv[1] = t13;
      drv[2] = t11*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=10 4 1 1 */
   } else if( i==4 && j==1 && k==1 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s+2.0/7.0*r-2.0/7.0;
      t6 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t8 = t1*t1;
      t9 = t8-20.0/17.0*t2+15.0/34.0*t1-r/17+1.0/476.0;
      t10 = t9*t6;
      t11 = t9*t4;
      drv[0] = (4.0*t2-60.0/17.0*t1+15.0/17.0*r-1.0/17.0)*t4*t6+2.0/7.0*t10+2.0
/3.0*t11;
      drv[1] = t10+2.0/3.0*t11;
      drv[2] = t11;
   /* p=10 4 2 0 */
   } else if( i==4 && j==2 && k==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t10 = t1*t1;
      t11 = t10-20.0/17.0*t2+15.0/34.0*t1-r/17+1.0/476.0;
      drv[0] = (4.0*t2-60.0/17.0*t1+15.0/17.0*r-1.0/17.0)*(t4+6.0/7.0*s*t5+t7/7
)+t11*(6.0/7.0*s+2.0/7.0*r-2.0/7.0);
      drv[1] = t11*(2.0*s+6.0/7.0*r-6.0/7.0);
      drv[2] = 0.0;
   /* p=10 5 0 1 */
   } else if( i==5 && j==0 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t7 = t2*r;
      drv[0] = (5.0*t2-120.0/17.0*t3+225.0/68.0*t1-10.0/17.0*r+15.0/476.0)*(t+
2.0/3.0*s+2.0/3.0*r-2.0/3.0)+2.0/3.0*t7-20.0/17.0*t2+25.0/34.0*t3-10.0/51.0*t1+
5.0/238.0*r-1.0/1547.0;
      drv[1] = 2.0/3.0*t7-20.0/17.0*t2+25.0/34.0*t3-10.0/51.0*t1+5.0/238.0*r
-1.0/1547.0;
      drv[2] = t7-30.0/17.0*t2+75.0/68.0*t3-5.0/17.0*t1+15.0/476.0*r-3.0/3094.0
;
   /* p=10 5 1 0 */
   } else if( i==5 && j==1 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t7 = t2*r;
      drv[0] = (5.0*t2-120.0/17.0*t3+225.0/68.0*t1-10.0/17.0*r+15.0/476.0)*(s+
2.0/5.0*r-2.0/5.0)+2.0/5.0*t7-12.0/17.0*t2+15.0/34.0*t3-2.0/17.0*t1+3.0/238.0*r
-3.0/7735.0;
      drv[1] = t7-30.0/17.0*t2+75.0/68.0*t3-5.0/17.0*t1+15.0/476.0*r-3.0/3094.0
;
      drv[2] = 0.0;
   /* p=10 6 0 0 */
   } else if( i==6 && j==0 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      drv[0] = 6.0*t2*r-210.0/17.0*t2+315.0/34.0*t1*r-105.0/34.0*t1+15.0/34.0*r
-9.0/442.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
   /* p=11 0 0 7 */
   } else if( i==0 && j==0 && k==7 ) {
      t1 = t*t;
      t2 = t1*t1;
      t3 = t2*t1;
      t5 = s+r-1.0;
      t6 = t2*t*t5;
      t7 = t5*t5;
      t8 = t2*t7;
      t11 = t1*t*t7*t5;
      t12 = t7*t7;
      t13 = t1*t12;
      t15 = t*t12*t5;
      t16 = t12*t7;
      t17 = 56.0/15.0*t3+56.0/5.0*t6+168.0/13.0*t8+280.0/39.0*t11+280.0/143.0*
t13+168.0/715.0*t15+56.0/6435.0*t16;
      drv[0] = t17;
      drv[1] = t17;
      drv[2] = 7.0*t3+112.0/5.0*t6+28.0*t8+224.0/13.0*t11+70.0/13.0*t13+112.0/
143.0*t15+28.0/715.0*t16;
   /* p=11 0 1 6 */
   } else if( i==0 && j==1 && k==6 ) {
      t1 = t*t;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t2*t;
      t5 = s+r-1.0;
      t6 = t4*t5;
      t7 = t5*t5;
      t8 = t2*t7;
      t9 = t1*t;
      t10 = t7*t5;
      t11 = t9*t10;
      t12 = t7*t7;
      t13 = t1*t12;
      t14 = t12*t5;
      t15 = t*t14;
      t16 = t12*t7;
      t17 = s+2.0/17.0*r-2.0/17.0;
      t18 = t2*t5;
      t19 = t9*t7;
      t20 = t1*t10;
      t21 = t*t12;
      t23 = t17*(42.0/13.0*t4+105.0/13.0*t18+1050.0/143.0*t19+420.0/143.0*t20+
70.0/143.0*t21+7.0/286.0*t14);
      drv[0] = 2.0/17.0*t3+84.0/221.0*t6+105.0/221.0*t8+700.0/2431.0*t11+210.0/
2431.0*t13+28.0/2431.0*t15+7.0/14586.0*t16+t23;
      drv[1] = t3+42.0/13.0*t6+105.0/26.0*t8+350.0/143.0*t11+105.0/143.0*t13+
14.0/143.0*t15+7.0/1716.0*t16+t23;
      drv[2] = t17*(6.0*t4+210.0/13.0*t18+210.0/13.0*t19+1050.0/143.0*t20+210.0
/143.0*t21+14.0/143.0*t14);
   /* p=11 0 2 5 */
   } else if( i==0 && j==2 && k==5 ) {
      t2 = t*t;
      t3 = t2*t2;
      t5 = s+r-1.0;
      t7 = t2*t;
      t8 = t5*t5;
      t10 = t8*t5;
      t12 = t8*t8;
      t15 = t3*t+30.0/11.0*t3*t5+30.0/11.0*t7*t8+40.0/33.0*t2*t10+5.0/22.0*t*
t12+t12*t5/77;
      t17 = s*s;
      t18 = r-1.0;
      t20 = t18*t18;
      t21 = t17+6.0/17.0*s*t18+3.0/136.0*t20;
      t22 = t7*t5;
      t23 = t2*t8;
      t24 = t*t10;
      t26 = t21*(30.0/11.0*t3+60.0/11.0*t22+40.0/11.0*t23+10.0/11.0*t24+5.0/
77.0*t12);
      drv[0] = (6.0/17.0*s+3.0/68.0*r-3.0/68.0)*t15+t26;
      drv[1] = (2.0*s+6.0/17.0*r-6.0/17.0)*t15+t26;
      drv[2] = t21*(5.0*t3+120.0/11.0*t22+90.0/11.0*t23+80.0/33.0*t24+5.0/22.0*
t12);
   /* p=11 0 3 4 */
   } else if( i==0 && j==3 && k==4 ) {
      t1 = s*s;
      t2 = r-1.0;
      t3 = s*t2;
      t4 = t2*t2;
      t6 = t*t;
      t7 = t6*t6;
      t8 = t6*t;
      t9 = s+r-1.0;
      t11 = t9*t9;
      t13 = t11*t9;
      t15 = t11*t11;
      t16 = t7+20.0/9.0*t8*t9+5.0/3.0*t6*t11+10.0/21.0*t*t13+5.0/126.0*t15;
      t22 = t1*s+12.0/17.0*t1*t2+9.0/68.0*s*t4+t4*t2/170;
      t23 = t6*t9;
      t24 = t*t11;
      t26 = t22*(20.0/9.0*t8+10.0/3.0*t23+10.0/7.0*t24+10.0/63.0*t13);
      drv[0] = (12.0/17.0*t1+9.0/34.0*t3+3.0/170.0*t4)*t16+t26;
      drv[1] = (3.0*t1+24.0/17.0*t3+9.0/68.0*t4)*t16+t26;
      drv[2] = t22*(4.0*t8+20.0/3.0*t23+10.0/3.0*t24+10.0/21.0*t13);
   /* p=11 0 4 3 */
   } else if( i==0 && j==4 && k==3 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = r-1.0;
      t4 = t3*t1;
      t5 = t3*t3;
      t6 = s*t5;
      t7 = t3*t5;
      t9 = t*t;
      t11 = s+r-1.0;
      t13 = t11*t11;
      t16 = t9*t+12.0/7.0*t11*t9+6.0/7.0*t*t13+4.0/35.0*t13*t11;
      t18 = t1*t1;
      t22 = t5*t5;
      t23 = t18+20.0/17.0*t3*t2+15.0/34.0*t1*t5+s*t7/17+t22/476;
      t24 = t*t11;
      t26 = t23*(12.0/7.0*t9+12.0/7.0*t24+12.0/35.0*t13);
      drv[0] = (20.0/17.0*t2+15.0/17.0*t4+3.0/17.0*t6+t7/119)*t16+t26;
      drv[1] = (4.0*t2+60.0/17.0*t4+15.0/17.0*t6+t7/17)*t16+t26;
      drv[2] = t23*(3.0*t9+24.0/7.0*t24+6.0/7.0*t13);
   /* p=11 0 5 2 */
   } else if( i==0 && j==5 && k==2 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t1*s;
      t4 = r-1.0;
      t5 = t3*t4;
      t6 = t4*t4;
      t7 = t1*t6;
      t8 = t6*t4;
      t9 = s*t8;
      t10 = t6*t6;
      t12 = t*t;
      t13 = s+r-1.0;
      t15 = t13*t13;
      t16 = t12+6.0/5.0*t*t13+3.0/10.0*t15;
      t24 = s*t2+30.0/17.0*t4*t2+75.0/68.0*t3*t6+5.0/17.0*t1*t8+15.0/476.0*s*
t10+3.0/3094.0*t10*t4;
      t26 = t24*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (30.0/17.0*t2+75.0/34.0*t5+15.0/17.0*t7+15.0/119.0*t9+15.0/
3094.0*t10)*t16+t26;
      drv[1] = (5.0*t2+120.0/17.0*t5+225.0/68.0*t7+10.0/17.0*t9+15.0/476.0*t10)
*t16+t26;
      drv[2] = t24*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=11 0 6 1 */
   } else if( i==0 && j==6 && k==1 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*s;
      t4 = r-1.0;
      t5 = t4*t2;
      t6 = t1*s;
      t7 = t4*t4;
      t8 = t6*t7;
      t9 = t7*t4;
      t10 = t1*t9;
      t11 = t7*t7;
      t12 = s*t11;
      t13 = t11*t4;
      t15 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t17 = t2*t1;
      t18 = t3*t4;
      t19 = t2*t7;
      t20 = t6*t9;
      t21 = t1*t11;
      t22 = s*t13;
      t23 = t11*t7;
      drv[0] = (42.0/17.0*t3+315.0/68.0*t5+105.0/34.0*t8+15.0/17.0*t10+45.0/
442.0*t12+3.0/884.0*t13)*t15+2.0/3.0*t17+28.0/17.0*t18+105.0/68.0*t19+35.0/51.0
*t20+5.0/34.0*t21+3.0/221.0*t22+t23/2652;
      drv[1] = (6.0*t3+210.0/17.0*t5+315.0/34.0*t8+105.0/34.0*t10+15.0/34.0*t12
+9.0/442.0*t13)*t15+2.0/3.0*t17+28.0/17.0*t18+105.0/68.0*t19+35.0/51.0*t20+5.0/
34.0*t21+3.0/221.0*t22+t23/2652;
      drv[2] = t17+42.0/17.0*t18+315.0/136.0*t19+35.0/34.0*t20+15.0/68.0*t21+
9.0/442.0*t22+t23/1768;
   /* p=11 0 7 0 */
   } else if( i==0 && j==7 && k==0 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t1;
      t5 = r-1.0;
      t6 = t2*s*t5;
      t7 = t5*t5;
      t8 = t2*t7;
      t11 = t1*s*t7*t5;
      t12 = t7*t7;
      t13 = t1*t12;
      t15 = s*t12*t5;
      t16 = t12*t7;
      drv[0] = 56.0/17.0*t3+147.0/17.0*t6+147.0/17.0*t8+70.0/17.0*t11+210.0/
221.0*t13+21.0/221.0*t15+7.0/2431.0*t16;
      drv[1] = 7.0*t3+336.0/17.0*t6+735.0/34.0*t8+196.0/17.0*t11+105.0/34.0*t13
+84.0/221.0*t15+7.0/442.0*t16;
      drv[2] = 0.0;
   /* p=11 1 0 6 */
   } else if( i==1 && j==0 && k==6 ) {
      t1 = t*t;
      t2 = t1*t1;
      t4 = t2*t;
      t5 = s+r-1.0;
      t7 = t5*t5;
      t9 = t1*t;
      t10 = t7*t5;
      t12 = t7*t7;
      t14 = t12*t5;
      t17 = r-2.0/19.0;
      t18 = t2*t5;
      t19 = t9*t7;
      t20 = t1*t10;
      t21 = t*t12;
      t23 = t17*(42.0/13.0*t4+105.0/13.0*t18+1050.0/143.0*t19+420.0/143.0*t20+
70.0/143.0*t21+7.0/286.0*t14);
      drv[0] = t2*t1+42.0/13.0*t4*t5+105.0/26.0*t2*t7+350.0/143.0*t9*t10+105.0/
143.0*t1*t12+14.0/143.0*t*t14+7.0/1716.0*t12*t7+t23;
      drv[1] = t23;
      drv[2] = t17*(6.0*t4+210.0/13.0*t18+210.0/13.0*t19+1050.0/143.0*t20+210.0
/143.0*t21+14.0/143.0*t14);
   /* p=11 1 1 5 */
   } else if( i==1 && j==1 && k==5 ) {
      t1 = s+2.0/15.0*r-2.0/15.0;
      t2 = t*t;
      t3 = t2*t2;
      t5 = s+r-1.0;
      t7 = t2*t;
      t8 = t5*t5;
      t10 = t8*t5;
      t12 = t8*t8;
      t15 = t3*t+30.0/11.0*t3*t5+30.0/11.0*t7*t8+40.0/33.0*t2*t10+5.0/22.0*t*
t12+t12*t5/77;
      t17 = r-2.0/19.0;
      t18 = t17*t15;
      t19 = t17*t1;
      t20 = t7*t5;
      t21 = t2*t8;
      t22 = t*t10;
      t24 = t19*(30.0/11.0*t3+60.0/11.0*t20+40.0/11.0*t21+10.0/11.0*t22+5.0/
77.0*t12);
      drv[0] = t1*t15+2.0/15.0*t18+t24;
      drv[1] = t18+t24;
      drv[2] = t19*(5.0*t3+120.0/11.0*t20+90.0/11.0*t21+80.0/33.0*t22+5.0/22.0*
t12);
   /* p=11 1 2 4 */
   } else if( i==1 && j==2 && k==4 ) {
      t1 = s*s;
      t2 = r-1.0;
      t4 = t2*t2;
      t5 = t1+2.0/5.0*s*t2+t4/35;
      t6 = t*t;
      t7 = t6*t6;
      t8 = t6*t;
      t9 = s+r-1.0;
      t11 = t9*t9;
      t13 = t11*t9;
      t15 = t11*t11;
      t16 = t7+20.0/9.0*t8*t9+5.0/3.0*t6*t11+10.0/21.0*t*t13+5.0/126.0*t15;
      t18 = r-2.0/19.0;
      t22 = t18*t5;
      t23 = t6*t9;
      t24 = t*t11;
      t26 = t22*(20.0/9.0*t8+10.0/3.0*t23+10.0/7.0*t24+10.0/63.0*t13);
      drv[0] = t5*t16+t18*(2.0/5.0*s+2.0/35.0*r-2.0/35.0)*t16+t26;
      drv[1] = t18*(2.0*s+2.0/5.0*r-2.0/5.0)*t16+t26;
      drv[2] = t22*(4.0*t8+20.0/3.0*t23+10.0/3.0*t24+10.0/21.0*t13);
   /* p=11 1 3 3 */
   } else if( i==1 && j==3 && k==3 ) {
      t1 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t8 = t1*s+4.0/5.0*t3*t1+6.0/35.0*s*t5+4.0/455.0*t5*t3;
      t9 = t*t;
      t11 = s+r-1.0;
      t13 = t11*t11;
      t16 = t9*t+12.0/7.0*t11*t9+6.0/7.0*t*t13+4.0/35.0*t13*t11;
      t18 = r-2.0/19.0;
      t19 = s*t3;
      t23 = t18*t8;
      t24 = t*t11;
      t26 = t23*(12.0/7.0*t9+12.0/7.0*t24+12.0/35.0*t13);
      drv[0] = t8*t16+t18*(4.0/5.0*t1+12.0/35.0*t19+12.0/455.0*t5)*t16+t26;
      drv[1] = t18*(3.0*t1+8.0/5.0*t19+6.0/35.0*t5)*t16+t26;
      drv[2] = t23*(3.0*t9+24.0/7.0*t24+6.0/7.0*t13);
   /* p=11 1 4 2 */
   } else if( i==1 && j==4 && k==2 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t1*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t8 = t6*t4;
      t10 = t6*t6;
      t11 = t2+4.0/3.0*t3*t4+4.0/7.0*t1*t6+8.0/91.0*s*t8+t10/273;
      t12 = t*t;
      t13 = s+r-1.0;
      t15 = t13*t13;
      t16 = t12+6.0/5.0*t*t13+3.0/10.0*t15;
      t18 = r-2.0/19.0;
      t19 = t4*t1;
      t20 = s*t6;
      t24 = t18*t11;
      t26 = t24*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = t11*t16+t18*(4.0/3.0*t3+8.0/7.0*t19+24.0/91.0*t20+4.0/273.0*t8)*
t16+t26;
      drv[1] = t18*(4.0*t3+4.0*t19+8.0/7.0*t20+8.0/91.0*t8)*t16+t26;
      drv[2] = t24*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=11 1 5 1 */
   } else if( i==1 && j==5 && k==1 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t6 = t1*s;
      t7 = t4*t4;
      t9 = t7*t4;
      t11 = t7*t7;
      t14 = s*t2+2.0*t4*t2+10.0/7.0*t6*t7+40.0/91.0*t1*t9+5.0/91.0*s*t11+2.0/
1001.0*t11*t4;
      t15 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t17 = r-2.0/19.0;
      t18 = t6*t4;
      t19 = t1*t7;
      t20 = s*t9;
      t24 = t17*t14;
      drv[0] = t14*t15+t17*(2.0*t2+20.0/7.0*t18+120.0/91.0*t19+20.0/91.0*t20+
10.0/1001.0*t11)*t15+2.0/3.0*t24;
      drv[1] = t17*(5.0*t2+8.0*t18+30.0/7.0*t19+80.0/91.0*t20+5.0/91.0*t11)*t15
+2.0/3.0*t24;
      drv[2] = t24;
   /* p=11 1 6 0 */
   } else if( i==1 && j==6 && k==0 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = s*t2;
      t5 = r-1.0;
      t7 = t5*t5;
      t9 = t1*s;
      t10 = t7*t5;
      t12 = t7*t7;
      t14 = t12*t5;
      t17 = r-2.0/19.0;
      t18 = t2*t5;
      t19 = t9*t7;
      t20 = t1*t10;
      t21 = s*t12;
      drv[0] = t2*t1+14.0/5.0*t4*t5+3.0*t2*t7+20.0/13.0*t9*t10+5.0/13.0*t1*t12+
6.0/143.0*s*t14+t12*t7/715+t17*(14.0/5.0*t4+6.0*t18+60.0/13.0*t19+20.0/13.0*t20
+30.0/143.0*t21+6.0/715.0*t14);
      drv[1] = t17*(6.0*t4+14.0*t18+12.0*t19+60.0/13.0*t20+10.0/13.0*t21+6.0/
143.0*t14);
      drv[2] = 0.0;
   /* p=11 2 0 5 */
   } else if( i==2 && j==0 && k==5 ) {
      t2 = t*t;
      t3 = t2*t2;
      t5 = s+r-1.0;
      t7 = t2*t;
      t8 = t5*t5;
      t10 = t8*t5;
      t12 = t8*t8;
      t17 = r*r;
      t18 = t17-6.0/19.0*r+1.0/57.0;
      t19 = t7*t5;
      t20 = t2*t8;
      t21 = t*t10;
      t23 = t18*(30.0/11.0*t3+60.0/11.0*t19+40.0/11.0*t20+10.0/11.0*t21+5.0/
77.0*t12);
      drv[0] = (2.0*r-6.0/19.0)*(t3*t+30.0/11.0*t3*t5+30.0/11.0*t7*t8+40.0/33.0
*t2*t10+5.0/22.0*t*t12+t12*t5/77)+t23;
      drv[1] = t23;
      drv[2] = t18*(5.0*t3+120.0/11.0*t19+90.0/11.0*t20+80.0/33.0*t21+5.0/22.0*
t12);
   /* p=11 2 1 4 */
   } else if( i==2 && j==1 && k==4 ) {
      t2 = s+2.0/13.0*r-2.0/13.0;
      t4 = t*t;
      t5 = t4*t4;
      t6 = t4*t;
      t7 = s+r-1.0;
      t9 = t7*t7;
      t11 = t9*t7;
      t13 = t9*t9;
      t14 = t5+20.0/9.0*t6*t7+5.0/3.0*t4*t9+10.0/21.0*t*t11+5.0/126.0*t13;
      t16 = r*r;
      t17 = t16-6.0/19.0*r+1.0/57.0;
      t18 = t17*t14;
      t19 = t17*t2;
      t20 = t7*t4;
      t21 = t*t9;
      t23 = t19*(20.0/9.0*t6+10.0/3.0*t20+10.0/7.0*t21+10.0/63.0*t11);
      drv[0] = t2*(2.0*r-6.0/19.0)*t14+2.0/13.0*t18+t23;
      drv[1] = t18+t23;
      drv[2] = t19*(4.0*t6+20.0/3.0*t20+10.0/3.0*t21+10.0/21.0*t11);
   /* p=11 2 2 3 */
   } else if( i==2 && j==2 && k==3 ) {
      t2 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t6 = t2+6.0/13.0*s*t3+t5/26;
      t8 = t*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      t15 = t8*t+12.0/7.0*t8*t10+6.0/7.0*t*t12+4.0/35.0*t12*t10;
      t17 = r*r;
      t18 = t17-6.0/19.0*r+1.0/57.0;
      t22 = t18*t6;
      t23 = t*t10;
      t25 = t22*(12.0/7.0*t8+12.0/7.0*t23+12.0/35.0*t12);
      drv[0] = (2.0*r-6.0/19.0)*t6*t15+t18*(6.0/13.0*s+r/13-1.0/13.0)*t15+t25;
      drv[1] = t18*(2.0*s+6.0/13.0*r-6.0/13.0)*t15+t25;
      drv[2] = t22*(3.0*t8+24.0/7.0*t23+6.0/7.0*t12);
   /* p=11 2 3 2 */
   } else if( i==2 && j==3 && k==2 ) {
      t2 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t9 = t2*s+12.0/13.0*t4*t2+3.0/13.0*s*t6+2.0/143.0*t6*t4;
      t11 = t*t;
      t12 = s+r-1.0;
      t14 = t12*t12;
      t15 = t11+6.0/5.0*t*t12+3.0/10.0*t14;
      t17 = r*r;
      t18 = t17-6.0/19.0*r+1.0/57.0;
      t19 = s*t4;
      t23 = t18*t9;
      t25 = t23*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (2.0*r-6.0/19.0)*t9*t15+t18*(12.0/13.0*t2+6.0/13.0*t19+6.0/143.0
*t6)*t15+t25;
      drv[1] = t18*(3.0*t2+24.0/13.0*t19+3.0/13.0*t6)*t15+t25;
      drv[2] = t23*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=11 2 4 1 */
   } else if( i==2 && j==4 && k==1 ) {
      t2 = s*s;
      t3 = t2*t2;
      t4 = t2*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t9 = t7*t5;
      t11 = t7*t7;
      t12 = t3+20.0/13.0*t4*t5+10.0/13.0*t2*t7+20.0/143.0*s*t9+t11/143;
      t14 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t16 = r*r;
      t17 = t16-6.0/19.0*r+1.0/57.0;
      t18 = t2*t5;
      t19 = s*t7;
      t23 = t17*t12;
      drv[0] = (2.0*r-6.0/19.0)*t12*t14+t17*(20.0/13.0*t4+20.0/13.0*t18+60.0/
143.0*t19+4.0/143.0*t9)*t14+2.0/3.0*t23;
      drv[1] = t17*(4.0*t4+60.0/13.0*t18+20.0/13.0*t19+20.0/143.0*t9)*t14+2.0/
3.0*t23;
      drv[2] = t23;
   /* p=11 2 5 0 */
   } else if( i==2 && j==5 && k==0 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = r-1.0;
      t7 = t2*s;
      t8 = t5*t5;
      t10 = t8*t5;
      t12 = t8*t8;
      t17 = r*r;
      t18 = t17-6.0/19.0*r+1.0/57.0;
      t19 = t7*t5;
      t20 = t2*t8;
      t21 = s*t10;
      drv[0] = (2.0*r-6.0/19.0)*(t3*s+30.0/13.0*t3*t5+25.0/13.0*t7*t8+100.0/
143.0*t2*t10+15.0/143.0*s*t12+2.0/429.0*t12*t5)+t18*(30.0/13.0*t3+50.0/13.0*t19
+300.0/143.0*t20+60.0/143.0*t21+10.0/429.0*t12);
      drv[1] = t18*(5.0*t3+120.0/13.0*t19+75.0/13.0*t20+200.0/143.0*t21+15.0/
143.0*t12);
      drv[2] = 0.0;
   /* p=11 3 0 4 */
   } else if( i==3 && j==0 && k==4 ) {
      t1 = r*r;
      t3 = t*t;
      t4 = t3*t3;
      t5 = t3*t;
      t6 = s+r-1.0;
      t8 = t6*t6;
      t10 = t8*t6;
      t12 = t8*t8;
      t16 = t1*r-12.0/19.0*t1+2.0/19.0*r-4.0/969.0;
      t17 = t3*t6;
      t18 = t*t8;
      t20 = t16*(20.0/9.0*t5+10.0/3.0*t17+10.0/7.0*t18+10.0/63.0*t10);
      drv[0] = (3.0*t1-24.0/19.0*r+2.0/19.0)*(t4+20.0/9.0*t5*t6+5.0/3.0*t3*t8+
10.0/21.0*t*t10+5.0/126.0*t12)+t20;
      drv[1] = t20;
      drv[2] = t16*(4.0*t5+20.0/3.0*t17+10.0/3.0*t18+10.0/21.0*t10);
   /* p=11 3 1 3 */
   } else if( i==3 && j==1 && k==3 ) {
      t1 = r*r;
      t3 = s+2.0/11.0*r-2.0/11.0;
      t5 = t*t;
      t7 = s+r-1.0;
      t9 = t7*t7;
      t12 = t5*t+12.0/7.0*t5*t7+6.0/7.0*t*t9+4.0/35.0*t9*t7;
      t15 = t1*r-12.0/19.0*t1+2.0/19.0*r-4.0/969.0;
      t16 = t15*t12;
      t17 = t15*t3;
      t18 = t*t7;
      t20 = t17*(12.0/7.0*t5+12.0/7.0*t18+12.0/35.0*t9);
      drv[0] = t3*(3.0*t1-24.0/19.0*r+2.0/19.0)*t12+2.0/11.0*t16+t20;
      drv[1] = t16+t20;
      drv[2] = t17*(3.0*t5+24.0/7.0*t18+6.0/7.0*t9);
   /* p=11 3 2 2 */
   } else if( i==3 && j==2 && k==2 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t7 = t3+6.0/11.0*s*t4+3.0/55.0*t6;
      t9 = t*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      t13 = t9+6.0/5.0*t*t10+3.0/10.0*t12;
      t16 = t1*r-12.0/19.0*t1+2.0/19.0*r-4.0/969.0;
      t20 = t16*t7;
      t22 = t20*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (3.0*t1-24.0/19.0*r+2.0/19.0)*t7*t13+t16*(6.0/11.0*s+6.0/55.0*r
-6.0/55.0)*t13+t22;
      drv[1] = t16*(2.0*s+6.0/11.0*r-6.0/11.0)*t13+t22;
      drv[2] = t20*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=11 3 3 1 */
   } else if( i==3 && j==3 && k==1 ) {
      t1 = r*r;
      t3 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t10 = t3*s+12.0/11.0*t3*t5+18.0/55.0*s*t7+4.0/165.0*t5*t7;
      t12 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t15 = t1*r-12.0/19.0*t1+2.0/19.0*r-4.0/969.0;
      t16 = s*t5;
      t20 = t15*t10;
      drv[0] = (3.0*t1-24.0/19.0*r+2.0/19.0)*t10*t12+t15*(12.0/11.0*t3+36.0/
55.0*t16+4.0/55.0*t7)*t12+2.0/3.0*t20;
      drv[1] = t15*(3.0*t3+24.0/11.0*t16+18.0/55.0*t7)*t12+2.0/3.0*t20;
      drv[2] = t20;
   /* p=11 3 4 0 */
   } else if( i==3 && j==4 && k==0 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t5 = t3*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t10 = t8*t6;
      t12 = t8*t8;
      t16 = t1*r-12.0/19.0*t1+2.0/19.0*r-4.0/969.0;
      t17 = t3*t6;
      t18 = s*t8;
      drv[0] = (3.0*t1-24.0/19.0*r+2.0/19.0)*(t4+20.0/11.0*t5*t6+12.0/11.0*t3*
t8+8.0/33.0*s*t10+t12/66)+t16*(20.0/11.0*t5+24.0/11.0*t17+8.0/11.0*t18+2.0/33.0
*t10);
      drv[1] = t16*(4.0*t5+60.0/11.0*t17+24.0/11.0*t18+8.0/33.0*t10);
      drv[2] = 0.0;
   /* p=11 4 0 3 */
   } else if( i==4 && j==0 && k==3 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = t*t;
      t6 = s+r-1.0;
      t8 = t6*t6;
      t13 = t1*t1;
      t14 = t13-20.0/19.0*t2+20.0/57.0*t1-40.0/969.0*r+5.0/3876.0;
      t15 = t*t6;
      t17 = t14*(12.0/7.0*t4+12.0/7.0*t15+12.0/35.0*t8);
      drv[0] = (4.0*t2-60.0/19.0*t1+40.0/57.0*r-40.0/969.0)*(t4*t+12.0/7.0*t4*
t6+6.0/7.0*t*t8+4.0/35.0*t8*t6)+t17;
      drv[1] = t17;
      drv[2] = t14*(3.0*t4+24.0/7.0*t15+6.0/7.0*t8);
   /* p=11 4 1 2 */
   } else if( i==4 && j==1 && k==2 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s+2.0/9.0*r-2.0/9.0;
      t6 = t*t;
      t7 = s+r-1.0;
      t9 = t7*t7;
      t10 = t6+6.0/5.0*t*t7+3.0/10.0*t9;
      t12 = t1*t1;
      t13 = t12-20.0/19.0*t2+20.0/57.0*t1-40.0/969.0*r+5.0/3876.0;
      t14 = t13*t10;
      t15 = t13*t4;
      t17 = t15*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (4.0*t2-60.0/19.0*t1+40.0/57.0*r-40.0/969.0)*t4*t10+2.0/9.0*t14+
t17;
      drv[1] = t14+t17;
      drv[2] = t15*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=11 4 2 1 */
   } else if( i==4 && j==2 && k==1 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t8 = t4+2.0/3.0*s*t5+t7/12;
      t10 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t12 = t1*t1;
      t13 = t12-20.0/19.0*t2+20.0/57.0*t1-40.0/969.0*r+5.0/3876.0;
      t17 = t13*t8;
      drv[0] = (4.0*t2-60.0/19.0*t1+40.0/57.0*r-40.0/969.0)*t8*t10+t13*(2.0/3.0
*s+r/6-1.0/6.0)*t10+2.0/3.0*t17;
      drv[1] = t13*(2.0*s+2.0/3.0*r-2.0/3.0)*t10+2.0/3.0*t17;
      drv[2] = t17;
   /* p=11 4 3 0 */
   } else if( i==4 && j==3 && k==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t13 = t1*t1;
      t14 = t13-20.0/19.0*t2+20.0/57.0*t1-40.0/969.0*r+5.0/3876.0;
      t15 = s*t6;
      drv[0] = (4.0*t2-60.0/19.0*t1+40.0/57.0*r-40.0/969.0)*(t4*s+4.0/3.0*t4*t6
+s*t8/2+t8*t6/21)+t14*(4.0/3.0*t4+t15+t8/7);
      drv[1] = t14*(3.0*t4+8.0/3.0*t15+t8/2);
      drv[2] = 0.0;
   /* p=11 5 0 2 */
   } else if( i==5 && j==0 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = t*t;
      t6 = s+r-1.0;
      t8 = t6*t6;
      t12 = t2*r-30.0/19.0*t2+50.0/57.0*t3-200.0/969.0*t1+25.0/1292.0*r-1.0/
1938.0;
      t14 = t12*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (5.0*t2-120.0/19.0*t3+50.0/19.0*t1-400.0/969.0*r+25.0/1292.0)*(
t5+6.0/5.0*t*t6+3.0/10.0*t8)+t14;
      drv[1] = t14;
      drv[2] = t12*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=11 5 1 1 */
   } else if( i==5 && j==1 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s+2.0/7.0*r-2.0/7.0;
      t7 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t10 = t2*r-30.0/19.0*t2+50.0/57.0*t3-200.0/969.0*t1+25.0/1292.0*r-1.0/
1938.0;
      t11 = t10*t7;
      t12 = t5*t10;
      drv[0] = (5.0*t2-120.0/19.0*t3+50.0/19.0*t1-400.0/969.0*r+25.0/1292.0)*t5
*t7+2.0/7.0*t11+2.0/3.0*t12;
      drv[1] = t11+2.0/3.0*t12;
      drv[2] = t12;
   /* p=11 5 2 0 */
   } else if( i==5 && j==2 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t12 = t2*r-30.0/19.0*t2+50.0/57.0*t3-200.0/969.0*t1+25.0/1292.0*r-1.0/
1938.0;
      drv[0] = (5.0*t2-120.0/19.0*t3+50.0/19.0*t1-400.0/969.0*r+25.0/1292.0)*(
t5+6.0/7.0*s*t6+t8/7)+t12*(6.0/7.0*s+2.0/7.0*r-2.0/7.0);
      drv[1] = t12*(2.0*s+6.0/7.0*r-6.0/7.0);
      drv[2] = 0.0;
   /* p=11 6 0 1 */
   } else if( i==6 && j==0 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t8 = t2*t1;
      drv[0] = (6.0*t3-210.0/19.0*t2+140.0/19.0*t4-700.0/323.0*t1+175.0/646.0*r
-7.0/646.0)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0)+2.0/3.0*t8-28.0/19.0*t3+70.0/57.0*
t2-1400.0/2907.0*t4+175.0/1938.0*t1-7.0/969.0*r+1.0/5814.0;
      drv[1] = 2.0/3.0*t8-28.0/19.0*t3+70.0/57.0*t2-1400.0/2907.0*t4+175.0/
1938.0*t1-7.0/969.0*r+1.0/5814.0;
      drv[2] = t8-42.0/19.0*t3+35.0/19.0*t2-700.0/969.0*t4+175.0/1292.0*t1-7.0/
646.0*r+1.0/3876.0;
   /* p=11 6 1 0 */
   } else if( i==6 && j==1 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t8 = t2*t1;
      drv[0] = (6.0*t3-210.0/19.0*t2+140.0/19.0*t4-700.0/323.0*t1+175.0/646.0*r
-7.0/646.0)*(s+2.0/5.0*r-2.0/5.0)+2.0/5.0*t8-84.0/95.0*t3+14.0/19.0*t2-280.0/
969.0*t4+35.0/646.0*t1-7.0/1615.0*r+1.0/9690.0;
      drv[1] = t8-42.0/19.0*t3+35.0/19.0*t2-700.0/969.0*t4+175.0/1292.0*t1-7.0/
646.0*r+1.0/3876.0;
      drv[2] = 0.0;
   /* p=11 7 0 0 */
   } else if( i==7 && j==0 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      drv[0] = 7.0*t2*t1-336.0/19.0*t2*r+980.0/57.0*t2-7840.0/969.0*t1*r+1225.0
/646.0*t1-196.0/969.0*r+7.0/969.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
   /* p=12 0 0 8 */
   } else if( i==0 && j==0 && k==8 ) {
      t1 = t*t;
      t2 = t1*t;
      t3 = t1*t1;
      t4 = t3*t2;
      t6 = s+r-1.0;
      t7 = t3*t1*t6;
      t9 = t6*t6;
      t10 = t3*t*t9;
      t11 = t9*t6;
      t12 = t3*t11;
      t13 = t9*t9;
      t14 = t2*t13;
      t16 = t1*t13*t6;
      t18 = t*t13*t9;
      t19 = t13*t11;
      t20 = 72.0/17.0*t4+252.0/17.0*t7+1764.0/85.0*t10+252.0/17.0*t12+1260.0/
221.0*t14+252.0/221.0*t16+252.0/2431.0*t18+36.0/12155.0*t19;
      drv[0] = t20;
      drv[1] = t20;
      drv[2] = 8.0*t4+504.0/17.0*t7+756.0/17.0*t10+588.0/17.0*t12+252.0/17.0*
t14+756.0/221.0*t16+84.0/221.0*t18+36.0/2431.0*t19;
   /* p=12 0 1 7 */
   } else if( i==0 && j==1 && k==7 ) {
      t1 = t*t;
      t2 = t1*t;
      t3 = t1*t1;
      t4 = t3*t2;
      t5 = t3*t1;
      t6 = s+r-1.0;
      t7 = t5*t6;
      t8 = t3*t;
      t9 = t6*t6;
      t10 = t8*t9;
      t11 = t9*t6;
      t12 = t3*t11;
      t13 = t9*t9;
      t14 = t2*t13;
      t15 = t13*t6;
      t16 = t1*t15;
      t17 = t13*t9;
      t18 = t*t17;
      t19 = t13*t11;
      t20 = s+2.0/19.0*r-2.0/19.0;
      t21 = t8*t6;
      t22 = t3*t9;
      t23 = t2*t11;
      t24 = t1*t13;
      t25 = t*t15;
      t27 = t20*(56.0/15.0*t5+56.0/5.0*t21+168.0/13.0*t22+280.0/39.0*t23+280.0/
143.0*t24+168.0/715.0*t25+56.0/6435.0*t17);
      drv[0] = 2.0/19.0*t4+112.0/285.0*t7+56.0/95.0*t10+112.0/247.0*t12+140.0/
741.0*t14+112.0/2717.0*t16+56.0/13585.0*t18+16.0/122265.0*t19+t27;
      drv[1] = t4+56.0/15.0*t7+28.0/5.0*t10+56.0/13.0*t12+70.0/39.0*t14+56.0/
143.0*t16+28.0/715.0*t18+8.0/6435.0*t19+t27;
      drv[2] = t20*(7.0*t5+112.0/5.0*t21+28.0*t22+224.0/13.0*t23+70.0/13.0*t24+
112.0/143.0*t25+28.0/715.0*t17);
   /* p=12 0 2 6 */
   } else if( i==0 && j==2 && k==6 ) {
      t2 = t*t;
      t3 = t2*t2;
      t5 = t3*t;
      t6 = s+r-1.0;
      t8 = t6*t6;
      t10 = t2*t;
      t11 = t8*t6;
      t13 = t8*t8;
      t15 = t13*t6;
      t18 = t3*t2+42.0/13.0*t5*t6+105.0/26.0*t3*t8+350.0/143.0*t10*t11+105.0/
143.0*t2*t13+14.0/143.0*t*t15+7.0/1716.0*t13*t8;
      t20 = s*s;
      t21 = r-1.0;
      t23 = t21*t21;
      t24 = t20+6.0/19.0*s*t21+t23/57;
      t25 = t3*t6;
      t26 = t10*t8;
      t27 = t2*t11;
      t28 = t*t13;
      t30 = t24*(42.0/13.0*t5+105.0/13.0*t25+1050.0/143.0*t26+420.0/143.0*t27+
70.0/143.0*t28+7.0/286.0*t15);
      drv[0] = (6.0/19.0*s+2.0/57.0*r-2.0/57.0)*t18+t30;
      drv[1] = (2.0*s+6.0/19.0*r-6.0/19.0)*t18+t30;
      drv[2] = t24*(6.0*t5+210.0/13.0*t25+210.0/13.0*t26+1050.0/143.0*t27+210.0
/143.0*t28+14.0/143.0*t15);
   /* p=12 0 3 5 */
   } else if( i==0 && j==3 && k==5 ) {
      t1 = s*s;
      t2 = r-1.0;
      t3 = s*t2;
      t4 = t2*t2;
      t6 = t*t;
      t7 = t6*t6;
      t9 = s+r-1.0;
      t11 = t6*t;
      t12 = t9*t9;
      t14 = t12*t9;
      t16 = t12*t12;
      t19 = t7*t+30.0/11.0*t7*t9+30.0/11.0*t11*t12+40.0/33.0*t6*t14+5.0/22.0*t*
t16+t16*t9/77;
      t25 = t1*s+12.0/19.0*t1*t2+2.0/19.0*s*t4+4.0/969.0*t4*t2;
      t26 = t11*t9;
      t27 = t6*t12;
      t28 = t*t14;
      t30 = t25*(30.0/11.0*t7+60.0/11.0*t26+40.0/11.0*t27+10.0/11.0*t28+5.0/
77.0*t16);
      drv[0] = (12.0/19.0*t1+4.0/19.0*t3+4.0/323.0*t4)*t19+t30;
      drv[1] = (3.0*t1+24.0/19.0*t3+2.0/19.0*t4)*t19+t30;
      drv[2] = t25*(5.0*t7+120.0/11.0*t26+90.0/11.0*t27+80.0/33.0*t28+5.0/22.0*
t16);
   /* p=12 0 4 4 */
   } else if( i==0 && j==4 && k==4 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = r-1.0;
      t4 = t3*t1;
      t5 = t3*t3;
      t6 = s*t5;
      t7 = t5*t3;
      t9 = t*t;
      t10 = t9*t9;
      t11 = t9*t;
      t12 = s+r-1.0;
      t14 = t12*t12;
      t16 = t14*t12;
      t18 = t14*t14;
      t19 = t10+20.0/9.0*t11*t12+5.0/3.0*t9*t14+10.0/21.0*t*t16+5.0/126.0*t18;
      t21 = t1*t1;
      t25 = t5*t5;
      t26 = t21+20.0/19.0*t3*t2+20.0/57.0*t1*t5+40.0/969.0*s*t7+5.0/3876.0*t25;
      t27 = t9*t12;
      t28 = t*t14;
      t30 = t26*(20.0/9.0*t11+10.0/3.0*t27+10.0/7.0*t28+10.0/63.0*t16);
      drv[0] = (20.0/19.0*t2+40.0/57.0*t4+40.0/323.0*t6+5.0/969.0*t7)*t19+t30;
      drv[1] = (4.0*t2+60.0/19.0*t4+40.0/57.0*t6+40.0/969.0*t7)*t19+t30;
      drv[2] = t26*(4.0*t11+20.0/3.0*t27+10.0/3.0*t28+10.0/21.0*t16);
   /* p=12 0 5 3 */
   } else if( i==0 && j==5 && k==3 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t1*s;
      t4 = r-1.0;
      t5 = t3*t4;
      t6 = t4*t4;
      t7 = t1*t6;
      t8 = t6*t4;
      t9 = s*t8;
      t10 = t6*t6;
      t12 = t*t;
      t14 = s+r-1.0;
      t16 = t14*t14;
      t19 = t12*t+12.0/7.0*t14*t12+6.0/7.0*t*t16+4.0/35.0*t16*t14;
      t27 = t2*s+30.0/19.0*t4*t2+50.0/57.0*t3*t6+200.0/969.0*t1*t8+25.0/1292.0*
s*t10+t10*t4/1938;
      t28 = t*t14;
      t30 = t27*(12.0/7.0*t12+12.0/7.0*t28+12.0/35.0*t16);
      drv[0] = (30.0/19.0*t2+100.0/57.0*t5+200.0/323.0*t7+25.0/323.0*t9+5.0/
1938.0*t10)*t19+t30;
      drv[1] = (5.0*t2+120.0/19.0*t5+50.0/19.0*t7+400.0/969.0*t9+25.0/1292.0*
t10)*t19+t30;
      drv[2] = t27*(3.0*t12+24.0/7.0*t28+6.0/7.0*t16);
   /* p=12 0 6 2 */
   } else if( i==0 && j==6 && k==2 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*s;
      t4 = r-1.0;
      t5 = t4*t2;
      t6 = t1*s;
      t7 = t4*t4;
      t8 = t6*t7;
      t9 = t7*t4;
      t10 = t1*t9;
      t11 = t7*t7;
      t12 = s*t11;
      t13 = t11*t4;
      t15 = t*t;
      t16 = s+r-1.0;
      t18 = t16*t16;
      t19 = t15+6.0/5.0*t*t16+3.0/10.0*t18;
      t28 = t2*t1+42.0/19.0*t3*t4+35.0/19.0*t2*t7+700.0/969.0*t6*t9+175.0/
1292.0*t1*t11+7.0/646.0*s*t13+t11*t7/3876;
      t30 = t28*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (42.0/19.0*t3+70.0/19.0*t5+700.0/323.0*t8+175.0/323.0*t10+35.0/
646.0*t12+t13/646)*t19+t30;
      drv[1] = (6.0*t3+210.0/19.0*t5+140.0/19.0*t8+700.0/323.0*t10+175.0/646.0*
t12+7.0/646.0*t13)*t19+t30;
      drv[2] = t28*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=12 0 7 1 */
   } else if( i==0 && j==7 && k==1 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t2*s;
      t5 = r-1.0;
      t6 = t4*t5;
      t7 = t5*t5;
      t8 = t2*t7;
      t9 = t1*s;
      t10 = t7*t5;
      t11 = t9*t10;
      t12 = t7*t7;
      t13 = t1*t12;
      t14 = t12*t5;
      t15 = s*t14;
      t16 = t12*t7;
      t18 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t20 = t2*t9;
      t21 = t3*t5;
      t22 = t4*t7;
      t23 = t2*t10;
      t24 = t9*t12;
      t25 = t1*t14;
      t26 = s*t16;
      t27 = t12*t10;
      drv[0] = (56.0/19.0*t3+392.0/57.0*t6+1960.0/323.0*t8+2450.0/969.0*t11+
490.0/969.0*t13+14.0/323.0*t15+14.0/12597.0*t16)*t18+2.0/3.0*t20+112.0/57.0*t21
+392.0/171.0*t22+3920.0/2907.0*t23+1225.0/2907.0*t24+196.0/2907.0*t25+14.0/
2907.0*t26+4.0/37791.0*t27;
      drv[1] = (7.0*t3+336.0/19.0*t6+980.0/57.0*t8+7840.0/969.0*t11+1225.0/
646.0*t13+196.0/969.0*t15+7.0/969.0*t16)*t18+2.0/3.0*t20+112.0/57.0*t21+392.0/
171.0*t22+3920.0/2907.0*t23+1225.0/2907.0*t24+196.0/2907.0*t25+14.0/2907.0*t26+
4.0/37791.0*t27;
      drv[2] = t20+56.0/19.0*t21+196.0/57.0*t22+1960.0/969.0*t23+1225.0/1938.0*
t24+98.0/969.0*t25+7.0/969.0*t26+2.0/12597.0*t27;
   /* p=12 0 8 0 */
   } else if( i==0 && j==8 && k==0 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t4 = t3*t2;
      t6 = r-1.0;
      t7 = t3*t1*t6;
      t9 = t6*t6;
      t10 = t3*s*t9;
      t11 = t9*t6;
      t12 = t3*t11;
      t13 = t9*t9;
      t14 = t2*t13;
      t16 = t1*t13*t6;
      t18 = s*t13*t9;
      t19 = t13*t11;
      drv[0] = 72.0/19.0*t4+224.0/19.0*t7+4704.0/323.0*t10+2940.0/323.0*t12+
980.0/323.0*t14+168.0/323.0*t16+168.0/4199.0*t18+4.0/4199.0*t19;
      drv[1] = 8.0*t4+504.0/19.0*t7+672.0/19.0*t10+7840.0/323.0*t12+2940.0/
323.0*t14+588.0/323.0*t16+56.0/323.0*t18+24.0/4199.0*t19;
      drv[2] = 0.0;
   /* p=12 1 0 7 */
   } else if( i==1 && j==0 && k==7 ) {
      t1 = t*t;
      t2 = t1*t;
      t3 = t1*t1;
      t5 = t3*t1;
      t6 = s+r-1.0;
      t8 = t3*t;
      t9 = t6*t6;
      t11 = t9*t6;
      t13 = t9*t9;
      t15 = t13*t6;
      t17 = t13*t9;
      t20 = r-2.0/21.0;
      t21 = t8*t6;
      t22 = t3*t9;
      t23 = t2*t11;
      t24 = t1*t13;
      t25 = t*t15;
      t27 = t20*(56.0/15.0*t5+56.0/5.0*t21+168.0/13.0*t22+280.0/39.0*t23+280.0/
143.0*t24+168.0/715.0*t25+56.0/6435.0*t17);
      drv[0] = t3*t2+56.0/15.0*t5*t6+28.0/5.0*t8*t9+56.0/13.0*t3*t11+70.0/39.0*
t2*t13+56.0/143.0*t1*t15+28.0/715.0*t*t17+8.0/6435.0*t13*t11+t27;
      drv[1] = t27;
      drv[2] = t20*(7.0*t5+112.0/5.0*t21+28.0*t22+224.0/13.0*t23+70.0/13.0*t24+
112.0/143.0*t25+28.0/715.0*t17);
   /* p=12 1 1 6 */
   } else if( i==1 && j==1 && k==6 ) {
      t1 = s+2.0/17.0*r-2.0/17.0;
      t2 = t*t;
      t3 = t2*t2;
      t5 = t3*t;
      t6 = s+r-1.0;
      t8 = t6*t6;
      t10 = t2*t;
      t11 = t8*t6;
      t13 = t8*t8;
      t15 = t13*t6;
      t18 = t3*t2+42.0/13.0*t5*t6+105.0/26.0*t3*t8+350.0/143.0*t10*t11+105.0/
143.0*t2*t13+14.0/143.0*t*t15+7.0/1716.0*t13*t8;
      t20 = r-2.0/21.0;
      t21 = t20*t18;
      t22 = t20*t1;
      t23 = t3*t6;
      t24 = t10*t8;
      t25 = t2*t11;
      t26 = t*t13;
      t28 = t22*(42.0/13.0*t5+105.0/13.0*t23+1050.0/143.0*t24+420.0/143.0*t25+
70.0/143.0*t26+7.0/286.0*t15);
      drv[0] = t1*t18+2.0/17.0*t21+t28;
      drv[1] = t21+t28;
      drv[2] = t22*(6.0*t5+210.0/13.0*t23+210.0/13.0*t24+1050.0/143.0*t25+210.0
/143.0*t26+14.0/143.0*t15);
   /* p=12 1 2 5 */
   } else if( i==1 && j==2 && k==5 ) {
      t1 = s*s;
      t2 = r-1.0;
      t4 = t2*t2;
      t5 = t1+6.0/17.0*s*t2+3.0/136.0*t4;
      t6 = t*t;
      t7 = t6*t6;
      t9 = s+r-1.0;
      t11 = t6*t;
      t12 = t9*t9;
      t14 = t12*t9;
      t16 = t12*t12;
      t19 = t7*t+30.0/11.0*t7*t9+30.0/11.0*t11*t12+40.0/33.0*t6*t14+5.0/22.0*t*
t16+t16*t9/77;
      t21 = r-2.0/21.0;
      t25 = t21*t5;
      t26 = t11*t9;
      t27 = t6*t12;
      t28 = t*t14;
      t30 = t25*(30.0/11.0*t7+60.0/11.0*t26+40.0/11.0*t27+10.0/11.0*t28+5.0/
77.0*t16);
      drv[0] = t5*t19+t21*(6.0/17.0*s+3.0/68.0*r-3.0/68.0)*t19+t30;
      drv[1] = t21*(2.0*s+6.0/17.0*r-6.0/17.0)*t19+t30;
      drv[2] = t25*(5.0*t7+120.0/11.0*t26+90.0/11.0*t27+80.0/33.0*t28+5.0/22.0*
t16);
   /* p=12 1 3 4 */
   } else if( i==1 && j==3 && k==4 ) {
      t1 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t8 = t1*s+12.0/17.0*t3*t1+9.0/68.0*s*t5+t5*t3/170;
      t9 = t*t;
      t10 = t9*t9;
      t11 = t9*t;
      t12 = s+r-1.0;
      t14 = t12*t12;
      t16 = t14*t12;
      t18 = t14*t14;
      t19 = t10+20.0/9.0*t11*t12+5.0/3.0*t9*t14+10.0/21.0*t*t16+5.0/126.0*t18;
      t21 = r-2.0/21.0;
      t22 = s*t3;
      t26 = t21*t8;
      t27 = t12*t9;
      t28 = t*t14;
      t30 = t26*(20.0/9.0*t11+10.0/3.0*t27+10.0/7.0*t28+10.0/63.0*t16);
      drv[0] = t8*t19+t21*(12.0/17.0*t1+9.0/34.0*t22+3.0/170.0*t5)*t19+t30;
      drv[1] = t21*(3.0*t1+24.0/17.0*t22+9.0/68.0*t5)*t19+t30;
      drv[2] = t26*(4.0*t11+20.0/3.0*t27+10.0/3.0*t28+10.0/21.0*t16);
   /* p=12 1 4 3 */
   } else if( i==1 && j==4 && k==3 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t1*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t8 = t6*t4;
      t10 = t6*t6;
      t11 = t2+20.0/17.0*t3*t4+15.0/34.0*t1*t6+s*t8/17+t10/476;
      t12 = t*t;
      t14 = s+r-1.0;
      t16 = t14*t14;
      t19 = t12*t+12.0/7.0*t14*t12+6.0/7.0*t*t16+4.0/35.0*t16*t14;
      t21 = r-2.0/21.0;
      t22 = t4*t1;
      t23 = s*t6;
      t27 = t21*t11;
      t28 = t*t14;
      t30 = t27*(12.0/7.0*t12+12.0/7.0*t28+12.0/35.0*t16);
      drv[0] = t11*t19+t21*(20.0/17.0*t3+15.0/17.0*t22+3.0/17.0*t23+t8/119)*t19
+t30;
      drv[1] = t21*(4.0*t3+60.0/17.0*t22+15.0/17.0*t23+t8/17)*t19+t30;
      drv[2] = t27*(3.0*t12+24.0/7.0*t28+6.0/7.0*t16);
   /* p=12 1 5 2 */
   } else if( i==1 && j==5 && k==2 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t6 = t1*s;
      t7 = t4*t4;
      t9 = t7*t4;
      t11 = t7*t7;
      t14 = t2*s+30.0/17.0*t4*t2+75.0/68.0*t6*t7+5.0/17.0*t1*t9+15.0/476.0*s*
t11+3.0/3094.0*t11*t4;
      t15 = t*t;
      t16 = s+r-1.0;
      t18 = t16*t16;
      t19 = t15+6.0/5.0*t*t16+3.0/10.0*t18;
      t21 = r-2.0/21.0;
      t22 = t6*t4;
      t23 = t1*t7;
      t24 = s*t9;
      t28 = t21*t14;
      t30 = t28*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = t14*t19+t21*(30.0/17.0*t2+75.0/34.0*t22+15.0/17.0*t23+15.0/119.0
*t24+15.0/3094.0*t11)*t19+t30;
      drv[1] = t21*(5.0*t2+120.0/17.0*t22+225.0/68.0*t23+10.0/17.0*t24+15.0/
476.0*t11)*t19+t30;
      drv[2] = t28*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=12 1 6 1 */
   } else if( i==1 && j==6 && k==1 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = t2*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t9 = t1*s;
      t10 = t7*t5;
      t12 = t7*t7;
      t14 = t12*t5;
      t17 = t2*t1+42.0/17.0*t4*t5+315.0/136.0*t2*t7+35.0/34.0*t9*t10+15.0/68.0*
t1*t12+9.0/442.0*s*t14+t12*t7/1768;
      t18 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t20 = r-2.0/21.0;
      t21 = t2*t5;
      t22 = t9*t7;
      t23 = t1*t10;
      t24 = s*t12;
      t28 = t20*t17;
      drv[0] = t17*t18+t20*(42.0/17.0*t4+315.0/68.0*t21+105.0/34.0*t22+15.0/
17.0*t23+45.0/442.0*t24+3.0/884.0*t14)*t18+2.0/3.0*t28;
      drv[1] = t20*(6.0*t4+210.0/17.0*t21+315.0/34.0*t22+105.0/34.0*t23+15.0/
34.0*t24+9.0/442.0*t14)*t18+2.0/3.0*t28;
      drv[2] = t28;
   /* p=12 1 7 0 */
   } else if( i==1 && j==7 && k==0 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t5 = t3*t1;
      t6 = r-1.0;
      t8 = t3*s;
      t9 = t6*t6;
      t11 = t9*t6;
      t13 = t9*t9;
      t15 = t13*t6;
      t17 = t13*t9;
      t20 = r-2.0/21.0;
      t21 = t8*t6;
      t22 = t3*t9;
      t23 = t2*t11;
      t24 = t1*t13;
      t25 = s*t15;
      drv[0] = t3*t2+56.0/17.0*t5*t6+147.0/34.0*t8*t9+49.0/17.0*t3*t11+35.0/
34.0*t2*t13+42.0/221.0*t1*t15+7.0/442.0*s*t17+t13*t11/2431+t20*(56.0/17.0*t5+
147.0/17.0*t21+147.0/17.0*t22+70.0/17.0*t23+210.0/221.0*t24+21.0/221.0*t25+7.0/
2431.0*t17);
      drv[1] = t20*(7.0*t5+336.0/17.0*t21+735.0/34.0*t22+196.0/17.0*t23+105.0/
34.0*t24+84.0/221.0*t25+7.0/442.0*t17);
      drv[2] = 0.0;
   /* p=12 2 0 6 */
   } else if( i==2 && j==0 && k==6 ) {
      t2 = t*t;
      t3 = t2*t2;
      t5 = t3*t;
      t6 = s+r-1.0;
      t8 = t6*t6;
      t10 = t2*t;
      t11 = t8*t6;
      t13 = t8*t8;
      t15 = t13*t6;
      t20 = r*r;
      t21 = t20-2.0/7.0*r+1.0/70.0;
      t22 = t3*t6;
      t23 = t10*t8;
      t24 = t2*t11;
      t25 = t*t13;
      t27 = t21*(42.0/13.0*t5+105.0/13.0*t22+1050.0/143.0*t23+420.0/143.0*t24+
70.0/143.0*t25+7.0/286.0*t15);
      drv[0] = (2.0*r-2.0/7.0)*(t3*t2+42.0/13.0*t5*t6+105.0/26.0*t3*t8+350.0/
143.0*t10*t11+105.0/143.0*t2*t13+14.0/143.0*t*t15+7.0/1716.0*t13*t8)+t27;
      drv[1] = t27;
      drv[2] = t21*(6.0*t5+210.0/13.0*t22+210.0/13.0*t23+1050.0/143.0*t24+210.0
/143.0*t25+14.0/143.0*t15);
   /* p=12 2 1 5 */
   } else if( i==2 && j==1 && k==5 ) {
      t2 = s+2.0/15.0*r-2.0/15.0;
      t4 = t*t;
      t5 = t4*t4;
      t7 = s+r-1.0;
      t9 = t4*t;
      t10 = t7*t7;
      t12 = t10*t7;
      t14 = t10*t10;
      t17 = t5*t+30.0/11.0*t5*t7+30.0/11.0*t9*t10+40.0/33.0*t4*t12+5.0/22.0*t*
t14+t14*t7/77;
      t19 = r*r;
      t20 = t19-2.0/7.0*r+1.0/70.0;
      t21 = t20*t17;
      t22 = t20*t2;
      t23 = t9*t7;
      t24 = t4*t10;
      t25 = t*t12;
      t27 = t22*(30.0/11.0*t5+60.0/11.0*t23+40.0/11.0*t24+10.0/11.0*t25+5.0/
77.0*t14);
      drv[0] = (2.0*r-2.0/7.0)*t2*t17+2.0/15.0*t21+t27;
      drv[1] = t21+t27;
      drv[2] = t22*(5.0*t5+120.0/11.0*t23+90.0/11.0*t24+80.0/33.0*t25+5.0/22.0*
t14);
   /* p=12 2 2 4 */
   } else if( i==2 && j==2 && k==4 ) {
      t2 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t6 = t2+2.0/5.0*s*t3+t5/35;
      t8 = t*t;
      t9 = t8*t8;
      t10 = t8*t;
      t11 = s+r-1.0;
      t13 = t11*t11;
      t15 = t13*t11;
      t17 = t13*t13;
      t18 = t9+20.0/9.0*t10*t11+5.0/3.0*t13*t8+10.0/21.0*t*t15+5.0/126.0*t17;
      t20 = r*r;
      t21 = t20-2.0/7.0*r+1.0/70.0;
      t25 = t21*t6;
      t26 = t8*t11;
      t27 = t*t13;
      t29 = t25*(20.0/9.0*t10+10.0/3.0*t26+10.0/7.0*t27+10.0/63.0*t15);
      drv[0] = (2.0*r-2.0/7.0)*t6*t18+t21*(2.0/5.0*s+2.0/35.0*r-2.0/35.0)*t18+
t29;
      drv[1] = t21*(2.0*s+2.0/5.0*r-2.0/5.0)*t18+t29;
      drv[2] = t25*(4.0*t10+20.0/3.0*t26+10.0/3.0*t27+10.0/21.0*t15);
   /* p=12 2 3 3 */
   } else if( i==2 && j==3 && k==3 ) {
      t2 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t9 = t2*s+4.0/5.0*t4*t2+6.0/35.0*s*t6+4.0/455.0*t6*t4;
      t11 = t*t;
      t13 = s+r-1.0;
      t15 = t13*t13;
      t18 = t11*t+12.0/7.0*t13*t11+6.0/7.0*t*t15+4.0/35.0*t15*t13;
      t20 = r*r;
      t21 = t20-2.0/7.0*r+1.0/70.0;
      t22 = s*t4;
      t26 = t21*t9;
      t27 = t*t13;
      t29 = t26*(12.0/7.0*t11+12.0/7.0*t27+12.0/35.0*t15);
      drv[0] = (2.0*r-2.0/7.0)*t9*t18+t21*(4.0/5.0*t2+12.0/35.0*t22+12.0/455.0*
t6)*t18+t29;
      drv[1] = t21*(3.0*t2+8.0/5.0*t22+6.0/35.0*t6)*t18+t29;
      drv[2] = t26*(3.0*t11+24.0/7.0*t27+6.0/7.0*t15);
   /* p=12 2 4 2 */
   } else if( i==2 && j==4 && k==2 ) {
      t2 = s*s;
      t3 = t2*t2;
      t4 = t2*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t9 = t7*t5;
      t11 = t7*t7;
      t12 = t3+4.0/3.0*t4*t5+4.0/7.0*t2*t7+8.0/91.0*s*t9+t11/273;
      t14 = t*t;
      t15 = s+r-1.0;
      t17 = t15*t15;
      t18 = t14+6.0/5.0*t*t15+3.0/10.0*t17;
      t20 = r*r;
      t21 = t20-2.0/7.0*r+1.0/70.0;
      t22 = t2*t5;
      t23 = s*t7;
      t27 = t21*t12;
      t29 = t27*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (2.0*r-2.0/7.0)*t12*t18+t21*(4.0/3.0*t4+8.0/7.0*t22+24.0/91.0*
t23+4.0/273.0*t9)*t18+t29;
      drv[1] = t21*(4.0*t4+4.0*t22+8.0/7.0*t23+8.0/91.0*t9)*t18+t29;
      drv[2] = t27*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=12 2 5 1 */
   } else if( i==2 && j==5 && k==1 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = r-1.0;
      t7 = t2*s;
      t8 = t5*t5;
      t10 = t8*t5;
      t12 = t8*t8;
      t15 = t3*s+2.0*t3*t5+10.0/7.0*t7*t8+40.0/91.0*t2*t10+5.0/91.0*s*t12+2.0/
1001.0*t12*t5;
      t17 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t19 = r*r;
      t20 = t19-2.0/7.0*r+1.0/70.0;
      t21 = t7*t5;
      t22 = t2*t8;
      t23 = s*t10;
      t27 = t20*t15;
      drv[0] = (2.0*r-2.0/7.0)*t15*t17+t20*(2.0*t3+20.0/7.0*t21+120.0/91.0*t22+
20.0/91.0*t23+10.0/1001.0*t12)*t17+2.0/3.0*t27;
      drv[1] = t20*(5.0*t3+8.0*t21+30.0/7.0*t22+80.0/91.0*t23+5.0/91.0*t12)*t17
+2.0/3.0*t27;
      drv[2] = t27;
   /* p=12 2 6 0 */
   } else if( i==2 && j==6 && k==0 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = t3*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t10 = t2*s;
      t11 = t8*t6;
      t13 = t8*t8;
      t15 = t13*t6;
      t20 = r*r;
      t21 = t20-2.0/7.0*r+1.0/70.0;
      t22 = t3*t6;
      t23 = t10*t8;
      t24 = t2*t11;
      t25 = s*t13;
      drv[0] = (2.0*r-2.0/7.0)*(t3*t2+14.0/5.0*t5*t6+3.0*t3*t8+20.0/13.0*t10*
t11+5.0/13.0*t2*t13+6.0/143.0*s*t15+t13*t8/715)+t21*(14.0/5.0*t5+6.0*t22+60.0/
13.0*t23+20.0/13.0*t24+30.0/143.0*t25+6.0/715.0*t15);
      drv[1] = t21*(6.0*t5+14.0*t22+12.0*t23+60.0/13.0*t24+10.0/13.0*t25+6.0/
143.0*t15);
      drv[2] = 0.0;
   /* p=12 3 0 5 */
   } else if( i==3 && j==0 && k==5 ) {
      t1 = r*r;
      t3 = t*t;
      t4 = t3*t3;
      t6 = s+r-1.0;
      t8 = t3*t;
      t9 = t6*t6;
      t11 = t9*t6;
      t13 = t9*t9;
      t19 = t1*r-4.0/7.0*t1+3.0/35.0*r-2.0/665.0;
      t20 = t8*t6;
      t21 = t3*t9;
      t22 = t*t11;
      t24 = t19*(30.0/11.0*t4+60.0/11.0*t20+40.0/11.0*t21+10.0/11.0*t22+5.0/
77.0*t13);
      drv[0] = (3.0*t1-8.0/7.0*r+3.0/35.0)*(t4*t+30.0/11.0*t4*t6+30.0/11.0*t8*
t9+40.0/33.0*t3*t11+5.0/22.0*t*t13+t13*t6/77)+t24;
      drv[1] = t24;
      drv[2] = t19*(5.0*t4+120.0/11.0*t20+90.0/11.0*t21+80.0/33.0*t22+5.0/22.0*
t13);
   /* p=12 3 1 4 */
   } else if( i==3 && j==1 && k==4 ) {
      t1 = r*r;
      t3 = s+2.0/13.0*r-2.0/13.0;
      t5 = t*t;
      t6 = t5*t5;
      t7 = t5*t;
      t8 = s+r-1.0;
      t10 = t8*t8;
      t12 = t10*t8;
      t14 = t10*t10;
      t15 = t6+20.0/9.0*t7*t8+5.0/3.0*t5*t10+10.0/21.0*t*t12+5.0/126.0*t14;
      t18 = t1*r-4.0/7.0*t1+3.0/35.0*r-2.0/665.0;
      t19 = t18*t15;
      t20 = t18*t3;
      t21 = t5*t8;
      t22 = t*t10;
      t24 = t20*(20.0/9.0*t7+10.0/3.0*t21+10.0/7.0*t22+10.0/63.0*t12);
      drv[0] = t3*(3.0*t1-8.0/7.0*r+3.0/35.0)*t15+2.0/13.0*t19+t24;
      drv[1] = t19+t24;
      drv[2] = t20*(4.0*t7+20.0/3.0*t21+10.0/3.0*t22+10.0/21.0*t12);
   /* p=12 3 2 3 */
   } else if( i==3 && j==2 && k==3 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t7 = t3+6.0/13.0*s*t4+t6/26;
      t9 = t*t;
      t11 = s+r-1.0;
      t13 = t11*t11;
      t16 = t9*t+12.0/7.0*t9*t11+6.0/7.0*t*t13+4.0/35.0*t13*t11;
      t19 = t1*r-4.0/7.0*t1+3.0/35.0*r-2.0/665.0;
      t23 = t19*t7;
      t24 = t*t11;
      t26 = t23*(12.0/7.0*t9+12.0/7.0*t24+12.0/35.0*t13);
      drv[0] = (3.0*t1-8.0/7.0*r+3.0/35.0)*t7*t16+t19*(6.0/13.0*s+r/13-1.0/13.0
)*t16+t26;
      drv[1] = t19*(2.0*s+6.0/13.0*r-6.0/13.0)*t16+t26;
      drv[2] = t23*(3.0*t9+24.0/7.0*t24+6.0/7.0*t13);
   /* p=12 3 3 2 */
   } else if( i==3 && j==3 && k==2 ) {
      t1 = r*r;
      t3 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t10 = t3*s+12.0/13.0*t3*t5+3.0/13.0*s*t7+2.0/143.0*t7*t5;
      t12 = t*t;
      t13 = s+r-1.0;
      t15 = t13*t13;
      t16 = t12+6.0/5.0*t*t13+3.0/10.0*t15;
      t19 = t1*r-4.0/7.0*t1+3.0/35.0*r-2.0/665.0;
      t20 = s*t5;
      t24 = t19*t10;
      t26 = t24*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (3.0*t1-8.0/7.0*r+3.0/35.0)*t10*t16+t19*(12.0/13.0*t3+6.0/13.0*
t20+6.0/143.0*t7)*t16+t26;
      drv[1] = t19*(3.0*t3+24.0/13.0*t20+3.0/13.0*t7)*t16+t26;
      drv[2] = t24*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=12 3 4 1 */
   } else if( i==3 && j==4 && k==1 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t5 = t3*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t10 = t8*t6;
      t12 = t8*t8;
      t13 = t4+20.0/13.0*t5*t6+10.0/13.0*t3*t8+20.0/143.0*s*t10+t12/143;
      t15 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t18 = t1*r-4.0/7.0*t1+3.0/35.0*r-2.0/665.0;
      t19 = t3*t6;
      t20 = s*t8;
      t24 = t18*t13;
      drv[0] = (3.0*t1-8.0/7.0*r+3.0/35.0)*t13*t15+t18*(20.0/13.0*t5+20.0/13.0*
t19+60.0/143.0*t20+4.0/143.0*t10)*t15+2.0/3.0*t24;
      drv[1] = t18*(4.0*t5+60.0/13.0*t19+20.0/13.0*t20+20.0/143.0*t10)*t15+2.0/
3.0*t24;
      drv[2] = t24;
   /* p=12 3 5 0 */
   } else if( i==3 && j==5 && k==0 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t6 = r-1.0;
      t8 = t3*s;
      t9 = t6*t6;
      t11 = t9*t6;
      t13 = t9*t9;
      t19 = t1*r-4.0/7.0*t1+3.0/35.0*r-2.0/665.0;
      t20 = t8*t6;
      t21 = t3*t9;
      t22 = s*t11;
      drv[0] = (3.0*t1-8.0/7.0*r+3.0/35.0)*(t4*s+30.0/13.0*t4*t6+25.0/13.0*t8*
t9+100.0/143.0*t3*t11+15.0/143.0*s*t13+2.0/429.0*t13*t6)+t19*(30.0/13.0*t4+50.0
/13.0*t20+300.0/143.0*t21+60.0/143.0*t22+10.0/429.0*t13);
      drv[1] = t19*(5.0*t4+120.0/13.0*t20+75.0/13.0*t21+200.0/143.0*t22+15.0/
143.0*t13);
      drv[2] = 0.0;
   /* p=12 4 0 4 */
   } else if( i==4 && j==0 && k==4 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = t*t;
      t5 = t4*t4;
      t6 = t4*t;
      t7 = s+r-1.0;
      t9 = t7*t7;
      t11 = t9*t7;
      t13 = t9*t9;
      t16 = t1*t1;
      t17 = t16-20.0/21.0*t2+2.0/7.0*t1-4.0/133.0*r+1.0/1197.0;
      t18 = t4*t7;
      t19 = t*t9;
      t21 = t17*(20.0/9.0*t6+10.0/3.0*t18+10.0/7.0*t19+10.0/63.0*t11);
      drv[0] = (4.0*t2-20.0/7.0*t1+4.0/7.0*r-4.0/133.0)*(t5+20.0/9.0*t6*t7+5.0/
3.0*t4*t9+10.0/21.0*t*t11+5.0/126.0*t13)+t21;
      drv[1] = t21;
      drv[2] = t17*(4.0*t6+20.0/3.0*t18+10.0/3.0*t19+10.0/21.0*t11);
   /* p=12 4 1 3 */
   } else if( i==4 && j==1 && k==3 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s+2.0/11.0*r-2.0/11.0;
      t6 = t*t;
      t8 = s+r-1.0;
      t10 = t8*t8;
      t13 = t6*t+12.0/7.0*t8*t6+6.0/7.0*t*t10+4.0/35.0*t10*t8;
      t15 = t1*t1;
      t16 = t15-20.0/21.0*t2+2.0/7.0*t1-4.0/133.0*r+1.0/1197.0;
      t17 = t16*t13;
      t18 = t16*t4;
      t19 = t*t8;
      t21 = t18*(12.0/7.0*t6+12.0/7.0*t19+12.0/35.0*t10);
      drv[0] = (4.0*t2-20.0/7.0*t1+4.0/7.0*r-4.0/133.0)*t4*t13+2.0/11.0*t17+t21
;
      drv[1] = t17+t21;
      drv[2] = t18*(3.0*t6+24.0/7.0*t19+6.0/7.0*t10);
   /* p=12 4 2 2 */
   } else if( i==4 && j==2 && k==2 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t8 = t4+6.0/11.0*s*t5+3.0/55.0*t7;
      t10 = t*t;
      t11 = s+r-1.0;
      t13 = t11*t11;
      t14 = t10+6.0/5.0*t*t11+3.0/10.0*t13;
      t16 = t1*t1;
      t17 = t16-20.0/21.0*t2+2.0/7.0*t1-4.0/133.0*r+1.0/1197.0;
      t21 = t17*t8;
      t23 = t21*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (4.0*t2-20.0/7.0*t1+4.0/7.0*r-4.0/133.0)*t8*t14+t17*(6.0/11.0*s+
6.0/55.0*r-6.0/55.0)*t14+t23;
      drv[1] = t17*(2.0*s+6.0/11.0*r-6.0/11.0)*t14+t23;
      drv[2] = t21*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=12 4 3 1 */
   } else if( i==4 && j==3 && k==1 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t11 = t4*s+12.0/11.0*t4*t6+18.0/55.0*s*t8+4.0/165.0*t8*t6;
      t13 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t15 = t1*t1;
      t16 = t15-20.0/21.0*t2+2.0/7.0*t1-4.0/133.0*r+1.0/1197.0;
      t17 = s*t6;
      t21 = t16*t11;
      drv[0] = (4.0*t2-20.0/7.0*t1+4.0/7.0*r-4.0/133.0)*t11*t13+t16*(12.0/11.0*
t4+36.0/55.0*t17+4.0/55.0*t8)*t13+2.0/3.0*t21;
      drv[1] = t16*(3.0*t4+24.0/11.0*t17+18.0/55.0*t8)*t13+2.0/3.0*t21;
      drv[2] = t21;
   /* p=12 4 4 0 */
   } else if( i==4 && j==4 && k==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t5 = t4*t4;
      t6 = t4*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t11 = t9*t7;
      t13 = t9*t9;
      t16 = t1*t1;
      t17 = t16-20.0/21.0*t2+2.0/7.0*t1-4.0/133.0*r+1.0/1197.0;
      t18 = t4*t7;
      t19 = s*t9;
      drv[0] = (4.0*t2-20.0/7.0*t1+4.0/7.0*r-4.0/133.0)*(t5+20.0/11.0*t6*t7+
12.0/11.0*t4*t9+8.0/33.0*s*t11+t13/66)+t17*(20.0/11.0*t6+24.0/11.0*t18+8.0/11.0
*t19+2.0/33.0*t11);
      drv[1] = t17*(4.0*t6+60.0/11.0*t18+24.0/11.0*t19+8.0/33.0*t11);
      drv[2] = 0.0;
   /* p=12 5 0 3 */
   } else if( i==5 && j==0 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = t*t;
      t7 = s+r-1.0;
      t9 = t7*t7;
      t15 = t2*r-10.0/7.0*t2+5.0/7.0*t3-20.0/133.0*t1+5.0/399.0*r-2.0/6783.0;
      t16 = t*t7;
      t18 = t15*(12.0/7.0*t5+12.0/7.0*t16+12.0/35.0*t9);
      drv[0] = (5.0*t2-40.0/7.0*t3+15.0/7.0*t1-40.0/133.0*r+5.0/399.0)*(t5*t+
12.0/7.0*t5*t7+6.0/7.0*t*t9+4.0/35.0*t9*t7)+t18;
      drv[1] = t18;
      drv[2] = t15*(3.0*t5+24.0/7.0*t16+6.0/7.0*t9);
   /* p=12 5 1 2 */
   } else if( i==5 && j==1 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s+2.0/9.0*r-2.0/9.0;
      t7 = t*t;
      t8 = s+r-1.0;
      t10 = t8*t8;
      t11 = t7+6.0/5.0*t*t8+3.0/10.0*t10;
      t14 = t2*r-10.0/7.0*t2+5.0/7.0*t3-20.0/133.0*t1+5.0/399.0*r-2.0/6783.0;
      t15 = t14*t11;
      t16 = t14*t5;
      t18 = t16*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (5.0*t2-40.0/7.0*t3+15.0/7.0*t1-40.0/133.0*r+5.0/399.0)*t5*t11+
2.0/9.0*t15+t18;
      drv[1] = t15+t18;
      drv[2] = t16*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=12 5 2 1 */
   } else if( i==5 && j==2 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t9 = t5+2.0/3.0*s*t6+t8/12;
      t11 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t14 = t2*r-10.0/7.0*t2+5.0/7.0*t3-20.0/133.0*t1+5.0/399.0*r-2.0/6783.0;
      t18 = t14*t9;
      drv[0] = (5.0*t2-40.0/7.0*t3+15.0/7.0*t1-40.0/133.0*r+5.0/399.0)*t9*t11+
t14*(2.0/3.0*s+r/6-1.0/6.0)*t11+2.0/3.0*t18;
      drv[1] = t14*(2.0*s+2.0/3.0*r-2.0/3.0)*t11+2.0/3.0*t18;
      drv[2] = t18;
   /* p=12 5 3 0 */
   } else if( i==5 && j==3 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t15 = t2*r-10.0/7.0*t2+5.0/7.0*t3-20.0/133.0*t1+5.0/399.0*r-2.0/6783.0;
      t16 = s*t7;
      drv[0] = (5.0*t2-40.0/7.0*t3+15.0/7.0*t1-40.0/133.0*r+5.0/399.0)*(t5*s+
4.0/3.0*t5*t7+s*t9/2+t9*t7/21)+t15*(4.0/3.0*t5+t16+t9/7);
      drv[1] = t15*(3.0*t5+8.0/3.0*t16+t9/2);
      drv[2] = 0.0;
   /* p=12 6 0 2 */
   } else if( i==6 && j==0 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t6 = t*t;
      t7 = s+r-1.0;
      t9 = t7*t7;
      t13 = t2*t1-2.0*t3+3.0/2.0*t2-10.0/19.0*t4+5.0/57.0*t1-2.0/323.0*r+1.0/
7752.0;
      t15 = t13*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (6.0*t3-10.0*t2+6.0*t4-30.0/19.0*t1+10.0/57.0*r-2.0/323.0)*(t6+
6.0/5.0*t*t7+3.0/10.0*t9)+t15;
      drv[1] = t15;
      drv[2] = t13*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=12 6 1 1 */
   } else if( i==6 && j==1 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t6 = s+2.0/7.0*r-2.0/7.0;
      t8 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t11 = t2*t1-2.0*t3+3.0/2.0*t2-10.0/19.0*t4+5.0/57.0*t1-2.0/323.0*r+1.0/
7752.0;
      t12 = t11*t8;
      t13 = t11*t6;
      drv[0] = (6.0*t3-10.0*t2+6.0*t4-30.0/19.0*t1+10.0/57.0*r-2.0/323.0)*t6*t8
+2.0/7.0*t12+2.0/3.0*t13;
      drv[1] = t12+2.0/3.0*t13;
      drv[2] = t13;
   /* p=12 6 2 0 */
   } else if( i==6 && j==2 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t6 = s*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t13 = t2*t1-2.0*t3+3.0/2.0*t2-10.0/19.0*t4+5.0/57.0*t1-2.0/323.0*r+1.0/
7752.0;
      drv[0] = (6.0*t3-10.0*t2+6.0*t4-30.0/19.0*t1+10.0/57.0*r-2.0/323.0)*(t6+
6.0/7.0*s*t7+t9/7)+t13*(6.0/7.0*s+2.0/7.0*r-2.0/7.0);
      drv[1] = t13*(2.0*s+6.0/7.0*r-6.0/7.0);
      drv[2] = 0.0;
   /* p=12 7 0 1 */
   } else if( i==7 && j==0 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t2*r;
      t5 = t1*r;
      t9 = t2*t5;
      drv[0] = (7.0*t3-16.0*t4+14.0*t2-112.0/19.0*t5+70.0/57.0*t1-112.0/969.0*r
+7.0/1938.0)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0)+2.0/3.0*t9-16.0/9.0*t3+28.0/15.0*
t4-56.0/57.0*t2+140.0/513.0*t5-112.0/2907.0*t1+7.0/2907.0*r-2.0/43605.0;
      drv[1] = 2.0/3.0*t9-16.0/9.0*t3+28.0/15.0*t4-56.0/57.0*t2+140.0/513.0*t5
-112.0/2907.0*t1+7.0/2907.0*r-2.0/43605.0;
      drv[2] = t9-8.0/3.0*t3+14.0/5.0*t4-28.0/19.0*t2+70.0/171.0*t5-56.0/969.0*
t1+7.0/1938.0*r-1.0/14535.0;
   /* p=12 7 1 0 */
   } else if( i==7 && j==1 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t2*r;
      t5 = t1*r;
      t9 = t2*t5;
      drv[0] = (7.0*t3-16.0*t4+14.0*t2-112.0/19.0*t5+70.0/57.0*t1-112.0/969.0*r
+7.0/1938.0)*(s+2.0/5.0*r-2.0/5.0)+2.0/5.0*t9-16.0/15.0*t3+28.0/25.0*t4-56.0/
95.0*t2+28.0/171.0*t5-112.0/4845.0*t1+7.0/4845.0*r-2.0/72675.0;
      drv[1] = t9-8.0/3.0*t3+14.0/5.0*t4-28.0/19.0*t2+70.0/171.0*t5-56.0/969.0*
t1+7.0/1938.0*r-1.0/14535.0;
      drv[2] = 0.0;
   /* p=12 8 0 0 */
   } else if( i==8 && j==0 && k==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      drv[0] = 8.0*t3*t2-24.0*t3*t1+144.0/5.0*t3*r-336.0/19.0*t3+112.0/19.0*t2
-336.0/323.0*t1+28.0/323.0*r-4.0/1615.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
   /* p=13 0 0 9 */
   } else if( i==0 && j==0 && k==9 ) {
      t1 = t*t;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*t;
      t6 = s+r-1.0;
      t7 = t4*t2*t6;
      t9 = t6*t6;
      t10 = t2*t1*t9;
      t12 = t9*t6;
      t13 = t2*t*t12;
      t14 = t9*t9;
      t15 = t2*t14;
      t17 = t4*t14*t6;
      t19 = t1*t14*t9;
      t21 = t*t14*t12;
      t22 = t14*t14;
      t23 = 90.0/19.0*t3+360.0/19.0*t7+10080.0/323.0*t10+8820.0/323.0*t13+
4410.0/323.0*t15+1260.0/323.0*t17+2520.0/4199.0*t19+180.0/4199.0*t21+45.0/
46189.0*t22;
      drv[0] = t23;
      drv[1] = t23;
      drv[2] = 9.0*t3+720.0/19.0*t7+1260.0/19.0*t10+20160.0/323.0*t13+11025.0/
323.0*t15+3528.0/323.0*t17+630.0/323.0*t19+720.0/4199.0*t21+45.0/8398.0*t22;
   /* p=13 0 1 8 */
   } else if( i==0 && j==1 && k==8 ) {
      t1 = t*t;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*t;
      t5 = t4*t2;
      t6 = s+r-1.0;
      t7 = t5*t6;
      t8 = t2*t1;
      t9 = t6*t6;
      t10 = t8*t9;
      t11 = t2*t;
      t12 = t9*t6;
      t13 = t11*t12;
      t14 = t9*t9;
      t15 = t2*t14;
      t16 = t14*t6;
      t17 = t4*t16;
      t18 = t14*t9;
      t19 = t1*t18;
      t20 = t14*t12;
      t21 = t*t20;
      t22 = t14*t14;
      t23 = s+2.0/21.0*r-2.0/21.0;
      t24 = t8*t6;
      t25 = t11*t9;
      t26 = t2*t12;
      t27 = t4*t14;
      t28 = t1*t16;
      t29 = t*t18;
      t31 = t23*(72.0/17.0*t5+252.0/17.0*t24+1764.0/85.0*t25+252.0/17.0*t26+
1260.0/221.0*t27+252.0/221.0*t28+252.0/2431.0*t29+36.0/12155.0*t20);
      drv[0] = 2.0/21.0*t3+48.0/119.0*t7+12.0/17.0*t10+56.0/85.0*t13+6.0/17.0*
t15+24.0/221.0*t17+4.0/221.0*t19+24.0/17017.0*t21+3.0/85085.0*t22+t31;
      drv[1] = t3+72.0/17.0*t7+126.0/17.0*t10+588.0/85.0*t13+63.0/17.0*t15+
252.0/221.0*t17+42.0/221.0*t19+36.0/2431.0*t21+9.0/24310.0*t22+t31;
      drv[2] = t23*(8.0*t5+504.0/17.0*t24+756.0/17.0*t25+588.0/17.0*t26+252.0/
17.0*t27+756.0/221.0*t28+84.0/221.0*t29+36.0/2431.0*t20);
   /* p=13 0 2 7 */
   } else if( i==0 && j==2 && k==7 ) {
      t2 = t*t;
      t3 = t2*t;
      t4 = t2*t2;
      t6 = t4*t2;
      t7 = s+r-1.0;
      t9 = t4*t;
      t10 = t7*t7;
      t12 = t10*t7;
      t14 = t10*t10;
      t16 = t14*t7;
      t18 = t14*t10;
      t21 = t4*t3+56.0/15.0*t6*t7+28.0/5.0*t9*t10+56.0/13.0*t4*t12+70.0/39.0*t3
*t14+56.0/143.0*t2*t16+28.0/715.0*t*t18+8.0/6435.0*t14*t12;
      t23 = s*s;
      t24 = r-1.0;
      t26 = t24*t24;
      t27 = t23+2.0/7.0*s*t24+t26/70;
      t28 = t9*t7;
      t29 = t4*t10;
      t30 = t3*t12;
      t31 = t2*t14;
      t32 = t*t16;
      t34 = t27*(56.0/15.0*t6+56.0/5.0*t28+168.0/13.0*t29+280.0/39.0*t30+280.0/
143.0*t31+168.0/715.0*t32+56.0/6435.0*t18);
      drv[0] = (2.0/7.0*s+r/35-1.0/35.0)*t21+t34;
      drv[1] = (2.0*s+2.0/7.0*r-2.0/7.0)*t21+t34;
      drv[2] = t27*(7.0*t6+112.0/5.0*t28+28.0*t29+224.0/13.0*t30+70.0/13.0*t31+
112.0/143.0*t32+28.0/715.0*t18);
   /* p=13 0 3 6 */
   } else if( i==0 && j==3 && k==6 ) {
      t1 = s*s;
      t2 = r-1.0;
      t3 = s*t2;
      t4 = t2*t2;
      t6 = t*t;
      t7 = t6*t6;
      t9 = t7*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      t14 = t6*t;
      t15 = t12*t10;
      t17 = t12*t12;
      t19 = t17*t10;
      t22 = t7*t6+42.0/13.0*t9*t10+105.0/26.0*t7*t12+350.0/143.0*t14*t15+105.0/
143.0*t6*t17+14.0/143.0*t*t19+7.0/1716.0*t17*t12;
      t28 = t1*s+4.0/7.0*t1*t2+3.0/35.0*s*t4+2.0/665.0*t4*t2;
      t29 = t7*t10;
      t30 = t14*t12;
      t31 = t6*t15;
      t32 = t*t17;
      t34 = t28*(42.0/13.0*t9+105.0/13.0*t29+1050.0/143.0*t30+420.0/143.0*t31+
70.0/143.0*t32+7.0/286.0*t19);
      drv[0] = (4.0/7.0*t1+6.0/35.0*t3+6.0/665.0*t4)*t22+t34;
      drv[1] = (3.0*t1+8.0/7.0*t3+3.0/35.0*t4)*t22+t34;
      drv[2] = t28*(6.0*t9+210.0/13.0*t29+210.0/13.0*t30+1050.0/143.0*t31+210.0
/143.0*t32+14.0/143.0*t19);
   /* p=13 0 4 5 */
   } else if( i==0 && j==4 && k==5 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = r-1.0;
      t4 = t3*t1;
      t5 = t3*t3;
      t6 = s*t5;
      t7 = t5*t3;
      t9 = t*t;
      t10 = t9*t9;
      t12 = s+r-1.0;
      t14 = t9*t;
      t15 = t12*t12;
      t17 = t15*t12;
      t19 = t15*t15;
      t22 = t10*t+30.0/11.0*t12*t10+30.0/11.0*t14*t15+40.0/33.0*t9*t17+5.0/22.0
*t*t19+t19*t12/77;
      t24 = t1*t1;
      t28 = t5*t5;
      t29 = t24+20.0/21.0*t3*t2+2.0/7.0*t1*t5+4.0/133.0*s*t7+t28/1197;
      t30 = t14*t12;
      t31 = t9*t15;
      t32 = t*t17;
      t34 = t29*(30.0/11.0*t10+60.0/11.0*t30+40.0/11.0*t31+10.0/11.0*t32+5.0/
77.0*t19);
      drv[0] = (20.0/21.0*t2+4.0/7.0*t4+12.0/133.0*t6+4.0/1197.0*t7)*t22+t34;
      drv[1] = (4.0*t2+20.0/7.0*t4+4.0/7.0*t6+4.0/133.0*t7)*t22+t34;
      drv[2] = t29*(5.0*t10+120.0/11.0*t30+90.0/11.0*t31+80.0/33.0*t32+5.0/22.0
*t19);
   /* p=13 0 5 4 */
   } else if( i==0 && j==5 && k==4 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t1*s;
      t4 = r-1.0;
      t5 = t3*t4;
      t6 = t4*t4;
      t7 = t1*t6;
      t8 = t6*t4;
      t9 = s*t8;
      t10 = t6*t6;
      t12 = t*t;
      t13 = t12*t12;
      t14 = t12*t;
      t15 = s+r-1.0;
      t17 = t15*t15;
      t19 = t17*t15;
      t21 = t17*t17;
      t22 = t13+20.0/9.0*t14*t15+5.0/3.0*t17*t12+10.0/21.0*t*t19+5.0/126.0*t21;
      t30 = s*t2+10.0/7.0*t4*t2+5.0/7.0*t3*t6+20.0/133.0*t1*t8+5.0/399.0*s*t10+
2.0/6783.0*t10*t4;
      t31 = t15*t12;
      t32 = t*t17;
      t34 = t30*(20.0/9.0*t14+10.0/3.0*t31+10.0/7.0*t32+10.0/63.0*t19);
      drv[0] = (10.0/7.0*t2+10.0/7.0*t5+60.0/133.0*t7+20.0/399.0*t9+10.0/6783.0
*t10)*t22+t34;
      drv[1] = (5.0*t2+40.0/7.0*t5+15.0/7.0*t7+40.0/133.0*t9+5.0/399.0*t10)*t22
+t34;
      drv[2] = t30*(4.0*t14+20.0/3.0*t31+10.0/3.0*t32+10.0/21.0*t19);
   /* p=13 0 6 3 */
   } else if( i==0 && j==6 && k==3 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*s;
      t4 = r-1.0;
      t5 = t4*t2;
      t6 = t1*s;
      t7 = t4*t4;
      t8 = t6*t7;
      t9 = t7*t4;
      t10 = t1*t9;
      t11 = t7*t7;
      t12 = s*t11;
      t13 = t11*t4;
      t15 = t*t;
      t17 = s+r-1.0;
      t19 = t17*t17;
      t22 = t15*t+12.0/7.0*t15*t17+6.0/7.0*t*t19+4.0/35.0*t19*t17;
      t31 = t2*t1+2.0*t3*t4+3.0/2.0*t2*t7+10.0/19.0*t6*t9+5.0/57.0*t1*t11+2.0/
323.0*s*t13+t11*t7/7752;
      t32 = t*t17;
      t34 = t31*(12.0/7.0*t15+12.0/7.0*t32+12.0/35.0*t19);
      drv[0] = (2.0*t3+3.0*t5+30.0/19.0*t8+20.0/57.0*t10+10.0/323.0*t12+t13
/1292)*t22+t34;
      drv[1] = (6.0*t3+10.0*t5+6.0*t8+30.0/19.0*t10+10.0/57.0*t12+2.0/323.0*t13
)*t22+t34;
      drv[2] = t31*(3.0*t15+24.0/7.0*t32+6.0/7.0*t19);
   /* p=13 0 7 2 */
   } else if( i==0 && j==7 && k==2 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t2*s;
      t5 = r-1.0;
      t6 = t4*t5;
      t7 = t5*t5;
      t8 = t2*t7;
      t9 = t1*s;
      t10 = t7*t5;
      t11 = t9*t10;
      t12 = t7*t7;
      t13 = t1*t12;
      t14 = t12*t5;
      t15 = s*t14;
      t16 = t12*t7;
      t18 = t*t;
      t19 = s+r-1.0;
      t21 = t19*t19;
      t22 = t18+6.0/5.0*t*t19+3.0/10.0*t21;
      t32 = t2*t9+8.0/3.0*t3*t5+14.0/5.0*t7*t4+28.0/19.0*t2*t10+70.0/171.0*t9*
t12+56.0/969.0*t1*t14+7.0/1938.0*s*t16+t12*t10/14535;
      t34 = t32*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (8.0/3.0*t3+28.0/5.0*t6+84.0/19.0*t8+280.0/171.0*t11+280.0/969.0
*t13+7.0/323.0*t15+7.0/14535.0*t16)*t22+t34;
      drv[1] = (7.0*t3+16.0*t6+14.0*t8+112.0/19.0*t11+70.0/57.0*t13+112.0/969.0
*t15+7.0/1938.0*t16)*t22+t34;
      drv[2] = t32*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=13 0 8 1 */
   } else if( i==0 && j==8 && k==1 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t4 = t3*t2;
      t5 = t3*t1;
      t6 = r-1.0;
      t7 = t5*t6;
      t8 = t3*s;
      t9 = t6*t6;
      t10 = t8*t9;
      t11 = t6*t9;
      t12 = t3*t11;
      t13 = t9*t9;
      t14 = t2*t13;
      t15 = t13*t6;
      t16 = t1*t15;
      t17 = t13*t9;
      t18 = s*t17;
      t19 = t13*t11;
      t21 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t23 = t3*t3;
      t24 = t4*t6;
      t25 = t5*t9;
      t26 = t8*t11;
      t27 = t3*t13;
      t28 = t2*t15;
      t29 = t1*t17;
      t30 = s*t19;
      t31 = t13*t13;
      drv[0] = (24.0/7.0*t4+48.0/5.0*t7+1008.0/95.0*t10+112.0/19.0*t12+560.0/
323.0*t14+84.0/323.0*t16+28.0/1615.0*t18+4.0/11305.0*t19)*t21+2.0/3.0*t23+16.0/
7.0*t24+16.0/5.0*t25+224.0/95.0*t26+56.0/57.0*t27+224.0/969.0*t28+28.0/969.0*
t29+8.0/4845.0*t30+t31/33915;
      drv[1] = (8.0*t4+24.0*t7+144.0/5.0*t10+336.0/19.0*t12+112.0/19.0*t14+
336.0/323.0*t16+28.0/323.0*t18+4.0/1615.0*t19)*t21+2.0/3.0*t23+16.0/7.0*t24+
16.0/5.0*t25+224.0/95.0*t26+56.0/57.0*t27+224.0/969.0*t28+28.0/969.0*t29+8.0/
4845.0*t30+t31/33915;
      drv[2] = t23+24.0/7.0*t24+24.0/5.0*t25+336.0/95.0*t26+28.0/19.0*t27+112.0
/323.0*t28+14.0/323.0*t29+4.0/1615.0*t30+t31/22610;
   /* p=13 0 9 0 */
   } else if( i==0 && j==9 && k==0 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*s;
      t6 = r-1.0;
      t7 = t4*t2*t6;
      t9 = t6*t6;
      t10 = t2*t1*t9;
      t12 = t6*t9;
      t13 = t2*s*t12;
      t14 = t9*t9;
      t15 = t2*t14;
      t17 = t4*t14*t6;
      t19 = t1*t14*t9;
      t21 = s*t14*t12;
      t22 = t14*t14;
      drv[0] = 30.0/7.0*t3+108.0/7.0*t7+432.0/19.0*t10+336.0/19.0*t13+2520.0/
323.0*t15+630.0/323.0*t17+84.0/323.0*t19+36.0/2261.0*t21+9.0/29393.0*t22;
      drv[1] = 9.0*t3+240.0/7.0*t7+54.0*t10+864.0/19.0*t13+420.0/19.0*t15+
2016.0/323.0*t17+315.0/323.0*t19+24.0/323.0*t21+9.0/4522.0*t22;
      drv[2] = 0.0;
   /* p=13 1 0 8 */
   } else if( i==1 && j==0 && k==8 ) {
      t1 = t*t;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*t;
      t5 = t4*t2;
      t6 = s+r-1.0;
      t8 = t2*t1;
      t9 = t6*t6;
      t11 = t2*t;
      t12 = t6*t9;
      t14 = t9*t9;
      t16 = t14*t6;
      t18 = t14*t9;
      t20 = t14*t12;
      t22 = t14*t14;
      t23 = r-2.0/23.0;
      t24 = t8*t6;
      t25 = t11*t9;
      t26 = t2*t12;
      t27 = t4*t14;
      t28 = t1*t16;
      t29 = t*t18;
      t31 = t23*(72.0/17.0*t5+252.0/17.0*t24+1764.0/85.0*t25+252.0/17.0*t26+
1260.0/221.0*t27+252.0/221.0*t28+252.0/2431.0*t29+36.0/12155.0*t20);
      drv[0] = t3+72.0/17.0*t5*t6+126.0/17.0*t8*t9+588.0/85.0*t11*t12+63.0/17.0
*t2*t14+252.0/221.0*t4*t16+42.0/221.0*t1*t18+36.0/2431.0*t*t20+9.0/24310.0*t22+
t31;
      drv[1] = t31;
      drv[2] = t23*(8.0*t5+504.0/17.0*t24+756.0/17.0*t25+588.0/17.0*t26+252.0/
17.0*t27+756.0/221.0*t28+84.0/221.0*t29+36.0/2431.0*t20);
   /* p=13 1 1 7 */
   } else if( i==1 && j==1 && k==7 ) {
      t1 = s+2.0/19.0*r-2.0/19.0;
      t2 = t*t;
      t3 = t2*t;
      t4 = t2*t2;
      t6 = t4*t2;
      t7 = s+r-1.0;
      t9 = t4*t;
      t10 = t7*t7;
      t12 = t10*t7;
      t14 = t10*t10;
      t16 = t14*t7;
      t18 = t14*t10;
      t21 = t4*t3+56.0/15.0*t6*t7+28.0/5.0*t9*t10+56.0/13.0*t4*t12+70.0/39.0*t3
*t14+56.0/143.0*t2*t16+28.0/715.0*t*t18+8.0/6435.0*t14*t12;
      t23 = r-2.0/23.0;
      t24 = t23*t21;
      t25 = t23*t1;
      t26 = t9*t7;
      t27 = t4*t10;
      t28 = t3*t12;
      t29 = t2*t14;
      t30 = t*t16;
      t32 = t25*(56.0/15.0*t6+56.0/5.0*t26+168.0/13.0*t27+280.0/39.0*t28+280.0/
143.0*t29+168.0/715.0*t30+56.0/6435.0*t18);
      drv[0] = t1*t21+2.0/19.0*t24+t32;
      drv[1] = t24+t32;
      drv[2] = t25*(7.0*t6+112.0/5.0*t26+28.0*t27+224.0/13.0*t28+70.0/13.0*t29+
112.0/143.0*t30+28.0/715.0*t18);
   /* p=13 1 2 6 */
   } else if( i==1 && j==2 && k==6 ) {
      t1 = s*s;
      t2 = r-1.0;
      t4 = t2*t2;
      t5 = t1+6.0/19.0*s*t2+t4/57;
      t6 = t*t;
      t7 = t6*t6;
      t9 = t7*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      t14 = t6*t;
      t15 = t12*t10;
      t17 = t12*t12;
      t19 = t17*t10;
      t22 = t7*t6+42.0/13.0*t9*t10+105.0/26.0*t7*t12+350.0/143.0*t14*t15+105.0/
143.0*t6*t17+14.0/143.0*t*t19+7.0/1716.0*t17*t12;
      t24 = r-2.0/23.0;
      t28 = t24*t5;
      t29 = t7*t10;
      t30 = t14*t12;
      t31 = t6*t15;
      t32 = t*t17;
      t34 = t28*(42.0/13.0*t9+105.0/13.0*t29+1050.0/143.0*t30+420.0/143.0*t31+
70.0/143.0*t32+7.0/286.0*t19);
      drv[0] = t5*t22+t24*(6.0/19.0*s+2.0/57.0*r-2.0/57.0)*t22+t34;
      drv[1] = t24*(2.0*s+6.0/19.0*r-6.0/19.0)*t22+t34;
      drv[2] = t28*(6.0*t9+210.0/13.0*t29+210.0/13.0*t30+1050.0/143.0*t31+210.0
/143.0*t32+14.0/143.0*t19);
   /* p=13 1 3 5 */
   } else if( i==1 && j==3 && k==5 ) {
      t1 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t8 = t1*s+12.0/19.0*t3*t1+2.0/19.0*s*t5+4.0/969.0*t5*t3;
      t9 = t*t;
      t10 = t9*t9;
      t12 = s+r-1.0;
      t14 = t9*t;
      t15 = t12*t12;
      t17 = t15*t12;
      t19 = t15*t15;
      t22 = t10*t+30.0/11.0*t12*t10+30.0/11.0*t14*t15+40.0/33.0*t9*t17+5.0/22.0
*t*t19+t19*t12/77;
      t24 = r-2.0/23.0;
      t25 = s*t3;
      t29 = t24*t8;
      t30 = t14*t12;
      t31 = t9*t15;
      t32 = t*t17;
      t34 = t29*(30.0/11.0*t10+60.0/11.0*t30+40.0/11.0*t31+10.0/11.0*t32+5.0/
77.0*t19);
      drv[0] = t8*t22+t24*(12.0/19.0*t1+4.0/19.0*t25+4.0/323.0*t5)*t22+t34;
      drv[1] = t24*(3.0*t1+24.0/19.0*t25+2.0/19.0*t5)*t22+t34;
      drv[2] = t29*(5.0*t10+120.0/11.0*t30+90.0/11.0*t31+80.0/33.0*t32+5.0/22.0
*t19);
   /* p=13 1 4 4 */
   } else if( i==1 && j==4 && k==4 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t1*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t8 = t6*t4;
      t10 = t6*t6;
      t11 = t2+20.0/19.0*t3*t4+20.0/57.0*t1*t6+40.0/969.0*s*t8+5.0/3876.0*t10;
      t12 = t*t;
      t13 = t12*t12;
      t14 = t12*t;
      t15 = s+r-1.0;
      t17 = t15*t15;
      t19 = t17*t15;
      t21 = t17*t17;
      t22 = t13+20.0/9.0*t14*t15+5.0/3.0*t17*t12+10.0/21.0*t*t19+5.0/126.0*t21;
      t24 = r-2.0/23.0;
      t25 = t4*t1;
      t26 = s*t6;
      t30 = t24*t11;
      t31 = t15*t12;
      t32 = t*t17;
      t34 = t30*(20.0/9.0*t14+10.0/3.0*t31+10.0/7.0*t32+10.0/63.0*t19);
      drv[0] = t11*t22+t24*(20.0/19.0*t3+40.0/57.0*t25+40.0/323.0*t26+5.0/969.0
*t8)*t22+t34;
      drv[1] = t24*(4.0*t3+60.0/19.0*t25+40.0/57.0*t26+40.0/969.0*t8)*t22+t34;
      drv[2] = t30*(4.0*t14+20.0/3.0*t31+10.0/3.0*t32+10.0/21.0*t19);
   /* p=13 1 5 3 */
   } else if( i==1 && j==5 && k==3 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t6 = t1*s;
      t7 = t4*t4;
      t9 = t7*t4;
      t11 = t7*t7;
      t14 = t2*s+30.0/19.0*t4*t2+50.0/57.0*t6*t7+200.0/969.0*t1*t9+25.0/1292.0*
s*t11+t11*t4/1938;
      t15 = t*t;
      t17 = s+r-1.0;
      t19 = t17*t17;
      t22 = t15*t+12.0/7.0*t17*t15+6.0/7.0*t*t19+4.0/35.0*t19*t17;
      t24 = r-2.0/23.0;
      t25 = t6*t4;
      t26 = t1*t7;
      t27 = s*t9;
      t31 = t24*t14;
      t32 = t*t17;
      t34 = t31*(12.0/7.0*t15+12.0/7.0*t32+12.0/35.0*t19);
      drv[0] = t14*t22+t24*(30.0/19.0*t2+100.0/57.0*t25+200.0/323.0*t26+25.0/
323.0*t27+5.0/1938.0*t11)*t22+t34;
      drv[1] = t24*(5.0*t2+120.0/19.0*t25+50.0/19.0*t26+400.0/969.0*t27+25.0/
1292.0*t11)*t22+t34;
      drv[2] = t31*(3.0*t15+24.0/7.0*t32+6.0/7.0*t19);
   /* p=13 1 6 2 */
   } else if( i==1 && j==6 && k==2 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = t2*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t9 = t1*s;
      t10 = t7*t5;
      t12 = t7*t7;
      t14 = t12*t5;
      t17 = t2*t1+42.0/19.0*t4*t5+35.0/19.0*t2*t7+700.0/969.0*t9*t10+175.0/
1292.0*t1*t12+7.0/646.0*s*t14+t12*t7/3876;
      t18 = t*t;
      t19 = s+r-1.0;
      t21 = t19*t19;
      t22 = t18+6.0/5.0*t*t19+3.0/10.0*t21;
      t24 = r-2.0/23.0;
      t25 = t2*t5;
      t26 = t9*t7;
      t27 = t1*t10;
      t28 = s*t12;
      t32 = t24*t17;
      t34 = t32*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = t17*t22+t24*(42.0/19.0*t4+70.0/19.0*t25+700.0/323.0*t26+175.0/
323.0*t27+35.0/646.0*t28+t14/646)*t22+t34;
      drv[1] = t24*(6.0*t4+210.0/19.0*t25+140.0/19.0*t26+700.0/323.0*t27+175.0/
646.0*t28+7.0/646.0*t14)*t22+t34;
      drv[2] = t32*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=13 1 7 1 */
   } else if( i==1 && j==7 && k==1 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t5 = t3*t1;
      t6 = r-1.0;
      t8 = t3*s;
      t9 = t6*t6;
      t11 = t9*t6;
      t13 = t9*t9;
      t15 = t13*t6;
      t17 = t13*t9;
      t20 = t3*t2+56.0/19.0*t5*t6+196.0/57.0*t8*t9+1960.0/969.0*t3*t11+1225.0/
1938.0*t2*t13+98.0/969.0*t1*t15+7.0/969.0*s*t17+2.0/12597.0*t13*t11;
      t21 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t23 = r-2.0/23.0;
      t24 = t8*t6;
      t25 = t3*t9;
      t26 = t2*t11;
      t27 = t1*t13;
      t28 = s*t15;
      t32 = t23*t20;
      drv[0] = t20*t21+t23*(56.0/19.0*t5+392.0/57.0*t24+1960.0/323.0*t25+2450.0
/969.0*t26+490.0/969.0*t27+14.0/323.0*t28+14.0/12597.0*t17)*t21+2.0/3.0*t32;
      drv[1] = t23*(7.0*t5+336.0/19.0*t24+980.0/57.0*t25+7840.0/969.0*t26+
1225.0/646.0*t27+196.0/969.0*t28+7.0/969.0*t17)*t21+2.0/3.0*t32;
      drv[2] = t32;
   /* p=13 1 8 0 */
   } else if( i==1 && j==8 && k==0 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*s;
      t5 = t4*t2;
      t6 = r-1.0;
      t8 = t2*t1;
      t9 = t6*t6;
      t11 = t2*s;
      t12 = t9*t6;
      t14 = t9*t9;
      t16 = t14*t6;
      t18 = t14*t9;
      t20 = t14*t12;
      t22 = t14*t14;
      t23 = r-2.0/23.0;
      t24 = t8*t6;
      t25 = t11*t9;
      t26 = t2*t12;
      t27 = t4*t14;
      t28 = t1*t16;
      t29 = s*t18;
      drv[0] = t3+72.0/19.0*t5*t6+112.0/19.0*t8*t9+1568.0/323.0*t11*t12+735.0/
323.0*t2*t14+196.0/323.0*t4*t16+28.0/323.0*t1*t18+24.0/4199.0*s*t20+t22/8398+
t23*(72.0/19.0*t5+224.0/19.0*t24+4704.0/323.0*t25+2940.0/323.0*t26+980.0/323.0*
t27+168.0/323.0*t28+168.0/4199.0*t29+4.0/4199.0*t20);
      drv[1] = t23*(8.0*t5+504.0/19.0*t24+672.0/19.0*t25+7840.0/323.0*t26+
2940.0/323.0*t27+588.0/323.0*t28+56.0/323.0*t29+24.0/4199.0*t20);
      drv[2] = 0.0;
   /* p=13 2 0 7 */
   } else if( i==2 && j==0 && k==7 ) {
      t2 = t*t;
      t3 = t2*t;
      t4 = t2*t2;
      t6 = t4*t2;
      t7 = s+r-1.0;
      t9 = t4*t;
      t10 = t7*t7;
      t12 = t10*t7;
      t14 = t10*t10;
      t16 = t14*t7;
      t18 = t14*t10;
      t23 = r*r;
      t24 = t23-6.0/23.0*r+3.0/253.0;
      t25 = t9*t7;
      t26 = t4*t10;
      t27 = t3*t12;
      t28 = t2*t14;
      t29 = t*t16;
      t31 = t24*(56.0/15.0*t6+56.0/5.0*t25+168.0/13.0*t26+280.0/39.0*t27+280.0/
143.0*t28+168.0/715.0*t29+56.0/6435.0*t18);
      drv[0] = (2.0*r-6.0/23.0)*(t4*t3+56.0/15.0*t6*t7+28.0/5.0*t9*t10+56.0/
13.0*t4*t12+70.0/39.0*t3*t14+56.0/143.0*t2*t16+28.0/715.0*t*t18+8.0/6435.0*t14*
t12)+t31;
      drv[1] = t31;
      drv[2] = t24*(7.0*t6+112.0/5.0*t25+28.0*t26+224.0/13.0*t27+70.0/13.0*t28+
112.0/143.0*t29+28.0/715.0*t18);
   /* p=13 2 1 6 */
   } else if( i==2 && j==1 && k==6 ) {
      t2 = s+2.0/17.0*r-2.0/17.0;
      t4 = t*t;
      t5 = t4*t4;
      t7 = t5*t;
      t8 = s+r-1.0;
      t10 = t8*t8;
      t12 = t4*t;
      t13 = t10*t8;
      t15 = t10*t10;
      t17 = t15*t8;
      t20 = t5*t4+42.0/13.0*t7*t8+105.0/26.0*t5*t10+350.0/143.0*t12*t13+105.0/
143.0*t4*t15+14.0/143.0*t*t17+7.0/1716.0*t15*t10;
      t22 = r*r;
      t23 = t22-6.0/23.0*r+3.0/253.0;
      t24 = t23*t20;
      t25 = t23*t2;
      t26 = t5*t8;
      t27 = t12*t10;
      t28 = t4*t13;
      t29 = t*t15;
      t31 = t25*(42.0/13.0*t7+105.0/13.0*t26+1050.0/143.0*t27+420.0/143.0*t28+
70.0/143.0*t29+7.0/286.0*t17);
      drv[0] = t2*(2.0*r-6.0/23.0)*t20+2.0/17.0*t24+t31;
      drv[1] = t24+t31;
      drv[2] = t25*(6.0*t7+210.0/13.0*t26+210.0/13.0*t27+1050.0/143.0*t28+210.0
/143.0*t29+14.0/143.0*t17);
   /* p=13 2 2 5 */
   } else if( i==2 && j==2 && k==5 ) {
      t2 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t6 = t2+6.0/17.0*s*t3+3.0/136.0*t5;
      t8 = t*t;
      t9 = t8*t8;
      t11 = s+r-1.0;
      t13 = t8*t;
      t14 = t11*t11;
      t16 = t14*t11;
      t18 = t14*t14;
      t21 = t9*t+30.0/11.0*t9*t11+30.0/11.0*t13*t14+40.0/33.0*t8*t16+5.0/22.0*t
*t18+t18*t11/77;
      t23 = r*r;
      t24 = t23-6.0/23.0*r+3.0/253.0;
      t28 = t24*t6;
      t29 = t13*t11;
      t30 = t8*t14;
      t31 = t*t16;
      t33 = t28*(30.0/11.0*t9+60.0/11.0*t29+40.0/11.0*t30+10.0/11.0*t31+5.0/
77.0*t18);
      drv[0] = (2.0*r-6.0/23.0)*t6*t21+t24*(6.0/17.0*s+3.0/68.0*r-3.0/68.0)*t21
+t33;
      drv[1] = t24*(2.0*s+6.0/17.0*r-6.0/17.0)*t21+t33;
      drv[2] = t28*(5.0*t9+120.0/11.0*t29+90.0/11.0*t30+80.0/33.0*t31+5.0/22.0*
t18);
   /* p=13 2 3 4 */
   } else if( i==2 && j==3 && k==4 ) {
      t2 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t9 = t2*s+12.0/17.0*t4*t2+9.0/68.0*s*t6+t6*t4/170;
      t11 = t*t;
      t12 = t11*t11;
      t13 = t11*t;
      t14 = s+r-1.0;
      t16 = t14*t14;
      t18 = t16*t14;
      t20 = t16*t16;
      t21 = t12+20.0/9.0*t13*t14+5.0/3.0*t11*t16+10.0/21.0*t*t18+5.0/126.0*t20;
      t23 = r*r;
      t24 = t23-6.0/23.0*r+3.0/253.0;
      t25 = s*t4;
      t29 = t24*t9;
      t30 = t14*t11;
      t31 = t*t16;
      t33 = t29*(20.0/9.0*t13+10.0/3.0*t30+10.0/7.0*t31+10.0/63.0*t18);
      drv[0] = (2.0*r-6.0/23.0)*t9*t21+t24*(12.0/17.0*t2+9.0/34.0*t25+3.0/170.0
*t6)*t21+t33;
      drv[1] = t24*(3.0*t2+24.0/17.0*t25+9.0/68.0*t6)*t21+t33;
      drv[2] = t29*(4.0*t13+20.0/3.0*t30+10.0/3.0*t31+10.0/21.0*t18);
   /* p=13 2 4 3 */
   } else if( i==2 && j==4 && k==3 ) {
      t2 = s*s;
      t3 = t2*t2;
      t4 = t2*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t9 = t7*t5;
      t11 = t7*t7;
      t12 = t3+20.0/17.0*t5*t4+15.0/34.0*t2*t7+s*t9/17+t11/476;
      t14 = t*t;
      t16 = s+r-1.0;
      t18 = t16*t16;
      t21 = t14*t+12.0/7.0*t16*t14+6.0/7.0*t*t18+4.0/35.0*t18*t16;
      t23 = r*r;
      t24 = t23-6.0/23.0*r+3.0/253.0;
      t25 = t2*t5;
      t26 = s*t7;
      t30 = t24*t12;
      t31 = t*t16;
      t33 = t30*(12.0/7.0*t14+12.0/7.0*t31+12.0/35.0*t18);
      drv[0] = (2.0*r-6.0/23.0)*t12*t21+t24*(20.0/17.0*t4+15.0/17.0*t25+3.0/
17.0*t26+t9/119)*t21+t33;
      drv[1] = t24*(4.0*t4+60.0/17.0*t25+15.0/17.0*t26+t9/17)*t21+t33;
      drv[2] = t30*(3.0*t14+24.0/7.0*t31+6.0/7.0*t18);
   /* p=13 2 5 2 */
   } else if( i==2 && j==5 && k==2 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = r-1.0;
      t7 = t2*s;
      t8 = t5*t5;
      t10 = t8*t5;
      t12 = t8*t8;
      t15 = t3*s+30.0/17.0*t3*t5+75.0/68.0*t7*t8+5.0/17.0*t2*t10+15.0/476.0*s*
t12+3.0/3094.0*t12*t5;
      t17 = t*t;
      t18 = s+r-1.0;
      t20 = t18*t18;
      t21 = t17+6.0/5.0*t*t18+3.0/10.0*t20;
      t23 = r*r;
      t24 = t23-6.0/23.0*r+3.0/253.0;
      t25 = t7*t5;
      t26 = t2*t8;
      t27 = s*t10;
      t31 = t24*t15;
      t33 = t31*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (2.0*r-6.0/23.0)*t15*t21+t24*(30.0/17.0*t3+75.0/34.0*t25+15.0/
17.0*t26+15.0/119.0*t27+15.0/3094.0*t12)*t21+t33;
      drv[1] = t24*(5.0*t3+120.0/17.0*t25+225.0/68.0*t26+10.0/17.0*t27+15.0/
476.0*t12)*t21+t33;
      drv[2] = t31*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=13 2 6 1 */
   } else if( i==2 && j==6 && k==1 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = t3*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t10 = t2*s;
      t11 = t8*t6;
      t13 = t8*t8;
      t15 = t13*t6;
      t18 = t3*t2+42.0/17.0*t5*t6+315.0/136.0*t3*t8+35.0/34.0*t10*t11+15.0/68.0
*t2*t13+9.0/442.0*s*t15+t13*t8/1768;
      t20 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t22 = r*r;
      t23 = t22-6.0/23.0*r+3.0/253.0;
      t24 = t3*t6;
      t25 = t10*t8;
      t26 = t2*t11;
      t27 = s*t13;
      t31 = t23*t18;
      drv[0] = (2.0*r-6.0/23.0)*t18*t20+t23*(42.0/17.0*t5+315.0/68.0*t24+105.0/
34.0*t25+15.0/17.0*t26+45.0/442.0*t27+3.0/884.0*t15)*t20+2.0/3.0*t31;
      drv[1] = t23*(6.0*t5+210.0/17.0*t24+315.0/34.0*t25+105.0/34.0*t26+15.0/
34.0*t27+9.0/442.0*t15)*t20+2.0/3.0*t31;
      drv[2] = t31;
   /* p=13 2 7 0 */
   } else if( i==2 && j==7 && k==0 ) {
      t2 = s*s;
      t3 = t2*s;
      t4 = t2*t2;
      t6 = t4*t2;
      t7 = r-1.0;
      t9 = t4*s;
      t10 = t7*t7;
      t12 = t10*t7;
      t14 = t10*t10;
      t16 = t14*t7;
      t18 = t14*t10;
      t23 = r*r;
      t24 = t23-6.0/23.0*r+3.0/253.0;
      t25 = t9*t7;
      t26 = t4*t10;
      t27 = t3*t12;
      t28 = t2*t14;
      t29 = s*t16;
      drv[0] = (2.0*r-6.0/23.0)*(t4*t3+56.0/17.0*t6*t7+147.0/34.0*t9*t10+49.0/
17.0*t4*t12+35.0/34.0*t3*t14+42.0/221.0*t2*t16+7.0/442.0*s*t18+t14*t12/2431)+
t24*(56.0/17.0*t6+147.0/17.0*t25+147.0/17.0*t26+70.0/17.0*t27+210.0/221.0*t28+
21.0/221.0*t29+7.0/2431.0*t18);
      drv[1] = t24*(7.0*t6+336.0/17.0*t25+735.0/34.0*t26+196.0/17.0*t27+105.0/
34.0*t28+84.0/221.0*t29+7.0/442.0*t18);
      drv[2] = 0.0;
   /* p=13 3 0 6 */
   } else if( i==3 && j==0 && k==6 ) {
      t1 = r*r;
      t3 = t*t;
      t4 = t3*t3;
      t6 = t4*t;
      t7 = s+r-1.0;
      t9 = t7*t7;
      t11 = t3*t;
      t12 = t9*t7;
      t14 = t9*t9;
      t16 = t14*t7;
      t22 = t1*r-12.0/23.0*t1+18.0/253.0*r-4.0/1771.0;
      t23 = t4*t7;
      t24 = t11*t9;
      t25 = t3*t12;
      t26 = t*t14;
      t28 = t22*(42.0/13.0*t6+105.0/13.0*t23+1050.0/143.0*t24+420.0/143.0*t25+
70.0/143.0*t26+7.0/286.0*t16);
      drv[0] = (3.0*t1-24.0/23.0*r+18.0/253.0)*(t4*t3+42.0/13.0*t6*t7+105.0/
26.0*t4*t9+350.0/143.0*t11*t12+105.0/143.0*t3*t14+14.0/143.0*t*t16+7.0/1716.0*
t14*t9)+t28;
      drv[1] = t28;
      drv[2] = t22*(6.0*t6+210.0/13.0*t23+210.0/13.0*t24+1050.0/143.0*t25+210.0
/143.0*t26+14.0/143.0*t16);
   /* p=13 3 1 5 */
   } else if( i==3 && j==1 && k==5 ) {
      t1 = r*r;
      t3 = s+2.0/15.0*r-2.0/15.0;
      t5 = t*t;
      t6 = t5*t5;
      t8 = s+r-1.0;
      t10 = t5*t;
      t11 = t8*t8;
      t13 = t11*t8;
      t15 = t11*t11;
      t18 = t6*t+30.0/11.0*t6*t8+30.0/11.0*t10*t11+40.0/33.0*t5*t13+5.0/22.0*t*
t15+t15*t8/77;
      t21 = t1*r-12.0/23.0*t1+18.0/253.0*r-4.0/1771.0;
      t22 = t21*t18;
      t23 = t21*t3;
      t24 = t10*t8;
      t25 = t5*t11;
      t26 = t*t13;
      t28 = t23*(30.0/11.0*t6+60.0/11.0*t24+40.0/11.0*t25+10.0/11.0*t26+5.0/
77.0*t15);
      drv[0] = t3*(3.0*t1-24.0/23.0*r+18.0/253.0)*t18+2.0/15.0*t22+t28;
      drv[1] = t22+t28;
      drv[2] = t23*(5.0*t6+120.0/11.0*t24+90.0/11.0*t25+80.0/33.0*t26+5.0/22.0*
t15);
   /* p=13 3 2 4 */
   } else if( i==3 && j==2 && k==4 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t7 = t3+2.0/5.0*s*t4+t6/35;
      t9 = t*t;
      t10 = t9*t9;
      t11 = t9*t;
      t12 = s+r-1.0;
      t14 = t12*t12;
      t16 = t14*t12;
      t18 = t14*t14;
      t19 = t10+20.0/9.0*t11*t12+5.0/3.0*t14*t9+10.0/21.0*t*t16+5.0/126.0*t18;
      t22 = t1*r-12.0/23.0*t1+18.0/253.0*r-4.0/1771.0;
      t26 = t22*t7;
      t27 = t9*t12;
      t28 = t*t14;
      t30 = t26*(20.0/9.0*t11+10.0/3.0*t27+10.0/7.0*t28+10.0/63.0*t16);
      drv[0] = (3.0*t1-24.0/23.0*r+18.0/253.0)*t7*t19+t22*(2.0/5.0*s+2.0/35.0*r
-2.0/35.0)*t19+t30;
      drv[1] = t22*(2.0*s+2.0/5.0*r-2.0/5.0)*t19+t30;
      drv[2] = t26*(4.0*t11+20.0/3.0*t27+10.0/3.0*t28+10.0/21.0*t16);
   /* p=13 3 3 3 */
   } else if( i==3 && j==3 && k==3 ) {
      t1 = r*r;
      t3 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t10 = t3*s+4.0/5.0*t3*t5+6.0/35.0*s*t7+4.0/455.0*t7*t5;
      t12 = t*t;
      t14 = s+r-1.0;
      t16 = t14*t14;
      t19 = t12*t+12.0/7.0*t12*t14+6.0/7.0*t*t16+4.0/35.0*t16*t14;
      t22 = t1*r-12.0/23.0*t1+18.0/253.0*r-4.0/1771.0;
      t23 = s*t5;
      t27 = t22*t10;
      t28 = t*t14;
      t30 = t27*(12.0/7.0*t12+12.0/7.0*t28+12.0/35.0*t16);
      drv[0] = (3.0*t1-24.0/23.0*r+18.0/253.0)*t10*t19+t22*(4.0/5.0*t3+12.0/
35.0*t23+12.0/455.0*t7)*t19+t30;
      drv[1] = t22*(3.0*t3+8.0/5.0*t23+6.0/35.0*t7)*t19+t30;
      drv[2] = t27*(3.0*t12+24.0/7.0*t28+6.0/7.0*t16);
   /* p=13 3 4 2 */
   } else if( i==3 && j==4 && k==2 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t5 = t3*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t10 = t8*t6;
      t12 = t8*t8;
      t13 = t4+4.0/3.0*t5*t6+4.0/7.0*t3*t8+8.0/91.0*s*t10+t12/273;
      t15 = t*t;
      t16 = s+r-1.0;
      t18 = t16*t16;
      t19 = t15+6.0/5.0*t*t16+3.0/10.0*t18;
      t22 = t1*r-12.0/23.0*t1+18.0/253.0*r-4.0/1771.0;
      t23 = t3*t6;
      t24 = s*t8;
      t28 = t22*t13;
      t30 = t28*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (3.0*t1-24.0/23.0*r+18.0/253.0)*t13*t19+t22*(4.0/3.0*t5+8.0/7.0*
t23+24.0/91.0*t24+4.0/273.0*t10)*t19+t30;
      drv[1] = t22*(4.0*t5+4.0*t23+8.0/7.0*t24+8.0/91.0*t10)*t19+t30;
      drv[2] = t28*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=13 3 5 1 */
   } else if( i==3 && j==5 && k==1 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t6 = r-1.0;
      t8 = t3*s;
      t9 = t6*t6;
      t11 = t9*t6;
      t13 = t9*t9;
      t16 = t4*s+2.0*t4*t6+10.0/7.0*t8*t9+40.0/91.0*t3*t11+5.0/91.0*s*t13+2.0/
1001.0*t13*t6;
      t18 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t21 = t1*r-12.0/23.0*t1+18.0/253.0*r-4.0/1771.0;
      t22 = t8*t6;
      t23 = t3*t9;
      t24 = s*t11;
      t28 = t21*t16;
      drv[0] = (3.0*t1-24.0/23.0*r+18.0/253.0)*t16*t18+t21*(2.0*t4+20.0/7.0*t22
+120.0/91.0*t23+20.0/91.0*t24+10.0/1001.0*t13)*t18+2.0/3.0*t28;
      drv[1] = t21*(5.0*t4+8.0*t22+30.0/7.0*t23+80.0/91.0*t24+5.0/91.0*t13)*t18
+2.0/3.0*t28;
      drv[2] = t28;
   /* p=13 3 6 0 */
   } else if( i==3 && j==6 && k==0 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t6 = t4*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t11 = t3*s;
      t12 = t9*t7;
      t14 = t9*t9;
      t16 = t14*t7;
      t22 = t1*r-12.0/23.0*t1+18.0/253.0*r-4.0/1771.0;
      t23 = t4*t7;
      t24 = t11*t9;
      t25 = t3*t12;
      t26 = s*t14;
      drv[0] = (3.0*t1-24.0/23.0*r+18.0/253.0)*(t4*t3+14.0/5.0*t6*t7+3.0*t4*t9+
20.0/13.0*t11*t12+5.0/13.0*t3*t14+6.0/143.0*s*t16+t14*t9/715)+t22*(14.0/5.0*t6+
6.0*t23+60.0/13.0*t24+20.0/13.0*t25+30.0/143.0*t26+6.0/715.0*t16);
      drv[1] = t22*(6.0*t6+14.0*t23+12.0*t24+60.0/13.0*t25+10.0/13.0*t26+6.0/
143.0*t16);
      drv[2] = 0.0;
   /* p=13 4 0 5 */
   } else if( i==4 && j==0 && k==5 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = t*t;
      t5 = t4*t4;
      t7 = s+r-1.0;
      t9 = t4*t;
      t10 = t7*t7;
      t12 = t10*t7;
      t14 = t10*t10;
      t19 = t1*t1;
      t20 = t19-20.0/23.0*t2+60.0/253.0*t1-40.0/1771.0*r+1.0/1771.0;
      t21 = t9*t7;
      t22 = t4*t10;
      t23 = t*t12;
      t25 = t20*(30.0/11.0*t5+60.0/11.0*t21+40.0/11.0*t22+10.0/11.0*t23+5.0/
77.0*t14);
      drv[0] = (4.0*t2-60.0/23.0*t1+120.0/253.0*r-40.0/1771.0)*(t5*t+30.0/11.0*
t5*t7+30.0/11.0*t9*t10+40.0/33.0*t4*t12+5.0/22.0*t*t14+t14*t7/77)+t25;
      drv[1] = t25;
      drv[2] = t20*(5.0*t5+120.0/11.0*t21+90.0/11.0*t22+80.0/33.0*t23+5.0/22.0*
t14);
   /* p=13 4 1 4 */
   } else if( i==4 && j==1 && k==4 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s+2.0/13.0*r-2.0/13.0;
      t6 = t*t;
      t7 = t6*t6;
      t8 = t6*t;
      t9 = s+r-1.0;
      t11 = t9*t9;
      t13 = t11*t9;
      t15 = t11*t11;
      t16 = t7+20.0/9.0*t8*t9+5.0/3.0*t6*t11+10.0/21.0*t*t13+5.0/126.0*t15;
      t18 = t1*t1;
      t19 = t18-20.0/23.0*t2+60.0/253.0*t1-40.0/1771.0*r+1.0/1771.0;
      t20 = t19*t16;
      t21 = t19*t4;
      t22 = t6*t9;
      t23 = t*t11;
      t25 = t21*(20.0/9.0*t8+10.0/3.0*t22+10.0/7.0*t23+10.0/63.0*t13);
      drv[0] = t4*(4.0*t2-60.0/23.0*t1+120.0/253.0*r-40.0/1771.0)*t16+2.0/13.0*
t20+t25;
      drv[1] = t20+t25;
      drv[2] = t21*(4.0*t8+20.0/3.0*t22+10.0/3.0*t23+10.0/21.0*t13);
   /* p=13 4 2 3 */
   } else if( i==4 && j==2 && k==3 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t8 = t4+6.0/13.0*s*t5+t7/26;
      t10 = t*t;
      t12 = s+r-1.0;
      t14 = t12*t12;
      t17 = t10*t+12.0/7.0*t10*t12+6.0/7.0*t*t14+4.0/35.0*t14*t12;
      t19 = t1*t1;
      t20 = t19-20.0/23.0*t2+60.0/253.0*t1-40.0/1771.0*r+1.0/1771.0;
      t24 = t20*t8;
      t25 = t*t12;
      t27 = t24*(12.0/7.0*t10+12.0/7.0*t25+12.0/35.0*t14);
      drv[0] = (4.0*t2-60.0/23.0*t1+120.0/253.0*r-40.0/1771.0)*t8*t17+t20*(6.0/
13.0*s+r/13-1.0/13.0)*t17+t27;
      drv[1] = t20*(2.0*s+6.0/13.0*r-6.0/13.0)*t17+t27;
      drv[2] = t24*(3.0*t10+24.0/7.0*t25+6.0/7.0*t14);
   /* p=13 4 3 2 */
   } else if( i==4 && j==3 && k==2 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t11 = t4*s+12.0/13.0*t4*t6+3.0/13.0*s*t8+2.0/143.0*t8*t6;
      t13 = t*t;
      t14 = s+r-1.0;
      t16 = t14*t14;
      t17 = t13+6.0/5.0*t*t14+3.0/10.0*t16;
      t19 = t1*t1;
      t20 = t19-20.0/23.0*t2+60.0/253.0*t1-40.0/1771.0*r+1.0/1771.0;
      t21 = s*t6;
      t25 = t20*t11;
      t27 = t25*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (4.0*t2-60.0/23.0*t1+120.0/253.0*r-40.0/1771.0)*t11*t17+t20*(
12.0/13.0*t4+6.0/13.0*t21+6.0/143.0*t8)*t17+t27;
      drv[1] = t20*(3.0*t4+24.0/13.0*t21+3.0/13.0*t8)*t17+t27;
      drv[2] = t25*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=13 4 4 1 */
   } else if( i==4 && j==4 && k==1 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t5 = t4*t4;
      t6 = t4*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t11 = t9*t7;
      t13 = t9*t9;
      t14 = t5+20.0/13.0*t6*t7+10.0/13.0*t4*t9+20.0/143.0*s*t11+t13/143;
      t16 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t18 = t1*t1;
      t19 = t18-20.0/23.0*t2+60.0/253.0*t1-40.0/1771.0*r+1.0/1771.0;
      t20 = t4*t7;
      t21 = s*t9;
      t25 = t19*t14;
      drv[0] = (4.0*t2-60.0/23.0*t1+120.0/253.0*r-40.0/1771.0)*t14*t16+t19*(
20.0/13.0*t6+20.0/13.0*t20+60.0/143.0*t21+4.0/143.0*t11)*t16+2.0/3.0*t25;
      drv[1] = t19*(4.0*t6+60.0/13.0*t20+20.0/13.0*t21+20.0/143.0*t11)*t16+2.0/
3.0*t25;
      drv[2] = t25;
   /* p=13 4 5 0 */
   } else if( i==4 && j==5 && k==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t5 = t4*t4;
      t7 = r-1.0;
      t9 = t4*s;
      t10 = t7*t7;
      t12 = t10*t7;
      t14 = t10*t10;
      t19 = t1*t1;
      t20 = t19-20.0/23.0*t2+60.0/253.0*t1-40.0/1771.0*r+1.0/1771.0;
      t21 = t9*t7;
      t22 = t4*t10;
      t23 = s*t12;
      drv[0] = (4.0*t2-60.0/23.0*t1+120.0/253.0*r-40.0/1771.0)*(t5*s+30.0/13.0*
t5*t7+25.0/13.0*t9*t10+100.0/143.0*t4*t12+15.0/143.0*s*t14+2.0/429.0*t14*t7)+
t20*(30.0/13.0*t5+50.0/13.0*t21+300.0/143.0*t22+60.0/143.0*t23+10.0/429.0*t14);
      drv[1] = t20*(5.0*t5+120.0/13.0*t21+75.0/13.0*t22+200.0/143.0*t23+15.0/
143.0*t14);
      drv[2] = 0.0;
   /* p=13 5 0 4 */
   } else if( i==5 && j==0 && k==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = t*t;
      t6 = t5*t5;
      t7 = t5*t;
      t8 = s+r-1.0;
      t10 = t8*t8;
      t12 = t10*t8;
      t14 = t10*t10;
      t18 = t2*r-30.0/23.0*t2+150.0/253.0*t3-200.0/1771.0*t1+15.0/1771.0*r-6.0/
33649.0;
      t19 = t5*t8;
      t20 = t*t10;
      t22 = t18*(20.0/9.0*t7+10.0/3.0*t19+10.0/7.0*t20+10.0/63.0*t12);
      drv[0] = (5.0*t2-120.0/23.0*t3+450.0/253.0*t1-400.0/1771.0*r+15.0/1771.0)
*(t6+20.0/9.0*t7*t8+5.0/3.0*t5*t10+10.0/21.0*t*t12+5.0/126.0*t14)+t22;
      drv[1] = t22;
      drv[2] = t18*(4.0*t7+20.0/3.0*t19+10.0/3.0*t20+10.0/21.0*t12);
   /* p=13 5 1 3 */
   } else if( i==5 && j==1 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s+2.0/11.0*r-2.0/11.0;
      t7 = t*t;
      t9 = s+r-1.0;
      t11 = t9*t9;
      t14 = t7*t+12.0/7.0*t7*t9+6.0/7.0*t*t11+4.0/35.0*t11*t9;
      t17 = t2*r-30.0/23.0*t2+150.0/253.0*t3-200.0/1771.0*t1+15.0/1771.0*r-6.0/
33649.0;
      t18 = t17*t14;
      t19 = t17*t5;
      t20 = t*t9;
      t22 = t19*(12.0/7.0*t7+12.0/7.0*t20+12.0/35.0*t11);
      drv[0] = (5.0*t2-120.0/23.0*t3+450.0/253.0*t1-400.0/1771.0*r+15.0/1771.0)
*t5*t14+2.0/11.0*t18+t22;
      drv[1] = t18+t22;
      drv[2] = t19*(3.0*t7+24.0/7.0*t20+6.0/7.0*t11);
   /* p=13 5 2 2 */
   } else if( i==5 && j==2 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t9 = t5+6.0/11.0*s*t6+3.0/55.0*t8;
      t11 = t*t;
      t12 = s+r-1.0;
      t14 = t12*t12;
      t15 = t11+6.0/5.0*t*t12+3.0/10.0*t14;
      t18 = t2*r-30.0/23.0*t2+150.0/253.0*t3-200.0/1771.0*t1+15.0/1771.0*r-6.0/
33649.0;
      t22 = t18*t9;
      t24 = t22*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (5.0*t2-120.0/23.0*t3+450.0/253.0*t1-400.0/1771.0*r+15.0/1771.0)
*t9*t15+t18*(6.0/11.0*s+6.0/55.0*r-6.0/55.0)*t15+t24;
      drv[1] = t18*(2.0*s+6.0/11.0*r-6.0/11.0)*t15+t24;
      drv[2] = t22*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=13 5 3 1 */
   } else if( i==5 && j==3 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t12 = t5*s+12.0/11.0*t5*t7+18.0/55.0*s*t9+4.0/165.0*t7*t9;
      t14 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t17 = t2*r-30.0/23.0*t2+150.0/253.0*t3-200.0/1771.0*t1+15.0/1771.0*r-6.0/
33649.0;
      t18 = s*t7;
      t22 = t17*t12;
      drv[0] = (5.0*t2-120.0/23.0*t3+450.0/253.0*t1-400.0/1771.0*r+15.0/1771.0)
*t12*t14+t17*(12.0/11.0*t5+36.0/55.0*t18+4.0/55.0*t9)*t14+2.0/3.0*t22;
      drv[1] = t17*(3.0*t5+24.0/11.0*t18+18.0/55.0*t9)*t14+2.0/3.0*t22;
      drv[2] = t22;
   /* p=13 5 4 0 */
   } else if( i==5 && j==4 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s*s;
      t6 = t5*t5;
      t7 = t5*s;
      t8 = r-1.0;
      t10 = t8*t8;
      t12 = t10*t8;
      t14 = t10*t10;
      t18 = t2*r-30.0/23.0*t2+150.0/253.0*t3-200.0/1771.0*t1+15.0/1771.0*r-6.0/
33649.0;
      t19 = t5*t8;
      t20 = s*t10;
      drv[0] = (5.0*t2-120.0/23.0*t3+450.0/253.0*t1-400.0/1771.0*r+15.0/1771.0)
*(t6+20.0/11.0*t7*t8+12.0/11.0*t5*t10+8.0/33.0*s*t12+t14/66)+t18*(20.0/11.0*t7+
24.0/11.0*t19+8.0/11.0*t20+2.0/33.0*t12);
      drv[1] = t18*(4.0*t7+60.0/11.0*t19+24.0/11.0*t20+8.0/33.0*t12);
      drv[2] = 0.0;
   /* p=13 6 0 3 */
   } else if( i==6 && j==0 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t6 = t*t;
      t8 = s+r-1.0;
      t10 = t8*t8;
      t16 = t2*t1-42.0/23.0*t3+315.0/253.0*t2-100.0/253.0*t4+15.0/253.0*t1-18.0
/4807.0*r+1.0/14421.0;
      t17 = t*t8;
      t19 = t16*(12.0/7.0*t6+12.0/7.0*t17+12.0/35.0*t10);
      drv[0] = (6.0*t3-210.0/23.0*t2+1260.0/253.0*t4-300.0/253.0*t1+30.0/253.0*
r-18.0/4807.0)*(t6*t+12.0/7.0*t6*t8+6.0/7.0*t*t10+4.0/35.0*t10*t8)+t19;
      drv[1] = t19;
      drv[2] = t16*(3.0*t6+24.0/7.0*t17+6.0/7.0*t10);
   /* p=13 6 1 2 */
   } else if( i==6 && j==1 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t6 = s+2.0/9.0*r-2.0/9.0;
      t8 = t*t;
      t9 = s+r-1.0;
      t11 = t9*t9;
      t12 = t8+6.0/5.0*t*t9+3.0/10.0*t11;
      t15 = t2*t1-42.0/23.0*t3+315.0/253.0*t2-100.0/253.0*t4+15.0/253.0*t1-18.0
/4807.0*r+1.0/14421.0;
      t16 = t15*t12;
      t17 = t15*t6;
      t19 = t17*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (6.0*t3-210.0/23.0*t2+1260.0/253.0*t4-300.0/253.0*t1+30.0/253.0*
r-18.0/4807.0)*t6*t12+2.0/9.0*t16+t19;
      drv[1] = t16+t19;
      drv[2] = t17*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=13 6 2 1 */
   } else if( i==6 && j==2 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t6 = s*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t10 = t6+2.0/3.0*s*t7+t9/12;
      t12 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t15 = t2*t1-42.0/23.0*t3+315.0/253.0*t2-100.0/253.0*t4+15.0/253.0*t1-18.0
/4807.0*r+1.0/14421.0;
      t19 = t15*t10;
      drv[0] = (6.0*t3-210.0/23.0*t2+1260.0/253.0*t4-300.0/253.0*t1+30.0/253.0*
r-18.0/4807.0)*t10*t12+t15*(2.0/3.0*s+r/6-1.0/6.0)*t12+2.0/3.0*t19;
      drv[1] = t15*(2.0*s+2.0/3.0*r-2.0/3.0)*t12+2.0/3.0*t19;
      drv[2] = t19;
   /* p=13 6 3 0 */
   } else if( i==6 && j==3 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t6 = s*s;
      t8 = r-1.0;
      t10 = t8*t8;
      t16 = t2*t1-42.0/23.0*t3+315.0/253.0*t2-100.0/253.0*t4+15.0/253.0*t1-18.0
/4807.0*r+1.0/14421.0;
      t17 = s*t8;
      drv[0] = (6.0*t3-210.0/23.0*t2+1260.0/253.0*t4-300.0/253.0*t1+30.0/253.0*
r-18.0/4807.0)*(t6*s+4.0/3.0*t6*t8+s*t10/2+t10*t8/21)+t16*(4.0/3.0*t6+t17+t10/7
);
      drv[1] = t16*(3.0*t6+8.0/3.0*t17+t10/2);
      drv[2] = 0.0;
   /* p=13 7 0 2 */
   } else if( i==7 && j==0 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t2*r;
      t5 = t1*r;
      t7 = t*t;
      t8 = s+r-1.0;
      t10 = t8*t8;
      t14 = t2*t5-56.0/23.0*t3+588.0/253.0*t4-280.0/253.0*t2+70.0/253.0*t5
-168.0/4807.0*t1+28.0/14421.0*r-8.0/245157.0;
      t16 = t14*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (7.0*t3-336.0/23.0*t4+2940.0/253.0*t2-1120.0/253.0*t5+210.0/
253.0*t1-336.0/4807.0*r+28.0/14421.0)*(t7+6.0/5.0*t*t8+3.0/10.0*t10)+t16;
      drv[1] = t16;
      drv[2] = t14*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=13 7 1 1 */
   } else if( i==7 && j==1 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t2*r;
      t5 = t1*r;
      t7 = s+2.0/7.0*r-2.0/7.0;
      t9 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t12 = t2*t5-56.0/23.0*t3+588.0/253.0*t4-280.0/253.0*t2+70.0/253.0*t5
-168.0/4807.0*t1+28.0/14421.0*r-8.0/245157.0;
      t13 = t12*t9;
      t14 = t12*t7;
      drv[0] = (7.0*t3-336.0/23.0*t4+2940.0/253.0*t2-1120.0/253.0*t5+210.0/
253.0*t1-336.0/4807.0*r+28.0/14421.0)*t7*t9+2.0/7.0*t13+2.0/3.0*t14;
      drv[1] = t13+2.0/3.0*t14;
      drv[2] = t14;
   /* p=13 7 2 0 */
   } else if( i==7 && j==2 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t2*r;
      t5 = t1*r;
      t7 = s*s;
      t8 = r-1.0;
      t10 = t8*t8;
      t14 = t2*t5-56.0/23.0*t3+588.0/253.0*t4-280.0/253.0*t2+70.0/253.0*t5
-168.0/4807.0*t1+28.0/14421.0*r-8.0/245157.0;
      drv[0] = (7.0*t3-336.0/23.0*t4+2940.0/253.0*t2-1120.0/253.0*t5+210.0/
253.0*t1-336.0/4807.0*r+28.0/14421.0)*(t7+6.0/7.0*s*t8+t10/7)+t14*(6.0/7.0*s+
2.0/7.0*r-2.0/7.0);
      drv[1] = t14*(2.0*s+6.0/7.0*r-6.0/7.0);
      drv[2] = 0.0;
   /* p=13 8 0 1 */
   } else if( i==8 && j==0 && k==1 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t4 = t3*t2;
      t5 = t3*t1;
      t6 = t3*r;
      t10 = t3*t3;
      drv[0] = (8.0*t4-504.0/23.0*t5+6048.0/253.0*t6-3360.0/253.0*t3+1008.0/
253.0*t2-3024.0/4807.0*t1+224.0/4807.0*r-96.0/81719.0)*(t+2.0/3.0*s+2.0/3.0*r
-2.0/3.0)+2.0/3.0*t10-48.0/23.0*t4+672.0/253.0*t5-448.0/253.0*t6+168.0/253.0*t3
-672.0/4807.0*t2+224.0/14421.0*t1-64.0/81719.0*r+1.0/81719.0;
      drv[1] = 2.0/3.0*t10-48.0/23.0*t4+672.0/253.0*t5-448.0/253.0*t6+168.0/
253.0*t3-672.0/4807.0*t2+224.0/14421.0*t1-64.0/81719.0*r+1.0/81719.0;
      drv[2] = t10-72.0/23.0*t4+1008.0/253.0*t5-672.0/253.0*t6+252.0/253.0*t3
-1008.0/4807.0*t2+112.0/4807.0*t1-96.0/81719.0*r+3.0/163438.0;
   /* p=13 8 1 0 */
   } else if( i==8 && j==1 && k==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t4 = t3*t2;
      t5 = t3*t1;
      t6 = t3*r;
      t10 = t3*t3;
      drv[0] = (8.0*t4-504.0/23.0*t5+6048.0/253.0*t6-3360.0/253.0*t3+1008.0/
253.0*t2-3024.0/4807.0*t1+224.0/4807.0*r-96.0/81719.0)*(s+2.0/5.0*r-2.0/5.0)+
2.0/5.0*t10-144.0/115.0*t4+2016.0/1265.0*t5-1344.0/1265.0*t6+504.0/1265.0*t3
-2016.0/24035.0*t2+224.0/24035.0*t1-192.0/408595.0*r+3.0/408595.0;
      drv[1] = t10-72.0/23.0*t4+1008.0/253.0*t5-672.0/253.0*t6+252.0/253.0*t3
-1008.0/4807.0*t2+112.0/4807.0*t1-96.0/81719.0*r+3.0/163438.0;
      drv[2] = 0.0;
   /* p=13 9 0 0 */
   } else if( i==9 && j==0 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*r;
      drv[0] = 9.0*t3-720.0/23.0*t4*t2+11340.0/253.0*t2*t1-8640.0/253.0*t2*r+
3780.0/253.0*t2-18144.0/4807.0*t4+2520.0/4807.0*t1-2880.0/81719.0*r+135.0/
163438.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
   /* p=14 0 0 10 */
   } else if( i==0 && j==0 && k==10 ) {
      t1 = t*t;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t3*t;
      t5 = s+r-1.0;
      t6 = t3*t5;
      t7 = t1*t;
      t9 = t5*t5;
      t10 = t2*t7*t9;
      t12 = t9*t5;
      t13 = t2*t1*t12;
      t15 = t9*t9;
      t16 = t2*t*t15;
      t18 = t2*t15*t5;
      t20 = t7*t15*t9;
      t22 = t1*t15*t12;
      t23 = t15*t15;
      t24 = t*t23;
      t25 = t23*t5;
      t26 = 110.0/21.0*t4+165.0/7.0*t6+5940.0/133.0*t10+880.0/19.0*t13+9240.0/
323.0*t16+3465.0/323.0*t18+770.0/323.0*t20+660.0/2261.0*t22+495.0/29393.0*t24+
55.0/176358.0*t25;
      drv[0] = t26;
      drv[1] = t26;
      drv[2] = 10.0*t4+330.0/7.0*t6+660.0/7.0*t10+1980.0/19.0*t13+1320.0/19.0*
t16+9240.0/323.0*t18+2310.0/323.0*t20+330.0/323.0*t22+165.0/2261.0*t24+55.0/
29393.0*t25;
   /* p=14 0 1 9 */
   } else if( i==0 && j==1 && k==9 ) {
      t1 = t*t;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t3*t;
      t5 = s+r-1.0;
      t6 = t3*t5;
      t7 = t1*t;
      t8 = t2*t7;
      t9 = t5*t5;
      t10 = t8*t9;
      t11 = t2*t1;
      t12 = t9*t5;
      t13 = t11*t12;
      t14 = t2*t;
      t15 = t9*t9;
      t16 = t14*t15;
      t17 = t15*t5;
      t18 = t2*t17;
      t19 = t15*t9;
      t20 = t7*t19;
      t21 = t15*t12;
      t22 = t1*t21;
      t23 = t15*t15;
      t24 = t*t23;
      t25 = t23*t5;
      t26 = s+2.0/23.0*r-2.0/23.0;
      t27 = t8*t5;
      t28 = t11*t9;
      t29 = t14*t12;
      t30 = t2*t15;
      t31 = t7*t17;
      t32 = t1*t19;
      t33 = t*t21;
      t35 = t26*(90.0/19.0*t3+360.0/19.0*t27+10080.0/323.0*t28+8820.0/323.0*t29
+4410.0/323.0*t30+1260.0/323.0*t31+2520.0/4199.0*t32+180.0/4199.0*t33+45.0/
46189.0*t23);
      t36 = 2.0/23.0*t4+180.0/437.0*t6+360.0/437.0*t10+6720.0/7429.0*t13+4410.0
/7429.0*t16+1764.0/7429.0*t18+420.0/7429.0*t20+720.0/96577.0*t22+45.0/96577.0*
t24+10.0/1062347.0*t25+t35;
      t37 = t4+90.0/19.0*t6+180.0/19.0*t10+3360.0/323.0*t13+2205.0/323.0*t16+
882.0/323.0*t18+210.0/323.0*t20+360.0/4199.0*t22+45.0/8398.0*t24+5.0/46189.0*
t25+t35;
      drv[0] = t36;
      drv[1] = t37;
      drv[2] = t26*(9.0*t3+720.0/19.0*t27+1260.0/19.0*t28+20160.0/323.0*t29+
11025.0/323.0*t30+3528.0/323.0*t31+630.0/323.0*t32+720.0/4199.0*t33+45.0/8398.0
*t23);
   /* p=14 0 2 8 */
   } else if( i==0 && j==2 && k==8 ) {
      t2 = t*t;
      t3 = t2*t2;
      t4 = t3*t3;
      t5 = t2*t;
      t6 = t3*t5;
      t7 = s+r-1.0;
      t9 = t3*t2;
      t10 = t7*t7;
      t12 = t3*t;
      t13 = t10*t7;
      t15 = t10*t10;
      t17 = t15*t7;
      t19 = t15*t10;
      t21 = t15*t13;
      t23 = t15*t15;
      t24 = t4+72.0/17.0*t6*t7+126.0/17.0*t9*t10+588.0/85.0*t12*t13+63.0/17.0*
t3*t15+252.0/221.0*t5*t17+42.0/221.0*t2*t19+36.0/2431.0*t*t21+9.0/24310.0*t23;
      t26 = s*s;
      t27 = r-1.0;
      t29 = t27*t27;
      t30 = t26+6.0/23.0*s*t27+3.0/253.0*t29;
      t31 = t9*t7;
      t32 = t12*t10;
      t33 = t3*t13;
      t34 = t15*t5;
      t35 = t2*t17;
      t36 = t*t19;
      t38 = t30*(72.0/17.0*t6+252.0/17.0*t31+1764.0/85.0*t32+252.0/17.0*t33+
1260.0/221.0*t34+252.0/221.0*t35+252.0/2431.0*t36+36.0/12155.0*t21);
      drv[0] = (6.0/23.0*s+6.0/253.0*r-6.0/253.0)*t24+t38;
      drv[1] = (2.0*s+6.0/23.0*r-6.0/23.0)*t24+t38;
      drv[2] = t30*(8.0*t6+504.0/17.0*t31+756.0/17.0*t32+588.0/17.0*t33+252.0/
17.0*t34+756.0/221.0*t35+84.0/221.0*t36+36.0/2431.0*t21);
   /* p=14 0 3 7 */
   } else if( i==0 && j==3 && k==7 ) {
      t1 = s*s;
      t2 = r-1.0;
      t3 = s*t2;
      t4 = t2*t2;
      t6 = t*t;
      t7 = t6*t;
      t8 = t6*t6;
      t10 = t8*t6;
      t11 = s+r-1.0;
      t13 = t8*t;
      t14 = t11*t11;
      t16 = t14*t11;
      t18 = t14*t14;
      t20 = t18*t11;
      t22 = t18*t14;
      t25 = t8*t7+56.0/15.0*t10*t11+28.0/5.0*t13*t14+56.0/13.0*t8*t16+70.0/39.0
*t7*t18+56.0/143.0*t6*t20+28.0/715.0*t*t22+8.0/6435.0*t18*t16;
      t31 = t1*s+12.0/23.0*t2*t1+18.0/253.0*s*t4+4.0/1771.0*t4*t2;
      t32 = t13*t11;
      t33 = t8*t14;
      t34 = t7*t16;
      t35 = t6*t18;
      t36 = t*t20;
      t38 = t31*(56.0/15.0*t10+56.0/5.0*t32+168.0/13.0*t33+280.0/39.0*t34+280.0
/143.0*t35+168.0/715.0*t36+56.0/6435.0*t22);
      drv[0] = (12.0/23.0*t1+36.0/253.0*t3+12.0/1771.0*t4)*t25+t38;
      drv[1] = (3.0*t1+24.0/23.0*t3+18.0/253.0*t4)*t25+t38;
      drv[2] = t31*(7.0*t10+112.0/5.0*t32+28.0*t33+224.0/13.0*t34+70.0/13.0*t35
+112.0/143.0*t36+28.0/715.0*t22);
   /* p=14 0 4 6 */
   } else if( i==0 && j==4 && k==6 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = r-1.0;
      t4 = t3*t1;
      t5 = t3*t3;
      t6 = s*t5;
      t7 = t5*t3;
      t9 = t*t;
      t10 = t9*t9;
      t12 = t10*t;
      t13 = s+r-1.0;
      t15 = t13*t13;
      t17 = t9*t;
      t18 = t15*t13;
      t20 = t15*t15;
      t22 = t20*t13;
      t25 = t10*t9+42.0/13.0*t12*t13+105.0/26.0*t10*t15+350.0/143.0*t17*t18+
105.0/143.0*t9*t20+14.0/143.0*t*t22+7.0/1716.0*t20*t15;
      t27 = t1*t1;
      t31 = t5*t5;
      t32 = t27+20.0/23.0*t3*t2+60.0/253.0*t1*t5+40.0/1771.0*s*t7+t31/1771;
      t33 = t10*t13;
      t34 = t17*t15;
      t35 = t9*t18;
      t36 = t*t20;
      t38 = t32*(42.0/13.0*t12+105.0/13.0*t33+1050.0/143.0*t34+420.0/143.0*t35+
70.0/143.0*t36+7.0/286.0*t22);
      drv[0] = (20.0/23.0*t2+120.0/253.0*t4+120.0/1771.0*t6+4.0/1771.0*t7)*t25+
t38;
      drv[1] = (4.0*t2+60.0/23.0*t4+120.0/253.0*t6+40.0/1771.0*t7)*t25+t38;
      drv[2] = t32*(6.0*t12+210.0/13.0*t33+210.0/13.0*t34+1050.0/143.0*t35+
210.0/143.0*t36+14.0/143.0*t22);
   /* p=14 0 5 5 */
   } else if( i==0 && j==5 && k==5 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t1*s;
      t4 = r-1.0;
      t5 = t3*t4;
      t6 = t4*t4;
      t7 = t1*t6;
      t8 = t6*t4;
      t9 = s*t8;
      t10 = t6*t6;
      t12 = t*t;
      t13 = t12*t12;
      t15 = s+r-1.0;
      t17 = t12*t;
      t18 = t15*t15;
      t20 = t18*t15;
      t22 = t18*t18;
      t25 = t13*t+30.0/11.0*t15*t13+30.0/11.0*t17*t18+40.0/33.0*t12*t20+5.0/
22.0*t*t22+t22*t15/77;
      t33 = s*t2+30.0/23.0*t4*t2+150.0/253.0*t3*t6+200.0/1771.0*t1*t8+15.0/
1771.0*s*t10+6.0/33649.0*t10*t4;
      t34 = t17*t15;
      t35 = t12*t18;
      t36 = t*t20;
      t38 = t33*(30.0/11.0*t13+60.0/11.0*t34+40.0/11.0*t35+10.0/11.0*t36+5.0/
77.0*t22);
      drv[0] = (30.0/23.0*t2+300.0/253.0*t5+600.0/1771.0*t7+60.0/1771.0*t9+30.0
/33649.0*t10)*t25+t38;
      drv[1] = (5.0*t2+120.0/23.0*t5+450.0/253.0*t7+400.0/1771.0*t9+15.0/1771.0
*t10)*t25+t38;
      drv[2] = t33*(5.0*t13+120.0/11.0*t34+90.0/11.0*t35+80.0/33.0*t36+5.0/22.0
*t22);
   /* p=14 0 6 4 */
   } else if( i==0 && j==6 && k==4 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*s;
      t4 = r-1.0;
      t5 = t4*t2;
      t6 = t1*s;
      t7 = t4*t4;
      t8 = t6*t7;
      t9 = t7*t4;
      t10 = t1*t9;
      t11 = t7*t7;
      t12 = s*t11;
      t13 = t11*t4;
      t15 = t*t;
      t16 = t15*t15;
      t17 = t15*t;
      t18 = s+r-1.0;
      t20 = t18*t18;
      t22 = t20*t18;
      t24 = t20*t20;
      t25 = t16+20.0/9.0*t17*t18+5.0/3.0*t20*t15+10.0/21.0*t*t22+5.0/126.0*t24;
      t34 = t2*t1+42.0/23.0*t3*t4+315.0/253.0*t2*t7+100.0/253.0*t6*t9+15.0/
253.0*t1*t11+18.0/4807.0*s*t13+t11*t7/14421;
      t35 = t18*t15;
      t36 = t*t20;
      t38 = t34*(20.0/9.0*t17+10.0/3.0*t35+10.0/7.0*t36+10.0/63.0*t22);
      drv[0] = (42.0/23.0*t3+630.0/253.0*t5+300.0/253.0*t8+60.0/253.0*t10+90.0/
4807.0*t12+2.0/4807.0*t13)*t25+t38;
      drv[1] = (6.0*t3+210.0/23.0*t5+1260.0/253.0*t8+300.0/253.0*t10+30.0/253.0
*t12+18.0/4807.0*t13)*t25+t38;
      drv[2] = t34*(4.0*t17+20.0/3.0*t35+10.0/3.0*t36+10.0/21.0*t22);
   /* p=14 0 7 3 */
   } else if( i==0 && j==7 && k==3 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t2*s;
      t5 = r-1.0;
      t6 = t4*t5;
      t7 = t5*t5;
      t8 = t2*t7;
      t9 = t1*s;
      t10 = t7*t5;
      t11 = t9*t10;
      t12 = t7*t7;
      t13 = t1*t12;
      t14 = t12*t5;
      t15 = s*t14;
      t16 = t12*t7;
      t18 = t*t;
      t20 = s+r-1.0;
      t22 = t20*t20;
      t25 = t18*t+12.0/7.0*t20*t18+6.0/7.0*t*t22+4.0/35.0*t22*t20;
      t35 = t2*t9+56.0/23.0*t3*t5+588.0/253.0*t7*t4+280.0/253.0*t2*t10+70.0/
253.0*t9*t12+168.0/4807.0*t1*t14+28.0/14421.0*s*t16+8.0/245157.0*t12*t10;
      t36 = t*t20;
      t38 = t35*(12.0/7.0*t18+12.0/7.0*t36+12.0/35.0*t22);
      drv[0] = (56.0/23.0*t3+1176.0/253.0*t6+840.0/253.0*t8+280.0/253.0*t11+
840.0/4807.0*t13+56.0/4807.0*t15+56.0/245157.0*t16)*t25+t38;
      drv[1] = (7.0*t3+336.0/23.0*t6+2940.0/253.0*t8+1120.0/253.0*t11+210.0/
253.0*t13+336.0/4807.0*t15+28.0/14421.0*t16)*t25+t38;
      drv[2] = t35*(3.0*t18+24.0/7.0*t36+6.0/7.0*t22);
   /* p=14 0 8 2 */
   } else if( i==0 && j==8 && k==2 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t4 = t3*t2;
      t5 = t3*t1;
      t6 = r-1.0;
      t7 = t5*t6;
      t8 = t3*s;
      t9 = t6*t6;
      t10 = t8*t9;
      t11 = t6*t9;
      t12 = t3*t11;
      t13 = t9*t9;
      t14 = t2*t13;
      t15 = t13*t6;
      t16 = t1*t15;
      t17 = t13*t9;
      t18 = s*t17;
      t19 = t13*t11;
      t21 = t*t;
      t22 = s+r-1.0;
      t24 = t22*t22;
      t25 = t21+6.0/5.0*t*t22+3.0/10.0*t24;
      t27 = t3*t3;
      t35 = t13*t13;
      t36 = t27+72.0/23.0*t4*t6+1008.0/253.0*t5*t9+672.0/253.0*t8*t11+252.0/
253.0*t3*t13+1008.0/4807.0*t2*t15+112.0/4807.0*t1*t17+96.0/81719.0*s*t19+3.0/
163438.0*t35;
      t38 = t36*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (72.0/23.0*t4+2016.0/253.0*t7+2016.0/253.0*t10+1008.0/253.0*t12+
5040.0/4807.0*t14+672.0/4807.0*t16+672.0/81719.0*t18+12.0/81719.0*t19)*t25+t38;
      drv[1] = (8.0*t4+504.0/23.0*t7+6048.0/253.0*t10+3360.0/253.0*t12+1008.0/
253.0*t14+3024.0/4807.0*t16+224.0/4807.0*t18+96.0/81719.0*t19)*t25+t38;
      drv[2] = t36*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=14 0 9 1 */
   } else if( i==0 && j==9 && k==1 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*s;
      t5 = t4*t2;
      t6 = r-1.0;
      t7 = t5*t6;
      t8 = t2*t1;
      t9 = t6*t6;
      t10 = t8*t9;
      t11 = t2*s;
      t12 = t9*t6;
      t13 = t11*t12;
      t14 = t9*t9;
      t15 = t2*t14;
      t16 = t14*t6;
      t17 = t4*t16;
      t18 = t14*t9;
      t19 = t1*t18;
      t20 = t14*t12;
      t21 = s*t20;
      t22 = t14*t14;
      t24 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t26 = t3*s;
      t27 = t3*t6;
      t28 = t5*t9;
      t29 = t8*t12;
      t30 = t11*t14;
      t31 = t2*t16;
      t32 = t4*t18;
      t33 = t1*t20;
      t34 = s*t22;
      t35 = t22*t6;
      t36 = (90.0/23.0*t3+3240.0/253.0*t7+4320.0/253.0*t10+3024.0/253.0*t13+
22680.0/4807.0*t15+5040.0/4807.0*t17+10080.0/81719.0*t19+540.0/81719.0*t21+9.0/
81719.0*t22)*t24+2.0/3.0*t26+60.0/23.0*t27+1080.0/253.0*t28+960.0/253.0*t29+
504.0/253.0*t30+3024.0/4807.0*t31+560.0/4807.0*t32+960.0/81719.0*t33+45.0/
81719.0*t34+2.0/245157.0*t35;
      t39 = (9.0*t3+720.0/23.0*t7+11340.0/253.0*t10+8640.0/253.0*t13+3780.0/
253.0*t15+18144.0/4807.0*t17+2520.0/4807.0*t19+2880.0/81719.0*t21+135.0/
163438.0*t22)*t24+2.0/3.0*t26+60.0/23.0*t27+1080.0/253.0*t28+960.0/253.0*t29+
504.0/253.0*t30+3024.0/4807.0*t31+560.0/4807.0*t32+960.0/81719.0*t33+45.0/
81719.0*t34+2.0/245157.0*t35;
      drv[0] = t36;
      drv[1] = t39;
      drv[2] = t26+90.0/23.0*t27+1620.0/253.0*t28+1440.0/253.0*t29+756.0/253.0*
t30+4536.0/4807.0*t31+840.0/4807.0*t32+1440.0/81719.0*t33+135.0/163438.0*t34+
t35/81719;
   /* p=14 0 10 0 */
   } else if( i==0 && j==10 && k==0 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t3*s;
      t5 = r-1.0;
      t6 = t3*t5;
      t7 = t1*s;
      t9 = t5*t5;
      t10 = t2*t7*t9;
      t12 = t5*t9;
      t13 = t2*t1*t12;
      t15 = t9*t9;
      t16 = t2*s*t15;
      t18 = t2*t15*t5;
      t20 = t7*t15*t9;
      t22 = t1*t15*t12;
      t23 = t15*t15;
      t24 = s*t23;
      t25 = t23*t5;
      drv[0] = 110.0/23.0*t4+450.0/23.0*t6+5400.0/161.0*t10+720.0/23.0*t13+
7560.0/437.0*t16+2520.0/437.0*t18+8400.0/7429.0*t20+900.0/7429.0*t22+45.0/
7429.0*t24+5.0/52003.0*t25;
      drv[1] = 10.0*t4+990.0/23.0*t6+1800.0/23.0*t10+1800.0/23.0*t13+1080.0/
23.0*t16+7560.0/437.0*t18+1680.0/437.0*t20+3600.0/7429.0*t22+225.0/7429.0*t24+
5.0/7429.0*t25;
      drv[2] = 0.0;
   /* p=14 1 0 9 */
   } else if( i==1 && j==0 && k==9 ) {
      t1 = t*t;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = s+r-1.0;
      t7 = t1*t;
      t8 = t2*t7;
      t9 = t5*t5;
      t11 = t2*t1;
      t12 = t5*t9;
      t14 = t2*t;
      t15 = t9*t9;
      t17 = t15*t5;
      t19 = t15*t9;
      t21 = t15*t12;
      t23 = t15*t15;
      t26 = r-2.0/25.0;
      t27 = t8*t5;
      t28 = t11*t9;
      t29 = t14*t12;
      t30 = t2*t15;
      t31 = t7*t17;
      t32 = t1*t19;
      t33 = t*t21;
      t35 = t26*(90.0/19.0*t3+360.0/19.0*t27+10080.0/323.0*t28+8820.0/323.0*t29
+4410.0/323.0*t30+1260.0/323.0*t31+2520.0/4199.0*t32+180.0/4199.0*t33+45.0/
46189.0*t23);
      t36 = t3*t+90.0/19.0*t3*t5+180.0/19.0*t8*t9+3360.0/323.0*t11*t12+2205.0/
323.0*t14*t15+882.0/323.0*t2*t17+210.0/323.0*t7*t19+360.0/4199.0*t1*t21+45.0/
8398.0*t*t23+5.0/46189.0*t23*t5+t35;
      drv[0] = t36;
      drv[1] = t35;
      drv[2] = t26*(9.0*t3+720.0/19.0*t27+1260.0/19.0*t28+20160.0/323.0*t29+
11025.0/323.0*t30+3528.0/323.0*t31+630.0/323.0*t32+720.0/4199.0*t33+45.0/8398.0
*t23);
   /* p=14 1 1 8 */
   } else if( i==1 && j==1 && k==8 ) {
      t1 = s+2.0/21.0*r-2.0/21.0;
      t2 = t*t;
      t3 = t2*t2;
      t4 = t3*t3;
      t5 = t2*t;
      t6 = t3*t5;
      t7 = s+r-1.0;
      t9 = t3*t2;
      t10 = t7*t7;
      t12 = t3*t;
      t13 = t10*t7;
      t15 = t10*t10;
      t17 = t15*t7;
      t19 = t15*t10;
      t21 = t15*t13;
      t23 = t15*t15;
      t24 = t4+72.0/17.0*t6*t7+126.0/17.0*t9*t10+588.0/85.0*t12*t13+63.0/17.0*
t3*t15+252.0/221.0*t5*t17+42.0/221.0*t2*t19+36.0/2431.0*t*t21+9.0/24310.0*t23;
      t26 = r-2.0/25.0;
      t27 = t26*t24;
      t28 = t26*t1;
      t29 = t9*t7;
      t30 = t12*t10;
      t31 = t3*t13;
      t32 = t15*t5;
      t33 = t2*t17;
      t34 = t*t19;
      t36 = t28*(72.0/17.0*t6+252.0/17.0*t29+1764.0/85.0*t30+252.0/17.0*t31+
1260.0/221.0*t32+252.0/221.0*t33+252.0/2431.0*t34+36.0/12155.0*t21);
      drv[0] = t1*t24+2.0/21.0*t27+t36;
      drv[1] = t27+t36;
      drv[2] = t28*(8.0*t6+504.0/17.0*t29+756.0/17.0*t30+588.0/17.0*t31+252.0/
17.0*t32+756.0/221.0*t33+84.0/221.0*t34+36.0/2431.0*t21);
   /* p=14 1 2 7 */
   } else if( i==1 && j==2 && k==7 ) {
      t1 = s*s;
      t2 = r-1.0;
      t4 = t2*t2;
      t5 = t1+2.0/7.0*s*t2+t4/70;
      t6 = t*t;
      t7 = t6*t;
      t8 = t6*t6;
      t10 = t8*t6;
      t11 = s+r-1.0;
      t13 = t8*t;
      t14 = t11*t11;
      t16 = t14*t11;
      t18 = t14*t14;
      t20 = t18*t11;
      t22 = t18*t14;
      t25 = t8*t7+56.0/15.0*t10*t11+28.0/5.0*t13*t14+56.0/13.0*t8*t16+70.0/39.0
*t7*t18+56.0/143.0*t6*t20+28.0/715.0*t*t22+8.0/6435.0*t18*t16;
      t27 = r-2.0/25.0;
      t31 = t27*t5;
      t32 = t13*t11;
      t33 = t8*t14;
      t34 = t7*t16;
      t35 = t6*t18;
      t36 = t*t20;
      t38 = t31*(56.0/15.0*t10+56.0/5.0*t32+168.0/13.0*t33+280.0/39.0*t34+280.0
/143.0*t35+168.0/715.0*t36+56.0/6435.0*t22);
      drv[0] = t5*t25+t27*(2.0/7.0*s+r/35-1.0/35.0)*t25+t38;
      drv[1] = t27*(2.0*s+2.0/7.0*r-2.0/7.0)*t25+t38;
      drv[2] = t31*(7.0*t10+112.0/5.0*t32+28.0*t33+224.0/13.0*t34+70.0/13.0*t35
+112.0/143.0*t36+28.0/715.0*t22);
   /* p=14 1 3 6 */
   } else if( i==1 && j==3 && k==6 ) {
      t1 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t8 = t1*s+4.0/7.0*t3*t1+3.0/35.0*s*t5+2.0/665.0*t5*t3;
      t9 = t*t;
      t10 = t9*t9;
      t12 = t10*t;
      t13 = s+r-1.0;
      t15 = t13*t13;
      t17 = t9*t;
      t18 = t15*t13;
      t20 = t15*t15;
      t22 = t20*t13;
      t25 = t10*t9+42.0/13.0*t12*t13+105.0/26.0*t10*t15+350.0/143.0*t17*t18+
105.0/143.0*t9*t20+14.0/143.0*t*t22+7.0/1716.0*t20*t15;
      t27 = r-2.0/25.0;
      t28 = s*t3;
      t32 = t27*t8;
      t33 = t10*t13;
      t34 = t17*t15;
      t35 = t9*t18;
      t36 = t*t20;
      t38 = t32*(42.0/13.0*t12+105.0/13.0*t33+1050.0/143.0*t34+420.0/143.0*t35+
70.0/143.0*t36+7.0/286.0*t22);
      drv[0] = t8*t25+t27*(4.0/7.0*t1+6.0/35.0*t28+6.0/665.0*t5)*t25+t38;
      drv[1] = t27*(3.0*t1+8.0/7.0*t28+3.0/35.0*t5)*t25+t38;
      drv[2] = t32*(6.0*t12+210.0/13.0*t33+210.0/13.0*t34+1050.0/143.0*t35+
210.0/143.0*t36+14.0/143.0*t22);
   /* p=14 1 4 5 */
   } else if( i==1 && j==4 && k==5 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t1*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t8 = t6*t4;
      t10 = t6*t6;
      t11 = t2+20.0/21.0*t3*t4+2.0/7.0*t1*t6+4.0/133.0*s*t8+t10/1197;
      t12 = t*t;
      t13 = t12*t12;
      t15 = s+r-1.0;
      t17 = t12*t;
      t18 = t15*t15;
      t20 = t18*t15;
      t22 = t18*t18;
      t25 = t13*t+30.0/11.0*t15*t13+30.0/11.0*t17*t18+40.0/33.0*t12*t20+5.0/
22.0*t*t22+t22*t15/77;
      t27 = r-2.0/25.0;
      t28 = t4*t1;
      t29 = s*t6;
      t33 = t27*t11;
      t34 = t17*t15;
      t35 = t12*t18;
      t36 = t*t20;
      t38 = t33*(30.0/11.0*t13+60.0/11.0*t34+40.0/11.0*t35+10.0/11.0*t36+5.0/
77.0*t22);
      drv[0] = t11*t25+t27*(20.0/21.0*t3+4.0/7.0*t28+12.0/133.0*t29+4.0/1197.0*
t8)*t25+t38;
      drv[1] = t27*(4.0*t3+20.0/7.0*t28+4.0/7.0*t29+4.0/133.0*t8)*t25+t38;
      drv[2] = t33*(5.0*t13+120.0/11.0*t34+90.0/11.0*t35+80.0/33.0*t36+5.0/22.0
*t22);
   /* p=14 1 5 4 */
   } else if( i==1 && j==5 && k==4 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t6 = t1*s;
      t7 = t4*t4;
      t9 = t7*t4;
      t11 = t7*t7;
      t14 = t2*s+10.0/7.0*t4*t2+5.0/7.0*t6*t7+20.0/133.0*t1*t9+5.0/399.0*s*t11+
2.0/6783.0*t11*t4;
      t15 = t*t;
      t16 = t15*t15;
      t17 = t15*t;
      t18 = s+r-1.0;
      t20 = t18*t18;
      t22 = t20*t18;
      t24 = t20*t20;
      t25 = t16+20.0/9.0*t17*t18+5.0/3.0*t20*t15+10.0/21.0*t*t22+5.0/126.0*t24;
      t27 = r-2.0/25.0;
      t28 = t6*t4;
      t29 = t1*t7;
      t30 = s*t9;
      t34 = t27*t14;
      t35 = t18*t15;
      t36 = t*t20;
      t38 = t34*(20.0/9.0*t17+10.0/3.0*t35+10.0/7.0*t36+10.0/63.0*t22);
      drv[0] = t14*t25+t27*(10.0/7.0*t2+10.0/7.0*t28+60.0/133.0*t29+20.0/399.0*
t30+10.0/6783.0*t11)*t25+t38;
      drv[1] = t27*(5.0*t2+40.0/7.0*t28+15.0/7.0*t29+40.0/133.0*t30+5.0/399.0*
t11)*t25+t38;
      drv[2] = t34*(4.0*t17+20.0/3.0*t35+10.0/3.0*t36+10.0/21.0*t22);
   /* p=14 1 6 3 */
   } else if( i==1 && j==6 && k==3 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = t2*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t9 = t1*s;
      t10 = t7*t5;
      t12 = t7*t7;
      t14 = t12*t5;
      t17 = t2*t1+2.0*t4*t5+3.0/2.0*t2*t7+10.0/19.0*t9*t10+5.0/57.0*t1*t12+2.0/
323.0*s*t14+t12*t7/7752;
      t18 = t*t;
      t20 = s+r-1.0;
      t22 = t20*t20;
      t25 = t18*t+12.0/7.0*t18*t20+6.0/7.0*t*t22+4.0/35.0*t22*t20;
      t27 = r-2.0/25.0;
      t28 = t2*t5;
      t29 = t9*t7;
      t30 = t1*t10;
      t31 = s*t12;
      t35 = t27*t17;
      t36 = t*t20;
      t38 = t35*(12.0/7.0*t18+12.0/7.0*t36+12.0/35.0*t22);
      drv[0] = t17*t25+t27*(2.0*t4+3.0*t28+30.0/19.0*t29+20.0/57.0*t30+10.0/
323.0*t31+t14/1292)*t25+t38;
      drv[1] = t27*(6.0*t4+10.0*t28+6.0*t29+30.0/19.0*t30+10.0/57.0*t31+2.0/
323.0*t14)*t25+t38;
      drv[2] = t35*(3.0*t18+24.0/7.0*t36+6.0/7.0*t22);
   /* p=14 1 7 2 */
   } else if( i==1 && j==7 && k==2 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t5 = t3*t1;
      t6 = r-1.0;
      t8 = t3*s;
      t9 = t6*t6;
      t11 = t9*t6;
      t13 = t9*t9;
      t15 = t13*t6;
      t17 = t13*t9;
      t20 = t3*t2+8.0/3.0*t5*t6+14.0/5.0*t8*t9+28.0/19.0*t3*t11+70.0/171.0*t2*
t13+56.0/969.0*t1*t15+7.0/1938.0*s*t17+t13*t11/14535;
      t21 = t*t;
      t22 = s+r-1.0;
      t24 = t22*t22;
      t25 = t21+6.0/5.0*t*t22+3.0/10.0*t24;
      t27 = r-2.0/25.0;
      t28 = t8*t6;
      t29 = t3*t9;
      t30 = t2*t11;
      t31 = t1*t13;
      t32 = s*t15;
      t36 = t27*t20;
      t38 = t36*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = t20*t25+t27*(8.0/3.0*t5+28.0/5.0*t28+84.0/19.0*t29+280.0/171.0*
t30+280.0/969.0*t31+7.0/323.0*t32+7.0/14535.0*t17)*t25+t38;
      drv[1] = t27*(7.0*t5+16.0*t28+14.0*t29+112.0/19.0*t30+70.0/57.0*t31+112.0
/969.0*t32+7.0/1938.0*t17)*t25+t38;
      drv[2] = t36*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=14 1 8 1 */
   } else if( i==1 && j==8 && k==1 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*s;
      t5 = t4*t2;
      t6 = r-1.0;
      t8 = t2*t1;
      t9 = t6*t6;
      t11 = t2*s;
      t12 = t9*t6;
      t14 = t9*t9;
      t16 = t14*t6;
      t18 = t14*t9;
      t20 = t14*t12;
      t22 = t14*t14;
      t23 = t3+24.0/7.0*t5*t6+24.0/5.0*t8*t9+336.0/95.0*t11*t12+28.0/19.0*t2*
t14+112.0/323.0*t4*t16+14.0/323.0*t1*t18+4.0/1615.0*s*t20+t22/22610;
      t24 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t26 = r-2.0/25.0;
      t27 = t8*t6;
      t28 = t11*t9;
      t29 = t2*t12;
      t30 = t4*t14;
      t31 = t1*t16;
      t32 = s*t18;
      t36 = t26*t23;
      drv[0] = t23*t24+t26*(24.0/7.0*t5+48.0/5.0*t27+1008.0/95.0*t28+112.0/19.0
*t29+560.0/323.0*t30+84.0/323.0*t31+28.0/1615.0*t32+4.0/11305.0*t20)*t24+2.0/
3.0*t36;
      drv[1] = t26*(8.0*t5+24.0*t27+144.0/5.0*t28+336.0/19.0*t29+112.0/19.0*t30
+336.0/323.0*t31+28.0/323.0*t32+4.0/1615.0*t20)*t24+2.0/3.0*t36;
      drv[2] = t36;
   /* p=14 1 9 0 */
   } else if( i==1 && j==9 && k==0 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = r-1.0;
      t7 = t1*s;
      t8 = t2*t7;
      t9 = t5*t5;
      t11 = t2*t1;
      t12 = t9*t5;
      t14 = t2*s;
      t15 = t9*t9;
      t17 = t15*t5;
      t19 = t15*t9;
      t21 = t15*t12;
      t23 = t15*t15;
      t26 = r-2.0/25.0;
      t27 = t8*t5;
      t28 = t11*t9;
      t29 = t14*t12;
      t30 = t2*t15;
      t31 = t7*t17;
      t32 = t1*t19;
      t33 = s*t21;
      t36 = t3*s+30.0/7.0*t3*t5+54.0/7.0*t8*t9+144.0/19.0*t11*t12+84.0/19.0*t14
*t15+504.0/323.0*t2*t17+105.0/323.0*t7*t19+12.0/323.0*t1*t21+9.0/4522.0*s*t23+
t23*t5/29393+t26*(30.0/7.0*t3+108.0/7.0*t27+432.0/19.0*t28+336.0/19.0*t29+
2520.0/323.0*t30+630.0/323.0*t31+84.0/323.0*t32+36.0/2261.0*t33+9.0/29393.0*t23
);
      drv[0] = t36;
      drv[1] = t26*(9.0*t3+240.0/7.0*t27+54.0*t28+864.0/19.0*t29+420.0/19.0*t30
+2016.0/323.0*t31+315.0/323.0*t32+24.0/323.0*t33+9.0/4522.0*t23);
      drv[2] = 0.0;
   /* p=14 2 0 8 */
   } else if( i==2 && j==0 && k==8 ) {
      t2 = t*t;
      t3 = t2*t2;
      t4 = t3*t3;
      t5 = t2*t;
      t6 = t3*t5;
      t7 = s+r-1.0;
      t9 = t3*t2;
      t10 = t7*t7;
      t12 = t3*t;
      t13 = t10*t7;
      t15 = t10*t10;
      t17 = t15*t7;
      t19 = t15*t10;
      t21 = t15*t13;
      t23 = t15*t15;
      t26 = r*r;
      t27 = t26-6.0/25.0*r+1.0/100.0;
      t28 = t9*t7;
      t29 = t12*t10;
      t30 = t3*t13;
      t31 = t15*t5;
      t32 = t2*t17;
      t33 = t*t19;
      t35 = t27*(72.0/17.0*t6+252.0/17.0*t28+1764.0/85.0*t29+252.0/17.0*t30+
1260.0/221.0*t31+252.0/221.0*t32+252.0/2431.0*t33+36.0/12155.0*t21);
      drv[0] = (2.0*r-6.0/25.0)*(t4+72.0/17.0*t6*t7+126.0/17.0*t9*t10+588.0/
85.0*t12*t13+63.0/17.0*t3*t15+252.0/221.0*t5*t17+42.0/221.0*t2*t19+36.0/2431.0*
t*t21+9.0/24310.0*t23)+t35;
      drv[1] = t35;
      drv[2] = t27*(8.0*t6+504.0/17.0*t28+756.0/17.0*t29+588.0/17.0*t30+252.0/
17.0*t31+756.0/221.0*t32+84.0/221.0*t33+36.0/2431.0*t21);
   /* p=14 2 1 7 */
   } else if( i==2 && j==1 && k==7 ) {
      t2 = s+2.0/19.0*r-2.0/19.0;
      t4 = t*t;
      t5 = t4*t;
      t6 = t4*t4;
      t8 = t6*t4;
      t9 = s+r-1.0;
      t11 = t6*t;
      t12 = t9*t9;
      t14 = t12*t9;
      t16 = t12*t12;
      t18 = t16*t9;
      t20 = t16*t12;
      t23 = t5*t6+56.0/15.0*t8*t9+28.0/5.0*t11*t12+56.0/13.0*t6*t14+70.0/39.0*
t5*t16+56.0/143.0*t4*t18+28.0/715.0*t*t20+8.0/6435.0*t16*t14;
      t25 = r*r;
      t26 = t25-6.0/25.0*r+1.0/100.0;
      t27 = t26*t23;
      t28 = t26*t2;
      t29 = t11*t9;
      t30 = t6*t12;
      t31 = t5*t14;
      t32 = t4*t16;
      t33 = t*t18;
      t35 = t28*(56.0/15.0*t8+56.0/5.0*t29+168.0/13.0*t30+280.0/39.0*t31+280.0/
143.0*t32+168.0/715.0*t33+56.0/6435.0*t20);
      drv[0] = t2*(2.0*r-6.0/25.0)*t23+2.0/19.0*t27+t35;
      drv[1] = t27+t35;
      drv[2] = t28*(7.0*t8+112.0/5.0*t29+28.0*t30+224.0/13.0*t31+70.0/13.0*t32+
112.0/143.0*t33+28.0/715.0*t20);
   /* p=14 2 2 6 */
   } else if( i==2 && j==2 && k==6 ) {
      t2 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t6 = t2+6.0/19.0*s*t3+t5/57;
      t8 = t*t;
      t9 = t8*t8;
      t11 = t9*t;
      t12 = s+r-1.0;
      t14 = t12*t12;
      t16 = t8*t;
      t17 = t14*t12;
      t19 = t14*t14;
      t21 = t19*t12;
      t24 = t8*t9+42.0/13.0*t11*t12+105.0/26.0*t9*t14+350.0/143.0*t16*t17+105.0
/143.0*t8*t19+14.0/143.0*t*t21+7.0/1716.0*t19*t14;
      t26 = r*r;
      t27 = t26-6.0/25.0*r+1.0/100.0;
      t31 = t27*t6;
      t32 = t12*t9;
      t33 = t16*t14;
      t34 = t8*t17;
      t35 = t*t19;
      t37 = t31*(42.0/13.0*t11+105.0/13.0*t32+1050.0/143.0*t33+420.0/143.0*t34+
70.0/143.0*t35+7.0/286.0*t21);
      drv[0] = (2.0*r-6.0/25.0)*t6*t24+t27*(6.0/19.0*s+2.0/57.0*r-2.0/57.0)*t24
+t37;
      drv[1] = t27*(2.0*s+6.0/19.0*r-6.0/19.0)*t24+t37;
      drv[2] = t31*(6.0*t11+210.0/13.0*t32+210.0/13.0*t33+1050.0/143.0*t34+
210.0/143.0*t35+14.0/143.0*t21);
   /* p=14 2 3 5 */
   } else if( i==2 && j==3 && k==5 ) {
      t2 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t9 = t2*s+12.0/19.0*t4*t2+2.0/19.0*s*t6+4.0/969.0*t6*t4;
      t11 = t*t;
      t12 = t11*t11;
      t14 = s+r-1.0;
      t16 = t11*t;
      t17 = t14*t14;
      t19 = t17*t14;
      t21 = t17*t17;
      t24 = t12*t+30.0/11.0*t14*t12+30.0/11.0*t16*t17+40.0/33.0*t11*t19+5.0/
22.0*t*t21+t21*t14/77;
      t26 = r*r;
      t27 = t26-6.0/25.0*r+1.0/100.0;
      t28 = s*t4;
      t32 = t27*t9;
      t33 = t16*t14;
      t34 = t11*t17;
      t35 = t*t19;
      t37 = t32*(30.0/11.0*t12+60.0/11.0*t33+40.0/11.0*t34+10.0/11.0*t35+5.0/
77.0*t21);
      drv[0] = (2.0*r-6.0/25.0)*t9*t24+t27*(12.0/19.0*t2+4.0/19.0*t28+4.0/323.0
*t6)*t24+t37;
      drv[1] = t27*(3.0*t2+24.0/19.0*t28+2.0/19.0*t6)*t24+t37;
      drv[2] = t32*(5.0*t12+120.0/11.0*t33+90.0/11.0*t34+80.0/33.0*t35+5.0/22.0
*t21);
   /* p=14 2 4 4 */
   } else if( i==2 && j==4 && k==4 ) {
      t2 = s*s;
      t3 = t2*t2;
      t4 = t2*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t9 = t7*t5;
      t11 = t7*t7;
      t12 = t3+20.0/19.0*t4*t5+20.0/57.0*t2*t7+40.0/969.0*s*t9+5.0/3876.0*t11;
      t14 = t*t;
      t15 = t14*t14;
      t16 = t14*t;
      t17 = s+r-1.0;
      t19 = t17*t17;
      t21 = t19*t17;
      t23 = t19*t19;
      t24 = t15+20.0/9.0*t16*t17+5.0/3.0*t14*t19+10.0/21.0*t*t21+5.0/126.0*t23;
      t26 = r*r;
      t27 = t26-6.0/25.0*r+1.0/100.0;
      t28 = t2*t5;
      t29 = s*t7;
      t33 = t27*t12;
      t34 = t14*t17;
      t35 = t*t19;
      t37 = t33*(20.0/9.0*t16+10.0/3.0*t34+10.0/7.0*t35+10.0/63.0*t21);
      drv[0] = (2.0*r-6.0/25.0)*t12*t24+t27*(20.0/19.0*t4+40.0/57.0*t28+40.0/
323.0*t29+5.0/969.0*t9)*t24+t37;
      drv[1] = t27*(4.0*t4+60.0/19.0*t28+40.0/57.0*t29+40.0/969.0*t9)*t24+t37;
      drv[2] = t33*(4.0*t16+20.0/3.0*t34+10.0/3.0*t35+10.0/21.0*t21);
   /* p=14 2 5 3 */
   } else if( i==2 && j==5 && k==3 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = r-1.0;
      t7 = t2*s;
      t8 = t5*t5;
      t10 = t8*t5;
      t12 = t8*t8;
      t15 = t3*s+30.0/19.0*t3*t5+50.0/57.0*t7*t8+200.0/969.0*t2*t10+25.0/1292.0
*s*t12+t12*t5/1938;
      t17 = t*t;
      t19 = s+r-1.0;
      t21 = t19*t19;
      t24 = t17*t+12.0/7.0*t19*t17+6.0/7.0*t*t21+4.0/35.0*t21*t19;
      t26 = r*r;
      t27 = t26-6.0/25.0*r+1.0/100.0;
      t28 = t7*t5;
      t29 = t2*t8;
      t30 = s*t10;
      t34 = t27*t15;
      t35 = t*t19;
      t37 = t34*(12.0/7.0*t17+12.0/7.0*t35+12.0/35.0*t21);
      drv[0] = (2.0*r-6.0/25.0)*t15*t24+t27*(30.0/19.0*t3+100.0/57.0*t28+200.0/
323.0*t29+25.0/323.0*t30+5.0/1938.0*t12)*t24+t37;
      drv[1] = t27*(5.0*t3+120.0/19.0*t28+50.0/19.0*t29+400.0/969.0*t30+25.0/
1292.0*t12)*t24+t37;
      drv[2] = t34*(3.0*t17+24.0/7.0*t35+6.0/7.0*t21);
   /* p=14 2 6 2 */
   } else if( i==2 && j==6 && k==2 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = t3*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t10 = t2*s;
      t11 = t8*t6;
      t13 = t8*t8;
      t15 = t13*t6;
      t18 = t3*t2+42.0/19.0*t5*t6+35.0/19.0*t3*t8+700.0/969.0*t10*t11+175.0/
1292.0*t2*t13+7.0/646.0*s*t15+t13*t8/3876;
      t20 = t*t;
      t21 = s+r-1.0;
      t23 = t21*t21;
      t24 = t20+6.0/5.0*t*t21+3.0/10.0*t23;
      t26 = r*r;
      t27 = t26-6.0/25.0*r+1.0/100.0;
      t28 = t3*t6;
      t29 = t10*t8;
      t30 = t2*t11;
      t31 = s*t13;
      t35 = t27*t18;
      t37 = t35*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (2.0*r-6.0/25.0)*t18*t24+t27*(42.0/19.0*t5+70.0/19.0*t28+700.0/
323.0*t29+175.0/323.0*t30+35.0/646.0*t31+t15/646)*t24+t37;
      drv[1] = t27*(6.0*t5+210.0/19.0*t28+140.0/19.0*t29+700.0/323.0*t30+175.0/
646.0*t31+7.0/646.0*t15)*t24+t37;
      drv[2] = t35*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=14 2 7 1 */
   } else if( i==2 && j==7 && k==1 ) {
      t2 = s*s;
      t3 = t2*s;
      t4 = t2*t2;
      t6 = t4*t2;
      t7 = r-1.0;
      t9 = t4*s;
      t10 = t7*t7;
      t12 = t10*t7;
      t14 = t10*t10;
      t16 = t14*t7;
      t18 = t14*t10;
      t21 = t4*t3+56.0/19.0*t6*t7+196.0/57.0*t9*t10+1960.0/969.0*t4*t12+1225.0/
1938.0*t3*t14+98.0/969.0*t2*t16+7.0/969.0*s*t18+2.0/12597.0*t14*t12;
      t23 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t25 = r*r;
      t26 = t25-6.0/25.0*r+1.0/100.0;
      t27 = t9*t7;
      t28 = t4*t10;
      t29 = t3*t12;
      t30 = t2*t14;
      t31 = s*t16;
      t35 = t26*t21;
      drv[0] = (2.0*r-6.0/25.0)*t21*t23+t26*(56.0/19.0*t6+392.0/57.0*t27+1960.0
/323.0*t28+2450.0/969.0*t29+490.0/969.0*t30+14.0/323.0*t31+14.0/12597.0*t18)*
t23+2.0/3.0*t35;
      drv[1] = t26*(7.0*t6+336.0/19.0*t27+980.0/57.0*t28+7840.0/969.0*t29+
1225.0/646.0*t30+196.0/969.0*t31+7.0/969.0*t18)*t23+2.0/3.0*t35;
      drv[2] = t35;
   /* p=14 2 8 0 */
   } else if( i==2 && j==8 && k==0 ) {
      t2 = s*s;
      t3 = t2*t2;
      t4 = t3*t3;
      t5 = t2*s;
      t6 = t3*t5;
      t7 = r-1.0;
      t9 = t3*t2;
      t10 = t7*t7;
      t12 = t3*s;
      t13 = t10*t7;
      t15 = t10*t10;
      t17 = t15*t7;
      t19 = t15*t10;
      t21 = t15*t13;
      t23 = t15*t15;
      t26 = r*r;
      t27 = t26-6.0/25.0*r+1.0/100.0;
      t28 = t9*t7;
      t29 = t12*t10;
      t30 = t3*t13;
      t31 = t5*t15;
      t32 = t2*t17;
      t33 = s*t19;
      drv[0] = (2.0*r-6.0/25.0)*(t4+72.0/19.0*t6*t7+112.0/19.0*t9*t10+1568.0/
323.0*t12*t13+735.0/323.0*t3*t15+196.0/323.0*t5*t17+28.0/323.0*t2*t19+24.0/
4199.0*s*t21+t23/8398)+t27*(72.0/19.0*t6+224.0/19.0*t28+4704.0/323.0*t29+2940.0
/323.0*t30+980.0/323.0*t31+168.0/323.0*t32+168.0/4199.0*t33+4.0/4199.0*t21);
      drv[1] = t27*(8.0*t6+504.0/19.0*t28+672.0/19.0*t29+7840.0/323.0*t30+
2940.0/323.0*t31+588.0/323.0*t32+56.0/323.0*t33+24.0/4199.0*t21);
      drv[2] = 0.0;
   /* p=14 3 0 7 */
   } else if( i==3 && j==0 && k==7 ) {
      t1 = r*r;
      t3 = t*t;
      t4 = t3*t;
      t5 = t3*t3;
      t7 = t3*t5;
      t8 = s+r-1.0;
      t10 = t5*t;
      t11 = t8*t8;
      t13 = t11*t8;
      t15 = t11*t11;
      t17 = t15*t8;
      t19 = t15*t11;
      t25 = t1*r-12.0/25.0*t1+3.0/50.0*r-1.0/575.0;
      t26 = t10*t8;
      t27 = t5*t11;
      t28 = t4*t13;
      t29 = t3*t15;
      t30 = t*t17;
      t32 = t25*(56.0/15.0*t7+56.0/5.0*t26+168.0/13.0*t27+280.0/39.0*t28+280.0/
143.0*t29+168.0/715.0*t30+56.0/6435.0*t19);
      drv[0] = (3.0*t1-24.0/25.0*r+3.0/50.0)*(t5*t4+56.0/15.0*t7*t8+28.0/5.0*
t10*t11+56.0/13.0*t5*t13+70.0/39.0*t4*t15+56.0/143.0*t3*t17+28.0/715.0*t*t19+
8.0/6435.0*t15*t13)+t32;
      drv[1] = t32;
      drv[2] = t25*(7.0*t7+112.0/5.0*t26+28.0*t27+224.0/13.0*t28+70.0/13.0*t29+
112.0/143.0*t30+28.0/715.0*t19);
   /* p=14 3 1 6 */
   } else if( i==3 && j==1 && k==6 ) {
      t1 = r*r;
      t3 = s+2.0/17.0*r-2.0/17.0;
      t5 = t*t;
      t6 = t5*t5;
      t8 = t6*t;
      t9 = s+r-1.0;
      t11 = t9*t9;
      t13 = t5*t;
      t14 = t11*t9;
      t16 = t11*t11;
      t18 = t16*t9;
      t21 = t6*t5+42.0/13.0*t8*t9+105.0/26.0*t6*t11+350.0/143.0*t13*t14+105.0/
143.0*t5*t16+14.0/143.0*t*t18+7.0/1716.0*t16*t11;
      t24 = t1*r-12.0/25.0*t1+3.0/50.0*r-1.0/575.0;
      t25 = t24*t21;
      t26 = t24*t3;
      t27 = t6*t9;
      t28 = t13*t11;
      t29 = t5*t14;
      t30 = t*t16;
      t32 = t26*(42.0/13.0*t8+105.0/13.0*t27+1050.0/143.0*t28+420.0/143.0*t29+
70.0/143.0*t30+7.0/286.0*t18);
      drv[0] = t3*(3.0*t1-24.0/25.0*r+3.0/50.0)*t21+2.0/17.0*t25+t32;
      drv[1] = t25+t32;
      drv[2] = t26*(6.0*t8+210.0/13.0*t27+210.0/13.0*t28+1050.0/143.0*t29+210.0
/143.0*t30+14.0/143.0*t18);
   /* p=14 3 2 5 */
   } else if( i==3 && j==2 && k==5 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t7 = t3+6.0/17.0*s*t4+3.0/136.0*t6;
      t9 = t*t;
      t10 = t9*t9;
      t12 = s+r-1.0;
      t14 = t9*t;
      t15 = t12*t12;
      t17 = t15*t12;
      t19 = t15*t15;
      t22 = t10*t+30.0/11.0*t10*t12+30.0/11.0*t14*t15+40.0/33.0*t9*t17+5.0/22.0
*t*t19+t19*t12/77;
      t25 = t1*r-12.0/25.0*t1+3.0/50.0*r-1.0/575.0;
      t29 = t25*t7;
      t30 = t14*t12;
      t31 = t9*t15;
      t32 = t*t17;
      t34 = t29*(30.0/11.0*t10+60.0/11.0*t30+40.0/11.0*t31+10.0/11.0*t32+5.0/
77.0*t19);
      drv[0] = (3.0*t1-24.0/25.0*r+3.0/50.0)*t7*t22+t25*(6.0/17.0*s+3.0/68.0*r
-3.0/68.0)*t22+t34;
      drv[1] = t25*(2.0*s+6.0/17.0*r-6.0/17.0)*t22+t34;
      drv[2] = t29*(5.0*t10+120.0/11.0*t30+90.0/11.0*t31+80.0/33.0*t32+5.0/22.0
*t19);
   /* p=14 3 3 4 */
   } else if( i==3 && j==3 && k==4 ) {
      t1 = r*r;
      t3 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t10 = t3*s+12.0/17.0*t3*t5+9.0/68.0*s*t7+t7*t5/170;
      t12 = t*t;
      t13 = t12*t12;
      t14 = t12*t;
      t15 = s+r-1.0;
      t17 = t15*t15;
      t19 = t17*t15;
      t21 = t17*t17;
      t22 = t13+20.0/9.0*t14*t15+5.0/3.0*t12*t17+10.0/21.0*t*t19+5.0/126.0*t21;
      t25 = t1*r-12.0/25.0*t1+3.0/50.0*r-1.0/575.0;
      t26 = s*t5;
      t30 = t25*t10;
      t31 = t15*t12;
      t32 = t*t17;
      t34 = t30*(20.0/9.0*t14+10.0/3.0*t31+10.0/7.0*t32+10.0/63.0*t19);
      drv[0] = (3.0*t1-24.0/25.0*r+3.0/50.0)*t10*t22+t25*(12.0/17.0*t3+9.0/34.0
*t26+3.0/170.0*t7)*t22+t34;
      drv[1] = t25*(3.0*t3+24.0/17.0*t26+9.0/68.0*t7)*t22+t34;
      drv[2] = t30*(4.0*t14+20.0/3.0*t31+10.0/3.0*t32+10.0/21.0*t19);
   /* p=14 3 4 3 */
   } else if( i==3 && j==4 && k==3 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t5 = t3*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t10 = t8*t6;
      t12 = t8*t8;
      t13 = t4+20.0/17.0*t5*t6+15.0/34.0*t3*t8+s*t10/17+t12/476;
      t15 = t*t;
      t17 = s+r-1.0;
      t19 = t17*t17;
      t22 = t15*t+12.0/7.0*t17*t15+6.0/7.0*t*t19+4.0/35.0*t19*t17;
      t25 = t1*r-12.0/25.0*t1+3.0/50.0*r-1.0/575.0;
      t26 = t3*t6;
      t27 = s*t8;
      t31 = t25*t13;
      t32 = t*t17;
      t34 = t31*(12.0/7.0*t15+12.0/7.0*t32+12.0/35.0*t19);
      drv[0] = (3.0*t1-24.0/25.0*r+3.0/50.0)*t13*t22+t25*(20.0/17.0*t5+15.0/
17.0*t26+3.0/17.0*t27+t10/119)*t22+t34;
      drv[1] = t25*(4.0*t5+60.0/17.0*t26+15.0/17.0*t27+t10/17)*t22+t34;
      drv[2] = t31*(3.0*t15+24.0/7.0*t32+6.0/7.0*t19);
   /* p=14 3 5 2 */
   } else if( i==3 && j==5 && k==2 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t6 = r-1.0;
      t8 = t3*s;
      t9 = t6*t6;
      t11 = t9*t6;
      t13 = t9*t9;
      t16 = t4*s+30.0/17.0*t4*t6+75.0/68.0*t8*t9+5.0/17.0*t3*t11+15.0/476.0*s*
t13+3.0/3094.0*t13*t6;
      t18 = t*t;
      t19 = s+r-1.0;
      t21 = t19*t19;
      t22 = t18+6.0/5.0*t*t19+3.0/10.0*t21;
      t25 = t1*r-12.0/25.0*t1+3.0/50.0*r-1.0/575.0;
      t26 = t8*t6;
      t27 = t3*t9;
      t28 = s*t11;
      t32 = t25*t16;
      t34 = t32*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (3.0*t1-24.0/25.0*r+3.0/50.0)*t16*t22+t25*(30.0/17.0*t4+75.0/
34.0*t26+15.0/17.0*t27+15.0/119.0*t28+15.0/3094.0*t13)*t22+t34;
      drv[1] = t25*(5.0*t4+120.0/17.0*t26+225.0/68.0*t27+10.0/17.0*t28+15.0/
476.0*t13)*t22+t34;
      drv[2] = t32*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=14 3 6 1 */
   } else if( i==3 && j==6 && k==1 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t6 = t4*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t11 = t3*s;
      t12 = t9*t7;
      t14 = t9*t9;
      t16 = t14*t7;
      t19 = t4*t3+42.0/17.0*t6*t7+315.0/136.0*t4*t9+35.0/34.0*t11*t12+15.0/68.0
*t3*t14+9.0/442.0*s*t16+t14*t9/1768;
      t21 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t24 = t1*r-12.0/25.0*t1+3.0/50.0*r-1.0/575.0;
      t25 = t4*t7;
      t26 = t11*t9;
      t27 = t3*t12;
      t28 = s*t14;
      t32 = t24*t19;
      drv[0] = (3.0*t1-24.0/25.0*r+3.0/50.0)*t19*t21+t24*(42.0/17.0*t6+315.0/
68.0*t25+105.0/34.0*t26+15.0/17.0*t27+45.0/442.0*t28+3.0/884.0*t16)*t21+2.0/3.0
*t32;
      drv[1] = t24*(6.0*t6+210.0/17.0*t25+315.0/34.0*t26+105.0/34.0*t27+15.0/
34.0*t28+9.0/442.0*t16)*t21+2.0/3.0*t32;
      drv[2] = t32;
   /* p=14 3 7 0 */
   } else if( i==3 && j==7 && k==0 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*s;
      t5 = t3*t3;
      t7 = t5*t3;
      t8 = r-1.0;
      t10 = t5*s;
      t11 = t8*t8;
      t13 = t11*t8;
      t15 = t11*t11;
      t17 = t15*t8;
      t19 = t15*t11;
      t25 = t1*r-12.0/25.0*t1+3.0/50.0*r-1.0/575.0;
      t26 = t10*t8;
      t27 = t5*t11;
      t28 = t4*t13;
      t29 = t3*t15;
      t30 = s*t17;
      drv[0] = (3.0*t1-24.0/25.0*r+3.0/50.0)*(t5*t4+56.0/17.0*t7*t8+147.0/34.0*
t10*t11+49.0/17.0*t5*t13+35.0/34.0*t4*t15+42.0/221.0*t3*t17+7.0/442.0*s*t19+t15
*t13/2431)+t25*(56.0/17.0*t7+147.0/17.0*t26+147.0/17.0*t27+70.0/17.0*t28+210.0/
221.0*t29+21.0/221.0*t30+7.0/2431.0*t19);
      drv[1] = t25*(7.0*t7+336.0/17.0*t26+735.0/34.0*t27+196.0/17.0*t28+105.0/
34.0*t29+84.0/221.0*t30+7.0/442.0*t19);
      drv[2] = 0.0;
   /* p=14 4 0 6 */
   } else if( i==4 && j==0 && k==6 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = t*t;
      t5 = t4*t4;
      t7 = t5*t;
      t8 = s+r-1.0;
      t10 = t8*t8;
      t12 = t4*t;
      t13 = t10*t8;
      t15 = t10*t10;
      t17 = t15*t8;
      t22 = t1*t1;
      t23 = t22-4.0/5.0*t2+t1/5-2.0/115.0*r+1.0/2530.0;
      t24 = t5*t8;
      t25 = t12*t10;
      t26 = t4*t13;
      t27 = t*t15;
      t29 = t23*(42.0/13.0*t7+105.0/13.0*t24+1050.0/143.0*t25+420.0/143.0*t26+
70.0/143.0*t27+7.0/286.0*t17);
      drv[0] = (4.0*t2-12.0/5.0*t1+2.0/5.0*r-2.0/115.0)*(t5*t4+42.0/13.0*t7*t8+
105.0/26.0*t5*t10+350.0/143.0*t12*t13+105.0/143.0*t4*t15+14.0/143.0*t*t17+7.0/
1716.0*t15*t10)+t29;
      drv[1] = t29;
      drv[2] = t23*(6.0*t7+210.0/13.0*t24+210.0/13.0*t25+1050.0/143.0*t26+210.0
/143.0*t27+14.0/143.0*t17);
   /* p=14 4 1 5 */
   } else if( i==4 && j==1 && k==5 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s+2.0/15.0*r-2.0/15.0;
      t6 = t*t;
      t7 = t6*t6;
      t9 = s+r-1.0;
      t11 = t6*t;
      t12 = t9*t9;
      t14 = t12*t9;
      t16 = t12*t12;
      t19 = t7*t+30.0/11.0*t9*t7+30.0/11.0*t11*t12+40.0/33.0*t6*t14+5.0/22.0*t*
t16+t16*t9/77;
      t21 = t1*t1;
      t22 = t21-4.0/5.0*t2+t1/5-2.0/115.0*r+1.0/2530.0;
      t23 = t22*t19;
      t24 = t22*t4;
      t25 = t11*t9;
      t26 = t6*t12;
      t27 = t*t14;
      t29 = t24*(30.0/11.0*t7+60.0/11.0*t25+40.0/11.0*t26+10.0/11.0*t27+5.0/
77.0*t16);
      drv[0] = t4*(4.0*t2-12.0/5.0*t1+2.0/5.0*r-2.0/115.0)*t19+2.0/15.0*t23+t29
;
      drv[1] = t23+t29;
      drv[2] = t24*(5.0*t7+120.0/11.0*t25+90.0/11.0*t26+80.0/33.0*t27+5.0/22.0*
t16);
   /* p=14 4 2 4 */
   } else if( i==4 && j==2 && k==4 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t8 = t4+2.0/5.0*s*t5+t7/35;
      t10 = t*t;
      t11 = t10*t10;
      t12 = t10*t;
      t13 = s+r-1.0;
      t15 = t13*t13;
      t17 = t15*t13;
      t19 = t15*t15;
      t20 = t11+20.0/9.0*t12*t13+5.0/3.0*t10*t15+10.0/21.0*t*t17+5.0/126.0*t19;
      t22 = t1*t1;
      t23 = t22-4.0/5.0*t2+t1/5-2.0/115.0*r+1.0/2530.0;
      t27 = t23*t8;
      t28 = t10*t13;
      t29 = t*t15;
      t31 = t27*(20.0/9.0*t12+10.0/3.0*t28+10.0/7.0*t29+10.0/63.0*t17);
      drv[0] = (4.0*t2-12.0/5.0*t1+2.0/5.0*r-2.0/115.0)*t8*t20+t23*(2.0/5.0*s+
2.0/35.0*r-2.0/35.0)*t20+t31;
      drv[1] = t23*(2.0*s+2.0/5.0*r-2.0/5.0)*t20+t31;
      drv[2] = t27*(4.0*t12+20.0/3.0*t28+10.0/3.0*t29+10.0/21.0*t17);
   /* p=14 4 3 3 */
   } else if( i==4 && j==3 && k==3 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t11 = t4*s+4.0/5.0*t4*t6+6.0/35.0*s*t8+4.0/455.0*t8*t6;
      t13 = t*t;
      t15 = s+r-1.0;
      t17 = t15*t15;
      t20 = t13*t+12.0/7.0*t15*t13+6.0/7.0*t*t17+4.0/35.0*t17*t15;
      t22 = t1*t1;
      t23 = t22-4.0/5.0*t2+t1/5-2.0/115.0*r+1.0/2530.0;
      t24 = s*t6;
      t28 = t23*t11;
      t29 = t*t15;
      t31 = t28*(12.0/7.0*t13+12.0/7.0*t29+12.0/35.0*t17);
      drv[0] = (4.0*t2-12.0/5.0*t1+2.0/5.0*r-2.0/115.0)*t11*t20+t23*(4.0/5.0*t4
+12.0/35.0*t24+12.0/455.0*t8)*t20+t31;
      drv[1] = t23*(3.0*t4+8.0/5.0*t24+6.0/35.0*t8)*t20+t31;
      drv[2] = t28*(3.0*t13+24.0/7.0*t29+6.0/7.0*t17);
   /* p=14 4 4 2 */
   } else if( i==4 && j==4 && k==2 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t5 = t4*t4;
      t6 = t4*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t11 = t9*t7;
      t13 = t9*t9;
      t14 = t5+4.0/3.0*t6*t7+4.0/7.0*t4*t9+8.0/91.0*s*t11+t13/273;
      t16 = t*t;
      t17 = s+r-1.0;
      t19 = t17*t17;
      t20 = t16+6.0/5.0*t*t17+3.0/10.0*t19;
      t22 = t1*t1;
      t23 = t22-4.0/5.0*t2+t1/5-2.0/115.0*r+1.0/2530.0;
      t24 = t4*t7;
      t25 = s*t9;
      t29 = t23*t14;
      t31 = t29*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (4.0*t2-12.0/5.0*t1+2.0/5.0*r-2.0/115.0)*t14*t20+t23*(4.0/3.0*t6
+8.0/7.0*t24+24.0/91.0*t25+4.0/273.0*t11)*t20+t31;
      drv[1] = t23*(4.0*t6+4.0*t24+8.0/7.0*t25+8.0/91.0*t11)*t20+t31;
      drv[2] = t29*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=14 4 5 1 */
   } else if( i==4 && j==5 && k==1 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t5 = t4*t4;
      t7 = r-1.0;
      t9 = t4*s;
      t10 = t7*t7;
      t12 = t10*t7;
      t14 = t10*t10;
      t17 = t5*s+2.0*t5*t7+10.0/7.0*t9*t10+40.0/91.0*t4*t12+5.0/91.0*s*t14+2.0/
1001.0*t14*t7;
      t19 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t21 = t1*t1;
      t22 = t21-4.0/5.0*t2+t1/5-2.0/115.0*r+1.0/2530.0;
      t23 = t9*t7;
      t24 = t4*t10;
      t25 = s*t12;
      t29 = t22*t17;
      drv[0] = (4.0*t2-12.0/5.0*t1+2.0/5.0*r-2.0/115.0)*t17*t19+t22*(2.0*t5+
20.0/7.0*t23+120.0/91.0*t24+20.0/91.0*t25+10.0/1001.0*t14)*t19+2.0/3.0*t29;
      drv[1] = t22*(5.0*t5+8.0*t23+30.0/7.0*t24+80.0/91.0*t25+5.0/91.0*t14)*t19
+2.0/3.0*t29;
      drv[2] = t29;
   /* p=14 4 6 0 */
   } else if( i==4 && j==6 && k==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t5 = t4*t4;
      t7 = t5*s;
      t8 = r-1.0;
      t10 = t8*t8;
      t12 = t4*s;
      t13 = t10*t8;
      t15 = t10*t10;
      t17 = t15*t8;
      t22 = t1*t1;
      t23 = t22-4.0/5.0*t2+t1/5-2.0/115.0*r+1.0/2530.0;
      t24 = t5*t8;
      t25 = t12*t10;
      t26 = t4*t13;
      t27 = s*t15;
      drv[0] = (4.0*t2-12.0/5.0*t1+2.0/5.0*r-2.0/115.0)*(t5*t4+14.0/5.0*t7*t8+
3.0*t5*t10+20.0/13.0*t12*t13+5.0/13.0*t4*t15+6.0/143.0*s*t17+t15*t10/715)+t23*(
14.0/5.0*t7+6.0*t24+60.0/13.0*t25+20.0/13.0*t26+30.0/143.0*t27+6.0/715.0*t17);
      drv[1] = t23*(6.0*t7+14.0*t24+12.0*t25+60.0/13.0*t26+10.0/13.0*t27+6.0/
143.0*t17);
      drv[2] = 0.0;
   /* p=14 5 0 5 */
   } else if( i==5 && j==0 && k==5 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = t*t;
      t6 = t5*t5;
      t8 = s+r-1.0;
      t10 = t5*t;
      t11 = t8*t8;
      t13 = t11*t8;
      t15 = t11*t11;
      t21 = t2*r-6.0/5.0*t2+t3/2-2.0/23.0*t1+3.0/506.0*r-1.0/8855.0;
      t22 = t10*t8;
      t23 = t5*t11;
      t24 = t*t13;
      t26 = t21*(30.0/11.0*t6+60.0/11.0*t22+40.0/11.0*t23+10.0/11.0*t24+5.0/
77.0*t15);
      drv[0] = (5.0*t2-24.0/5.0*t3+3.0/2.0*t1-4.0/23.0*r+3.0/506.0)*(t6*t+30.0/
11.0*t6*t8+30.0/11.0*t10*t11+40.0/33.0*t5*t13+5.0/22.0*t*t15+t15*t8/77)+t26;
      drv[1] = t26;
      drv[2] = t21*(5.0*t6+120.0/11.0*t22+90.0/11.0*t23+80.0/33.0*t24+5.0/22.0*
t15);
   /* p=14 5 1 4 */
   } else if( i==5 && j==1 && k==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s+2.0/13.0*r-2.0/13.0;
      t7 = t*t;
      t8 = t7*t7;
      t9 = t7*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      t14 = t12*t10;
      t16 = t12*t12;
      t17 = t8+20.0/9.0*t9*t10+5.0/3.0*t7*t12+10.0/21.0*t*t14+5.0/126.0*t16;
      t20 = t2*r-6.0/5.0*t2+t3/2-2.0/23.0*t1+3.0/506.0*r-1.0/8855.0;
      t21 = t20*t17;
      t22 = t20*t5;
      t23 = t7*t10;
      t24 = t*t12;
      t26 = t22*(20.0/9.0*t9+10.0/3.0*t23+10.0/7.0*t24+10.0/63.0*t14);
      drv[0] = (5.0*t2-24.0/5.0*t3+3.0/2.0*t1-4.0/23.0*r+3.0/506.0)*t5*t17+2.0/
13.0*t21+t26;
      drv[1] = t21+t26;
      drv[2] = t22*(4.0*t9+20.0/3.0*t23+10.0/3.0*t24+10.0/21.0*t14);
   /* p=14 5 2 3 */
   } else if( i==5 && j==2 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t9 = t5+6.0/13.0*s*t6+t8/26;
      t11 = t*t;
      t13 = s+r-1.0;
      t15 = t13*t13;
      t18 = t11*t+12.0/7.0*t11*t13+6.0/7.0*t*t15+4.0/35.0*t15*t13;
      t21 = t2*r-6.0/5.0*t2+t3/2-2.0/23.0*t1+3.0/506.0*r-1.0/8855.0;
      t25 = t21*t9;
      t26 = t*t13;
      t28 = t25*(12.0/7.0*t11+12.0/7.0*t26+12.0/35.0*t15);
      drv[0] = (5.0*t2-24.0/5.0*t3+3.0/2.0*t1-4.0/23.0*r+3.0/506.0)*t9*t18+t21*
(6.0/13.0*s+r/13-1.0/13.0)*t18+t28;
      drv[1] = t21*(2.0*s+6.0/13.0*r-6.0/13.0)*t18+t28;
      drv[2] = t25*(3.0*t11+24.0/7.0*t26+6.0/7.0*t15);
   /* p=14 5 3 2 */
   } else if( i==5 && j==3 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t12 = t5*s+12.0/13.0*t5*t7+3.0/13.0*s*t9+2.0/143.0*t9*t7;
      t14 = t*t;
      t15 = s+r-1.0;
      t17 = t15*t15;
      t18 = t14+6.0/5.0*t*t15+3.0/10.0*t17;
      t21 = t2*r-6.0/5.0*t2+t3/2-2.0/23.0*t1+3.0/506.0*r-1.0/8855.0;
      t22 = s*t7;
      t26 = t21*t12;
      t28 = t26*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (5.0*t2-24.0/5.0*t3+3.0/2.0*t1-4.0/23.0*r+3.0/506.0)*t12*t18+t21
*(12.0/13.0*t5+6.0/13.0*t22+6.0/143.0*t9)*t18+t28;
      drv[1] = t21*(3.0*t5+24.0/13.0*t22+3.0/13.0*t9)*t18+t28;
      drv[2] = t26*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=14 5 4 1 */
   } else if( i==5 && j==4 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s*s;
      t6 = t5*t5;
      t7 = t5*s;
      t8 = r-1.0;
      t10 = t8*t8;
      t12 = t10*t8;
      t14 = t10*t10;
      t15 = t6+20.0/13.0*t7*t8+10.0/13.0*t5*t10+20.0/143.0*s*t12+t14/143;
      t17 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t20 = t2*r-6.0/5.0*t2+t3/2-2.0/23.0*t1+3.0/506.0*r-1.0/8855.0;
      t21 = t5*t8;
      t22 = s*t10;
      t26 = t20*t15;
      drv[0] = (5.0*t2-24.0/5.0*t3+3.0/2.0*t1-4.0/23.0*r+3.0/506.0)*t15*t17+t20
*(20.0/13.0*t7+20.0/13.0*t21+60.0/143.0*t22+4.0/143.0*t12)*t17+2.0/3.0*t26;
      drv[1] = t20*(4.0*t7+60.0/13.0*t21+20.0/13.0*t22+20.0/143.0*t12)*t17+2.0/
3.0*t26;
      drv[2] = t26;
   /* p=14 5 5 0 */
   } else if( i==5 && j==5 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s*s;
      t6 = t5*t5;
      t8 = r-1.0;
      t10 = t5*s;
      t11 = t8*t8;
      t13 = t11*t8;
      t15 = t11*t11;
      t21 = t2*r-6.0/5.0*t2+t3/2-2.0/23.0*t1+3.0/506.0*r-1.0/8855.0;
      t22 = t10*t8;
      t23 = t5*t11;
      t24 = s*t13;
      drv[0] = (5.0*t2-24.0/5.0*t3+3.0/2.0*t1-4.0/23.0*r+3.0/506.0)*(t6*s+30.0/
13.0*t6*t8+25.0/13.0*t10*t11+100.0/143.0*t5*t13+15.0/143.0*s*t15+2.0/429.0*t15*
t8)+t21*(30.0/13.0*t6+50.0/13.0*t22+300.0/143.0*t23+60.0/143.0*t24+10.0/429.0*
t15);
      drv[1] = t21*(5.0*t6+120.0/13.0*t22+75.0/13.0*t23+200.0/143.0*t24+15.0/
143.0*t15);
      drv[2] = 0.0;
   /* p=14 6 0 4 */
   } else if( i==6 && j==0 && k==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t6 = t*t;
      t7 = t6*t6;
      t8 = t6*t;
      t9 = s+r-1.0;
      t11 = t9*t9;
      t13 = t11*t9;
      t15 = t11*t11;
      t19 = t2*t1-42.0/25.0*t3+21.0/20.0*t2-7.0/23.0*t4+21.0/506.0*t1-3.0/
1265.0*r+1.0/25300.0;
      t20 = t6*t9;
      t21 = t*t11;
      t23 = t19*(20.0/9.0*t8+10.0/3.0*t20+10.0/7.0*t21+10.0/63.0*t13);
      drv[0] = (6.0*t3-42.0/5.0*t2+21.0/5.0*t4-21.0/23.0*t1+21.0/253.0*r-3.0/
1265.0)*(t7+20.0/9.0*t8*t9+5.0/3.0*t6*t11+10.0/21.0*t*t13+5.0/126.0*t15)+t23;
      drv[1] = t23;
      drv[2] = t19*(4.0*t8+20.0/3.0*t20+10.0/3.0*t21+10.0/21.0*t13);
   /* p=14 6 1 3 */
   } else if( i==6 && j==1 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t6 = s+2.0/11.0*r-2.0/11.0;
      t8 = t*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      t15 = t8*t+12.0/7.0*t10*t8+6.0/7.0*t*t12+4.0/35.0*t12*t10;
      t18 = t2*t1-42.0/25.0*t3+21.0/20.0*t2-7.0/23.0*t4+21.0/506.0*t1-3.0/
1265.0*r+1.0/25300.0;
      t19 = t18*t15;
      t20 = t18*t6;
      t21 = t*t10;
      t23 = t20*(12.0/7.0*t8+12.0/7.0*t21+12.0/35.0*t12);
      drv[0] = (6.0*t3-42.0/5.0*t2+21.0/5.0*t4-21.0/23.0*t1+21.0/253.0*r-3.0/
1265.0)*t6*t15+2.0/11.0*t19+t23;
      drv[1] = t19+t23;
      drv[2] = t20*(3.0*t8+24.0/7.0*t21+6.0/7.0*t12);
   /* p=14 6 2 2 */
   } else if( i==6 && j==2 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t6 = s*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t10 = t6+6.0/11.0*s*t7+3.0/55.0*t9;
      t12 = t*t;
      t13 = s+r-1.0;
      t15 = t13*t13;
      t16 = t12+6.0/5.0*t*t13+3.0/10.0*t15;
      t19 = t2*t1-42.0/25.0*t3+21.0/20.0*t2-7.0/23.0*t4+21.0/506.0*t1-3.0/
1265.0*r+1.0/25300.0;
      t23 = t19*t10;
      t25 = t23*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (6.0*t3-42.0/5.0*t2+21.0/5.0*t4-21.0/23.0*t1+21.0/253.0*r-3.0/
1265.0)*t10*t16+t19*(6.0/11.0*s+6.0/55.0*r-6.0/55.0)*t16+t25;
      drv[1] = t19*(2.0*s+6.0/11.0*r-6.0/11.0)*t16+t25;
      drv[2] = t23*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=14 6 3 1 */
   } else if( i==6 && j==3 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t6 = s*s;
      t8 = r-1.0;
      t10 = t8*t8;
      t13 = t6*s+12.0/11.0*t6*t8+18.0/55.0*s*t10+4.0/165.0*t10*t8;
      t15 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t18 = t2*t1-42.0/25.0*t3+21.0/20.0*t2-7.0/23.0*t4+21.0/506.0*t1-3.0/
1265.0*r+1.0/25300.0;
      t19 = s*t8;
      t23 = t18*t13;
      drv[0] = (6.0*t3-42.0/5.0*t2+21.0/5.0*t4-21.0/23.0*t1+21.0/253.0*r-3.0/
1265.0)*t13*t15+t18*(12.0/11.0*t6+36.0/55.0*t19+4.0/55.0*t10)*t15+2.0/3.0*t23;
      drv[1] = t18*(3.0*t6+24.0/11.0*t19+18.0/55.0*t10)*t15+2.0/3.0*t23;
      drv[2] = t23;
   /* p=14 6 4 0 */
   } else if( i==6 && j==4 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t6 = s*s;
      t7 = t6*t6;
      t8 = t6*s;
      t9 = r-1.0;
      t11 = t9*t9;
      t13 = t11*t9;
      t15 = t11*t11;
      t19 = t2*t1-42.0/25.0*t3+21.0/20.0*t2-7.0/23.0*t4+21.0/506.0*t1-3.0/
1265.0*r+1.0/25300.0;
      t20 = t6*t9;
      t21 = s*t11;
      drv[0] = (6.0*t3-42.0/5.0*t2+21.0/5.0*t4-21.0/23.0*t1+21.0/253.0*r-3.0/
1265.0)*(t7+20.0/11.0*t8*t9+12.0/11.0*t6*t11+8.0/33.0*s*t13+t15/66)+t19*(20.0/
11.0*t8+24.0/11.0*t20+8.0/11.0*t21+2.0/33.0*t13);
      drv[1] = t19*(4.0*t8+60.0/11.0*t20+24.0/11.0*t21+8.0/33.0*t13);
      drv[2] = 0.0;
   /* p=14 7 0 3 */
   } else if( i==7 && j==0 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t2*r;
      t5 = t1*r;
      t7 = t*t;
      t9 = s+r-1.0;
      t11 = t9*t9;
      t17 = t2*t5-56.0/25.0*t3+49.0/25.0*t4-98.0/115.0*t2+49.0/253.0*t5-28.0/
1265.0*t1+7.0/6325.0*r-2.0/120175.0;
      t18 = t*t9;
      t20 = t17*(12.0/7.0*t7+12.0/7.0*t18+12.0/35.0*t11);
      drv[0] = (7.0*t3-336.0/25.0*t4+49.0/5.0*t2-392.0/115.0*t5+147.0/253.0*t1
-56.0/1265.0*r+7.0/6325.0)*(t7*t+12.0/7.0*t7*t9+6.0/7.0*t*t11+4.0/35.0*t11*t9)+
t20;
      drv[1] = t20;
      drv[2] = t17*(3.0*t7+24.0/7.0*t18+6.0/7.0*t11);
   /* p=14 7 1 2 */
   } else if( i==7 && j==1 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t2*r;
      t5 = t1*r;
      t7 = s+2.0/9.0*r-2.0/9.0;
      t9 = t*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      t13 = t9+6.0/5.0*t*t10+3.0/10.0*t12;
      t16 = t2*t5-56.0/25.0*t3+49.0/25.0*t4-98.0/115.0*t2+49.0/253.0*t5-28.0/
1265.0*t1+7.0/6325.0*r-2.0/120175.0;
      t17 = t16*t13;
      t18 = t16*t7;
      t20 = t18*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (7.0*t3-336.0/25.0*t4+49.0/5.0*t2-392.0/115.0*t5+147.0/253.0*t1
-56.0/1265.0*r+7.0/6325.0)*t7*t13+2.0/9.0*t17+t20;
      drv[1] = t17+t20;
      drv[2] = t18*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=14 7 2 1 */
   } else if( i==7 && j==2 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t2*r;
      t5 = t1*r;
      t7 = s*s;
      t8 = r-1.0;
      t10 = t8*t8;
      t11 = t7+2.0/3.0*s*t8+t10/12;
      t13 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t16 = t2*t5-56.0/25.0*t3+49.0/25.0*t4-98.0/115.0*t2+49.0/253.0*t5-28.0/
1265.0*t1+7.0/6325.0*r-2.0/120175.0;
      t20 = t16*t11;
      drv[0] = (7.0*t3-336.0/25.0*t4+49.0/5.0*t2-392.0/115.0*t5+147.0/253.0*t1
-56.0/1265.0*r+7.0/6325.0)*t11*t13+t16*(2.0/3.0*s+r/6-1.0/6.0)*t13+2.0/3.0*t20;
      drv[1] = t16*(2.0*s+2.0/3.0*r-2.0/3.0)*t13+2.0/3.0*t20;
      drv[2] = t20;
   /* p=14 7 3 0 */
   } else if( i==7 && j==3 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t2*r;
      t5 = t1*r;
      t7 = s*s;
      t9 = r-1.0;
      t11 = t9*t9;
      t17 = t2*t5-56.0/25.0*t3+49.0/25.0*t4-98.0/115.0*t2+49.0/253.0*t5-28.0/
1265.0*t1+7.0/6325.0*r-2.0/120175.0;
      t18 = s*t9;
      drv[0] = (7.0*t3-336.0/25.0*t4+49.0/5.0*t2-392.0/115.0*t5+147.0/253.0*t1
-56.0/1265.0*r+7.0/6325.0)*(t7*s+4.0/3.0*t7*t9+s*t11/2+t11*t9/21)+t17*(4.0/3.0*
t7+t18+t11/7);
      drv[1] = t17*(3.0*t7+8.0/3.0*t18+t11/2);
      drv[2] = 0.0;
   /* p=14 8 0 2 */
   } else if( i==8 && j==0 && k==2 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t4 = t3*t2;
      t5 = t3*t1;
      t6 = t3*r;
      t8 = t*t;
      t9 = s+r-1.0;
      t11 = t9*t9;
      t14 = t3*t3;
      t15 = t14-72.0/25.0*t4+84.0/25.0*t5-1176.0/575.0*t6+882.0/1265.0*t3-168.0
/1265.0*t2+84.0/6325.0*t1-72.0/120175.0*r+1.0/120175.0;
      t17 = t15*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (8.0*t4-504.0/25.0*t5+504.0/25.0*t6-1176.0/115.0*t3+3528.0/
1265.0*t2-504.0/1265.0*t1+168.0/6325.0*r-72.0/120175.0)*(t8+6.0/5.0*t*t9+3.0/
10.0*t11)+t17;
      drv[1] = t17;
      drv[2] = t15*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=14 8 1 1 */
   } else if( i==8 && j==1 && k==1 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t4 = t3*t2;
      t5 = t3*t1;
      t6 = t3*r;
      t8 = s+2.0/7.0*r-2.0/7.0;
      t10 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t12 = t3*t3;
      t13 = t12-72.0/25.0*t4+84.0/25.0*t5-1176.0/575.0*t6+882.0/1265.0*t3-168.0
/1265.0*t2+84.0/6325.0*t1-72.0/120175.0*r+1.0/120175.0;
      t14 = t13*t10;
      t15 = t13*t8;
      drv[0] = (8.0*t4-504.0/25.0*t5+504.0/25.0*t6-1176.0/115.0*t3+3528.0/
1265.0*t2-504.0/1265.0*t1+168.0/6325.0*r-72.0/120175.0)*t8*t10+2.0/7.0*t14+2.0/
3.0*t15;
      drv[1] = t14+2.0/3.0*t15;
      drv[2] = t15;
   /* p=14 8 2 0 */
   } else if( i==8 && j==2 && k==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t4 = t3*t2;
      t5 = t3*t1;
      t6 = t3*r;
      t8 = s*s;
      t9 = r-1.0;
      t11 = t9*t9;
      t14 = t3*t3;
      t15 = t14-72.0/25.0*t4+84.0/25.0*t5-1176.0/575.0*t6+882.0/1265.0*t3-168.0
/1265.0*t2+84.0/6325.0*t1-72.0/120175.0*r+1.0/120175.0;
      drv[0] = (8.0*t4-504.0/25.0*t5+504.0/25.0*t6-1176.0/115.0*t3+3528.0/
1265.0*t2-504.0/1265.0*t1+168.0/6325.0*r-72.0/120175.0)*(t8+6.0/7.0*s*t9+t11/7)
+t15*(6.0/7.0*s+2.0/7.0*r-2.0/7.0);
      drv[1] = t15*(2.0*s+6.0/7.0*r-6.0/7.0);
      drv[2] = 0.0;
   /* p=14 9 0 1 */
   } else if( i==9 && j==0 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*r;
      t5 = t4*t2;
      t6 = t2*t1;
      t7 = t2*r;
      t11 = t3*r;
      t12 = (9.0*t3-144.0/5.0*t5+189.0/5.0*t6-3024.0/115.0*t7+2646.0/253.0*t2
-3024.0/1265.0*t4+378.0/1265.0*t1-432.0/24035.0*r+9.0/24035.0)*(t+2.0/3.0*s+2.0
/3.0*r-2.0/3.0)+2.0/3.0*t11-12.0/5.0*t3+18.0/5.0*t5-336.0/115.0*t6+1764.0/
1265.0*t7-504.0/1265.0*t2+84.0/1265.0*t4-144.0/24035.0*t1+6.0/24035.0*r-4.0/
1225785.0;
      drv[0] = t12;
      drv[1] = 2.0/3.0*t11-12.0/5.0*t3+18.0/5.0*t5-336.0/115.0*t6+1764.0/1265.0
*t7-504.0/1265.0*t2+84.0/1265.0*t4-144.0/24035.0*t1+6.0/24035.0*r-4.0/1225785.0
;
      drv[2] = t11-18.0/5.0*t3+27.0/5.0*t5-504.0/115.0*t6+2646.0/1265.0*t7
-756.0/1265.0*t2+126.0/1265.0*t4-216.0/24035.0*t1+9.0/24035.0*r-2.0/408595.0;
   /* p=14 9 1 0 */
   } else if( i==9 && j==1 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*r;
      t5 = t4*t2;
      t6 = t2*t1;
      t7 = t2*r;
      t11 = t3*r;
      t12 = (9.0*t3-144.0/5.0*t5+189.0/5.0*t6-3024.0/115.0*t7+2646.0/253.0*t2
-3024.0/1265.0*t4+378.0/1265.0*t1-432.0/24035.0*r+9.0/24035.0)*(s+2.0/5.0*r-2.0
/5.0)+2.0/5.0*t11-36.0/25.0*t3+54.0/25.0*t5-1008.0/575.0*t6+5292.0/6325.0*t7
-1512.0/6325.0*t2+252.0/6325.0*t4-432.0/120175.0*t1+18.0/120175.0*r-4.0/
2042975.0;
      drv[0] = t12;
      drv[1] = t11-18.0/5.0*t3+27.0/5.0*t5-504.0/115.0*t6+2646.0/1265.0*t7
-756.0/1265.0*t2+126.0/1265.0*t4-216.0/24035.0*t1+9.0/24035.0*r-2.0/408595.0;
      drv[2] = 0.0;
   /* p=14 10 0 0 */
   } else if( i==10 && j==0 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*r;
      drv[0] = 10.0*t3*r-198.0/5.0*t3+66.0*t2*t5-1386.0/23.0*t2*t1+756.0/23.0*
t2*r-252.0/23.0*t2+252.0/115.0*t5-108.0/437.0*t1+6.0/437.0*r-2.0/7429.0;
      drv[1] = 0.0;
      drv[2] = 0.0;
   /* p=15 0 0 11 */
   } else if( i==0 && j==0 && k==11 ) {
      t1 = t*t;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t3*t1;
      t6 = s+r-1.0;
      t7 = t3*t*t6;
      t8 = t6*t6;
      t9 = t3*t8;
      t10 = t1*t;
      t12 = t8*t6;
      t13 = t2*t10*t12;
      t15 = t8*t8;
      t16 = t2*t1*t15;
      t19 = t2*t*t15*t6;
      t21 = t2*t15*t8;
      t23 = t10*t15*t12;
      t24 = t15*t15;
      t25 = t1*t24;
      t27 = t*t24*t6;
      t28 = t24*t8;
      t29 = 132.0/23.0*t4+660.0/23.0*t7+9900.0/161.0*t9+11880.0/161.0*t13+
23760.0/437.0*t16+11088.0/437.0*t19+55440.0/7429.0*t21+9900.0/7429.0*t23+990.0/
7429.0*t25+330.0/52003.0*t27+66.0/676039.0*t28;
      t30 = 11.0*t4+1320.0/23.0*t7+2970.0/23.0*t9+26400.0/161.0*t13+2970.0/23.0
*t16+28512.0/437.0*t19+9240.0/437.0*t21+31680.0/7429.0*t23+7425.0/14858.0*t25+
220.0/7429.0*t27+33.0/52003.0*t28;
      drv[0] = t29;
      drv[1] = t29;
      drv[2] = t30;
   /* p=15 0 1 10 */
   } else if( i==0 && j==1 && k==10 ) {
      t1 = t*t;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t3*t1;
      t5 = t3*t;
      t6 = s+r-1.0;
      t7 = t5*t6;
      t8 = t6*t6;
      t9 = t3*t8;
      t10 = t1*t;
      t11 = t2*t10;
      t12 = t8*t6;
      t13 = t11*t12;
      t14 = t2*t1;
      t15 = t8*t8;
      t16 = t14*t15;
      t17 = t2*t;
      t18 = t15*t6;
      t19 = t17*t18;
      t20 = t15*t8;
      t21 = t2*t20;
      t22 = t15*t12;
      t23 = t10*t22;
      t24 = t15*t15;
      t25 = t1*t24;
      t26 = t24*t6;
      t27 = t*t26;
      t28 = t24*t8;
      t29 = s+2.0/25.0*r-2.0/25.0;
      t30 = t3*t6;
      t31 = t11*t8;
      t32 = t14*t12;
      t33 = t17*t15;
      t34 = t2*t18;
      t35 = t10*t20;
      t36 = t1*t22;
      t37 = t*t24;
      t39 = t29*(110.0/21.0*t5+165.0/7.0*t30+5940.0/133.0*t31+880.0/19.0*t32+
9240.0/323.0*t33+3465.0/323.0*t34+770.0/323.0*t35+660.0/2261.0*t36+495.0/
29393.0*t37+55.0/176358.0*t26);
      t40 = 2.0/25.0*t4+44.0/105.0*t7+33.0/35.0*t9+792.0/665.0*t13+88.0/95.0*
t16+3696.0/8075.0*t19+231.0/1615.0*t21+44.0/1615.0*t23+33.0/11305.0*t25+22.0/
146965.0*t27+11.0/4408950.0*t28+t39;
      t41 = t4+110.0/21.0*t7+165.0/14.0*t9+1980.0/133.0*t13+220.0/19.0*t16+
1848.0/323.0*t19+1155.0/646.0*t21+110.0/323.0*t23+165.0/4522.0*t25+55.0/29393.0
*t27+11.0/352716.0*t28+t39;
      drv[0] = t40;
      drv[1] = t41;
      drv[2] = t29*(10.0*t5+330.0/7.0*t30+660.0/7.0*t31+1980.0/19.0*t32+1320.0/
19.0*t33+9240.0/323.0*t34+2310.0/323.0*t35+330.0/323.0*t36+165.0/2261.0*t37+
55.0/29393.0*t26);
   /* p=15 0 2 9 */
   } else if( i==0 && j==2 && k==9 ) {
      t2 = t*t;
      t3 = t2*t2;
      t4 = t3*t3;
      t6 = s+r-1.0;
      t8 = t2*t;
      t9 = t3*t8;
      t10 = t6*t6;
      t12 = t3*t2;
      t13 = t10*t6;
      t15 = t3*t;
      t16 = t10*t10;
      t18 = t16*t6;
      t20 = t16*t10;
      t22 = t16*t13;
      t24 = t16*t16;
      t27 = t4*t+90.0/19.0*t4*t6+180.0/19.0*t9*t10+3360.0/323.0*t12*t13+2205.0/
323.0*t15*t16+882.0/323.0*t3*t18+210.0/323.0*t8*t20+360.0/4199.0*t2*t22+45.0/
8398.0*t*t24+5.0/46189.0*t24*t6;
      t29 = s*s;
      t30 = r-1.0;
      t32 = t30*t30;
      t33 = t29+6.0/25.0*s*t30+t32/100;
      t34 = t9*t6;
      t35 = t12*t10;
      t36 = t15*t13;
      t37 = t3*t16;
      t38 = t8*t18;
      t39 = t2*t20;
      t40 = t*t22;
      t42 = t33*(90.0/19.0*t4+360.0/19.0*t34+10080.0/323.0*t35+8820.0/323.0*t36
+4410.0/323.0*t37+1260.0/323.0*t38+2520.0/4199.0*t39+180.0/4199.0*t40+45.0/
46189.0*t24);
      drv[0] = (6.0/25.0*s+r/50-1.0/50.0)*t27+t42;
      drv[1] = (2.0*s+6.0/25.0*r-6.0/25.0)*t27+t42;
      drv[2] = t33*(9.0*t4+720.0/19.0*t34+1260.0/19.0*t35+20160.0/323.0*t36+
11025.0/323.0*t37+3528.0/323.0*t38+630.0/323.0*t39+720.0/4199.0*t40+45.0/8398.0
*t24);
   /* p=15 0 3 8 */
   } else if( i==0 && j==3 && k==8 ) {
      t1 = s*s;
      t2 = r-1.0;
      t3 = s*t2;
      t4 = t2*t2;
      t6 = t*t;
      t7 = t6*t6;
      t8 = t7*t7;
      t9 = t6*t;
      t10 = t7*t9;
      t11 = s+r-1.0;
      t13 = t7*t6;
      t14 = t11*t11;
      t16 = t7*t;
      t17 = t14*t11;
      t19 = t14*t14;
      t21 = t19*t11;
      t23 = t19*t14;
      t25 = t19*t17;
      t27 = t19*t19;
      t28 = t8+72.0/17.0*t10*t11+126.0/17.0*t13*t14+588.0/85.0*t16*t17+63.0/
17.0*t7*t19+252.0/221.0*t9*t21+42.0/221.0*t6*t23+36.0/2431.0*t*t25+9.0/24310.0*
t27;
      t34 = t1*s+12.0/25.0*t2*t1+3.0/50.0*s*t4+t4*t2/575;
      t35 = t13*t11;
      t36 = t16*t14;
      t37 = t7*t17;
      t38 = t9*t19;
      t39 = t6*t21;
      t40 = t*t23;
      t42 = t34*(72.0/17.0*t10+252.0/17.0*t35+1764.0/85.0*t36+252.0/17.0*t37+
1260.0/221.0*t38+252.0/221.0*t39+252.0/2431.0*t40+36.0/12155.0*t25);
      drv[0] = (12.0/25.0*t1+3.0/25.0*t3+3.0/575.0*t4)*t28+t42;
      drv[1] = (3.0*t1+24.0/25.0*t3+3.0/50.0*t4)*t28+t42;
      drv[2] = t34*(8.0*t10+504.0/17.0*t35+756.0/17.0*t36+588.0/17.0*t37+252.0/
17.0*t38+756.0/221.0*t39+84.0/221.0*t40+36.0/2431.0*t25);
   /* p=15 0 4 7 */
   } else if( i==0 && j==4 && k==7 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = r-1.0;
      t4 = t3*t1;
      t5 = t3*t3;
      t6 = s*t5;
      t7 = t5*t3;
      t9 = t*t;
      t10 = t9*t;
      t11 = t9*t9;
      t13 = t11*t9;
      t14 = s+r-1.0;
      t16 = t11*t;
      t17 = t14*t14;
      t19 = t17*t14;
      t21 = t17*t17;
      t23 = t21*t14;
      t25 = t21*t17;
      t28 = t10*t11+56.0/15.0*t13*t14+28.0/5.0*t16*t17+56.0/13.0*t19*t11+70.0/
39.0*t10*t21+56.0/143.0*t9*t23+28.0/715.0*t*t25+8.0/6435.0*t21*t19;
      t30 = t1*t1;
      t34 = t5*t5;
      t35 = t30+4.0/5.0*t3*t2+t1*t5/5+2.0/115.0*s*t7+t34/2530;
      t36 = t16*t14;
      t37 = t11*t17;
      t38 = t10*t19;
      t39 = t9*t21;
      t40 = t*t23;
      t42 = t35*(56.0/15.0*t13+56.0/5.0*t36+168.0/13.0*t37+280.0/39.0*t38+280.0
/143.0*t39+168.0/715.0*t40+56.0/6435.0*t25);
      drv[0] = (4.0/5.0*t2+2.0/5.0*t4+6.0/115.0*t6+2.0/1265.0*t7)*t28+t42;
      drv[1] = (4.0*t2+12.0/5.0*t4+2.0/5.0*t6+2.0/115.0*t7)*t28+t42;
      drv[2] = t35*(7.0*t13+112.0/5.0*t36+28.0*t37+224.0/13.0*t38+70.0/13.0*t39
+112.0/143.0*t40+28.0/715.0*t25);
   /* p=15 0 5 6 */
   } else if( i==0 && j==5 && k==6 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t1*s;
      t4 = r-1.0;
      t5 = t3*t4;
      t6 = t4*t4;
      t7 = t1*t6;
      t8 = t6*t4;
      t9 = s*t8;
      t10 = t6*t6;
      t12 = t*t;
      t13 = t12*t12;
      t15 = t13*t;
      t16 = s+r-1.0;
      t18 = t16*t16;
      t20 = t12*t;
      t21 = t18*t16;
      t23 = t18*t18;
      t25 = t23*t16;
      t28 = t13*t12+42.0/13.0*t15*t16+105.0/26.0*t13*t18+350.0/143.0*t20*t21+
105.0/143.0*t12*t23+14.0/143.0*t*t25+7.0/1716.0*t23*t18;
      t36 = s*t2+6.0/5.0*t4*t2+t3*t6/2+2.0/23.0*t1*t8+3.0/506.0*s*t10+t10*t4
/8855;
      t37 = t13*t16;
      t38 = t20*t18;
      t39 = t12*t21;
      t40 = t*t23;
      t42 = t36*(42.0/13.0*t15+105.0/13.0*t37+1050.0/143.0*t38+420.0/143.0*t39+
70.0/143.0*t40+7.0/286.0*t25);
      drv[0] = (6.0/5.0*t2+t5+6.0/23.0*t7+6.0/253.0*t9+t10/1771)*t28+t42;
      drv[1] = (5.0*t2+24.0/5.0*t5+3.0/2.0*t7+4.0/23.0*t9+3.0/506.0*t10)*t28+
t42;
      drv[2] = t36*(6.0*t15+210.0/13.0*t37+210.0/13.0*t38+1050.0/143.0*t39+
210.0/143.0*t40+14.0/143.0*t25);
   /* p=15 0 6 5 */
   } else if( i==0 && j==6 && k==5 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = s*t2;
      t4 = r-1.0;
      t5 = t4*t2;
      t6 = t1*s;
      t7 = t4*t4;
      t8 = t6*t7;
      t9 = t7*t4;
      t10 = t1*t9;
      t11 = t7*t7;
      t12 = s*t11;
      t13 = t11*t4;
      t15 = t*t;
      t16 = t15*t15;
      t18 = s+r-1.0;
      t20 = t15*t;
      t21 = t18*t18;
      t23 = t21*t18;
      t25 = t21*t21;
      t28 = t16*t+30.0/11.0*t18*t16+30.0/11.0*t20*t21+40.0/33.0*t15*t23+5.0/
22.0*t*t25+t25*t18/77;
      t37 = t2*t1+42.0/25.0*t3*t4+21.0/20.0*t2*t7+7.0/23.0*t6*t9+21.0/506.0*t1*
t11+3.0/1265.0*s*t13+t11*t7/25300;
      t38 = t20*t18;
      t39 = t15*t21;
      t40 = t*t23;
      t42 = t37*(30.0/11.0*t16+60.0/11.0*t38+40.0/11.0*t39+10.0/11.0*t40+5.0/
77.0*t25);
      drv[0] = (42.0/25.0*t3+21.0/10.0*t5+21.0/23.0*t8+42.0/253.0*t10+3.0/253.0
*t12+3.0/12650.0*t13)*t28+t42;
      drv[1] = (6.0*t3+42.0/5.0*t5+21.0/5.0*t8+21.0/23.0*t10+21.0/253.0*t12+3.0
/1265.0*t13)*t28+t42;
      drv[2] = t37*(5.0*t16+120.0/11.0*t38+90.0/11.0*t39+80.0/33.0*t40+5.0/22.0
*t25);
   /* p=15 0 7 4 */
   } else if( i==0 && j==7 && k==4 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = s*t2;
      t5 = r-1.0;
      t6 = t4*t5;
      t7 = t5*t5;
      t8 = t2*t7;
      t9 = t1*s;
      t10 = t7*t5;
      t11 = t9*t10;
      t12 = t7*t7;
      t13 = t1*t12;
      t14 = t12*t5;
      t15 = s*t14;
      t16 = t12*t7;
      t18 = t*t;
      t19 = t18*t18;
      t20 = t18*t;
      t21 = s+r-1.0;
      t23 = t21*t21;
      t25 = t23*t21;
      t27 = t23*t23;
      t28 = t19+20.0/9.0*t20*t21+5.0/3.0*t23*t18+10.0/21.0*t*t25+5.0/126.0*t27;
      t38 = t2*t9+56.0/25.0*t3*t5+49.0/25.0*t7*t4+98.0/115.0*t2*t10+49.0/253.0*
t9*t12+28.0/1265.0*t1*t14+7.0/6325.0*s*t16+2.0/120175.0*t12*t10;
      t39 = t21*t18;
      t40 = t*t23;
      t42 = t38*(20.0/9.0*t20+10.0/3.0*t39+10.0/7.0*t40+10.0/63.0*t25);
      drv[0] = (56.0/25.0*t3+98.0/25.0*t6+294.0/115.0*t8+196.0/253.0*t11+28.0/
253.0*t13+42.0/6325.0*t15+14.0/120175.0*t16)*t28+t42;
      drv[1] = (7.0*t3+336.0/25.0*t6+49.0/5.0*t8+392.0/115.0*t11+147.0/253.0*
t13+56.0/1265.0*t15+7.0/6325.0*t16)*t28+t42;
      drv[2] = t38*(4.0*t20+20.0/3.0*t39+10.0/3.0*t40+10.0/21.0*t25);
   /* p=15 0 8 3 */
   } else if( i==0 && j==8 && k==3 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t4 = t3*t2;
      t5 = t3*t1;
      t6 = r-1.0;
      t7 = t5*t6;
      t8 = t3*s;
      t9 = t6*t6;
      t10 = t8*t9;
      t11 = t9*t6;
      t12 = t3*t11;
      t13 = t9*t9;
      t14 = t2*t13;
      t15 = t13*t6;
      t16 = t1*t15;
      t17 = t13*t9;
      t18 = s*t17;
      t19 = t13*t11;
      t21 = t*t;
      t23 = s+r-1.0;
      t25 = t23*t23;
      t28 = t21*t+12.0/7.0*t21*t23+6.0/7.0*t*t25+4.0/35.0*t25*t23;
      t30 = t3*t3;
      t38 = t13*t13;
      t39 = t30+72.0/25.0*t4*t6+84.0/25.0*t5*t9+1176.0/575.0*t8*t11+882.0/
1265.0*t3*t13+168.0/1265.0*t2*t15+84.0/6325.0*t1*t17+72.0/120175.0*s*t19+t38
/120175;
      t40 = t*t23;
      t42 = t39*(12.0/7.0*t21+12.0/7.0*t40+12.0/35.0*t25);
      drv[0] = (72.0/25.0*t4+168.0/25.0*t7+3528.0/575.0*t10+3528.0/1265.0*t12+
168.0/253.0*t14+504.0/6325.0*t16+504.0/120175.0*t18+8.0/120175.0*t19)*t28+t42;
      drv[1] = (8.0*t4+504.0/25.0*t7+504.0/25.0*t10+1176.0/115.0*t12+3528.0/
1265.0*t14+504.0/1265.0*t16+168.0/6325.0*t18+72.0/120175.0*t19)*t28+t42;
      drv[2] = t39*(3.0*t21+24.0/7.0*t40+6.0/7.0*t25);
   /* p=15 0 9 2 */
   } else if( i==0 && j==9 && k==2 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*s;
      t5 = t4*t2;
      t6 = r-1.0;
      t7 = t5*t6;
      t8 = t2*t1;
      t9 = t6*t6;
      t10 = t8*t9;
      t11 = t2*s;
      t12 = t9*t6;
      t13 = t11*t12;
      t14 = t9*t9;
      t15 = t2*t14;
      t16 = t14*t6;
      t17 = t4*t16;
      t18 = t14*t9;
      t19 = t1*t18;
      t20 = t14*t12;
      t21 = s*t20;
      t22 = t14*t14;
      t24 = t*t;
      t25 = s+r-1.0;
      t27 = t25*t25;
      t28 = t24+6.0/5.0*t*t25+3.0/10.0*t27;
      t40 = t3*s+18.0/5.0*t3*t6+27.0/5.0*t5*t9+504.0/115.0*t8*t12+2646.0/1265.0
*t11*t14+756.0/1265.0*t2*t16+126.0/1265.0*t4*t18+216.0/24035.0*t1*t20+9.0/
24035.0*s*t22+2.0/408595.0*t22*t6;
      t42 = t40*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (18.0/5.0*t3+54.0/5.0*t7+1512.0/115.0*t10+10584.0/1265.0*t13+
756.0/253.0*t15+756.0/1265.0*t17+1512.0/24035.0*t19+72.0/24035.0*t21+18.0/
408595.0*t22)*t28+t42;
      drv[1] = (9.0*t3+144.0/5.0*t7+189.0/5.0*t10+3024.0/115.0*t13+2646.0/253.0
*t15+3024.0/1265.0*t17+378.0/1265.0*t19+432.0/24035.0*t21+9.0/24035.0*t22)*t28+
t42;
      drv[2] = t40*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=15 0 10 1 */
   } else if( i==0 && j==10 && k==1 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t3*s;
      t5 = r-1.0;
      t6 = t3*t5;
      t7 = t1*s;
      t8 = t2*t7;
      t9 = t5*t5;
      t10 = t8*t9;
      t11 = t2*t1;
      t12 = t5*t9;
      t13 = t11*t12;
      t14 = t2*s;
      t15 = t9*t9;
      t16 = t14*t15;
      t17 = t15*t5;
      t18 = t2*t17;
      t19 = t15*t9;
      t20 = t7*t19;
      t21 = t15*t12;
      t22 = t1*t21;
      t23 = t15*t15;
      t24 = s*t23;
      t25 = t23*t5;
      t27 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t29 = t3*t1;
      t30 = t4*t5;
      t31 = t3*t9;
      t32 = t8*t12;
      t33 = t11*t15;
      t34 = t14*t17;
      t35 = t2*t19;
      t36 = t7*t21;
      t37 = t1*t23;
      t38 = s*t25;
      t39 = t23*t9;
      t40 = (22.0/5.0*t4+33.0/2.0*t6+594.0/23.0*t10+504.0/23.0*t13+252.0/23.0*
t16+378.0/115.0*t18+252.0/437.0*t20+24.0/437.0*t22+18.0/7429.0*t24+t25/29716)*
t27+2.0/3.0*t29+44.0/15.0*t30+11.0/2.0*t31+132.0/23.0*t32+84.0/23.0*t33+168.0/
115.0*t34+42.0/115.0*t35+24.0/437.0*t36+2.0/437.0*t37+4.0/22287.0*t38+t39
/445740;
      t43 = (10.0*t4+198.0/5.0*t6+66.0*t10+1386.0/23.0*t13+756.0/23.0*t16+252.0
/23.0*t18+252.0/115.0*t20+108.0/437.0*t22+6.0/437.0*t24+2.0/7429.0*t25)*t27+2.0
/3.0*t29+44.0/15.0*t30+11.0/2.0*t31+132.0/23.0*t32+84.0/23.0*t33+168.0/115.0*
t34+42.0/115.0*t35+24.0/437.0*t36+2.0/437.0*t37+4.0/22287.0*t38+t39/445740;
      t44 = t29+22.0/5.0*t30+33.0/4.0*t31+198.0/23.0*t32+126.0/23.0*t33+252.0/
115.0*t34+63.0/115.0*t35+36.0/437.0*t36+3.0/437.0*t37+2.0/7429.0*t38+t39/297160
;
      drv[0] = t40;
      drv[1] = t43;
      drv[2] = t44;
   /* p=15 0 11 0 */
   } else if( i==0 && j==11 && k==0 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t3*t1;
      t6 = r-1.0;
      t7 = t3*s*t6;
      t8 = t6*t6;
      t9 = t3*t8;
      t10 = t1*s;
      t12 = t8*t6;
      t13 = t2*t10*t12;
      t15 = t8*t8;
      t16 = t2*t1*t15;
      t19 = t2*s*t15*t6;
      t21 = t2*t15*t8;
      t23 = t10*t15*t12;
      t24 = t15*t15;
      t25 = t1*t24;
      t27 = s*t24*t6;
      t28 = t24*t8;
      t29 = 132.0/25.0*t4+121.0/5.0*t7+1089.0/23.0*t9+1188.0/23.0*t13+792.0/
23.0*t16+8316.0/575.0*t19+8316.0/2185.0*t21+264.0/437.0*t23+396.0/7429.0*t25+
33.0/14858.0*t27+11.0/371450.0*t28;
      t30 = 11.0*t4+264.0/5.0*t7+1089.0/10.0*t9+2904.0/23.0*t13+2079.0/23.0*t16
+4752.0/115.0*t19+1386.0/115.0*t21+4752.0/2185.0*t23+99.0/437.0*t25+88.0/7429.0
*t27+33.0/148580.0*t28;
      drv[0] = t29;
      drv[1] = t30;
      drv[2] = 0.0;
   /* p=15 1 0 10 */
   } else if( i==1 && j==0 && k==10 ) {
      t1 = t*t;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t3*t;
      t6 = s+r-1.0;
      t8 = t6*t6;
      t10 = t1*t;
      t11 = t2*t10;
      t12 = t8*t6;
      t14 = t2*t1;
      t15 = t8*t8;
      t17 = t2*t;
      t18 = t15*t6;
      t20 = t15*t8;
      t22 = t15*t12;
      t24 = t15*t15;
      t26 = t24*t6;
      t29 = r-2.0/27.0;
      t30 = t3*t6;
      t31 = t11*t8;
      t32 = t14*t12;
      t33 = t17*t15;
      t34 = t2*t18;
      t35 = t10*t20;
      t36 = t1*t22;
      t37 = t*t24;
      t39 = t29*(110.0/21.0*t5+165.0/7.0*t30+5940.0/133.0*t31+880.0/19.0*t32+
9240.0/323.0*t33+3465.0/323.0*t34+770.0/323.0*t35+660.0/2261.0*t36+495.0/
29393.0*t37+55.0/176358.0*t26);
      t40 = t3*t1+110.0/21.0*t5*t6+165.0/14.0*t3*t8+1980.0/133.0*t11*t12+220.0/
19.0*t14*t15+1848.0/323.0*t17*t18+1155.0/646.0*t2*t20+110.0/323.0*t10*t22+165.0
/4522.0*t1*t24+55.0/29393.0*t*t26+11.0/352716.0*t24*t8+t39;
      drv[0] = t40;
      drv[1] = t39;
      drv[2] = t29*(10.0*t5+330.0/7.0*t30+660.0/7.0*t31+1980.0/19.0*t32+1320.0/
19.0*t33+9240.0/323.0*t34+2310.0/323.0*t35+330.0/323.0*t36+165.0/2261.0*t37+
55.0/29393.0*t26);
   /* p=15 1 1 9 */
   } else if( i==1 && j==1 && k==9 ) {
      t1 = s+2.0/23.0*r-2.0/23.0;
      t2 = t*t;
      t3 = t2*t2;
      t4 = t3*t3;
      t6 = s+r-1.0;
      t8 = t2*t;
      t9 = t3*t8;
      t10 = t6*t6;
      t12 = t3*t2;
      t13 = t10*t6;
      t15 = t3*t;
      t16 = t10*t10;
      t18 = t16*t6;
      t20 = t16*t10;
      t22 = t16*t13;
      t24 = t16*t16;
      t27 = t4*t+90.0/19.0*t4*t6+180.0/19.0*t9*t10+3360.0/323.0*t12*t13+2205.0/
323.0*t15*t16+882.0/323.0*t3*t18+210.0/323.0*t8*t20+360.0/4199.0*t2*t22+45.0/
8398.0*t*t24+5.0/46189.0*t24*t6;
      t29 = r-2.0/27.0;
      t30 = t29*t27;
      t31 = t29*t1;
      t32 = t9*t6;
      t33 = t12*t10;
      t34 = t15*t13;
      t35 = t3*t16;
      t36 = t8*t18;
      t37 = t2*t20;
      t38 = t*t22;
      t40 = t31*(90.0/19.0*t4+360.0/19.0*t32+10080.0/323.0*t33+8820.0/323.0*t34
+4410.0/323.0*t35+1260.0/323.0*t36+2520.0/4199.0*t37+180.0/4199.0*t38+45.0/
46189.0*t24);
      drv[0] = t1*t27+2.0/23.0*t30+t40;
      drv[1] = t30+t40;
      drv[2] = t31*(9.0*t4+720.0/19.0*t32+1260.0/19.0*t33+20160.0/323.0*t34+
11025.0/323.0*t35+3528.0/323.0*t36+630.0/323.0*t37+720.0/4199.0*t38+45.0/8398.0
*t24);
   /* p=15 1 2 8 */
   } else if( i==1 && j==2 && k==8 ) {
      t1 = s*s;
      t2 = r-1.0;
      t4 = t2*t2;
      t5 = t1+6.0/23.0*s*t2+3.0/253.0*t4;
      t6 = t*t;
      t7 = t6*t6;
      t8 = t7*t7;
      t9 = t6*t;
      t10 = t7*t9;
      t11 = s+r-1.0;
      t13 = t7*t6;
      t14 = t11*t11;
      t16 = t7*t;
      t17 = t14*t11;
      t19 = t14*t14;
      t21 = t19*t11;
      t23 = t19*t14;
      t25 = t19*t17;
      t27 = t19*t19;
      t28 = t8+72.0/17.0*t10*t11+126.0/17.0*t13*t14+588.0/85.0*t16*t17+63.0/
17.0*t7*t19+252.0/221.0*t9*t21+42.0/221.0*t6*t23+36.0/2431.0*t*t25+9.0/24310.0*
t27;
      t30 = r-2.0/27.0;
      t34 = t30*t5;
      t35 = t13*t11;
      t36 = t16*t14;
      t37 = t7*t17;
      t38 = t9*t19;
      t39 = t6*t21;
      t40 = t*t23;
      t42 = t34*(72.0/17.0*t10+252.0/17.0*t35+1764.0/85.0*t36+252.0/17.0*t37+
1260.0/221.0*t38+252.0/221.0*t39+252.0/2431.0*t40+36.0/12155.0*t25);
      drv[0] = t5*t28+t30*(6.0/23.0*s+6.0/253.0*r-6.0/253.0)*t28+t42;
      drv[1] = t30*(2.0*s+6.0/23.0*r-6.0/23.0)*t28+t42;
      drv[2] = t34*(8.0*t10+504.0/17.0*t35+756.0/17.0*t36+588.0/17.0*t37+252.0/
17.0*t38+756.0/221.0*t39+84.0/221.0*t40+36.0/2431.0*t25);
   /* p=15 1 3 7 */
   } else if( i==1 && j==3 && k==7 ) {
      t1 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t8 = t1*s+12.0/23.0*t3*t1+18.0/253.0*s*t5+4.0/1771.0*t5*t3;
      t9 = t*t;
      t10 = t9*t;
      t11 = t9*t9;
      t13 = t11*t9;
      t14 = s+r-1.0;
      t16 = t11*t;
      t17 = t14*t14;
      t19 = t17*t14;
      t21 = t17*t17;
      t23 = t21*t14;
      t25 = t21*t17;
      t28 = t11*t10+56.0/15.0*t13*t14+28.0/5.0*t16*t17+56.0/13.0*t11*t19+70.0/
39.0*t10*t21+56.0/143.0*t9*t23+28.0/715.0*t*t25+8.0/6435.0*t21*t19;
      t30 = r-2.0/27.0;
      t31 = s*t3;
      t35 = t30*t8;
      t36 = t16*t14;
      t37 = t11*t17;
      t38 = t10*t19;
      t39 = t9*t21;
      t40 = t*t23;
      t42 = t35*(56.0/15.0*t13+56.0/5.0*t36+168.0/13.0*t37+280.0/39.0*t38+280.0
/143.0*t39+168.0/715.0*t40+56.0/6435.0*t25);
      drv[0] = t8*t28+t30*(12.0/23.0*t1+36.0/253.0*t31+12.0/1771.0*t5)*t28+t42;
      drv[1] = t30*(3.0*t1+24.0/23.0*t31+18.0/253.0*t5)*t28+t42;
      drv[2] = t35*(7.0*t13+112.0/5.0*t36+28.0*t37+224.0/13.0*t38+70.0/13.0*t39
+112.0/143.0*t40+28.0/715.0*t25);
   /* p=15 1 4 6 */
   } else if( i==1 && j==4 && k==6 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t1*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t8 = t6*t4;
      t10 = t6*t6;
      t11 = t2+20.0/23.0*t3*t4+60.0/253.0*t1*t6+40.0/1771.0*s*t8+t10/1771;
      t12 = t*t;
      t13 = t12*t12;
      t15 = t13*t;
      t16 = s+r-1.0;
      t18 = t16*t16;
      t20 = t12*t;
      t21 = t18*t16;
      t23 = t18*t18;
      t25 = t23*t16;
      t28 = t13*t12+42.0/13.0*t15*t16+105.0/26.0*t13*t18+350.0/143.0*t20*t21+
105.0/143.0*t12*t23+14.0/143.0*t*t25+7.0/1716.0*t23*t18;
      t30 = r-2.0/27.0;
      t31 = t4*t1;
      t32 = s*t6;
      t36 = t30*t11;
      t37 = t13*t16;
      t38 = t20*t18;
      t39 = t12*t21;
      t40 = t*t23;
      t42 = t36*(42.0/13.0*t15+105.0/13.0*t37+1050.0/143.0*t38+420.0/143.0*t39+
70.0/143.0*t40+7.0/286.0*t25);
      drv[0] = t11*t28+t30*(20.0/23.0*t3+120.0/253.0*t31+120.0/1771.0*t32+4.0/
1771.0*t8)*t28+t42;
      drv[1] = t30*(4.0*t3+60.0/23.0*t31+120.0/253.0*t32+40.0/1771.0*t8)*t28+
t42;
      drv[2] = t36*(6.0*t15+210.0/13.0*t37+210.0/13.0*t38+1050.0/143.0*t39+
210.0/143.0*t40+14.0/143.0*t25);
   /* p=15 1 5 5 */
   } else if( i==1 && j==5 && k==5 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t6 = t1*s;
      t7 = t4*t4;
      t9 = t7*t4;
      t11 = t7*t7;
      t14 = t2*s+30.0/23.0*t4*t2+150.0/253.0*t6*t7+200.0/1771.0*t1*t9+15.0/
1771.0*s*t11+6.0/33649.0*t11*t4;
      t15 = t*t;
      t16 = t15*t15;
      t18 = s+r-1.0;
      t20 = t15*t;
      t21 = t18*t18;
      t23 = t21*t18;
      t25 = t21*t21;
      t28 = t16*t+30.0/11.0*t18*t16+30.0/11.0*t20*t21+40.0/33.0*t15*t23+5.0/
22.0*t*t25+t25*t18/77;
      t30 = r-2.0/27.0;
      t31 = t6*t4;
      t32 = t1*t7;
      t33 = s*t9;
      t37 = t30*t14;
      t38 = t20*t18;
      t39 = t15*t21;
      t40 = t*t23;
      t42 = t37*(30.0/11.0*t16+60.0/11.0*t38+40.0/11.0*t39+10.0/11.0*t40+5.0/
77.0*t25);
      drv[0] = t14*t28+t30*(30.0/23.0*t2+300.0/253.0*t31+600.0/1771.0*t32+60.0/
1771.0*t33+30.0/33649.0*t11)*t28+t42;
      drv[1] = t30*(5.0*t2+120.0/23.0*t31+450.0/253.0*t32+400.0/1771.0*t33+15.0
/1771.0*t11)*t28+t42;
      drv[2] = t37*(5.0*t16+120.0/11.0*t38+90.0/11.0*t39+80.0/33.0*t40+5.0/22.0
*t25);
   /* p=15 1 6 4 */
   } else if( i==1 && j==6 && k==4 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = t2*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t9 = t1*s;
      t10 = t7*t5;
      t12 = t7*t7;
      t14 = t12*t5;
      t17 = t2*t1+42.0/23.0*t4*t5+315.0/253.0*t2*t7+100.0/253.0*t9*t10+15.0/
253.0*t1*t12+18.0/4807.0*s*t14+t12*t7/14421;
      t18 = t*t;
      t19 = t18*t18;
      t20 = t18*t;
      t21 = s+r-1.0;
      t23 = t21*t21;
      t25 = t23*t21;
      t27 = t23*t23;
      t28 = t19+20.0/9.0*t20*t21+5.0/3.0*t18*t23+10.0/21.0*t*t25+5.0/126.0*t27;
      t30 = r-2.0/27.0;
      t31 = t2*t5;
      t32 = t9*t7;
      t33 = t1*t10;
      t34 = s*t12;
      t38 = t30*t17;
      t39 = t21*t18;
      t40 = t*t23;
      t42 = t38*(20.0/9.0*t20+10.0/3.0*t39+10.0/7.0*t40+10.0/63.0*t25);
      drv[0] = t17*t28+t30*(42.0/23.0*t4+630.0/253.0*t31+300.0/253.0*t32+60.0/
253.0*t33+90.0/4807.0*t34+2.0/4807.0*t14)*t28+t42;
      drv[1] = t30*(6.0*t4+210.0/23.0*t31+1260.0/253.0*t32+300.0/253.0*t33+30.0
/253.0*t34+18.0/4807.0*t14)*t28+t42;
      drv[2] = t38*(4.0*t20+20.0/3.0*t39+10.0/3.0*t40+10.0/21.0*t25);
   /* p=15 1 7 3 */
   } else if( i==1 && j==7 && k==3 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t5 = t3*t1;
      t6 = r-1.0;
      t8 = t3*s;
      t9 = t6*t6;
      t11 = t9*t6;
      t13 = t9*t9;
      t15 = t13*t6;
      t17 = t13*t9;
      t20 = t3*t2+56.0/23.0*t5*t6+588.0/253.0*t8*t9+280.0/253.0*t3*t11+70.0/
253.0*t2*t13+168.0/4807.0*t1*t15+28.0/14421.0*s*t17+8.0/245157.0*t13*t11;
      t21 = t*t;
      t23 = s+r-1.0;
      t25 = t23*t23;
      t28 = t21*t+12.0/7.0*t23*t21+6.0/7.0*t*t25+4.0/35.0*t25*t23;
      t30 = r-2.0/27.0;
      t31 = t8*t6;
      t32 = t3*t9;
      t33 = t2*t11;
      t34 = t1*t13;
      t35 = s*t15;
      t39 = t30*t20;
      t40 = t*t23;
      t42 = t39*(12.0/7.0*t21+12.0/7.0*t40+12.0/35.0*t25);
      drv[0] = t20*t28+t30*(56.0/23.0*t5+1176.0/253.0*t31+840.0/253.0*t32+280.0
/253.0*t33+840.0/4807.0*t34+56.0/4807.0*t35+56.0/245157.0*t17)*t28+t42;
      drv[1] = t30*(7.0*t5+336.0/23.0*t31+2940.0/253.0*t32+1120.0/253.0*t33+
210.0/253.0*t34+336.0/4807.0*t35+28.0/14421.0*t17)*t28+t42;
      drv[2] = t39*(3.0*t21+24.0/7.0*t40+6.0/7.0*t25);
   /* p=15 1 8 2 */
   } else if( i==1 && j==8 && k==2 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*s;
      t5 = t4*t2;
      t6 = r-1.0;
      t8 = t2*t1;
      t9 = t6*t6;
      t11 = t2*s;
      t12 = t9*t6;
      t14 = t9*t9;
      t16 = t14*t6;
      t18 = t14*t9;
      t20 = t14*t12;
      t22 = t14*t14;
      t23 = t3+72.0/23.0*t5*t6+1008.0/253.0*t8*t9+672.0/253.0*t11*t12+252.0/
253.0*t2*t14+1008.0/4807.0*t4*t16+112.0/4807.0*t1*t18+96.0/81719.0*s*t20+3.0/
163438.0*t22;
      t24 = t*t;
      t25 = s+r-1.0;
      t27 = t25*t25;
      t28 = t24+6.0/5.0*t*t25+3.0/10.0*t27;
      t30 = r-2.0/27.0;
      t31 = t8*t6;
      t32 = t11*t9;
      t33 = t2*t12;
      t34 = t4*t14;
      t35 = t1*t16;
      t36 = s*t18;
      t40 = t30*t23;
      t42 = t40*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = t23*t28+t30*(72.0/23.0*t5+2016.0/253.0*t31+2016.0/253.0*t32+
1008.0/253.0*t33+5040.0/4807.0*t34+672.0/4807.0*t35+672.0/81719.0*t36+12.0/
81719.0*t20)*t28+t42;
      drv[1] = t30*(8.0*t5+504.0/23.0*t31+6048.0/253.0*t32+3360.0/253.0*t33+
1008.0/253.0*t34+3024.0/4807.0*t35+224.0/4807.0*t36+96.0/81719.0*t20)*t28+t42;
      drv[2] = t40*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=15 1 9 1 */
   } else if( i==1 && j==9 && k==1 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = r-1.0;
      t7 = t1*s;
      t8 = t2*t7;
      t9 = t5*t5;
      t11 = t2*t1;
      t12 = t9*t5;
      t14 = t2*s;
      t15 = t9*t9;
      t17 = t15*t5;
      t19 = t15*t9;
      t21 = t15*t12;
      t23 = t15*t15;
      t26 = t3*s+90.0/23.0*t3*t5+1620.0/253.0*t8*t9+1440.0/253.0*t11*t12+756.0/
253.0*t14*t15+4536.0/4807.0*t2*t17+840.0/4807.0*t7*t19+1440.0/81719.0*t1*t21+
135.0/163438.0*s*t23+t23*t5/81719;
      t27 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t29 = r-2.0/27.0;
      t30 = t8*t5;
      t31 = t11*t9;
      t32 = t14*t12;
      t33 = t2*t15;
      t34 = t7*t17;
      t35 = t1*t19;
      t36 = s*t21;
      t40 = t29*t26;
      drv[0] = t26*t27+t29*(90.0/23.0*t3+3240.0/253.0*t30+4320.0/253.0*t31+
3024.0/253.0*t32+22680.0/4807.0*t33+5040.0/4807.0*t34+10080.0/81719.0*t35+540.0
/81719.0*t36+9.0/81719.0*t23)*t27+2.0/3.0*t40;
      drv[1] = t29*(9.0*t3+720.0/23.0*t30+11340.0/253.0*t31+8640.0/253.0*t32+
3780.0/253.0*t33+18144.0/4807.0*t34+2520.0/4807.0*t35+2880.0/81719.0*t36+135.0/
163438.0*t23)*t27+2.0/3.0*t40;
      drv[2] = t40;
   /* p=15 1 10 0 */
   } else if( i==1 && j==10 && k==0 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t3*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t10 = t1*s;
      t11 = t2*t10;
      t12 = t8*t6;
      t14 = t2*t1;
      t15 = t8*t8;
      t17 = t2*s;
      t18 = t15*t6;
      t20 = t15*t8;
      t22 = t15*t12;
      t24 = t15*t15;
      t26 = t24*t6;
      t29 = r-2.0/27.0;
      t30 = t3*t6;
      t31 = t11*t8;
      t32 = t14*t12;
      t33 = t17*t15;
      t34 = t2*t18;
      t35 = t10*t20;
      t36 = t1*t22;
      t37 = s*t24;
      t40 = t3*t1+110.0/23.0*t5*t6+225.0/23.0*t3*t8+1800.0/161.0*t11*t12+180.0/
23.0*t14*t15+1512.0/437.0*t17*t18+420.0/437.0*t2*t20+1200.0/7429.0*t10*t22+
225.0/14858.0*t1*t24+5.0/7429.0*s*t26+t24*t8/104006+t29*(110.0/23.0*t5+450.0/
23.0*t30+5400.0/161.0*t31+720.0/23.0*t32+7560.0/437.0*t33+2520.0/437.0*t34+
8400.0/7429.0*t35+900.0/7429.0*t36+45.0/7429.0*t37+5.0/52003.0*t26);
      drv[0] = t40;
      drv[1] = t29*(10.0*t5+990.0/23.0*t30+1800.0/23.0*t31+1800.0/23.0*t32+
1080.0/23.0*t33+7560.0/437.0*t34+1680.0/437.0*t35+3600.0/7429.0*t36+225.0/
7429.0*t37+5.0/7429.0*t26);
      drv[2] = 0.0;
   /* p=15 2 0 9 */
   } else if( i==2 && j==0 && k==9 ) {
      t2 = t*t;
      t3 = t2*t2;
      t4 = t3*t3;
      t6 = s+r-1.0;
      t8 = t2*t;
      t9 = t3*t8;
      t10 = t6*t6;
      t12 = t3*t2;
      t13 = t10*t6;
      t15 = t3*t;
      t16 = t10*t10;
      t18 = t16*t6;
      t20 = t16*t10;
      t22 = t16*t13;
      t24 = t16*t16;
      t29 = r*r;
      t30 = t29-2.0/9.0*r+1.0/117.0;
      t31 = t9*t6;
      t32 = t12*t10;
      t33 = t15*t13;
      t34 = t3*t16;
      t35 = t8*t18;
      t36 = t2*t20;
      t37 = t*t22;
      t39 = t30*(90.0/19.0*t4+360.0/19.0*t31+10080.0/323.0*t32+8820.0/323.0*t33
+4410.0/323.0*t34+1260.0/323.0*t35+2520.0/4199.0*t36+180.0/4199.0*t37+45.0/
46189.0*t24);
      drv[0] = (2.0*r-2.0/9.0)*(t4*t+90.0/19.0*t4*t6+180.0/19.0*t9*t10+3360.0/
323.0*t12*t13+2205.0/323.0*t15*t16+882.0/323.0*t3*t18+210.0/323.0*t8*t20+360.0/
4199.0*t2*t22+45.0/8398.0*t*t24+5.0/46189.0*t24*t6)+t39;
      drv[1] = t39;
      drv[2] = t30*(9.0*t4+720.0/19.0*t31+1260.0/19.0*t32+20160.0/323.0*t33+
11025.0/323.0*t34+3528.0/323.0*t35+630.0/323.0*t36+720.0/4199.0*t37+45.0/8398.0
*t24);
   /* p=15 2 1 8 */
   } else if( i==2 && j==1 && k==8 ) {
      t2 = s+2.0/21.0*r-2.0/21.0;
      t4 = t*t;
      t5 = t4*t4;
      t6 = t5*t5;
      t7 = t4*t;
      t8 = t5*t7;
      t9 = s+r-1.0;
      t11 = t5*t4;
      t12 = t9*t9;
      t14 = t5*t;
      t15 = t12*t9;
      t17 = t12*t12;
      t19 = t17*t9;
      t21 = t17*t12;
      t23 = t17*t15;
      t25 = t17*t17;
      t26 = t6+72.0/17.0*t8*t9+126.0/17.0*t11*t12+588.0/85.0*t14*t15+63.0/17.0*
t5*t17+252.0/221.0*t7*t19+42.0/221.0*t4*t21+36.0/2431.0*t*t23+9.0/24310.0*t25;
      t28 = r*r;
      t29 = t28-2.0/9.0*r+1.0/117.0;
      t30 = t29*t26;
      t31 = t29*t2;
      t32 = t11*t9;
      t33 = t14*t12;
      t34 = t5*t15;
      t35 = t7*t17;
      t36 = t4*t19;
      t37 = t*t21;
      t39 = t31*(72.0/17.0*t8+252.0/17.0*t32+1764.0/85.0*t33+252.0/17.0*t34+
1260.0/221.0*t35+252.0/221.0*t36+252.0/2431.0*t37+36.0/12155.0*t23);
      drv[0] = t2*(2.0*r-2.0/9.0)*t26+2.0/21.0*t30+t39;
      drv[1] = t30+t39;
      drv[2] = t31*(8.0*t8+504.0/17.0*t32+756.0/17.0*t33+588.0/17.0*t34+252.0/
17.0*t35+756.0/221.0*t36+84.0/221.0*t37+36.0/2431.0*t23);
   /* p=15 2 2 7 */
   } else if( i==2 && j==2 && k==7 ) {
      t2 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t6 = t2+2.0/7.0*s*t3+t5/70;
      t8 = t*t;
      t9 = t8*t;
      t10 = t8*t8;
      t12 = t10*t8;
      t13 = s+r-1.0;
      t15 = t10*t;
      t16 = t13*t13;
      t18 = t16*t13;
      t20 = t16*t16;
      t22 = t20*t13;
      t24 = t20*t16;
      t27 = t10*t9+56.0/15.0*t12*t13+28.0/5.0*t15*t16+56.0/13.0*t10*t18+70.0/
39.0*t9*t20+56.0/143.0*t8*t22+28.0/715.0*t*t24+8.0/6435.0*t20*t18;
      t29 = r*r;
      t30 = t29-2.0/9.0*r+1.0/117.0;
      t34 = t30*t6;
      t35 = t15*t13;
      t36 = t10*t16;
      t37 = t9*t18;
      t38 = t8*t20;
      t39 = t*t22;
      t41 = t34*(56.0/15.0*t12+56.0/5.0*t35+168.0/13.0*t36+280.0/39.0*t37+280.0
/143.0*t38+168.0/715.0*t39+56.0/6435.0*t24);
      drv[0] = (2.0*r-2.0/9.0)*t6*t27+t30*(2.0/7.0*s+r/35-1.0/35.0)*t27+t41;
      drv[1] = t30*(2.0*s+2.0/7.0*r-2.0/7.0)*t27+t41;
      drv[2] = t34*(7.0*t12+112.0/5.0*t35+28.0*t36+224.0/13.0*t37+70.0/13.0*t38
+112.0/143.0*t39+28.0/715.0*t24);
   /* p=15 2 3 6 */
   } else if( i==2 && j==3 && k==6 ) {
      t2 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t9 = t2*s+4.0/7.0*t4*t2+3.0/35.0*s*t6+2.0/665.0*t6*t4;
      t11 = t*t;
      t12 = t11*t11;
      t14 = t12*t;
      t15 = s+r-1.0;
      t17 = t15*t15;
      t19 = t11*t;
      t20 = t17*t15;
      t22 = t17*t17;
      t24 = t22*t15;
      t27 = t11*t12+42.0/13.0*t14*t15+105.0/26.0*t17*t12+350.0/143.0*t19*t20+
105.0/143.0*t11*t22+14.0/143.0*t*t24+7.0/1716.0*t22*t17;
      t29 = r*r;
      t30 = t29-2.0/9.0*r+1.0/117.0;
      t31 = s*t4;
      t35 = t30*t9;
      t36 = t12*t15;
      t37 = t19*t17;
      t38 = t11*t20;
      t39 = t*t22;
      t41 = t35*(42.0/13.0*t14+105.0/13.0*t36+1050.0/143.0*t37+420.0/143.0*t38+
70.0/143.0*t39+7.0/286.0*t24);
      drv[0] = (2.0*r-2.0/9.0)*t9*t27+t30*(4.0/7.0*t2+6.0/35.0*t31+6.0/665.0*t6
)*t27+t41;
      drv[1] = t30*(3.0*t2+8.0/7.0*t31+3.0/35.0*t6)*t27+t41;
      drv[2] = t35*(6.0*t14+210.0/13.0*t36+210.0/13.0*t37+1050.0/143.0*t38+
210.0/143.0*t39+14.0/143.0*t24);
   /* p=15 2 4 5 */
   } else if( i==2 && j==4 && k==5 ) {
      t2 = s*s;
      t3 = t2*t2;
      t4 = t2*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t9 = t7*t5;
      t11 = t7*t7;
      t12 = t3+20.0/21.0*t4*t5+2.0/7.0*t2*t7+4.0/133.0*s*t9+t11/1197;
      t14 = t*t;
      t15 = t14*t14;
      t17 = s+r-1.0;
      t19 = t14*t;
      t20 = t17*t17;
      t22 = t20*t17;
      t24 = t20*t20;
      t27 = t15*t+30.0/11.0*t15*t17+30.0/11.0*t19*t20+40.0/33.0*t14*t22+5.0/
22.0*t*t24+t24*t17/77;
      t29 = r*r;
      t30 = t29-2.0/9.0*r+1.0/117.0;
      t31 = t2*t5;
      t32 = s*t7;
      t36 = t30*t12;
      t37 = t19*t17;
      t38 = t14*t20;
      t39 = t*t22;
      t41 = t36*(30.0/11.0*t15+60.0/11.0*t37+40.0/11.0*t38+10.0/11.0*t39+5.0/
77.0*t24);
      drv[0] = (2.0*r-2.0/9.0)*t12*t27+t30*(20.0/21.0*t4+4.0/7.0*t31+12.0/133.0
*t32+4.0/1197.0*t9)*t27+t41;
      drv[1] = t30*(4.0*t4+20.0/7.0*t31+4.0/7.0*t32+4.0/133.0*t9)*t27+t41;
      drv[2] = t36*(5.0*t15+120.0/11.0*t37+90.0/11.0*t38+80.0/33.0*t39+5.0/22.0
*t24);
   /* p=15 2 5 4 */
   } else if( i==2 && j==5 && k==4 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = r-1.0;
      t7 = t2*s;
      t8 = t5*t5;
      t10 = t8*t5;
      t12 = t8*t8;
      t15 = t3*s+10.0/7.0*t3*t5+5.0/7.0*t7*t8+20.0/133.0*t2*t10+5.0/399.0*s*t12
+2.0/6783.0*t12*t5;
      t17 = t*t;
      t18 = t17*t17;
      t19 = t17*t;
      t20 = s+r-1.0;
      t22 = t20*t20;
      t24 = t22*t20;
      t26 = t22*t22;
      t27 = t18+20.0/9.0*t19*t20+5.0/3.0*t17*t22+10.0/21.0*t*t24+5.0/126.0*t26;
      t29 = r*r;
      t30 = t29-2.0/9.0*r+1.0/117.0;
      t31 = t7*t5;
      t32 = t2*t8;
      t33 = s*t10;
      t37 = t30*t15;
      t38 = t20*t17;
      t39 = t*t22;
      t41 = t37*(20.0/9.0*t19+10.0/3.0*t38+10.0/7.0*t39+10.0/63.0*t24);
      drv[0] = (2.0*r-2.0/9.0)*t15*t27+t30*(10.0/7.0*t3+10.0/7.0*t31+60.0/133.0
*t32+20.0/399.0*t33+10.0/6783.0*t12)*t27+t41;
      drv[1] = t30*(5.0*t3+40.0/7.0*t31+15.0/7.0*t32+40.0/133.0*t33+5.0/399.0*
t12)*t27+t41;
      drv[2] = t37*(4.0*t19+20.0/3.0*t38+10.0/3.0*t39+10.0/21.0*t24);
   /* p=15 2 6 3 */
   } else if( i==2 && j==6 && k==3 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = t3*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t10 = t2*s;
      t11 = t8*t6;
      t13 = t8*t8;
      t15 = t13*t6;
      t18 = t3*t2+2.0*t5*t6+3.0/2.0*t3*t8+10.0/19.0*t10*t11+5.0/57.0*t2*t13+2.0
/323.0*s*t15+t13*t8/7752;
      t20 = t*t;
      t22 = s+r-1.0;
      t24 = t22*t22;
      t27 = t20*t+12.0/7.0*t22*t20+6.0/7.0*t*t24+4.0/35.0*t24*t22;
      t29 = r*r;
      t30 = t29-2.0/9.0*r+1.0/117.0;
      t31 = t3*t6;
      t32 = t10*t8;
      t33 = t2*t11;
      t34 = s*t13;
      t38 = t30*t18;
      t39 = t*t22;
      t41 = t38*(12.0/7.0*t20+12.0/7.0*t39+12.0/35.0*t24);
      drv[0] = (2.0*r-2.0/9.0)*t18*t27+t30*(2.0*t5+3.0*t31+30.0/19.0*t32+20.0/
57.0*t33+10.0/323.0*t34+t15/1292)*t27+t41;
      drv[1] = t30*(6.0*t5+10.0*t31+6.0*t32+30.0/19.0*t33+10.0/57.0*t34+2.0/
323.0*t15)*t27+t41;
      drv[2] = t38*(3.0*t20+24.0/7.0*t39+6.0/7.0*t24);
   /* p=15 2 7 2 */
   } else if( i==2 && j==7 && k==2 ) {
      t2 = s*s;
      t3 = t2*s;
      t4 = t2*t2;
      t6 = t4*t2;
      t7 = r-1.0;
      t9 = t4*s;
      t10 = t7*t7;
      t12 = t10*t7;
      t14 = t10*t10;
      t16 = t14*t7;
      t18 = t14*t10;
      t21 = t4*t3+8.0/3.0*t6*t7+14.0/5.0*t9*t10+28.0/19.0*t4*t12+70.0/171.0*t3*
t14+56.0/969.0*t2*t16+7.0/1938.0*s*t18+t14*t12/14535;
      t23 = t*t;
      t24 = s+r-1.0;
      t26 = t24*t24;
      t27 = t23+6.0/5.0*t*t24+3.0/10.0*t26;
      t29 = r*r;
      t30 = t29-2.0/9.0*r+1.0/117.0;
      t31 = t9*t7;
      t32 = t4*t10;
      t33 = t3*t12;
      t34 = t2*t14;
      t35 = s*t16;
      t39 = t30*t21;
      t41 = t39*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (2.0*r-2.0/9.0)*t21*t27+t30*(8.0/3.0*t6+28.0/5.0*t31+84.0/19.0*
t32+280.0/171.0*t33+280.0/969.0*t34+7.0/323.0*t35+7.0/14535.0*t18)*t27+t41;
      drv[1] = t30*(7.0*t6+16.0*t31+14.0*t32+112.0/19.0*t33+70.0/57.0*t34+112.0
/969.0*t35+7.0/1938.0*t18)*t27+t41;
      drv[2] = t39*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=15 2 8 1 */
   } else if( i==2 && j==8 && k==1 ) {
      t2 = s*s;
      t3 = t2*t2;
      t4 = t3*t3;
      t5 = t2*s;
      t6 = t3*t5;
      t7 = r-1.0;
      t9 = t3*t2;
      t10 = t7*t7;
      t12 = t3*s;
      t13 = t10*t7;
      t15 = t10*t10;
      t17 = t15*t7;
      t19 = t15*t10;
      t21 = t15*t13;
      t23 = t15*t15;
      t24 = t4+24.0/7.0*t6*t7+24.0/5.0*t9*t10+336.0/95.0*t12*t13+28.0/19.0*t3*
t15+112.0/323.0*t5*t17+14.0/323.0*t2*t19+4.0/1615.0*s*t21+t23/22610;
      t26 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t28 = r*r;
      t29 = t28-2.0/9.0*r+1.0/117.0;
      t30 = t9*t7;
      t31 = t12*t10;
      t32 = t3*t13;
      t33 = t5*t15;
      t34 = t2*t17;
      t35 = s*t19;
      t39 = t29*t24;
      drv[0] = (2.0*r-2.0/9.0)*t24*t26+t29*(24.0/7.0*t6+48.0/5.0*t30+1008.0/
95.0*t31+112.0/19.0*t32+560.0/323.0*t33+84.0/323.0*t34+28.0/1615.0*t35+4.0/
11305.0*t21)*t26+2.0/3.0*t39;
      drv[1] = t29*(8.0*t6+24.0*t30+144.0/5.0*t31+336.0/19.0*t32+112.0/19.0*t33
+336.0/323.0*t34+28.0/323.0*t35+4.0/1615.0*t21)*t26+2.0/3.0*t39;
      drv[2] = t39;
   /* p=15 2 9 0 */
   } else if( i==2 && j==9 && k==0 ) {
      t2 = s*s;
      t3 = t2*t2;
      t4 = t3*t3;
      t6 = r-1.0;
      t8 = t2*s;
      t9 = t3*t8;
      t10 = t6*t6;
      t12 = t3*t2;
      t13 = t10*t6;
      t15 = t3*s;
      t16 = t10*t10;
      t18 = t16*t6;
      t20 = t16*t10;
      t22 = t16*t13;
      t24 = t16*t16;
      t29 = r*r;
      t30 = t29-2.0/9.0*r+1.0/117.0;
      t31 = t9*t6;
      t32 = t12*t10;
      t33 = t15*t13;
      t34 = t3*t16;
      t35 = t8*t18;
      t36 = t2*t20;
      t37 = s*t22;
      drv[0] = (2.0*r-2.0/9.0)*(t4*s+30.0/7.0*t4*t6+54.0/7.0*t9*t10+144.0/19.0*
t12*t13+84.0/19.0*t15*t16+504.0/323.0*t3*t18+105.0/323.0*t8*t20+12.0/323.0*t2*
t22+9.0/4522.0*s*t24+t24*t6/29393)+t30*(30.0/7.0*t4+108.0/7.0*t31+432.0/19.0*
t32+336.0/19.0*t33+2520.0/323.0*t34+630.0/323.0*t35+84.0/323.0*t36+36.0/2261.0*
t37+9.0/29393.0*t24);
      drv[1] = t30*(9.0*t4+240.0/7.0*t31+54.0*t32+864.0/19.0*t33+420.0/19.0*t34
+2016.0/323.0*t35+315.0/323.0*t36+24.0/323.0*t37+9.0/4522.0*t24);
      drv[2] = 0.0;
   /* p=15 3 0 8 */
   } else if( i==3 && j==0 && k==8 ) {
      t1 = r*r;
      t3 = t*t;
      t4 = t3*t3;
      t5 = t4*t4;
      t6 = t3*t;
      t7 = t4*t6;
      t8 = s+r-1.0;
      t10 = t4*t3;
      t11 = t8*t8;
      t13 = t4*t;
      t14 = t11*t8;
      t16 = t11*t11;
      t18 = t16*t8;
      t20 = t16*t11;
      t22 = t16*t14;
      t24 = t16*t16;
      t28 = t1*r-4.0/9.0*t1+2.0/39.0*r-4.0/2925.0;
      t29 = t10*t8;
      t30 = t13*t11;
      t31 = t4*t14;
      t32 = t16*t6;
      t33 = t3*t18;
      t34 = t*t20;
      t36 = t28*(72.0/17.0*t7+252.0/17.0*t29+1764.0/85.0*t30+252.0/17.0*t31+
1260.0/221.0*t32+252.0/221.0*t33+252.0/2431.0*t34+36.0/12155.0*t22);
      drv[0] = (3.0*t1-8.0/9.0*r+2.0/39.0)*(t5+72.0/17.0*t7*t8+126.0/17.0*t10*
t11+588.0/85.0*t13*t14+63.0/17.0*t4*t16+252.0/221.0*t6*t18+42.0/221.0*t3*t20+
36.0/2431.0*t*t22+9.0/24310.0*t24)+t36;
      drv[1] = t36;
      drv[2] = t28*(8.0*t7+504.0/17.0*t29+756.0/17.0*t30+588.0/17.0*t31+252.0/
17.0*t32+756.0/221.0*t33+84.0/221.0*t34+36.0/2431.0*t22);
   /* p=15 3 1 7 */
   } else if( i==3 && j==1 && k==7 ) {
      t1 = r*r;
      t3 = s+2.0/19.0*r-2.0/19.0;
      t5 = t*t;
      t6 = t5*t;
      t7 = t5*t5;
      t9 = t7*t5;
      t10 = s+r-1.0;
      t12 = t7*t;
      t13 = t10*t10;
      t15 = t13*t10;
      t17 = t13*t13;
      t19 = t17*t10;
      t21 = t17*t13;
      t24 = t7*t6+56.0/15.0*t9*t10+28.0/5.0*t12*t13+56.0/13.0*t7*t15+70.0/39.0*
t6*t17+56.0/143.0*t5*t19+28.0/715.0*t*t21+8.0/6435.0*t17*t15;
      t27 = t1*r-4.0/9.0*t1+2.0/39.0*r-4.0/2925.0;
      t28 = t27*t24;
      t29 = t27*t3;
      t30 = t12*t10;
      t31 = t7*t13;
      t32 = t6*t15;
      t33 = t5*t17;
      t34 = t*t19;
      t36 = t29*(56.0/15.0*t9+56.0/5.0*t30+168.0/13.0*t31+280.0/39.0*t32+280.0/
143.0*t33+168.0/715.0*t34+56.0/6435.0*t21);
      drv[0] = t3*(3.0*t1-8.0/9.0*r+2.0/39.0)*t24+2.0/19.0*t28+t36;
      drv[1] = t28+t36;
      drv[2] = t29*(7.0*t9+112.0/5.0*t30+28.0*t31+224.0/13.0*t32+70.0/13.0*t33+
112.0/143.0*t34+28.0/715.0*t21);
   /* p=15 3 2 6 */
   } else if( i==3 && j==2 && k==6 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t7 = t3+6.0/19.0*s*t4+t6/57;
      t9 = t*t;
      t10 = t9*t9;
      t12 = t10*t;
      t13 = s+r-1.0;
      t15 = t13*t13;
      t17 = t9*t;
      t18 = t15*t13;
      t20 = t15*t15;
      t22 = t20*t13;
      t25 = t10*t9+42.0/13.0*t12*t13+105.0/26.0*t10*t15+350.0/143.0*t17*t18+
105.0/143.0*t9*t20+14.0/143.0*t*t22+7.0/1716.0*t20*t15;
      t28 = t1*r-4.0/9.0*t1+2.0/39.0*r-4.0/2925.0;
      t32 = t28*t7;
      t33 = t10*t13;
      t34 = t17*t15;
      t35 = t9*t18;
      t36 = t*t20;
      t38 = t32*(42.0/13.0*t12+105.0/13.0*t33+1050.0/143.0*t34+420.0/143.0*t35+
70.0/143.0*t36+7.0/286.0*t22);
      drv[0] = (3.0*t1-8.0/9.0*r+2.0/39.0)*t7*t25+t28*(6.0/19.0*s+2.0/57.0*r
-2.0/57.0)*t25+t38;
      drv[1] = t28*(2.0*s+6.0/19.0*r-6.0/19.0)*t25+t38;
      drv[2] = t32*(6.0*t12+210.0/13.0*t33+210.0/13.0*t34+1050.0/143.0*t35+
210.0/143.0*t36+14.0/143.0*t22);
   /* p=15 3 3 5 */
   } else if( i==3 && j==3 && k==5 ) {
      t1 = r*r;
      t3 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t10 = t3*s+12.0/19.0*t3*t5+2.0/19.0*s*t7+4.0/969.0*t7*t5;
      t12 = t*t;
      t13 = t12*t12;
      t15 = s+r-1.0;
      t17 = t12*t;
      t18 = t15*t15;
      t20 = t18*t15;
      t22 = t18*t18;
      t25 = t13*t+30.0/11.0*t15*t13+30.0/11.0*t17*t18+40.0/33.0*t12*t20+5.0/
22.0*t*t22+t22*t15/77;
      t28 = t1*r-4.0/9.0*t1+2.0/39.0*r-4.0/2925.0;
      t29 = s*t5;
      t33 = t28*t10;
      t34 = t17*t15;
      t35 = t12*t18;
      t36 = t*t20;
      t38 = t33*(30.0/11.0*t13+60.0/11.0*t34+40.0/11.0*t35+10.0/11.0*t36+5.0/
77.0*t22);
      drv[0] = (3.0*t1-8.0/9.0*r+2.0/39.0)*t10*t25+t28*(12.0/19.0*t3+4.0/19.0*
t29+4.0/323.0*t7)*t25+t38;
      drv[1] = t28*(3.0*t3+24.0/19.0*t29+2.0/19.0*t7)*t25+t38;
      drv[2] = t33*(5.0*t13+120.0/11.0*t34+90.0/11.0*t35+80.0/33.0*t36+5.0/22.0
*t22);
   /* p=15 3 4 4 */
   } else if( i==3 && j==4 && k==4 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t5 = t3*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t10 = t8*t6;
      t12 = t8*t8;
      t13 = t4+20.0/19.0*t5*t6+20.0/57.0*t3*t8+40.0/969.0*s*t10+5.0/3876.0*t12;
      t15 = t*t;
      t16 = t15*t15;
      t17 = t15*t;
      t18 = s+r-1.0;
      t20 = t18*t18;
      t22 = t20*t18;
      t24 = t20*t20;
      t25 = t16+20.0/9.0*t17*t18+5.0/3.0*t20*t15+10.0/21.0*t*t22+5.0/126.0*t24;
      t28 = t1*r-4.0/9.0*t1+2.0/39.0*r-4.0/2925.0;
      t29 = t3*t6;
      t30 = s*t8;
      t34 = t28*t13;
      t35 = t18*t15;
      t36 = t*t20;
      t38 = t34*(20.0/9.0*t17+10.0/3.0*t35+10.0/7.0*t36+10.0/63.0*t22);
      drv[0] = (3.0*t1-8.0/9.0*r+2.0/39.0)*t13*t25+t28*(20.0/19.0*t5+40.0/57.0*
t29+40.0/323.0*t30+5.0/969.0*t10)*t25+t38;
      drv[1] = t28*(4.0*t5+60.0/19.0*t29+40.0/57.0*t30+40.0/969.0*t10)*t25+t38;
      drv[2] = t34*(4.0*t17+20.0/3.0*t35+10.0/3.0*t36+10.0/21.0*t22);
   /* p=15 3 5 3 */
   } else if( i==3 && j==5 && k==3 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t6 = r-1.0;
      t8 = t3*s;
      t9 = t6*t6;
      t11 = t9*t6;
      t13 = t9*t9;
      t16 = t4*s+30.0/19.0*t4*t6+50.0/57.0*t8*t9+200.0/969.0*t3*t11+25.0/1292.0
*s*t13+t13*t6/1938;
      t18 = t*t;
      t20 = s+r-1.0;
      t22 = t20*t20;
      t25 = t18*t+12.0/7.0*t20*t18+6.0/7.0*t*t22+4.0/35.0*t22*t20;
      t28 = t1*r-4.0/9.0*t1+2.0/39.0*r-4.0/2925.0;
      t29 = t8*t6;
      t30 = t3*t9;
      t31 = s*t11;
      t35 = t28*t16;
      t36 = t*t20;
      t38 = t35*(12.0/7.0*t18+12.0/7.0*t36+12.0/35.0*t22);
      drv[0] = (3.0*t1-8.0/9.0*r+2.0/39.0)*t16*t25+t28*(30.0/19.0*t4+100.0/57.0
*t29+200.0/323.0*t30+25.0/323.0*t31+5.0/1938.0*t13)*t25+t38;
      drv[1] = t28*(5.0*t4+120.0/19.0*t29+50.0/19.0*t30+400.0/969.0*t31+25.0/
1292.0*t13)*t25+t38;
      drv[2] = t35*(3.0*t18+24.0/7.0*t36+6.0/7.0*t22);
   /* p=15 3 6 2 */
   } else if( i==3 && j==6 && k==2 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t6 = t4*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t11 = t3*s;
      t12 = t9*t7;
      t14 = t9*t9;
      t16 = t14*t7;
      t19 = t4*t3+42.0/19.0*t6*t7+35.0/19.0*t4*t9+700.0/969.0*t11*t12+175.0/
1292.0*t3*t14+7.0/646.0*s*t16+t14*t9/3876;
      t21 = t*t;
      t22 = s+r-1.0;
      t24 = t22*t22;
      t25 = t21+6.0/5.0*t*t22+3.0/10.0*t24;
      t28 = t1*r-4.0/9.0*t1+2.0/39.0*r-4.0/2925.0;
      t29 = t4*t7;
      t30 = t11*t9;
      t31 = t3*t12;
      t32 = s*t14;
      t36 = t28*t19;
      t38 = t36*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (3.0*t1-8.0/9.0*r+2.0/39.0)*t19*t25+t28*(42.0/19.0*t6+70.0/19.0*
t29+700.0/323.0*t30+175.0/323.0*t31+35.0/646.0*t32+t16/646)*t25+t38;
      drv[1] = t28*(6.0*t6+210.0/19.0*t29+140.0/19.0*t30+700.0/323.0*t31+175.0/
646.0*t32+7.0/646.0*t16)*t25+t38;
      drv[2] = t36*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=15 3 7 1 */
   } else if( i==3 && j==7 && k==1 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*s;
      t5 = t3*t3;
      t7 = t5*t3;
      t8 = r-1.0;
      t10 = t5*s;
      t11 = t8*t8;
      t13 = t11*t8;
      t15 = t11*t11;
      t17 = t15*t8;
      t19 = t15*t11;
      t22 = t5*t4+56.0/19.0*t7*t8+196.0/57.0*t10*t11+1960.0/969.0*t5*t13+1225.0
/1938.0*t4*t15+98.0/969.0*t3*t17+7.0/969.0*s*t19+2.0/12597.0*t15*t13;
      t24 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t27 = t1*r-4.0/9.0*t1+2.0/39.0*r-4.0/2925.0;
      t28 = t10*t8;
      t29 = t5*t11;
      t30 = t4*t13;
      t31 = t3*t15;
      t32 = s*t17;
      t36 = t27*t22;
      drv[0] = (3.0*t1-8.0/9.0*r+2.0/39.0)*t22*t24+t27*(56.0/19.0*t7+392.0/57.0
*t28+1960.0/323.0*t29+2450.0/969.0*t30+490.0/969.0*t31+14.0/323.0*t32+14.0/
12597.0*t19)*t24+2.0/3.0*t36;
      drv[1] = t27*(7.0*t7+336.0/19.0*t28+980.0/57.0*t29+7840.0/969.0*t30+
1225.0/646.0*t31+196.0/969.0*t32+7.0/969.0*t19)*t24+2.0/3.0*t36;
      drv[2] = t36;
   /* p=15 3 8 0 */
   } else if( i==3 && j==8 && k==0 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t5 = t4*t4;
      t6 = t3*s;
      t7 = t4*t6;
      t8 = r-1.0;
      t10 = t4*t3;
      t11 = t8*t8;
      t13 = t4*s;
      t14 = t11*t8;
      t16 = t11*t11;
      t18 = t16*t8;
      t20 = t16*t11;
      t22 = t16*t14;
      t24 = t16*t16;
      t28 = t1*r-4.0/9.0*t1+2.0/39.0*r-4.0/2925.0;
      t29 = t10*t8;
      t30 = t13*t11;
      t31 = t4*t14;
      t32 = t6*t16;
      t33 = t3*t18;
      t34 = s*t20;
      drv[0] = (3.0*t1-8.0/9.0*r+2.0/39.0)*(t5+72.0/19.0*t7*t8+112.0/19.0*t10*
t11+1568.0/323.0*t13*t14+735.0/323.0*t4*t16+196.0/323.0*t6*t18+28.0/323.0*t3*
t20+24.0/4199.0*s*t22+t24/8398)+t28*(72.0/19.0*t7+224.0/19.0*t29+4704.0/323.0*
t30+2940.0/323.0*t31+980.0/323.0*t32+168.0/323.0*t33+168.0/4199.0*t34+4.0/
4199.0*t22);
      drv[1] = t28*(8.0*t7+504.0/19.0*t29+672.0/19.0*t30+7840.0/323.0*t31+
2940.0/323.0*t32+588.0/323.0*t33+56.0/323.0*t34+24.0/4199.0*t22);
      drv[2] = 0.0;
   /* p=15 4 0 7 */
   } else if( i==4 && j==0 && k==7 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = t*t;
      t5 = t4*t;
      t6 = t4*t4;
      t8 = t4*t6;
      t9 = s+r-1.0;
      t11 = t6*t;
      t12 = t9*t9;
      t14 = t12*t9;
      t16 = t12*t12;
      t18 = t16*t9;
      t20 = t16*t12;
      t25 = t1*t1;
      t26 = t25-20.0/27.0*t2+20.0/117.0*t1-8.0/585.0*r+1.0/3510.0;
      t27 = t11*t9;
      t28 = t6*t12;
      t29 = t5*t14;
      t30 = t4*t16;
      t31 = t*t18;
      t33 = t26*(56.0/15.0*t8+56.0/5.0*t27+168.0/13.0*t28+280.0/39.0*t29+280.0/
143.0*t30+168.0/715.0*t31+56.0/6435.0*t20);
      drv[0] = (4.0*t2-20.0/9.0*t1+40.0/117.0*r-8.0/585.0)*(t6*t5+56.0/15.0*t8*
t9+28.0/5.0*t11*t12+56.0/13.0*t6*t14+70.0/39.0*t5*t16+56.0/143.0*t4*t18+28.0/
715.0*t*t20+8.0/6435.0*t16*t14)+t33;
      drv[1] = t33;
      drv[2] = t26*(7.0*t8+112.0/5.0*t27+28.0*t28+224.0/13.0*t29+70.0/13.0*t30+
112.0/143.0*t31+28.0/715.0*t20);
   /* p=15 4 1 6 */
   } else if( i==4 && j==1 && k==6 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s+2.0/17.0*r-2.0/17.0;
      t6 = t*t;
      t7 = t6*t6;
      t9 = t7*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      t14 = t6*t;
      t15 = t12*t10;
      t17 = t12*t12;
      t19 = t17*t10;
      t22 = t7*t6+42.0/13.0*t9*t10+105.0/26.0*t7*t12+350.0/143.0*t14*t15+105.0/
143.0*t6*t17+14.0/143.0*t*t19+7.0/1716.0*t17*t12;
      t24 = t1*t1;
      t25 = t24-20.0/27.0*t2+20.0/117.0*t1-8.0/585.0*r+1.0/3510.0;
      t26 = t25*t22;
      t27 = t25*t4;
      t28 = t7*t10;
      t29 = t14*t12;
      t30 = t6*t15;
      t31 = t*t17;
      t33 = t27*(42.0/13.0*t9+105.0/13.0*t28+1050.0/143.0*t29+420.0/143.0*t30+
70.0/143.0*t31+7.0/286.0*t19);
      drv[0] = (4.0*t2-20.0/9.0*t1+40.0/117.0*r-8.0/585.0)*t4*t22+2.0/17.0*t26+
t33;
      drv[1] = t26+t33;
      drv[2] = t27*(6.0*t9+210.0/13.0*t28+210.0/13.0*t29+1050.0/143.0*t30+210.0
/143.0*t31+14.0/143.0*t19);
   /* p=15 4 2 5 */
   } else if( i==4 && j==2 && k==5 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t8 = t4+6.0/17.0*s*t5+3.0/136.0*t7;
      t10 = t*t;
      t11 = t10*t10;
      t13 = s+r-1.0;
      t15 = t10*t;
      t16 = t13*t13;
      t18 = t16*t13;
      t20 = t16*t16;
      t23 = t11*t+30.0/11.0*t11*t13+30.0/11.0*t15*t16+40.0/33.0*t10*t18+5.0/
22.0*t*t20+t20*t13/77;
      t25 = t1*t1;
      t26 = t25-20.0/27.0*t2+20.0/117.0*t1-8.0/585.0*r+1.0/3510.0;
      t30 = t26*t8;
      t31 = t15*t13;
      t32 = t10*t16;
      t33 = t*t18;
      t35 = t30*(30.0/11.0*t11+60.0/11.0*t31+40.0/11.0*t32+10.0/11.0*t33+5.0/
77.0*t20);
      drv[0] = (4.0*t2-20.0/9.0*t1+40.0/117.0*r-8.0/585.0)*t8*t23+t26*(6.0/17.0
*s+3.0/68.0*r-3.0/68.0)*t23+t35;
      drv[1] = t26*(2.0*s+6.0/17.0*r-6.0/17.0)*t23+t35;
      drv[2] = t30*(5.0*t11+120.0/11.0*t31+90.0/11.0*t32+80.0/33.0*t33+5.0/22.0
*t20);
   /* p=15 4 3 4 */
   } else if( i==4 && j==3 && k==4 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t11 = t4*s+12.0/17.0*t4*t6+9.0/68.0*s*t8+t8*t6/170;
      t13 = t*t;
      t14 = t13*t13;
      t15 = t13*t;
      t16 = s+r-1.0;
      t18 = t16*t16;
      t20 = t18*t16;
      t22 = t18*t18;
      t23 = t14+20.0/9.0*t15*t16+5.0/3.0*t13*t18+10.0/21.0*t*t20+5.0/126.0*t22;
      t25 = t1*t1;
      t26 = t25-20.0/27.0*t2+20.0/117.0*t1-8.0/585.0*r+1.0/3510.0;
      t27 = s*t6;
      t31 = t26*t11;
      t32 = t16*t13;
      t33 = t*t18;
      t35 = t31*(20.0/9.0*t15+10.0/3.0*t32+10.0/7.0*t33+10.0/63.0*t20);
      drv[0] = (4.0*t2-20.0/9.0*t1+40.0/117.0*r-8.0/585.0)*t11*t23+t26*(12.0/
17.0*t4+9.0/34.0*t27+3.0/170.0*t8)*t23+t35;
      drv[1] = t26*(3.0*t4+24.0/17.0*t27+9.0/68.0*t8)*t23+t35;
      drv[2] = t31*(4.0*t15+20.0/3.0*t32+10.0/3.0*t33+10.0/21.0*t20);
   /* p=15 4 4 3 */
   } else if( i==4 && j==4 && k==3 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t5 = t4*t4;
      t6 = t4*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t11 = t9*t7;
      t13 = t9*t9;
      t14 = t5+20.0/17.0*t6*t7+15.0/34.0*t4*t9+s*t11/17+t13/476;
      t16 = t*t;
      t18 = s+r-1.0;
      t20 = t18*t18;
      t23 = t16*t+12.0/7.0*t18*t16+6.0/7.0*t*t20+4.0/35.0*t20*t18;
      t25 = t1*t1;
      t26 = t25-20.0/27.0*t2+20.0/117.0*t1-8.0/585.0*r+1.0/3510.0;
      t27 = t4*t7;
      t28 = s*t9;
      t32 = t26*t14;
      t33 = t*t18;
      t35 = t32*(12.0/7.0*t16+12.0/7.0*t33+12.0/35.0*t20);
      drv[0] = (4.0*t2-20.0/9.0*t1+40.0/117.0*r-8.0/585.0)*t14*t23+t26*(20.0/
17.0*t6+15.0/17.0*t27+3.0/17.0*t28+t11/119)*t23+t35;
      drv[1] = t26*(4.0*t6+60.0/17.0*t27+15.0/17.0*t28+t11/17)*t23+t35;
      drv[2] = t32*(3.0*t16+24.0/7.0*t33+6.0/7.0*t20);
   /* p=15 4 5 2 */
   } else if( i==4 && j==5 && k==2 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t5 = t4*t4;
      t7 = r-1.0;
      t9 = t4*s;
      t10 = t7*t7;
      t12 = t10*t7;
      t14 = t10*t10;
      t17 = t5*s+30.0/17.0*t5*t7+75.0/68.0*t9*t10+5.0/17.0*t4*t12+15.0/476.0*s*
t14+3.0/3094.0*t14*t7;
      t19 = t*t;
      t20 = s+r-1.0;
      t22 = t20*t20;
      t23 = t19+6.0/5.0*t*t20+3.0/10.0*t22;
      t25 = t1*t1;
      t26 = t25-20.0/27.0*t2+20.0/117.0*t1-8.0/585.0*r+1.0/3510.0;
      t27 = t9*t7;
      t28 = t4*t10;
      t29 = s*t12;
      t33 = t26*t17;
      t35 = t33*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (4.0*t2-20.0/9.0*t1+40.0/117.0*r-8.0/585.0)*t17*t23+t26*(30.0/
17.0*t5+75.0/34.0*t27+15.0/17.0*t28+15.0/119.0*t29+15.0/3094.0*t14)*t23+t35;
      drv[1] = t26*(5.0*t5+120.0/17.0*t27+225.0/68.0*t28+10.0/17.0*t29+15.0/
476.0*t14)*t23+t35;
      drv[2] = t33*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=15 4 6 1 */
   } else if( i==4 && j==6 && k==1 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t5 = t4*t4;
      t7 = t5*s;
      t8 = r-1.0;
      t10 = t8*t8;
      t12 = t4*s;
      t13 = t10*t8;
      t15 = t10*t10;
      t17 = t15*t8;
      t20 = t5*t4+42.0/17.0*t7*t8+315.0/136.0*t5*t10+35.0/34.0*t12*t13+15.0/
68.0*t4*t15+9.0/442.0*s*t17+t15*t10/1768;
      t22 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t24 = t1*t1;
      t25 = t24-20.0/27.0*t2+20.0/117.0*t1-8.0/585.0*r+1.0/3510.0;
      t26 = t5*t8;
      t27 = t12*t10;
      t28 = t4*t13;
      t29 = s*t15;
      t33 = t25*t20;
      drv[0] = (4.0*t2-20.0/9.0*t1+40.0/117.0*r-8.0/585.0)*t20*t22+t25*(42.0/
17.0*t7+315.0/68.0*t26+105.0/34.0*t27+15.0/17.0*t28+45.0/442.0*t29+3.0/884.0*
t17)*t22+2.0/3.0*t33;
      drv[1] = t25*(6.0*t7+210.0/17.0*t26+315.0/34.0*t27+105.0/34.0*t28+15.0/
34.0*t29+9.0/442.0*t17)*t22+2.0/3.0*t33;
      drv[2] = t33;
   /* p=15 4 7 0 */
   } else if( i==4 && j==7 && k==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t4 = s*s;
      t5 = t4*s;
      t6 = t4*t4;
      t8 = t6*t4;
      t9 = r-1.0;
      t11 = t6*s;
      t12 = t9*t9;
      t14 = t12*t9;
      t16 = t12*t12;
      t18 = t16*t9;
      t20 = t16*t12;
      t25 = t1*t1;
      t26 = t25-20.0/27.0*t2+20.0/117.0*t1-8.0/585.0*r+1.0/3510.0;
      t27 = t11*t9;
      t28 = t6*t12;
      t29 = t5*t14;
      t30 = t4*t16;
      t31 = s*t18;
      drv[0] = (4.0*t2-20.0/9.0*t1+40.0/117.0*r-8.0/585.0)*(t6*t5+56.0/17.0*t8*
t9+147.0/34.0*t11*t12+49.0/17.0*t6*t14+35.0/34.0*t5*t16+42.0/221.0*t4*t18+7.0/
442.0*s*t20+t16*t14/2431)+t26*(56.0/17.0*t8+147.0/17.0*t27+147.0/17.0*t28+70.0/
17.0*t29+210.0/221.0*t30+21.0/221.0*t31+7.0/2431.0*t20);
      drv[1] = t26*(7.0*t8+336.0/17.0*t27+735.0/34.0*t28+196.0/17.0*t29+105.0/
34.0*t30+84.0/221.0*t31+7.0/442.0*t20);
      drv[2] = 0.0;
   /* p=15 5 0 6 */
   } else if( i==5 && j==0 && k==6 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = t*t;
      t6 = t5*t5;
      t8 = t6*t;
      t9 = s+r-1.0;
      t11 = t9*t9;
      t13 = t5*t;
      t14 = t11*t9;
      t16 = t11*t11;
      t18 = t16*t9;
      t24 = t2*r-10.0/9.0*t2+50.0/117.0*t3-8.0/117.0*t1+r/234-1.0/13455.0;
      t25 = t6*t9;
      t26 = t13*t11;
      t27 = t5*t14;
      t28 = t*t16;
      t30 = t24*(42.0/13.0*t8+105.0/13.0*t25+1050.0/143.0*t26+420.0/143.0*t27+
70.0/143.0*t28+7.0/286.0*t18);
      drv[0] = (5.0*t2-40.0/9.0*t3+50.0/39.0*t1-16.0/117.0*r+1.0/234.0)*(t6*t5+
42.0/13.0*t8*t9+105.0/26.0*t6*t11+350.0/143.0*t13*t14+105.0/143.0*t5*t16+14.0/
143.0*t*t18+7.0/1716.0*t16*t11)+t30;
      drv[1] = t30;
      drv[2] = t24*(6.0*t8+210.0/13.0*t25+210.0/13.0*t26+1050.0/143.0*t27+210.0
/143.0*t28+14.0/143.0*t18);
   /* p=15 5 1 5 */
   } else if( i==5 && j==1 && k==5 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s+2.0/15.0*r-2.0/15.0;
      t7 = t*t;
      t8 = t7*t7;
      t10 = s+r-1.0;
      t12 = t7*t;
      t13 = t10*t10;
      t15 = t13*t10;
      t17 = t13*t13;
      t20 = t8*t+30.0/11.0*t8*t10+30.0/11.0*t12*t13+40.0/33.0*t7*t15+5.0/22.0*t
*t17+t17*t10/77;
      t23 = t2*r-10.0/9.0*t2+50.0/117.0*t3-8.0/117.0*t1+r/234-1.0/13455.0;
      t24 = t23*t20;
      t25 = t23*t5;
      t26 = t12*t10;
      t27 = t7*t13;
      t28 = t*t15;
      t30 = t25*(30.0/11.0*t8+60.0/11.0*t26+40.0/11.0*t27+10.0/11.0*t28+5.0/
77.0*t17);
      drv[0] = (5.0*t2-40.0/9.0*t3+50.0/39.0*t1-16.0/117.0*r+1.0/234.0)*t5*t20+
2.0/15.0*t24+t30;
      drv[1] = t24+t30;
      drv[2] = t25*(5.0*t8+120.0/11.0*t26+90.0/11.0*t27+80.0/33.0*t28+5.0/22.0*
t17);
   /* p=15 5 2 4 */
   } else if( i==5 && j==2 && k==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t9 = t5+2.0/5.0*s*t6+t8/35;
      t11 = t*t;
      t12 = t11*t11;
      t13 = t11*t;
      t14 = s+r-1.0;
      t16 = t14*t14;
      t18 = t16*t14;
      t20 = t16*t16;
      t21 = t12+20.0/9.0*t13*t14+5.0/3.0*t11*t16+10.0/21.0*t*t18+5.0/126.0*t20;
      t24 = t2*r-10.0/9.0*t2+50.0/117.0*t3-8.0/117.0*t1+r/234-1.0/13455.0;
      t28 = t24*t9;
      t29 = t11*t14;
      t30 = t*t16;
      t32 = t28*(20.0/9.0*t13+10.0/3.0*t29+10.0/7.0*t30+10.0/63.0*t18);
      drv[0] = (5.0*t2-40.0/9.0*t3+50.0/39.0*t1-16.0/117.0*r+1.0/234.0)*t9*t21+
t24*(2.0/5.0*s+2.0/35.0*r-2.0/35.0)*t21+t32;
      drv[1] = t24*(2.0*s+2.0/5.0*r-2.0/5.0)*t21+t32;
      drv[2] = t28*(4.0*t13+20.0/3.0*t29+10.0/3.0*t30+10.0/21.0*t18);
   /* p=15 5 3 3 */
   } else if( i==5 && j==3 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t12 = t5*s+4.0/5.0*t5*t7+6.0/35.0*s*t9+4.0/455.0*t9*t7;
      t14 = t*t;
      t16 = s+r-1.0;
      t18 = t16*t16;
      t21 = t14*t+12.0/7.0*t16*t14+6.0/7.0*t*t18+4.0/35.0*t18*t16;
      t24 = t2*r-10.0/9.0*t2+50.0/117.0*t3-8.0/117.0*t1+r/234-1.0/13455.0;
      t25 = s*t7;
      t29 = t24*t12;
      t30 = t*t16;
      t32 = t29*(12.0/7.0*t14+12.0/7.0*t30+12.0/35.0*t18);
      drv[0] = (5.0*t2-40.0/9.0*t3+50.0/39.0*t1-16.0/117.0*r+1.0/234.0)*t12*t21
+t24*(4.0/5.0*t5+12.0/35.0*t25+12.0/455.0*t9)*t21+t32;
      drv[1] = t24*(3.0*t5+8.0/5.0*t25+6.0/35.0*t9)*t21+t32;
      drv[2] = t29*(3.0*t14+24.0/7.0*t30+6.0/7.0*t18);
   /* p=15 5 4 2 */
   } else if( i==5 && j==4 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s*s;
      t6 = t5*t5;
      t7 = t5*s;
      t8 = r-1.0;
      t10 = t8*t8;
      t12 = t10*t8;
      t14 = t10*t10;
      t15 = t6+4.0/3.0*t7*t8+4.0/7.0*t5*t10+8.0/91.0*s*t12+t14/273;
      t17 = t*t;
      t18 = s+r-1.0;
      t20 = t18*t18;
      t21 = t17+6.0/5.0*t*t18+3.0/10.0*t20;
      t24 = t2*r-10.0/9.0*t2+50.0/117.0*t3-8.0/117.0*t1+r/234-1.0/13455.0;
      t25 = t5*t8;
      t26 = s*t10;
      t30 = t24*t15;
      t32 = t30*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (5.0*t2-40.0/9.0*t3+50.0/39.0*t1-16.0/117.0*r+1.0/234.0)*t15*t21
+t24*(4.0/3.0*t7+8.0/7.0*t25+24.0/91.0*t26+4.0/273.0*t12)*t21+t32;
      drv[1] = t24*(4.0*t7+4.0*t25+8.0/7.0*t26+8.0/91.0*t12)*t21+t32;
      drv[2] = t30*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=15 5 5 1 */
   } else if( i==5 && j==5 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s*s;
      t6 = t5*t5;
      t8 = r-1.0;
      t10 = t5*s;
      t11 = t8*t8;
      t13 = t11*t8;
      t15 = t11*t11;
      t18 = t6*s+2.0*t6*t8+10.0/7.0*t10*t11+40.0/91.0*t5*t13+5.0/91.0*s*t15+2.0
/1001.0*t15*t8;
      t20 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t23 = t2*r-10.0/9.0*t2+50.0/117.0*t3-8.0/117.0*t1+r/234-1.0/13455.0;
      t24 = t10*t8;
      t25 = t5*t11;
      t26 = s*t13;
      t30 = t23*t18;
      drv[0] = (5.0*t2-40.0/9.0*t3+50.0/39.0*t1-16.0/117.0*r+1.0/234.0)*t18*t20
+t23*(2.0*t6+20.0/7.0*t24+120.0/91.0*t25+20.0/91.0*t26+10.0/1001.0*t15)*t20+2.0
/3.0*t30;
      drv[1] = t23*(5.0*t6+8.0*t24+30.0/7.0*t25+80.0/91.0*t26+5.0/91.0*t15)*t20
+2.0/3.0*t30;
      drv[2] = t30;
   /* p=15 5 6 0 */
   } else if( i==5 && j==6 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t1*r;
      t5 = s*s;
      t6 = t5*t5;
      t8 = t6*s;
      t9 = r-1.0;
      t11 = t9*t9;
      t13 = t5*s;
      t14 = t11*t9;
      t16 = t11*t11;
      t18 = t16*t9;
      t24 = t2*r-10.0/9.0*t2+50.0/117.0*t3-8.0/117.0*t1+r/234-1.0/13455.0;
      t25 = t6*t9;
      t26 = t13*t11;
      t27 = t5*t14;
      t28 = s*t16;
      drv[0] = (5.0*t2-40.0/9.0*t3+50.0/39.0*t1-16.0/117.0*r+1.0/234.0)*(t6*t5+
14.0/5.0*t8*t9+3.0*t6*t11+20.0/13.0*t13*t14+5.0/13.0*t5*t16+6.0/143.0*s*t18+t16
*t11/715)+t24*(14.0/5.0*t8+6.0*t25+60.0/13.0*t26+20.0/13.0*t27+30.0/143.0*t28+
6.0/715.0*t18);
      drv[1] = t24*(6.0*t8+14.0*t25+12.0*t26+60.0/13.0*t27+10.0/13.0*t28+6.0/
143.0*t18);
      drv[2] = 0.0;
   /* p=15 6 0 5 */
   } else if( i==6 && j==0 && k==5 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t6 = t*t;
      t7 = t6*t6;
      t9 = s+r-1.0;
      t11 = t6*t;
      t12 = t9*t9;
      t14 = t12*t9;
      t16 = t12*t12;
      t22 = t2*t1-14.0/9.0*t3+35.0/39.0*t2-28.0/117.0*t4+7.0/234.0*t1-7.0/
4485.0*r+7.0/296010.0;
      t23 = t11*t9;
      t24 = t6*t12;
      t25 = t*t14;
      t27 = t22*(30.0/11.0*t7+60.0/11.0*t23+40.0/11.0*t24+10.0/11.0*t25+5.0/
77.0*t16);
      drv[0] = (6.0*t3-70.0/9.0*t2+140.0/39.0*t4-28.0/39.0*t1+7.0/117.0*r-7.0/
4485.0)*(t7*t+30.0/11.0*t7*t9+30.0/11.0*t11*t12+40.0/33.0*t6*t14+5.0/22.0*t*t16
+t16*t9/77)+t27;
      drv[1] = t27;
      drv[2] = t22*(5.0*t7+120.0/11.0*t23+90.0/11.0*t24+80.0/33.0*t25+5.0/22.0*
t16);
   /* p=15 6 1 4 */
   } else if( i==6 && j==1 && k==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t6 = s+2.0/13.0*r-2.0/13.0;
      t8 = t*t;
      t9 = t8*t8;
      t10 = t8*t;
      t11 = s+r-1.0;
      t13 = t11*t11;
      t15 = t13*t11;
      t17 = t13*t13;
      t18 = t9+20.0/9.0*t10*t11+5.0/3.0*t8*t13+10.0/21.0*t*t15+5.0/126.0*t17;
      t21 = t2*t1-14.0/9.0*t3+35.0/39.0*t2-28.0/117.0*t4+7.0/234.0*t1-7.0/
4485.0*r+7.0/296010.0;
      t22 = t21*t18;
      t23 = t21*t6;
      t24 = t8*t11;
      t25 = t*t13;
      t27 = t23*(20.0/9.0*t10+10.0/3.0*t24+10.0/7.0*t25+10.0/63.0*t15);
      drv[0] = (6.0*t3-70.0/9.0*t2+140.0/39.0*t4-28.0/39.0*t1+7.0/117.0*r-7.0/
4485.0)*t6*t18+2.0/13.0*t22+t27;
      drv[1] = t22+t27;
      drv[2] = t23*(4.0*t10+20.0/3.0*t24+10.0/3.0*t25+10.0/21.0*t15);
   /* p=15 6 2 3 */
   } else if( i==6 && j==2 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t6 = s*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t10 = t6+6.0/13.0*s*t7+t9/26;
      t12 = t*t;
      t14 = s+r-1.0;
      t16 = t14*t14;
      t19 = t12*t+12.0/7.0*t12*t14+6.0/7.0*t*t16+4.0/35.0*t16*t14;
      t22 = t2*t1-14.0/9.0*t3+35.0/39.0*t2-28.0/117.0*t4+7.0/234.0*t1-7.0/
4485.0*r+7.0/296010.0;
      t26 = t22*t10;
      t27 = t*t14;
      t29 = t26*(12.0/7.0*t12+12.0/7.0*t27+12.0/35.0*t16);
      drv[0] = (6.0*t3-70.0/9.0*t2+140.0/39.0*t4-28.0/39.0*t1+7.0/117.0*r-7.0/
4485.0)*t10*t19+t22*(6.0/13.0*s+r/13-1.0/13.0)*t19+t29;
      drv[1] = t22*(2.0*s+6.0/13.0*r-6.0/13.0)*t19+t29;
      drv[2] = t26*(3.0*t12+24.0/7.0*t27+6.0/7.0*t16);
   /* p=15 6 3 2 */
   } else if( i==6 && j==3 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t6 = s*s;
      t8 = r-1.0;
      t10 = t8*t8;
      t13 = t6*s+12.0/13.0*t6*t8+3.0/13.0*s*t10+2.0/143.0*t10*t8;
      t15 = t*t;
      t16 = s+r-1.0;
      t18 = t16*t16;
      t19 = t15+6.0/5.0*t*t16+3.0/10.0*t18;
      t22 = t2*t1-14.0/9.0*t3+35.0/39.0*t2-28.0/117.0*t4+7.0/234.0*t1-7.0/
4485.0*r+7.0/296010.0;
      t23 = s*t8;
      t27 = t22*t13;
      t29 = t27*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (6.0*t3-70.0/9.0*t2+140.0/39.0*t4-28.0/39.0*t1+7.0/117.0*r-7.0/
4485.0)*t13*t19+t22*(12.0/13.0*t6+6.0/13.0*t23+6.0/143.0*t10)*t19+t29;
      drv[1] = t22*(3.0*t6+24.0/13.0*t23+3.0/13.0*t10)*t19+t29;
      drv[2] = t27*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=15 6 4 1 */
   } else if( i==6 && j==4 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t6 = s*s;
      t7 = t6*t6;
      t8 = t6*s;
      t9 = r-1.0;
      t11 = t9*t9;
      t13 = t11*t9;
      t15 = t11*t11;
      t16 = t7+20.0/13.0*t8*t9+10.0/13.0*t6*t11+20.0/143.0*s*t13+t15/143;
      t18 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t21 = t2*t1-14.0/9.0*t3+35.0/39.0*t2-28.0/117.0*t4+7.0/234.0*t1-7.0/
4485.0*r+7.0/296010.0;
      t22 = t6*t9;
      t23 = s*t11;
      t27 = t21*t16;
      drv[0] = (6.0*t3-70.0/9.0*t2+140.0/39.0*t4-28.0/39.0*t1+7.0/117.0*r-7.0/
4485.0)*t16*t18+t21*(20.0/13.0*t8+20.0/13.0*t22+60.0/143.0*t23+4.0/143.0*t13)*
t18+2.0/3.0*t27;
      drv[1] = t21*(4.0*t8+60.0/13.0*t22+20.0/13.0*t23+20.0/143.0*t13)*t18+2.0/
3.0*t27;
      drv[2] = t27;
   /* p=15 6 5 0 */
   } else if( i==6 && j==5 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*r;
      t4 = t1*r;
      t6 = s*s;
      t7 = t6*t6;
      t9 = r-1.0;
      t11 = t6*s;
      t12 = t9*t9;
      t14 = t12*t9;
      t16 = t12*t12;
      t22 = t2*t1-14.0/9.0*t3+35.0/39.0*t2-28.0/117.0*t4+7.0/234.0*t1-7.0/
4485.0*r+7.0/296010.0;
      t23 = t11*t9;
      t24 = t6*t12;
      t25 = s*t14;
      drv[0] = (6.0*t3-70.0/9.0*t2+140.0/39.0*t4-28.0/39.0*t1+7.0/117.0*r-7.0/
4485.0)*(t7*s+30.0/13.0*t7*t9+25.0/13.0*t11*t12+100.0/143.0*t6*t14+15.0/143.0*s
*t16+2.0/429.0*t16*t9)+t22*(30.0/13.0*t7+50.0/13.0*t23+300.0/143.0*t24+60.0/
143.0*t25+10.0/429.0*t16);
      drv[1] = t22*(5.0*t7+120.0/13.0*t23+75.0/13.0*t24+200.0/143.0*t25+15.0/
143.0*t16);
      drv[2] = 0.0;
   /* p=15 7 0 4 */
   } else if( i==7 && j==0 && k==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t2*r;
      t5 = t1*r;
      t7 = t*t;
      t8 = t7*t7;
      t9 = t7*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      t14 = t12*t10;
      t16 = t12*t12;
      t20 = t2*t5-56.0/27.0*t3+196.0/117.0*t4-392.0/585.0*t2+49.0/351.0*t5
-196.0/13455.0*t1+98.0/148005.0*r-4.0/444015.0;
      t21 = t7*t10;
      t22 = t*t12;
      t24 = t20*(20.0/9.0*t9+10.0/3.0*t21+10.0/7.0*t22+10.0/63.0*t14);
      drv[0] = (7.0*t3-112.0/9.0*t4+980.0/117.0*t2-1568.0/585.0*t5+49.0/117.0*
t1-392.0/13455.0*r+98.0/148005.0)*(t8+20.0/9.0*t9*t10+5.0/3.0*t7*t12+10.0/21.0*
t*t14+5.0/126.0*t16)+t24;
      drv[1] = t24;
      drv[2] = t20*(4.0*t9+20.0/3.0*t21+10.0/3.0*t22+10.0/21.0*t14);
   /* p=15 7 1 3 */
   } else if( i==7 && j==1 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t2*r;
      t5 = t1*r;
      t7 = s+2.0/11.0*r-2.0/11.0;
      t9 = t*t;
      t11 = s+r-1.0;
      t13 = t11*t11;
      t16 = t9*t+12.0/7.0*t9*t11+6.0/7.0*t*t13+4.0/35.0*t13*t11;
      t19 = t2*t5-56.0/27.0*t3+196.0/117.0*t4-392.0/585.0*t2+49.0/351.0*t5
-196.0/13455.0*t1+98.0/148005.0*r-4.0/444015.0;
      t20 = t19*t16;
      t21 = t19*t7;
      t22 = t*t11;
      t24 = t21*(12.0/7.0*t9+12.0/7.0*t22+12.0/35.0*t13);
      drv[0] = (7.0*t3-112.0/9.0*t4+980.0/117.0*t2-1568.0/585.0*t5+49.0/117.0*
t1-392.0/13455.0*r+98.0/148005.0)*t7*t16+2.0/11.0*t20+t24;
      drv[1] = t20+t24;
      drv[2] = t21*(3.0*t9+24.0/7.0*t22+6.0/7.0*t13);
   /* p=15 7 2 2 */
   } else if( i==7 && j==2 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t2*r;
      t5 = t1*r;
      t7 = s*s;
      t8 = r-1.0;
      t10 = t8*t8;
      t11 = t7+6.0/11.0*s*t8+3.0/55.0*t10;
      t13 = t*t;
      t14 = s+r-1.0;
      t16 = t14*t14;
      t17 = t13+6.0/5.0*t*t14+3.0/10.0*t16;
      t20 = t2*t5-56.0/27.0*t3+196.0/117.0*t4-392.0/585.0*t2+49.0/351.0*t5
-196.0/13455.0*t1+98.0/148005.0*r-4.0/444015.0;
      t24 = t20*t11;
      t26 = t24*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (7.0*t3-112.0/9.0*t4+980.0/117.0*t2-1568.0/585.0*t5+49.0/117.0*
t1-392.0/13455.0*r+98.0/148005.0)*t11*t17+t20*(6.0/11.0*s+6.0/55.0*r-6.0/55.0)*
t17+t26;
      drv[1] = t20*(2.0*s+6.0/11.0*r-6.0/11.0)*t17+t26;
      drv[2] = t24*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=15 7 3 1 */
   } else if( i==7 && j==3 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t2*r;
      t5 = t1*r;
      t7 = s*s;
      t9 = r-1.0;
      t11 = t9*t9;
      t14 = t7*s+12.0/11.0*t7*t9+18.0/55.0*s*t11+4.0/165.0*t11*t9;
      t16 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t19 = t2*t5-56.0/27.0*t3+196.0/117.0*t4-392.0/585.0*t2+49.0/351.0*t5
-196.0/13455.0*t1+98.0/148005.0*r-4.0/444015.0;
      t20 = s*t9;
      t24 = t19*t14;
      drv[0] = (7.0*t3-112.0/9.0*t4+980.0/117.0*t2-1568.0/585.0*t5+49.0/117.0*
t1-392.0/13455.0*r+98.0/148005.0)*t14*t16+t19*(12.0/11.0*t7+36.0/55.0*t20+4.0/
55.0*t11)*t16+2.0/3.0*t24;
      drv[1] = t19*(3.0*t7+24.0/11.0*t20+18.0/55.0*t11)*t16+2.0/3.0*t24;
      drv[2] = t24;
   /* p=15 7 4 0 */
   } else if( i==7 && j==4 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t1;
      t4 = t2*r;
      t5 = t1*r;
      t7 = s*s;
      t8 = t7*t7;
      t9 = t7*s;
      t10 = r-1.0;
      t12 = t10*t10;
      t14 = t12*t10;
      t16 = t12*t12;
      t20 = t2*t5-56.0/27.0*t3+196.0/117.0*t4-392.0/585.0*t2+49.0/351.0*t5
-196.0/13455.0*t1+98.0/148005.0*r-4.0/444015.0;
      t21 = t7*t10;
      t22 = s*t12;
      drv[0] = (7.0*t3-112.0/9.0*t4+980.0/117.0*t2-1568.0/585.0*t5+49.0/117.0*
t1-392.0/13455.0*r+98.0/148005.0)*(t8+20.0/11.0*t9*t10+12.0/11.0*t7*t12+8.0/
33.0*s*t14+t16/66)+t20*(20.0/11.0*t9+24.0/11.0*t21+8.0/11.0*t22+2.0/33.0*t14);
      drv[1] = t20*(4.0*t9+60.0/11.0*t21+24.0/11.0*t22+8.0/33.0*t14);
      drv[2] = 0.0;
   /* p=15 8 0 3 */
   } else if( i==8 && j==0 && k==3 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t4 = t3*t2;
      t5 = t3*t1;
      t6 = t3*r;
      t8 = t*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      t17 = t3*t3;
      t18 = t17-8.0/3.0*t4+112.0/39.0*t5-1568.0/975.0*t6+98.0/195.0*t3-392.0/
4485.0*t2+392.0/49335.0*t1-16.0/49335.0*r+1.0/246675.0;
      t19 = t*t10;
      t21 = t18*(12.0/7.0*t8+12.0/7.0*t19+12.0/35.0*t12);
      drv[0] = (8.0*t4-56.0/3.0*t5+224.0/13.0*t6-1568.0/195.0*t3+392.0/195.0*t2
-392.0/1495.0*t1+784.0/49335.0*r-16.0/49335.0)*(t8*t+12.0/7.0*t8*t10+6.0/7.0*t*
t12+4.0/35.0*t12*t10)+t21;
      drv[1] = t21;
      drv[2] = t18*(3.0*t8+24.0/7.0*t19+6.0/7.0*t12);
   /* p=15 8 1 2 */
   } else if( i==8 && j==1 && k==2 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t4 = t3*t2;
      t5 = t3*t1;
      t6 = t3*r;
      t8 = s+2.0/9.0*r-2.0/9.0;
      t10 = t*t;
      t11 = s+r-1.0;
      t13 = t11*t11;
      t14 = t10+6.0/5.0*t*t11+3.0/10.0*t13;
      t16 = t3*t3;
      t17 = t16-8.0/3.0*t4+112.0/39.0*t5-1568.0/975.0*t6+98.0/195.0*t3-392.0/
4485.0*t2+392.0/49335.0*t1-16.0/49335.0*r+1.0/246675.0;
      t18 = t17*t14;
      t19 = t17*t8;
      t21 = t19*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (8.0*t4-56.0/3.0*t5+224.0/13.0*t6-1568.0/195.0*t3+392.0/195.0*t2
-392.0/1495.0*t1+784.0/49335.0*r-16.0/49335.0)*t8*t14+2.0/9.0*t18+t21;
      drv[1] = t18+t21;
      drv[2] = t19*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=15 8 2 1 */
   } else if( i==8 && j==2 && k==1 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t4 = t3*t2;
      t5 = t3*t1;
      t6 = t3*r;
      t8 = s*s;
      t9 = r-1.0;
      t11 = t9*t9;
      t12 = t8+2.0/3.0*s*t9+t11/12;
      t14 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t16 = t3*t3;
      t17 = t16-8.0/3.0*t4+112.0/39.0*t5-1568.0/975.0*t6+98.0/195.0*t3-392.0/
4485.0*t2+392.0/49335.0*t1-16.0/49335.0*r+1.0/246675.0;
      t21 = t17*t12;
      drv[0] = (8.0*t4-56.0/3.0*t5+224.0/13.0*t6-1568.0/195.0*t3+392.0/195.0*t2
-392.0/1495.0*t1+784.0/49335.0*r-16.0/49335.0)*t12*t14+t17*(2.0/3.0*s+r/6-1.0/
6.0)*t14+2.0/3.0*t21;
      drv[1] = t17*(2.0*s+2.0/3.0*r-2.0/3.0)*t14+2.0/3.0*t21;
      drv[2] = t21;
   /* p=15 8 3 0 */
   } else if( i==8 && j==3 && k==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t4 = t3*t2;
      t5 = t3*t1;
      t6 = t3*r;
      t8 = s*s;
      t10 = r-1.0;
      t12 = t10*t10;
      t17 = t3*t3;
      t18 = t17-8.0/3.0*t4+112.0/39.0*t5-1568.0/975.0*t6+98.0/195.0*t3-392.0/
4485.0*t2+392.0/49335.0*t1-16.0/49335.0*r+1.0/246675.0;
      t19 = s*t10;
      drv[0] = (8.0*t4-56.0/3.0*t5+224.0/13.0*t6-1568.0/195.0*t3+392.0/195.0*t2
-392.0/1495.0*t1+784.0/49335.0*r-16.0/49335.0)*(t8*s+4.0/3.0*t8*t10+s*t12/2+t12
*t10/21)+t18*(4.0/3.0*t8+t19+t12/7);
      drv[1] = t18*(3.0*t8+8.0/3.0*t19+t12/2);
      drv[2] = 0.0;
   /* p=15 9 0 2 */
   } else if( i==9 && j==0 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*r;
      t5 = t4*t2;
      t6 = t2*t1;
      t7 = t2*r;
      t9 = t*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      t16 = t3*r-10.0/3.0*t3+60.0/13.0*t5-224.0/65.0*t6+98.0/65.0*t7-588.0/
1495.0*t2+196.0/3289.0*t4-16.0/3289.0*t1+3.0/16445.0*r-2.0/937365.0;
      t18 = t16*(6.0/5.0*t+3.0/5.0*s+3.0/5.0*r-3.0/5.0);
      drv[0] = (9.0*t3-80.0/3.0*t5+420.0/13.0*t6-1344.0/65.0*t7+98.0/13.0*t2
-2352.0/1495.0*t4+588.0/3289.0*t1-32.0/3289.0*r+3.0/16445.0)*(t9+6.0/5.0*t*t10+
3.0/10.0*t12)+t18;
      drv[1] = t18;
      drv[2] = t16*(2.0*t+6.0/5.0*s+6.0/5.0*r-6.0/5.0);
   /* p=15 9 1 1 */
   } else if( i==9 && j==1 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*r;
      t5 = t4*t2;
      t6 = t2*t1;
      t7 = t2*r;
      t9 = s+2.0/7.0*r-2.0/7.0;
      t11 = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
      t14 = t3*r-10.0/3.0*t3+60.0/13.0*t5-224.0/65.0*t6+98.0/65.0*t7-588.0/
1495.0*t2+196.0/3289.0*t4-16.0/3289.0*t1+3.0/16445.0*r-2.0/937365.0;
      t15 = t14*t11;
      t16 = t14*t9;
      drv[0] = (9.0*t3-80.0/3.0*t5+420.0/13.0*t6-1344.0/65.0*t7+98.0/13.0*t2
-2352.0/1495.0*t4+588.0/3289.0*t1-32.0/3289.0*r+3.0/16445.0)*t9*t11+2.0/7.0*t15
+2.0/3.0*t16;
      drv[1] = t15+2.0/3.0*t16;
      drv[2] = t16;
   /* p=15 9 2 0 */
   } else if( i==9 && j==2 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*r;
      t5 = t4*t2;
      t6 = t2*t1;
      t7 = t2*r;
      t9 = s*s;
      t10 = r-1.0;
      t12 = t10*t10;
      t16 = t3*r-10.0/3.0*t3+60.0/13.0*t5-224.0/65.0*t6+98.0/65.0*t7-588.0/
1495.0*t2+196.0/3289.0*t4-16.0/3289.0*t1+3.0/16445.0*r-2.0/937365.0;
      drv[0] = (9.0*t3-80.0/3.0*t5+420.0/13.0*t6-1344.0/65.0*t7+98.0/13.0*t2
-2352.0/1495.0*t4+588.0/3289.0*t1-32.0/3289.0*r+3.0/16445.0)*(t9+6.0/7.0*s*t10+
t12/7)+t16*(6.0/7.0*s+2.0/7.0*r-2.0/7.0);
      drv[1] = t16*(2.0*s+6.0/7.0*r-6.0/7.0);
      drv[2] = 0.0;
   /* p=15 10 0 1 */
   } else if( i==10 && j==0 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t3*r;
      t5 = t1*r;
      t6 = t2*t5;
      t7 = t2*t1;
      t8 = t2*r;
      t12 = t3*t1;
      t13 = (10.0*t4-110.0/3.0*t3+2200.0/39.0*t6-616.0/13.0*t7+308.0/13.0*t8
-2156.0/299.0*t2+392.0/299.0*t5-40.0/299.0*t1+2.0/299.0*r-2.0/17043.0)*(t+2.0/
3.0*s+2.0/3.0*r-2.0/3.0)+2.0/3.0*t12-220.0/81.0*t4+550.0/117.0*t3-176.0/39.0*t6
+308.0/117.0*t7-4312.0/4485.0*t8+196.0/897.0*t2-80.0/2691.0*t5+2.0/897.0*t1-4.0
/51129.0*r+2.0/2300805.0;
      t14 = 2.0/3.0*t12-220.0/81.0*t4+550.0/117.0*t3-176.0/39.0*t6+308.0/117.0*
t7-4312.0/4485.0*t8+196.0/897.0*t2-80.0/2691.0*t5+2.0/897.0*t1-4.0/51129.0*r+
2.0/2300805.0;
      t15 = t12-110.0/27.0*t4+275.0/39.0*t3-88.0/13.0*t6+154.0/39.0*t7-2156.0/
1495.0*t8+98.0/299.0*t2-40.0/897.0*t5+t1/299-2.0/17043.0*r+1.0/766935.0;
      drv[0] = t13;
      drv[1] = t14;
      drv[2] = t15;
   /* p=15 10 1 0 */
   } else if( i==10 && j==1 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t3*r;
      t5 = t1*r;
      t6 = t2*t5;
      t7 = t2*t1;
      t8 = t2*r;
      t12 = t3*t1;
      t13 = (10.0*t4-110.0/3.0*t3+2200.0/39.0*t6-616.0/13.0*t7+308.0/13.0*t8
-2156.0/299.0*t2+392.0/299.0*t5-40.0/299.0*t1+2.0/299.0*r-2.0/17043.0)*(s+2.0/
5.0*r-2.0/5.0)+2.0/5.0*t12-44.0/27.0*t4+110.0/39.0*t3-176.0/65.0*t6+308.0/195.0
*t7-4312.0/7475.0*t8+196.0/1495.0*t2-16.0/897.0*t5+2.0/1495.0*t1-4.0/85215.0*r+
2.0/3834675.0;
      t14 = t12-110.0/27.0*t4+275.0/39.0*t3-88.0/13.0*t6+154.0/39.0*t7-2156.0/
1495.0*t8+98.0/299.0*t2-40.0/897.0*t5+t1/299-2.0/17043.0*r+1.0/766935.0;
      drv[0] = t13;
      drv[1] = t14;
      drv[2] = 0.0;
   /* p=15 11 0 0 */
   } else if( i==11 && j==0 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t6 = t1*r;
      t10 = 11.0*t3*t1-440.0/9.0*t3*r+1210.0/13.0*t3-3872.0/39.0*t2*t6+847.0/
13.0*t2*t1-40656.0/1495.0*t2*r+2156.0/299.0*t2-352.0/299.0*t6+33.0/299.0*t1
-88.0/17043.0*r+22.0/255645.0;
      drv[0] = t10;
      drv[1] = 0.0;
      drv[2] = 0.0;

    } else
      return 0;
    return 1;
}
#ifdef __cplusplus
}
#endif
