/*-------------------------------------------------------------------------
  Scientific Computation Research Center, RPI, Troy NY
  (C) Copyright 1995, RPI-SCOREC
 
  Project  : shapeFuntions
  Author(s): Saikat Dey
  Creation : Oct., 95
  Modifi.  : 
  Function :
             return the "body" mode for a tetrahedron. i,j,k are the highest
             monomial orders of r,s,t in the resulting polynomial order
             NOTE: code generated by Maple.
-------------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

double Bn(int i, int j, int k, double r, double s, double t) {
   double f = 0.0; 
   double t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15,t16,t17,t18;
   double t19,t20,t21,t22,t23,t24,t25,t26,t27,t28,t29,t30,t31,t32,t33,t34;
   double t35,t36,t37,t38,t39,t40,t41,t42,t43,t44,t45;

   /* p=4 0 0 0 */
   if( i==0 && j==0 && k==0 ) {
      f = 1.0;
   /* p=5 0 0 1 */
   } else if( i==0 && j==0 && k==1 ) {
      f = t+2.0/3.0*s+2.0/3.0*r-2.0/3.0;
   /* p=5 0 1 0 */
   } else if( i==0 && j==1 && k==0 ) {
      f = s+2.0/5.0*r-2.0/5.0;
   /* p=5 1 0 0 */
   } else if( i==1 && j==0 && k==0 ) {
      f = r-2.0/7.0;
   /* p=6 0 0 2 */
   } else if( i==0 && j==0 && k==2 ) {
      t1 = t*t;
      t2 = s+r-1.0;
      t4 = t2*t2;
      f = t1+6.0/5.0*t*t2+3.0/10.0*t4;
   /* p=6 0 1 1 */
   } else if( i==0 && j==1 && k==1 ) {
      f = (s+2.0/7.0*r-2.0/7.0)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=6 0 2 0 */
   } else if( i==0 && j==2 && k==0 ) {
      t1 = s*s;
      t2 = r-1.0;
      t4 = t2*t2;
      f = t1+6.0/7.0*t2*s+t4/7;
   /* p=6 1 0 1 */
   } else if( i==1 && j==0 && k==1 ) {
      f = (r-2.0/9.0)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=6 1 1 0 */
   } else if( i==1 && j==1 && k==0 ) {
      f = (r-2.0/9.0)*(s+2.0/5.0*r-2.0/5.0);
   /* p=6 2 0 0 */
   } else if( i==2 && j==0 && k==0 ) {
      t1 = r*r;
      f = t1-2.0/3.0*r+1.0/12.0;
   /* p=7 0 0 3 */
   } else if( i==0 && j==0 && k==3 ) {
      t1 = t*t;
      t3 = s+r-1.0;
      t5 = t3*t3;
      f = t1*t+12.0/7.0*t3*t1+6.0/7.0*t*t5+4.0/35.0*t3*t5;
   /* p=7 0 1 2 */
   } else if( i==0 && j==1 && k==2 ) {
      t2 = t*t;
      t3 = s+r-1.0;
      t5 = t3*t3;
      f = (s+2.0/9.0*r-2.0/9.0)*(t2+6.0/5.0*t*t3+3.0/10.0*t5);
   /* p=7 0 2 1 */
   } else if( i==0 && j==2 && k==1 ) {
      t1 = s*s;
      t2 = r-1.0;
      t4 = t2*t2;
      f = (t1+2.0/3.0*s*t2+t4/12)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=7 0 3 0 */
   } else if( i==0 && j==3 && k==0 ) {
      t1 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      f = t1*s+4.0/3.0*t1*t3+s*t5/2+t5*t3/21;
   /* p=7 1 0 2 */
   } else if( i==1 && j==0 && k==2 ) {
      t2 = t*t;
      t3 = s+r-1.0;
      t5 = t3*t3;
      f = (r-2.0/11.0)*(t2+6.0/5.0*t*t3+3.0/10.0*t5);
   /* p=7 1 1 1 */
   } else if( i==1 && j==1 && k==1 ) {
      f = (r-2.0/11.0)*(s+2.0/7.0*r-2.0/7.0)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=7 1 2 0 */
   } else if( i==1 && j==2 && k==0 ) {
      t2 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      f = (r-2.0/11.0)*(t2+6.0/7.0*s*t3+t5/7);
   /* p=7 2 0 1 */
   } else if( i==2 && j==0 && k==1 ) {
      t1 = r*r;
      f = (t1-6.0/11.0*r+3.0/55.0)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=7 2 1 0 */
   } else if( i==2 && j==1 && k==0 ) {
      t1 = r*r;
      f = (t1-6.0/11.0*r+3.0/55.0)*(s+2.0/5.0*r-2.0/5.0);
   /* p=7 3 0 0 */
   } else if( i==3 && j==0 && k==0 ) {
      t1 = r*r;
      f = t1*r-12.0/11.0*t1+18.0/55.0*r-4.0/165.0;
   /* p=8 0 0 4 */
   } else if( i==0 && j==0 && k==4 ) {
      t1 = t*t;
      t2 = t1*t1;
      t4 = s+r-1.0;
      t6 = t4*t4;
      t10 = t6*t6;
      f = t2+20.0/9.0*t1*t*t4+5.0/3.0*t1*t6+10.0/21.0*t*t6*t4+5.0/126.0*t10;
   /* p=8 0 1 3 */
   } else if( i==0 && j==1 && k==3 ) {
      t2 = t*t;
      t4 = s+r-1.0;
      t6 = t4*t4;
      f = (s+2.0/11.0*r-2.0/11.0)*(t2*t+12.0/7.0*t2*t4+6.0/7.0*t*t6+4.0/35.0*
t6*t4);
   /* p=8 0 2 2 */
   } else if( i==0 && j==2 && k==2 ) {
      t1 = s*s;
      t2 = r-1.0;
      t4 = t2*t2;
      t6 = t*t;
      t7 = s+r-1.0;
      t9 = t7*t7;
      f = (t1+6.0/11.0*s*t2+3.0/55.0*t4)*(t6+6.0/5.0*t*t7+3.0/10.0*t9);
   /* p=8 0 3 1 */
   } else if( i==0 && j==3 && k==1 ) {
      t1 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      f = (t1*s+12.0/11.0*t1*t3+18.0/55.0*s*t5+4.0/165.0*t5*t3)*(t+2.0/3.0*s+
2.0/3.0*r-2.0/3.0);
   /* p=8 0 4 0 */
   } else if( i==0 && j==4 && k==0 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t6 = t4*t4;
      t10 = t6*t6;
      f = t2+20.0/11.0*t1*s*t4+12.0/11.0*t1*t6+8.0/33.0*s*t6*t4+t10/66;
   /* p=8 1 0 3 */
   } else if( i==1 && j==0 && k==3 ) {
      t2 = t*t;
      t4 = s+r-1.0;
      t6 = t4*t4;
      f = (r-2.0/13.0)*(t2*t+12.0/7.0*t2*t4+6.0/7.0*t*t6+4.0/35.0*t6*t4);
   /* p=8 1 1 2 */
   } else if( i==1 && j==1 && k==2 ) {
      t4 = t*t;
      t5 = s+r-1.0;
      t7 = t5*t5;
      f = (r-2.0/13.0)*(s+2.0/9.0*r-2.0/9.0)*(t4+6.0/5.0*t*t5+3.0/10.0*t7);
   /* p=8 1 2 1 */
   } else if( i==1 && j==2 && k==1 ) {
      t2 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      f = (r-2.0/13.0)*(t2+2.0/3.0*s*t3+t5/12)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=8 1 3 0 */
   } else if( i==1 && j==3 && k==0 ) {
      t2 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      f = (r-2.0/13.0)*(t2*s+4.0/3.0*t2*t4+s*t6/2+t6*t4/21);
   /* p=8 2 0 2 */
   } else if( i==2 && j==0 && k==2 ) {
      t1 = r*r;
      t3 = t*t;
      t4 = s+r-1.0;
      t6 = t4*t4;
      f = (t1-6.0/13.0*r+1.0/26.0)*(t3+6.0/5.0*t*t4+3.0/10.0*t6);
   /* p=8 2 1 1 */
   } else if( i==2 && j==1 && k==1 ) {
      t1 = r*r;
      f = (t1-6.0/13.0*r+1.0/26.0)*(s+2.0/7.0*r-2.0/7.0)*(t+2.0/3.0*s+2.0/3.0*
r-2.0/3.0);
   /* p=8 2 2 0 */
   } else if( i==2 && j==2 && k==0 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      f = (t1-6.0/13.0*r+1.0/26.0)*(t3+6.0/7.0*s*t4+t6/7);
   /* p=8 3 0 1 */
   } else if( i==3 && j==0 && k==1 ) {
      t1 = r*r;
      f = (t1*r-12.0/13.0*t1+3.0/13.0*r-2.0/143.0)*(t+2.0/3.0*s+2.0/3.0*r-2.0/
3.0);
   /* p=8 3 1 0 */
   } else if( i==3 && j==1 && k==0 ) {
      t1 = r*r;
      f = (t1*r-12.0/13.0*t1+3.0/13.0*r-2.0/143.0)*(s+2.0/5.0*r-2.0/5.0);
   /* p=8 4 0 0 */
   } else if( i==4 && j==0 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      f = t2-20.0/13.0*t1*r+10.0/13.0*t1-20.0/143.0*r+1.0/143.0;
   /* p=9 0 0 5 */
   } else if( i==0 && j==0 && k==5 ) {
      t1 = t*t;
      t2 = t1*t1;
      t4 = s+r-1.0;
      t7 = t4*t4;
      t11 = t7*t7;
      f = t2*t+30.0/11.0*t2*t4+30.0/11.0*t1*t*t7+40.0/33.0*t1*t7*t4+5.0/22.0*
t*t11+t11*t4/77;
   /* p=9 0 1 4 */
   } else if( i==0 && j==1 && k==4 ) {
      t2 = t*t;
      t3 = t2*t2;
      t5 = s+r-1.0;
      t7 = t5*t5;
      t11 = t7*t7;
      f = (s+2.0/13.0*r-2.0/13.0)*(t3+20.0/9.0*t2*t*t5+5.0/3.0*t2*t7+10.0/
21.0*t*t7*t5+5.0/126.0*t11);
   /* p=9 0 2 3 */
   } else if( i==0 && j==2 && k==3 ) {
      t1 = s*s;
      t2 = r-1.0;
      t4 = t2*t2;
      t6 = t*t;
      t8 = s+r-1.0;
      t10 = t8*t8;
      f = (t1+6.0/13.0*t2*s+t4/26)*(t6*t+12.0/7.0*t6*t8+6.0/7.0*t*t10+4.0/
35.0*t10*t8);
   /* p=9 0 3 2 */
   } else if( i==0 && j==3 && k==2 ) {
      t1 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t9 = t*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      f = (t1*s+12.0/13.0*t1*t3+3.0/13.0*s*t5+2.0/143.0*t5*t3)*(t9+6.0/5.0*t*
t10+3.0/10.0*t12);
   /* p=9 0 4 1 */
   } else if( i==0 && j==4 && k==1 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t6 = t4*t4;
      t10 = t6*t6;
      f = (t2+20.0/13.0*t1*s*t4+10.0/13.0*t1*t6+20.0/143.0*s*t6*t4+t10/143)*(
t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=9 0 5 0 */
   } else if( i==0 && j==5 && k==0 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t7 = t4*t4;
      t11 = t7*t7;
      f = t2*s+30.0/13.0*t2*t4+25.0/13.0*t1*s*t7+100.0/143.0*t1*t7*t4+15.0/
143.0*s*t11+2.0/429.0*t11*t4;
   /* p=9 1 0 4 */
   } else if( i==1 && j==0 && k==4 ) {
      t2 = t*t;
      t3 = t2*t2;
      t5 = s+r-1.0;
      t7 = t5*t5;
      t11 = t7*t7;
      f = (r-2.0/15.0)*(t3+20.0/9.0*t2*t*t5+5.0/3.0*t2*t7+10.0/21.0*t*t7*t5+
5.0/126.0*t11);
   /* p=9 1 1 3 */
   } else if( i==1 && j==1 && k==3 ) {
      t4 = t*t;
      t6 = s+r-1.0;
      t8 = t6*t6;
      f = (r-2.0/15.0)*(s+2.0/11.0*r-2.0/11.0)*(t4*t+12.0/7.0*t4*t6+6.0/7.0*t
*t8+4.0/35.0*t8*t6);
   /* p=9 1 2 2 */
   } else if( i==1 && j==2 && k==2 ) {
      t2 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t8 = t*t;
      t9 = s+r-1.0;
      t11 = t9*t9;
      f = (r-2.0/15.0)*(t2+6.0/11.0*s*t3+3.0/55.0*t5)*(t8+6.0/5.0*t*t9+3.0/
10.0*t11);
   /* p=9 1 3 1 */
   } else if( i==1 && j==3 && k==1 ) {
      t2 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      f = (r-2.0/15.0)*(t2*s+12.0/11.0*t2*t4+18.0/55.0*s*t6+4.0/165.0*t4*t6)*
(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=9 1 4 0 */
   } else if( i==1 && j==4 && k==0 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = r-1.0;
      t7 = t5*t5;
      t11 = t7*t7;
      f = (r-2.0/15.0)*(t3+20.0/11.0*t2*s*t5+12.0/11.0*t2*t7+8.0/33.0*s*t7*t5
+t11/66);
   /* p=9 2 0 3 */
   } else if( i==2 && j==0 && k==3 ) {
      t1 = r*r;
      t3 = t*t;
      t5 = s+r-1.0;
      t7 = t5*t5;
      f = (t1-2.0/5.0*r+1.0/35.0)*(t3*t+12.0/7.0*t3*t5+6.0/7.0*t*t7+4.0/35.0*
t7*t5);
   /* p=9 2 1 2 */
   } else if( i==2 && j==1 && k==2 ) {
      t1 = r*r;
      t5 = t*t;
      t6 = s+r-1.0;
      t8 = t6*t6;
      f = (t1-2.0/5.0*r+1.0/35.0)*(s+2.0/9.0*r-2.0/9.0)*(t5+6.0/5.0*t*t6+3.0/
10.0*t8);
   /* p=9 2 2 1 */
   } else if( i==2 && j==2 && k==1 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      f = (t1-2.0/5.0*r+1.0/35.0)*(t3+2.0/3.0*s*t4+t6/12)*(t+2.0/3.0*s+2.0/
3.0*r-2.0/3.0);
   /* p=9 2 3 0 */
   } else if( i==2 && j==3 && k==0 ) {
      t1 = r*r;
      t3 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      f = (t1-2.0/5.0*r+1.0/35.0)*(s*t3+4.0/3.0*t3*t5+s*t7/2+t7*t5/21);
   /* p=9 3 0 2 */
   } else if( i==3 && j==0 && k==2 ) {
      t1 = r*r;
      t4 = t*t;
      t5 = s+r-1.0;
      t7 = t5*t5;
      f = (t1*r-4.0/5.0*t1+6.0/35.0*r-4.0/455.0)*(t4+6.0/5.0*t*t5+3.0/10.0*t7)
;
   /* p=9 3 1 1 */
   } else if( i==3 && j==1 && k==1 ) {
      t1 = r*r;
      f = (t1*r-4.0/5.0*t1+6.0/35.0*r-4.0/455.0)*(s+2.0/7.0*r-2.0/7.0)*(t+2.0/
3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=9 3 2 0 */
   } else if( i==3 && j==2 && k==0 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      f = (t1*r-4.0/5.0*t1+6.0/35.0*r-4.0/455.0)*(t4+6.0/7.0*s*t5+t7/7);
   /* p=9 4 0 1 */
   } else if( i==4 && j==0 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      f = (t2-4.0/3.0*t1*r+4.0/7.0*t1-8.0/91.0*r+1.0/273.0)*(t+2.0/3.0*s+2.0/
3.0*r-2.0/3.0);
   /* p=9 4 1 0 */
   } else if( i==4 && j==1 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      f = (t2-4.0/3.0*t1*r+4.0/7.0*t1-8.0/91.0*r+1.0/273.0)*(s+2.0/5.0*r-2.0/
5.0);
   /* p=9 5 0 0 */
   } else if( i==5 && j==0 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      f = t2*r-2.0*t2+10.0/7.0*t1*r-40.0/91.0*t1+5.0/91.0*r-2.0/1001.0;
   /* p=10 0 0 6 */
   } else if( i==0 && j==0 && k==6 ) {
      t1 = t*t;
      t2 = t1*t1;
      t5 = s+r-1.0;
      t7 = t5*t5;
      t12 = t7*t7;
      f = t2*t1+42.0/13.0*t2*t*t5+105.0/26.0*t2*t7+350.0/143.0*t1*t*t7*t5+
105.0/143.0*t1*t12+14.0/143.0*t*t12*t5+7.0/1716.0*t12*t7;
   /* p=10 0 1 5 */
   } else if( i==0 && j==1 && k==5 ) {
      t2 = t*t;
      t3 = t2*t2;
      t5 = s+r-1.0;
      t8 = t5*t5;
      t12 = t8*t8;
      f = (s+2.0/15.0*r-2.0/15.0)*(t3*t+30.0/11.0*t3*t5+30.0/11.0*t2*t*t8+
40.0/33.0*t2*t8*t5+5.0/22.0*t*t12+t12*t5/77);
   /* p=10 0 2 4 */
   } else if( i==0 && j==2 && k==4 ) {
      t1 = s*s;
      t2 = r-1.0;
      t4 = t2*t2;
      t6 = t*t;
      t7 = t6*t6;
      t9 = s+r-1.0;
      t11 = t9*t9;
      t15 = t11*t11;
      f = (t1+2.0/5.0*s*t2+t4/35)*(t7+20.0/9.0*t6*t*t9+5.0/3.0*t6*t11+10.0/
21.0*t*t11*t9+5.0/126.0*t15);
   /* p=10 0 3 3 */
   } else if( i==0 && j==3 && k==3 ) {
      t1 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t9 = t*t;
      t11 = s+r-1.0;
      t13 = t11*t11;
      f = (t1*s+4.0/5.0*t1*t3+6.0/35.0*s*t5+4.0/455.0*t3*t5)*(t9*t+12.0/7.0*
t11*t9+6.0/7.0*t*t13+4.0/35.0*t13*t11);
   /* p=10 0 4 2 */
   } else if( i==0 && j==4 && k==2 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t6 = t4*t4;
      t10 = t6*t6;
      t12 = t*t;
      t13 = s+r-1.0;
      t15 = t13*t13;
      f = (t2+4.0/3.0*t1*s*t4+4.0/7.0*t1*t6+8.0/91.0*s*t6*t4+t10/273)*(t12+
6.0/5.0*t*t13+3.0/10.0*t15);
   /* p=10 0 5 1 */
   } else if( i==0 && j==5 && k==1 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t7 = t4*t4;
      t11 = t7*t7;
      f = (s*t2+2.0*t2*t4+10.0/7.0*t1*s*t7+40.0/91.0*t1*t7*t4+5.0/91.0*s*t11+
2.0/1001.0*t11*t4)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=10 0 6 0 */
   } else if( i==0 && j==6 && k==0 ) {
      t1 = s*s;
      t2 = t1*t1;
      t5 = r-1.0;
      t7 = t5*t5;
      t12 = t7*t7;
      f = t2*t1+14.0/5.0*t2*s*t5+3.0*t2*t7+20.0/13.0*t1*s*t7*t5+5.0/13.0*t1*
t12+6.0/143.0*s*t12*t5+t12*t7/715;
   /* p=10 1 0 5 */
   } else if( i==1 && j==0 && k==5 ) {
      t2 = t*t;
      t3 = t2*t2;
      t5 = s+r-1.0;
      t8 = t5*t5;
      t12 = t8*t8;
      f = (r-2.0/17.0)*(t3*t+30.0/11.0*t3*t5+30.0/11.0*t2*t*t8+40.0/33.0*t2*
t8*t5+5.0/22.0*t*t12+t12*t5/77);
   /* p=10 1 1 4 */
   } else if( i==1 && j==1 && k==4 ) {
      t4 = t*t;
      t5 = t4*t4;
      t7 = s+r-1.0;
      t9 = t7*t7;
      t13 = t9*t9;
      f = (r-2.0/17.0)*(s+2.0/13.0*r-2.0/13.0)*(t5+20.0/9.0*t4*t*t7+5.0/3.0*
t4*t9+10.0/21.0*t*t9*t7+5.0/126.0*t13);
   /* p=10 1 2 3 */
   } else if( i==1 && j==2 && k==3 ) {
      t2 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t8 = t*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      f = (r-2.0/17.0)*(t2+6.0/13.0*s*t3+t5/26)*(t8*t+12.0/7.0*t8*t10+6.0/7.0
*t*t12+4.0/35.0*t12*t10);
   /* p=10 1 3 2 */
   } else if( i==1 && j==3 && k==2 ) {
      t2 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t11 = t*t;
      t12 = s+r-1.0;
      t14 = t12*t12;
      f = (r-2.0/17.0)*(t2*s+12.0/13.0*t2*t4+3.0/13.0*s*t6+2.0/143.0*t6*t4)*(
t11+6.0/5.0*t*t12+3.0/10.0*t14);
   /* p=10 1 4 1 */
   } else if( i==1 && j==4 && k==1 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = r-1.0;
      t7 = t5*t5;
      t11 = t7*t7;
      f = (r-2.0/17.0)*(t3+20.0/13.0*t2*s*t5+10.0/13.0*t2*t7+20.0/143.0*s*t7*
t5+t11/143)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=10 1 5 0 */
   } else if( i==1 && j==5 && k==0 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = r-1.0;
      t8 = t5*t5;
      t12 = t8*t8;
      f = (r-2.0/17.0)*(s*t3+30.0/13.0*t3*t5+25.0/13.0*t2*s*t8+100.0/143.0*t2
*t8*t5+15.0/143.0*s*t12+2.0/429.0*t12*t5);
   /* p=10 2 0 4 */
   } else if( i==2 && j==0 && k==4 ) {
      t1 = r*r;
      t3 = t*t;
      t4 = t3*t3;
      t6 = s+r-1.0;
      t8 = t6*t6;
      t12 = t8*t8;
      f = (t1-6.0/17.0*r+3.0/136.0)*(t4+20.0/9.0*t3*t*t6+5.0/3.0*t3*t8+10.0/
21.0*t*t8*t6+5.0/126.0*t12);
   /* p=10 2 1 3 */
   } else if( i==2 && j==1 && k==3 ) {
      t1 = r*r;
      t5 = t*t;
      t7 = s+r-1.0;
      t9 = t7*t7;
      f = (t1-6.0/17.0*r+3.0/136.0)*(s+2.0/11.0*r-2.0/11.0)*(t5*t+12.0/7.0*t7
*t5+6.0/7.0*t*t9+4.0/35.0*t9*t7);
   /* p=10 2 2 2 */
   } else if( i==2 && j==2 && k==2 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t9 = t*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      f = (t1-6.0/17.0*r+3.0/136.0)*(t3+6.0/11.0*s*t4+3.0/55.0*t6)*(t9+6.0/
5.0*t*t10+3.0/10.0*t12);
   /* p=10 2 3 1 */
   } else if( i==2 && j==3 && k==1 ) {
      t1 = r*r;
      t3 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      f = (t1-6.0/17.0*r+3.0/136.0)*(s*t3+12.0/11.0*t3*t5+18.0/55.0*s*t7+4.0/
165.0*t7*t5)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=10 2 4 0 */
   } else if( i==2 && j==4 && k==0 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t6 = r-1.0;
      t8 = t6*t6;
      t12 = t8*t8;
      f = (t1-6.0/17.0*r+3.0/136.0)*(t4+20.0/11.0*t3*s*t6+12.0/11.0*t3*t8+8.0
/33.0*s*t8*t6+t12/66);
   /* p=10 3 0 3 */
   } else if( i==3 && j==0 && k==3 ) {
      t1 = r*r;
      t4 = t*t;
      t6 = s+r-1.0;
      t8 = t6*t6;
      f = (t1*r-12.0/17.0*t1+9.0/68.0*r-1.0/170.0)*(t4*t+12.0/7.0*t4*t6+6.0/
7.0*t*t8+4.0/35.0*t8*t6);
   /* p=10 3 1 2 */
   } else if( i==3 && j==1 && k==2 ) {
      t1 = r*r;
      t6 = t*t;
      t7 = s+r-1.0;
      t9 = t7*t7;
      f = (t1*r-12.0/17.0*t1+9.0/68.0*r-1.0/170.0)*(s+2.0/9.0*r-2.0/9.0)*(t6+
6.0/5.0*t*t7+3.0/10.0*t9);
   /* p=10 3 2 1 */
   } else if( i==3 && j==2 && k==1 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      f = (t1*r-12.0/17.0*t1+9.0/68.0*r-1.0/170.0)*(t4+2.0/3.0*s*t5+t7/12)*(t
+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=10 3 3 0 */
   } else if( i==3 && j==3 && k==0 ) {
      t1 = r*r;
      t4 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      f = (t1*r-12.0/17.0*t1+9.0/68.0*r-1.0/170.0)*(t4*s+4.0/3.0*t4*t6+s*t8/2
+t8*t6/21);
   /* p=10 4 0 2 */
   } else if( i==4 && j==0 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = t*t;
      t6 = s+r-1.0;
      t8 = t6*t6;
      f = (t2-20.0/17.0*t1*r+15.0/34.0*t1-r/17+1.0/476.0)*(t5+6.0/5.0*t*t6+
3.0/10.0*t8);
   /* p=10 4 1 1 */
   } else if( i==4 && j==1 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      f = (t2-20.0/17.0*t1*r+15.0/34.0*t1-r/17+1.0/476.0)*(s+2.0/7.0*r-2.0/7.0
)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=10 4 2 0 */
   } else if( i==4 && j==2 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      f = (t2-20.0/17.0*t1*r+15.0/34.0*t1-r/17+1.0/476.0)*(t5+6.0/7.0*s*t6+t8
/7);
   /* p=10 5 0 1 */
   } else if( i==5 && j==0 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      f = (t2*r-30.0/17.0*t2+75.0/68.0*t1*r-5.0/17.0*t1+15.0/476.0*r-3.0/
3094.0)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=10 5 1 0 */
   } else if( i==5 && j==1 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      f = (t2*r-30.0/17.0*t2+75.0/68.0*t1*r-5.0/17.0*t1+15.0/476.0*r-3.0/
3094.0)*(s+2.0/5.0*r-2.0/5.0);
   /* p=10 6 0 0 */
   } else if( i==6 && j==0 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      f = t2*t1-42.0/17.0*t2*r+315.0/136.0*t2-35.0/34.0*t1*r+15.0/68.0*t1-9.0/
442.0*r+1.0/1768.0;
   /* p=11 0 0 7 */
   } else if( i==0 && j==0 && k==7 ) {
      t1 = t*t;
      t2 = t1*t;
      t3 = t1*t1;
      t6 = s+r-1.0;
      t9 = t6*t6;
      t11 = t9*t6;
      t13 = t9*t9;
      f = t3*t2+56.0/15.0*t3*t1*t6+28.0/5.0*t3*t*t9+56.0/13.0*t3*t11+70.0/
39.0*t2*t13+56.0/143.0*t1*t13*t6+28.0/715.0*t*t13*t9+8.0/6435.0*t13*t11;
   /* p=11 0 1 6 */
   } else if( i==0 && j==1 && k==6 ) {
      t2 = t*t;
      t3 = t2*t2;
      t6 = s+r-1.0;
      t8 = t6*t6;
      t13 = t8*t8;
      f = (s+2.0/17.0*r-2.0/17.0)*(t3*t2+42.0/13.0*t3*t*t6+105.0/26.0*t3*t8+
350.0/143.0*t2*t*t8*t6+105.0/143.0*t2*t13+14.0/143.0*t*t13*t6+7.0/1716.0*t13*t8
);
   /* p=11 0 2 5 */
   } else if( i==0 && j==2 && k==5 ) {
      t1 = s*s;
      t2 = r-1.0;
      t4 = t2*t2;
      t6 = t*t;
      t7 = t6*t6;
      t9 = s+r-1.0;
      t12 = t9*t9;
      t16 = t12*t12;
      f = (t1+6.0/17.0*s*t2+3.0/136.0*t4)*(t7*t+30.0/11.0*t7*t9+30.0/11.0*t6*
t*t12+40.0/33.0*t6*t12*t9+5.0/22.0*t*t16+t16*t9/77);
   /* p=11 0 3 4 */
   } else if( i==0 && j==3 && k==4 ) {
      t1 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t9 = t*t;
      t10 = t9*t9;
      t12 = s+r-1.0;
      t14 = t12*t12;
      t18 = t14*t14;
      f = (t1*s+12.0/17.0*t3*t1+9.0/68.0*s*t5+t5*t3/170)*(t10+20.0/9.0*t9*t*
t12+5.0/3.0*t9*t14+10.0/21.0*t*t14*t12+5.0/126.0*t18);
   /* p=11 0 4 3 */
   } else if( i==0 && j==4 && k==3 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t6 = t4*t4;
      t10 = t6*t6;
      t12 = t*t;
      t14 = s+r-1.0;
      t16 = t14*t14;
      f = (t2+20.0/17.0*t1*s*t4+15.0/34.0*t1*t6+s*t6*t4/17+t10/476)*(t12*t+
12.0/7.0*t14*t12+6.0/7.0*t*t16+4.0/35.0*t16*t14);
   /* p=11 0 5 2 */
   } else if( i==0 && j==5 && k==2 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t7 = t4*t4;
      t11 = t7*t7;
      t15 = t*t;
      t16 = s+r-1.0;
      t18 = t16*t16;
      f = (s*t2+30.0/17.0*t2*t4+75.0/68.0*t1*s*t7+5.0/17.0*t1*t7*t4+15.0/
476.0*s*t11+3.0/3094.0*t11*t4)*(t15+6.0/5.0*t*t16+3.0/10.0*t18);
   /* p=11 0 6 1 */
   } else if( i==0 && j==6 && k==1 ) {
      t1 = s*s;
      t2 = t1*t1;
      t5 = r-1.0;
      t7 = t5*t5;
      t12 = t7*t7;
      f = (t2*t1+42.0/17.0*t2*s*t5+315.0/136.0*t2*t7+35.0/34.0*t1*s*t7*t5+
15.0/68.0*t1*t12+9.0/442.0*s*t12*t5+t12*t7/1768)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0
);
   /* p=11 0 7 0 */
   } else if( i==0 && j==7 && k==0 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t6 = r-1.0;
      t9 = t6*t6;
      t11 = t9*t6;
      t13 = t9*t9;
      f = t3*t2+56.0/17.0*t3*t1*t6+147.0/34.0*t3*s*t9+49.0/17.0*t3*t11+35.0/
34.0*t2*t13+42.0/221.0*t1*t13*t6+7.0/442.0*s*t13*t9+t13*t11/2431;
   /* p=11 1 0 6 */
   } else if( i==1 && j==0 && k==6 ) {
      t2 = t*t;
      t3 = t2*t2;
      t6 = s+r-1.0;
      t8 = t6*t6;
      t13 = t8*t8;
      f = (r-2.0/19.0)*(t3*t2+42.0/13.0*t3*t*t6+105.0/26.0*t3*t8+350.0/143.0*
t2*t*t8*t6+105.0/143.0*t2*t13+14.0/143.0*t*t13*t6+7.0/1716.0*t13*t8);
   /* p=11 1 1 5 */
   } else if( i==1 && j==1 && k==5 ) {
      t4 = t*t;
      t5 = t4*t4;
      t7 = s+r-1.0;
      t10 = t7*t7;
      t14 = t10*t10;
      f = (r-2.0/19.0)*(s+2.0/15.0*r-2.0/15.0)*(t5*t+30.0/11.0*t5*t7+30.0/
11.0*t4*t*t10+40.0/33.0*t4*t10*t7+5.0/22.0*t*t14+t14*t7/77);
   /* p=11 1 2 4 */
   } else if( i==1 && j==2 && k==4 ) {
      t2 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t8 = t*t;
      t9 = t8*t8;
      t11 = s+r-1.0;
      t13 = t11*t11;
      t17 = t13*t13;
      f = (r-2.0/19.0)*(t2+2.0/5.0*s*t3+t5/35)*(t9+20.0/9.0*t8*t*t11+5.0/3.0*
t13*t8+10.0/21.0*t*t13*t11+5.0/126.0*t17);
   /* p=11 1 3 3 */
   } else if( i==1 && j==3 && k==3 ) {
      t2 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t11 = t*t;
      t13 = s+r-1.0;
      t15 = t13*t13;
      f = (r-2.0/19.0)*(t2*s+4.0/5.0*t2*t4+6.0/35.0*s*t6+4.0/455.0*t6*t4)*(
t11*t+12.0/7.0*t13*t11+6.0/7.0*t*t15+4.0/35.0*t15*t13);
   /* p=11 1 4 2 */
   } else if( i==1 && j==4 && k==2 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = r-1.0;
      t7 = t5*t5;
      t11 = t7*t7;
      t14 = t*t;
      t15 = s+r-1.0;
      t17 = t15*t15;
      f = (r-2.0/19.0)*(t3+4.0/3.0*t2*s*t5+4.0/7.0*t2*t7+8.0/91.0*s*t5*t7+t11
/273)*(t14+6.0/5.0*t*t15+3.0/10.0*t17);
   /* p=11 1 5 1 */
   } else if( i==1 && j==5 && k==1 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = r-1.0;
      t8 = t5*t5;
      t12 = t8*t8;
      f = (r-2.0/19.0)*(s*t3+2.0*t3*t5+10.0/7.0*t2*s*t8+40.0/91.0*t2*t8*t5+
5.0/91.0*s*t12+2.0/1001.0*t12*t5)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=11 1 6 0 */
   } else if( i==1 && j==6 && k==0 ) {
      t2 = s*s;
      t3 = t2*t2;
      t6 = r-1.0;
      t8 = t6*t6;
      t13 = t8*t8;
      f = (r-2.0/19.0)*(t3*t2+14.0/5.0*t3*s*t6+3.0*t3*t8+20.0/13.0*t2*s*t8*t6
+5.0/13.0*t2*t13+6.0/143.0*s*t13*t6+t13*t8/715);
   /* p=11 2 0 5 */
   } else if( i==2 && j==0 && k==5 ) {
      t1 = r*r;
      t3 = t*t;
      t4 = t3*t3;
      t6 = s+r-1.0;
      t9 = t6*t6;
      t13 = t9*t9;
      f = (t1-6.0/19.0*r+1.0/57.0)*(t4*t+30.0/11.0*t6*t4+30.0/11.0*t3*t*t9+
40.0/33.0*t3*t9*t6+5.0/22.0*t*t13+t13*t6/77);
   /* p=11 2 1 4 */
   } else if( i==2 && j==1 && k==4 ) {
      t1 = r*r;
      t5 = t*t;
      t6 = t5*t5;
      t8 = s+r-1.0;
      t10 = t8*t8;
      t14 = t10*t10;
      f = (s+2.0/13.0*r-2.0/13.0)*(t1-6.0/19.0*r+1.0/57.0)*(t6+20.0/9.0*t5*t*
t8+5.0/3.0*t5*t10+10.0/21.0*t*t10*t8+5.0/126.0*t14);
   /* p=11 2 2 3 */
   } else if( i==2 && j==2 && k==3 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t9 = t*t;
      t11 = s+r-1.0;
      t13 = t11*t11;
      f = (t1-6.0/19.0*r+1.0/57.0)*(t3+6.0/13.0*s*t4+t6/26)*(t9*t+12.0/7.0*t9
*t11+6.0/7.0*t*t13+4.0/35.0*t13*t11);
   /* p=11 2 3 2 */
   } else if( i==2 && j==3 && k==2 ) {
      t1 = r*r;
      t3 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t12 = t*t;
      t13 = s+r-1.0;
      t15 = t13*t13;
      f = (t1-6.0/19.0*r+1.0/57.0)*(t3*s+12.0/13.0*t3*t5+3.0/13.0*s*t7+2.0/
143.0*t7*t5)*(t12+6.0/5.0*t*t13+3.0/10.0*t15);
   /* p=11 2 4 1 */
   } else if( i==2 && j==4 && k==1 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t6 = r-1.0;
      t8 = t6*t6;
      t12 = t8*t8;
      f = (t1-6.0/19.0*r+1.0/57.0)*(t4+20.0/13.0*t3*s*t6+10.0/13.0*t3*t8+20.0
/143.0*s*t8*t6+t12/143)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=11 2 5 0 */
   } else if( i==2 && j==5 && k==0 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t6 = r-1.0;
      t9 = t6*t6;
      t13 = t9*t9;
      f = (t1-6.0/19.0*r+1.0/57.0)*(s*t4+30.0/13.0*t4*t6+25.0/13.0*t3*s*t9+
100.0/143.0*t3*t9*t6+15.0/143.0*s*t13+2.0/429.0*t13*t6);
   /* p=11 3 0 4 */
   } else if( i==3 && j==0 && k==4 ) {
      t1 = r*r;
      t4 = t*t;
      t5 = t4*t4;
      t7 = s+r-1.0;
      t9 = t7*t7;
      t13 = t9*t9;
      f = (t1*r-12.0/19.0*t1+2.0/19.0*r-4.0/969.0)*(t5+20.0/9.0*t4*t*t7+5.0/
3.0*t4*t9+10.0/21.0*t*t9*t7+5.0/126.0*t13);
   /* p=11 3 1 3 */
   } else if( i==3 && j==1 && k==3 ) {
      t1 = r*r;
      t6 = t*t;
      t8 = s+r-1.0;
      t10 = t8*t8;
      f = (t1*r-12.0/19.0*t1+2.0/19.0*r-4.0/969.0)*(s+2.0/11.0*r-2.0/11.0)*(
t6*t+12.0/7.0*t8*t6+6.0/7.0*t*t10+4.0/35.0*t10*t8);
   /* p=11 3 2 2 */
   } else if( i==3 && j==2 && k==2 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t10 = t*t;
      t11 = s+r-1.0;
      t13 = t11*t11;
      f = (t1*r-12.0/19.0*t1+2.0/19.0*r-4.0/969.0)*(t4+6.0/11.0*s*t5+3.0/55.0
*t7)*(t10+6.0/5.0*t*t11+3.0/10.0*t13);
   /* p=11 3 3 1 */
   } else if( i==3 && j==3 && k==1 ) {
      t1 = r*r;
      t4 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      f = (t1*r-12.0/19.0*t1+2.0/19.0*r-4.0/969.0)*(s*t4+12.0/11.0*t4*t6+18.0
/55.0*s*t8+4.0/165.0*t8*t6)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=11 3 4 0 */
   } else if( i==3 && j==4 && k==0 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = t4*t4;
      t7 = r-1.0;
      t9 = t7*t7;
      t13 = t9*t9;
      f = (t1*r-12.0/19.0*t1+2.0/19.0*r-4.0/969.0)*(t5+20.0/11.0*t4*s*t7+12.0
/11.0*t4*t9+8.0/33.0*s*t9*t7+t13/66);
   /* p=11 4 0 3 */
   } else if( i==4 && j==0 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = t*t;
      t7 = s+r-1.0;
      t9 = t7*t7;
      f = (t2-20.0/19.0*t1*r+20.0/57.0*t1-40.0/969.0*r+5.0/3876.0)*(t5*t+12.0
/7.0*t7*t5+6.0/7.0*t9*t+4.0/35.0*t9*t7);
   /* p=11 4 1 2 */
   } else if( i==4 && j==1 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t7 = t*t;
      t8 = s+r-1.0;
      t10 = t8*t8;
      f = (t2-20.0/19.0*t1*r+20.0/57.0*t1-40.0/969.0*r+5.0/3876.0)*(s+2.0/9.0
*r-2.0/9.0)*(t7+6.0/5.0*t*t8+3.0/10.0*t10);
   /* p=11 4 2 1 */
   } else if( i==4 && j==2 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      f = (t2-20.0/19.0*t1*r+20.0/57.0*t1-40.0/969.0*r+5.0/3876.0)*(t5+2.0/
3.0*s*t6+t8/12)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=11 4 3 0 */
   } else if( i==4 && j==3 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t7 = r-1.0;
      t9 = t7*t7;
      f = (t2-20.0/19.0*t1*r+20.0/57.0*t1-40.0/969.0*r+5.0/3876.0)*(t5*s+4.0/
3.0*t7*t5+s*t9/2+t9*t7/21);
   /* p=11 5 0 2 */
   } else if( i==5 && j==0 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = t*t;
      t7 = s+r-1.0;
      t9 = t7*t7;
      f = (t2*r-30.0/19.0*t2+50.0/57.0*t1*r-200.0/969.0*t1+25.0/1292.0*r-1.0/
1938.0)*(t6+6.0/5.0*t*t7+3.0/10.0*t9);
   /* p=11 5 1 1 */
   } else if( i==5 && j==1 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      f = (t2*r-30.0/19.0*t2+50.0/57.0*t1*r-200.0/969.0*t1+25.0/1292.0*r-1.0/
1938.0)*(s+2.0/7.0*r-2.0/7.0)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=11 5 2 0 */
   } else if( i==5 && j==2 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = s*s;
      t7 = r-1.0;
      t9 = t7*t7;
      f = (t2*r-30.0/19.0*t2+50.0/57.0*t1*r-200.0/969.0*t1+25.0/1292.0*r-1.0/
1938.0)*(t6+6.0/7.0*s*t7+t9/7);
   /* p=11 6 0 1 */
   } else if( i==6 && j==0 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      f = (t2*t1-42.0/19.0*t2*r+35.0/19.0*t2-700.0/969.0*t1*r+175.0/1292.0*t1
-7.0/646.0*r+1.0/3876.0)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=11 6 1 0 */
   } else if( i==6 && j==1 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      f = (t2*t1-42.0/19.0*t2*r+35.0/19.0*t2-700.0/969.0*t1*r+175.0/1292.0*t1
-7.0/646.0*r+1.0/3876.0)*(s+2.0/5.0*r-2.0/5.0);
   /* p=11 7 0 0 */
   } else if( i==7 && j==0 && k==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      f = t3*t2-56.0/19.0*t3*t1+196.0/57.0*t3*r-1960.0/969.0*t3+1225.0/1938.0*
t2-98.0/969.0*t1+7.0/969.0*r-2.0/12597.0;
   /* p=12 0 0 8 */
   } else if( i==0 && j==0 && k==8 ) {
      t1 = t*t;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*t;
      t6 = s+r-1.0;
      t9 = t6*t6;
      t12 = t9*t6;
      t14 = t9*t9;
      t22 = t14*t14;
      f = t3+72.0/17.0*t2*t4*t6+126.0/17.0*t2*t1*t9+588.0/85.0*t2*t*t12+63.0/
17.0*t2*t14+252.0/221.0*t4*t14*t6+42.0/221.0*t1*t14*t9+36.0/2431.0*t*t14*t12+
9.0/24310.0*t22;
   /* p=12 0 1 7 */
   } else if( i==0 && j==1 && k==7 ) {
      t2 = t*t;
      t3 = t2*t;
      t4 = t2*t2;
      t7 = s+r-1.0;
      t10 = t7*t7;
      t12 = t10*t7;
      t14 = t10*t10;
      f = (s+2.0/19.0*r-2.0/19.0)*(t4*t3+56.0/15.0*t4*t2*t7+28.0/5.0*t4*t*t10
+56.0/13.0*t4*t12+70.0/39.0*t3*t14+56.0/143.0*t2*t14*t7+28.0/715.0*t*t14*t10+
8.0/6435.0*t14*t12);
   /* p=12 0 2 6 */
   } else if( i==0 && j==2 && k==6 ) {
      t1 = s*s;
      t2 = r-1.0;
      t4 = t2*t2;
      t6 = t*t;
      t7 = t6*t6;
      t10 = s+r-1.0;
      t12 = t10*t10;
      t17 = t12*t12;
      f = (t1+6.0/19.0*s*t2+t4/57)*(t6*t7+42.0/13.0*t7*t*t10+105.0/26.0*t7*
t12+350.0/143.0*t6*t*t12*t10+105.0/143.0*t6*t17+14.0/143.0*t*t17*t10+7.0/1716.0
*t17*t12);
   /* p=12 0 3 5 */
   } else if( i==0 && j==3 && k==5 ) {
      t1 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t9 = t*t;
      t10 = t9*t9;
      t12 = s+r-1.0;
      t15 = t12*t12;
      t19 = t15*t15;
      f = (t1*s+12.0/19.0*t1*t3+2.0/19.0*s*t5+4.0/969.0*t5*t3)*(t10*t+30.0/
11.0*t12*t10+30.0/11.0*t9*t*t15+40.0/33.0*t9*t15*t12+5.0/22.0*t*t19+t19*t12/77)
;
   /* p=12 0 4 4 */
   } else if( i==0 && j==4 && k==4 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t6 = t4*t4;
      t10 = t6*t6;
      t12 = t*t;
      t13 = t12*t12;
      t15 = s+r-1.0;
      t17 = t15*t15;
      t21 = t17*t17;
      f = (t2+20.0/19.0*t4*t1*s+20.0/57.0*t1*t6+40.0/969.0*s*t6*t4+5.0/3876.0
*t10)*(t13+20.0/9.0*t12*t*t15+5.0/3.0*t17*t12+10.0/21.0*t*t17*t15+5.0/126.0*t21
);
   /* p=12 0 5 3 */
   } else if( i==0 && j==5 && k==3 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t7 = t4*t4;
      t11 = t7*t7;
      t15 = t*t;
      t17 = s+r-1.0;
      t19 = t17*t17;
      f = (s*t2+30.0/19.0*t4*t2+50.0/57.0*t1*s*t7+200.0/969.0*t1*t7*t4+25.0/
1292.0*s*t11+t11*t4/1938)*(t15*t+12.0/7.0*t17*t15+6.0/7.0*t*t19+4.0/35.0*t19*
t17);
   /* p=12 0 6 2 */
   } else if( i==0 && j==6 && k==2 ) {
      t1 = s*s;
      t2 = t1*t1;
      t5 = r-1.0;
      t7 = t5*t5;
      t12 = t7*t7;
      t18 = t*t;
      t19 = s+r-1.0;
      t21 = t19*t19;
      f = (t2*t1+42.0/19.0*t2*s*t5+35.0/19.0*t2*t7+700.0/969.0*t1*s*t7*t5+
175.0/1292.0*t1*t12+7.0/646.0*s*t12*t5+t7*t12/3876)*(t18+6.0/5.0*t*t19+3.0/10.0
*t21);
   /* p=12 0 7 1 */
   } else if( i==0 && j==7 && k==1 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t6 = r-1.0;
      t9 = t6*t6;
      t11 = t9*t6;
      t13 = t9*t9;
      f = (t3*t2+56.0/19.0*t1*t3*t6+196.0/57.0*t3*s*t9+1960.0/969.0*t3*t11+
1225.0/1938.0*t2*t13+98.0/969.0*t1*t13*t6+7.0/969.0*s*t13*t9+2.0/12597.0*t13*
t11)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=12 0 8 0 */
   } else if( i==0 && j==8 && k==0 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*s;
      t6 = r-1.0;
      t9 = t6*t6;
      t12 = t9*t6;
      t14 = t9*t9;
      t22 = t14*t14;
      f = t3+72.0/19.0*t2*t4*t6+112.0/19.0*t2*t1*t9+1568.0/323.0*t2*s*t12+
735.0/323.0*t2*t14+196.0/323.0*t4*t14*t6+28.0/323.0*t1*t14*t9+24.0/4199.0*s*t14
*t12+t22/8398;
   /* p=12 1 0 7 */
   } else if( i==1 && j==0 && k==7 ) {
      t2 = t*t;
      t3 = t2*t;
      t4 = t2*t2;
      t7 = s+r-1.0;
      t10 = t7*t7;
      t12 = t10*t7;
      t14 = t10*t10;
      f = (r-2.0/21.0)*(t4*t3+56.0/15.0*t2*t4*t7+28.0/5.0*t4*t*t10+56.0/13.0*
t4*t12+70.0/39.0*t3*t14+56.0/143.0*t2*t14*t7+28.0/715.0*t*t14*t10+8.0/6435.0*
t14*t12);
   /* p=12 1 1 6 */
   } else if( i==1 && j==1 && k==6 ) {
      t4 = t*t;
      t5 = t4*t4;
      t8 = s+r-1.0;
      t10 = t8*t8;
      t15 = t10*t10;
      f = (s+2.0/17.0*r-2.0/17.0)*(r-2.0/21.0)*(t5*t4+42.0/13.0*t5*t*t8+105.0
/26.0*t5*t10+350.0/143.0*t4*t*t10*t8+105.0/143.0*t4*t15+14.0/143.0*t*t15*t8+7.0
/1716.0*t15*t10);
   /* p=12 1 2 5 */
   } else if( i==1 && j==2 && k==5 ) {
      t2 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t8 = t*t;
      t9 = t8*t8;
      t11 = s+r-1.0;
      t14 = t11*t11;
      t18 = t14*t14;
      f = (r-2.0/21.0)*(t2+6.0/17.0*s*t3+3.0/136.0*t5)*(t9*t+30.0/11.0*t9*t11
+30.0/11.0*t8*t*t14+40.0/33.0*t8*t14*t11+5.0/22.0*t*t18+t18*t11/77);
   /* p=12 1 3 4 */
   } else if( i==1 && j==3 && k==4 ) {
      t2 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t11 = t*t;
      t12 = t11*t11;
      t14 = s+r-1.0;
      t16 = t14*t14;
      t20 = t16*t16;
      f = (r-2.0/21.0)*(t2*s+12.0/17.0*t2*t4+9.0/68.0*s*t6+t6*t4/170)*(t12+
20.0/9.0*t11*t*t14+5.0/3.0*t11*t16+10.0/21.0*t*t16*t14+5.0/126.0*t20);
   /* p=12 1 4 3 */
   } else if( i==1 && j==4 && k==3 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = r-1.0;
      t7 = t5*t5;
      t11 = t7*t7;
      t14 = t*t;
      t16 = s+r-1.0;
      t18 = t16*t16;
      f = (r-2.0/21.0)*(t3+20.0/17.0*t5*t2*s+15.0/34.0*t2*t7+s*t7*t5/17+t11
/476)*(t14*t+12.0/7.0*t16*t14+6.0/7.0*t*t18+4.0/35.0*t18*t16);
   /* p=12 1 5 2 */
   } else if( i==1 && j==5 && k==2 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = r-1.0;
      t8 = t5*t5;
      t12 = t8*t8;
      t17 = t*t;
      t18 = s+r-1.0;
      t20 = t18*t18;
      f = (r-2.0/21.0)*(s*t3+30.0/17.0*t3*t5+75.0/68.0*t2*s*t8+5.0/17.0*t2*t8
*t5+15.0/476.0*s*t12+3.0/3094.0*t12*t5)*(t17+6.0/5.0*t*t18+3.0/10.0*t20);
   /* p=12 1 6 1 */
   } else if( i==1 && j==6 && k==1 ) {
      t2 = s*s;
      t3 = t2*t2;
      t6 = r-1.0;
      t8 = t6*t6;
      t13 = t8*t8;
      f = (r-2.0/21.0)*(t3*t2+42.0/17.0*t3*s*t6+315.0/136.0*t3*t8+35.0/34.0*
t2*s*t8*t6+15.0/68.0*t2*t13+9.0/442.0*s*t13*t6+t13*t8/1768)*(t+2.0/3.0*s+2.0/
3.0*r-2.0/3.0);
   /* p=12 1 7 0 */
   } else if( i==1 && j==7 && k==0 ) {
      t2 = s*s;
      t3 = t2*s;
      t4 = t2*t2;
      t7 = r-1.0;
      t10 = t7*t7;
      t12 = t10*t7;
      t14 = t10*t10;
      f = (r-2.0/21.0)*(t4*t3+56.0/17.0*t4*t2*t7+147.0/34.0*t4*s*t10+49.0/
17.0*t4*t12+35.0/34.0*t3*t14+42.0/221.0*t2*t14*t7+7.0/442.0*s*t14*t10+t14*t12
/2431);
   /* p=12 2 0 6 */
   } else if( i==2 && j==0 && k==6 ) {
      t1 = r*r;
      t3 = t*t;
      t4 = t3*t3;
      t7 = s+r-1.0;
      t9 = t7*t7;
      t14 = t9*t9;
      f = (t1-2.0/7.0*r+1.0/70.0)*(t4*t3+42.0/13.0*t4*t*t7+105.0/26.0*t4*t9+
350.0/143.0*t3*t*t9*t7+105.0/143.0*t3*t14+14.0/143.0*t*t14*t7+7.0/1716.0*t14*t9
);
   /* p=12 2 1 5 */
   } else if( i==2 && j==1 && k==5 ) {
      t1 = r*r;
      t5 = t*t;
      t6 = t5*t5;
      t8 = s+r-1.0;
      t11 = t8*t8;
      t15 = t11*t11;
      f = (s+2.0/15.0*r-2.0/15.0)*(t1-2.0/7.0*r+1.0/70.0)*(t6*t+30.0/11.0*t6*
t8+30.0/11.0*t5*t*t11+40.0/33.0*t5*t11*t8+5.0/22.0*t*t15+t15*t8/77);
   /* p=12 2 2 4 */
   } else if( i==2 && j==2 && k==4 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t9 = t*t;
      t10 = t9*t9;
      t12 = s+r-1.0;
      t14 = t12*t12;
      t18 = t14*t14;
      f = (t1-2.0/7.0*r+1.0/70.0)*(t3+2.0/5.0*s*t4+t6/35)*(t10+20.0/9.0*t9*t*
t12+5.0/3.0*t14*t9+10.0/21.0*t*t14*t12+5.0/126.0*t18);
   /* p=12 2 3 3 */
   } else if( i==2 && j==3 && k==3 ) {
      t1 = r*r;
      t3 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t12 = t*t;
      t14 = s+r-1.0;
      t16 = t14*t14;
      f = (t1-2.0/7.0*r+1.0/70.0)*(t3*s+4.0/5.0*t3*t5+6.0/35.0*s*t7+4.0/455.0
*t7*t5)*(t12*t+12.0/7.0*t14*t12+6.0/7.0*t*t16+4.0/35.0*t16*t14);
   /* p=12 2 4 2 */
   } else if( i==2 && j==4 && k==2 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t6 = r-1.0;
      t8 = t6*t6;
      t12 = t8*t8;
      t15 = t*t;
      t16 = s+r-1.0;
      t18 = t16*t16;
      f = (t1-2.0/7.0*r+1.0/70.0)*(t4+4.0/3.0*t3*s*t6+4.0/7.0*t3*t8+8.0/91.0*
s*t6*t8+t12/273)*(t15+6.0/5.0*t*t16+3.0/10.0*t18);
   /* p=12 2 5 1 */
   } else if( i==2 && j==5 && k==1 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t6 = r-1.0;
      t9 = t6*t6;
      t13 = t9*t9;
      f = (t1-2.0/7.0*r+1.0/70.0)*(s*t4+2.0*t4*t6+10.0/7.0*t3*s*t9+40.0/91.0*
t3*t9*t6+5.0/91.0*s*t13+2.0/1001.0*t13*t6)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=12 2 6 0 */
   } else if( i==2 && j==6 && k==0 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t7 = r-1.0;
      t9 = t7*t7;
      t14 = t9*t9;
      f = (t1-2.0/7.0*r+1.0/70.0)*(t4*t3+14.0/5.0*t4*s*t7+3.0*t4*t9+20.0/13.0
*t3*s*t9*t7+5.0/13.0*t3*t14+6.0/143.0*s*t14*t7+t14*t9/715);
   /* p=12 3 0 5 */
   } else if( i==3 && j==0 && k==5 ) {
      t1 = r*r;
      t4 = t*t;
      t5 = t4*t4;
      t7 = s+r-1.0;
      t10 = t7*t7;
      t14 = t10*t10;
      f = (t1*r-4.0/7.0*t1+3.0/35.0*r-2.0/665.0)*(t5*t+30.0/11.0*t5*t7+30.0/
11.0*t4*t*t10+40.0/33.0*t4*t10*t7+5.0/22.0*t*t14+t14*t7/77);
   /* p=12 3 1 4 */
   } else if( i==3 && j==1 && k==4 ) {
      t1 = r*r;
      t6 = t*t;
      t7 = t6*t6;
      t9 = s+r-1.0;
      t11 = t9*t9;
      t15 = t11*t11;
      f = (s+2.0/13.0*r-2.0/13.0)*(t1*r-4.0/7.0*t1+3.0/35.0*r-2.0/665.0)*(t7+
20.0/9.0*t6*t*t9+5.0/3.0*t6*t11+10.0/21.0*t*t11*t9+5.0/126.0*t15);
   /* p=12 3 2 3 */
   } else if( i==3 && j==2 && k==3 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t10 = t*t;
      t12 = s+r-1.0;
      t14 = t12*t12;
      f = (t1*r-4.0/7.0*t1+3.0/35.0*r-2.0/665.0)*(t4+6.0/13.0*s*t5+t7/26)*(
t10*t+12.0/7.0*t10*t12+6.0/7.0*t*t14+4.0/35.0*t14*t12);
   /* p=12 3 3 2 */
   } else if( i==3 && j==3 && k==2 ) {
      t1 = r*r;
      t4 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t13 = t*t;
      t14 = s+r-1.0;
      t16 = t14*t14;
      f = (t1*r-4.0/7.0*t1+3.0/35.0*r-2.0/665.0)*(t4*s+12.0/13.0*t4*t6+3.0/
13.0*s*t8+2.0/143.0*t8*t6)*(t13+6.0/5.0*t*t14+3.0/10.0*t16);
   /* p=12 3 4 1 */
   } else if( i==3 && j==4 && k==1 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = t4*t4;
      t7 = r-1.0;
      t9 = t7*t7;
      t13 = t9*t9;
      f = (t1*r-4.0/7.0*t1+3.0/35.0*r-2.0/665.0)*(t5+20.0/13.0*t4*s*t7+10.0/
13.0*t4*t9+20.0/143.0*s*t9*t7+t13/143)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=12 3 5 0 */
   } else if( i==3 && j==5 && k==0 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = t4*t4;
      t7 = r-1.0;
      t10 = t7*t7;
      t14 = t10*t10;
      f = (t1*r-4.0/7.0*t1+3.0/35.0*r-2.0/665.0)*(s*t5+30.0/13.0*t5*t7+25.0/
13.0*t4*s*t10+100.0/143.0*t4*t10*t7+15.0/143.0*s*t14+2.0/429.0*t14*t7);
   /* p=12 4 0 4 */
   } else if( i==4 && j==0 && k==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = t*t;
      t6 = t5*t5;
      t8 = s+r-1.0;
      t10 = t8*t8;
      t14 = t10*t10;
      f = (t2-20.0/21.0*t1*r+2.0/7.0*t1-4.0/133.0*r+1.0/1197.0)*(t6+20.0/9.0*
t5*t*t8+5.0/3.0*t5*t10+10.0/21.0*t*t10*t8+5.0/126.0*t14);
   /* p=12 4 1 3 */
   } else if( i==4 && j==1 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t7 = t*t;
      t9 = s+r-1.0;
      t11 = t9*t9;
      f = (t2-20.0/21.0*t1*r+2.0/7.0*t1-4.0/133.0*r+1.0/1197.0)*(s+2.0/11.0*r
-2.0/11.0)*(t7*t+12.0/7.0*t9*t7+6.0/7.0*t*t11+4.0/35.0*t11*t9);
   /* p=12 4 2 2 */
   } else if( i==4 && j==2 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t11 = t*t;
      t12 = s+r-1.0;
      t14 = t12*t12;
      f = (t2-20.0/21.0*t1*r+2.0/7.0*t1-4.0/133.0*r+1.0/1197.0)*(t5+6.0/11.0*
s*t6+3.0/55.0*t8)*(t11+6.0/5.0*t*t12+3.0/10.0*t14);
   /* p=12 4 3 1 */
   } else if( i==4 && j==3 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t7 = r-1.0;
      t9 = t7*t7;
      f = (t2-20.0/21.0*t1*r+2.0/7.0*t1-4.0/133.0*r+1.0/1197.0)*(t5*s+12.0/
11.0*t5*t7+18.0/55.0*s*t9+4.0/165.0*t9*t7)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=12 4 4 0 */
   } else if( i==4 && j==4 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t6 = t5*t5;
      t8 = r-1.0;
      t10 = t8*t8;
      t14 = t10*t10;
      f = (t2-20.0/21.0*t1*r+2.0/7.0*t1-4.0/133.0*r+1.0/1197.0)*(t6+20.0/11.0
*t5*s*t8+12.0/11.0*t5*t10+8.0/33.0*s*t10*t8+t14/66);
   /* p=12 5 0 3 */
   } else if( i==5 && j==0 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = t*t;
      t8 = s+r-1.0;
      t10 = t8*t8;
      f = (t2*r-10.0/7.0*t2+5.0/7.0*t1*r-20.0/133.0*t1+5.0/399.0*r-2.0/6783.0
)*(t6*t+12.0/7.0*t6*t8+6.0/7.0*t*t10+4.0/35.0*t10*t8);
   /* p=12 5 1 2 */
   } else if( i==5 && j==1 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t8 = t*t;
      t9 = s+r-1.0;
      t11 = t9*t9;
      f = (t2*r-10.0/7.0*t2+5.0/7.0*t1*r-20.0/133.0*t1+5.0/399.0*r-2.0/6783.0
)*(s+2.0/9.0*r-2.0/9.0)*(t8+6.0/5.0*t*t9+3.0/10.0*t11);
   /* p=12 5 2 1 */
   } else if( i==5 && j==2 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = s*s;
      t7 = r-1.0;
      t9 = t7*t7;
      f = (t2*r-10.0/7.0*t2+5.0/7.0*t1*r-20.0/133.0*t1+5.0/399.0*r-2.0/6783.0
)*(t6+2.0/3.0*s*t7+t9/12)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=12 5 3 0 */
   } else if( i==5 && j==3 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = s*s;
      t8 = r-1.0;
      t10 = t8*t8;
      f = (t2*r-10.0/7.0*t2+5.0/7.0*t1*r-20.0/133.0*t1+5.0/399.0*r-2.0/6783.0
)*(s*t6+4.0/3.0*t6*t8+s*t10/2+t10*t8/21);
   /* p=12 6 0 2 */
   } else if( i==6 && j==0 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t7 = t*t;
      t8 = s+r-1.0;
      t10 = t8*t8;
      f = (t2*t1-2.0*t2*r+3.0/2.0*t2-10.0/19.0*t1*r+5.0/57.0*t1-2.0/323.0*r+
1.0/7752.0)*(t7+6.0/5.0*t*t8+3.0/10.0*t10);
   /* p=12 6 1 1 */
   } else if( i==6 && j==1 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      f = (t2*t1-2.0*t2*r+3.0/2.0*t2-10.0/19.0*t1*r+5.0/57.0*t1-2.0/323.0*r+
1.0/7752.0)*(s+2.0/7.0*r-2.0/7.0)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=12 6 2 0 */
   } else if( i==6 && j==2 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t7 = s*s;
      t8 = r-1.0;
      t10 = t8*t8;
      f = (t2*t1-2.0*t2*r+3.0/2.0*t2-10.0/19.0*t1*r+5.0/57.0*t1-2.0/323.0*r+
1.0/7752.0)*(t7+6.0/7.0*s*t8+t10/7);
   /* p=12 7 0 1 */
   } else if( i==7 && j==0 && k==1 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      f = (t3*t2-8.0/3.0*t3*t1+14.0/5.0*t3*r-28.0/19.0*t3+70.0/171.0*t2-56.0/
969.0*t1+7.0/1938.0*r-1.0/14535.0)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=12 7 1 0 */
   } else if( i==7 && j==1 && k==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      f = (t3*t2-8.0/3.0*t3*t1+14.0/5.0*t3*r-28.0/19.0*t3+70.0/171.0*t2-56.0/
969.0*t1+7.0/1938.0*r-1.0/14535.0)*(s+2.0/5.0*r-2.0/5.0);
   /* p=12 8 0 0 */
   } else if( i==8 && j==0 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*r;
      f = t3-24.0/7.0*t2*t4+24.0/5.0*t2*t1-336.0/95.0*t2*r+28.0/19.0*t2-112.0/
323.0*t4+14.0/323.0*t1-4.0/1615.0*r+1.0/22610.0;
   /* p=13 0 0 9 */
   } else if( i==0 && j==0 && k==9 ) {
      t1 = t*t;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = s+r-1.0;
      t7 = t1*t;
      t9 = t5*t5;
      t12 = t9*t5;
      t15 = t9*t9;
      t23 = t15*t15;
      f = t3*t+90.0/19.0*t3*t5+180.0/19.0*t2*t7*t9+3360.0/323.0*t2*t1*t12+
2205.0/323.0*t2*t*t15+882.0/323.0*t2*t15*t5+210.0/323.0*t7*t15*t9+360.0/4199.0*
t1*t15*t12+45.0/8398.0*t*t23+5.0/46189.0*t23*t5;
   /* p=13 0 1 8 */
   } else if( i==0 && j==1 && k==8 ) {
      t2 = t*t;
      t3 = t2*t2;
      t4 = t3*t3;
      t5 = t2*t;
      t7 = s+r-1.0;
      t10 = t7*t7;
      t13 = t10*t7;
      t15 = t10*t10;
      t23 = t15*t15;
      f = (s+2.0/21.0*r-2.0/21.0)*(t4+72.0/17.0*t3*t5*t7+126.0/17.0*t3*t2*t10
+588.0/85.0*t3*t*t13+63.0/17.0*t3*t15+252.0/221.0*t5*t15*t7+42.0/221.0*t2*t15*
t10+36.0/2431.0*t*t15*t13+9.0/24310.0*t23);
   /* p=13 0 2 7 */
   } else if( i==0 && j==2 && k==7 ) {
      t1 = s*s;
      t2 = r-1.0;
      t4 = t2*t2;
      t6 = t*t;
      t7 = t6*t;
      t8 = t6*t6;
      t11 = s+r-1.0;
      t14 = t11*t11;
      t16 = t14*t11;
      t18 = t14*t14;
      f = (t1+2.0/7.0*s*t2+t4/70)*(t7*t8+56.0/15.0*t8*t6*t11+28.0/5.0*t8*t*
t14+56.0/13.0*t8*t16+70.0/39.0*t7*t18+56.0/143.0*t6*t18*t11+28.0/715.0*t*t18*
t14+8.0/6435.0*t18*t16);
   /* p=13 0 3 6 */
   } else if( i==0 && j==3 && k==6 ) {
      t1 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t9 = t*t;
      t10 = t9*t9;
      t13 = s+r-1.0;
      t15 = t13*t13;
      t20 = t15*t15;
      f = (t1*s+4.0/7.0*t3*t1+3.0/35.0*s*t5+2.0/665.0*t3*t5)*(t9*t10+42.0/
13.0*t10*t*t13+105.0/26.0*t15*t10+350.0/143.0*t9*t*t15*t13+105.0/143.0*t9*t20+
14.0/143.0*t*t20*t13+7.0/1716.0*t20*t15);
   /* p=13 0 4 5 */
   } else if( i==0 && j==4 && k==5 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t6 = t4*t4;
      t10 = t6*t6;
      t12 = t*t;
      t13 = t12*t12;
      t15 = s+r-1.0;
      t18 = t15*t15;
      t22 = t18*t18;
      f = (t2+20.0/21.0*t1*s*t4+2.0/7.0*t1*t6+4.0/133.0*s*t6*t4+t10/1197)*(
t13*t+30.0/11.0*t13*t15+30.0/11.0*t12*t*t18+40.0/33.0*t12*t18*t15+5.0/22.0*t*
t22+t22*t15/77);
   /* p=13 0 5 4 */
   } else if( i==0 && j==5 && k==4 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t7 = t4*t4;
      t11 = t7*t7;
      t15 = t*t;
      t16 = t15*t15;
      t18 = s+r-1.0;
      t20 = t18*t18;
      t24 = t20*t20;
      f = (t2*s+10.0/7.0*t2*t4+5.0/7.0*t1*s*t7+20.0/133.0*t1*t7*t4+5.0/399.0*
s*t11+2.0/6783.0*t11*t4)*(t16+20.0/9.0*t15*t*t18+5.0/3.0*t20*t15+10.0/21.0*t*
t20*t18+5.0/126.0*t24);
   /* p=13 0 6 3 */
   } else if( i==0 && j==6 && k==3 ) {
      t1 = s*s;
      t2 = t1*t1;
      t5 = r-1.0;
      t7 = t5*t5;
      t12 = t7*t7;
      t18 = t*t;
      t20 = s+r-1.0;
      t22 = t20*t20;
      f = (t2*t1+2.0*t2*s*t5+3.0/2.0*t2*t7+10.0/19.0*t1*s*t7*t5+5.0/57.0*t1*
t12+2.0/323.0*s*t12*t5+t12*t7/7752)*(t18*t+12.0/7.0*t20*t18+6.0/7.0*t*t22+4.0/
35.0*t22*t20);
   /* p=13 0 7 2 */
   } else if( i==0 && j==7 && k==2 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t6 = r-1.0;
      t9 = t6*t6;
      t11 = t9*t6;
      t13 = t9*t9;
      t21 = t*t;
      t22 = s+r-1.0;
      t24 = t22*t22;
      f = (t3*t2+8.0/3.0*t3*t1*t6+14.0/5.0*t3*s*t9+28.0/19.0*t3*t11+70.0/
171.0*t2*t13+56.0/969.0*t1*t13*t6+7.0/1938.0*s*t13*t9+t13*t11/14535)*(t21+6.0/
5.0*t*t22+3.0/10.0*t24);
   /* p=13 0 8 1 */
   } else if( i==0 && j==8 && k==1 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*s;
      t6 = r-1.0;
      t9 = t6*t6;
      t12 = t9*t6;
      t14 = t9*t9;
      t22 = t14*t14;
      f = (t3+24.0/7.0*t2*t4*t6+24.0/5.0*t2*t1*t9+336.0/95.0*t2*s*t12+28.0/
19.0*t2*t14+112.0/323.0*t4*t14*t6+14.0/323.0*t1*t14*t9+4.0/1615.0*s*t14*t12+t22
/22610)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=13 0 9 0 */
   } else if( i==0 && j==9 && k==0 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = r-1.0;
      t7 = t1*s;
      t9 = t5*t5;
      t12 = t9*t5;
      t15 = t9*t9;
      t23 = t15*t15;
      f = t3*s+30.0/7.0*t3*t5+54.0/7.0*t2*t7*t9+144.0/19.0*t2*t1*t12+84.0/
19.0*t2*s*t15+504.0/323.0*t2*t15*t5+105.0/323.0*t7*t15*t9+12.0/323.0*t1*t15*t12
+9.0/4522.0*s*t23+t23*t5/29393;
   /* p=13 1 0 8 */
   } else if( i==1 && j==0 && k==8 ) {
      t2 = t*t;
      t3 = t2*t2;
      t4 = t3*t3;
      t5 = t2*t;
      t7 = s+r-1.0;
      t10 = t7*t7;
      t13 = t10*t7;
      t15 = t10*t10;
      t23 = t15*t15;
      f = (r-2.0/23.0)*(t4+72.0/17.0*t3*t5*t7+126.0/17.0*t3*t2*t10+588.0/85.0
*t3*t*t13+63.0/17.0*t3*t15+252.0/221.0*t5*t15*t7+42.0/221.0*t2*t15*t10+36.0/
2431.0*t*t13*t15+9.0/24310.0*t23);
   /* p=13 1 1 7 */
   } else if( i==1 && j==1 && k==7 ) {
      t4 = t*t;
      t5 = t4*t;
      t6 = t4*t4;
      t9 = s+r-1.0;
      t12 = t9*t9;
      t14 = t12*t9;
      t16 = t12*t12;
      f = (r-2.0/23.0)*(s+2.0/19.0*r-2.0/19.0)*(t6*t5+56.0/15.0*t6*t4*t9+28.0
/5.0*t6*t*t12+56.0/13.0*t6*t14+70.0/39.0*t5*t16+56.0/143.0*t4*t16*t9+28.0/715.0
*t*t16*t12+8.0/6435.0*t16*t14);
   /* p=13 1 2 6 */
   } else if( i==1 && j==2 && k==6 ) {
      t2 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t8 = t*t;
      t9 = t8*t8;
      t12 = s+r-1.0;
      t14 = t12*t12;
      t19 = t14*t14;
      f = (r-2.0/23.0)*(t2+6.0/19.0*s*t3+t5/57)*(t8*t9+42.0/13.0*t9*t*t12+
105.0/26.0*t9*t14+350.0/143.0*t8*t*t14*t12+105.0/143.0*t8*t19+14.0/143.0*t*t19*
t12+7.0/1716.0*t19*t14);
   /* p=13 1 3 5 */
   } else if( i==1 && j==3 && k==5 ) {
      t2 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t11 = t*t;
      t12 = t11*t11;
      t14 = s+r-1.0;
      t17 = t14*t14;
      t21 = t17*t17;
      f = (r-2.0/23.0)*(t2*s+12.0/19.0*t2*t4+2.0/19.0*s*t6+4.0/969.0*t6*t4)*(
t12*t+30.0/11.0*t14*t12+30.0/11.0*t11*t*t17+40.0/33.0*t11*t17*t14+5.0/22.0*t*
t21+t21*t14/77);
   /* p=13 1 4 4 */
   } else if( i==1 && j==4 && k==4 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = r-1.0;
      t7 = t5*t5;
      t11 = t7*t7;
      t14 = t*t;
      t15 = t14*t14;
      t17 = s+r-1.0;
      t19 = t17*t17;
      t23 = t19*t19;
      f = (r-2.0/23.0)*(t3+20.0/19.0*t2*s*t5+20.0/57.0*t2*t7+40.0/969.0*s*t7*
t5+5.0/3876.0*t11)*(t15+20.0/9.0*t14*t*t17+5.0/3.0*t19*t14+10.0/21.0*t*t19*t17+
5.0/126.0*t23);
   /* p=13 1 5 3 */
   } else if( i==1 && j==5 && k==3 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = r-1.0;
      t8 = t5*t5;
      t12 = t8*t8;
      t17 = t*t;
      t19 = s+r-1.0;
      t21 = t19*t19;
      f = (r-2.0/23.0)*(s*t3+30.0/19.0*t3*t5+50.0/57.0*t2*s*t8+200.0/969.0*t2
*t8*t5+25.0/1292.0*s*t12+t12*t5/1938)*(t17*t+12.0/7.0*t19*t17+6.0/7.0*t*t21+4.0
/35.0*t21*t19);
   /* p=13 1 6 2 */
   } else if( i==1 && j==6 && k==2 ) {
      t2 = s*s;
      t3 = t2*t2;
      t6 = r-1.0;
      t8 = t6*t6;
      t13 = t8*t8;
      t20 = t*t;
      t21 = s+r-1.0;
      t23 = t21*t21;
      f = (r-2.0/23.0)*(t3*t2+42.0/19.0*t6*t3*s+35.0/19.0*t3*t8+700.0/969.0*
t2*s*t8*t6+175.0/1292.0*t2*t13+7.0/646.0*s*t13*t6+t13*t8/3876)*(t20+6.0/5.0*t*
t21+3.0/10.0*t23);
   /* p=13 1 7 1 */
   } else if( i==1 && j==7 && k==1 ) {
      t2 = s*s;
      t3 = t2*s;
      t4 = t2*t2;
      t7 = r-1.0;
      t10 = t7*t7;
      t12 = t10*t7;
      t14 = t10*t10;
      f = (r-2.0/23.0)*(t4*t3+56.0/19.0*t4*t2*t7+196.0/57.0*t4*s*t10+1960.0/
969.0*t4*t12+1225.0/1938.0*t3*t14+98.0/969.0*t2*t14*t7+7.0/969.0*s*t14*t10+2.0/
12597.0*t14*t12)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=13 1 8 0 */
   } else if( i==1 && j==8 && k==0 ) {
      t2 = s*s;
      t3 = t2*t2;
      t4 = t3*t3;
      t5 = t2*s;
      t7 = r-1.0;
      t10 = t7*t7;
      t13 = t10*t7;
      t15 = t10*t10;
      t23 = t15*t15;
      f = (r-2.0/23.0)*(t4+72.0/19.0*t3*t5*t7+112.0/19.0*t3*t2*t10+1568.0/
323.0*t3*s*t13+735.0/323.0*t3*t15+196.0/323.0*t5*t15*t7+28.0/323.0*t2*t15*t10+
24.0/4199.0*s*t15*t13+t23/8398);
   /* p=13 2 0 7 */
   } else if( i==2 && j==0 && k==7 ) {
      t1 = r*r;
      t3 = t*t;
      t4 = t3*t;
      t5 = t3*t3;
      t8 = s+r-1.0;
      t11 = t8*t8;
      t13 = t11*t8;
      t15 = t11*t11;
      f = (t1-6.0/23.0*r+3.0/253.0)*(t5*t4+56.0/15.0*t3*t5*t8+28.0/5.0*t5*t*
t11+56.0/13.0*t5*t13+70.0/39.0*t4*t15+56.0/143.0*t3*t15*t8+28.0/715.0*t*t15*t11
+8.0/6435.0*t15*t13);
   /* p=13 2 1 6 */
   } else if( i==2 && j==1 && k==6 ) {
      t1 = r*r;
      t5 = t*t;
      t6 = t5*t5;
      t9 = s+r-1.0;
      t11 = t9*t9;
      t16 = t11*t11;
      f = (s+2.0/17.0*r-2.0/17.0)*(t1-6.0/23.0*r+3.0/253.0)*(t6*t5+42.0/13.0*
t6*t*t9+105.0/26.0*t6*t11+350.0/143.0*t5*t*t11*t9+105.0/143.0*t5*t16+14.0/143.0
*t*t16*t9+7.0/1716.0*t16*t11);
   /* p=13 2 2 5 */
   } else if( i==2 && j==2 && k==5 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t9 = t*t;
      t10 = t9*t9;
      t12 = s+r-1.0;
      t15 = t12*t12;
      t19 = t15*t15;
      f = (t1-6.0/23.0*r+3.0/253.0)*(t3+6.0/17.0*s*t4+3.0/136.0*t6)*(t10*t+
30.0/11.0*t10*t12+30.0/11.0*t9*t*t15+40.0/33.0*t9*t15*t12+5.0/22.0*t*t19+t19*
t12/77);
   /* p=13 2 3 4 */
   } else if( i==2 && j==3 && k==4 ) {
      t1 = r*r;
      t3 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t12 = t*t;
      t13 = t12*t12;
      t15 = s+r-1.0;
      t17 = t15*t15;
      t21 = t17*t17;
      f = (t1-6.0/23.0*r+3.0/253.0)*(t3*s+12.0/17.0*t3*t5+9.0/68.0*s*t7+t7*t5
/170)*(t13+20.0/9.0*t12*t*t15+5.0/3.0*t12*t17+10.0/21.0*t*t17*t15+5.0/126.0*t21
);
   /* p=13 2 4 3 */
   } else if( i==2 && j==4 && k==3 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t6 = r-1.0;
      t8 = t6*t6;
      t12 = t8*t8;
      t15 = t*t;
      t17 = s+r-1.0;
      t19 = t17*t17;
      f = (t1-6.0/23.0*r+3.0/253.0)*(t4+20.0/17.0*t6*t3*s+15.0/34.0*t3*t8+s*
t8*t6/17+t12/476)*(t15*t+12.0/7.0*t17*t15+6.0/7.0*t*t19+4.0/35.0*t19*t17);
   /* p=13 2 5 2 */
   } else if( i==2 && j==5 && k==2 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t6 = r-1.0;
      t9 = t6*t6;
      t13 = t9*t9;
      t18 = t*t;
      t19 = s+r-1.0;
      t21 = t19*t19;
      f = (t1-6.0/23.0*r+3.0/253.0)*(t4*s+30.0/17.0*t4*t6+75.0/68.0*t3*s*t9+
5.0/17.0*t3*t9*t6+15.0/476.0*s*t13+3.0/3094.0*t13*t6)*(t18+6.0/5.0*t*t19+3.0/
10.0*t21);
   /* p=13 2 6 1 */
   } else if( i==2 && j==6 && k==1 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t7 = r-1.0;
      t9 = t7*t7;
      t14 = t9*t9;
      f = (t1-6.0/23.0*r+3.0/253.0)*(t4*t3+42.0/17.0*t4*s*t7+315.0/136.0*t4*
t9+35.0/34.0*t3*s*t9*t7+15.0/68.0*t3*t14+9.0/442.0*s*t14*t7+t14*t9/1768)*(t+2.0
/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=13 2 7 0 */
   } else if( i==2 && j==7 && k==0 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*s;
      t5 = t3*t3;
      t8 = r-1.0;
      t11 = t8*t8;
      t13 = t11*t8;
      t15 = t11*t11;
      f = (t1-6.0/23.0*r+3.0/253.0)*(t5*t4+56.0/17.0*t5*t3*t8+147.0/34.0*t5*s
*t11+49.0/17.0*t5*t13+35.0/34.0*t4*t15+42.0/221.0*t3*t15*t8+7.0/442.0*s*t15*t11
+t15*t13/2431);
   /* p=13 3 0 6 */
   } else if( i==3 && j==0 && k==6 ) {
      t1 = r*r;
      t4 = t*t;
      t5 = t4*t4;
      t8 = s+r-1.0;
      t10 = t8*t8;
      t15 = t10*t10;
      f = (t1*r-12.0/23.0*t1+18.0/253.0*r-4.0/1771.0)*(t5*t4+42.0/13.0*t5*t*
t8+105.0/26.0*t5*t10+350.0/143.0*t4*t*t10*t8+105.0/143.0*t4*t15+14.0/143.0*t*
t15*t8+7.0/1716.0*t15*t10);
   /* p=13 3 1 5 */
   } else if( i==3 && j==1 && k==5 ) {
      t1 = r*r;
      t6 = t*t;
      t7 = t6*t6;
      t9 = s+r-1.0;
      t12 = t9*t9;
      t16 = t12*t12;
      f = (s+2.0/15.0*r-2.0/15.0)*(t1*r-12.0/23.0*t1+18.0/253.0*r-4.0/1771.0)
*(t7*t+30.0/11.0*t9*t7+30.0/11.0*t6*t*t12+40.0/33.0*t6*t12*t9+5.0/22.0*t*t16+
t16*t9/77);
   /* p=13 3 2 4 */
   } else if( i==3 && j==2 && k==4 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t10 = t*t;
      t11 = t10*t10;
      t13 = s+r-1.0;
      t15 = t13*t13;
      t19 = t15*t15;
      f = (t1*r-12.0/23.0*t1+18.0/253.0*r-4.0/1771.0)*(t4+2.0/5.0*s*t5+t7/35)
*(t11+20.0/9.0*t10*t*t13+5.0/3.0*t15*t10+10.0/21.0*t*t15*t13+5.0/126.0*t19);
   /* p=13 3 3 3 */
   } else if( i==3 && j==3 && k==3 ) {
      t1 = r*r;
      t4 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t13 = t*t;
      t15 = s+r-1.0;
      t17 = t15*t15;
      f = (t1*r-12.0/23.0*t1+18.0/253.0*r-4.0/1771.0)*(t4*s+4.0/5.0*t4*t6+6.0
/35.0*s*t8+4.0/455.0*t8*t6)*(t13*t+12.0/7.0*t15*t13+6.0/7.0*t*t17+4.0/35.0*t17*
t15);
   /* p=13 3 4 2 */
   } else if( i==3 && j==4 && k==2 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = t4*t4;
      t7 = r-1.0;
      t9 = t7*t7;
      t13 = t9*t9;
      t16 = t*t;
      t17 = s+r-1.0;
      t19 = t17*t17;
      f = (t1*r-12.0/23.0*t1+18.0/253.0*r-4.0/1771.0)*(t5+4.0/3.0*t4*s*t7+4.0
/7.0*t4*t9+8.0/91.0*s*t9*t7+t13/273)*(t16+6.0/5.0*t*t17+3.0/10.0*t19);
   /* p=13 3 5 1 */
   } else if( i==3 && j==5 && k==1 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = t4*t4;
      t7 = r-1.0;
      t10 = t7*t7;
      t14 = t10*t10;
      f = (t1*r-12.0/23.0*t1+18.0/253.0*r-4.0/1771.0)*(t5*s+2.0*t5*t7+10.0/
7.0*t4*s*t10+40.0/91.0*t4*t10*t7+5.0/91.0*s*t14+2.0/1001.0*t14*t7)*(t+2.0/3.0*s
+2.0/3.0*r-2.0/3.0);
   /* p=13 3 6 0 */
   } else if( i==3 && j==6 && k==0 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = t4*t4;
      t8 = r-1.0;
      t10 = t8*t8;
      t15 = t10*t10;
      f = (t1*r-12.0/23.0*t1+18.0/253.0*r-4.0/1771.0)*(t5*t4+14.0/5.0*t5*s*t8
+3.0*t5*t10+20.0/13.0*t4*s*t10*t8+5.0/13.0*t4*t15+6.0/143.0*s*t15*t8+t15*t10
/715);
   /* p=13 4 0 5 */
   } else if( i==4 && j==0 && k==5 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = t*t;
      t6 = t5*t5;
      t8 = s+r-1.0;
      t11 = t8*t8;
      t15 = t11*t11;
      f = (t2-20.0/23.0*t1*r+60.0/253.0*t1-40.0/1771.0*r+1.0/1771.0)*(t6*t+
30.0/11.0*t6*t8+30.0/11.0*t5*t*t11+40.0/33.0*t5*t11*t8+5.0/22.0*t*t15+t15*t8/77
);
   /* p=13 4 1 4 */
   } else if( i==4 && j==1 && k==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t7 = t*t;
      t8 = t7*t7;
      t10 = s+r-1.0;
      t12 = t10*t10;
      t16 = t12*t12;
      f = (s+2.0/13.0*r-2.0/13.0)*(t2-20.0/23.0*t1*r+60.0/253.0*t1-40.0/
1771.0*r+1.0/1771.0)*(t8+20.0/9.0*t7*t*t10+5.0/3.0*t7*t12+10.0/21.0*t*t12*t10+
5.0/126.0*t16);
   /* p=13 4 2 3 */
   } else if( i==4 && j==2 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t11 = t*t;
      t13 = s+r-1.0;
      t15 = t13*t13;
      f = (t2-20.0/23.0*t1*r+60.0/253.0*t1-40.0/1771.0*r+1.0/1771.0)*(t5+6.0/
13.0*s*t6+t8/26)*(t11*t+12.0/7.0*t11*t13+6.0/7.0*t*t15+4.0/35.0*t15*t13);
   /* p=13 4 3 2 */
   } else if( i==4 && j==3 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t14 = t*t;
      t15 = s+r-1.0;
      t17 = t15*t15;
      f = (t2-20.0/23.0*t1*r+60.0/253.0*t1-40.0/1771.0*r+1.0/1771.0)*(t5*s+
12.0/13.0*t5*t7+3.0/13.0*s*t9+2.0/143.0*t9*t7)*(t14+6.0/5.0*t*t15+3.0/10.0*t17)
;
   /* p=13 4 4 1 */
   } else if( i==4 && j==4 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t6 = t5*t5;
      t8 = r-1.0;
      t10 = t8*t8;
      t14 = t10*t10;
      f = (t2-20.0/23.0*t1*r+60.0/253.0*t1-40.0/1771.0*r+1.0/1771.0)*(t6+20.0
/13.0*t5*s*t8+10.0/13.0*t5*t10+20.0/143.0*s*t10*t8+t14/143)*(t+2.0/3.0*s+2.0/
3.0*r-2.0/3.0);
   /* p=13 4 5 0 */
   } else if( i==4 && j==5 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t6 = t5*t5;
      t8 = r-1.0;
      t11 = t8*t8;
      t15 = t11*t11;
      f = (t2-20.0/23.0*t1*r+60.0/253.0*t1-40.0/1771.0*r+1.0/1771.0)*(t6*s+
30.0/13.0*t6*t8+25.0/13.0*t5*s*t11+100.0/143.0*t5*t11*t8+15.0/143.0*s*t15+2.0/
429.0*t15*t8);
   /* p=13 5 0 4 */
   } else if( i==5 && j==0 && k==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = t*t;
      t7 = t6*t6;
      t9 = s+r-1.0;
      t11 = t9*t9;
      t15 = t11*t11;
      f = (t2*r-30.0/23.0*t2+150.0/253.0*t1*r-200.0/1771.0*t1+15.0/1771.0*r
-6.0/33649.0)*(t7+20.0/9.0*t6*t*t9+5.0/3.0*t6*t11+10.0/21.0*t*t11*t9+5.0/126.0*
t15);
   /* p=13 5 1 3 */
   } else if( i==5 && j==1 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t8 = t*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      f = (t2*r-30.0/23.0*t2+150.0/253.0*t1*r-200.0/1771.0*t1+15.0/1771.0*r
-6.0/33649.0)*(s+2.0/11.0*r-2.0/11.0)*(t8*t+12.0/7.0*t8*t10+6.0/7.0*t*t12+4.0/
35.0*t12*t10);
   /* p=13 5 2 2 */
   } else if( i==5 && j==2 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = s*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t12 = t*t;
      t13 = s+r-1.0;
      t15 = t13*t13;
      f = (t2*r-30.0/23.0*t2+150.0/253.0*t1*r-200.0/1771.0*t1+15.0/1771.0*r
-6.0/33649.0)*(t6+6.0/11.0*s*t7+3.0/55.0*t9)*(t12+6.0/5.0*t*t13+3.0/10.0*t15);
   /* p=13 5 3 1 */
   } else if( i==5 && j==3 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = s*s;
      t8 = r-1.0;
      t10 = t8*t8;
      f = (t2*r-30.0/23.0*t2+150.0/253.0*t1*r-200.0/1771.0*t1+15.0/1771.0*r
-6.0/33649.0)*(t6*s+12.0/11.0*t6*t8+18.0/55.0*s*t10+4.0/165.0*t8*t10)*(t+2.0/
3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=13 5 4 0 */
   } else if( i==5 && j==4 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = s*s;
      t7 = t6*t6;
      t9 = r-1.0;
      t11 = t9*t9;
      t15 = t11*t11;
      f = (t2*r-30.0/23.0*t2+150.0/253.0*t1*r-200.0/1771.0*t1+15.0/1771.0*r
-6.0/33649.0)*(t7+20.0/11.0*t6*s*t9+12.0/11.0*t6*t11+8.0/33.0*s*t11*t9+t15/66);
   /* p=13 6 0 3 */
   } else if( i==6 && j==0 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t7 = t*t;
      t9 = s+r-1.0;
      t11 = t9*t9;
      f = (t2*t1-42.0/23.0*t2*r+315.0/253.0*t2-100.0/253.0*t1*r+15.0/253.0*t1
-18.0/4807.0*r+1.0/14421.0)*(t7*t+12.0/7.0*t7*t9+6.0/7.0*t*t11+4.0/35.0*t11*t9)
;
   /* p=13 6 1 2 */
   } else if( i==6 && j==1 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t9 = t*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      f = (t2*t1-42.0/23.0*t2*r+315.0/253.0*t2-100.0/253.0*t1*r+15.0/253.0*t1
-18.0/4807.0*r+1.0/14421.0)*(s+2.0/9.0*r-2.0/9.0)*(t9+6.0/5.0*t*t10+3.0/10.0*
t12);
   /* p=13 6 2 1 */
   } else if( i==6 && j==2 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t7 = s*s;
      t8 = r-1.0;
      t10 = t8*t8;
      f = (t2*t1-42.0/23.0*t2*r+315.0/253.0*t2-100.0/253.0*t1*r+15.0/253.0*t1
-18.0/4807.0*r+1.0/14421.0)*(t7+2.0/3.0*s*t8+t10/12)*(t+2.0/3.0*s+2.0/3.0*r-2.0
/3.0);
   /* p=13 6 3 0 */
   } else if( i==6 && j==3 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t7 = s*s;
      t9 = r-1.0;
      t11 = t9*t9;
      f = (t2*t1-42.0/23.0*t2*r+315.0/253.0*t2-100.0/253.0*t1*r+15.0/253.0*t1
-18.0/4807.0*r+1.0/14421.0)*(t7*s+4.0/3.0*t7*t9+s*t11/2+t11*t9/21);
   /* p=13 7 0 2 */
   } else if( i==7 && j==0 && k==2 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t8 = t*t;
      t9 = s+r-1.0;
      t11 = t9*t9;
      f = (t3*t2-56.0/23.0*t3*t1+588.0/253.0*t3*r-280.0/253.0*t3+70.0/253.0*
t2-168.0/4807.0*t1+28.0/14421.0*r-8.0/245157.0)*(t8+6.0/5.0*t*t9+3.0/10.0*t11);
   /* p=13 7 1 1 */
   } else if( i==7 && j==1 && k==1 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      f = (t3*t2-56.0/23.0*t3*t1+588.0/253.0*t3*r-280.0/253.0*t3+70.0/253.0*
t2-168.0/4807.0*t1+28.0/14421.0*r-8.0/245157.0)*(s+2.0/7.0*r-2.0/7.0)*(t+2.0/
3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=13 7 2 0 */
   } else if( i==7 && j==2 && k==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t8 = s*s;
      t9 = r-1.0;
      t11 = t9*t9;
      f = (t3*t2-56.0/23.0*t3*t1+588.0/253.0*t3*r-280.0/253.0*t3+70.0/253.0*
t2-168.0/4807.0*t1+28.0/14421.0*r-8.0/245157.0)*(t8+6.0/7.0*s*t9+t11/7);
   /* p=13 8 0 1 */
   } else if( i==8 && j==0 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*r;
      f = (t3-72.0/23.0*t2*t4+1008.0/253.0*t2*t1-672.0/253.0*t2*r+252.0/253.0
*t2-1008.0/4807.0*t4+112.0/4807.0*t1-96.0/81719.0*r+3.0/163438.0)*(t+2.0/3.0*s+
2.0/3.0*r-2.0/3.0);
   /* p=13 8 1 0 */
   } else if( i==8 && j==1 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*r;
      f = (t3-72.0/23.0*t2*t4+1008.0/253.0*t2*t1-672.0/253.0*t2*r+252.0/253.0
*t2-1008.0/4807.0*t4+112.0/4807.0*t1-96.0/81719.0*r+3.0/163438.0)*(s+2.0/5.0*r
-2.0/5.0);
   /* p=13 9 0 0 */
   } else if( i==9 && j==0 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*r;
      f = t3*r-90.0/23.0*t3+1620.0/253.0*t2*t5-1440.0/253.0*t2*t1+756.0/253.0*
t2*r-4536.0/4807.0*t2+840.0/4807.0*t5-1440.0/81719.0*t1+135.0/163438.0*r-1.0/
81719.0;
   /* p=14 0 0 10 */
   } else if( i==0 && j==0 && k==10 ) {
      t1 = t*t;
      t2 = t1*t1;
      t3 = t2*t2;
      t6 = s+r-1.0;
      t8 = t6*t6;
      t10 = t1*t;
      t12 = t8*t6;
      t15 = t8*t8;
      t24 = t15*t15;
      f = t3*t1+110.0/21.0*t3*t*t6+165.0/14.0*t3*t8+1980.0/133.0*t2*t10*t12+
220.0/19.0*t2*t1*t15+1848.0/323.0*t2*t*t15*t6+1155.0/646.0*t2*t15*t8+110.0/
323.0*t10*t15*t12+165.0/4522.0*t1*t24+55.0/29393.0*t*t24*t6+11.0/352716.0*t24*
t8;
   /* p=14 0 1 9 */
   } else if( i==0 && j==1 && k==9 ) {
      t2 = t*t;
      t3 = t2*t2;
      t4 = t3*t3;
      t6 = s+r-1.0;
      t8 = t2*t;
      t10 = t6*t6;
      t13 = t10*t6;
      t16 = t10*t10;
      t24 = t16*t16;
      f = (s+2.0/23.0*r-2.0/23.0)*(t4*t+90.0/19.0*t4*t6+180.0/19.0*t3*t8*t10+
3360.0/323.0*t3*t2*t13+2205.0/323.0*t3*t*t16+882.0/323.0*t3*t16*t6+210.0/323.0*
t8*t16*t10+360.0/4199.0*t2*t16*t13+45.0/8398.0*t*t24+5.0/46189.0*t24*t6);
   /* p=14 0 2 8 */
   } else if( i==0 && j==2 && k==8 ) {
      t1 = s*s;
      t2 = r-1.0;
      t4 = t2*t2;
      t6 = t*t;
      t7 = t6*t6;
      t8 = t7*t7;
      t9 = t6*t;
      t11 = s+r-1.0;
      t14 = t11*t11;
      t17 = t14*t11;
      t19 = t14*t14;
      t27 = t19*t19;
      f = (t1+6.0/23.0*s*t2+3.0/253.0*t4)*(t8+72.0/17.0*t7*t9*t11+126.0/17.0*
t7*t6*t14+588.0/85.0*t7*t*t17+63.0/17.0*t7*t19+252.0/221.0*t9*t19*t11+42.0/
221.0*t6*t19*t14+36.0/2431.0*t*t19*t17+9.0/24310.0*t27);
   /* p=14 0 3 7 */
   } else if( i==0 && j==3 && k==7 ) {
      t1 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t9 = t*t;
      t10 = t9*t;
      t11 = t9*t9;
      t14 = s+r-1.0;
      t17 = t14*t14;
      t19 = t17*t14;
      t21 = t17*t17;
      f = (t1*s+12.0/23.0*t3*t1+18.0/253.0*s*t5+4.0/1771.0*t5*t3)*(t10*t11+
56.0/15.0*t11*t9*t14+28.0/5.0*t11*t*t17+56.0/13.0*t19*t11+70.0/39.0*t10*t21+
56.0/143.0*t9*t21*t14+28.0/715.0*t*t21*t17+8.0/6435.0*t21*t19);
   /* p=14 0 4 6 */
   } else if( i==0 && j==4 && k==6 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t6 = t4*t4;
      t10 = t6*t6;
      t12 = t*t;
      t13 = t12*t12;
      t16 = s+r-1.0;
      t18 = t16*t16;
      t23 = t18*t18;
      f = (t2+20.0/23.0*t1*s*t4+60.0/253.0*t1*t6+40.0/1771.0*s*t4*t6+t10/1771
)*(t12*t13+42.0/13.0*t13*t*t16+105.0/26.0*t13*t18+350.0/143.0*t12*t*t18*t16+
105.0/143.0*t12*t23+14.0/143.0*t*t23*t16+7.0/1716.0*t23*t18);
   /* p=14 0 5 5 */
   } else if( i==0 && j==5 && k==5 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t7 = t4*t4;
      t11 = t7*t7;
      t15 = t*t;
      t16 = t15*t15;
      t18 = s+r-1.0;
      t21 = t18*t18;
      t25 = t21*t21;
      f = (s*t2+30.0/23.0*t2*t4+150.0/253.0*t7*t1*s+200.0/1771.0*t1*t7*t4+
15.0/1771.0*s*t11+6.0/33649.0*t11*t4)*(t16*t+30.0/11.0*t18*t16+30.0/11.0*t15*t*
t21+40.0/33.0*t15*t21*t18+5.0/22.0*t*t25+t25*t18/77);
   /* p=14 0 6 4 */
   } else if( i==0 && j==6 && k==4 ) {
      t1 = s*s;
      t2 = t1*t1;
      t5 = r-1.0;
      t7 = t5*t5;
      t12 = t7*t7;
      t18 = t*t;
      t19 = t18*t18;
      t21 = s+r-1.0;
      t23 = t21*t21;
      t27 = t23*t23;
      f = (t2*t1+42.0/23.0*t2*s*t5+315.0/253.0*t2*t7+100.0/253.0*t1*s*t7*t5+
15.0/253.0*t1*t12+18.0/4807.0*s*t12*t5+t12*t7/14421)*(t19+20.0/9.0*t18*t*t21+
5.0/3.0*t23*t18+10.0/21.0*t*t23*t21+5.0/126.0*t27);
   /* p=14 0 7 3 */
   } else if( i==0 && j==7 && k==3 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t6 = r-1.0;
      t9 = t6*t6;
      t11 = t9*t6;
      t13 = t9*t9;
      t21 = t*t;
      t23 = s+r-1.0;
      t25 = t23*t23;
      f = (t3*t2+56.0/23.0*t3*t1*t6+588.0/253.0*t3*s*t9+280.0/253.0*t3*t11+
70.0/253.0*t2*t13+168.0/4807.0*t1*t13*t6+28.0/14421.0*s*t13*t9+8.0/245157.0*t13
*t11)*(t21*t+12.0/7.0*t21*t23+6.0/7.0*t*t25+4.0/35.0*t25*t23);
   /* p=14 0 8 2 */
   } else if( i==0 && j==8 && k==2 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*s;
      t6 = r-1.0;
      t9 = t6*t6;
      t12 = t9*t6;
      t14 = t9*t9;
      t22 = t14*t14;
      t24 = t*t;
      t25 = s+r-1.0;
      t27 = t25*t25;
      f = (t3+72.0/23.0*t2*t4*t6+1008.0/253.0*t2*t1*t9+672.0/253.0*t2*s*t12+
252.0/253.0*t2*t14+1008.0/4807.0*t4*t14*t6+112.0/4807.0*t1*t14*t9+96.0/81719.0*
s*t14*t12+3.0/163438.0*t22)*(t24+6.0/5.0*t*t25+3.0/10.0*t27);
   /* p=14 0 9 1 */
   } else if( i==0 && j==9 && k==1 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = r-1.0;
      t7 = t1*s;
      t9 = t5*t5;
      t12 = t9*t5;
      t15 = t9*t9;
      t23 = t15*t15;
      f = (t3*s+90.0/23.0*t3*t5+1620.0/253.0*t2*t7*t9+1440.0/253.0*t2*t1*t12+
756.0/253.0*t2*s*t15+4536.0/4807.0*t2*t15*t5+840.0/4807.0*t7*t15*t9+1440.0/
81719.0*t1*t15*t12+135.0/163438.0*s*t23+t23*t5/81719)*(t+2.0/3.0*s+2.0/3.0*r
-2.0/3.0);
   /* p=14 0 10 0 */
   } else if( i==0 && j==10 && k==0 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t6 = r-1.0;
      t8 = t6*t6;
      t10 = t1*s;
      t12 = t8*t6;
      t15 = t8*t8;
      t24 = t15*t15;
      f = t3*t1+110.0/23.0*t3*s*t6+225.0/23.0*t3*t8+1800.0/161.0*t2*t10*t12+
180.0/23.0*t2*t1*t15+1512.0/437.0*t2*s*t15*t6+420.0/437.0*t2*t15*t8+1200.0/
7429.0*t10*t15*t12+225.0/14858.0*t1*t24+5.0/7429.0*s*t24*t6+t24*t8/104006;
   /* p=14 1 0 9 */
   } else if( i==1 && j==0 && k==9 ) {
      t2 = t*t;
      t3 = t2*t2;
      t4 = t3*t3;
      t6 = s+r-1.0;
      t8 = t2*t;
      t10 = t6*t6;
      t13 = t10*t6;
      t16 = t10*t10;
      t24 = t16*t16;
      f = (r-2.0/25.0)*(t4*t+90.0/19.0*t4*t6+180.0/19.0*t3*t8*t10+3360.0/
323.0*t3*t2*t13+2205.0/323.0*t3*t*t16+882.0/323.0*t3*t16*t6+210.0/323.0*t8*t16*
t10+360.0/4199.0*t2*t16*t13+45.0/8398.0*t*t24+5.0/46189.0*t24*t6);
   /* p=14 1 1 8 */
   } else if( i==1 && j==1 && k==8 ) {
      t4 = t*t;
      t5 = t4*t4;
      t6 = t5*t5;
      t7 = t4*t;
      t9 = s+r-1.0;
      t12 = t9*t9;
      t15 = t12*t9;
      t17 = t12*t12;
      t25 = t17*t17;
      f = (s+2.0/21.0*r-2.0/21.0)*(r-2.0/25.0)*(t6+72.0/17.0*t5*t7*t9+126.0/
17.0*t5*t4*t12+588.0/85.0*t5*t*t15+63.0/17.0*t5*t17+252.0/221.0*t7*t17*t9+42.0/
221.0*t4*t17*t12+36.0/2431.0*t*t17*t15+9.0/24310.0*t25);
   /* p=14 1 2 7 */
   } else if( i==1 && j==2 && k==7 ) {
      t2 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t8 = t*t;
      t9 = t8*t;
      t10 = t8*t8;
      t13 = s+r-1.0;
      t16 = t13*t13;
      t18 = t16*t13;
      t20 = t16*t16;
      f = (r-2.0/25.0)*(t2+2.0/7.0*s*t3+t5/70)*(t10*t9+56.0/15.0*t10*t8*t13+
28.0/5.0*t10*t*t16+56.0/13.0*t10*t18+70.0/39.0*t9*t20+56.0/143.0*t8*t20*t13+
28.0/715.0*t*t20*t16+8.0/6435.0*t20*t18);
   /* p=14 1 3 6 */
   } else if( i==1 && j==3 && k==6 ) {
      t2 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t11 = t*t;
      t12 = t11*t11;
      t15 = s+r-1.0;
      t17 = t15*t15;
      t22 = t17*t17;
      f = (r-2.0/25.0)*(t2*s+4.0/7.0*t2*t4+3.0/35.0*s*t6+2.0/665.0*t6*t4)*(
t11*t12+42.0/13.0*t12*t*t15+105.0/26.0*t17*t12+350.0/143.0*t11*t*t17*t15+105.0/
143.0*t11*t22+14.0/143.0*t*t22*t15+7.0/1716.0*t22*t17);
   /* p=14 1 4 5 */
   } else if( i==1 && j==4 && k==5 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = r-1.0;
      t7 = t5*t5;
      t11 = t7*t7;
      t14 = t*t;
      t15 = t14*t14;
      t17 = s+r-1.0;
      t20 = t17*t17;
      t24 = t20*t20;
      f = (r-2.0/25.0)*(t3+20.0/21.0*t5*t2*s+2.0/7.0*t2*t7+4.0/133.0*s*t5*t7+
t11/1197)*(t15*t+30.0/11.0*t17*t15+30.0/11.0*t14*t*t20+40.0/33.0*t14*t20*t17+
5.0/22.0*t*t24+t24*t17/77);
   /* p=14 1 5 4 */
   } else if( i==1 && j==5 && k==4 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = r-1.0;
      t8 = t5*t5;
      t12 = t8*t8;
      t17 = t*t;
      t18 = t17*t17;
      t20 = s+r-1.0;
      t22 = t20*t20;
      t26 = t22*t22;
      f = (r-2.0/25.0)*(s*t3+10.0/7.0*t3*t5+5.0/7.0*t2*s*t8+20.0/133.0*t2*t8*
t5+5.0/399.0*s*t12+2.0/6783.0*t12*t5)*(t18+20.0/9.0*t17*t*t20+5.0/3.0*t22*t17+
10.0/21.0*t*t22*t20+5.0/126.0*t26);
   /* p=14 1 6 3 */
   } else if( i==1 && j==6 && k==3 ) {
      t2 = s*s;
      t3 = t2*t2;
      t6 = r-1.0;
      t8 = t6*t6;
      t13 = t8*t8;
      t20 = t*t;
      t22 = s+r-1.0;
      t24 = t22*t22;
      f = (r-2.0/25.0)*(t3*t2+2.0*t3*s*t6+3.0/2.0*t3*t8+10.0/19.0*t2*s*t8*t6+
5.0/57.0*t2*t13+2.0/323.0*s*t13*t6+t13*t8/7752)*(t20*t+12.0/7.0*t22*t20+6.0/7.0
*t*t24+4.0/35.0*t24*t22);
   /* p=14 1 7 2 */
   } else if( i==1 && j==7 && k==2 ) {
      t2 = s*s;
      t3 = t2*s;
      t4 = t2*t2;
      t7 = r-1.0;
      t10 = t7*t7;
      t12 = t10*t7;
      t14 = t10*t10;
      t23 = t*t;
      t24 = s+r-1.0;
      t26 = t24*t24;
      f = (r-2.0/25.0)*(t4*t3+8.0/3.0*t2*t4*t7+14.0/5.0*t10*t4*s+28.0/19.0*t4
*t12+70.0/171.0*t3*t14+56.0/969.0*t2*t14*t7+7.0/1938.0*s*t14*t10+t14*t12/14535)
*(t23+6.0/5.0*t*t24+3.0/10.0*t26);
   /* p=14 1 8 1 */
   } else if( i==1 && j==8 && k==1 ) {
      t2 = s*s;
      t3 = t2*t2;
      t4 = t3*t3;
      t5 = t2*s;
      t7 = r-1.0;
      t10 = t7*t7;
      t13 = t10*t7;
      t15 = t10*t10;
      t23 = t15*t15;
      f = (r-2.0/25.0)*(t4+24.0/7.0*t3*t5*t7+24.0/5.0*t3*t2*t10+336.0/95.0*t3
*s*t13+28.0/19.0*t3*t15+112.0/323.0*t5*t15*t7+14.0/323.0*t2*t15*t10+4.0/1615.0*
s*t15*t13+t23/22610)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=14 1 9 0 */
   } else if( i==1 && j==9 && k==0 ) {
      t2 = s*s;
      t3 = t2*t2;
      t4 = t3*t3;
      t6 = r-1.0;
      t8 = t2*s;
      t10 = t6*t6;
      t13 = t10*t6;
      t16 = t10*t10;
      t24 = t16*t16;
      f = (r-2.0/25.0)*(t4*s+30.0/7.0*t4*t6+54.0/7.0*t3*t8*t10+144.0/19.0*t3*
t2*t13+84.0/19.0*t3*s*t16+504.0/323.0*t3*t16*t6+105.0/323.0*t8*t16*t10+12.0/
323.0*t2*t16*t13+9.0/4522.0*s*t24+t24*t6/29393);
   /* p=14 2 0 8 */
   } else if( i==2 && j==0 && k==8 ) {
      t1 = r*r;
      t3 = t*t;
      t4 = t3*t3;
      t5 = t4*t4;
      t6 = t3*t;
      t8 = s+r-1.0;
      t11 = t8*t8;
      t14 = t11*t8;
      t16 = t11*t11;
      t24 = t16*t16;
      f = (t1-6.0/25.0*r+1.0/100.0)*(t5+72.0/17.0*t4*t6*t8+126.0/17.0*t4*t3*
t11+588.0/85.0*t4*t*t14+63.0/17.0*t4*t16+252.0/221.0*t6*t16*t8+42.0/221.0*t3*
t16*t11+36.0/2431.0*t*t16*t14+9.0/24310.0*t24);
   /* p=14 2 1 7 */
   } else if( i==2 && j==1 && k==7 ) {
      t1 = r*r;
      t5 = t*t;
      t6 = t5*t;
      t7 = t5*t5;
      t10 = s+r-1.0;
      t13 = t10*t10;
      t15 = t13*t10;
      t17 = t13*t13;
      f = (s+2.0/19.0*r-2.0/19.0)*(t1-6.0/25.0*r+1.0/100.0)*(t6*t7+56.0/15.0*
t7*t5*t10+28.0/5.0*t7*t*t13+56.0/13.0*t15*t7+70.0/39.0*t6*t17+56.0/143.0*t5*t17
*t10+28.0/715.0*t*t17*t13+8.0/6435.0*t17*t15);
   /* p=14 2 2 6 */
   } else if( i==2 && j==2 && k==6 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t9 = t*t;
      t10 = t9*t9;
      t13 = s+r-1.0;
      t15 = t13*t13;
      t20 = t15*t15;
      f = (t1-6.0/25.0*r+1.0/100.0)*(t3+6.0/19.0*t4*s+t6/57)*(t9*t10+42.0/
13.0*t10*t*t13+105.0/26.0*t15*t10+350.0/143.0*t9*t*t15*t13+105.0/143.0*t9*t20+
14.0/143.0*t*t20*t13+7.0/1716.0*t20*t15);
   /* p=14 2 3 5 */
   } else if( i==2 && j==3 && k==5 ) {
      t1 = r*r;
      t3 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t12 = t*t;
      t13 = t12*t12;
      t15 = s+r-1.0;
      t18 = t15*t15;
      t22 = t18*t18;
      f = (t1-6.0/25.0*r+1.0/100.0)*(t3*s+12.0/19.0*t3*t5+2.0/19.0*s*t7+4.0/
969.0*t7*t5)*(t13*t+30.0/11.0*t15*t13+30.0/11.0*t12*t*t18+40.0/33.0*t12*t18*t15
+5.0/22.0*t*t22+t22*t15/77);
   /* p=14 2 4 4 */
   } else if( i==2 && j==4 && k==4 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t6 = r-1.0;
      t8 = t6*t6;
      t12 = t8*t8;
      t15 = t*t;
      t16 = t15*t15;
      t18 = s+r-1.0;
      t20 = t18*t18;
      t24 = t20*t20;
      f = (t1-6.0/25.0*r+1.0/100.0)*(t4+20.0/19.0*t3*s*t6+20.0/57.0*t3*t8+
40.0/969.0*s*t8*t6+5.0/3876.0*t12)*(t16+20.0/9.0*t15*t*t18+5.0/3.0*t15*t20+10.0
/21.0*t*t20*t18+5.0/126.0*t24);
   /* p=14 2 5 3 */
   } else if( i==2 && j==5 && k==3 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t6 = r-1.0;
      t9 = t6*t6;
      t13 = t9*t9;
      t18 = t*t;
      t20 = s+r-1.0;
      t22 = t20*t20;
      f = (t1-6.0/25.0*r+1.0/100.0)*(t4*s+30.0/19.0*t4*t6+50.0/57.0*t3*s*t9+
200.0/969.0*t3*t9*t6+25.0/1292.0*s*t13+t13*t6/1938)*(t18*t+12.0/7.0*t20*t18+6.0
/7.0*t*t22+4.0/35.0*t22*t20);
   /* p=14 2 6 2 */
   } else if( i==2 && j==6 && k==2 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t7 = r-1.0;
      t9 = t7*t7;
      t14 = t9*t9;
      t21 = t*t;
      t22 = s+r-1.0;
      t24 = t22*t22;
      f = (t1-6.0/25.0*r+1.0/100.0)*(t4*t3+42.0/19.0*t4*s*t7+35.0/19.0*t4*t9+
700.0/969.0*t3*s*t9*t7+175.0/1292.0*t3*t14+7.0/646.0*s*t14*t7+t14*t9/3876)*(t21
+6.0/5.0*t*t22+3.0/10.0*t24);
   /* p=14 2 7 1 */
   } else if( i==2 && j==7 && k==1 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*s;
      t5 = t3*t3;
      t8 = r-1.0;
      t11 = t8*t8;
      t13 = t11*t8;
      t15 = t11*t11;
      f = (t1-6.0/25.0*r+1.0/100.0)*(t5*t4+56.0/19.0*t5*t3*t8+196.0/57.0*t5*s
*t11+1960.0/969.0*t5*t13+1225.0/1938.0*t4*t15+98.0/969.0*t3*t15*t8+7.0/969.0*s*
t15*t11+2.0/12597.0*t15*t13)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=14 2 8 0 */
   } else if( i==2 && j==8 && k==0 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t5 = t4*t4;
      t6 = t3*s;
      t8 = r-1.0;
      t11 = t8*t8;
      t14 = t11*t8;
      t16 = t11*t11;
      t24 = t16*t16;
      f = (t1-6.0/25.0*r+1.0/100.0)*(t5+72.0/19.0*t4*t6*t8+112.0/19.0*t4*t3*
t11+1568.0/323.0*t4*s*t14+735.0/323.0*t4*t16+196.0/323.0*t6*t16*t8+28.0/323.0*
t3*t16*t11+24.0/4199.0*s*t16*t14+t24/8398);
   /* p=14 3 0 7 */
   } else if( i==3 && j==0 && k==7 ) {
      t1 = r*r;
      t4 = t*t;
      t5 = t4*t;
      t6 = t4*t4;
      t9 = s+r-1.0;
      t12 = t9*t9;
      t14 = t12*t9;
      t16 = t12*t12;
      f = (t1*r-12.0/25.0*t1+3.0/50.0*r-1.0/575.0)*(t5*t6+56.0/15.0*t4*t6*t9+
28.0/5.0*t6*t*t12+56.0/13.0*t6*t14+70.0/39.0*t5*t16+56.0/143.0*t4*t16*t9+28.0/
715.0*t*t16*t12+8.0/6435.0*t16*t14);
   /* p=14 3 1 6 */
   } else if( i==3 && j==1 && k==6 ) {
      t1 = r*r;
      t6 = t*t;
      t7 = t6*t6;
      t10 = s+r-1.0;
      t12 = t10*t10;
      t17 = t12*t12;
      f = (s+2.0/17.0*r-2.0/17.0)*(t1*r-12.0/25.0*t1+3.0/50.0*r-1.0/575.0)*(
t6*t7+42.0/13.0*t7*t*t10+105.0/26.0*t7*t12+350.0/143.0*t6*t*t12*t10+105.0/143.0
*t6*t17+14.0/143.0*t*t17*t10+7.0/1716.0*t17*t12);
   /* p=14 3 2 5 */
   } else if( i==3 && j==2 && k==5 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t10 = t*t;
      t11 = t10*t10;
      t13 = s+r-1.0;
      t16 = t13*t13;
      t20 = t16*t16;
      f = (t1*r-12.0/25.0*t1+3.0/50.0*r-1.0/575.0)*(t4+6.0/17.0*s*t5+3.0/
136.0*t7)*(t11*t+30.0/11.0*t11*t13+30.0/11.0*t10*t*t16+40.0/33.0*t10*t16*t13+
5.0/22.0*t*t20+t20*t13/77);
   /* p=14 3 3 4 */
   } else if( i==3 && j==3 && k==4 ) {
      t1 = r*r;
      t4 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t13 = t*t;
      t14 = t13*t13;
      t16 = s+r-1.0;
      t18 = t16*t16;
      t22 = t18*t18;
      f = (t1*r-12.0/25.0*t1+3.0/50.0*r-1.0/575.0)*(t4*s+12.0/17.0*t4*t6+9.0/
68.0*s*t8+t8*t6/170)*(t14+20.0/9.0*t13*t*t16+5.0/3.0*t13*t18+10.0/21.0*t*t18*
t16+5.0/126.0*t22);
   /* p=14 3 4 3 */
   } else if( i==3 && j==4 && k==3 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = t4*t4;
      t7 = r-1.0;
      t9 = t7*t7;
      t13 = t9*t9;
      t16 = t*t;
      t18 = s+r-1.0;
      t20 = t18*t18;
      f = (t1*r-12.0/25.0*t1+3.0/50.0*r-1.0/575.0)*(t5+20.0/17.0*t4*s*t7+15.0
/34.0*t4*t9+s*t9*t7/17+t13/476)*(t16*t+12.0/7.0*t18*t16+6.0/7.0*t*t20+4.0/35.0*
t20*t18);
   /* p=14 3 5 2 */
   } else if( i==3 && j==5 && k==2 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = t4*t4;
      t7 = r-1.0;
      t10 = t7*t7;
      t14 = t10*t10;
      t19 = t*t;
      t20 = s+r-1.0;
      t22 = t20*t20;
      f = (t1*r-12.0/25.0*t1+3.0/50.0*r-1.0/575.0)*(s*t5+30.0/17.0*t5*t7+75.0
/68.0*t4*s*t10+5.0/17.0*t4*t10*t7+15.0/476.0*s*t14+3.0/3094.0*t14*t7)*(t19+6.0/
5.0*t*t20+3.0/10.0*t22);
   /* p=14 3 6 1 */
   } else if( i==3 && j==6 && k==1 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = t4*t4;
      t8 = r-1.0;
      t10 = t8*t8;
      t15 = t10*t10;
      f = (t1*r-12.0/25.0*t1+3.0/50.0*r-1.0/575.0)*(t5*t4+42.0/17.0*t5*s*t8+
315.0/136.0*t5*t10+35.0/34.0*t4*s*t10*t8+15.0/68.0*t4*t15+9.0/442.0*s*t15*t8+
t15*t10/1768)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=14 3 7 0 */
   } else if( i==3 && j==7 && k==0 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = t4*s;
      t6 = t4*t4;
      t9 = r-1.0;
      t12 = t9*t9;
      t14 = t12*t9;
      t16 = t12*t12;
      f = (t1*r-12.0/25.0*t1+3.0/50.0*r-1.0/575.0)*(t6*t5+56.0/17.0*t4*t6*t9+
147.0/34.0*t6*s*t12+49.0/17.0*t6*t14+35.0/34.0*t5*t16+42.0/221.0*t4*t16*t9+7.0/
442.0*s*t16*t12+t16*t14/2431);
   /* p=14 4 0 6 */
   } else if( i==4 && j==0 && k==6 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = t*t;
      t6 = t5*t5;
      t9 = s+r-1.0;
      t11 = t9*t9;
      t16 = t11*t11;
      f = (t2-4.0/5.0*t1*r+t1/5-2.0/115.0*r+1.0/2530.0)*(t6*t5+42.0/13.0*t6*t
*t9+105.0/26.0*t6*t11+350.0/143.0*t5*t*t11*t9+105.0/143.0*t5*t16+14.0/143.0*t*
t16*t9+7.0/1716.0*t16*t11);
   /* p=14 4 1 5 */
   } else if( i==4 && j==1 && k==5 ) {
      t1 = r*r;
      t2 = t1*t1;
      t7 = t*t;
      t8 = t7*t7;
      t10 = s+r-1.0;
      t13 = t10*t10;
      t17 = t13*t13;
      f = (t2-4.0/5.0*t1*r+t1/5-2.0/115.0*r+1.0/2530.0)*(s+2.0/15.0*r-2.0/
15.0)*(t8*t+30.0/11.0*t8*t10+30.0/11.0*t7*t*t13+40.0/33.0*t7*t13*t10+5.0/22.0*t
*t17+t17*t10/77);
   /* p=14 4 2 4 */
   } else if( i==4 && j==2 && k==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t11 = t*t;
      t12 = t11*t11;
      t14 = s+r-1.0;
      t16 = t14*t14;
      t20 = t16*t16;
      f = (t2-4.0/5.0*t1*r+t1/5-2.0/115.0*r+1.0/2530.0)*(t5+2.0/5.0*s*t6+t8
/35)*(t12+20.0/9.0*t11*t*t14+5.0/3.0*t16*t11+10.0/21.0*t*t16*t14+5.0/126.0*t20)
;
   /* p=14 4 3 3 */
   } else if( i==4 && j==3 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t14 = t*t;
      t16 = s+r-1.0;
      t18 = t16*t16;
      f = (t2-4.0/5.0*t1*r+t1/5-2.0/115.0*r+1.0/2530.0)*(t5*s+4.0/5.0*t5*t7+
6.0/35.0*s*t9+4.0/455.0*t9*t7)*(t14*t+12.0/7.0*t16*t14+6.0/7.0*t*t18+4.0/35.0*
t18*t16);
   /* p=14 4 4 2 */
   } else if( i==4 && j==4 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t6 = t5*t5;
      t8 = r-1.0;
      t10 = t8*t8;
      t14 = t10*t10;
      t17 = t*t;
      t18 = s+r-1.0;
      t20 = t18*t18;
      f = (t2-4.0/5.0*t1*r+t1/5-2.0/115.0*r+1.0/2530.0)*(t6+4.0/3.0*t5*s*t8+
4.0/7.0*t5*t10+8.0/91.0*s*t8*t10+t14/273)*(t17+6.0/5.0*t*t18+3.0/10.0*t20);
   /* p=14 4 5 1 */
   } else if( i==4 && j==5 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t6 = t5*t5;
      t8 = r-1.0;
      t11 = t8*t8;
      t15 = t11*t11;
      f = (t2-4.0/5.0*t1*r+t1/5-2.0/115.0*r+1.0/2530.0)*(s*t6+2.0*t6*t8+10.0/
7.0*t5*s*t11+40.0/91.0*t5*t11*t8+5.0/91.0*s*t15+2.0/1001.0*t15*t8)*(t+2.0/3.0*s
+2.0/3.0*r-2.0/3.0);
   /* p=14 4 6 0 */
   } else if( i==4 && j==6 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t6 = t5*t5;
      t9 = r-1.0;
      t11 = t9*t9;
      t16 = t11*t11;
      f = (t2-4.0/5.0*t1*r+t1/5-2.0/115.0*r+1.0/2530.0)*(t6*t5+14.0/5.0*t6*s*
t9+3.0*t6*t11+20.0/13.0*t5*s*t11*t9+5.0/13.0*t5*t16+6.0/143.0*s*t16*t9+t16*t11
/715);
   /* p=14 5 0 5 */
   } else if( i==5 && j==0 && k==5 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = t*t;
      t7 = t6*t6;
      t9 = s+r-1.0;
      t12 = t9*t9;
      t16 = t12*t12;
      f = (t2*r-6.0/5.0*t2+t1*r/2-2.0/23.0*t1+3.0/506.0*r-1.0/8855.0)*(t7*t+
30.0/11.0*t7*t9+30.0/11.0*t6*t*t12+40.0/33.0*t6*t12*t9+5.0/22.0*t*t16+t16*t9/77
);
   /* p=14 5 1 4 */
   } else if( i==5 && j==1 && k==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t8 = t*t;
      t9 = t8*t8;
      t11 = s+r-1.0;
      t13 = t11*t11;
      t17 = t13*t13;
      f = (s+2.0/13.0*r-2.0/13.0)*(t2*r-6.0/5.0*t2+t1*r/2-2.0/23.0*t1+3.0/
506.0*r-1.0/8855.0)*(t9+20.0/9.0*t8*t*t11+5.0/3.0*t8*t13+10.0/21.0*t*t13*t11+
5.0/126.0*t17);
   /* p=14 5 2 3 */
   } else if( i==5 && j==2 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = s*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t12 = t*t;
      t14 = s+r-1.0;
      t16 = t14*t14;
      f = (t2*r-6.0/5.0*t2+t1*r/2-2.0/23.0*t1+3.0/506.0*r-1.0/8855.0)*(t6+6.0
/13.0*s*t7+t9/26)*(t12*t+12.0/7.0*t12*t14+6.0/7.0*t*t16+4.0/35.0*t16*t14);
   /* p=14 5 3 2 */
   } else if( i==5 && j==3 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = s*s;
      t8 = r-1.0;
      t10 = t8*t8;
      t15 = t*t;
      t16 = s+r-1.0;
      t18 = t16*t16;
      f = (t2*r-6.0/5.0*t2+t1*r/2-2.0/23.0*t1+3.0/506.0*r-1.0/8855.0)*(t6*s+
12.0/13.0*t6*t8+3.0/13.0*s*t10+2.0/143.0*t10*t8)*(t15+6.0/5.0*t*t16+3.0/10.0*
t18);
   /* p=14 5 4 1 */
   } else if( i==5 && j==4 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = s*s;
      t7 = t6*t6;
      t9 = r-1.0;
      t11 = t9*t9;
      t15 = t11*t11;
      f = (t2*r-6.0/5.0*t2+t1*r/2-2.0/23.0*t1+3.0/506.0*r-1.0/8855.0)*(t7+
20.0/13.0*t6*s*t9+10.0/13.0*t6*t11+20.0/143.0*s*t11*t9+t15/143)*(t+2.0/3.0*s+
2.0/3.0*r-2.0/3.0);
   /* p=14 5 5 0 */
   } else if( i==5 && j==5 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = s*s;
      t7 = t6*t6;
      t9 = r-1.0;
      t12 = t9*t9;
      t16 = t12*t12;
      f = (t2*r-6.0/5.0*t2+t1*r/2-2.0/23.0*t1+3.0/506.0*r-1.0/8855.0)*(s*t7+
30.0/13.0*t7*t9+25.0/13.0*t6*s*t12+100.0/143.0*t6*t12*t9+15.0/143.0*s*t16+2.0/
429.0*t16*t9);
   /* p=14 6 0 4 */
   } else if( i==6 && j==0 && k==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t7 = t*t;
      t8 = t7*t7;
      t10 = s+r-1.0;
      t12 = t10*t10;
      t16 = t12*t12;
      f = (t2*t1-42.0/25.0*t2*r+21.0/20.0*t2-7.0/23.0*t1*r+21.0/506.0*t1-3.0/
1265.0*r+1.0/25300.0)*(t8+20.0/9.0*t7*t*t10+5.0/3.0*t7*t12+10.0/21.0*t*t12*t10+
5.0/126.0*t16);
   /* p=14 6 1 3 */
   } else if( i==6 && j==1 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t9 = t*t;
      t11 = s+r-1.0;
      t13 = t11*t11;
      f = (t2*t1-42.0/25.0*t2*r+21.0/20.0*t2-7.0/23.0*t1*r+21.0/506.0*t1-3.0/
1265.0*r+1.0/25300.0)*(s+2.0/11.0*r-2.0/11.0)*(t9*t+12.0/7.0*t11*t9+6.0/7.0*t*
t13+4.0/35.0*t13*t11);
   /* p=14 6 2 2 */
   } else if( i==6 && j==2 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t7 = s*s;
      t8 = r-1.0;
      t10 = t8*t8;
      t13 = t*t;
      t14 = s+r-1.0;
      t16 = t14*t14;
      f = (t2*t1-42.0/25.0*t2*r+21.0/20.0*t2-7.0/23.0*t1*r+21.0/506.0*t1-3.0/
1265.0*r+1.0/25300.0)*(t7+6.0/11.0*s*t8+3.0/55.0*t10)*(t13+6.0/5.0*t*t14+3.0/
10.0*t16);
   /* p=14 6 3 1 */
   } else if( i==6 && j==3 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t7 = s*s;
      t9 = r-1.0;
      t11 = t9*t9;
      f = (t2*t1-42.0/25.0*t2*r+21.0/20.0*t2-7.0/23.0*t1*r+21.0/506.0*t1-3.0/
1265.0*r+1.0/25300.0)*(t7*s+12.0/11.0*t7*t9+18.0/55.0*s*t11+4.0/165.0*t11*t9)*(
t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=14 6 4 0 */
   } else if( i==6 && j==4 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t7 = s*s;
      t8 = t7*t7;
      t10 = r-1.0;
      t12 = t10*t10;
      t16 = t12*t12;
      f = (t2*t1-42.0/25.0*t2*r+21.0/20.0*t2-7.0/23.0*t1*r+21.0/506.0*t1-3.0/
1265.0*r+1.0/25300.0)*(t8+20.0/11.0*t7*s*t10+12.0/11.0*t7*t12+8.0/33.0*s*t12*
t10+t16/66);
   /* p=14 7 0 3 */
   } else if( i==7 && j==0 && k==3 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t8 = t*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      f = (t3*t2-56.0/25.0*t3*t1+49.0/25.0*t3*r-98.0/115.0*t3+49.0/253.0*t2
-28.0/1265.0*t1+7.0/6325.0*r-2.0/120175.0)*(t8*t+12.0/7.0*t8*t10+6.0/7.0*t*t12+
4.0/35.0*t12*t10);
   /* p=14 7 1 2 */
   } else if( i==7 && j==1 && k==2 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t10 = t*t;
      t11 = s+r-1.0;
      t13 = t11*t11;
      f = (t3*t2-56.0/25.0*t3*t1+49.0/25.0*t3*r-98.0/115.0*t3+49.0/253.0*t2
-28.0/1265.0*t1+7.0/6325.0*r-2.0/120175.0)*(s+2.0/9.0*r-2.0/9.0)*(t10+6.0/5.0*t
*t11+3.0/10.0*t13);
   /* p=14 7 2 1 */
   } else if( i==7 && j==2 && k==1 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t8 = s*s;
      t9 = r-1.0;
      t11 = t9*t9;
      f = (t3*t2-56.0/25.0*t3*t1+49.0/25.0*t3*r-98.0/115.0*t3+49.0/253.0*t2
-28.0/1265.0*t1+7.0/6325.0*r-2.0/120175.0)*(t8+2.0/3.0*s*t9+t11/12)*(t+2.0/3.0*
s+2.0/3.0*r-2.0/3.0);
   /* p=14 7 3 0 */
   } else if( i==7 && j==3 && k==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t8 = s*s;
      t10 = r-1.0;
      t12 = t10*t10;
      f = (t3*t2-56.0/25.0*t3*t1+49.0/25.0*t3*r-98.0/115.0*t3+49.0/253.0*t2
-28.0/1265.0*t1+7.0/6325.0*r-2.0/120175.0)*(s*t8+4.0/3.0*t8*t10+s*t12/2+t12*t10
/21);
   /* p=14 8 0 2 */
   } else if( i==8 && j==0 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*r;
      t9 = t*t;
      t10 = s+r-1.0;
      t12 = t10*t10;
      f = (t3-72.0/25.0*t2*t4+84.0/25.0*t2*t1-1176.0/575.0*t2*r+882.0/1265.0*
t2-168.0/1265.0*t4+84.0/6325.0*t1-72.0/120175.0*r+1.0/120175.0)*(t9+6.0/5.0*t*
t10+3.0/10.0*t12);
   /* p=14 8 1 1 */
   } else if( i==8 && j==1 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*r;
      f = (t3-72.0/25.0*t2*t4+84.0/25.0*t2*t1-1176.0/575.0*t2*r+882.0/1265.0*
t2-168.0/1265.0*t4+84.0/6325.0*t1-72.0/120175.0*r+1.0/120175.0)*(s+2.0/7.0*r
-2.0/7.0)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=14 8 2 0 */
   } else if( i==8 && j==2 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*r;
      t9 = s*s;
      t10 = r-1.0;
      t12 = t10*t10;
      f = (t3-72.0/25.0*t2*t4+84.0/25.0*t2*t1-1176.0/575.0*t2*r+882.0/1265.0*
t2-168.0/1265.0*t4+84.0/6325.0*t1-72.0/120175.0*r+1.0/120175.0)*(t9+6.0/7.0*s*
t10+t12/7);
   /* p=14 9 0 1 */
   } else if( i==9 && j==0 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*r;
      f = (t3*r-18.0/5.0*t3+27.0/5.0*t2*t5-504.0/115.0*t2*t1+2646.0/1265.0*t2
*r-756.0/1265.0*t2+126.0/1265.0*t5-216.0/24035.0*t1+9.0/24035.0*r-2.0/408595.0)
*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=14 9 1 0 */
   } else if( i==9 && j==1 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*r;
      f = (t3*r-18.0/5.0*t3+27.0/5.0*t2*t5-504.0/115.0*t2*t1+2646.0/1265.0*t2
*r-756.0/1265.0*t2+126.0/1265.0*t5-216.0/24035.0*t1+9.0/24035.0*r-2.0/408595.0)
*(s+2.0/5.0*r-2.0/5.0);
   /* p=14 10 0 0 */
   } else if( i==10 && j==0 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t6 = t1*r;
      f = t3*t1-22.0/5.0*t3*r+33.0/4.0*t3-198.0/23.0*t2*t6+126.0/23.0*t2*t1
-252.0/115.0*t2*r+63.0/115.0*t2-36.0/437.0*t6+3.0/437.0*t1-2.0/7429.0*r+1.0/
297160.0;
   /* p=15 0 0 11 */
   } else if( i==0 && j==0 && k==11 ) {
      t1 = t*t;
      t2 = t1*t;
      t3 = t1*t1;
      t4 = t3*t3;
      t7 = s+r-1.0;
      t10 = t7*t7;
      t12 = t10*t7;
      t15 = t10*t10;
      t25 = t15*t15;
      f = t2*t4+132.0/23.0*t4*t1*t7+330.0/23.0*t4*t*t10+3300.0/161.0*t4*t12+
2970.0/161.0*t3*t2*t15+4752.0/437.0*t3*t1*t15*t7+1848.0/437.0*t3*t*t15*t10+
7920.0/7429.0*t3*t15*t12+2475.0/14858.0*t2*t25+110.0/7429.0*t1*t25*t7+33.0/
52003.0*t*t25*t10+6.0/676039.0*t25*t12;
   /* p=15 0 1 10 */
   } else if( i==0 && j==1 && k==10 ) {
      t2 = t*t;
      t3 = t2*t2;
      t4 = t3*t3;
      t7 = s+r-1.0;
      t9 = t7*t7;
      t11 = t2*t;
      t13 = t9*t7;
      t16 = t9*t9;
      t25 = t16*t16;
      t30 = t2*t4+110.0/21.0*t4*t*t7+165.0/14.0*t4*t9+1980.0/133.0*t3*t11*t13+
220.0/19.0*t3*t2*t16+1848.0/323.0*t3*t*t16*t7+1155.0/646.0*t3*t16*t9+110.0/
323.0*t11*t16*t13+165.0/4522.0*t2*t25+55.0/29393.0*t*t25*t7+11.0/352716.0*t25*
t9;
      f = (s+2.0/25.0*r-2.0/25.0)*t30;
   /* p=15 0 2 9 */
   } else if( i==0 && j==2 && k==9 ) {
      t1 = s*s;
      t2 = r-1.0;
      t4 = t2*t2;
      t6 = t*t;
      t7 = t6*t6;
      t8 = t7*t7;
      t10 = s+r-1.0;
      t12 = t6*t;
      t14 = t10*t10;
      t17 = t14*t10;
      t20 = t14*t14;
      t28 = t20*t20;
      f = (t1+6.0/25.0*s*t2+t4/100)*(t8*t+90.0/19.0*t8*t10+180.0/19.0*t7*t12*
t14+3360.0/323.0*t7*t6*t17+2205.0/323.0*t7*t*t20+882.0/323.0*t7*t20*t10+210.0/
323.0*t12*t20*t14+360.0/4199.0*t6*t20*t17+45.0/8398.0*t*t28+5.0/46189.0*t28*t10
);
   /* p=15 0 3 8 */
   } else if( i==0 && j==3 && k==8 ) {
      t1 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t9 = t*t;
      t10 = t9*t9;
      t11 = t10*t10;
      t12 = t9*t;
      t14 = s+r-1.0;
      t17 = t14*t14;
      t20 = t17*t14;
      t22 = t17*t17;
      t30 = t22*t22;
      f = (t1*s+12.0/25.0*t3*t1+3.0/50.0*s*t5+t5*t3/575)*(t11+72.0/17.0*t10*
t12*t14+126.0/17.0*t10*t9*t17+588.0/85.0*t10*t*t20+63.0/17.0*t10*t22+252.0/
221.0*t12*t22*t14+42.0/221.0*t9*t22*t17+36.0/2431.0*t*t22*t20+9.0/24310.0*t30);
   /* p=15 0 4 7 */
   } else if( i==0 && j==4 && k==7 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t6 = t4*t4;
      t10 = t6*t6;
      t12 = t*t;
      t13 = t12*t;
      t14 = t12*t12;
      t17 = s+r-1.0;
      t20 = t17*t17;
      t22 = t20*t17;
      t24 = t20*t20;
      f = (t2+4.0/5.0*t1*s*t4+t1*t6/5+2.0/115.0*s*t6*t4+t10/2530)*(t13*t14+
56.0/15.0*t14*t12*t17+28.0/5.0*t14*t*t20+56.0/13.0*t22*t14+70.0/39.0*t13*t24+
56.0/143.0*t12*t24*t17+28.0/715.0*t*t24*t20+8.0/6435.0*t24*t22);
   /* p=15 0 5 6 */
   } else if( i==0 && j==5 && k==6 ) {
      t1 = s*s;
      t2 = t1*t1;
      t4 = r-1.0;
      t7 = t4*t4;
      t11 = t7*t7;
      t15 = t*t;
      t16 = t15*t15;
      t19 = s+r-1.0;
      t21 = t19*t19;
      t26 = t21*t21;
      f = (s*t2+6.0/5.0*t2*t4+t7*t1*s/2+2.0/23.0*t1*t7*t4+3.0/506.0*s*t11+t11
*t4/8855)*(t16*t15+42.0/13.0*t16*t*t19+105.0/26.0*t16*t21+350.0/143.0*t15*t*t21
*t19+105.0/143.0*t15*t26+14.0/143.0*t*t26*t19+7.0/1716.0*t26*t21);
   /* p=15 0 6 5 */
   } else if( i==0 && j==6 && k==5 ) {
      t1 = s*s;
      t2 = t1*t1;
      t5 = r-1.0;
      t7 = t5*t5;
      t12 = t7*t7;
      t18 = t*t;
      t19 = t18*t18;
      t21 = s+r-1.0;
      t24 = t21*t21;
      t28 = t24*t24;
      f = (t2*t1+42.0/25.0*t2*s*t5+21.0/20.0*t2*t7+7.0/23.0*t7*t5*t1*s+21.0/
506.0*t1*t12+3.0/1265.0*s*t12*t5+t7*t12/25300)*(t19*t+30.0/11.0*t21*t19+30.0/
11.0*t18*t*t24+40.0/33.0*t18*t24*t21+5.0/22.0*t*t28+t28*t21/77);
   /* p=15 0 7 4 */
   } else if( i==0 && j==7 && k==4 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t6 = r-1.0;
      t9 = t6*t6;
      t11 = t9*t6;
      t13 = t9*t9;
      t21 = t*t;
      t22 = t21*t21;
      t24 = s+r-1.0;
      t26 = t24*t24;
      t30 = t26*t26;
      f = (t3*t2+56.0/25.0*t3*t1*t6+49.0/25.0*t3*s*t9+98.0/115.0*t3*t11+49.0/
253.0*t2*t13+28.0/1265.0*t1*t13*t6+7.0/6325.0*s*t13*t9+2.0/120175.0*t13*t11)*(
t22+20.0/9.0*t21*t*t24+5.0/3.0*t21*t26+10.0/21.0*t*t26*t24+5.0/126.0*t30);
   /* p=15 0 8 3 */
   } else if( i==0 && j==8 && k==3 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*s;
      t6 = r-1.0;
      t9 = t6*t6;
      t12 = t9*t6;
      t14 = t9*t9;
      t22 = t14*t14;
      t24 = t*t;
      t26 = s+r-1.0;
      t28 = t26*t26;
      f = (t3+72.0/25.0*t2*t4*t6+84.0/25.0*t2*t1*t9+1176.0/575.0*t2*s*t12+
882.0/1265.0*t2*t14+168.0/1265.0*t4*t14*t6+84.0/6325.0*t1*t14*t9+72.0/120175.0*
s*t14*t12+t22/120175)*(t24*t+12.0/7.0*t26*t24+6.0/7.0*t*t28+4.0/35.0*t28*t26);
   /* p=15 0 9 2 */
   } else if( i==0 && j==9 && k==2 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = r-1.0;
      t7 = t1*s;
      t9 = t5*t5;
      t12 = t9*t5;
      t15 = t9*t9;
      t23 = t15*t15;
      t27 = t*t;
      t28 = s+r-1.0;
      t30 = t28*t28;
      f = (t3*s+18.0/5.0*t3*t5+27.0/5.0*t2*t7*t9+504.0/115.0*t2*t1*t12+2646.0
/1265.0*t2*s*t15+756.0/1265.0*t2*t15*t5+126.0/1265.0*t7*t15*t9+216.0/24035.0*t1
*t15*t12+9.0/24035.0*s*t23+2.0/408595.0*t23*t5)*(t27+6.0/5.0*t*t28+3.0/10.0*t30
);
   /* p=15 0 10 1 */
   } else if( i==0 && j==10 && k==1 ) {
      t1 = s*s;
      t2 = t1*t1;
      t3 = t2*t2;
      t6 = r-1.0;
      t8 = t6*t6;
      t10 = t1*s;
      t12 = t8*t6;
      t15 = t8*t8;
      t24 = t15*t15;
      t29 = t3*t1+22.0/5.0*t3*s*t6+33.0/4.0*t3*t8+198.0/23.0*t2*t10*t12+126.0/
23.0*t2*t1*t15+252.0/115.0*t2*s*t15*t6+63.0/115.0*t2*t15*t8+36.0/437.0*t10*t15*
t12+3.0/437.0*t1*t24+2.0/7429.0*s*t24*t6+t24*t8/297160;
      f = t29*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=15 0 11 0 */
   } else if( i==0 && j==11 && k==0 ) {
      t1 = s*s;
      t2 = t1*s;
      t3 = t1*t1;
      t4 = t3*t3;
      t7 = r-1.0;
      t10 = t7*t7;
      t12 = t10*t7;
      t15 = t10*t10;
      t25 = t15*t15;
      f = t2*t4+132.0/25.0*t4*t1*t7+121.0/10.0*t4*s*t10+363.0/23.0*t4*t12+
297.0/23.0*t3*t2*t15+792.0/115.0*t3*t1*t15*t7+1386.0/575.0*t3*s*t15*t10+1188.0/
2185.0*t3*t15*t12+33.0/437.0*t2*t25+44.0/7429.0*t1*t25*t7+33.0/148580.0*s*t25*
t10+t25*t12/371450;
   /* p=15 1 0 10 */
   } else if( i==1 && j==0 && k==10 ) {
      t2 = t*t;
      t3 = t2*t2;
      t4 = t3*t3;
      t7 = s+r-1.0;
      t9 = t7*t7;
      t11 = t2*t;
      t13 = t9*t7;
      t16 = t9*t9;
      t25 = t16*t16;
      t30 = t2*t4+110.0/21.0*t4*t*t7+165.0/14.0*t4*t9+1980.0/133.0*t3*t11*t13+
220.0/19.0*t3*t2*t16+1848.0/323.0*t3*t*t16*t7+1155.0/646.0*t3*t16*t9+110.0/
323.0*t11*t16*t13+165.0/4522.0*t2*t25+55.0/29393.0*t*t25*t7+11.0/352716.0*t25*
t9;
      f = (r-2.0/27.0)*t30;
   /* p=15 1 1 9 */
   } else if( i==1 && j==1 && k==9 ) {
      t4 = t*t;
      t5 = t4*t4;
      t6 = t5*t5;
      t8 = s+r-1.0;
      t10 = t4*t;
      t12 = t8*t8;
      t15 = t12*t8;
      t18 = t12*t12;
      t26 = t18*t18;
      f = (s+2.0/23.0*r-2.0/23.0)*(r-2.0/27.0)*(t6*t+90.0/19.0*t6*t8+180.0/
19.0*t5*t10*t12+3360.0/323.0*t5*t4*t15+2205.0/323.0*t5*t*t18+882.0/323.0*t5*t18
*t8+210.0/323.0*t10*t18*t12+360.0/4199.0*t4*t18*t15+45.0/8398.0*t*t26+5.0/
46189.0*t26*t8);
   /* p=15 1 2 8 */
   } else if( i==1 && j==2 && k==8 ) {
      t2 = s*s;
      t3 = r-1.0;
      t5 = t3*t3;
      t8 = t*t;
      t9 = t8*t8;
      t10 = t9*t9;
      t11 = t8*t;
      t13 = s+r-1.0;
      t16 = t13*t13;
      t19 = t16*t13;
      t21 = t16*t16;
      t29 = t21*t21;
      f = (r-2.0/27.0)*(t2+6.0/23.0*s*t3+3.0/253.0*t5)*(t10+72.0/17.0*t9*t11*
t13+126.0/17.0*t9*t8*t16+588.0/85.0*t9*t*t19+63.0/17.0*t9*t21+252.0/221.0*t11*
t21*t13+42.0/221.0*t8*t21*t16+36.0/2431.0*t*t21*t19+9.0/24310.0*t29);
   /* p=15 1 3 7 */
   } else if( i==1 && j==3 && k==7 ) {
      t2 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t11 = t*t;
      t12 = t11*t;
      t13 = t11*t11;
      t16 = s+r-1.0;
      t19 = t16*t16;
      t21 = t19*t16;
      t23 = t19*t19;
      f = (r-2.0/27.0)*(t2*s+12.0/23.0*t2*t4+18.0/253.0*s*t6+4.0/1771.0*t6*t4
)*(t12*t13+56.0/15.0*t11*t16*t13+28.0/5.0*t13*t*t19+56.0/13.0*t21*t13+70.0/39.0
*t12*t23+56.0/143.0*t11*t23*t16+28.0/715.0*t*t23*t19+8.0/6435.0*t23*t21);
   /* p=15 1 4 6 */
   } else if( i==1 && j==4 && k==6 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = r-1.0;
      t7 = t5*t5;
      t11 = t7*t7;
      t14 = t*t;
      t15 = t14*t14;
      t18 = s+r-1.0;
      t20 = t18*t18;
      t25 = t20*t20;
      f = (r-2.0/27.0)*(t3+20.0/23.0*t5*t2*s+60.0/253.0*t2*t7+40.0/1771.0*s*
t7*t5+t11/1771)*(t14*t15+42.0/13.0*t15*t*t18+105.0/26.0*t15*t20+350.0/143.0*t14
*t*t20*t18+105.0/143.0*t14*t25+14.0/143.0*t*t25*t18+7.0/1716.0*t25*t20);
   /* p=15 1 5 5 */
   } else if( i==1 && j==5 && k==5 ) {
      t2 = s*s;
      t3 = t2*t2;
      t5 = r-1.0;
      t8 = t5*t5;
      t12 = t8*t8;
      t17 = t*t;
      t18 = t17*t17;
      t20 = s+r-1.0;
      t23 = t20*t20;
      t27 = t23*t23;
      f = (r-2.0/27.0)*(s*t3+30.0/23.0*t3*t5+150.0/253.0*t2*s*t8+200.0/1771.0
*t2*t8*t5+15.0/1771.0*s*t12+6.0/33649.0*t12*t5)*(t18*t+30.0/11.0*t20*t18+30.0/
11.0*t17*t*t23+40.0/33.0*t17*t23*t20+5.0/22.0*t*t27+t27*t20/77);
   /* p=15 1 6 4 */
   } else if( i==1 && j==6 && k==4 ) {
      t2 = s*s;
      t3 = t2*t2;
      t6 = r-1.0;
      t8 = t6*t6;
      t13 = t8*t8;
      t20 = t*t;
      t21 = t20*t20;
      t23 = s+r-1.0;
      t25 = t23*t23;
      t29 = t25*t25;
      f = (r-2.0/27.0)*(t3*t2+42.0/23.0*t3*s*t6+315.0/253.0*t3*t8+100.0/253.0
*t2*s*t8*t6+15.0/253.0*t2*t13+18.0/4807.0*s*t13*t6+t13*t8/14421)*(t21+20.0/9.0*
t20*t*t23+5.0/3.0*t20*t25+10.0/21.0*t*t25*t23+5.0/126.0*t29);
   /* p=15 1 7 3 */
   } else if( i==1 && j==7 && k==3 ) {
      t2 = s*s;
      t3 = t2*s;
      t4 = t2*t2;
      t7 = r-1.0;
      t10 = t7*t7;
      t12 = t10*t7;
      t14 = t10*t10;
      t23 = t*t;
      t25 = s+r-1.0;
      t27 = t25*t25;
      f = (r-2.0/27.0)*(t4*t3+56.0/23.0*t4*t2*t7+588.0/253.0*t4*s*t10+280.0/
253.0*t4*t12+70.0/253.0*t3*t14+168.0/4807.0*t2*t14*t7+28.0/14421.0*s*t14*t10+
8.0/245157.0*t14*t12)*(t23*t+12.0/7.0*t25*t23+6.0/7.0*t*t27+4.0/35.0*t27*t25);
   /* p=15 1 8 2 */
   } else if( i==1 && j==8 && k==2 ) {
      t2 = s*s;
      t3 = t2*t2;
      t4 = t3*t3;
      t5 = t2*s;
      t7 = r-1.0;
      t10 = t7*t7;
      t13 = t10*t7;
      t15 = t10*t10;
      t23 = t15*t15;
      t26 = t*t;
      t27 = s+r-1.0;
      t29 = t27*t27;
      f = (r-2.0/27.0)*(t4+72.0/23.0*t3*t5*t7+1008.0/253.0*t3*t2*t10+672.0/
253.0*t3*s*t13+252.0/253.0*t3*t15+1008.0/4807.0*t5*t15*t7+112.0/4807.0*t2*t15*
t10+96.0/81719.0*s*t15*t13+3.0/163438.0*t23)*(t26+6.0/5.0*t*t27+3.0/10.0*t29);
   /* p=15 1 9 1 */
   } else if( i==1 && j==9 && k==1 ) {
      t2 = s*s;
      t3 = t2*t2;
      t4 = t3*t3;
      t6 = r-1.0;
      t8 = t2*s;
      t10 = t6*t6;
      t13 = t10*t6;
      t16 = t10*t10;
      t24 = t16*t16;
      f = (r-2.0/27.0)*(t4*s+90.0/23.0*t4*t6+1620.0/253.0*t3*t8*t10+1440.0/
253.0*t3*t2*t13+756.0/253.0*t3*s*t16+4536.0/4807.0*t3*t16*t6+840.0/4807.0*t8*
t16*t10+1440.0/81719.0*t2*t16*t13+135.0/163438.0*s*t24+t24*t6/81719)*(t+2.0/3.0
*s+2.0/3.0*r-2.0/3.0);
   /* p=15 1 10 0 */
   } else if( i==1 && j==10 && k==0 ) {
      t2 = s*s;
      t3 = t2*t2;
      t4 = t3*t3;
      t7 = r-1.0;
      t9 = t7*t7;
      t11 = t2*s;
      t13 = t9*t7;
      t16 = t9*t9;
      t25 = t16*t16;
      t30 = t4*t2+110.0/23.0*t4*s*t7+225.0/23.0*t4*t9+1800.0/161.0*t3*t11*t13+
180.0/23.0*t3*t2*t16+1512.0/437.0*t3*s*t16*t7+420.0/437.0*t3*t16*t9+1200.0/
7429.0*t11*t16*t13+225.0/14858.0*t2*t25+5.0/7429.0*s*t25*t7+t25*t9/104006;
      f = (r-2.0/27.0)*t30;
   /* p=15 2 0 9 */
   } else if( i==2 && j==0 && k==9 ) {
      t1 = r*r;
      t3 = t*t;
      t4 = t3*t3;
      t5 = t4*t4;
      t7 = s+r-1.0;
      t9 = t3*t;
      t11 = t7*t7;
      t14 = t11*t7;
      t17 = t11*t11;
      t25 = t17*t17;
      f = (t1-2.0/9.0*r+1.0/117.0)*(t5*t+90.0/19.0*t5*t7+180.0/19.0*t4*t9*t11
+3360.0/323.0*t4*t3*t14+2205.0/323.0*t4*t*t17+882.0/323.0*t4*t17*t7+210.0/323.0
*t9*t17*t11+360.0/4199.0*t3*t17*t14+45.0/8398.0*t*t25+5.0/46189.0*t25*t7);
   /* p=15 2 1 8 */
   } else if( i==2 && j==1 && k==8 ) {
      t1 = r*r;
      t5 = t*t;
      t6 = t5*t5;
      t7 = t6*t6;
      t8 = t5*t;
      t10 = s+r-1.0;
      t13 = t10*t10;
      t16 = t13*t10;
      t18 = t13*t13;
      t26 = t18*t18;
      f = (t1-2.0/9.0*r+1.0/117.0)*(s+2.0/21.0*r-2.0/21.0)*(t7+72.0/17.0*t6*
t8*t10+126.0/17.0*t6*t5*t13+588.0/85.0*t6*t*t16+63.0/17.0*t6*t18+252.0/221.0*t8
*t18*t10+42.0/221.0*t5*t18*t13+36.0/2431.0*t*t18*t16+9.0/24310.0*t26);
   /* p=15 2 2 7 */
   } else if( i==2 && j==2 && k==7 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = r-1.0;
      t6 = t4*t4;
      t9 = t*t;
      t10 = t9*t;
      t11 = t9*t9;
      t14 = s+r-1.0;
      t17 = t14*t14;
      t19 = t17*t14;
      t21 = t17*t17;
      f = (t1-2.0/9.0*r+1.0/117.0)*(t3+2.0/7.0*s*t4+t6/70)*(t11*t10+56.0/15.0
*t11*t9*t14+28.0/5.0*t11*t*t17+56.0/13.0*t11*t19+70.0/39.0*t10*t21+56.0/143.0*
t9*t21*t14+28.0/715.0*t*t21*t17+8.0/6435.0*t21*t19);
   /* p=15 2 3 6 */
   } else if( i==2 && j==3 && k==6 ) {
      t1 = r*r;
      t3 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t12 = t*t;
      t13 = t12*t12;
      t16 = s+r-1.0;
      t18 = t16*t16;
      t23 = t18*t18;
      f = (t1-2.0/9.0*r+1.0/117.0)*(t3*s+4.0/7.0*t3*t5+3.0/35.0*s*t7+2.0/
665.0*t5*t7)*(t12*t13+42.0/13.0*t13*t*t16+105.0/26.0*t18*t13+350.0/143.0*t12*t*
t18*t16+105.0/143.0*t12*t23+14.0/143.0*t*t23*t16+7.0/1716.0*t23*t18);
   /* p=15 2 4 5 */
   } else if( i==2 && j==4 && k==5 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t6 = r-1.0;
      t8 = t6*t6;
      t12 = t8*t8;
      t15 = t*t;
      t16 = t15*t15;
      t18 = s+r-1.0;
      t21 = t18*t18;
      t25 = t21*t21;
      f = (t1-2.0/9.0*r+1.0/117.0)*(t4+20.0/21.0*t6*t3*s+2.0/7.0*t3*t8+4.0/
133.0*s*t6*t8+t12/1197)*(t16*t+30.0/11.0*t18*t16+30.0/11.0*t15*t*t21+40.0/33.0*
t15*t21*t18+5.0/22.0*t*t25+t25*t18/77);
   /* p=15 2 5 4 */
   } else if( i==2 && j==5 && k==4 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t6 = r-1.0;
      t9 = t6*t6;
      t13 = t9*t9;
      t18 = t*t;
      t19 = t18*t18;
      t21 = s+r-1.0;
      t23 = t21*t21;
      t27 = t23*t23;
      f = (t1-2.0/9.0*r+1.0/117.0)*(s*t4+10.0/7.0*t4*t6+5.0/7.0*t3*s*t9+20.0/
133.0*t3*t9*t6+5.0/399.0*s*t13+2.0/6783.0*t13*t6)*(t19+20.0/9.0*t18*t*t21+5.0/
3.0*t23*t18+10.0/21.0*t*t23*t21+5.0/126.0*t27);
   /* p=15 2 6 3 */
   } else if( i==2 && j==6 && k==3 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t7 = r-1.0;
      t9 = t7*t7;
      t14 = t9*t9;
      t21 = t*t;
      t23 = s+r-1.0;
      t25 = t23*t23;
      f = (t1-2.0/9.0*r+1.0/117.0)*(t4*t3+2.0*t4*s*t7+3.0/2.0*t4*t9+10.0/19.0
*t3*s*t9*t7+5.0/57.0*t3*t14+2.0/323.0*s*t14*t7+t14*t9/7752)*(t21*t+12.0/7.0*t23
*t21+6.0/7.0*t*t25+4.0/35.0*t25*t23);
   /* p=15 2 7 2 */
   } else if( i==2 && j==7 && k==2 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*s;
      t5 = t3*t3;
      t8 = r-1.0;
      t11 = t8*t8;
      t13 = t11*t8;
      t15 = t11*t11;
      t24 = t*t;
      t25 = s+r-1.0;
      t27 = t25*t25;
      f = (t1-2.0/9.0*r+1.0/117.0)*(t5*t4+8.0/3.0*t5*t3*t8+14.0/5.0*t5*s*t11+
28.0/19.0*t5*t13+70.0/171.0*t4*t15+56.0/969.0*t3*t15*t8+7.0/1938.0*s*t15*t11+
t15*t13/14535)*(t24+6.0/5.0*t*t25+3.0/10.0*t27);
   /* p=15 2 8 1 */
   } else if( i==2 && j==8 && k==1 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t5 = t4*t4;
      t6 = t3*s;
      t8 = r-1.0;
      t11 = t8*t8;
      t14 = t11*t8;
      t16 = t11*t11;
      t24 = t16*t16;
      f = (t1-2.0/9.0*r+1.0/117.0)*(t5+24.0/7.0*t4*t6*t8+24.0/5.0*t4*t3*t11+
336.0/95.0*t4*s*t14+28.0/19.0*t4*t16+112.0/323.0*t6*t16*t8+14.0/323.0*t3*t16*
t11+4.0/1615.0*s*t16*t14+t24/22610)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=15 2 9 0 */
   } else if( i==2 && j==9 && k==0 ) {
      t1 = r*r;
      t3 = s*s;
      t4 = t3*t3;
      t5 = t4*t4;
      t7 = r-1.0;
      t9 = t3*s;
      t11 = t7*t7;
      t14 = t11*t7;
      t17 = t11*t11;
      t25 = t17*t17;
      f = (t1-2.0/9.0*r+1.0/117.0)*(t5*s+30.0/7.0*t5*t7+54.0/7.0*t4*t9*t11+
144.0/19.0*t4*t3*t14+84.0/19.0*t4*s*t17+504.0/323.0*t4*t17*t7+105.0/323.0*t9*
t17*t11+12.0/323.0*t3*t17*t14+9.0/4522.0*s*t25+t25*t7/29393);
   /* p=15 3 0 8 */
   } else if( i==3 && j==0 && k==8 ) {
      t1 = r*r;
      t4 = t*t;
      t5 = t4*t4;
      t6 = t5*t5;
      t7 = t4*t;
      t9 = s+r-1.0;
      t12 = t9*t9;
      t15 = t12*t9;
      t17 = t12*t12;
      t25 = t17*t17;
      f = (t1*r-4.0/9.0*t1+2.0/39.0*r-4.0/2925.0)*(t6+72.0/17.0*t5*t7*t9+
126.0/17.0*t5*t4*t12+588.0/85.0*t5*t*t15+63.0/17.0*t5*t17+252.0/221.0*t7*t17*t9
+42.0/221.0*t4*t17*t12+36.0/2431.0*t*t17*t15+9.0/24310.0*t25);
   /* p=15 3 1 7 */
   } else if( i==3 && j==1 && k==7 ) {
      t1 = r*r;
      t6 = t*t;
      t7 = t6*t;
      t8 = t6*t6;
      t11 = s+r-1.0;
      t14 = t11*t11;
      t16 = t14*t11;
      t18 = t14*t14;
      f = (s+2.0/19.0*r-2.0/19.0)*(t1*r-4.0/9.0*t1+2.0/39.0*r-4.0/2925.0)*(t7
*t8+56.0/15.0*t8*t6*t11+28.0/5.0*t8*t*t14+56.0/13.0*t16*t8+70.0/39.0*t7*t18+
56.0/143.0*t6*t18*t11+28.0/715.0*t*t18*t14+8.0/6435.0*t18*t16);
   /* p=15 3 2 6 */
   } else if( i==3 && j==2 && k==6 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = r-1.0;
      t7 = t5*t5;
      t10 = t*t;
      t11 = t10*t10;
      t14 = s+r-1.0;
      t16 = t14*t14;
      t21 = t16*t16;
      f = (t1*r-4.0/9.0*t1+2.0/39.0*r-4.0/2925.0)*(t4+6.0/19.0*s*t5+t7/57)*(
t10*t11+42.0/13.0*t11*t*t14+105.0/26.0*t16*t11+350.0/143.0*t10*t*t16*t14+105.0/
143.0*t10*t21+14.0/143.0*t*t21*t14+7.0/1716.0*t21*t16);
   /* p=15 3 3 5 */
   } else if( i==3 && j==3 && k==5 ) {
      t1 = r*r;
      t4 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t13 = t*t;
      t14 = t13*t13;
      t16 = s+r-1.0;
      t19 = t16*t16;
      t23 = t19*t19;
      f = (t1*r-4.0/9.0*t1+2.0/39.0*r-4.0/2925.0)*(t4*s+12.0/19.0*t4*t6+2.0/
19.0*s*t8+4.0/969.0*t8*t6)*(t14*t+30.0/11.0*t16*t14+30.0/11.0*t13*t*t19+40.0/
33.0*t13*t19*t16+5.0/22.0*t*t23+t23*t16/77);
   /* p=15 3 4 4 */
   } else if( i==3 && j==4 && k==4 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = t4*t4;
      t7 = r-1.0;
      t9 = t7*t7;
      t13 = t9*t9;
      t16 = t*t;
      t17 = t16*t16;
      t19 = s+r-1.0;
      t21 = t19*t19;
      t25 = t21*t21;
      f = (t1*r-4.0/9.0*t1+2.0/39.0*r-4.0/2925.0)*(t5+20.0/19.0*t4*s*t7+20.0/
57.0*t4*t9+40.0/969.0*s*t9*t7+5.0/3876.0*t13)*(t17+20.0/9.0*t16*t*t19+5.0/3.0*
t21*t16+10.0/21.0*t*t21*t19+5.0/126.0*t25);
   /* p=15 3 5 3 */
   } else if( i==3 && j==5 && k==3 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = t4*t4;
      t7 = r-1.0;
      t10 = t7*t7;
      t14 = t10*t10;
      t19 = t*t;
      t21 = s+r-1.0;
      t23 = t21*t21;
      f = (t1*r-4.0/9.0*t1+2.0/39.0*r-4.0/2925.0)*(s*t5+30.0/19.0*t5*t7+50.0/
57.0*t4*s*t10+200.0/969.0*t4*t10*t7+25.0/1292.0*s*t14+t14*t7/1938)*(t19*t+12.0/
7.0*t21*t19+6.0/7.0*t*t23+4.0/35.0*t23*t21);
   /* p=15 3 6 2 */
   } else if( i==3 && j==6 && k==2 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = t4*t4;
      t8 = r-1.0;
      t10 = t8*t8;
      t15 = t10*t10;
      t22 = t*t;
      t23 = s+r-1.0;
      t25 = t23*t23;
      f = (t1*r-4.0/9.0*t1+2.0/39.0*r-4.0/2925.0)*(t5*t4+42.0/19.0*t5*s*t8+
35.0/19.0*t5*t10+700.0/969.0*t4*s*t10*t8+175.0/1292.0*t4*t15+7.0/646.0*s*t15*t8
+t15*t10/3876)*(t22+6.0/5.0*t*t23+3.0/10.0*t25);
   /* p=15 3 7 1 */
   } else if( i==3 && j==7 && k==1 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = t4*s;
      t6 = t4*t4;
      t9 = r-1.0;
      t12 = t9*t9;
      t14 = t12*t9;
      t16 = t12*t12;
      f = (t1*r-4.0/9.0*t1+2.0/39.0*r-4.0/2925.0)*(t6*t5+56.0/19.0*t4*t6*t9+
196.0/57.0*t6*s*t12+1960.0/969.0*t6*t14+1225.0/1938.0*t5*t16+98.0/969.0*t4*t16*
t9+7.0/969.0*s*t16*t12+2.0/12597.0*t16*t14)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=15 3 8 0 */
   } else if( i==3 && j==8 && k==0 ) {
      t1 = r*r;
      t4 = s*s;
      t5 = t4*t4;
      t6 = t5*t5;
      t7 = t4*s;
      t9 = r-1.0;
      t12 = t9*t9;
      t15 = t12*t9;
      t17 = t12*t12;
      t25 = t17*t17;
      f = (t1*r-4.0/9.0*t1+2.0/39.0*r-4.0/2925.0)*(t6+72.0/19.0*t5*t7*t9+
112.0/19.0*t5*t4*t12+1568.0/323.0*t5*s*t15+735.0/323.0*t5*t17+196.0/323.0*t7*
t17*t9+28.0/323.0*t4*t17*t12+24.0/4199.0*s*t17*t15+t25/8398);
   /* p=15 4 0 7 */
   } else if( i==4 && j==0 && k==7 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = t*t;
      t6 = t5*t;
      t7 = t5*t5;
      t10 = s+r-1.0;
      t13 = t10*t10;
      t15 = t13*t10;
      t17 = t13*t13;
      f = (t2-20.0/27.0*t1*r+20.0/117.0*t1-8.0/585.0*r+1.0/3510.0)*(t7*t6+
56.0/15.0*t5*t7*t10+28.0/5.0*t7*t*t13+56.0/13.0*t7*t15+70.0/39.0*t6*t17+56.0/
143.0*t5*t17*t10+28.0/715.0*t*t17*t13+8.0/6435.0*t17*t15);
   /* p=15 4 1 6 */
   } else if( i==4 && j==1 && k==6 ) {
      t1 = r*r;
      t2 = t1*t1;
      t7 = t*t;
      t8 = t7*t7;
      t11 = s+r-1.0;
      t13 = t11*t11;
      t18 = t13*t13;
      f = (s+2.0/17.0*r-2.0/17.0)*(t2-20.0/27.0*t1*r+20.0/117.0*t1-8.0/585.0*
r+1.0/3510.0)*(t8*t7+42.0/13.0*t8*t*t11+105.0/26.0*t8*t13+350.0/143.0*t7*t*t13*
t11+105.0/143.0*t7*t18+14.0/143.0*t*t18*t11+7.0/1716.0*t18*t13);
   /* p=15 4 2 5 */
   } else if( i==4 && j==2 && k==5 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t6 = r-1.0;
      t8 = t6*t6;
      t11 = t*t;
      t12 = t11*t11;
      t14 = s+r-1.0;
      t17 = t14*t14;
      t21 = t17*t17;
      f = (t2-20.0/27.0*t1*r+20.0/117.0*t1-8.0/585.0*r+1.0/3510.0)*(t5+6.0/
17.0*s*t6+3.0/136.0*t8)*(t12*t+30.0/11.0*t12*t14+30.0/11.0*t11*t*t17+40.0/33.0*
t11*t17*t14+5.0/22.0*t*t21+t21*t14/77);
   /* p=15 4 3 4 */
   } else if( i==4 && j==3 && k==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t14 = t*t;
      t15 = t14*t14;
      t17 = s+r-1.0;
      t19 = t17*t17;
      t23 = t19*t19;
      f = (t2-20.0/27.0*t1*r+20.0/117.0*t1-8.0/585.0*r+1.0/3510.0)*(t5*s+12.0
/17.0*t5*t7+9.0/68.0*s*t9+t9*t7/170)*(t15+20.0/9.0*t14*t*t17+5.0/3.0*t14*t19+
10.0/21.0*t*t19*t17+5.0/126.0*t23);
   /* p=15 4 4 3 */
   } else if( i==4 && j==4 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t6 = t5*t5;
      t8 = r-1.0;
      t10 = t8*t8;
      t14 = t10*t10;
      t17 = t*t;
      t19 = s+r-1.0;
      t21 = t19*t19;
      f = (t2-20.0/27.0*t1*r+20.0/117.0*t1-8.0/585.0*r+1.0/3510.0)*(t6+20.0/
17.0*t8*t5*s+15.0/34.0*t5*t10+s*t10*t8/17+t14/476)*(t17*t+12.0/7.0*t19*t17+6.0/
7.0*t*t21+4.0/35.0*t21*t19);
   /* p=15 4 5 2 */
   } else if( i==4 && j==5 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t6 = t5*t5;
      t8 = r-1.0;
      t11 = t8*t8;
      t15 = t11*t11;
      t20 = t*t;
      t21 = s+r-1.0;
      t23 = t21*t21;
      f = (t2-20.0/27.0*t1*r+20.0/117.0*t1-8.0/585.0*r+1.0/3510.0)*(s*t6+30.0
/17.0*t6*t8+75.0/68.0*t5*s*t11+5.0/17.0*t5*t11*t8+15.0/476.0*s*t15+3.0/3094.0*
t15*t8)*(t20+6.0/5.0*t*t21+3.0/10.0*t23);
   /* p=15 4 6 1 */
   } else if( i==4 && j==6 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t6 = t5*t5;
      t9 = r-1.0;
      t11 = t9*t9;
      t16 = t11*t11;
      f = (t2-20.0/27.0*t1*r+20.0/117.0*t1-8.0/585.0*r+1.0/3510.0)*(t6*t5+
42.0/17.0*t6*s*t9+315.0/136.0*t6*t11+35.0/34.0*t5*s*t11*t9+15.0/68.0*t5*t16+9.0
/442.0*s*t16*t9+t16*t11/1768)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=15 4 7 0 */
   } else if( i==4 && j==7 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t5 = s*s;
      t6 = t5*s;
      t7 = t5*t5;
      t10 = r-1.0;
      t13 = t10*t10;
      t15 = t13*t10;
      t17 = t13*t13;
      f = (t2-20.0/27.0*t1*r+20.0/117.0*t1-8.0/585.0*r+1.0/3510.0)*(t7*t6+
56.0/17.0*t7*t5*t10+147.0/34.0*t7*s*t13+49.0/17.0*t7*t15+35.0/34.0*t6*t17+42.0/
221.0*t5*t17*t10+7.0/442.0*s*t17*t13+t17*t15/2431);
   /* p=15 5 0 6 */
   } else if( i==5 && j==0 && k==6 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = t*t;
      t7 = t6*t6;
      t10 = s+r-1.0;
      t12 = t10*t10;
      t17 = t12*t12;
      f = (t2*r-10.0/9.0*t2+50.0/117.0*t1*r-8.0/117.0*t1+r/234-1.0/13455.0)*(
t7*t6+42.0/13.0*t7*t*t10+105.0/26.0*t7*t12+350.0/143.0*t6*t*t12*t10+105.0/143.0
*t6*t17+14.0/143.0*t*t17*t10+7.0/1716.0*t17*t12);
   /* p=15 5 1 5 */
   } else if( i==5 && j==1 && k==5 ) {
      t1 = r*r;
      t2 = t1*t1;
      t8 = t*t;
      t9 = t8*t8;
      t11 = s+r-1.0;
      t14 = t11*t11;
      t18 = t14*t14;
      f = (s+2.0/15.0*r-2.0/15.0)*(t2*r-10.0/9.0*t2+50.0/117.0*t1*r-8.0/117.0
*t1+r/234-1.0/13455.0)*(t9*t+30.0/11.0*t11*t9+30.0/11.0*t8*t*t14+40.0/33.0*t8*
t14*t11+5.0/22.0*t*t18+t18*t11/77);
   /* p=15 5 2 4 */
   } else if( i==5 && j==2 && k==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = s*s;
      t7 = r-1.0;
      t9 = t7*t7;
      t12 = t*t;
      t13 = t12*t12;
      t15 = s+r-1.0;
      t17 = t15*t15;
      t21 = t17*t17;
      f = (t2*r-10.0/9.0*t2+50.0/117.0*t1*r-8.0/117.0*t1+r/234-1.0/13455.0)*(
t6+2.0/5.0*s*t7+t9/35)*(t13+20.0/9.0*t12*t*t15+5.0/3.0*t17*t12+10.0/21.0*t*t17*
t15+5.0/126.0*t21);
   /* p=15 5 3 3 */
   } else if( i==5 && j==3 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = s*s;
      t8 = r-1.0;
      t10 = t8*t8;
      t15 = t*t;
      t17 = s+r-1.0;
      t19 = t17*t17;
      f = (t2*r-10.0/9.0*t2+50.0/117.0*t1*r-8.0/117.0*t1+r/234-1.0/13455.0)*(
s*t6+4.0/5.0*t6*t8+6.0/35.0*s*t10+4.0/455.0*t10*t8)*(t15*t+12.0/7.0*t17*t15+6.0
/7.0*t*t19+4.0/35.0*t19*t17);
   /* p=15 5 4 2 */
   } else if( i==5 && j==4 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = s*s;
      t7 = t6*t6;
      t9 = r-1.0;
      t11 = t9*t9;
      t15 = t11*t11;
      t18 = t*t;
      t19 = s+r-1.0;
      t21 = t19*t19;
      f = (t2*r-10.0/9.0*t2+50.0/117.0*t1*r-8.0/117.0*t1+r/234-1.0/13455.0)*(
t7+4.0/3.0*t6*s*t9+4.0/7.0*t6*t11+8.0/91.0*s*t11*t9+t15/273)*(t18+6.0/5.0*t*t19
+3.0/10.0*t21);
   /* p=15 5 5 1 */
   } else if( i==5 && j==5 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = s*s;
      t7 = t6*t6;
      t9 = r-1.0;
      t12 = t9*t9;
      t16 = t12*t12;
      f = (t2*r-10.0/9.0*t2+50.0/117.0*t1*r-8.0/117.0*t1+r/234-1.0/13455.0)*(
t7*s+2.0*t7*t9+10.0/7.0*t6*s*t12+40.0/91.0*t6*t12*t9+5.0/91.0*s*t16+2.0/1001.0*
t16*t9)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=15 5 6 0 */
   } else if( i==5 && j==6 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t6 = s*s;
      t7 = t6*t6;
      t10 = r-1.0;
      t12 = t10*t10;
      t17 = t12*t12;
      f = (t2*r-10.0/9.0*t2+50.0/117.0*t1*r-8.0/117.0*t1+r/234-1.0/13455.0)*(
t7*t6+14.0/5.0*t7*s*t10+3.0*t7*t12+20.0/13.0*t6*s*t12*t10+5.0/13.0*t6*t17+6.0/
143.0*s*t17*t10+t17*t12/715);
   /* p=15 6 0 5 */
   } else if( i==6 && j==0 && k==5 ) {
      t1 = r*r;
      t2 = t1*t1;
      t7 = t*t;
      t8 = t7*t7;
      t10 = s+r-1.0;
      t13 = t10*t10;
      t17 = t13*t13;
      f = (t2*t1-14.0/9.0*t2*r+35.0/39.0*t2-28.0/117.0*t1*r+7.0/234.0*t1-7.0/
4485.0*r+7.0/296010.0)*(t8*t+30.0/11.0*t8*t10+30.0/11.0*t7*t*t13+40.0/33.0*t7*
t13*t10+5.0/22.0*t*t17+t17*t10/77);
   /* p=15 6 1 4 */
   } else if( i==6 && j==1 && k==4 ) {
      t1 = r*r;
      t2 = t1*t1;
      t9 = t*t;
      t10 = t9*t9;
      t12 = s+r-1.0;
      t14 = t12*t12;
      t18 = t14*t14;
      f = (s+2.0/13.0*r-2.0/13.0)*(t2*t1-14.0/9.0*t2*r+35.0/39.0*t2-28.0/
117.0*t1*r+7.0/234.0*t1-7.0/4485.0*r+7.0/296010.0)*(t10+20.0/9.0*t9*t*t12+5.0/
3.0*t9*t14+10.0/21.0*t*t14*t12+5.0/126.0*t18);
   /* p=15 6 2 3 */
   } else if( i==6 && j==2 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t7 = s*s;
      t8 = r-1.0;
      t10 = t8*t8;
      t13 = t*t;
      t15 = s+r-1.0;
      t17 = t15*t15;
      f = (t2*t1-14.0/9.0*t2*r+35.0/39.0*t2-28.0/117.0*t1*r+7.0/234.0*t1-7.0/
4485.0*r+7.0/296010.0)*(t7+6.0/13.0*s*t8+t10/26)*(t13*t+12.0/7.0*t13*t15+6.0/
7.0*t*t17+4.0/35.0*t17*t15);
   /* p=15 6 3 2 */
   } else if( i==6 && j==3 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t7 = s*s;
      t9 = r-1.0;
      t11 = t9*t9;
      t16 = t*t;
      t17 = s+r-1.0;
      t19 = t17*t17;
      f = (t2*t1-14.0/9.0*t2*r+35.0/39.0*t2-28.0/117.0*t1*r+7.0/234.0*t1-7.0/
4485.0*r+7.0/296010.0)*(t7*s+12.0/13.0*t7*t9+3.0/13.0*s*t11+2.0/143.0*t11*t9)*(
t16+6.0/5.0*t*t17+3.0/10.0*t19);
   /* p=15 6 4 1 */
   } else if( i==6 && j==4 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t7 = s*s;
      t8 = t7*t7;
      t10 = r-1.0;
      t12 = t10*t10;
      t16 = t12*t12;
      f = (t2*t1-14.0/9.0*t2*r+35.0/39.0*t2-28.0/117.0*t1*r+7.0/234.0*t1-7.0/
4485.0*r+7.0/296010.0)*(t8+20.0/13.0*t7*s*t10+10.0/13.0*t7*t12+20.0/143.0*s*t12
*t10+t16/143)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=15 6 5 0 */
   } else if( i==6 && j==5 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t7 = s*s;
      t8 = t7*t7;
      t10 = r-1.0;
      t13 = t10*t10;
      t17 = t13*t13;
      f = (t2*t1-14.0/9.0*t2*r+35.0/39.0*t2-28.0/117.0*t1*r+7.0/234.0*t1-7.0/
4485.0*r+7.0/296010.0)*(t8*s+30.0/13.0*t8*t10+25.0/13.0*t7*s*t13+100.0/143.0*t7
*t13*t10+15.0/143.0*s*t17+2.0/429.0*t17*t10);
   /* p=15 7 0 4 */
   } else if( i==7 && j==0 && k==4 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t8 = t*t;
      t9 = t8*t8;
      t11 = s+r-1.0;
      t13 = t11*t11;
      t17 = t13*t13;
      f = (t3*t2-56.0/27.0*t3*t1+196.0/117.0*t3*r-392.0/585.0*t3+49.0/351.0*
t2-196.0/13455.0*t1+98.0/148005.0*r-4.0/444015.0)*(t9+20.0/9.0*t8*t*t11+5.0/3.0
*t8*t13+10.0/21.0*t*t13*t11+5.0/126.0*t17);
   /* p=15 7 1 3 */
   } else if( i==7 && j==1 && k==3 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t10 = t*t;
      t12 = s+r-1.0;
      t14 = t12*t12;
      f = (t3*t2-56.0/27.0*t3*t1+196.0/117.0*t3*r-392.0/585.0*t3+49.0/351.0*
t2-196.0/13455.0*t1+98.0/148005.0*r-4.0/444015.0)*(s+2.0/11.0*r-2.0/11.0)*(t10*
t+12.0/7.0*t12*t10+6.0/7.0*t*t14+4.0/35.0*t14*t12);
   /* p=15 7 2 2 */
   } else if( i==7 && j==2 && k==2 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t8 = s*s;
      t9 = r-1.0;
      t11 = t9*t9;
      t14 = t*t;
      t15 = s+r-1.0;
      t17 = t15*t15;
      f = (t3*t2-56.0/27.0*t3*t1+196.0/117.0*t3*r-392.0/585.0*t3+49.0/351.0*
t2-196.0/13455.0*t1+98.0/148005.0*r-4.0/444015.0)*(t8+6.0/11.0*s*t9+3.0/55.0*
t11)*(t14+6.0/5.0*t*t15+3.0/10.0*t17);
   /* p=15 7 3 1 */
   } else if( i==7 && j==3 && k==1 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t8 = s*s;
      t10 = r-1.0;
      t12 = t10*t10;
      f = (t3*t2-56.0/27.0*t3*t1+196.0/117.0*t3*r-392.0/585.0*t3+49.0/351.0*
t2-196.0/13455.0*t1+98.0/148005.0*r-4.0/444015.0)*(t8*s+12.0/11.0*t8*t10+18.0/
55.0*s*t12+4.0/165.0*t12*t10)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=15 7 4 0 */
   } else if( i==7 && j==4 && k==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t8 = s*s;
      t9 = t8*t8;
      t11 = r-1.0;
      t13 = t11*t11;
      t17 = t13*t13;
      f = (t3*t2-56.0/27.0*t3*t1+196.0/117.0*t3*r-392.0/585.0*t3+49.0/351.0*
t2-196.0/13455.0*t1+98.0/148005.0*r-4.0/444015.0)*(t9+20.0/11.0*t8*s*t11+12.0/
11.0*t8*t13+8.0/33.0*s*t13*t11+t17/66);
   /* p=15 8 0 3 */
   } else if( i==8 && j==0 && k==3 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*r;
      t9 = t*t;
      t11 = s+r-1.0;
      t13 = t11*t11;
      f = (t3-8.0/3.0*t2*t4+112.0/39.0*t2*t1-1568.0/975.0*t2*r+98.0/195.0*t2
-392.0/4485.0*t4+392.0/49335.0*t1-16.0/49335.0*r+1.0/246675.0)*(t9*t+12.0/7.0*
t9*t11+6.0/7.0*t*t13+4.0/35.0*t13*t11);
   /* p=15 8 1 2 */
   } else if( i==8 && j==1 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*r;
      t11 = t*t;
      t12 = s+r-1.0;
      t14 = t12*t12;
      f = (t3-8.0/3.0*t2*t4+112.0/39.0*t2*t1-1568.0/975.0*t2*r+98.0/195.0*t2
-392.0/4485.0*t4+392.0/49335.0*t1-16.0/49335.0*r+1.0/246675.0)*(s+2.0/9.0*r-2.0
/9.0)*(t11+6.0/5.0*t*t12+3.0/10.0*t14);
   /* p=15 8 2 1 */
   } else if( i==8 && j==2 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*r;
      t9 = s*s;
      t10 = r-1.0;
      t12 = t10*t10;
      f = (t3-8.0/3.0*t2*t4+112.0/39.0*t2*t1-1568.0/975.0*t2*r+98.0/195.0*t2
-392.0/4485.0*t4+392.0/49335.0*t1-16.0/49335.0*r+1.0/246675.0)*(t9+2.0/3.0*s*
t10+t12/12)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=15 8 3 0 */
   } else if( i==8 && j==3 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t4 = t1*r;
      t9 = s*s;
      t11 = r-1.0;
      t13 = t11*t11;
      f = (t3-8.0/3.0*t2*t4+112.0/39.0*t2*t1-1568.0/975.0*t2*r+98.0/195.0*t2
-392.0/4485.0*t4+392.0/49335.0*t1-16.0/49335.0*r+1.0/246675.0)*(t9*s+4.0/3.0*t9
*t11+s*t13/2+t13*t11/21);
   /* p=15 9 0 2 */
   } else if( i==9 && j==0 && k==2 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*r;
      t10 = t*t;
      t11 = s+r-1.0;
      t13 = t11*t11;
      f = (t3*r-10.0/3.0*t3+60.0/13.0*t2*t5-224.0/65.0*t2*t1+98.0/65.0*t2*r
-588.0/1495.0*t2+196.0/3289.0*t5-16.0/3289.0*t1+3.0/16445.0*r-2.0/937365.0)*(
t10+6.0/5.0*t*t11+3.0/10.0*t13);
   /* p=15 9 1 1 */
   } else if( i==9 && j==1 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*r;
      f = (t3*r-10.0/3.0*t3+60.0/13.0*t2*t5-224.0/65.0*t2*t1+98.0/65.0*t2*r
-588.0/1495.0*t2+196.0/3289.0*t5-16.0/3289.0*t1+3.0/16445.0*r-2.0/937365.0)*(s+
2.0/7.0*r-2.0/7.0)*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=15 9 2 0 */
   } else if( i==9 && j==2 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t5 = t1*r;
      t10 = s*s;
      t11 = r-1.0;
      t13 = t11*t11;
      f = (t3*r-10.0/3.0*t3+60.0/13.0*t2*t5-224.0/65.0*t2*t1+98.0/65.0*t2*r
-588.0/1495.0*t2+196.0/3289.0*t5-16.0/3289.0*t1+3.0/16445.0*r-2.0/937365.0)*(
t10+6.0/7.0*s*t11+t13/7);
   /* p=15 10 0 1 */
   } else if( i==10 && j==0 && k==1 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t6 = t1*r;
      t10 = t3*t1-110.0/27.0*t3*r+275.0/39.0*t3-88.0/13.0*t2*t6+154.0/39.0*t2*
t1-2156.0/1495.0*t2*r+98.0/299.0*t2-40.0/897.0*t6+t1/299-2.0/17043.0*r+1.0/
766935.0;
      f = t10*(t+2.0/3.0*s+2.0/3.0*r-2.0/3.0);
   /* p=15 10 1 0 */
   } else if( i==10 && j==1 && k==0 ) {
      t1 = r*r;
      t2 = t1*t1;
      t3 = t2*t2;
      t6 = t1*r;
      t10 = t3*t1-110.0/27.0*t3*r+275.0/39.0*t3-88.0/13.0*t2*t6+154.0/39.0*t2*
t1-2156.0/1495.0*t2*r+98.0/299.0*t2-40.0/897.0*t6+t1/299-2.0/17043.0*r+1.0/
766935.0;
      f = t10*(s+2.0/5.0*r-2.0/5.0);
   /* p=15 11 0 0 */
   } else if( i==11 && j==0 && k==0 ) {
      t1 = r*r;
      t2 = t1*r;
      t3 = t1*t1;
      t4 = t3*t3;
      f = t4*t2-44.0/9.0*t4*t1+1210.0/117.0*t4*r-484.0/39.0*t4+121.0/13.0*t3*
t2-6776.0/1495.0*t3*t1+2156.0/1495.0*t3*r-88.0/299.0*t3+11.0/299.0*t2-44.0/
17043.0*t1+22.0/255645.0*r-4.0/4345965.0;
   }
   return f ;
}

#ifdef __cplusplus
}
#endif
